"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T22:17:13.999711
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:17:14.250252.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = t2.copy()
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    e_cc = einsum(tmp0, (0, 1, 2, 3), v.oovv, (0, 1, 2, 3), ()) * 0.25
    del tmp0
    e_cc += einsum(t1, (0, 1), f.ov, (0, 1), ())

    return e_cc

def update_amps(f=None, t1=None, t2=None, t3=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:17:45.411100.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    t3 : array
        T3 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    t3new : array
        Updated T3 residuals.
    """

    tmp0 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp67 = einsum(t1, (0, 1), tmp0, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp73 = einsum(t2, (0, 1, 2, 3), tmp0, (4, 5, 6, 3), (4, 0, 1, 6, 5, 2))
    tmp49 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp59 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 5, 6, 3), (4, 5, 0, 1, 2, 6))
    tmp17 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp68 = einsum(t1, (0, 1), tmp67, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp67
    tmp3 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp19 = einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 2, 3), (4, 5, 0, 6))
    tmp18 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp81 = einsum(f.ov, (0, 1), t1, (0, 2), (1, 2))
    tmp56 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp54 = einsum(t1, (0, 1), v.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp28 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp5 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp74 = einsum(t1, (0, 1), tmp73, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp73
    tmp51 = einsum(t1, (0, 1), tmp49, (2, 3, 4, 1), (2, 0, 3, 4)) * -1
    tmp60 = einsum(t1, (0, 1), tmp59, (2, 3, 4, 0, 5, 6), (2, 3, 4, 5, 1, 6))
    del tmp59
    tmp69 = tmp17.transpose((2, 1, 0, 3)).copy() * -1
    tmp69 += tmp68
    del tmp68
    tmp40 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp42 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp44 = einsum(tmp3, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    tmp6 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp37 = einsum(t1, (0, 1), tmp3, (2, 1), (0, 2))
    tmp15 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp20 = tmp17.transpose((0, 2, 1, 3)).copy()
    del tmp17
    tmp20 += tmp18.transpose((2, 1, 0, 3)) * -0.5
    del tmp18
    tmp20 += tmp19.transpose((2, 1, 0, 3)) * 0.5
    del tmp19
    tmp9 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp11 = t2.copy()
    tmp11 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    tmp26 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp7 = t2.copy()
    tmp7 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp82 = f.vv.copy()
    tmp82 += tmp81 * -1
    del tmp81
    tmp64 = einsum(tmp49, (0, 1, 2, 3), t2, (4, 5, 6, 3), (0, 4, 5, 1, 6, 2)) * -1
    tmp86 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 6, 3), (0, 1, 4, 6, 2, 5))
    tmp57 = einsum(tmp56, (0, 1, 2, 3), t2, (4, 5, 6, 3), (0, 4, 5, 6, 1, 2)) * -1
    del tmp56
    tmp55 = einsum(t2, (0, 1, 2, 3), tmp54, (4, 5, 1, 6), (0, 4, 5, 6, 2, 3)) * -1
    del tmp54
    tmp77 = einsum(t1, (0, 1), tmp28, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    tmp79 = f.oo.copy()
    tmp79 += tmp5
    tmp72 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 2, 5, 6), (4, 0, 1, 5, 6, 3))
    tmp75 = einsum(t1, (0, 1), tmp74, (2, 3, 4, 0, 5, 6), (2, 3, 4, 5, 1, 6)) * -1
    del tmp74
    tmp84 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp62 = einsum(tmp51, (0, 1, 2, 3), t2, (4, 2, 5, 6), (1, 0, 4, 5, 6, 3)) * -1
    tmp61 = einsum(t1, (0, 1), tmp60, (2, 3, 0, 4, 5, 6), (2, 3, 4, 5, 1, 6)) * -1
    del tmp60
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2, (4, 2, 5, 6), (0, 1, 4, 3, 5, 6)) * -1
    del tmp69
    tmp66 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 6, 1), (4, 5, 0, 6, 2, 3))
    tmp41 = einsum(t2, (0, 1, 2, 3), tmp40, (4, 3), (0, 1, 2, 4)) * -1
    del tmp40
    tmp43 = einsum(t2, (0, 1, 2, 3), tmp42, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp42
    tmp45 = einsum(tmp44, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp44
    tmp31 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp32 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp36 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp38 = einsum(t2, (0, 1, 2, 3), tmp37, (4, 1), (4, 0, 2, 3)) * -1
    del tmp37
    tmp35 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp16 = einsum(t2, (0, 1, 2, 3), tmp15, (4, 3), (0, 1, 2, 4))
    del tmp15
    tmp21 = einsum(tmp20, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp20
    tmp14 = einsum(t3, (0, 1, 2, 3, 4, 5), v.ovvv, (2, 6, 4, 5), (0, 1, 3, 6))
    tmp47 = einsum(tmp0, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp10 = einsum(tmp9, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    del tmp9
    tmp12 = einsum(v.ovov, (0, 1, 2, 3), tmp11, (2, 4, 1, 5), (4, 0, 5, 3))
    del tmp11
    tmp25 = einsum(tmp0, (0, 1, 2, 3), t3, (4, 2, 1, 5, 6, 3), (0, 4, 5, 6))
    tmp27 = einsum(t2, (0, 1, 2, 3), tmp26, (4, 1), (0, 4, 2, 3))
    del tmp26
    tmp24 = einsum(v.ovoo, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 1), (4, 0, 5, 6))
    tmp23 = einsum(t2, (0, 1, 2, 3), tmp5, (1, 4), (4, 0, 2, 3))
    tmp29 = einsum(tmp7, (0, 1, 2, 3), tmp28, (4, 0, 1, 5), (4, 5, 2, 3)) * 0.5
    del tmp28
    tmp83 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp82, (5, 6), (0, 1, 2, 6, 3, 4))
    del tmp82
    t3new = tmp83.transpose((1, 2, 0, 4, 5, 3)).copy()
    t3new += tmp83.transpose((1, 2, 0, 4, 3, 5)) * -1
    t3new += tmp83.transpose((1, 2, 0, 3, 4, 5))
    del tmp83
    tmp65 = einsum(t1, (0, 1), tmp64, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp64
    t3new += tmp65.transpose((1, 2, 0, 5, 4, 3))
    t3new += tmp65.transpose((1, 2, 0, 4, 5, 3)) * -1
    t3new += tmp65.transpose((1, 2, 0, 5, 3, 4)) * -1
    t3new += tmp65.transpose((1, 2, 0, 4, 3, 5))
    t3new += tmp65.transpose((1, 2, 0, 3, 5, 4))
    t3new += tmp65.transpose((1, 2, 0, 3, 4, 5)) * -1
    t3new += tmp65.transpose((1, 0, 2, 5, 4, 3)) * -1
    t3new += tmp65.transpose((1, 0, 2, 4, 5, 3))
    t3new += tmp65.transpose((1, 0, 2, 5, 3, 4))
    t3new += tmp65.transpose((1, 0, 2, 4, 3, 5)) * -1
    t3new += tmp65.transpose((1, 0, 2, 3, 5, 4)) * -1
    t3new += tmp65.transpose((1, 0, 2, 3, 4, 5))
    t3new += tmp65.transpose((0, 2, 1, 5, 4, 3)) * -1
    t3new += tmp65.transpose((0, 2, 1, 4, 5, 3))
    t3new += tmp65.transpose((0, 2, 1, 5, 3, 4))
    t3new += tmp65.transpose((0, 2, 1, 4, 3, 5)) * -1
    t3new += tmp65.transpose((0, 2, 1, 3, 5, 4)) * -1
    t3new += tmp65.transpose((0, 2, 1, 3, 4, 5))
    del tmp65
    tmp87 = einsum(t1, (0, 1), tmp86, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp86
    t3new += tmp87.transpose((2, 1, 0, 5, 4, 3)) * -1
    t3new += tmp87.transpose((2, 1, 0, 4, 5, 3))
    t3new += tmp87.transpose((2, 1, 0, 5, 3, 4))
    t3new += tmp87.transpose((2, 1, 0, 4, 3, 5)) * -1
    t3new += tmp87.transpose((2, 1, 0, 3, 5, 4)) * -1
    t3new += tmp87.transpose((2, 1, 0, 3, 4, 5))
    t3new += tmp87.transpose((0, 2, 1, 5, 4, 3)) * -1
    t3new += tmp87.transpose((0, 2, 1, 4, 5, 3))
    t3new += tmp87.transpose((0, 2, 1, 5, 3, 4))
    t3new += tmp87.transpose((0, 2, 1, 4, 3, 5)) * -1
    t3new += tmp87.transpose((0, 2, 1, 3, 5, 4)) * -1
    t3new += tmp87.transpose((0, 2, 1, 3, 4, 5))
    t3new += tmp87.transpose((0, 1, 2, 5, 4, 3))
    t3new += tmp87.transpose((0, 1, 2, 4, 5, 3)) * -1
    t3new += tmp87.transpose((0, 1, 2, 5, 3, 4)) * -1
    t3new += tmp87.transpose((0, 1, 2, 4, 3, 5))
    t3new += tmp87.transpose((0, 1, 2, 3, 5, 4))
    t3new += tmp87 * -1
    del tmp87
    tmp58 = tmp55.transpose((0, 2, 1, 3, 5, 4)).copy()
    del tmp55
    tmp58 += tmp57.transpose((0, 2, 1, 3, 5, 4))
    del tmp57
    t3new += tmp58.transpose((2, 1, 0, 4, 5, 3))
    t3new += tmp58.transpose((2, 1, 0, 4, 3, 5)) * -1
    t3new += tmp58.transpose((2, 1, 0, 3, 4, 5))
    t3new += tmp58.transpose((2, 0, 1, 4, 5, 3)) * -1
    t3new += tmp58.transpose((2, 0, 1, 4, 3, 5))
    t3new += tmp58.transpose((2, 0, 1, 3, 4, 5)) * -1
    t3new += tmp58.transpose((0, 1, 2, 4, 5, 3)) * -1
    t3new += tmp58.transpose((0, 1, 2, 4, 3, 5))
    t3new += tmp58 * -1
    del tmp58
    tmp78 = einsum(t2, (0, 1, 2, 3), tmp77, (4, 1, 5, 6), (4, 0, 5, 6, 2, 3)) * -1
    del tmp77
    t3new += tmp78.transpose((2, 1, 0, 5, 4, 3)) * -1
    t3new += tmp78.transpose((2, 1, 0, 5, 3, 4))
    t3new += tmp78.transpose((2, 1, 0, 3, 5, 4)) * -1
    t3new += tmp78.transpose((1, 2, 0, 5, 4, 3))
    t3new += tmp78.transpose((1, 2, 0, 5, 3, 4)) * -1
    t3new += tmp78.transpose((1, 2, 0, 3, 5, 4))
    t3new += tmp78.transpose((2, 0, 1, 5, 4, 3))
    t3new += tmp78.transpose((2, 0, 1, 5, 3, 4)) * -1
    t3new += tmp78.transpose((2, 0, 1, 3, 5, 4))
    t3new += tmp78.transpose((1, 0, 2, 5, 4, 3)) * -1
    t3new += tmp78.transpose((1, 0, 2, 5, 3, 4))
    t3new += tmp78.transpose((1, 0, 2, 3, 5, 4)) * -1
    t3new += tmp78.transpose((0, 2, 1, 5, 4, 3)) * -1
    t3new += tmp78.transpose((0, 2, 1, 5, 3, 4))
    t3new += tmp78.transpose((0, 2, 1, 3, 5, 4)) * -1
    t3new += tmp78.transpose((0, 1, 2, 5, 4, 3))
    t3new += tmp78.transpose((0, 1, 2, 5, 3, 4)) * -1
    t3new += tmp78.transpose((0, 1, 2, 3, 5, 4))
    del tmp78
    tmp80 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp79, (2, 6), (6, 0, 1, 3, 4, 5))
    del tmp79
    t3new += tmp80.transpose((2, 1, 0, 3, 4, 5))
    t3new += tmp80.transpose((2, 0, 1, 3, 4, 5)) * -1
    t3new += tmp80 * -1
    del tmp80
    tmp76 = tmp72.transpose((0, 2, 1, 4, 3, 5)).copy()
    del tmp72
    tmp76 += tmp75.transpose((0, 2, 1, 4, 3, 5))
    del tmp75
    t3new += tmp76.transpose((2, 1, 0, 5, 3, 4))
    t3new += tmp76.transpose((2, 1, 0, 3, 5, 4)) * -1
    t3new += tmp76.transpose((2, 1, 0, 3, 4, 5))
    t3new += tmp76.transpose((2, 0, 1, 5, 3, 4)) * -1
    t3new += tmp76.transpose((2, 0, 1, 3, 5, 4))
    t3new += tmp76.transpose((2, 0, 1, 3, 4, 5)) * -1
    t3new += tmp76.transpose((0, 1, 2, 5, 3, 4)) * -1
    t3new += tmp76.transpose((0, 1, 2, 3, 5, 4))
    t3new += tmp76 * -1
    del tmp76
    tmp85 = einsum(tmp84, (0, 1, 2, 3), t2, (4, 1, 5, 6), (0, 4, 2, 5, 6, 3))
    del tmp84
    t3new += tmp85.transpose((2, 1, 0, 5, 4, 3)) * -1
    t3new += tmp85.transpose((2, 1, 0, 4, 5, 3))
    t3new += tmp85.transpose((2, 1, 0, 4, 3, 5)) * -1
    t3new += tmp85.transpose((1, 2, 0, 5, 4, 3))
    t3new += tmp85.transpose((1, 2, 0, 4, 5, 3)) * -1
    t3new += tmp85.transpose((1, 2, 0, 4, 3, 5))
    t3new += tmp85.transpose((2, 0, 1, 5, 4, 3))
    t3new += tmp85.transpose((2, 0, 1, 4, 5, 3)) * -1
    t3new += tmp85.transpose((2, 0, 1, 4, 3, 5))
    t3new += tmp85.transpose((1, 0, 2, 5, 4, 3)) * -1
    t3new += tmp85.transpose((1, 0, 2, 4, 5, 3))
    t3new += tmp85.transpose((1, 0, 2, 4, 3, 5)) * -1
    t3new += tmp85.transpose((0, 2, 1, 5, 4, 3)) * -1
    t3new += tmp85.transpose((0, 2, 1, 4, 5, 3))
    t3new += tmp85.transpose((0, 2, 1, 4, 3, 5)) * -1
    t3new += tmp85.transpose((0, 1, 2, 5, 4, 3))
    t3new += tmp85.transpose((0, 1, 2, 4, 5, 3)) * -1
    t3new += tmp85.transpose((0, 1, 2, 4, 3, 5))
    del tmp85
    tmp63 = tmp61.transpose((0, 1, 2, 4, 3, 5)).copy() * -1
    del tmp61
    tmp63 += tmp62.transpose((0, 1, 2, 4, 3, 5)) * -1
    del tmp62
    t3new += tmp63.transpose((2, 1, 0, 5, 3, 4))
    t3new += tmp63.transpose((2, 1, 0, 3, 5, 4)) * -1
    t3new += tmp63.transpose((2, 1, 0, 3, 4, 5))
    t3new += tmp63.transpose((0, 2, 1, 5, 3, 4))
    t3new += tmp63.transpose((0, 2, 1, 3, 5, 4)) * -1
    t3new += tmp63.transpose((0, 2, 1, 3, 4, 5))
    t3new += tmp63.transpose((0, 1, 2, 5, 3, 4)) * -1
    t3new += tmp63.transpose((0, 1, 2, 3, 5, 4))
    t3new += tmp63 * -1
    del tmp63
    tmp71 = tmp66.transpose((0, 1, 2, 3, 5, 4)).copy() * -1
    del tmp66
    tmp71 += tmp70.transpose((0, 1, 2, 3, 5, 4)) * -1
    del tmp70
    t3new += tmp71.transpose((2, 1, 0, 4, 5, 3))
    t3new += tmp71.transpose((2, 1, 0, 4, 3, 5)) * -1
    t3new += tmp71.transpose((2, 1, 0, 3, 4, 5))
    t3new += tmp71.transpose((0, 2, 1, 4, 5, 3))
    t3new += tmp71.transpose((0, 2, 1, 4, 3, 5)) * -1
    t3new += tmp71.transpose((0, 2, 1, 3, 4, 5))
    t3new += tmp71.transpose((0, 1, 2, 4, 5, 3)) * -1
    t3new += tmp71.transpose((0, 1, 2, 4, 3, 5))
    t3new += tmp71 * -1
    del tmp71
    tmp46 = tmp41.copy()
    del tmp41
    tmp46 += tmp43
    del tmp43
    tmp46 += tmp45 * -1
    del tmp45
    t2new = tmp46.transpose((0, 1, 3, 2)).copy() * -1
    t2new += tmp46
    del tmp46
    tmp33 = tmp31.transpose((1, 0, 2, 3)).copy() * -1
    del tmp31
    tmp33 += tmp32.transpose((1, 0, 2, 3)) * -1
    del tmp32
    t2new += tmp33.transpose((0, 1, 3, 2))
    t2new += tmp33 * -1
    del tmp33
    tmp53 = v.oooo.copy()
    tmp53 += einsum(tmp7, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), (4, 5, 1, 0)) * -0.5
    t2new += einsum(tmp7, (0, 1, 2, 3), tmp53, (0, 1, 4, 5), (4, 5, 3, 2)) * -0.5
    del tmp53
    tmp39 = tmp35.transpose((0, 1, 3, 2)).copy() * -1
    del tmp35
    tmp39 += tmp36.transpose((0, 1, 3, 2))
    del tmp36
    tmp39 += tmp38.transpose((0, 1, 3, 2)) * -1
    del tmp38
    t2new += tmp39.transpose((1, 0, 2, 3))
    t2new += tmp39 * -1
    del tmp39
    tmp50 = einsum(tmp49, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    del tmp49
    t2new += tmp50.transpose((1, 0, 3, 2))
    t2new += tmp50.transpose((1, 0, 2, 3)) * -1
    t2new += tmp50.transpose((0, 1, 3, 2)) * -1
    t2new += tmp50
    del tmp50
    tmp2 = t2.copy() * 0.5
    tmp2 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    t2new += einsum(v.vvvv, (0, 1, 2, 3), tmp2, (4, 5, 2, 3), (5, 4, 0, 1)) * -1
    t1new = einsum(v.ovvv, (0, 1, 2, 3), tmp2, (0, 4, 2, 3), (4, 1))
    del tmp2
    tmp4 = f.ov.copy()
    tmp4 += tmp3
    del tmp3
    t2new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp4, (2, 5), (0, 1, 3, 4))
    t1new += einsum(t2, (0, 1, 2, 3), tmp4, (1, 3), (0, 2))
    del tmp4
    tmp22 = tmp14.copy() * 0.5
    del tmp14
    tmp22 += tmp16 * 0.5
    del tmp16
    tmp22 += tmp21.transpose((1, 0, 3, 2)) * -1
    del tmp21
    t2new += tmp22.transpose((0, 1, 3, 2))
    t2new += tmp22 * -1
    del tmp22
    tmp52 = einsum(tmp51, (0, 1, 2, 3), t1, (2, 4), (1, 0, 4, 3)) * -1
    del tmp51
    t2new += tmp52.transpose((0, 1, 3, 2))
    t2new += tmp52 * -1
    del tmp52
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp47
    t2new += tmp48.transpose((1, 0, 3, 2)) * -1
    t2new += tmp48.transpose((1, 0, 2, 3))
    t2new += tmp48.transpose((0, 1, 3, 2))
    t2new += tmp48 * -1
    del tmp48
    tmp34 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    t2new += tmp34.transpose((1, 0, 3, 2))
    t2new += tmp34.transpose((0, 1, 3, 2)) * -1
    del tmp34
    tmp13 = tmp10.copy()
    del tmp10
    tmp13 += tmp12 * -1
    del tmp12
    t2new += tmp13.transpose((1, 0, 3, 2))
    t2new += tmp13.transpose((1, 0, 2, 3)) * -1
    t2new += tmp13.transpose((0, 1, 3, 2)) * -1
    t2new += tmp13
    del tmp13
    tmp30 = tmp23.transpose((0, 1, 3, 2)).copy()
    del tmp23
    tmp30 += tmp24.transpose((0, 1, 3, 2)) * -0.5
    del tmp24
    tmp30 += tmp25.transpose((0, 1, 3, 2)) * 0.5
    del tmp25
    tmp30 += tmp27.transpose((0, 1, 3, 2)) * -0.5
    del tmp27
    tmp30 += tmp29.transpose((0, 1, 3, 2)) * -1
    del tmp29
    t2new += tmp30.transpose((1, 0, 2, 3))
    t2new += tmp30 * -1
    del tmp30
    tmp8 = f.oo.copy()
    tmp8 += tmp5
    del tmp5
    tmp8 += tmp6
    del tmp6
    tmp8 += einsum(tmp7, (0, 1, 2, 3), v.oovv, (4, 0, 2, 3), (4, 1)) * -0.5
    del tmp7
    t1new += einsum(t1, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8
    tmp1 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -1
    tmp1 += tmp0.transpose((0, 2, 1, 3)) * -1
    del tmp0
    t1new += einsum(t2, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (4, 2)) * 0.5
    del tmp1
    t1new += einsum(t3, (0, 1, 2, 3, 4, 5), v.oovv, (1, 2, 4, 5), (0, 3)) * 0.25
    t1new += f.ov
    t1new += einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3)) * -1
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t2new += v.oovv

    return {f"t1new": t1new, f"t2new": t2new, f"t3new": t3new}

