"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:45:03.180654
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:03.433201.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = t2.copy()
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    e_cc = einsum(tmp0, (0, 1, 2, 3), v.oovv, (0, 1, 2, 3), ()) * 0.25
    del tmp0
    e_cc += einsum(t1, (0, 1), f.ov, (0, 1), ())

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:11.246246.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp19 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp18 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp3 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp36 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp38 = t2.copy()
    tmp38 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    tmp0 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp16 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp20 = tmp18.transpose((0, 2, 1, 3)).copy() * -1
    del tmp18
    tmp20 += tmp19.transpose((2, 1, 0, 3)) * 0.5
    del tmp19
    tmp9 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp11 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp13 = einsum(tmp3, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    tmp26 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp7 = t2.copy()
    tmp7 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp24 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp5 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp45 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp33 = einsum(tmp3, (0, 1), t1, (2, 1), (2, 0))
    tmp6 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    del tmp36
    tmp39 = einsum(tmp38, (0, 1, 2, 3), v.ovov, (4, 2, 0, 5), (1, 4, 3, 5))
    del tmp38
    tmp29 = einsum(tmp0, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp17 = einsum(tmp16, (0, 1), t2, (2, 3, 4, 1), (2, 3, 4, 0))
    del tmp16
    tmp21 = einsum(t1, (0, 1), tmp20, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp20
    tmp41 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp42 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp10 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 3), (0, 1, 2, 4)) * -1
    del tmp9
    tmp12 = einsum(tmp11, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp11
    tmp14 = einsum(t1, (0, 1), tmp13, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp13
    tmp27 = einsum(tmp26, (0, 1, 2, 3), tmp7, (1, 2, 4, 5), (0, 3, 4, 5)) * 0.5
    del tmp26
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp24, (4, 1), (0, 4, 2, 3))
    del tmp24
    tmp23 = einsum(t2, (0, 1, 2, 3), tmp5, (1, 4), (4, 0, 2, 3))
    tmp47 = einsum(tmp45, (0, 1, 2, 3), t1, (4, 3), (0, 4, 1, 2)) * -1
    tmp31 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3))
    tmp34 = einsum(t2, (0, 1, 2, 3), tmp33, (4, 1), (4, 0, 2, 3)) * -1
    del tmp33
    tmp32 = einsum(t2, (0, 1, 2, 3), tmp6, (1, 4), (0, 4, 2, 3)) * -1
    tmp2 = t2.copy() * 0.5
    tmp2 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    t2new = einsum(v.vvvv, (0, 1, 2, 3), tmp2, (4, 5, 2, 3), (5, 4, 0, 1)) * -1
    t1new = einsum(tmp2, (0, 1, 2, 3), v.ovvv, (0, 4, 2, 3), (1, 4))
    del tmp2
    tmp44 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    t2new += tmp44.transpose((1, 0, 3, 2))
    t2new += tmp44.transpose((0, 1, 3, 2)) * -1
    del tmp44
    tmp40 = tmp37.copy()
    del tmp37
    tmp40 += tmp39 * -1
    del tmp39
    t2new += tmp40.transpose((1, 0, 3, 2))
    t2new += tmp40.transpose((1, 0, 2, 3)) * -1
    t2new += tmp40.transpose((0, 1, 3, 2)) * -1
    t2new += tmp40
    del tmp40
    tmp30 = einsum(tmp29, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp29
    t2new += tmp30.transpose((1, 0, 3, 2)) * -1
    t2new += tmp30.transpose((1, 0, 2, 3))
    t2new += tmp30.transpose((0, 1, 3, 2))
    t2new += tmp30 * -1
    del tmp30
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    del tmp45
    t2new += tmp46.transpose((1, 0, 3, 2))
    t2new += tmp46.transpose((1, 0, 2, 3)) * -1
    t2new += tmp46.transpose((0, 1, 3, 2)) * -1
    t2new += tmp46
    del tmp46
    tmp22 = tmp17.copy() * 0.5
    del tmp17
    tmp22 += tmp21.transpose((1, 0, 3, 2))
    del tmp21
    t2new += tmp22.transpose((0, 1, 3, 2))
    t2new += tmp22 * -1
    del tmp22
    tmp43 = tmp41.transpose((1, 0, 2, 3)).copy() * -1
    del tmp41
    tmp43 += tmp42.transpose((1, 0, 2, 3)) * -1
    del tmp42
    t2new += tmp43.transpose((0, 1, 3, 2))
    t2new += tmp43 * -1
    del tmp43
    tmp15 = tmp10.copy()
    del tmp10
    tmp15 += tmp12
    del tmp12
    tmp15 += tmp14 * -1
    del tmp14
    t2new += tmp15.transpose((0, 1, 3, 2)) * -1
    t2new += tmp15
    del tmp15
    tmp28 = tmp23.transpose((0, 1, 3, 2)).copy()
    del tmp23
    tmp28 += tmp25.transpose((0, 1, 3, 2)) * -0.5
    del tmp25
    tmp28 += tmp27.transpose((0, 1, 3, 2)) * -1
    del tmp27
    t2new += tmp28.transpose((1, 0, 2, 3))
    t2new += tmp28 * -1
    del tmp28
    tmp49 = v.oooo.copy() * 2
    tmp49 += einsum(v.oovv, (0, 1, 2, 3), tmp7, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    t2new += einsum(tmp7, (0, 1, 2, 3), tmp49, (0, 1, 4, 5), (4, 5, 3, 2)) * -0.25
    del tmp49
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t1, (2, 4), (1, 0, 4, 3)) * -1
    del tmp47
    t2new += tmp48.transpose((0, 1, 3, 2))
    t2new += tmp48 * -1
    del tmp48
    tmp35 = tmp31.transpose((0, 1, 3, 2)).copy() * -1
    del tmp31
    tmp35 += tmp32.transpose((0, 1, 3, 2))
    del tmp32
    tmp35 += tmp34.transpose((0, 1, 3, 2)) * -1
    del tmp34
    t2new += tmp35.transpose((1, 0, 2, 3))
    t2new += tmp35 * -1
    del tmp35
    tmp4 = f.ov.copy()
    tmp4 += tmp3
    del tmp3
    t1new += einsum(tmp4, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    del tmp4
    tmp8 = f.oo.copy() * 2
    tmp8 += tmp5 * 2
    del tmp5
    tmp8 += tmp6 * 2
    del tmp6
    tmp8 += einsum(v.oovv, (0, 1, 2, 3), tmp7, (1, 4, 2, 3), (0, 4)) * -1
    del tmp7
    t1new += einsum(tmp8, (0, 1), t1, (0, 2), (1, 2)) * -0.5
    del tmp8
    tmp1 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -1
    tmp1 += tmp0.transpose((0, 2, 1, 3)) * -1
    del tmp0
    t1new += einsum(t2, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (4, 2)) * 0.5
    del tmp1
    t1new += einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    t1new += f.ov
    t1new += einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3)) * -1
    t2new += v.oovv

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:22.417278.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp5 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp24 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp41 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp26 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp27 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp20 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 0, 1), (2, 4))
    tmp19 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp1 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    l2new = einsum(tmp2, (0, 1, 2, 3), v.ovvv, (2, 3, 4, 5), (4, 5, 0, 1))
    l1new = einsum(tmp2, (0, 1, 2, 3), v.ovov, (2, 3, 1, 4), (4, 0)) * -1
    l1new += einsum(tmp2, (0, 1, 2, 3), tmp1, (1, 2, 3, 4), (4, 0))
    tmp6 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -1
    tmp6 += tmp5.transpose((0, 2, 1, 3)) * -1
    tmp17 = einsum(t2, (0, 1, 2, 3), l2, (4, 3, 0, 1), (4, 2))
    tmp42 = tmp24.copy()
    tmp42 += tmp41 * 0.5
    del tmp41
    tmp7 = einsum(v.oovv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp29 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp36 = tmp26.copy() * 2
    tmp36 += tmp27.transpose((1, 0))
    tmp23 = tmp19.copy()
    tmp23 += tmp20 * 0.5
    l1new += einsum(v.ooov, (0, 1, 2, 3), tmp23, (2, 1), (3, 0))
    tmp33 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp52 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp52 += tmp1
    tmp4 = einsum(tmp2, (0, 1, 2, 3), t1, (4, 3), (0, 1, 4, 2))
    l1new += einsum(tmp4, (0, 1, 2, 3), v.ooov, (2, 3, 1, 4), (4, 0)) * -0.5
    tmp3 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    l1new += einsum(tmp3, (0, 1, 2, 3), v.ovoo, (1, 4, 3, 2), (4, 0)) * 0.25
    tmp10 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp11 = v.ooov.copy()
    tmp11 += tmp5.transpose((2, 1, 0, 3)) * 0.5
    tmp56 = einsum(l1, (0, 1), v.ovvv, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp55 = einsum(f.oo, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    tmp44 = einsum(l1, (0, 1), tmp6, (1, 2, 3, 4), (2, 3, 4, 0))
    tmp39 = einsum(tmp2, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp40 = einsum(v.oovv, (0, 1, 2, 3), tmp17, (4, 3), (0, 1, 4, 2)) * -1
    tmp43 = einsum(l2, (0, 1, 2, 3), tmp42, (1, 4), (2, 3, 4, 0)) * -1
    del tmp42
    tmp48 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp49 = einsum(tmp2, (0, 1, 2, 3), tmp7, (2, 4), (0, 1, 3, 4))
    tmp31 = einsum(tmp2, (0, 1, 2, 3), tmp5, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp5
    tmp30 = einsum(l2, (0, 1, 2, 3), tmp29, (3, 4, 1, 5), (2, 4, 0, 5))
    del tmp29
    tmp37 = einsum(l2, (0, 1, 2, 3), tmp36, (4, 3), (4, 2, 0, 1)) * -0.5
    del tmp36
    tmp35 = einsum(v.oovv, (0, 1, 2, 3), tmp23, (4, 1), (4, 0, 2, 3)) * -1
    del tmp23
    tmp34 = einsum(tmp33, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp33
    tmp46 = einsum(tmp7, (0, 1), t1, (2, 1), (2, 0))
    tmp53 = einsum(tmp52, (0, 1, 2, 3), l2, (4, 2, 5, 0), (1, 5, 3, 4))
    del tmp52
    tmp51 = einsum(v.ooov, (0, 1, 2, 3), tmp2, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp15 = tmp3.transpose((1, 0, 3, 2)).copy() * -0.5
    tmp15 += tmp4.transpose((0, 1, 3, 2))
    tmp9 = v.ovov.transpose((0, 2, 1, 3)).copy()
    tmp9 += tmp1.transpose((0, 1, 3, 2)) * -0.5
    del tmp1
    tmp12 = v.oooo.copy() * -0.5
    tmp12 += tmp10.transpose((3, 2, 1, 0)) * -0.25
    tmp12 += einsum(t1, (0, 1), tmp11, (2, 3, 4, 1), (3, 2, 0, 4)) * -1
    tmp8 = f.ov.copy()
    tmp8 += tmp7
    tmp21 = tmp19.copy() * 2
    del tmp19
    tmp21 += tmp20
    del tmp20
    l1new += einsum(tmp21, (0, 1), tmp8, (1, 2), (2, 0)) * -0.5
    tmp57 = tmp55.transpose((0, 1, 3, 2)).copy() * -1
    del tmp55
    tmp57 += tmp56.transpose((0, 1, 3, 2))
    del tmp56
    l2new += tmp57.transpose((2, 3, 1, 0)) * -1
    l2new += tmp57.transpose((2, 3, 0, 1))
    del tmp57
    tmp45 = tmp39.copy() * -1
    del tmp39
    tmp45 += tmp40 * 0.5
    del tmp40
    tmp45 += tmp43.transpose((1, 0, 3, 2))
    del tmp43
    tmp45 += tmp44.transpose((1, 0, 3, 2))
    del tmp44
    l2new += tmp45.transpose((3, 2, 0, 1))
    l2new += tmp45.transpose((2, 3, 0, 1)) * -1
    del tmp45
    tmp59 = tmp3.transpose((1, 0, 3, 2)).copy() * -1
    del tmp3
    tmp59 += tmp4.transpose((0, 1, 3, 2)) * 2
    del tmp4
    l2new += einsum(v.oovv, (0, 1, 2, 3), tmp59, (4, 5, 0, 1), (2, 3, 5, 4)) * 0.25
    del tmp59
    tmp50 = tmp48.transpose((1, 0, 2, 3)).copy() * -1
    del tmp48
    tmp50 += tmp49
    del tmp49
    l2new += tmp50.transpose((3, 2, 0, 1))
    l2new += tmp50.transpose((2, 3, 0, 1)) * -1
    del tmp50
    tmp32 = tmp30.copy()
    del tmp30
    tmp32 += tmp31 * -1
    del tmp31
    l2new += tmp32.transpose((3, 2, 1, 0))
    l2new += tmp32.transpose((2, 3, 1, 0)) * -1
    l2new += tmp32.transpose((3, 2, 0, 1)) * -1
    l2new += tmp32.transpose((2, 3, 0, 1))
    del tmp32
    tmp58 = v.oooo.copy() * 2
    tmp58 += tmp10.transpose((1, 0, 3, 2))
    del tmp10
    tmp58 += einsum(tmp11, (0, 1, 2, 3), t1, (4, 3), (2, 4, 1, 0)) * -4
    del tmp11
    l2new += einsum(l2, (0, 1, 2, 3), tmp58, (2, 3, 4, 5), (0, 1, 4, 5)) * 0.25
    del tmp58
    tmp38 = tmp34.transpose((0, 1, 3, 2)).copy()
    del tmp34
    tmp38 += tmp35.transpose((0, 1, 3, 2)) * -1
    del tmp35
    tmp38 += tmp37.transpose((1, 0, 3, 2))
    del tmp37
    l2new += tmp38.transpose((3, 2, 1, 0)) * -1
    l2new += tmp38.transpose((3, 2, 0, 1))
    del tmp38
    tmp47 = einsum(tmp46, (0, 1), l2, (2, 3, 4, 0), (4, 1, 2, 3))
    del tmp46
    l2new += tmp47.transpose((2, 3, 1, 0))
    l2new += tmp47.transpose((2, 3, 0, 1)) * -1
    del tmp47
    tmp54 = einsum(l1, (0, 1), tmp7, (2, 3), (1, 2, 0, 3))
    del tmp7
    tmp54 += tmp51
    del tmp51
    tmp54 += tmp53.transpose((1, 0, 3, 2))
    del tmp53
    l2new += tmp54.transpose((3, 2, 1, 0))
    l2new += tmp54.transpose((2, 3, 1, 0)) * -1
    l2new += tmp54.transpose((3, 2, 0, 1)) * -1
    l2new += tmp54.transpose((2, 3, 0, 1))
    del tmp54
    tmp16 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2)) * 0.5
    tmp16 += einsum(tmp2, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    tmp16 += einsum(tmp15, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4)) * -0.5
    del tmp15
    l1new += einsum(tmp16, (0, 1, 2, 3), v.oovv, (1, 2, 4, 3), (4, 0))
    del tmp16
    tmp13 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -2
    tmp13 += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), (4, 0, 1, 5)) * -1
    tmp13 += einsum(tmp6, (0, 1, 2, 3), t2, (4, 1, 5, 3), (2, 4, 0, 5)) * 4
    del tmp6
    tmp13 += einsum(t2, (0, 1, 2, 3), tmp8, (4, 3), (4, 0, 1, 2)) * 2
    tmp13 += einsum(t1, (0, 1), tmp9, (2, 3, 1, 4), (3, 2, 0, 4)) * -4
    del tmp9
    tmp13 += einsum(tmp12, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4)) * -4
    del tmp12
    l1new += einsum(l2, (0, 1, 2, 3), tmp13, (4, 2, 3, 1), (0, 4)) * 0.25
    del tmp13
    tmp22 = t1.copy() * -1
    tmp22 += einsum(l1, (0, 1), t2, (2, 1, 3, 0), (2, 3)) * -1
    tmp22 += einsum(tmp2, (0, 1, 2, 3), t2, (1, 0, 4, 3), (2, 4)) * 0.5
    del tmp2
    tmp22 += einsum(tmp21, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    del tmp21
    l1new += einsum(tmp22, (0, 1), v.oovv, (2, 0, 3, 1), (3, 2)) * -1
    del tmp22
    tmp28 = f.oo.copy()
    tmp28 += tmp26.transpose((1, 0))
    del tmp26
    tmp28 += tmp27 * 0.5
    del tmp27
    tmp28 += einsum(tmp8, (0, 1), t1, (2, 1), (2, 0))
    del tmp8
    l1new += einsum(l1, (0, 1), tmp28, (1, 2), (0, 2)) * -1
    del tmp28
    tmp0 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 5, 1), (2, 4, 0, 5))
    l1new += einsum(tmp0, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (4, 0)) * -1
    del tmp0
    tmp14 = v.ovvv.copy()
    tmp14 += einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3)) * -1
    l1new += einsum(tmp14, (0, 1, 2, 3), l2, (2, 3, 4, 0), (1, 4)) * -0.5
    del tmp14
    tmp18 = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    tmp18 += tmp17 * 0.5
    del tmp17
    l1new += einsum(tmp18, (0, 1), v.ovvv, (2, 0, 3, 1), (3, 2))
    del tmp18
    tmp25 = f.vv.copy()
    tmp25 += tmp24 * -1
    del tmp24
    l1new += einsum(tmp25, (0, 1), l1, (0, 2), (1, 2))
    del tmp25
    l1new += f.ov.transpose((1, 0))
    l1new += einsum(v.ovov, (0, 1, 2, 3), l1, (1, 2), (3, 0)) * -1
    l2new += einsum(l2, (0, 1, 2, 3), v.vvvv, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    l2new += v.oovv.transpose((2, 3, 0, 1))
    l2new += einsum(l1, (0, 1), f.ov, (2, 3), (3, 0, 2, 1))
    l2new += einsum(l1, (0, 1), f.ov, (2, 3), (0, 3, 2, 1)) * -1
    l2new += einsum(f.ov, (0, 1), l1, (2, 3), (1, 2, 3, 0)) * -1
    l2new += einsum(f.ov, (0, 1), l1, (2, 3), (2, 1, 3, 0))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:23.109949.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 1), (4, 0))
    rdm1.oo = tmp1.transpose((1, 0)).copy() * -0.5
    tmp0 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm1.oo += tmp0.transpose((1, 0)) * -1
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.ov = einsum(t2, (0, 1, 2, 3), tmp2, (1, 0, 4, 3), (4, 2)) * -0.5
    del tmp2
    tmp3 = tmp0.copy() * 2
    del tmp0
    tmp3 += tmp1
    del tmp1
    rdm1.ov += einsum(tmp3, (0, 1), t1, (0, 2), (1, 2)) * -0.5
    del tmp3
    rdm1.oo += delta.oo
    del delta
    rdm1.ov += einsum(l1, (0, 1), t2, (2, 1, 3, 0), (2, 3))
    rdm1.ov += t1
    rdm1.vo = l1.copy()
    rdm1.vv = einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4)) * 0.5
    rdm1.vv += einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:34.008370.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.vooo = tmp1.transpose((3, 2, 1, 0)).copy()
    rdm2.ovoo = tmp1.transpose((2, 3, 1, 0)).copy() * -1
    tmp3 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm2.oovo = einsum(t1, (0, 1), tmp3, (2, 3), (3, 0, 1, 2))
    rdm2.oovo += einsum(t1, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.ooov = einsum(t1, (0, 1), tmp3, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp3, (2, 3), (0, 3, 2, 1))
    rdm2.oooo = einsum(delta.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp3, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp3, (2, 3), (3, 0, 2, 1)) * -1
    tmp4 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 1), (4, 0))
    rdm2.oovo += einsum(tmp4, (0, 1), t1, (2, 3), (1, 2, 3, 0)) * 0.5
    rdm2.oovo += einsum(tmp4, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -0.5
    rdm2.ooov += einsum(tmp4, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -0.5
    rdm2.ooov += einsum(tmp4, (0, 1), t1, (2, 3), (2, 1, 0, 3)) * 0.5
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -0.5
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (3, 0, 1, 2)) * 0.5
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1)) * 0.5
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -0.5
    tmp19 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.vovo = tmp19.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.voov = tmp19.transpose((2, 1, 0, 3)).copy()
    rdm2.ovvo = tmp19.transpose((1, 2, 3, 0)).copy()
    rdm2.ovov = tmp19.transpose((1, 2, 0, 3)).copy() * -1
    tmp0 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.oooo += tmp0.transpose((3, 2, 1, 0)) * 0.5
    tmp2 = einsum(tmp1, (0, 1, 2, 3), t1, (4, 3), (0, 1, 4, 2))
    rdm2.oooo += tmp2.transpose((2, 3, 1, 0)) * -1
    tmp5 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    rdm2.oovo += tmp5.transpose((2, 1, 3, 0))
    rdm2.ooov += tmp5.transpose((2, 1, 0, 3)) * -1
    tmp9 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    rdm2.oovo += tmp9.transpose((2, 1, 3, 0)) * -1
    rdm2.oovo += tmp9.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp9.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp9.transpose((1, 2, 0, 3)) * -1
    tmp6 = einsum(l1, (0, 1), t2, (2, 1, 3, 0), (2, 3))
    tmp7 = einsum(tmp3, (0, 1), t1, (0, 2), (1, 2))
    tmp14 = tmp3.copy() * 2
    tmp14 += tmp4
    tmp22 = einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp30 = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    rdm2.ovvv = einsum(tmp30, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvv += einsum(t1, (0, 1), tmp30, (2, 3), (0, 2, 1, 3))
    tmp29 = einsum(t1, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.vovo += tmp29.transpose((2, 1, 3, 0))
    rdm2.voov += tmp29.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo += tmp29.transpose((1, 2, 3, 0)) * -1
    rdm2.ovov += tmp29.transpose((1, 2, 0, 3))
    tmp36 = einsum(t1, (0, 1), tmp19, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.vovv = tmp36.transpose((1, 0, 3, 2)).copy() * -1
    rdm2.vovv += tmp36.transpose((1, 0, 2, 3))
    tmp10 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 0, 4, 3), (4, 2))
    tmp11 = einsum(tmp4, (0, 1), t1, (0, 2), (1, 2))
    tmp13 = tmp0.transpose((1, 0, 3, 2)).copy() * -0.5
    tmp13 += tmp2.transpose((0, 1, 3, 2))
    rdm2.oovv = einsum(t2, (0, 1, 2, 3), tmp13, (0, 1, 4, 5), (5, 4, 2, 3)) * 0.5
    rdm2.ooov += einsum(tmp13, (0, 1, 2, 3), t1, (0, 4), (3, 2, 1, 4)) * -1
    tmp20 = einsum(t2, (0, 1, 2, 3), tmp19, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp19
    tmp18 = einsum(t1, (0, 1), tmp5, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp5
    tmp25 = einsum(tmp9, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp9
    tmp8 = tmp6.copy()
    tmp8 += tmp7 * -1
    del tmp7
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp8, (2, 3), (0, 2, 1, 3))
    rdm2.ooov += einsum(tmp8, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    tmp15 = einsum(tmp14, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    del tmp14
    tmp38 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2.vvvv = einsum(tmp38, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    rdm2.vvvo = tmp38.transpose((2, 1, 3, 0)).copy()
    rdm2.vvov = tmp38.transpose((2, 1, 0, 3)).copy() * -1
    del tmp38
    tmp31 = tmp30.copy()
    tmp31 += tmp22 * 0.5
    rdm2.vovv += einsum(tmp31, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovv += einsum(t1, (0, 1), tmp31, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp31, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp31, (2, 3), (0, 2, 1, 3))
    del tmp31
    tmp33 = einsum(l1, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.vovv += tmp33.transpose((1, 0, 3, 2))
    rdm2.ovvv += tmp33.transpose((0, 1, 3, 2)) * -1
    del tmp33
    tmp34 = einsum(tmp1, (0, 1, 2, 3), t2, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    del tmp1
    rdm2.vovv += tmp34.transpose((1, 0, 3, 2)) * 0.5
    rdm2.ovvv += tmp34.transpose((0, 1, 3, 2)) * -0.5
    del tmp34
    tmp35 = einsum(t1, (0, 1), tmp29, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp29
    rdm2.vovv += tmp35.transpose((1, 0, 3, 2))
    rdm2.ovvv += tmp35.transpose((0, 1, 3, 2)) * -1
    del tmp35
    tmp37 = tmp36.copy()
    del tmp36
    tmp37 += einsum(t1, (0, 1), tmp22, (2, 3), (0, 2, 1, 3)) * -0.5
    rdm2.ovvv += tmp37.transpose((0, 1, 3, 2))
    rdm2.ovvv += tmp37 * -1
    del tmp37
    tmp32 = tmp30.copy() * 2
    del tmp30
    tmp32 += tmp22
    rdm2.vovo += einsum(tmp32, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 0.5
    rdm2.voov += einsum(tmp32, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -0.5
    del tmp32
    tmp27 = einsum(t2, (0, 1, 2, 3), tmp3, (1, 4), (4, 0, 2, 3))
    del tmp3
    rdm2.oovv += tmp27.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp27.transpose((0, 1, 3, 2)) * -1
    del tmp27
    tmp12 = tmp10.copy()
    tmp12 += tmp11
    del tmp11
    rdm2.oovv += einsum(t1, (0, 1), tmp12, (2, 3), (2, 0, 3, 1)) * -0.5
    rdm2.oovv += einsum(tmp12, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * 0.5
    rdm2.oovv += einsum(t1, (0, 1), tmp12, (2, 3), (0, 2, 3, 1)) * 0.5
    rdm2.oovv += einsum(tmp12, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -0.5
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp12, (2, 3), (0, 2, 1, 3)) * -0.5
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp12, (2, 3), (2, 0, 1, 3)) * 0.5
    del tmp12
    tmp23 = einsum(tmp22, (0, 1), t2, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp22
    rdm2.oovv += tmp23.transpose((0, 1, 3, 2)) * 0.5
    rdm2.oovv += tmp23 * -0.5
    del tmp23
    tmp24 = einsum(t2, (0, 1, 2, 3), tmp4, (1, 4), (0, 4, 2, 3))
    del tmp4
    rdm2.oovv += tmp24.transpose((1, 0, 3, 2)) * -0.5
    rdm2.oovv += tmp24.transpose((0, 1, 3, 2)) * 0.5
    del tmp24
    tmp28 = einsum(tmp13, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4)) * -2
    del tmp13
    rdm2.oovv += einsum(t1, (0, 1), tmp28, (0, 2, 3, 4), (2, 3, 1, 4)) * 0.5
    del tmp28
    tmp21 = tmp18.copy()
    del tmp18
    tmp21 += tmp20
    del tmp20
    rdm2.oovv += tmp21.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp21
    del tmp21
    tmp26 = tmp25.copy()
    del tmp25
    tmp26 += einsum(t1, (0, 1), tmp8, (2, 3), (0, 2, 1, 3)) * -1
    del tmp8
    rdm2.oovv += tmp26.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp26.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp26.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp26 * -1
    del tmp26
    tmp16 = tmp6.copy() * -1
    del tmp6
    tmp16 += tmp10 * 0.5
    del tmp10
    tmp16 += tmp15
    del tmp15
    rdm2.oovo += einsum(tmp16, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3))
    rdm2.oovo += einsum(tmp16, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    del tmp16
    tmp17 = tmp0.transpose((1, 0, 3, 2)).copy() * -1
    del tmp0
    tmp17 += tmp2.transpose((0, 1, 3, 2)) * 2
    del tmp2
    rdm2.oovo += einsum(tmp17, (0, 1, 2, 3), t1, (0, 4), (3, 2, 4, 1)) * 0.5
    del tmp17
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    del delta
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vvoo = l2.copy()
    rdm2.vvvv += einsum(t2, (0, 1, 2, 3), l2, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = rdm2.swapaxes(1, 2)

    return rdm2

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:43.669981.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    tmp2 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp22 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp14 = einsum(tmp2, (0, 1), t1, (2, 1), (2, 0))
    tmp13 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp9 = einsum(r1, (0,), v.ooov, (1, 0, 2, 3), (1, 2, 3))
    tmp11 = einsum(r2, (0, 1, 2), v.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp39 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp38 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp45 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp23 = f.vv.copy()
    tmp23 += tmp22.transpose((1, 0)) * -1
    tmp15 = tmp13.copy()
    del tmp13
    tmp15 += tmp14.transpose((1, 0))
    del tmp14
    tmp17 = einsum(tmp9, (0, 1, 2), t1, (3, 2), (3, 0, 1))
    tmp18 = einsum(tmp11, (0, 1, 2), t1, (3, 2), (0, 3, 1)) * -1
    tmp48 = tmp38.copy() * 2
    tmp48 += tmp39.transpose((1, 0))
    tmp46 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -1
    tmp46 += tmp45.transpose((0, 2, 1, 3)) * -1
    tmp24 = einsum(tmp23, (0, 1), t1, (2, 0), (2, 1))
    del tmp23
    tmp25 = einsum(t1, (0, 1), tmp15, (0, 2), (2, 1))
    tmp21 = einsum(tmp2, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp19 = tmp17.copy()
    del tmp17
    tmp19 += tmp18.transpose((0, 2, 1))
    del tmp18
    tmp1 = einsum(r1, (0,), t1, (1, 2), (1, 0, 2))
    tmp1 += r2 * -0.5
    r1new = einsum(tmp1, (0, 1, 2), v.ovoo, (3, 2, 0, 1), (3,))
    tmp30 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp32 = einsum(v.ooov, (0, 1, 2, 3), r2, (4, 1, 3), (4, 0, 2))
    tmp44 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1))
    tmp43 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp49 = einsum(t1, (0, 1), tmp48, (0, 2), (2, 1)) * 0.5
    del tmp48
    tmp42 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp47 = einsum(t2, (0, 1, 2, 3), tmp46, (4, 0, 1, 3), (4, 2)) * -0.5
    del tmp46
    tmp40 = tmp38.transpose((1, 0)).copy() * 2
    del tmp38
    tmp40 += tmp39
    del tmp39
    tmp36 = r2.copy()
    tmp36 += einsum(r1, (0,), t1, (1, 2), (0, 1, 2))
    tmp34 = einsum(v.ovvv, (0, 1, 2, 3), r2, (4, 0, 3), (4, 1, 2))
    tmp0 = einsum(r1, (0,), v.oovv, (1, 0, 2, 3), (1, 2, 3))
    r1new += einsum(tmp0, (0, 1, 2), t2, (3, 0, 2, 1), (3,)) * -0.5
    tmp56 = t2.copy()
    tmp56 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp10 = einsum(t2, (0, 1, 2, 3), tmp9, (1, 4, 3), (0, 4, 2)) * -1
    del tmp9
    tmp16 = einsum(r2, (0, 1, 2), tmp15, (1, 3), (3, 0, 2)) * -1
    del tmp15
    tmp12 = einsum(tmp11, (0, 1, 2), t2, (3, 1, 4, 2), (0, 3, 4))
    del tmp11
    tmp26 = tmp21.copy() * -1
    del tmp21
    tmp26 += tmp24 * -1
    del tmp24
    tmp26 += tmp25
    del tmp25
    tmp20 = einsum(tmp19, (0, 1, 2), t1, (1, 3), (0, 2, 3))
    del tmp19
    tmp5 = einsum(tmp1, (0, 1, 2), v.oovv, (0, 1, 3, 2), (3,)) * -2
    tmp4 = einsum(r1, (0,), f.ov, (0, 1), (1,))
    tmp31 = einsum(tmp30, (0, 1, 2, 3), r2, (2, 1, 4), (0, 3, 4)) * -1
    del tmp30
    tmp33 = einsum(t1, (0, 1), tmp32, (2, 0, 3), (2, 3, 1)) * -1
    del tmp32
    tmp50 = tmp42.copy()
    del tmp42
    tmp50 += tmp43 * -1
    del tmp43
    tmp50 += tmp44 * 0.5
    del tmp44
    tmp50 += tmp47
    del tmp47
    tmp50 += tmp49
    del tmp49
    tmp28 = einsum(r2, (0, 1, 2), f.oo, (3, 1), (3, 0, 2))
    tmp41 = einsum(r2, (0, 1, 2), tmp40, (3, 1), (3, 0, 2)) * -0.5
    del tmp40
    tmp37 = einsum(v.ovov, (0, 1, 2, 3), tmp36, (2, 4, 1), (4, 0, 3))
    del tmp36
    tmp35 = einsum(t1, (0, 1), tmp34, (2, 3, 1), (2, 0, 3)) * -1
    del tmp34
    tmp29 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp7 = einsum(r1, (0,), v.ovvv, (0, 1, 2, 3), (1, 2, 3))
    tmp52 = einsum(tmp0, (0, 1, 2), t1, (3, 2), (3, 0, 1))
    del tmp0
    tmp57 = f.vv.copy() * -1
    tmp57 += einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp57 += tmp22.transpose((1, 0))
    del tmp22
    tmp57 += einsum(v.oovv, (0, 1, 2, 3), tmp56, (0, 1, 3, 4), (2, 4)) * -0.5
    del tmp56
    r2new = einsum(tmp57, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp57
    tmp27 = einsum(r1, (0,), f.ov, (1, 2), (1, 0, 2))
    tmp27 += tmp10 * -1
    del tmp10
    tmp27 += tmp12 * -1
    del tmp12
    tmp27 += tmp16.transpose((1, 0, 2)) * -1
    del tmp16
    tmp27 += tmp20 * -1
    del tmp20
    tmp27 += einsum(r1, (0,), tmp26, (1, 2), (0, 1, 2))
    del tmp26
    r2new += tmp27.transpose((1, 0, 2))
    r2new += tmp27 * -1
    del tmp27
    tmp6 = tmp4.copy() * 2
    del tmp4
    tmp6 += tmp5
    del tmp5
    r2new += einsum(tmp6, (0,), t2, (1, 2, 3, 0), (1, 2, 3)) * 0.5
    r1new += einsum(tmp6, (0,), t1, (1, 0), (1,)) * -0.5
    del tmp6
    tmp51 = tmp28.copy() * -1
    del tmp28
    tmp51 += einsum(r1, (0,), tmp29, (1, 2), (1, 0, 2)) * -1
    del tmp29
    tmp51 += tmp31 * 0.5
    del tmp31
    tmp51 += tmp33 * -1
    del tmp33
    tmp51 += tmp35 * -1
    del tmp35
    tmp51 += tmp37 * -1
    del tmp37
    tmp51 += tmp41.transpose((1, 0, 2)) * -1
    del tmp41
    tmp51 += einsum(r1, (0,), tmp50, (1, 2), (0, 1, 2))
    del tmp50
    r2new += tmp51.transpose((1, 0, 2))
    r2new += tmp51 * -1
    del tmp51
    tmp8 = einsum(tmp7, (0, 1, 2), t1, (3, 1), (3, 0, 2)) * -1
    r2new += einsum(t1, (0, 1), tmp8, (2, 3, 1), (0, 2, 3)) * -1
    del tmp8
    tmp58 = einsum(r1, (0,), v.oooo, (1, 2, 3, 0), (1, 2, 3))
    tmp58 += einsum(tmp52, (0, 1, 2), t1, (3, 2), (0, 3, 1)) * -1
    r2new += einsum(tmp58, (0, 1, 2), t1, (2, 3), (1, 0, 3))
    del tmp58
    tmp53 = einsum(t2, (0, 1, 2, 3), tmp52, (4, 1, 3), (4, 0, 2))
    del tmp52
    r2new += tmp53.transpose((1, 0, 2))
    r2new += tmp53 * -1
    del tmp53
    tmp55 = v.oooo.copy()
    tmp55 += einsum(t1, (0, 1), tmp45, (2, 3, 4, 1), (4, 3, 0, 2)) * -1
    del tmp45
    r2new += einsum(r2, (0, 1, 2), tmp55, (0, 1, 3, 4), (3, 4, 2)) * 0.5
    del tmp55
    tmp54 = tmp7.transpose((0, 2, 1)).copy()
    del tmp7
    tmp54 += einsum(v.oovv, (0, 1, 2, 3), tmp1, (0, 1, 4), (4, 2, 3)) * -1
    del tmp1
    r2new += einsum(tmp54, (0, 1, 2), t2, (3, 4, 1, 2), (3, 4, 0)) * 0.5
    del tmp54
    tmp3 = f.ov.copy()
    tmp3 += tmp2
    del tmp2
    r1new += einsum(r2, (0, 1, 2), tmp3, (1, 2), (0,))
    del tmp3
    r1new += einsum(r1, (0,), f.oo, (1, 0), (1,)) * -1
    r2new += einsum(r1, (0,), v.ooov, (1, 2, 0, 3), (1, 2, 3)) * -1

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:45:53.192267.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    tmp2 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp33 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp34 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp9 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp51 = einsum(tmp2, (0, 1), t1, (2, 1), (2, 0))
    tmp50 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp24 = einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp25 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp35 = tmp33.copy() * 2
    tmp35 += tmp34.transpose((1, 0))
    del tmp34
    tmp31 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -1
    tmp31 += tmp9.transpose((0, 2, 1, 3)) * -1
    tmp12 = r2.transpose((2, 0, 1)).copy()
    tmp12 += einsum(t1, (0, 1), r1, (2,), (0, 2, 1))
    tmp16 = einsum(tmp2, (0, 1), t1, (0, 2), (2, 1))
    tmp15 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp44 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    tmp45 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp52 = tmp50.copy()
    tmp52 += tmp51.transpose((1, 0))
    del tmp51
    tmp1 = einsum(r1, (0,), t1, (1, 2), (1, 2, 0))
    tmp1 += r2.transpose((2, 0, 1)) * -0.5
    r1new = einsum(tmp1, (0, 1, 2), v.ovvv, (0, 3, 1, 2), (3,))
    tmp26 = tmp24.transpose((1, 0)).copy()
    del tmp24
    tmp26 += tmp25 * 0.5
    del tmp25
    tmp38 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp22 = r2.transpose((2, 0, 1)).copy()
    tmp22 += einsum(t1, (0, 1), r1, (2,), (0, 2, 1))
    tmp20 = einsum(r2, (0, 1, 2), v.ovvv, (3, 4, 0, 1), (2, 3, 4))
    tmp36 = einsum(tmp35, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    del tmp35
    tmp30 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1))
    tmp32 = einsum(t2, (0, 1, 2, 3), tmp31, (4, 0, 1, 3), (4, 2)) * -0.5
    del tmp31
    tmp28 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp29 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp10 = einsum(r2, (0, 1, 2), tmp9, (3, 2, 4, 1), (3, 4, 0)) * -1
    del tmp9
    tmp13 = einsum(v.oovv, (0, 1, 2, 3), tmp12, (1, 3, 4), (0, 4, 2))
    del tmp12
    tmp17 = tmp15.copy()
    tmp17 += tmp16
    del tmp16
    tmp41 = einsum(v.ovvv, (0, 1, 2, 3), r1, (3,), (0, 1, 2))
    tmp42 = t2.copy()
    tmp42 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    tmp46 = tmp44.transpose((1, 0, 2, 3)).copy()
    del tmp44
    tmp46 += tmp45
    del tmp45
    tmp48 = einsum(t1, (0, 1), tmp15, (2, 1), (0, 2))
    del tmp15
    tmp53 = einsum(tmp52, (0, 1), t1, (0, 2), (1, 2))
    del tmp52
    tmp49 = einsum(tmp2, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp56 = einsum(r1, (0,), t1, (1, 2), (1, 2, 0)) * 2
    tmp56 += r2.transpose((2, 0, 1)) * -1
    r2new = einsum(v.vvvv, (0, 1, 2, 3), tmp56, (4, 2, 3), (0, 1, 4)) * -0.5
    tmp5 = einsum(tmp1, (0, 1, 2), v.oovv, (3, 0, 1, 2), (3,)) * -1
    del tmp1
    tmp4 = einsum(f.ov, (0, 1), r1, (1,), (0,))
    tmp27 = einsum(r2, (0, 1, 2), tmp26, (3, 1), (2, 3, 0)) * -1
    del tmp26
    tmp39 = f.ov.copy()
    tmp39 += tmp38
    del tmp38
    tmp23 = einsum(tmp22, (0, 1, 2), v.ovov, (3, 1, 0, 4), (3, 4, 2))
    del tmp22
    tmp21 = einsum(tmp20, (0, 1, 2), t1, (1, 3), (0, 3, 2))
    del tmp20
    tmp37 = tmp28.copy()
    del tmp28
    tmp37 += tmp29 * -1
    del tmp29
    tmp37 += tmp30 * 0.5
    del tmp30
    tmp37 += tmp32
    del tmp32
    tmp37 += tmp36
    del tmp36
    tmp11 = einsum(tmp10, (0, 1, 2), t1, (1, 3), (0, 2, 3)) * -1
    del tmp10
    tmp14 = einsum(t2, (0, 1, 2, 3), tmp13, (1, 4, 3), (0, 4, 2)) * -1
    del tmp13
    tmp8 = einsum(r2, (0, 1, 2), f.vv, (3, 1), (2, 3, 0))
    tmp18 = einsum(r2, (0, 1, 2), tmp17, (3, 1), (2, 3, 0)) * -1
    del tmp17
    tmp7 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp43 = einsum(tmp41, (0, 1, 2), tmp42, (0, 3, 2, 4), (3, 4, 1))
    del tmp41, tmp42
    tmp47 = einsum(r2, (0, 1, 2), tmp46, (3, 2, 4, 1), (3, 4, 0)) * -1
    del tmp46
    tmp54 = tmp48.copy()
    del tmp48
    tmp54 += tmp49 * -1
    del tmp49
    tmp54 += tmp53
    del tmp53
    tmp59 = t2.copy()
    tmp59 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp57 = einsum(r1, (0,), v.ooov, (1, 2, 3, 0), (1, 2, 3)) * -2
    tmp57 += einsum(tmp56, (0, 1, 2), v.oovv, (3, 4, 1, 2), (3, 4, 0)) * -1
    del tmp56
    tmp6 = tmp4.copy()
    del tmp4
    tmp6 += tmp5
    del tmp5
    r2new += einsum(tmp6, (0,), t2, (1, 0, 2, 3), (2, 3, 1))
    r1new += einsum(tmp6, (0,), t1, (0, 1), (1,)) * -1
    del tmp6
    tmp40 = tmp21.copy() * 0.5
    del tmp21
    tmp40 += tmp23.transpose((0, 2, 1)) * -1
    del tmp23
    tmp40 += tmp27.transpose((0, 2, 1)) * -1
    del tmp27
    tmp40 += einsum(tmp37, (0, 1), r1, (2,), (0, 2, 1))
    del tmp37
    tmp40 += einsum(tmp39, (0, 1), r1, (2,), (0, 1, 2))
    del tmp39
    r2new += tmp40.transpose((2, 1, 0))
    r2new += tmp40.transpose((1, 2, 0)) * -1
    del tmp40
    tmp19 = einsum(tmp7, (0, 1), r1, (2,), (0, 2, 1))
    del tmp7
    tmp19 += tmp8
    del tmp8
    tmp19 += tmp11
    del tmp11
    tmp19 += tmp14 * -1
    del tmp14
    tmp19 += tmp18.transpose((0, 2, 1)) * -1
    del tmp18
    r2new += tmp19.transpose((2, 1, 0))
    r2new += tmp19.transpose((1, 2, 0)) * -1
    del tmp19
    tmp58 = t2.copy() * 0.5
    tmp58 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    r2new += einsum(tmp57, (0, 1, 2), tmp58, (0, 1, 3, 4), (4, 3, 2)) * -0.5
    del tmp57, tmp58
    tmp55 = tmp43.copy() * -1
    del tmp43
    tmp55 += tmp47.transpose((0, 2, 1)) * -1
    del tmp47
    tmp55 += einsum(r1, (0,), tmp54, (1, 2), (1, 0, 2)) * -1
    del tmp54
    r2new += tmp55.transpose((2, 1, 0)) * -1
    r2new += tmp55.transpose((1, 2, 0))
    del tmp55
    tmp60 = f.oo.copy() * 2
    tmp60 += tmp33 * 2
    del tmp33
    tmp60 += tmp50 * 2
    del tmp50
    tmp60 += einsum(v.oovv, (0, 1, 2, 3), tmp59, (1, 4, 2, 3), (0, 4)) * -1
    del tmp59
    r2new += einsum(r2, (0, 1, 2), tmp60, (2, 3), (0, 1, 3)) * -0.5
    del tmp60
    tmp0 = einsum(r1, (0,), v.oovv, (1, 2, 3, 0), (1, 2, 3))
    r1new += einsum(tmp0, (0, 1, 2), t2, (1, 0, 3, 2), (3,)) * -0.5
    del tmp0
    tmp3 = f.ov.copy()
    tmp3 += tmp2
    del tmp2
    r1new += einsum(tmp3, (0, 1), r2, (2, 1, 0), (2,))
    del tmp3
    r1new += einsum(r1, (0,), f.vv, (1, 0), (1,))
    r2new += einsum(v.ovvv, (0, 1, 2, 3), r1, (1,), (2, 3, 0)) * -1

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ee(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:46:17.367651.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    tmp26 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 4), (2, 1, 3, 4))
    tmp2 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp5 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp56 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp27 = v.ovvv.copy()
    tmp27 += tmp26.transpose((0, 1, 3, 2))
    tmp47 = r2.copy() * 0.5
    tmp47 += einsum(r1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp11 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp10 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp3 = v.ovoo.transpose((0, 2, 3, 1)).copy() * -1
    tmp3 += tmp2.transpose((0, 2, 1, 3)) * -1
    r1new = einsum(tmp3, (0, 1, 2, 3), r2, (1, 2, 4, 3), (0, 4)) * 0.5
    tmp51 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp93 = einsum(tmp5, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    tmp92 = einsum(tmp56, (0, 1, 2, 3), t1, (4, 3), (0, 4, 1, 2)) * -1
    tmp91 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp0 = einsum(v.oovv, (0, 1, 2, 3), r1, (1, 3), (0, 2))
    r1new += einsum(tmp0, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp73 = einsum(tmp2, (0, 1, 2, 3), t1, (4, 3), (0, 4, 2, 1))
    tmp76 = einsum(tmp5, (0, 1), t1, (0, 2), (2, 1))
    tmp64 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp67 = einsum(tmp5, (0, 1), t1, (2, 1), (2, 0))
    tmp83 = einsum(r1, (0, 1), tmp2, (2, 3, 4, 1), (0, 2, 4, 3)) * -1
    tmp17 = r2.copy() * -1
    tmp17 += einsum(r1, (0, 1), t1, (2, 3), (0, 2, 3, 1))
    tmp17 += einsum(r1, (0, 1), t1, (2, 3), (2, 0, 1, 3))
    tmp25 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp28 = einsum(t2, (0, 1, 2, 3), tmp27, (4, 5, 2, 3), (0, 1, 4, 5)) * 0.5
    del tmp27
    tmp31 = einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp32 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp60 = t2.copy()
    tmp60 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    tmp55 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    tmp48 = einsum(tmp47, (0, 1, 2, 3), v.oovv, (4, 0, 2, 3), (4, 1)) * -2
    del tmp47
    tmp7 = einsum(r1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp44 = v.ooov.copy()
    tmp44 += tmp2.transpose((2, 1, 0, 3))
    tmp41 = einsum(r1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp113 = f.oo.copy()
    tmp113 += tmp10
    tmp113 += tmp11
    tmp97 = r2.copy() * -1
    tmp97 += einsum(r1, (0, 1), t1, (2, 3), (0, 2, 3, 1))
    tmp97 += einsum(r1, (0, 1), t1, (2, 3), (2, 0, 1, 3))
    tmp103 = einsum(tmp3, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4)) * -0.5
    del tmp3
    tmp99 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp101 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1))
    tmp102 = einsum(tmp51, (0, 1), t1, (1, 2), (0, 2))
    tmp100 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp94 = tmp91.transpose((1, 0, 2, 3)).copy()
    del tmp91
    tmp94 += tmp92
    del tmp92
    tmp94 += tmp93
    del tmp93
    tmp89 = einsum(r1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp71 = einsum(t2, (0, 1, 2, 3), tmp0, (4, 3), (0, 1, 4, 2)) * -1
    tmp74 = einsum(tmp73, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp73
    tmp77 = tmp64.copy()
    tmp77 += tmp76
    del tmp76
    tmp86 = tmp11.copy()
    tmp86 += tmp67.transpose((1, 0))
    tmp81 = einsum(tmp0, (0, 1), t1, (2, 1), (2, 0)) * -1
    del tmp0
    tmp84 = einsum(tmp83, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp83
    tmp15 = einsum(r2, (0, 1, 2, 3), tmp2, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    del tmp2
    tmp18 = einsum(v.oovv, (0, 1, 2, 3), tmp17, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp17
    tmp21 = einsum(v.ovvv, (0, 1, 2, 3), r2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp23 = einsum(v.oovv, (0, 1, 2, 3), r2, (0, 1, 4, 3), (4, 2))
    tmp29 = tmp25.transpose((0, 2, 1, 3)).copy()
    del tmp25
    tmp29 += tmp28.transpose((2, 1, 0, 3)) * -1
    del tmp28
    tmp33 = tmp31.transpose((1, 0)).copy()
    del tmp31
    tmp33 += tmp32 * 0.5
    del tmp32
    tmp62 = einsum(v.ooov, (0, 1, 2, 3), tmp60, (1, 4, 3, 5), (0, 2, 4, 5)) * -1
    tmp68 = einsum(tmp67, (0, 1), t1, (1, 2), (0, 2))
    del tmp67
    tmp65 = einsum(t1, (0, 1), tmp64, (2, 1), (0, 2))
    del tmp64
    tmp66 = einsum(tmp5, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp57 = tmp55.copy()
    del tmp55
    tmp57 += tmp56.transpose((1, 0, 2, 3))
    del tmp56
    tmp59 = einsum(r1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp38 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp8 = einsum(r1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp49 = tmp7.transpose((1, 0)).copy() * 2
    tmp49 += tmp48.transpose((1, 0))
    del tmp48
    tmp45 = einsum(tmp44, (0, 1, 2, 3), r1, (4, 3), (0, 1, 2, 4))
    del tmp44
    tmp52 = tmp10.transpose((1, 0)).copy() * 2
    tmp52 += tmp51
    del tmp51
    tmp42 = einsum(tmp41, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4)) * -1
    del tmp41
    tmp36 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp107 = einsum(r2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp106 = einsum(r1, (0, 1), v.ooov, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp112 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp114 = einsum(tmp113, (0, 1), t1, (0, 2), (1, 2))
    del tmp113
    tmp98 = einsum(tmp97, (0, 1, 2, 3), v.ovov, (4, 2, 0, 5), (1, 4, 3, 5))
    del tmp97
    tmp104 = tmp99.copy()
    del tmp99
    tmp104 += tmp100 * -1
    del tmp100
    tmp104 += tmp101 * 0.5
    del tmp101
    tmp104 += tmp102 * 0.5
    del tmp102
    tmp104 += tmp103
    del tmp103
    tmp12 = t2.copy()
    tmp12 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp95 = einsum(tmp94, (0, 1, 2, 3), r1, (2, 4), (0, 1, 3, 4))
    del tmp94
    tmp90 = einsum(t2, (0, 1, 2, 3), tmp89, (4, 3), (0, 1, 2, 4)) * -1
    del tmp89
    tmp72 = einsum(tmp71, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3)) * -1
    del tmp71
    tmp75 = einsum(r1, (0, 1), tmp74, (2, 3, 0, 4), (3, 2, 1, 4)) * -1
    del tmp74
    tmp78 = einsum(tmp77, (0, 1), r2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    del tmp77
    tmp87 = einsum(r2, (0, 1, 2, 3), tmp86, (1, 4), (4, 0, 2, 3)) * -1
    del tmp86
    tmp82 = einsum(t2, (0, 1, 2, 3), tmp81, (4, 1), (4, 0, 2, 3)) * -1
    del tmp81
    tmp80 = einsum(r1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp85 = einsum(t1, (0, 1), tmp84, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp84
    tmp16 = einsum(t1, (0, 1), tmp15, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp15
    tmp19 = einsum(t2, (0, 1, 2, 3), tmp18, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp18
    tmp22 = einsum(tmp21, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp21
    tmp24 = einsum(tmp23, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    del tmp23
    tmp30 = einsum(r1, (0, 1), tmp29, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp29
    tmp34 = einsum(r2, (0, 1, 2, 3), tmp33, (4, 3), (0, 1, 4, 2)) * -1
    del tmp33
    tmp63 = einsum(r1, (0, 1), tmp62, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    del tmp62
    tmp69 = tmp65.copy()
    del tmp65
    tmp69 += tmp66 * -1
    del tmp66
    tmp69 += tmp68
    del tmp68
    tmp58 = einsum(r2, (0, 1, 2, 3), tmp57, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp57
    tmp61 = einsum(tmp59, (0, 1, 2, 3), tmp60, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp60, tmp59
    tmp39 = einsum(tmp38, (0, 1, 2, 3), r2, (2, 1, 4, 5), (0, 3, 4, 5)) * -1
    del tmp38
    tmp40 = einsum(t2, (0, 1, 2, 3), tmp8, (1, 4), (0, 4, 2, 3)) * -1
    tmp50 = einsum(t2, (0, 1, 2, 3), tmp49, (4, 1), (0, 4, 2, 3)) * -0.5
    del tmp49
    tmp46 = einsum(t2, (0, 1, 2, 3), tmp45, (1, 0, 4, 5), (5, 4, 2, 3)) * -0.5
    del tmp45
    tmp53 = einsum(r2, (0, 1, 2, 3), tmp52, (4, 1), (4, 0, 2, 3)) * -0.5
    del tmp52
    tmp43 = einsum(t1, (0, 1), tmp42, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp42
    tmp37 = einsum(tmp36, (0, 1, 2, 3), r1, (4, 3), (4, 0, 1, 2))
    del tmp36
    tmp4 = r2.copy()
    tmp4 += einsum(r1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    tmp4 += einsum(r1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    r1new += einsum(tmp4, (0, 1, 2, 3), v.ovvv, (0, 4, 2, 3), (1, 4)) * 0.5
    tmp108 = tmp106.transpose((1, 0, 2, 3)).copy() * -1
    del tmp106
    tmp108 += tmp107.transpose((1, 0, 2, 3)) * -1
    del tmp107
    r2new = tmp108.transpose((0, 1, 3, 2)).copy()
    r2new += tmp108 * -1
    del tmp108
    tmp115 = f.ov.copy() * -1
    tmp115 += tmp112 * -1
    del tmp112
    tmp115 += tmp114
    del tmp114
    r2new += einsum(r1, (0, 1), tmp115, (2, 3), (2, 0, 1, 3))
    r2new += einsum(tmp115, (0, 1), r1, (2, 3), (2, 0, 1, 3))
    r2new += einsum(r1, (0, 1), tmp115, (2, 3), (0, 2, 1, 3)) * -1
    r2new += einsum(tmp115, (0, 1), r1, (2, 3), (0, 2, 1, 3)) * -1
    del tmp115
    tmp105 = tmp98.copy() * -1
    del tmp98
    tmp105 += einsum(r1, (0, 1), tmp104, (2, 3), (0, 2, 1, 3))
    del tmp104
    r2new += tmp105.transpose((1, 0, 3, 2)) * -1
    r2new += tmp105.transpose((1, 0, 2, 3))
    r2new += tmp105.transpose((0, 1, 3, 2))
    r2new += tmp105 * -1
    del tmp105
    tmp14 = einsum(v.oovv, (0, 1, 2, 3), r2, (4, 5, 2, 3), (4, 5, 0, 1))
    r2new += einsum(t2, (0, 1, 2, 3), tmp14, (4, 5, 1, 0), (5, 4, 2, 3)) * 0.25
    del tmp14
    tmp111 = v.vvvv.copy()
    tmp111 += einsum(tmp26, (0, 1, 2, 3), t1, (0, 4), (3, 2, 4, 1)) * -1
    del tmp26
    r2new += einsum(tmp111, (0, 1, 2, 3), r2, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    del tmp111
    tmp110 = v.oooo.copy() * 2
    tmp110 += einsum(v.oovv, (0, 1, 2, 3), tmp12, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    r2new += einsum(r2, (0, 1, 2, 3), tmp110, (0, 1, 4, 5), (4, 5, 2, 3)) * 0.25
    del tmp110
    tmp109 = einsum(r2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    r2new += tmp109.transpose((1, 0, 3, 2))
    r2new += tmp109.transpose((0, 1, 3, 2)) * -1
    del tmp109
    tmp96 = tmp90.copy()
    del tmp90
    tmp96 += tmp95.transpose((0, 1, 3, 2)) * -1
    del tmp95
    r2new += tmp96.transpose((0, 1, 3, 2)) * -1
    r2new += tmp96
    del tmp96
    tmp79 = tmp72.copy() * -1
    del tmp72
    tmp79 += tmp75 * -1
    del tmp75
    tmp79 += tmp78.transpose((1, 0, 3, 2))
    del tmp78
    r2new += tmp79.transpose((0, 1, 3, 2))
    r2new += tmp79 * -1
    del tmp79
    tmp88 = tmp80.transpose((0, 1, 3, 2)).copy() * -1
    del tmp80
    tmp88 += tmp82.transpose((0, 1, 3, 2))
    del tmp82
    tmp88 += tmp85.transpose((0, 1, 3, 2))
    del tmp85
    tmp88 += tmp87.transpose((1, 0, 3, 2))
    del tmp87
    r2new += tmp88.transpose((1, 0, 2, 3))
    r2new += tmp88 * -1
    del tmp88
    tmp20 = tmp16.copy()
    del tmp16
    tmp20 += tmp19.transpose((1, 0, 3, 2))
    del tmp19
    r2new += tmp20.transpose((1, 0, 3, 2)) * -1
    r2new += tmp20.transpose((1, 0, 2, 3))
    r2new += tmp20.transpose((0, 1, 3, 2))
    r2new += tmp20 * -1
    del tmp20
    tmp35 = tmp22.copy() * 0.5
    del tmp22
    tmp35 += tmp24 * 0.5
    del tmp24
    tmp35 += tmp30.transpose((1, 0, 3, 2)) * -1
    del tmp30
    tmp35 += tmp34.transpose((1, 0, 3, 2))
    del tmp34
    r2new += tmp35.transpose((0, 1, 3, 2))
    r2new += tmp35 * -1
    del tmp35
    tmp70 = tmp58.transpose((1, 0, 3, 2)).copy()
    del tmp58
    tmp70 += tmp61.transpose((0, 1, 3, 2)) * -1
    del tmp61
    tmp70 += tmp63.transpose((0, 1, 3, 2))
    del tmp63
    tmp70 += einsum(r1, (0, 1), tmp69, (2, 3), (0, 2, 1, 3)) * -1
    del tmp69
    r2new += tmp70.transpose((1, 0, 3, 2))
    r2new += tmp70.transpose((1, 0, 2, 3)) * -1
    r2new += tmp70.transpose((0, 1, 3, 2)) * -1
    r2new += tmp70
    del tmp70
    tmp54 = tmp37.transpose((0, 1, 3, 2)).copy()
    del tmp37
    tmp54 += tmp39.transpose((0, 1, 3, 2)) * -0.5
    del tmp39
    tmp54 += tmp40.transpose((0, 1, 3, 2))
    del tmp40
    tmp54 += tmp43.transpose((0, 1, 3, 2)) * -1
    del tmp43
    tmp54 += tmp46.transpose((0, 1, 3, 2)) * -1
    del tmp46
    tmp54 += tmp50.transpose((1, 0, 3, 2)) * -1
    del tmp50
    tmp54 += tmp53.transpose((1, 0, 3, 2))
    del tmp53
    r2new += tmp54.transpose((1, 0, 2, 3))
    r2new += tmp54 * -1
    del tmp54
    tmp9 = tmp7.copy() * 2
    del tmp7
    tmp9 += tmp8 * 2
    del tmp8
    tmp9 += einsum(tmp4, (0, 1, 2, 3), v.oovv, (4, 0, 2, 3), (4, 1)) * -1
    del tmp4
    r1new += einsum(tmp9, (0, 1), t1, (0, 2), (1, 2)) * -0.5
    del tmp9
    tmp13 = f.oo.copy()
    tmp13 += tmp10
    del tmp10
    tmp13 += tmp11
    del tmp11
    tmp13 += einsum(tmp12, (0, 1, 2, 3), v.oovv, (4, 0, 2, 3), (4, 1)) * -0.5
    del tmp12
    r1new += einsum(r1, (0, 1), tmp13, (0, 2), (2, 1)) * -1
    del tmp13
    tmp6 = f.ov.copy()
    tmp6 += tmp5
    del tmp5
    r1new += einsum(tmp6, (0, 1), r2, (2, 0, 3, 1), (2, 3))
    del tmp6
    tmp1 = einsum(r1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    r1new += einsum(t2, (0, 1, 2, 3), tmp1, (4, 1, 0, 3), (4, 2)) * -0.5
    del tmp1
    r1new += einsum(f.vv, (0, 1), r1, (2, 1), (2, 0))
    r1new += einsum(v.ovov, (0, 1, 2, 3), r1, (2, 1), (0, 3)) * -1

    return {f"r1new": r1new, f"r2new": r2new}

