"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:56:04.829264
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:56:05.544997.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp0 += v.ovov.transpose((0, 2, 1, 3))
    tmp1 = f.ov.copy()
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp0
    e_cc = einsum(t1, (0, 1), tmp1, (0, 1), ()) * 2
    del tmp1
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:56:11.386215.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp14 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp15 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp22 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp16 = tmp14.copy()
    del tmp14
    tmp16 += tmp15.transpose((2, 0, 1, 3))
    del tmp15
    tmp8 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp21 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp2 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp23 = einsum(t1, (0, 1), tmp22, (2, 3, 4, 0), (2, 4, 3, 1))
    del tmp22
    tmp17 = einsum(t1, (0, 1), tmp16, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp16
    tmp13 = einsum(t2, (0, 1, 2, 3), tmp8, (1, 4), (4, 0, 2, 3))
    tmp26 = einsum(t1, (0, 1), tmp21, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp29 = v.oooo.copy()
    tmp29 += einsum(tmp2, (0, 1, 2, 3), t1, (4, 3), (1, 4, 0, 2))
    tmp20 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp24 = einsum(t1, (0, 1), tmp23, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp23
    tmp4 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp4 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp9 = v.ovov.transpose((0, 2, 3, 1)).copy() * 2
    tmp9 += v.ovov.transpose((0, 2, 1, 3)) * -1
    tmp10 = v.ooov.copy()
    tmp10 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp0 = t2.copy()
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp18 = tmp13.copy()
    del tmp13
    tmp18 += tmp17.transpose((0, 1, 3, 2))
    del tmp17
    t2new = tmp18.transpose((1, 0, 2, 3)).copy() * -1
    t2new += tmp18.transpose((0, 1, 3, 2)) * -1
    del tmp18
    tmp27 = einsum(t1, (0, 1), tmp26, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp26
    t2new += tmp27.transpose((1, 0, 3, 2)) * -1
    t2new += tmp27 * -1
    del tmp27
    tmp19 = einsum(t1, (0, 1), tmp2, (2, 3, 0, 4), (2, 3, 1, 4))
    t2new += tmp19.transpose((1, 0, 3, 2)) * -1
    t2new += tmp19 * -1
    del tmp19
    tmp12 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    t2new += einsum(tmp12, (0, 1, 2, 3), t1, (4, 2), (4, 0, 1, 3))
    del tmp12
    tmp30 = v.ooov.transpose((0, 2, 1, 3)).copy() * -1
    tmp30 += einsum(t1, (0, 1), tmp29, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp29
    t2new += einsum(t1, (0, 1), tmp30, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp30
    tmp28 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    t2new += tmp28.transpose((1, 0, 2, 3)) * -1
    t2new += tmp28.transpose((0, 1, 3, 2)) * -1
    del tmp28
    tmp25 = tmp20.copy()
    del tmp20
    tmp25 += tmp21
    del tmp21
    tmp25 += tmp24
    del tmp24
    t2new += tmp25.transpose((1, 0, 2, 3))
    t2new += tmp25.transpose((0, 1, 3, 2))
    del tmp25
    tmp5 = f.ov.copy()
    tmp5 += einsum(t1, (0, 1), tmp4, (0, 2, 1, 3), (2, 3))
    del tmp4
    tmp3 = v.ooov.copy() * -0.5
    tmp3 += v.ooov.transpose((0, 2, 1, 3))
    tmp3 += tmp2
    tmp3 += tmp2.transpose((0, 2, 1, 3)) * -0.5
    del tmp2
    t1new = einsum(tmp3, (0, 1, 2, 3), t2, (1, 2, 3, 4), (0, 4)) * -2
    del tmp3
    tmp1 = v.ovvv.copy()
    tmp1 += v.ovvv.transpose((0, 2, 1, 3)) * -0.5
    t1new += einsum(tmp1, (0, 1, 2, 3), tmp0, (0, 4, 1, 2), (4, 3)) * 2
    del tmp1
    tmp11 = f.oo.copy()
    tmp11 += tmp8
    del tmp8
    tmp11 += einsum(tmp0, (0, 1, 2, 3), tmp9, (0, 4, 3, 2), (4, 1))
    del tmp0, tmp9
    tmp11 += einsum(tmp10, (0, 1, 2, 3), t1, (2, 3), (1, 0)) * 2
    del tmp10
    t1new += einsum(t1, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    tmp6 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp6 += t2 * 2
    t1new += einsum(tmp6, (0, 1, 2, 3), tmp5, (0, 2), (1, 3))
    del tmp6, tmp5
    tmp7 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp7 += v.oovv * -1
    t1new += einsum(t1, (0, 1), tmp7, (0, 2, 1, 3), (2, 3))
    del tmp7
    t1new += f.ov
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t2new += v.ovov.transpose((0, 2, 1, 3))
    t2new += einsum(v.ovoo, (0, 1, 2, 3), t1, (3, 4), (0, 2, 1, 4)) * -1

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:57:03.643064.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp51 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp51 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp5 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp78 = einsum(tmp51, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    tmp4 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp6 = einsum(t1, (0, 1), tmp5, (2, 3, 4, 1), (0, 2, 3, 4))
    l2new = einsum(tmp6, (0, 1, 2, 3), l2, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp2 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3))
    tmp68 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp20 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp77 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp79 = einsum(t1, (0, 1), tmp78, (2, 1), (0, 2))
    tmp10 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp10 += v.ovov.transpose((0, 2, 1, 3))
    tmp7 = tmp4.transpose((1, 0, 3, 2)).copy()
    del tmp4
    tmp7 += tmp6
    del tmp6
    tmp48 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp101 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp86 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp71 = v.oovv.copy()
    tmp71 += tmp2.transpose((0, 1, 3, 2))
    tmp16 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp69 = v.ovov.transpose((0, 2, 3, 1)).copy()
    tmp69 += tmp68
    del tmp68
    tmp67 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp67 += l2.transpose((2, 3, 0, 1)) * 2
    tmp73 = tmp20.copy() * 2
    tmp73 += tmp20.transpose((1, 0, 2, 3)) * -1
    tmp63 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp75 = tmp5.copy() * -1
    tmp75 += tmp5.transpose((0, 2, 1, 3)) * 2
    tmp80 = tmp77.copy()
    del tmp77
    tmp80 += tmp79 * -1
    del tmp79
    tmp11 = einsum(t1, (0, 1), tmp10, (0, 2, 1, 3), (2, 3)) * 2
    tmp8 = einsum(t1, (0, 1), tmp7, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp7
    tmp1 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp3 = einsum(t1, (0, 1), tmp2, (2, 3, 4, 1), (2, 0, 3, 4))
    del tmp2
    tmp38 = t2.transpose((0, 1, 3, 2)).copy()
    tmp38 += t2 * -0.5
    tmp35 = einsum(t1, (0, 1), tmp20, (2, 3, 4, 1), (3, 2, 4, 0))
    l2new += einsum(tmp35, (0, 1, 2, 3), v.ovov, (3, 4, 2, 5), (4, 5, 1, 0))
    tmp40 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp98 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp94 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    tmp95 = einsum(tmp5, (0, 1, 2, 3), l1, (4, 0), (1, 2, 4, 3))
    tmp96 = einsum(tmp48, (0, 1), v.ovov, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp100 = einsum(l1, (0, 1), v.ooov, (2, 1, 3, 4), (2, 3, 0, 4))
    tmp102 = einsum(tmp101, (0, 1), l2, (2, 3, 4, 1), (4, 0, 2, 3))
    del tmp101
    tmp87 = einsum(l2, (0, 1, 2, 3), tmp86, (4, 3), (4, 2, 0, 1))
    del tmp86
    tmp92 = einsum(l2, (0, 1, 2, 3), tmp71, (2, 4, 1, 5), (3, 4, 0, 5))
    tmp89 = einsum(tmp16, (0, 1, 2, 3), l2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp91 = einsum(tmp5, (0, 1, 2, 3), tmp20, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp88 = einsum(tmp20, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp84 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp85 = einsum(l1, (0, 1), v.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp90 = einsum(v.ooov, (0, 1, 2, 3), tmp20, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp65 = einsum(tmp20, (0, 1, 2, 3), v.ovvv, (2, 4, 5, 3), (1, 0, 4, 5))
    tmp62 = einsum(v.ooov, (0, 1, 2, 3), tmp20, (4, 1, 2, 5), (4, 0, 5, 3))
    tmp70 = einsum(tmp69, (0, 1, 2, 3), tmp67, (0, 4, 3, 5), (4, 1, 5, 2))
    del tmp69, tmp67
    tmp74 = einsum(tmp73, (0, 1, 2, 3), v.ovoo, (4, 5, 1, 2), (4, 0, 5, 3))
    del tmp73
    tmp64 = einsum(l2, (0, 1, 2, 3), tmp63, (4, 1), (2, 3, 0, 4))
    del tmp63
    tmp66 = einsum(tmp20, (0, 1, 2, 3), tmp5, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp76 = einsum(tmp75, (0, 1, 2, 3), tmp20, (4, 0, 1, 5), (4, 2, 5, 3))
    del tmp75
    tmp81 = einsum(l2, (0, 1, 2, 3), tmp80, (2, 4), (3, 4, 0, 1))
    del tmp80
    tmp72 = einsum(l2, (0, 1, 2, 3), tmp71, (3, 4, 1, 5), (2, 4, 0, 5))
    del tmp71
    tmp82 = einsum(tmp78, (0, 1), tmp20, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp59 = v.ooov.copy() * -0.5
    tmp59 += v.ovoo.transpose((0, 2, 3, 1))
    tmp19 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp19 += t2 * -1
    tmp60 = f.ov.copy()
    tmp60 += tmp11
    tmp25 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp25 += l2.transpose((2, 3, 0, 1)) * 2
    tmp14 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp14 += t2
    tmp9 = tmp1.copy()
    del tmp1
    tmp9 += tmp3
    del tmp3
    tmp9 += tmp8.transpose((1, 0, 2, 3)) * -1
    del tmp8
    tmp12 = einsum(t2, (0, 1, 2, 3), tmp11, (4, 2), (0, 1, 4, 3)) * 0.5
    del tmp11
    tmp17 = v.oooo.transpose((0, 2, 1, 3)).copy() * -1
    tmp17 += v.oooo * 2
    tmp17 += tmp16.transpose((2, 1, 0, 3)) * 2
    tmp17 += tmp16.transpose((3, 2, 0, 1)) * -1
    tmp13 = v.ooov.copy()
    tmp13 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp13 += tmp5 * -0.5
    tmp13 += tmp5.transpose((0, 2, 1, 3))
    tmp0 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp15 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp15 += v.oovv * -1
    tmp32 = tmp20.copy() * 2
    tmp32 += tmp20.transpose((1, 0, 2, 3)) * -1
    tmp49 = tmp48.copy() * 0.5
    tmp49 += einsum(l2, (0, 1, 2, 3), tmp38, (2, 4, 1, 0), (3, 4))
    tmp47 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp47 += t2 * 2
    tmp29 = v.ovov.transpose((0, 2, 1, 3)).copy() * -1
    tmp29 += v.oovv * 2
    tmp27 = v.ooov.copy() * -1
    tmp27 += v.ooov.transpose((0, 2, 1, 3)) * 2
    tmp27 += tmp5 * 2
    tmp27 += tmp5.transpose((0, 2, 1, 3)) * -1
    tmp30 = tmp16.transpose((0, 2, 1, 3)).copy() * -1
    tmp30 += tmp16.transpose((0, 3, 2, 1)) * 2
    del tmp16
    tmp28 = v.ooov.copy() * 2
    tmp28 += v.ooov.transpose((0, 2, 1, 3)) * -1
    tmp28 += tmp5 * -1
    tmp28 += tmp5.transpose((0, 2, 1, 3)) * 2
    del tmp5
    tmp37 = tmp20.copy() * -1
    tmp37 += tmp20.transpose((1, 0, 2, 3)) * 2
    tmp34 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp36 = einsum(t1, (0, 1), tmp35, (0, 2, 3, 4), (2, 4, 3, 1))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp21 = tmp20.copy()
    tmp21 += tmp20.transpose((1, 0, 2, 3)) * -0.5
    tmp56 = v.ovvv.copy() * -0.5
    tmp56 += v.ovvv.transpose((0, 2, 1, 3))
    tmp52 = einsum(l2, (0, 1, 2, 3), tmp38, (2, 4, 1, 0), (3, 4)) * 2
    tmp99 = einsum(tmp98, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp98
    l2new += tmp99.transpose((3, 2, 1, 0)) * -1
    l2new += tmp99.transpose((2, 3, 0, 1)) * -1
    del tmp99
    tmp97 = tmp94.copy()
    del tmp94
    tmp97 += tmp95
    del tmp95
    tmp97 += tmp96
    del tmp96
    l2new += tmp97.transpose((2, 3, 1, 0)) * -1
    l2new += tmp97.transpose((3, 2, 0, 1)) * -1
    del tmp97
    tmp103 = tmp100.copy()
    del tmp100
    tmp103 += tmp102 * 2
    del tmp102
    l2new += tmp103.transpose((3, 2, 1, 0)) * -1
    l2new += tmp103.transpose((2, 3, 0, 1)) * -1
    del tmp103
    tmp93 = tmp84.copy()
    del tmp84
    tmp93 += tmp85
    del tmp85
    tmp93 += tmp87 * -1
    del tmp87
    tmp93 += tmp88 * -1
    del tmp88
    tmp93 += tmp89
    del tmp89
    tmp93 += tmp90
    del tmp90
    tmp93 += tmp91
    del tmp91
    tmp93 += tmp92 * -1
    del tmp92
    l2new += tmp93.transpose((2, 3, 1, 0))
    l2new += tmp93.transpose((3, 2, 0, 1))
    del tmp93
    tmp83 = einsum(f.ov, (0, 1), l1, (2, 3), (0, 3, 1, 2))
    tmp83 += tmp62
    del tmp62
    tmp83 += tmp64 * 2
    del tmp64
    tmp83 += tmp65 * -1
    del tmp65
    tmp83 += tmp66
    del tmp66
    tmp83 += tmp70
    del tmp70
    tmp83 += tmp72 * -1
    del tmp72
    tmp83 += tmp74.transpose((1, 0, 3, 2)) * -1
    del tmp74
    tmp83 += tmp76 * -1
    del tmp76
    tmp83 += tmp81.transpose((0, 1, 3, 2))
    del tmp81
    tmp83 += tmp82 * -1
    del tmp82
    tmp83 += einsum(l1, (0, 1), tmp78, (2, 3), (1, 2, 0, 3))
    del tmp78
    l2new += tmp83.transpose((3, 2, 1, 0))
    l2new += tmp83.transpose((2, 3, 0, 1))
    del tmp83
    tmp61 = f.oo.copy()
    tmp61 += einsum(v.ovov, (0, 1, 2, 3), tmp19, (2, 4, 1, 3), (4, 0))
    tmp61 += einsum(tmp59, (0, 1, 2, 3), t1, (0, 3), (1, 2)) * 2
    del tmp59
    tmp61 += einsum(t1, (0, 1), tmp60, (2, 1), (0, 2))
    del tmp60
    l1new = einsum(l1, (0, 1), tmp61, (1, 2), (0, 2)) * -1
    del tmp61
    tmp55 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp55 += v.oovv * -1
    l1new += einsum(tmp55, (0, 1, 2, 3), l1, (2, 0), (3, 1))
    del tmp55
    tmp26 = l2.transpose((2, 3, 0, 1)).copy()
    tmp26 += einsum(tmp14, (0, 1, 2, 3), tmp25, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp25
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp26, (4, 0, 3, 1), (2, 4)) * 2
    del tmp26
    tmp24 = v.vvvv.transpose((0, 2, 3, 1)).copy() * 2
    tmp24 += v.vvvv * -1
    tmp18 = v.ooov.transpose((0, 2, 1, 3)).copy() * -1
    tmp18 += v.ovoo.transpose((0, 2, 3, 1)) * 0.5
    tmp18 += tmp0.transpose((1, 2, 0, 3)) * 0.5
    tmp18 += tmp0.transpose((2, 1, 0, 3)) * -1
    del tmp0
    tmp18 += tmp9 * -1
    tmp18 += tmp9.transpose((1, 0, 2, 3)) * 0.5
    del tmp9
    tmp18 += tmp12.transpose((1, 0, 2, 3))
    tmp18 += tmp12 * -2
    del tmp12
    tmp18 += einsum(tmp14, (0, 1, 2, 3), tmp13, (4, 5, 0, 2), (4, 1, 5, 3)) * -2
    del tmp13
    tmp18 += einsum(t1, (0, 1), tmp15, (2, 3, 1, 4), (0, 3, 2, 4)) * -0.5
    del tmp15
    tmp18 += einsum(t1, (0, 1), tmp17, (0, 2, 3, 4), (3, 2, 4, 1)) * 0.5
    del tmp17
    l1new += einsum(tmp18, (0, 1, 2, 3), l2, (4, 3, 0, 1), (4, 2)) * 2
    del tmp18
    tmp33 = l2.transpose((3, 2, 0, 1)).copy()
    tmp33 += einsum(t1, (0, 1), tmp32, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp32
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp33, (4, 0, 3, 1), (2, 4)) * -1
    del tmp33
    tmp46 = v.ovvv.copy() * 2
    tmp46 += v.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp45 = einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 0.5
    tmp45 += einsum(tmp38, (0, 1, 2, 3), l2, (4, 3, 1, 0), (4, 2))
    l1new += einsum(tmp45, (0, 1), tmp46, (2, 3, 1, 0), (3, 2)) * 2
    del tmp45, tmp46
    tmp50 = t1.copy() * -1
    tmp50 += einsum(tmp38, (0, 1, 2, 3), tmp20, (0, 1, 4, 3), (4, 2)) * 2
    tmp50 += einsum(tmp47, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * -1
    del tmp47
    tmp50 += einsum(tmp49, (0, 1), t1, (0, 2), (1, 2)) * 2
    del tmp49
    l1new += einsum(tmp51, (0, 1, 2, 3), tmp50, (0, 2), (3, 1)) * -1
    del tmp51, tmp50
    tmp31 = einsum(t2, (0, 1, 2, 3), tmp27, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp27
    tmp31 += einsum(t2, (0, 1, 2, 3), tmp28, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp28
    tmp31 += einsum(t1, (0, 1), tmp29, (2, 3, 1, 4), (0, 3, 2, 4)) * -1
    del tmp29
    tmp31 += einsum(t1, (0, 1), tmp30, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp30
    l1new += einsum(l2, (0, 1, 2, 3), tmp31, (3, 2, 4, 1), (0, 4))
    del tmp31
    tmp39 = tmp34.copy() * -0.5
    tmp39 += tmp34.transpose((0, 2, 1, 3))
    del tmp34
    tmp39 += tmp20.transpose((0, 2, 1, 3)) * -0.5
    tmp39 += tmp20.transpose((1, 2, 0, 3))
    tmp39 += tmp36 * -1
    tmp39 += tmp36.transpose((0, 2, 1, 3)) * 0.5
    del tmp36
    tmp39 += einsum(tmp38, (0, 1, 2, 3), tmp37, (4, 0, 5, 3), (4, 5, 1, 2))
    del tmp38
    l1new += einsum(tmp39, (0, 1, 2, 3), v.ovov, (2, 3, 1, 4), (4, 0)) * -2
    del tmp39
    tmp44 = tmp40.transpose((1, 0, 2, 3)).copy() * -1
    tmp44 += tmp40.transpose((1, 0, 3, 2)) * 2
    del tmp40
    tmp44 += tmp35.transpose((2, 1, 0, 3)) * 2
    tmp44 += tmp35.transpose((3, 1, 0, 2)) * -1
    del tmp35
    l1new += einsum(tmp44, (0, 1, 2, 3), v.ooov, (2, 0, 3, 4), (4, 1))
    del tmp44
    tmp23 = einsum(l2, (0, 1, 2, 3), t1, (3, 4), (2, 0, 1, 4))
    l1new += einsum(tmp23, (0, 1, 2, 3), tmp24, (2, 4, 1, 3), (4, 0))
    del tmp23, tmp24
    tmp58 = f.ov.copy() * 0.5
    tmp58 += einsum(t1, (0, 1), tmp10, (0, 2, 1, 3), (2, 3))
    del tmp10
    tmp42 = tmp41.copy() * -1
    tmp42 += tmp41.transpose((0, 2, 1, 3)) * 2
    del tmp41
    tmp42 += einsum(tmp37, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5))
    del tmp37
    tmp42 += einsum(t2, (0, 1, 2, 3), tmp21, (4, 1, 5, 2), (4, 5, 0, 3)) * 2
    l1new += einsum(tmp42, (0, 1, 2, 3), v.ovov, (2, 4, 1, 3), (4, 0))
    del tmp42
    tmp54 = v.ooov.copy() * -1
    tmp54 += v.ooov.transpose((0, 2, 1, 3)) * 2
    tmp57 = f.vv.copy()
    tmp57 += einsum(t1, (0, 1), tmp56, (0, 2, 1, 3), (3, 2)) * 2
    del tmp56
    l1new += einsum(tmp57, (0, 1), l1, (0, 2), (1, 2))
    del tmp57
    tmp53 = tmp48.copy()
    del tmp48
    tmp53 += tmp52
    del tmp52
    l1new += einsum(tmp53, (0, 1), tmp58, (1, 2), (2, 0)) * -2
    del tmp58
    l1new += einsum(tmp54, (0, 1, 2, 3), tmp53, (0, 2), (3, 1)) * -1
    del tmp53, tmp54
    tmp43 = tmp20.copy() * -1
    tmp43 += tmp20.transpose((1, 0, 2, 3)) * 2
    del tmp20
    l1new += einsum(tmp43, (0, 1, 2, 3), v.oovv, (0, 2, 4, 3), (4, 1)) * -1
    del tmp43
    tmp22 = einsum(l2, (0, 1, 2, 3), tmp19, (2, 4, 1, 5), (3, 4, 0, 5))
    del tmp19
    tmp22 += einsum(l2, (0, 1, 2, 3), tmp14, (3, 4, 1, 5), (2, 4, 0, 5)) * 2
    del tmp14
    tmp22 += einsum(t1, (0, 1), tmp21, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp21
    l1new += einsum(tmp22, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp22
    l1new += f.ov.transpose((1, 0))
    l2new += einsum(v.oooo, (0, 1, 2, 3), l2, (4, 5, 1, 3), (4, 5, 0, 2))
    l2new += v.ovov.transpose((1, 3, 0, 2))
    l2new += einsum(l2, (0, 1, 2, 3), v.vvvv, (4, 1, 5, 0), (4, 5, 3, 2))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:57:05.203623.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp0 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    rdm1.oo = tmp0.transpose((1, 0)).copy() * -2
    tmp1 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp1 += t2
    rdm1.oo += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (4, 3)) * -4
    tmp2 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp6 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp6 += l2.transpose((2, 3, 0, 1)) * -1
    rdm1.vv = einsum(t2, (0, 1, 2, 3), tmp6, (0, 1, 4, 2), (4, 3)) * 2
    del tmp6
    tmp5 = tmp0.copy() * 0.5
    del tmp0
    tmp5 += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (3, 4))
    del tmp1
    rdm1.ov = einsum(t1, (0, 1), tmp5, (0, 2), (2, 1)) * -4
    del tmp5
    tmp3 = tmp2.copy() * -0.5
    tmp3 += tmp2.transpose((1, 0, 2, 3))
    del tmp2
    rdm1.ov += einsum(t2, (0, 1, 2, 3), tmp3, (1, 0, 4, 2), (4, 3)) * -4
    del tmp3
    tmp4 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp4 += t2 * 2
    rdm1.ov += einsum(tmp4, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * 2
    del tmp4
    rdm1.oo += delta.oo * 2
    del delta
    rdm1.ov += t1 * 2
    rdm1.vo = l1.copy() * 2
    rdm1.vv += einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 2
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:58:19.555134.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp2 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    rdm2.vooo = tmp2.transpose((3, 2, 1, 0)).copy()
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp2.transpose((3, 2, 1, 0))
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.ovoo = tmp2.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 0, 1))
    rdm2.ovoo += tmp2.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 0, 1))
    tmp98 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp98 += t2
    tmp13 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp13 += t2 * 2
    tmp20 = tmp2.copy() * -1
    tmp20 += tmp2.transpose((1, 0, 2, 3)) * 2
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp5 += t2
    tmp18 = tmp2.copy() * -1
    tmp18 += tmp2.transpose((1, 0, 2, 3))
    tmp62 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp62 += l2.transpose((2, 3, 0, 1)) * -1
    tmp99 = einsum(l2, (0, 1, 2, 3), tmp98, (2, 4, 1, 5), (4, 3, 5, 0))
    del tmp98
    tmp97 = einsum(l2, (0, 1, 2, 3), tmp13, (3, 4, 1, 5), (4, 2, 5, 0))
    tmp93 = einsum(t1, (0, 1), tmp2, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.voov = tmp93.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.voov += tmp93.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo = tmp93.transpose((1, 2, 3, 0)).copy() * -1
    rdm2.ovvo += tmp93.transpose((1, 2, 3, 0)) * -1
    tmp45 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp45 += l2.transpose((2, 3, 0, 1)) * 2
    tmp107 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp107 += l2.transpose((2, 3, 0, 1)) * 2
    tmp25 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    rdm2.oovo = tmp25.transpose((2, 1, 3, 0)).copy()
    rdm2.oovo += tmp25.transpose((2, 1, 3, 0))
    rdm2.ooov = tmp25.transpose((1, 2, 0, 3)).copy()
    rdm2.ooov += tmp25.transpose((1, 2, 0, 3))
    tmp21 = einsum(tmp20, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5))
    del tmp20
    rdm2.ooov += tmp21.transpose((1, 2, 0, 3)) * -1
    rdm2.ooov += tmp21.transpose((1, 2, 0, 3)) * -1
    tmp6 = einsum(l2, (0, 1, 2, 3), tmp5, (2, 4, 0, 1), (3, 4)) * 2
    rdm2.oooo = einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    tmp8 = tmp2.copy() * 2
    tmp8 += tmp2.transpose((1, 0, 2, 3)) * -1
    tmp16 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    rdm2.oovo += tmp16.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp16.transpose((1, 2, 3, 0)) * -1
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    tmp26 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    tmp19 = einsum(t2, (0, 1, 2, 3), tmp18, (4, 1, 5, 2), (4, 5, 0, 3))
    tmp0 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (0, 3, 2, 1))
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (3, 0, 1, 2))
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (3, 0, 1, 2))
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (3, 0, 2, 1)) * -1
    tmp54 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp54 += l2.transpose((2, 3, 0, 1))
    tmp3 = einsum(t1, (0, 1), tmp2, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2.oooo += tmp3.transpose((3, 2, 1, 0))
    rdm2.oooo += tmp3.transpose((3, 2, 1, 0))
    tmp31 = einsum(l2, (0, 1, 2, 3), tmp5, (2, 4, 0, 1), (3, 4))
    del tmp5
    tmp1 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 1, 0), (3, 2, 4, 5))
    rdm2.oooo += tmp1.transpose((3, 2, 1, 0))
    rdm2.oooo += tmp1.transpose((3, 2, 1, 0))
    tmp117 = einsum(l2, (0, 1, 2, 3), t1, (3, 4), (2, 0, 1, 4))
    rdm2.vvvo = tmp117.transpose((2, 1, 3, 0)).copy()
    rdm2.vvvo += tmp117.transpose((1, 2, 3, 0)) * -1
    rdm2.vvvo += tmp117.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp117.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp117.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp117.transpose((1, 2, 3, 0)) * -1
    rdm2.vvov = tmp117.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.vvov += tmp117.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp117.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp117.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp117.transpose((2, 1, 0, 3)) * -1
    rdm2.vvov += tmp117.transpose((1, 2, 0, 3))
    tmp84 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp87 = einsum(t2, (0, 1, 2, 3), tmp62, (0, 1, 3, 4), (4, 2))
    tmp111 = tmp93.copy()
    tmp111 += tmp99.transpose((1, 0, 3, 2))
    tmp111 += tmp97.transpose((1, 0, 3, 2)) * -1
    tmp52 = einsum(t2, (0, 1, 2, 3), tmp45, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp67 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 5, 1), (5, 0, 4, 3))
    rdm2.voov += tmp67.transpose((2, 1, 0, 3)) * -1
    rdm2.voov += tmp67.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo += tmp67.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp67.transpose((1, 2, 3, 0)) * -1
    tmp100 = tmp97.transpose((1, 0, 3, 2)).copy()
    del tmp97
    tmp100 += tmp99.transpose((1, 0, 3, 2)) * -1
    del tmp99
    tmp108 = einsum(t2, (0, 1, 2, 3), tmp107, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp107
    tmp59 = t2.copy()
    tmp59 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp71 = tmp25.copy()
    del tmp25
    tmp71 += tmp21 * -1
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp45
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (0, 1, 3, 4), (4, 2)) * 0.5
    del tmp62
    tmp10 = einsum(tmp6, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    tmp9 = einsum(tmp8, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4)) * 0.5
    tmp74 = tmp16.copy()
    tmp74 += tmp26 * -1
    del tmp26
    tmp48 = tmp16.copy()
    tmp48 += tmp19
    tmp48 += tmp21 * -1
    tmp14 = einsum(l1, (0, 1), tmp13, (1, 2, 0, 3), (2, 3))
    del tmp13
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp14, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp14, (2, 3), (2, 0, 3, 1))
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp14, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp14, (2, 3), (2, 0, 3, 1))
    tmp12 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    rdm2.oovv = einsum(t1, (0, 1), tmp12, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), tmp12, (2, 3), (0, 2, 1, 3)) * -1
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp17 = einsum(t1, (0, 1), tmp3, (0, 2, 3, 4), (2, 4, 3, 1))
    tmp29 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp29 += t2 * 2
    tmp32 = tmp0.copy() * 0.5
    tmp32 += tmp31
    del tmp31
    tmp4 = tmp1.transpose((1, 0, 3, 2)).copy()
    tmp4 += tmp3
    rdm2.oooo += tmp4.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp4.transpose((3, 2, 0, 1)) * -1
    rdm2.oooo += tmp4.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp4.transpose((3, 2, 0, 1)) * -1
    tmp119 = einsum(tmp117, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    del tmp117
    rdm2.vvvv = tmp119.transpose((1, 0, 3, 2)).copy()
    rdm2.vvvv += tmp119.transpose((1, 0, 3, 2))
    tmp118 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    rdm2.vvvv += tmp118.transpose((1, 0, 3, 2))
    rdm2.vvvv += tmp118.transpose((1, 0, 3, 2))
    tmp88 = tmp84.copy()
    tmp88 += tmp87
    del tmp87
    rdm2.vovv = einsum(tmp88, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovv += einsum(tmp88, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovo = einsum(tmp88, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.vovo += einsum(tmp88, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(tmp88, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.voov += einsum(tmp88, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovvo += einsum(tmp88, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvo += einsum(tmp88, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovov = einsum(tmp88, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovov += einsum(tmp88, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    tmp103 = einsum(t2, (0, 1, 2, 3), tmp2, (0, 1, 4, 5), (4, 5, 2, 3))
    rdm2.vovv += tmp103.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp103.transpose((1, 0, 2, 3)) * -1
    rdm2.ovvv = tmp103.transpose((0, 1, 3, 2)).copy() * -1
    rdm2.ovvv += tmp103.transpose((0, 1, 3, 2)) * -1
    tmp112 = einsum(tmp111, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp111
    tmp96 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    rdm2.vovv += tmp96.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp96.transpose((1, 0, 3, 2))
    rdm2.ovvv += tmp96
    rdm2.ovvv += tmp96
    tmp115 = tmp67.copy()
    tmp115 += tmp93
    tmp115 += tmp52 * -1
    tmp69 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 1, 5), (5, 0, 4, 3))
    rdm2.vovo += tmp69.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp69.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp69.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp69.transpose((1, 2, 0, 3)) * -1
    tmp101 = einsum(tmp100, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp100
    tmp109 = tmp67.copy()
    tmp109 += tmp93
    tmp109 += tmp108 * -1
    del tmp108
    tmp89 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp89 += l2.transpose((2, 3, 0, 1)) * -1
    tmp80 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp80 += t2 * -1
    tmp78 = t2.transpose((0, 1, 3, 2)).copy()
    tmp78 += t2 * -1
    tmp91 = l2.transpose((3, 2, 0, 1)).copy()
    tmp91 += l2.transpose((2, 3, 0, 1)) * -1
    tmp82 = tmp2.copy()
    tmp82 += tmp2.transpose((1, 0, 2, 3)) * -1
    tmp60 = einsum(tmp59, (0, 1, 2, 3), tmp1, (0, 1, 4, 5), (4, 5, 2, 3))
    del tmp59
    rdm2.oovv += tmp60.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp60.transpose((1, 0, 3, 2))
    tmp58 = einsum(t2, (0, 1, 2, 3), tmp3, (0, 1, 4, 5), (5, 4, 3, 2))
    del tmp3
    rdm2.oovv += tmp58
    rdm2.oovv += tmp58
    tmp72 = einsum(tmp71, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp71
    tmp47 = einsum(t2, (0, 1, 2, 3), tmp46, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp46
    tmp65 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 4), (2, 1, 4, 3))
    tmp64 = einsum(t2, (0, 1, 2, 3), tmp63, (2, 4), (0, 1, 4, 3)) * 2
    tmp11 = tmp9.copy()
    tmp11 += tmp10
    del tmp10
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (2, 0, 1, 3)) * 2
    tmp75 = einsum(t1, (0, 1), tmp74, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp74
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp0, (1, 4), (4, 0, 2, 3))
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp48
    tmp15 = tmp12.copy()
    tmp15 += tmp14 * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp15, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp15, (2, 3), (2, 0, 1, 3))
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp15, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp15, (2, 3), (2, 0, 1, 3))
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp55
    tmp51 = einsum(t1, (0, 1), tmp17, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.oovv += tmp51
    rdm2.oovv += tmp51
    tmp53 = einsum(t2, (0, 1, 2, 3), tmp52, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp52
    rdm2.oovv += tmp53 * 2
    rdm2.oovv += tmp53 * 2
    tmp39 = tmp2.copy() * 2
    tmp39 += tmp2.transpose((1, 0, 2, 3)) * -1
    tmp41 = einsum(tmp29, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * 0.5
    tmp42 = einsum(tmp32, (0, 1), t1, (0, 2), (1, 2))
    tmp33 = einsum(tmp32, (0, 1), t1, (0, 2), (1, 2)) * 2
    del tmp32
    tmp28 = einsum(tmp8, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4))
    del tmp8
    tmp27 = einsum(t1, (0, 1), tmp4, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp4
    rdm2.oovo += tmp27.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp27.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp27.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp27.transpose((2, 1, 0, 3))
    tmp30 = einsum(tmp29, (0, 1, 2, 3), l1, (2, 0), (1, 3))
    del tmp29
    tmp23 = einsum(tmp1, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp1
    tmp120 = tmp118.transpose((1, 0, 3, 2)).copy()
    del tmp118
    tmp120 += tmp119.transpose((1, 0, 3, 2))
    del tmp119
    rdm2.vvvv += tmp120
    rdm2.vvvv += tmp120.transpose((0, 1, 3, 2)) * -1
    rdm2.vvvv += tmp120
    rdm2.vvvv += tmp120.transpose((0, 1, 3, 2)) * -1
    del tmp120
    tmp114 = tmp103.copy()
    tmp114 += einsum(t1, (0, 1), tmp88, (2, 3), (0, 2, 1, 3))
    del tmp88
    rdm2.vovv += tmp114.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp114.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp114.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp114.transpose((1, 0, 2, 3)) * -1
    del tmp114
    tmp113 = tmp96.copy()
    tmp113 += tmp112.transpose((0, 1, 3, 2))
    del tmp112
    rdm2.vovv += tmp113.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp113.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp113.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp113.transpose((1, 0, 2, 3)) * -1
    del tmp113
    tmp116 = einsum(tmp115, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp115
    rdm2.vovv += tmp116.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp116.transpose((1, 0, 3, 2)) * -1
    del tmp116
    tmp106 = einsum(t1, (0, 1), tmp69, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.vovv += tmp106.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp106.transpose((1, 0, 3, 2)) * -1
    rdm2.ovvv += tmp106 * -1
    rdm2.ovvv += tmp106 * -1
    del tmp106
    tmp102 = tmp96.copy()
    del tmp96
    tmp102 += einsum(t1, (0, 1), tmp84, (2, 3), (0, 2, 1, 3))
    tmp102 += tmp101.transpose((0, 1, 3, 2)) * -1
    del tmp101
    rdm2.ovvv += tmp102.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp102
    rdm2.ovvv += tmp102.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp102
    del tmp102
    tmp105 = einsum(tmp93, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp93
    rdm2.ovvv += tmp105.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp105
    rdm2.ovvv += tmp105.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp105
    del tmp105
    tmp110 = einsum(tmp109, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp109
    rdm2.ovvv += tmp110 * -1
    rdm2.ovvv += tmp110 * -1
    del tmp110
    tmp104 = tmp103.copy()
    del tmp103
    tmp104 += einsum(t1, (0, 1), tmp63, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovvv += tmp104.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp104
    rdm2.ovvv += tmp104.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp104
    del tmp104
    tmp85 = tmp84.copy() * 0.5
    del tmp84
    tmp85 += tmp63
    del tmp63
    rdm2.ovvv += einsum(t1, (0, 1), tmp85, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovvv += einsum(t1, (0, 1), tmp85, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp85, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp85, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp85, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp85, (2, 3), (0, 2, 1, 3)) * 2
    del tmp85
    tmp94 = einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp18
    rdm2.vovo += tmp94.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp94.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp94.transpose((2, 1, 0, 3))
    rdm2.voov += tmp94.transpose((2, 1, 0, 3))
    del tmp94
    tmp86 = einsum(t1, (0, 1), tmp2, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp2
    rdm2.vovo += tmp86.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp86.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp86.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp86.transpose((1, 2, 0, 3)) * -1
    del tmp86
    tmp95 = einsum(tmp54, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp54
    rdm2.vovo += tmp95.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp95.transpose((2, 1, 3, 0)) * -1
    del tmp95
    tmp90 = einsum(t2, (0, 1, 2, 3), tmp89, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp89
    rdm2.vovo += tmp90.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp90.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp90.transpose((2, 1, 0, 3))
    rdm2.voov += tmp90.transpose((2, 1, 0, 3))
    rdm2.ovvo += tmp90.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp90.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp90.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp90.transpose((1, 2, 3, 0))
    del tmp90
    tmp81 = einsum(l2, (0, 1, 2, 3), tmp80, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp80
    rdm2.voov += tmp81.transpose((3, 0, 1, 2))
    rdm2.voov += tmp81.transpose((3, 0, 1, 2))
    rdm2.ovov += tmp81.transpose((0, 3, 1, 2)) * -1
    rdm2.ovov += tmp81.transpose((0, 3, 1, 2)) * -1
    del tmp81
    tmp79 = einsum(l2, (0, 1, 2, 3), tmp78, (2, 4, 5, 1), (4, 3, 5, 0))
    del tmp78
    rdm2.voov += tmp79.transpose((3, 0, 1, 2)) * -1
    rdm2.voov += tmp79.transpose((3, 0, 1, 2)) * -1
    rdm2.ovov += tmp79.transpose((0, 3, 1, 2))
    rdm2.ovov += tmp79.transpose((0, 3, 1, 2))
    del tmp79
    tmp92 = einsum(tmp91, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp91
    rdm2.ovvo += tmp92.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp92.transpose((1, 2, 3, 0)) * -1
    del tmp92
    tmp83 = einsum(t1, (0, 1), tmp82, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp82
    rdm2.ovvo += tmp83.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp83.transpose((1, 2, 3, 0)) * -1
    rdm2.ovov += tmp83.transpose((1, 2, 0, 3))
    rdm2.ovov += tmp83.transpose((1, 2, 0, 3))
    del tmp83
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2, (4, 0, 2, 5), (4, 1, 5, 3))
    del tmp69
    rdm2.oovv += tmp70.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp70.transpose((0, 1, 3, 2))
    del tmp70
    tmp61 = tmp58.copy()
    del tmp58
    tmp61 += tmp60.transpose((1, 0, 3, 2))
    del tmp60
    rdm2.oovv += tmp61.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp61
    rdm2.oovv += tmp61.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp61
    del tmp61
    tmp73 = tmp47.transpose((1, 0, 3, 2)).copy() * -1
    tmp73 += tmp72.transpose((0, 1, 3, 2))
    del tmp72
    tmp73 += einsum(t1, (0, 1), tmp14, (2, 3), (0, 2, 1, 3))
    del tmp14
    rdm2.oovv += tmp73.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp73
    rdm2.oovv += tmp73.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp73
    del tmp73
    tmp66 = tmp64.transpose((1, 0, 3, 2)).copy()
    del tmp64
    tmp66 += tmp65.transpose((0, 1, 3, 2))
    del tmp65
    tmp66 += einsum(t1, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * 2
    del tmp11
    rdm2.oovv += tmp66.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp66.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp66.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp66 * -1
    rdm2.oovv += tmp66.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp66 * -1
    rdm2.oovv += tmp66.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp66 * -1
    rdm2.oovv += tmp66.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp66.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp66.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp66 * -1
    del tmp66
    tmp76 = tmp44.copy()
    tmp76 += tmp75.transpose((0, 1, 3, 2))
    del tmp75
    rdm2.oovv += tmp76.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp76.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp76.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp76.transpose((0, 1, 3, 2)) * -1
    del tmp76
    tmp77 = t1.copy()
    tmp77 += tmp12 * -1
    del tmp12
    rdm2.oovv += einsum(t1, (0, 1), tmp77, (2, 3), (2, 0, 3, 1))
    rdm2.oovv += einsum(t1, (0, 1), tmp77, (2, 3), (2, 0, 3, 1))
    del tmp77
    tmp68 = einsum(tmp67, (0, 1, 2, 3), t2, (4, 0, 2, 5), (4, 1, 5, 3))
    del tmp67
    rdm2.oovv += tmp68
    rdm2.oovv += tmp68
    del tmp68
    tmp50 = tmp44.copy()
    del tmp44
    tmp50 += tmp47.transpose((1, 0, 3, 2)) * -1
    del tmp47
    tmp50 += tmp49.transpose((0, 1, 3, 2))
    del tmp49
    tmp50 += einsum(t1, (0, 1), tmp15, (2, 3), (0, 2, 1, 3)) * -1
    del tmp15
    rdm2.oovv += tmp50.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp50.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp50.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp50
    rdm2.oovv += tmp50.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp50.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp50.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp50
    del tmp50
    tmp57 = tmp51.copy()
    del tmp51
    tmp57 += tmp53.transpose((1, 0, 3, 2)) * 2
    del tmp53
    tmp57 += tmp56
    del tmp56
    rdm2.oovv += tmp57.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp57
    rdm2.oovv += tmp57.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp57
    del tmp57
    tmp35 = tmp0.copy()
    tmp35 += tmp6
    rdm2.oovo += einsum(t1, (0, 1), tmp35, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oovo += einsum(t1, (0, 1), tmp35, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp35, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp35, (2, 3), (3, 0, 2, 1)) * -1
    del tmp35
    tmp37 = einsum(tmp0, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp37 += tmp19
    tmp37 += tmp21 * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    del tmp37
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 2, 4, 5))
    del tmp39
    rdm2.oovo += tmp40.transpose((2, 1, 3, 0)) * -1
    rdm2.oovo += tmp40.transpose((2, 1, 3, 0)) * -1
    del tmp40
    tmp43 = t1.copy() * -0.5
    tmp43 += tmp9
    del tmp9
    tmp43 += tmp41 * -1
    del tmp41
    tmp43 += tmp42
    del tmp42
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp43, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp43, (2, 3), (2, 0, 3, 1)) * -2
    del tmp43
    tmp36 = tmp28.copy()
    tmp36 += tmp33
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp36, (2, 3), (0, 2, 3, 1))
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp36, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp36, (2, 3), (0, 2, 3, 1))
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp36, (2, 3), (2, 0, 3, 1)) * -1
    del tmp36
    tmp38 = tmp16.copy()
    tmp38 += tmp27.transpose((0, 2, 1, 3))
    del tmp27
    tmp38 += einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    rdm2.oovo += tmp38.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp38.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp38.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp38.transpose((1, 2, 3, 0)) * -1
    del tmp38
    tmp34 = t1.copy() * -1
    tmp34 += tmp28
    del tmp28
    tmp34 += tmp30 * -1
    del tmp30
    tmp34 += tmp33
    del tmp33
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp34, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp34, (2, 3), (0, 2, 1, 3)) * -1
    del tmp34
    tmp24 = tmp23.copy()
    del tmp23
    tmp24 += einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    del tmp6
    rdm2.ooov += tmp24.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp24.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp24.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp24.transpose((1, 2, 0, 3))
    del tmp24
    tmp22 = tmp16.copy()
    del tmp16
    tmp22 += tmp17
    del tmp17
    tmp22 += tmp19
    del tmp19
    tmp22 += tmp21 * -1
    del tmp21
    rdm2.ooov += tmp22.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp22.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp22.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp22.transpose((1, 2, 0, 3))
    del tmp22
    tmp7 = delta.oo.copy()
    tmp7 += tmp0 * -1
    del tmp0
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp7, (2, 3), (3, 0, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp7, (2, 3), (3, 0, 2, 1))
    del tmp7
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    del delta
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovv += t2
    rdm2.oovv += t2
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovov += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vovo += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vovo += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vvoo = l2.transpose((0, 1, 3, 2)).copy() * -1
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2.transpose((0, 1, 3, 2)) * -1
    rdm2.vvoo += l2
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = rdm2.swapaxes(1, 2)

    return rdm2

