"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:31:02.024459
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:31:02.743836.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp0 += v.ovov.transpose((0, 2, 1, 3))
    tmp1 = f.ov.copy()
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp0
    e_cc = einsum(t1, (0, 1), tmp1, (0, 1), ()) * 2
    del tmp1
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:31:19.783923.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp4 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp4 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp23 = tmp2.copy() * -1
    tmp23 += tmp2.transpose((0, 2, 1, 3)) * 2
    tmp39 = einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp39 += t2.transpose((0, 1, 3, 2)) * -2
    tmp39 += t2
    tmp5 = einsum(t1, (0, 1), tmp4, (0, 2, 1, 3), (2, 3))
    tmp58 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp58 += v.ovov.transpose((0, 2, 1, 3))
    tmp61 = v.ovov.transpose((0, 2, 3, 1)).copy()
    tmp61 += v.ovov.transpose((0, 2, 1, 3)) * -0.5
    tmp9 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp16 = einsum(t2, (0, 1, 2, 3), tmp4, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp4
    tmp15 = einsum(tmp2, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp27 = v.ooov.copy() * 2
    tmp27 += v.ooov.transpose((0, 2, 1, 3)) * -1
    tmp19 = v.ovvv.copy() * -1
    tmp19 += v.ovvv.transpose((0, 2, 1, 3)) * 2
    tmp24 = einsum(tmp23, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp23
    tmp22 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp36 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp37 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp38 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    tmp40 = einsum(v.ooov, (0, 1, 2, 3), tmp39, (2, 4, 5, 3), (4, 0, 1, 5))
    del tmp39
    tmp41 = einsum(tmp5, (0, 1), t2, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp56 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp59 = einsum(t2, (0, 1, 2, 3), tmp58, (0, 1, 4, 3), (4, 2))
    del tmp58
    tmp62 = einsum(t2, (0, 1, 2, 3), tmp61, (1, 4, 2, 3), (4, 0)) * 2
    del tmp61
    tmp67 = einsum(t1, (0, 1), tmp2, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp66 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp49 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp51 = f.oo.copy()
    tmp51 += tmp9
    tmp17 = tmp15.copy()
    del tmp15
    tmp17 += tmp16.transpose((1, 0, 3, 2)) * -1
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    del tmp27
    tmp20 = einsum(t1, (0, 1), tmp19, (0, 2, 1, 3), (2, 3))
    del tmp19
    tmp25 = tmp2.copy()
    tmp25 += tmp22 * -1
    del tmp22
    tmp25 += tmp24.transpose((0, 2, 1, 3))
    del tmp24
    tmp33 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp44 = einsum(t1, (0, 1), tmp5, (2, 1), (2, 0))
    tmp42 = tmp36.transpose((0, 2, 1, 3)).copy() * -1
    del tmp36
    tmp42 += tmp37.transpose((0, 2, 1, 3))
    del tmp37
    tmp42 += tmp38.transpose((0, 2, 1, 3))
    del tmp38
    tmp42 += tmp40.transpose((0, 2, 1, 3))
    del tmp40
    tmp42 += tmp41.transpose((2, 0, 1, 3)) * -1
    del tmp41
    tmp7 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp7 += t2 * 2
    tmp32 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp57 = einsum(tmp56, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp56
    tmp60 = einsum(t2, (0, 1, 2, 3), tmp59, (2, 4), (0, 1, 4, 3)) * 2
    del tmp59
    tmp63 = einsum(tmp62, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp62
    tmp69 = v.oooo.copy()
    tmp69 += tmp66.transpose((3, 1, 0, 2))
    tmp69 += tmp67.transpose((3, 1, 0, 2))
    tmp14 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    t2new = tmp14.copy() * -1
    tmp50 = einsum(tmp49, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp49
    tmp52 = einsum(tmp51, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp51
    tmp18 = einsum(t2, (0, 1, 2, 3), tmp17, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp17
    tmp29 = einsum(tmp28, (0, 1), t2, (2, 1, 3, 4), (0, 2, 4, 3))
    del tmp28
    tmp21 = einsum(t2, (0, 1, 2, 3), tmp20, (2, 4), (0, 1, 4, 3))
    del tmp20
    tmp26 = einsum(t1, (0, 1), tmp25, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp25
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp45 = einsum(tmp44, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp44
    tmp43 = einsum(t1, (0, 1), tmp42, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp42
    tmp31 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp35 = einsum(tmp32, (0, 1, 2, 3), tmp7, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp54 = t2.copy()
    tmp54 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp47 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp11 = v.ooov.copy()
    tmp11 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp10 = v.ovov.transpose((0, 2, 3, 1)).copy() * 2
    tmp10 += v.ovov.transpose((0, 2, 1, 3)) * -1
    tmp0 = t2.copy()
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp64 = tmp57.copy()
    del tmp57
    tmp64 += tmp60.transpose((1, 0, 3, 2))
    del tmp60
    tmp64 += tmp63.transpose((1, 0, 3, 2))
    del tmp63
    t2new += tmp64.transpose((1, 0, 3, 2)) * -1
    t2new += tmp64 * -1
    del tmp64
    tmp70 = v.ooov.transpose((0, 2, 1, 3)).copy() * -1
    tmp70 += einsum(tmp69, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    del tmp69
    t2new += einsum(t1, (0, 1), tmp70, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp70
    tmp72 = v.ovov.transpose((0, 2, 1, 3)).copy() * -1
    tmp72 += tmp14
    del tmp14
    t2new += einsum(t2, (0, 1, 2, 3), tmp72, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp72
    tmp53 = tmp50.copy()
    del tmp50
    tmp53 += tmp52.transpose((0, 1, 3, 2))
    del tmp52
    t2new += tmp53.transpose((1, 0, 2, 3)) * -1
    t2new += tmp53.transpose((0, 1, 3, 2)) * -1
    del tmp53
    tmp68 = v.oooo.copy()
    tmp68 += tmp66.transpose((3, 1, 2, 0))
    del tmp66
    tmp68 += tmp67.transpose((3, 1, 2, 0))
    del tmp67
    t2new += einsum(t2, (0, 1, 2, 3), tmp68, (0, 4, 1, 5), (4, 5, 2, 3))
    del tmp68
    tmp13 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    t2new += einsum(t1, (0, 1), tmp13, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp13
    tmp30 = tmp18.copy()
    del tmp18
    tmp30 += tmp21.transpose((1, 0, 3, 2))
    del tmp21
    tmp30 += tmp26.transpose((0, 1, 3, 2)) * -1
    del tmp26
    tmp30 += tmp29.transpose((1, 0, 3, 2)) * -1
    del tmp29
    t2new += tmp30.transpose((1, 0, 3, 2))
    t2new += tmp30
    del tmp30
    tmp65 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp65 += v.oovv * -1
    tmp65 += tmp16.transpose((1, 0, 3, 2)) * 2
    del tmp16
    t2new += einsum(tmp65, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp65
    tmp46 = tmp31.copy()
    del tmp31
    tmp46 += tmp32
    del tmp32
    tmp46 += tmp34 * -1
    del tmp34
    tmp46 += tmp35.transpose((1, 0, 2, 3))
    del tmp35
    tmp46 += tmp43.transpose((0, 1, 3, 2))
    del tmp43
    tmp46 += tmp45.transpose((0, 1, 3, 2)) * -1
    del tmp45
    t2new += tmp46.transpose((1, 0, 2, 3))
    t2new += tmp46.transpose((0, 1, 3, 2))
    del tmp46
    tmp71 = v.oovv.copy() * -1
    tmp71 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    t2new += einsum(t2, (0, 1, 2, 3), tmp71, (4, 1, 5, 2), (0, 4, 5, 3))
    del tmp71
    tmp55 = einsum(tmp54, (0, 1, 2, 3), tmp33, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp33, tmp54
    t2new += tmp55.transpose((0, 1, 3, 2)) * -1
    t2new += tmp55.transpose((1, 0, 2, 3)) * -1
    del tmp55
    tmp48 = einsum(t2, (0, 1, 2, 3), tmp47, (4, 5, 1, 0), (4, 5, 3, 2))
    del tmp47
    t2new += tmp48.transpose((1, 0, 2, 3))
    t2new += tmp48.transpose((0, 1, 3, 2))
    del tmp48
    tmp8 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp8 += v.oovv * -1
    t1new = einsum(tmp8, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp8
    tmp12 = f.oo.copy() * 0.5
    tmp12 += tmp9 * 0.5
    del tmp9
    tmp12 += einsum(tmp0, (0, 1, 2, 3), tmp10, (0, 4, 3, 2), (4, 1)) * 0.5
    del tmp10
    tmp12 += einsum(t1, (0, 1), tmp11, (2, 3, 0, 1), (3, 2))
    del tmp11
    t1new += einsum(tmp12, (0, 1), t1, (0, 2), (1, 2)) * -2
    del tmp12
    tmp3 = v.ooov.copy()
    tmp3 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp3 += tmp2 * -0.5
    tmp3 += tmp2.transpose((0, 2, 1, 3))
    del tmp2
    t1new += einsum(tmp3, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4)) * -2
    del tmp3
    tmp6 = f.ov.copy()
    tmp6 += tmp5
    del tmp5
    t1new += einsum(tmp6, (0, 1), tmp7, (0, 2, 1, 3), (2, 3))
    del tmp7, tmp6
    tmp1 = v.ovvv.copy() * -0.5
    tmp1 += v.ovvv.transpose((0, 2, 1, 3))
    t1new += einsum(tmp1, (0, 1, 2, 3), tmp0, (0, 4, 2, 1), (4, 3)) * 2
    del tmp0, tmp1
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += f.ov
    t2new += einsum(v.vvvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 2), (4, 0, 3, 5)) * -1
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 3), (4, 0, 5, 2)) * 2
    t2new += v.ovov.transpose((0, 2, 1, 3))
    t2new += einsum(t1, (0, 1), v.ovoo, (2, 3, 4, 0), (2, 4, 3, 1)) * -1

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:32:18.550763.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp53 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp53 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp83 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp83 += t2 * -1
    tmp93 = einsum(tmp53, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    tmp15 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp15 += t2 * -1
    tmp16 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp16 += t2
    tmp8 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp84 = einsum(tmp83, (0, 1, 2, 3), v.ovov, (4, 5, 0, 3), (4, 1, 5, 2))
    del tmp83
    tmp82 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp81 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp17 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp24 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp71 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp94 = einsum(tmp93, (0, 1), t1, (2, 1), (2, 0))
    tmp92 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp103 = einsum(tmp15, (0, 1, 2, 3), v.ovov, (4, 2, 0, 3), (4, 1)) * 0.5
    tmp102 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp38 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp38 += t2 * 2
    tmp49 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp59 = einsum(l2, (0, 1, 2, 3), tmp16, (2, 4, 0, 1), (3, 4)) * 2
    tmp5 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp5 += v.ovov.transpose((0, 2, 1, 3))
    tmp2 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    l2new = einsum(tmp2, (0, 1, 2, 3), l2, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp26 = einsum(t1, (0, 1), tmp8, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp85 = v.ovov.transpose((0, 2, 1, 3)).copy()
    tmp85 += tmp81.transpose((0, 1, 3, 2))
    del tmp81
    tmp85 += tmp82 * -1
    del tmp82
    tmp85 += tmp84.transpose((1, 0, 3, 2))
    del tmp84
    tmp80 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp80 += l2.transpose((2, 3, 0, 1)) * -1
    tmp90 = tmp8.copy() * 2
    tmp90 += tmp8.transpose((0, 2, 1, 3)) * -1
    tmp88 = tmp17.copy() * 2
    tmp88 += tmp17.transpose((1, 0, 2, 3)) * -1
    tmp72 = v.oovv.copy()
    tmp72 += tmp24.transpose((0, 1, 3, 2))
    tmp72 += tmp71 * -1
    del tmp71
    tmp76 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp95 = tmp92.copy()
    del tmp92
    tmp95 += tmp94 * -1
    del tmp94
    tmp12 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp65 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp104 = tmp102.transpose((1, 0)).copy()
    del tmp102
    tmp104 += tmp103.transpose((1, 0))
    del tmp103
    tmp100 = einsum(v.ovov, (0, 1, 2, 3), tmp38, (0, 2, 4, 3), (1, 4)) * 0.5
    tmp60 = tmp49.copy()
    tmp60 += tmp59
    del tmp59
    tmp46 = einsum(tmp16, (0, 1, 2, 3), l2, (4, 3, 0, 1), (4, 2)) * 2
    tmp6 = einsum(t1, (0, 1), tmp5, (0, 2, 1, 3), (2, 3)) * 2
    del tmp5
    tmp1 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp3 = einsum(t1, (0, 1), tmp2, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp2
    tmp36 = einsum(tmp17, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    l2new += einsum(tmp36, (0, 1, 2, 3), v.ovov, (3, 4, 2, 5), (4, 5, 1, 0))
    tmp41 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    l2new += einsum(tmp41, (0, 1, 2, 3), v.ovov, (3, 4, 2, 5), (5, 4, 0, 1))
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp25 = einsum(tmp24, (0, 1, 2, 3), t1, (4, 3), (0, 4, 1, 2))
    del tmp24
    tmp50 = einsum(l2, (0, 1, 2, 3), tmp16, (2, 4, 0, 1), (3, 4))
    tmp79 = einsum(tmp8, (0, 1, 2, 3), tmp17, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp86 = einsum(tmp85, (0, 1, 2, 3), tmp80, (0, 4, 5, 2), (4, 1, 5, 3))
    del tmp85, tmp80
    tmp91 = einsum(tmp90, (0, 1, 2, 3), tmp17, (4, 0, 2, 5), (4, 1, 5, 3))
    del tmp90
    tmp78 = einsum(v.ovvv, (0, 1, 2, 3), tmp17, (4, 5, 0, 3), (5, 4, 1, 2))
    tmp89 = einsum(tmp88, (0, 1, 2, 3), v.ovoo, (4, 5, 1, 2), (4, 0, 5, 3))
    del tmp88
    tmp87 = einsum(l2, (0, 1, 2, 3), tmp72, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp77 = einsum(tmp76, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp76
    tmp75 = einsum(tmp17, (0, 1, 2, 3), v.ooov, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp97 = einsum(tmp93, (0, 1), tmp17, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp96 = einsum(tmp95, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del tmp95
    tmp67 = einsum(f.ov, (0, 1), tmp17, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp64 = einsum(v.ovvv, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp70 = einsum(tmp8, (0, 1, 2, 3), tmp17, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp69 = einsum(v.ooov, (0, 1, 2, 3), tmp17, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp68 = einsum(l2, (0, 1, 2, 3), tmp12, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp73 = einsum(tmp72, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp72
    tmp66 = einsum(tmp65, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp65
    tmp63 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp112 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp105 = einsum(tmp104, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3)) * 2
    del tmp104
    tmp101 = einsum(l2, (0, 1, 2, 3), tmp100, (4, 1), (3, 2, 0, 4)) * 2
    del tmp100
    tmp99 = einsum(v.ooov, (0, 1, 2, 3), l1, (4, 1), (0, 2, 4, 3))
    tmp108 = einsum(l1, (0, 1), tmp8, (1, 2, 3, 4), (2, 3, 0, 4))
    tmp110 = einsum(tmp60, (0, 1), v.ovov, (2, 3, 1, 4), (2, 0, 4, 3))
    tmp109 = einsum(v.ovov, (0, 1, 2, 3), tmp46, (4, 1), (0, 2, 3, 4))
    tmp107 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    tmp11 = v.oovv.copy() * 2
    tmp11 += v.ovov.transpose((0, 2, 1, 3)) * -1
    tmp9 = v.ooov.copy() * 2
    tmp9 += v.ooov.transpose((0, 2, 1, 3)) * -1
    tmp9 += tmp8 * -1
    tmp9 += tmp8.transpose((0, 2, 1, 3)) * 2
    tmp7 = einsum(t2, (0, 1, 2, 3), tmp6, (4, 2), (0, 1, 4, 3)) * 2
    tmp10 = v.ooov.copy() * -0.5
    tmp10 += v.ooov.transpose((0, 2, 1, 3))
    tmp10 += tmp8
    tmp10 += tmp8.transpose((0, 2, 1, 3)) * -0.5
    tmp13 = v.oooo.transpose((0, 2, 3, 1)).copy() * -1
    tmp13 += v.oooo * 2
    tmp13 += tmp12.transpose((2, 0, 3, 1)) * -1
    tmp13 += tmp12.transpose((3, 0, 2, 1)) * 2
    tmp0 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp4 = tmp1.copy()
    del tmp1
    tmp4 += tmp3 * -1
    del tmp3
    tmp34 = tmp17.copy() * -1
    tmp34 += tmp17.transpose((1, 0, 2, 3)) * 2
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp40 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp18 = tmp17.copy()
    tmp18 += tmp17.transpose((1, 0, 2, 3)) * -0.5
    tmp42 = einsum(tmp41, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp58 = f.ov.copy()
    tmp58 += tmp6
    del tmp6
    l1new = einsum(tmp60, (0, 1), tmp58, (1, 2), (2, 0)) * -1
    del tmp60
    tmp61 = v.ooov.copy()
    tmp61 += v.ovoo.transpose((0, 2, 3, 1)) * -0.5
    tmp30 = t2.transpose((0, 1, 3, 2)).copy()
    tmp30 += t2 * -0.5
    tmp28 = tmp25.copy()
    del tmp25
    tmp28 += tmp27 * -1
    del tmp27
    tmp29 = v.ooov.copy()
    tmp29 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp29 += tmp8 * -0.5
    tmp29 += tmp8.transpose((0, 2, 1, 3))
    del tmp8
    tmp32 = tmp12.transpose((0, 2, 1, 3)).copy() * -1
    tmp32 += tmp12.transpose((0, 3, 2, 1)) * 2
    del tmp12
    tmp31 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp31 += v.oovv * -1
    tmp51 = tmp49.copy() * 0.5
    del tmp49
    tmp51 += tmp50
    del tmp50
    tmp22 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp22 += l2.transpose((2, 3, 0, 1)) * -1
    tmp56 = v.ovvv.copy() * -0.5
    tmp56 += v.ovvv.transpose((0, 2, 1, 3))
    tmp98 = einsum(l1, (0, 1), f.ov, (2, 3), (2, 1, 3, 0))
    tmp98 += tmp75
    del tmp75
    tmp98 += tmp77 * 2
    del tmp77
    tmp98 += tmp78 * -1
    del tmp78
    tmp98 += tmp79
    del tmp79
    tmp98 += tmp86
    del tmp86
    tmp98 += tmp87 * -1
    del tmp87
    tmp98 += tmp89.transpose((1, 0, 3, 2)) * -1
    del tmp89
    tmp98 += tmp91 * -1
    del tmp91
    tmp98 += tmp96.transpose((0, 1, 3, 2))
    del tmp96
    tmp98 += tmp97 * -1
    del tmp97
    tmp98 += einsum(tmp93, (0, 1), l1, (2, 3), (3, 0, 2, 1))
    del tmp93
    l2new += tmp98.transpose((3, 2, 1, 0))
    l2new += tmp98.transpose((2, 3, 0, 1))
    del tmp98
    tmp74 = tmp63.copy()
    del tmp63
    tmp74 += tmp64
    del tmp64
    tmp74 += tmp66 * -1
    del tmp66
    tmp74 += tmp67 * -1
    del tmp67
    tmp74 += tmp68
    del tmp68
    tmp74 += tmp69
    del tmp69
    tmp74 += tmp70
    del tmp70
    tmp74 += tmp73 * -1
    del tmp73
    l2new += tmp74.transpose((2, 3, 1, 0))
    l2new += tmp74.transpose((3, 2, 0, 1))
    del tmp74
    tmp113 = einsum(tmp112, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp112
    l2new += tmp113.transpose((3, 2, 1, 0)) * -1
    l2new += tmp113.transpose((2, 3, 0, 1)) * -1
    del tmp113
    tmp114 = v.oooo.copy()
    tmp114 += tmp26.transpose((0, 2, 3, 1))
    del tmp26
    l2new += einsum(l2, (0, 1, 2, 3), tmp114, (3, 4, 5, 2), (0, 1, 5, 4))
    del tmp114
    tmp106 = tmp99.copy()
    del tmp99
    tmp106 += tmp101.transpose((1, 0, 2, 3))
    del tmp101
    tmp106 += tmp105.transpose((0, 1, 3, 2))
    del tmp105
    l2new += tmp106.transpose((3, 2, 1, 0)) * -1
    l2new += tmp106.transpose((2, 3, 0, 1)) * -1
    del tmp106
    tmp111 = tmp107.copy()
    del tmp107
    tmp111 += tmp108
    del tmp108
    tmp111 += tmp109.transpose((1, 0, 3, 2))
    del tmp109
    tmp111 += tmp110.transpose((1, 0, 3, 2))
    del tmp110
    l2new += tmp111.transpose((2, 3, 1, 0)) * -1
    l2new += tmp111.transpose((3, 2, 0, 1)) * -1
    del tmp111
    tmp14 = v.ooov.transpose((0, 2, 1, 3)).copy()
    tmp14 += v.ovoo.transpose((0, 2, 3, 1)) * -2
    tmp14 += tmp0.transpose((1, 2, 0, 3)) * -2
    tmp14 += tmp0.transpose((2, 1, 0, 3))
    del tmp0
    tmp14 += tmp4
    tmp14 += tmp4.transpose((1, 0, 2, 3)) * -2
    del tmp4
    tmp14 += tmp7.transpose((1, 0, 2, 3)) * -1
    tmp14 += tmp7 * 0.5
    del tmp7
    tmp14 += einsum(t2, (0, 1, 2, 3), tmp9, (4, 5, 1, 3), (4, 0, 5, 2))
    del tmp9
    tmp14 += einsum(tmp10, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5)) * 2
    del tmp10
    tmp14 += einsum(tmp11, (0, 1, 2, 3), t1, (4, 2), (4, 1, 0, 3)) * -1
    del tmp11
    tmp14 += einsum(tmp13, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    del tmp13
    l1new += einsum(tmp14, (0, 1, 2, 3), l2, (4, 3, 1, 0), (4, 2))
    del tmp14
    tmp21 = v.vvvv.transpose((0, 2, 1, 3)).copy() * -1
    tmp21 += v.vvvv * 2
    tmp47 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp47 += tmp46
    del tmp46
    tmp39 = tmp17.transpose((0, 2, 1, 3)).copy() * 0.5
    tmp39 += tmp17.transpose((1, 2, 0, 3)) * -1
    tmp39 += tmp37
    tmp39 += tmp37.transpose((0, 2, 1, 3)) * -0.5
    del tmp37
    tmp39 += einsum(tmp34, (0, 1, 2, 3), tmp38, (1, 4, 3, 5), (0, 2, 4, 5)) * -0.5
    l1new += einsum(v.ovov, (0, 1, 2, 3), tmp39, (4, 2, 0, 1), (3, 4)) * 2
    del tmp39
    tmp43 = tmp40.copy() * -2
    tmp43 += tmp40.transpose((0, 2, 1, 3))
    del tmp40
    tmp43 += tmp42 * -1
    tmp43 += tmp42.transpose((0, 2, 1, 3)) * 2
    del tmp42
    tmp43 += einsum(tmp34, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5))
    tmp43 += einsum(t2, (0, 1, 2, 3), tmp18, (4, 1, 5, 2), (4, 5, 0, 3)) * 2
    l1new += einsum(v.ovov, (0, 1, 2, 3), tmp43, (4, 2, 0, 3), (1, 4))
    del tmp43
    tmp20 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    l1new += einsum(tmp20, (0, 1, 2, 3), tmp21, (2, 3, 4, 1), (4, 0))
    del tmp20, tmp21
    tmp62 = f.oo.copy()
    tmp62 += einsum(tmp15, (0, 1, 2, 3), v.ovov, (4, 2, 0, 3), (1, 4))
    tmp62 += einsum(tmp61, (0, 1, 2, 3), t1, (2, 3), (1, 0)) * 2
    del tmp61
    tmp62 += einsum(t1, (0, 1), tmp58, (2, 1), (0, 2))
    del tmp58
    l1new += einsum(tmp62, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp62
    tmp19 = einsum(tmp15, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp15
    tmp19 += einsum(tmp16, (0, 1, 2, 3), l2, (4, 2, 5, 0), (5, 1, 4, 3)) * 2
    tmp19 += einsum(tmp18, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3)) * 2
    del tmp18
    l1new += einsum(tmp19, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp19
    tmp45 = tmp41.transpose((1, 0, 2, 3)).copy() * -0.5
    tmp45 += tmp41.transpose((1, 0, 3, 2))
    del tmp41
    tmp45 += tmp36.transpose((2, 1, 0, 3))
    tmp45 += tmp36.transpose((3, 1, 0, 2)) * -0.5
    del tmp36
    l1new += einsum(v.ooov, (0, 1, 2, 3), tmp45, (1, 4, 0, 2), (3, 4)) * 2
    del tmp45
    tmp55 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp55 += v.oovv * -1
    l1new += einsum(tmp55, (0, 1, 2, 3), l1, (2, 0), (3, 1))
    del tmp55
    tmp33 = tmp28.copy() * -1
    tmp33 += tmp28.transpose((1, 0, 2, 3)) * 0.5
    del tmp28
    tmp33 += einsum(tmp29, (0, 1, 2, 3), tmp30, (2, 4, 5, 3), (0, 4, 1, 5)) * -2
    del tmp29, tmp30
    tmp33 += einsum(t1, (0, 1), tmp31, (2, 3, 1, 4), (0, 3, 2, 4)) * -0.5
    del tmp31
    tmp33 += einsum(tmp32, (0, 1, 2, 3), t1, (3, 4), (0, 2, 1, 4)) * 0.5
    del tmp32
    l1new += einsum(tmp33, (0, 1, 2, 3), l2, (4, 3, 0, 1), (4, 2)) * 2
    del tmp33
    tmp35 = l2.transpose((3, 2, 0, 1)).copy()
    tmp35 += einsum(t1, (0, 1), tmp34, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp34
    l1new += einsum(tmp35, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (4, 0)) * -1
    del tmp35
    tmp52 = t1.copy() * -0.5
    tmp52 += einsum(tmp17, (0, 1, 2, 3), tmp16, (1, 0, 4, 3), (2, 4))
    tmp52 += einsum(tmp38, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * -0.5
    del tmp38
    tmp52 += einsum(tmp51, (0, 1), t1, (0, 2), (1, 2))
    l1new += einsum(tmp53, (0, 1, 2, 3), tmp52, (0, 2), (3, 1)) * -2
    del tmp53, tmp52
    tmp54 = v.ooov.copy() * -0.5
    tmp54 += v.ooov.transpose((0, 2, 1, 3))
    l1new += einsum(tmp51, (0, 1), tmp54, (0, 2, 1, 3), (3, 2)) * -4
    del tmp51, tmp54
    tmp23 = l2.transpose((2, 3, 0, 1)).copy()
    tmp23 += einsum(tmp22, (0, 1, 2, 3), tmp16, (0, 4, 3, 5), (1, 4, 2, 5))
    del tmp16, tmp22
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp23, (4, 0, 3, 1), (2, 4)) * 2
    del tmp23
    tmp48 = v.ovvv.copy() * 2
    tmp48 += v.ovvv.transpose((0, 2, 1, 3)) * -1
    l1new += einsum(tmp47, (0, 1), tmp48, (2, 3, 1, 0), (3, 2))
    del tmp47, tmp48
    tmp44 = tmp17.copy() * -1
    tmp44 += tmp17.transpose((1, 0, 2, 3)) * 2
    del tmp17
    l1new += einsum(v.oovv, (0, 1, 2, 3), tmp44, (0, 4, 1, 3), (2, 4)) * -1
    del tmp44
    tmp57 = f.vv.copy() * 0.5
    tmp57 += einsum(t1, (0, 1), tmp56, (0, 2, 1, 3), (3, 2))
    del tmp56
    l1new += einsum(l1, (0, 1), tmp57, (0, 2), (2, 1)) * 2
    del tmp57
    l1new += f.ov.transpose((1, 0))
    l2new += einsum(v.vvvv, (0, 1, 2, 3), l2, (3, 1, 4, 5), (0, 2, 5, 4))
    l2new += v.ovov.transpose((1, 3, 0, 2))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:32:20.175235.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp0 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    rdm1.oo = tmp0.transpose((1, 0)).copy() * -2
    tmp1 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp1 += t2
    rdm1.oo += einsum(tmp1, (0, 1, 2, 3), l2, (2, 3, 0, 4), (1, 4)) * -4
    tmp6 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp6 += l2.transpose((2, 3, 0, 1)) * 2
    rdm1.vv = einsum(t2, (0, 1, 2, 3), tmp6, (0, 1, 4, 3), (4, 2)) * 2
    del tmp6
    tmp3 = tmp2.copy() * -0.5
    tmp3 += tmp2.transpose((1, 0, 2, 3))
    del tmp2
    rdm1.ov = einsum(tmp3, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4)) * -4
    del tmp3
    tmp5 = tmp0.copy() * 0.5
    del tmp0
    tmp5 += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (3, 4))
    del tmp1
    rdm1.ov += einsum(t1, (0, 1), tmp5, (0, 2), (2, 1)) * -4
    del tmp5
    tmp4 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp4 += t2 * 2
    rdm1.ov += einsum(l1, (0, 1), tmp4, (1, 2, 0, 3), (2, 3)) * 2
    del tmp4
    rdm1.oo += delta.oo * 2
    del delta
    rdm1.ov += t1 * 2
    rdm1.vo = l1.copy() * 2
    rdm1.vv += einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 2
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:33:36.643232.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.vooo = tmp1.transpose((3, 2, 1, 0)).copy()
    rdm2.vooo += tmp1.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp1.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp1.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp1.transpose((3, 2, 1, 0))
    rdm2.vooo += tmp1.transpose((3, 2, 0, 1)) * -1
    rdm2.ovoo = tmp1.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.ovoo += tmp1.transpose((2, 3, 0, 1))
    rdm2.ovoo += tmp1.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp1.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp1.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp1.transpose((2, 3, 0, 1))
    tmp76 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp76 += t2
    tmp22 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp22 += t2 * 2
    tmp12 = tmp1.copy() * -1
    tmp12 += tmp1.transpose((1, 0, 2, 3)) * 2
    tmp10 = tmp1.copy() * -1
    tmp10 += tmp1.transpose((1, 0, 2, 3))
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp5 += t2
    tmp43 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp43 += l2.transpose((2, 3, 0, 1)) * -1
    tmp88 = einsum(t1, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.voov = tmp88.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.voov += tmp88.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo = tmp88.transpose((1, 2, 3, 0)).copy() * -1
    rdm2.ovvo += tmp88.transpose((1, 2, 3, 0)) * -1
    tmp77 = einsum(tmp76, (0, 1, 2, 3), l2, (4, 2, 0, 5), (1, 5, 3, 4))
    del tmp76
    rdm2.voov += tmp77.transpose((3, 0, 1, 2)) * -1
    rdm2.voov += tmp77.transpose((3, 0, 1, 2)) * -1
    rdm2.ovov = tmp77.transpose((0, 3, 1, 2)).copy()
    rdm2.ovov += tmp77.transpose((0, 3, 1, 2))
    tmp78 = einsum(l2, (0, 1, 2, 3), tmp22, (3, 4, 1, 5), (4, 2, 5, 0))
    rdm2.voov += tmp78.transpose((3, 0, 1, 2))
    rdm2.voov += tmp78.transpose((3, 0, 1, 2))
    rdm2.ovov += tmp78.transpose((0, 3, 1, 2)) * -1
    rdm2.ovov += tmp78.transpose((0, 3, 1, 2)) * -1
    tmp59 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp59 += l2.transpose((2, 3, 0, 1)) * -1
    tmp13 = einsum(tmp12, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5))
    del tmp12
    rdm2.oovo = tmp13.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.oovo += tmp13.transpose((2, 1, 3, 0)) * -1
    rdm2.ooov = tmp13.transpose((1, 2, 0, 3)).copy() * -1
    rdm2.ooov += tmp13.transpose((1, 2, 0, 3)) * -1
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4, 5, 2), (4, 5, 0, 3))
    rdm2.oovo += tmp25.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp25.transpose((2, 1, 3, 0))
    rdm2.ooov += tmp25.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp25.transpose((1, 2, 0, 3))
    tmp0 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.oooo = tmp0.transpose((3, 2, 1, 0)).copy()
    rdm2.oooo += tmp0.transpose((3, 2, 1, 0))
    tmp2 = einsum(tmp1, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    rdm2.oooo += tmp2.transpose((3, 2, 1, 0))
    rdm2.oooo += tmp2.transpose((3, 2, 1, 0))
    tmp46 = l2.transpose((3, 2, 0, 1)).copy()
    tmp46 += l2.transpose((2, 3, 0, 1)) * -1
    tmp4 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    rdm2.ooov += einsum(t1, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.ooov += einsum(t1, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    tmp11 = einsum(t2, (0, 1, 2, 3), tmp10, (4, 1, 5, 2), (4, 5, 0, 3))
    tmp8 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2.oovo += tmp8.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp8.transpose((1, 2, 3, 0)) * -1
    rdm2.ooov += tmp8.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp8.transpose((2, 1, 0, 3)) * -1
    tmp26 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    tmp17 = tmp1.copy() * 2
    tmp17 += tmp1.transpose((1, 0, 2, 3)) * -1
    tmp6 = einsum(tmp5, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    tmp31 = einsum(tmp5, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    del tmp5
    tmp110 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2.vvvo = tmp110.transpose((2, 1, 3, 0)).copy()
    rdm2.vvvo += tmp110.transpose((1, 2, 3, 0)) * -1
    rdm2.vvvo += tmp110.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp110.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp110.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp110.transpose((1, 2, 3, 0)) * -1
    rdm2.vvov = tmp110.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.vvov += tmp110.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp110.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp110.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp110.transpose((2, 1, 0, 3)) * -1
    rdm2.vvov += tmp110.transpose((1, 2, 0, 3))
    tmp64 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 5, 1), (5, 0, 4, 3))
    rdm2.voov += tmp64.transpose((2, 1, 0, 3)) * -1
    rdm2.voov += tmp64.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo += tmp64.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp64.transpose((1, 2, 3, 0)) * -1
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp43, (1, 4, 5, 3), (4, 0, 5, 2))
    tmp104 = tmp88.copy()
    tmp104 += tmp77.transpose((1, 0, 3, 2))
    tmp104 += tmp78.transpose((1, 0, 3, 2)) * -1
    tmp90 = einsum(t2, (0, 1, 2, 3), tmp59, (0, 1, 4, 2), (4, 3))
    tmp81 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp94 = tmp78.transpose((1, 0, 3, 2)).copy()
    del tmp78
    tmp94 += tmp77.transpose((1, 0, 3, 2)) * -1
    del tmp77
    tmp101 = einsum(t2, (0, 1, 2, 3), tmp59, (1, 4, 5, 3), (4, 0, 5, 2))
    tmp68 = tmp25.copy()
    del tmp25
    tmp68 += tmp13 * -1
    tmp51 = einsum(t2, (0, 1, 2, 3), tmp43, (1, 4, 5, 2), (4, 0, 5, 3))
    del tmp43
    tmp3 = tmp0.transpose((1, 0, 3, 2)).copy()
    tmp3 += tmp2
    rdm2.oooo += tmp3.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp3.transpose((3, 2, 0, 1)) * -1
    rdm2.oooo += tmp3.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp3.transpose((3, 2, 0, 1)) * -1
    tmp15 = einsum(tmp0, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp0
    tmp9 = einsum(tmp2, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    del tmp2
    tmp47 = einsum(t2, (0, 1, 2, 3), tmp46, (1, 4, 5, 2), (4, 0, 5, 3))
    tmp21 = einsum(tmp4, (0, 1), t1, (0, 2), (1, 2))
    rdm2.oovv = einsum(t1, (0, 1), tmp21, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), tmp21, (2, 3), (0, 2, 1, 3)) * -1
    tmp23 = einsum(l1, (0, 1), tmp22, (1, 2, 0, 3), (2, 3))
    del tmp22
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(tmp23, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(tmp23, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    tmp53 = tmp8.copy()
    tmp53 += tmp11
    tmp53 += tmp13 * -1
    tmp71 = tmp8.copy()
    tmp71 += tmp26 * -1
    del tmp26
    tmp18 = einsum(tmp17, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4)) * 0.5
    tmp19 = einsum(t1, (0, 1), tmp6, (0, 2), (2, 1)) * 0.5
    tmp60 = einsum(t2, (0, 1, 2, 3), tmp59, (0, 1, 4, 2), (4, 3)) * 0.5
    del tmp59
    tmp32 = tmp4.copy() * 0.5
    tmp32 += tmp31
    del tmp31
    tmp29 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp29 += t2 * 2
    tmp112 = einsum(tmp110, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    del tmp110
    rdm2.vvvv = tmp112.transpose((1, 0, 3, 2)).copy()
    rdm2.vvvv += tmp112.transpose((1, 0, 3, 2))
    tmp111 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    rdm2.vvvv += tmp111.transpose((1, 0, 3, 2))
    rdm2.vvvv += tmp111.transpose((1, 0, 3, 2))
    tmp66 = einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    rdm2.vovo = tmp66.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.vovo += tmp66.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp66.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp66.transpose((1, 2, 0, 3)) * -1
    tmp108 = tmp64.copy()
    tmp108 += tmp88
    tmp108 += tmp44 * -1
    tmp105 = einsum(t1, (0, 1), tmp104, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp104
    tmp93 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    rdm2.vovv = tmp93.transpose((1, 0, 3, 2)).copy()
    rdm2.vovv += tmp93.transpose((1, 0, 3, 2))
    rdm2.ovvv = tmp93.copy()
    rdm2.ovvv += tmp93
    tmp91 = tmp81.copy()
    tmp91 += tmp90
    del tmp90
    rdm2.vovv += einsum(t1, (0, 1), tmp91, (2, 3), (2, 0, 3, 1))
    rdm2.vovv += einsum(t1, (0, 1), tmp91, (2, 3), (2, 0, 3, 1))
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp91, (2, 3), (2, 0, 3, 1))
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp91, (2, 3), (2, 0, 3, 1))
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp91, (2, 3), (2, 0, 3, 1))
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp91, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(delta.oo, (0, 1), tmp91, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.voov += einsum(delta.oo, (0, 1), tmp91, (2, 3), (2, 0, 1, 3)) * -1
    tmp97 = einsum(t2, (0, 1, 2, 3), tmp1, (0, 1, 4, 5), (4, 5, 2, 3))
    rdm2.vovv += tmp97.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp97.transpose((1, 0, 2, 3)) * -1
    rdm2.ovvv += tmp97.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp97.transpose((0, 1, 3, 2)) * -1
    tmp95 = einsum(t1, (0, 1), tmp94, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp94
    tmp102 = tmp64.copy()
    tmp102 += tmp88
    tmp102 += tmp101 * -1
    del tmp101
    tmp84 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp84 += l2.transpose((2, 3, 0, 1)) * 2
    tmp79 = tmp1.copy()
    tmp79 += tmp1.transpose((1, 0, 2, 3)) * -1
    tmp86 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp86 += l2.transpose((2, 3, 0, 1))
    tmp69 = einsum(t1, (0, 1), tmp68, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp68
    tmp52 = einsum(t2, (0, 1, 2, 3), tmp51, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp51
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp3, (0, 1, 4, 5), (4, 5, 2, 3))
    rdm2.oovv += tmp57
    rdm2.oovv += tmp57
    tmp56 = einsum(t1, (0, 1), tmp15, (0, 2, 3, 4), (3, 2, 4, 1))
    tmp27 = einsum(t1, (0, 1), tmp3, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp3
    rdm2.oovo += tmp27.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp27.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp27.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp27.transpose((2, 1, 0, 3))
    tmp45 = einsum(t2, (0, 1, 2, 3), tmp44, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp44
    rdm2.oovv += tmp45 * 2
    rdm2.oovv += tmp45 * 2
    tmp42 = einsum(t1, (0, 1), tmp9, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp48 = einsum(t2, (0, 1, 2, 3), tmp47, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp47
    tmp24 = tmp21.copy()
    tmp24 += tmp23 * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1))
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1))
    tmp50 = einsum(tmp4, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp54 = einsum(t1, (0, 1), tmp53, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp53
    tmp72 = einsum(t1, (0, 1), tmp71, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp71
    tmp20 = tmp18.copy()
    tmp20 += tmp19
    del tmp19
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp20, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp20, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp20, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp20, (2, 3), (2, 0, 1, 3)) * 2
    tmp62 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 4), (2, 1, 4, 3))
    tmp61 = einsum(tmp60, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4)) * 2
    tmp33 = einsum(t1, (0, 1), tmp32, (0, 2), (2, 1)) * 2
    tmp28 = einsum(tmp17, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4))
    del tmp17
    tmp39 = einsum(l1, (0, 1), tmp29, (1, 2, 0, 3), (2, 3)) * 0.5
    tmp40 = einsum(t1, (0, 1), tmp32, (0, 2), (2, 1))
    del tmp32
    tmp30 = einsum(l1, (0, 1), tmp29, (1, 2, 0, 3), (2, 3))
    del tmp29
    tmp113 = tmp111.transpose((1, 0, 3, 2)).copy()
    del tmp111
    tmp113 += tmp112.transpose((1, 0, 3, 2))
    del tmp112
    rdm2.vvvv += tmp113
    rdm2.vvvv += tmp113.transpose((0, 1, 3, 2)) * -1
    rdm2.vvvv += tmp113
    rdm2.vvvv += tmp113.transpose((0, 1, 3, 2)) * -1
    del tmp113
    tmp100 = einsum(t1, (0, 1), tmp66, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.vovv += tmp100.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp100.transpose((1, 0, 3, 2)) * -1
    rdm2.ovvv += tmp100 * -1
    rdm2.ovvv += tmp100 * -1
    del tmp100
    tmp109 = einsum(tmp108, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp108
    rdm2.vovv += tmp109.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp109.transpose((1, 0, 3, 2)) * -1
    del tmp109
    tmp106 = tmp93.copy()
    tmp106 += tmp105.transpose((0, 1, 3, 2))
    del tmp105
    rdm2.vovv += tmp106.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp106.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp106.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp106.transpose((1, 0, 2, 3)) * -1
    del tmp106
    tmp107 = tmp97.copy()
    tmp107 += einsum(tmp91, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    del tmp91
    rdm2.vovv += tmp107.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp107.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp107.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp107.transpose((1, 0, 2, 3)) * -1
    del tmp107
    tmp99 = einsum(t1, (0, 1), tmp88, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp88
    rdm2.ovvv += tmp99.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp99
    rdm2.ovvv += tmp99.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp99
    del tmp99
    tmp98 = tmp97.copy()
    del tmp97
    tmp98 += einsum(tmp60, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ovvv += tmp98.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp98
    rdm2.ovvv += tmp98.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp98
    del tmp98
    tmp82 = tmp81.copy() * 0.5
    tmp82 += tmp60
    del tmp60
    rdm2.ovvv += einsum(tmp82, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ovvv += einsum(tmp82, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp82, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp82, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp82, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp82, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp82, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp82, (2, 3), (0, 2, 1, 3)) * 2
    del tmp82
    tmp96 = tmp93.copy()
    del tmp93
    tmp96 += einsum(tmp81, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    del tmp81
    tmp96 += tmp95.transpose((0, 1, 3, 2)) * -1
    del tmp95
    rdm2.ovvv += tmp96.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp96
    rdm2.ovvv += tmp96.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp96
    del tmp96
    tmp103 = einsum(t1, (0, 1), tmp102, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp102
    rdm2.ovvv += tmp103 * -1
    rdm2.ovvv += tmp103 * -1
    del tmp103
    tmp85 = einsum(t2, (0, 1, 2, 3), tmp84, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp84
    rdm2.vovo += tmp85.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp85.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp85.transpose((2, 1, 0, 3))
    rdm2.voov += tmp85.transpose((2, 1, 0, 3))
    rdm2.ovvo += tmp85.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp85.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp85.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp85.transpose((1, 2, 3, 0))
    del tmp85
    tmp89 = einsum(t1, (0, 1), tmp10, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp10
    rdm2.vovo += tmp89.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp89.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp89.transpose((2, 1, 0, 3))
    rdm2.voov += tmp89.transpose((2, 1, 0, 3))
    del tmp89
    tmp92 = einsum(t2, (0, 1, 2, 3), tmp46, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp46
    rdm2.vovo += tmp92.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp92.transpose((2, 1, 3, 0)) * -1
    del tmp92
    tmp83 = einsum(t1, (0, 1), tmp1, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp1
    rdm2.vovo += tmp83.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp83.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp83.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp83.transpose((1, 2, 0, 3)) * -1
    del tmp83
    tmp80 = einsum(t1, (0, 1), tmp79, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp79
    rdm2.ovvo += tmp80.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp80.transpose((1, 2, 3, 0)) * -1
    rdm2.ovov += tmp80.transpose((1, 2, 0, 3))
    rdm2.ovov += tmp80.transpose((1, 2, 0, 3))
    del tmp80
    tmp87 = einsum(t2, (0, 1, 2, 3), tmp86, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp86
    rdm2.ovvo += tmp87.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp87.transpose((1, 2, 3, 0)) * -1
    del tmp87
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp66
    rdm2.oovv += tmp67.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp67.transpose((0, 1, 3, 2))
    del tmp67
    tmp70 = tmp52.transpose((1, 0, 3, 2)).copy() * -1
    tmp70 += tmp69.transpose((0, 1, 3, 2))
    del tmp69
    tmp70 += einsum(t1, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    del tmp23
    rdm2.oovv += tmp70.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp70
    rdm2.oovv += tmp70.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp70
    del tmp70
    tmp58 = tmp56.copy()
    del tmp56
    tmp58 += tmp57
    del tmp57
    rdm2.oovv += tmp58.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp58
    rdm2.oovv += tmp58.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp58
    del tmp58
    tmp74 = einsum(t1, (0, 1), tmp27, (0, 2, 3, 4), (3, 2, 4, 1))
    rdm2.oovv += tmp74.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp74.transpose((0, 1, 3, 2))
    del tmp74
    tmp49 = tmp42.copy()
    del tmp42
    tmp49 += tmp45 * 2
    del tmp45
    tmp49 += tmp48.transpose((1, 0, 3, 2))
    del tmp48
    rdm2.oovv += tmp49.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp49
    rdm2.oovv += tmp49.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp49
    del tmp49
    tmp55 = tmp50.copy()
    tmp55 += tmp52.transpose((1, 0, 3, 2)) * -1
    del tmp52
    tmp55 += tmp54.transpose((0, 1, 3, 2))
    del tmp54
    tmp55 += einsum(t1, (0, 1), tmp24, (2, 3), (0, 2, 1, 3)) * -1
    del tmp24
    rdm2.oovv += tmp55.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp55.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp55.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp55
    rdm2.oovv += tmp55.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp55.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp55.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp55
    del tmp55
    tmp75 = t1.copy()
    tmp75 += tmp21 * -1
    del tmp21
    rdm2.oovv += einsum(t1, (0, 1), tmp75, (2, 3), (2, 0, 3, 1))
    rdm2.oovv += einsum(t1, (0, 1), tmp75, (2, 3), (2, 0, 3, 1))
    del tmp75
    tmp65 = einsum(tmp64, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp64
    rdm2.oovv += tmp65
    rdm2.oovv += tmp65
    del tmp65
    tmp73 = tmp50.copy()
    del tmp50
    tmp73 += tmp72.transpose((0, 1, 3, 2))
    del tmp72
    rdm2.oovv += tmp73.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp73.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp73.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp73.transpose((0, 1, 3, 2)) * -1
    del tmp73
    tmp63 = tmp61.transpose((1, 0, 3, 2)).copy()
    del tmp61
    tmp63 += tmp62.transpose((0, 1, 3, 2))
    del tmp62
    tmp63 += einsum(t1, (0, 1), tmp20, (2, 3), (0, 2, 1, 3)) * 2
    del tmp20
    rdm2.oovv += tmp63.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp63.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp63.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp63 * -1
    rdm2.oovv += tmp63.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp63 * -1
    rdm2.oovv += tmp63.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp63 * -1
    rdm2.oovv += tmp63.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp63.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp63.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp63 * -1
    del tmp63
    tmp36 = tmp8.copy()
    tmp36 += tmp27.transpose((0, 2, 1, 3))
    del tmp27
    tmp36 += einsum(tmp6, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += tmp36.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp36.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp36.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp36.transpose((1, 2, 3, 0)) * -1
    del tmp36
    tmp37 = einsum(tmp4, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp37 += tmp11
    tmp37 += tmp13 * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    del tmp37
    tmp38 = tmp28.copy()
    tmp38 += tmp33
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp38, (2, 3), (0, 2, 3, 1))
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp38, (2, 3), (0, 2, 3, 1))
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    del tmp38
    tmp41 = t1.copy() * -0.5
    tmp41 += tmp18
    del tmp18
    tmp41 += tmp39 * -1
    del tmp39
    tmp41 += tmp40
    del tmp40
    rdm2.oovo += einsum(tmp41, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.oovo += einsum(tmp41, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -2
    del tmp41
    tmp35 = tmp4.copy()
    tmp35 += tmp6
    rdm2.oovo += einsum(t1, (0, 1), tmp35, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oovo += einsum(t1, (0, 1), tmp35, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp35, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp35, (2, 3), (3, 0, 2, 1)) * -1
    del tmp35
    tmp34 = t1.copy() * -1
    tmp34 += tmp28
    del tmp28
    tmp34 += tmp30 * -1
    del tmp30
    tmp34 += tmp33
    del tmp33
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp34, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp34, (2, 3), (0, 2, 1, 3)) * -1
    del tmp34
    tmp14 = tmp8.copy()
    del tmp8
    tmp14 += tmp9
    del tmp9
    tmp14 += tmp11
    del tmp11
    tmp14 += tmp13 * -1
    del tmp13
    rdm2.ooov += tmp14.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp14.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp14.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp14.transpose((1, 2, 0, 3))
    del tmp14
    tmp16 = tmp15.copy()
    del tmp15
    tmp16 += einsum(tmp6, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    del tmp6
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((1, 2, 0, 3))
    del tmp16
    tmp7 = delta.oo.copy()
    tmp7 += tmp4 * -1
    del tmp4
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp7, (2, 3), (3, 0, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp7, (2, 3), (3, 0, 2, 1))
    del tmp7
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    del delta
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovv += t2
    rdm2.oovv += t2
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vvoo = l2.transpose((0, 1, 3, 2)).copy() * -1
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2.transpose((0, 1, 3, 2)) * -1
    rdm2.vvoo += l2
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = rdm2.swapaxes(1, 2)

    return rdm2

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:33:57.287839.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    tmp4 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp4 += v.ovov.transpose((0, 2, 1, 3))
    tmp5 = einsum(t1, (0, 1), tmp4, (0, 2, 1, 3), (2, 3))
    del tmp4
    tmp19 = r2.copy()
    tmp19 += einsum(t1, (0, 1), r1, (2,), (0, 2, 1)) * -1
    tmp27 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp27 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp37 = v.ooov.copy()
    tmp37 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp6 = f.ov.copy() * 0.5
    tmp6 += tmp5
    del tmp5
    tmp24 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp14 = einsum(t1, (0, 1), r1, (2,), (2, 0, 1))
    tmp14 += r2 * 2
    tmp14 += r2.transpose((1, 0, 2)) * -1
    tmp7 = r2.copy() * -1
    tmp7 += r2.transpose((1, 0, 2)) * 2
    r1new = einsum(tmp6, (0, 1), tmp7, (2, 0, 1), (2,)) * -2
    tmp13 = einsum(v.ovov, (0, 1, 2, 3), r2, (2, 4, 1), (4, 0, 3))
    tmp12 = einsum(r1, (0,), v.ooov, (1, 0, 2, 3), (1, 2, 3))
    r2new = tmp12.transpose((1, 0, 2)).copy()
    tmp18 = einsum(r1, (0,), v.ooov, (1, 2, 0, 3), (1, 2, 3))
    tmp20 = einsum(tmp19, (0, 1, 2), v.ovov, (3, 2, 1, 4), (3, 0, 4))
    del tmp19
    tmp9 = r2.copy() * 2
    tmp9 += einsum(t1, (0, 1), r1, (2,), (2, 0, 1))
    tmp8 = einsum(r1, (0,), f.ov, (0, 1), (1,))
    tmp3 = r2.copy() * 0.5
    tmp3 += einsum(t1, (0, 1), r1, (2,), (2, 0, 1))
    r1new += einsum(v.ooov, (0, 1, 2, 3), tmp3, (1, 2, 3), (0,)) * -2
    tmp36 = einsum(tmp27, (0, 1, 2, 3), t2, (4, 0, 3, 2), (4, 1))
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t1, (2, 3), (0, 1)) * 2
    tmp39 = einsum(t1, (0, 1), tmp6, (2, 1), (0, 2)) * 2
    tmp28 = v.ovvv.copy() * -1
    tmp28 += v.ovvv.transpose((0, 2, 1, 3)) * 2
    tmp23 = t2.copy()
    tmp23 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp45 = f.oo.copy() * 0.5
    tmp45 += einsum(t2, (0, 1, 2, 3), tmp27, (1, 4, 3, 2), (4, 0)) * 0.5
    tmp45 += einsum(tmp37, (0, 1, 2, 3), t1, (2, 3), (1, 0))
    del tmp37
    tmp45 += einsum(tmp6, (0, 1), t1, (2, 1), (0, 2))
    tmp43 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp43 += t2 * 2
    tmp44 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp44 += v.oovv * -1
    tmp42 = v.ooov.copy() * 2
    tmp42 += v.ooov.transpose((0, 2, 1, 3)) * -1
    tmp42 += tmp24 * -1
    tmp42 += tmp24.transpose((0, 2, 1, 3)) * 2
    tmp15 = einsum(v.ovov, (0, 1, 2, 3), tmp14, (2, 4, 3), (0, 4, 1))
    r2new += tmp15
    tmp25 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp34 = v.ooov.copy()
    tmp34 += tmp24.transpose((2, 0, 1, 3))
    tmp33 = tmp12.copy()
    tmp33 += tmp13 * -1
    tmp33 += einsum(tmp7, (0, 1, 2), v.ovov, (3, 4, 1, 2), (0, 3, 4))
    del tmp7
    tmp31 = r2.copy() * 2
    tmp31 += r2.transpose((1, 0, 2)) * -1
    tmp0 = einsum(v.ovov, (0, 1, 2, 3), r1, (2,), (0, 1, 3))
    tmp11 = einsum(r2, (0, 1, 2), v.ovov, (0, 3, 1, 4), (2, 3, 4))
    r2new += einsum(tmp11, (0, 1, 2), t2, (3, 4, 1, 2), (3, 4, 0))
    del tmp11
    tmp21 = tmp18.transpose((1, 0, 2)).copy()
    del tmp18
    tmp21 += tmp20.transpose((1, 0, 2)) * -1
    del tmp20
    r2new += einsum(tmp21, (0, 1, 2), t2, (3, 1, 4, 2), (3, 0, 4)) * -1
    r2new += einsum(t2, (0, 1, 2, 3), tmp21, (4, 1, 2), (4, 0, 3)) * -1
    del tmp21
    tmp30 = tmp8.copy() * 0.5
    tmp30 += einsum(tmp3, (0, 1, 2), v.ovov, (1, 2, 0, 3), (3,))
    tmp30 += einsum(tmp9, (0, 1, 2), v.ovov, (1, 3, 0, 2), (3,)) * -0.5
    r2new += einsum(t2, (0, 1, 2, 3), tmp30, (3,), (0, 1, 2)) * 2
    del tmp30
    tmp40 = f.oo.copy()
    tmp40 += tmp36.transpose((1, 0))
    del tmp36
    tmp40 += tmp38.transpose((1, 0))
    del tmp38
    tmp40 += tmp39.transpose((1, 0))
    del tmp39
    r2new += einsum(r2, (0, 1, 2), tmp40, (0, 3), (3, 1, 2)) * -1
    r2new += einsum(tmp40, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp40
    tmp46 = f.ov.copy() * -1
    tmp46 += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0)) * -1
    tmp46 += einsum(tmp28, (0, 1, 2, 3), tmp23, (0, 4, 2, 1), (4, 3)) * -1
    tmp46 += einsum(tmp42, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    del tmp42
    tmp46 += einsum(tmp43, (0, 1, 2, 3), tmp6, (0, 2), (1, 3)) * -2
    del tmp43
    tmp46 += einsum(t1, (0, 1), tmp44, (0, 2, 1, 3), (2, 3)) * -1
    del tmp44
    tmp46 += einsum(t1, (0, 1), tmp45, (0, 2), (2, 1)) * 2
    del tmp45
    r2new += einsum(r1, (0,), tmp46, (1, 2), (1, 0, 2))
    del tmp46
    tmp17 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp17 += t2 * -1
    tmp16 = tmp12.copy()
    del tmp12
    tmp16 += tmp13 * -1
    del tmp13
    tmp16 += tmp15.transpose((1, 0, 2))
    del tmp15
    r2new += einsum(tmp17, (0, 1, 2, 3), tmp16, (4, 0, 3), (1, 4, 2))
    del tmp17, tmp16
    tmp26 = v.oooo.copy()
    tmp26 += einsum(tmp24, (0, 1, 2, 3), t1, (4, 3), (1, 4, 0, 2))
    del tmp24
    tmp26 += tmp25.transpose((3, 0, 2, 1))
    tmp26 += tmp25.transpose((2, 1, 0, 3))
    del tmp25
    r2new += einsum(r2, (0, 1, 2), tmp26, (1, 3, 4, 0), (4, 3, 2))
    del tmp26
    tmp41 = v.oovv.copy()
    tmp41 += einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (2, 0, 3, 4))
    r2new += einsum(r2, (0, 1, 2), tmp41, (1, 3, 2, 4), (0, 3, 4)) * -1
    del tmp41
    tmp35 = einsum(v.oooo, (0, 1, 2, 3), r1, (3,), (0, 1, 2)) * -1
    tmp35 += einsum(v.ovoo, (0, 1, 2, 3), r2, (3, 4, 1), (0, 2, 4))
    tmp35 += einsum(v.ooov, (0, 1, 2, 3), tmp14, (2, 4, 3), (0, 1, 4)) * -1
    del tmp14
    tmp35 += einsum(t1, (0, 1), tmp33, (2, 3, 1), (3, 0, 2)) * -1
    del tmp33
    tmp35 += einsum(r2, (0, 1, 2), tmp34, (1, 3, 4, 2), (4, 0, 3))
    del tmp34
    r2new += einsum(tmp35, (0, 1, 2), t1, (0, 3), (1, 2, 3))
    del tmp35
    tmp29 = f.vv.copy() * -1
    tmp29 += einsum(t2, (0, 1, 2, 3), tmp27, (0, 1, 4, 3), (4, 2))
    del tmp27
    tmp29 += einsum(t1, (0, 1), tmp28, (0, 2, 1, 3), (2, 3)) * -1
    del tmp28
    tmp29 += einsum(tmp6, (0, 1), t1, (0, 2), (1, 2)) * 2
    del tmp6
    r2new += einsum(tmp29, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp29
    tmp32 = einsum(v.oovv, (0, 1, 2, 3), r1, (1,), (0, 2, 3))
    tmp32 += einsum(r2, (0, 1, 2), v.ovvv, (0, 3, 4, 2), (1, 3, 4)) * -1
    tmp32 += einsum(v.ovvv, (0, 1, 2, 3), tmp31, (0, 4, 1), (4, 2, 3))
    del tmp31
    r2new += einsum(tmp32, (0, 1, 2), t1, (3, 1), (3, 0, 2))
    del tmp32
    tmp22 = einsum(r1, (0,), v.ovvv, (0, 1, 2, 3), (1, 2, 3))
    tmp22 += einsum(t1, (0, 1), tmp0, (0, 2, 3), (3, 2, 1)) * -1
    r2new += einsum(tmp22, (0, 1, 2), tmp23, (3, 4, 0, 1), (4, 3, 2))
    del tmp23, tmp22
    tmp10 = tmp8.copy()
    del tmp8
    tmp10 += einsum(tmp3, (0, 1, 2), v.ovov, (1, 2, 0, 3), (3,)) * 2
    del tmp3
    tmp10 += einsum(tmp9, (0, 1, 2), v.ovov, (1, 3, 0, 2), (3,)) * -1
    del tmp9
    r1new += einsum(t1, (0, 1), tmp10, (1,), (0,)) * -1
    del tmp10
    tmp2 = einsum(t1, (0, 1), r1, (2,), (2, 0, 1))
    tmp2 += r2 * 2
    r1new += einsum(v.ooov, (0, 1, 2, 3), tmp2, (2, 1, 3), (0,))
    del tmp2
    tmp1 = tmp0.copy() * -0.5
    tmp1 += tmp0.transpose((0, 2, 1))
    del tmp0
    r1new += einsum(t2, (0, 1, 2, 3), tmp1, (1, 2, 3), (0,)) * -2
    del tmp1
    r1new += einsum(f.oo, (0, 1), r1, (1,), (0,)) * -1
    r2new += einsum(r2, (0, 1, 2), v.oovv, (3, 0, 4, 2), (3, 1, 4)) * -1

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:34:18.066135.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    tmp38 = v.ovov.transpose((0, 2, 3, 1)).copy() * -0.5
    tmp38 += v.ovov.transpose((0, 2, 1, 3))
    tmp39 = einsum(tmp38, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp38
    tmp2 = einsum(r1, (0,), v.ovov, (1, 2, 3, 0), (1, 3, 2))
    tmp17 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp50 = v.ovvv.copy() * -0.5
    tmp50 += v.ovvv.transpose((0, 2, 1, 3))
    tmp8 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp8 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp37 = v.ooov.copy()
    tmp37 += v.ooov.transpose((0, 2, 1, 3)) * -0.5
    tmp40 = f.ov.copy() * 0.5
    tmp40 += tmp39
    del tmp39
    tmp29 = einsum(v.ovov, (0, 1, 2, 3), r2, (1, 3, 4), (4, 0, 2))
    tmp28 = einsum(v.ooov, (0, 1, 2, 3), r1, (3,), (0, 1, 2))
    tmp11 = einsum(tmp2, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    r2new = einsum(tmp11, (0, 1, 2), t2, (2, 1, 3, 4), (3, 4, 0)) * -1
    tmp33 = t2.copy()
    tmp33 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp32 = v.ovov.transpose((0, 2, 3, 1)).copy() * 2
    tmp32 += v.ovov.transpose((0, 2, 1, 3)) * -1
    tmp1 = v.ovvv.copy() * -1
    tmp1 += v.ovvv.transpose((0, 2, 1, 3)) * 2
    tmp21 = r2.transpose((2, 0, 1)).copy()
    tmp21 += einsum(t1, (0, 1), r1, (2,), (0, 1, 2)) * -1
    tmp13 = einsum(r1, (0,), t1, (1, 2), (1, 0, 2))
    tmp13 += r2.transpose((2, 0, 1)) * 2
    tmp13 += r2.transpose((2, 1, 0)) * -1
    tmp12 = einsum(v.ovvv, (0, 1, 2, 3), r1, (3,), (0, 1, 2))
    r2new += tmp12.transpose((1, 2, 0)) * -1
    tmp24 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp18 = v.ooov.copy()
    tmp18 += tmp17.transpose((2, 0, 1, 3))
    tmp47 = v.ooov.copy() * 2
    tmp47 += v.ooov.transpose((0, 2, 1, 3)) * -1
    tmp47 += tmp17 * -1
    tmp47 += tmp17.transpose((0, 2, 1, 3)) * 2
    tmp49 = v.ovov.transpose((0, 2, 1, 3)).copy() * 2
    tmp49 += v.oovv * -1
    tmp51 = f.vv.copy()
    tmp51 += einsum(t1, (0, 1), tmp50, (0, 2, 1, 3), (2, 3)) * 2
    del tmp50
    tmp48 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp48 += t2 * 2
    tmp46 = v.ovvv.copy() * 2
    tmp46 += v.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp52 = f.oo.copy() * 0.5
    tmp52 += einsum(t2, (0, 1, 2, 3), tmp8, (1, 4, 3, 2), (4, 0)) * 0.5
    tmp52 += einsum(tmp37, (0, 1, 2, 3), t1, (2, 3), (1, 0))
    tmp52 += einsum(t1, (0, 1), tmp40, (2, 1), (2, 0))
    tmp42 = tmp28.transpose((1, 0, 2)).copy()
    tmp42 += tmp29 * -1
    tmp42 += tmp11.transpose((0, 2, 1))
    del tmp11
    tmp34 = einsum(tmp33, (0, 1, 2, 3), tmp32, (0, 1, 4, 2), (4, 3)) * 0.5
    del tmp33, tmp32
    tmp35 = einsum(t1, (0, 1), tmp1, (0, 2, 1, 3), (2, 3)) * 0.5
    tmp31 = einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp20 = einsum(r1, (0,), v.ovvv, (1, 0, 2, 3), (1, 2, 3))
    tmp25 = v.ooov.copy()
    tmp25 += tmp17.transpose((2, 0, 1, 3))
    del tmp17
    tmp22 = einsum(v.ovov, (0, 1, 2, 3), tmp21, (2, 4, 1), (0, 3, 4))
    del tmp21
    tmp7 = einsum(r1, (0,), f.ov, (1, 0), (1,))
    tmp0 = r2.transpose((2, 0, 1)).copy()
    tmp0 += einsum(t1, (0, 1), r1, (2,), (0, 1, 2)) * -1
    r1new = einsum(tmp0, (0, 1, 2), tmp1, (0, 2, 1, 3), (3,)) * -1
    del tmp1
    tmp4 = v.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp4 += v.ovov.transpose((0, 2, 1, 3)) * 2
    tmp14 = tmp12.transpose((0, 2, 1)).copy()
    tmp14 += einsum(v.ovov, (0, 1, 2, 3), r2, (1, 4, 2), (0, 4, 3))
    tmp14 += einsum(v.ovov, (0, 1, 2, 3), tmp13, (2, 3, 4), (0, 4, 1)) * -1
    del tmp13
    tmp27 = v.oovv.copy()
    tmp27 += tmp24.transpose((0, 1, 3, 2))
    tmp27 += einsum(t1, (0, 1), tmp18, (2, 3, 0, 4), (3, 2, 4, 1)) * -1
    r2new += einsum(tmp27, (0, 1, 2, 3), r2, (4, 2, 1), (4, 3, 0)) * -1
    del tmp27
    tmp53 = f.ov.copy() * -0.5
    tmp53 += einsum(tmp46, (0, 1, 2, 3), t2, (4, 0, 2, 1), (4, 3)) * -0.5
    del tmp46
    tmp53 += einsum(tmp47, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4)) * 0.5
    del tmp47
    tmp53 += einsum(tmp40, (0, 1), tmp48, (0, 2, 1, 3), (2, 3)) * -1
    del tmp48
    tmp53 += einsum(t1, (0, 1), tmp49, (0, 2, 1, 3), (2, 3)) * -0.5
    del tmp49
    tmp53 += einsum(t1, (0, 1), tmp51, (1, 2), (0, 2)) * -0.5
    del tmp51
    tmp53 += einsum(t1, (0, 1), tmp52, (0, 2), (2, 1))
    del tmp52
    r2new += einsum(r1, (0,), tmp53, (1, 2), (2, 0, 1)) * 2
    del tmp53
    tmp10 = einsum(v.vvvv, (0, 1, 2, 3), r1, (3,), (0, 1, 2))
    r2new += einsum(t1, (0, 1), tmp10, (2, 1, 3), (2, 3, 0)) * -1
    del tmp10
    tmp15 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp15 += t2 * -1
    r2new += einsum(tmp15, (0, 1, 2, 3), tmp14, (0, 4, 3), (2, 4, 1)) * -1
    del tmp15, tmp14
    tmp30 = tmp28.transpose((1, 0, 2)).copy()
    del tmp28
    tmp30 += tmp29.transpose((1, 0, 2)) * -1
    del tmp29
    r2new += einsum(tmp30, (0, 1, 2), t2, (0, 2, 3, 4), (3, 4, 1)) * -1
    del tmp30
    tmp43 = einsum(r1, (0,), v.oovv, (1, 2, 3, 0), (1, 2, 3))
    tmp43 += einsum(r2, (0, 1, 2), v.ovvv, (3, 0, 4, 1), (3, 2, 4)) * -1
    tmp43 += einsum(t1, (0, 1), tmp12, (2, 1, 3), (2, 0, 3))
    del tmp12
    tmp43 += einsum(t1, (0, 1), tmp42, (2, 3, 0), (3, 2, 1)) * -1
    del tmp42
    r2new += einsum(t1, (0, 1), tmp43, (0, 2, 3), (1, 3, 2))
    del tmp43
    tmp36 = f.vv.copy() * -0.5
    tmp36 += tmp31 * 0.5
    del tmp31
    tmp36 += tmp34
    del tmp34
    tmp36 += tmp35 * -1
    del tmp35
    r2new += einsum(tmp36, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -2
    r2new += einsum(tmp36, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -2
    del tmp36
    tmp19 = v.ovov.transpose((0, 2, 3, 1)).copy()
    tmp19 += einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp19 += einsum(t1, (0, 1), tmp18, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp18
    tmp16 = r2.transpose((2, 0, 1)).copy() * 2
    tmp16 += r2.transpose((2, 1, 0)) * -1
    r2new += einsum(tmp19, (0, 1, 2, 3), tmp16, (1, 2, 4), (3, 4, 0))
    del tmp19, tmp16
    tmp45 = tmp2.copy()
    tmp45 += einsum(r2, (0, 1, 2), v.ovvv, (3, 1, 4, 0), (2, 3, 4)) * -1
    tmp45 += einsum(tmp20, (0, 1, 2), t1, (3, 2), (3, 0, 1))
    r2new += einsum(t1, (0, 1), tmp45, (2, 0, 3), (3, 1, 2))
    del tmp45
    tmp26 = v.oovv.copy()
    tmp26 += tmp24.transpose((0, 1, 3, 2))
    del tmp24
    tmp26 += einsum(t1, (0, 1), tmp25, (2, 3, 0, 4), (3, 2, 4, 1)) * -1
    del tmp25
    r2new += einsum(r2, (0, 1, 2), tmp26, (3, 2, 0, 4), (4, 1, 3)) * -1
    del tmp26
    tmp41 = f.oo.copy()
    tmp41 += einsum(t2, (0, 1, 2, 3), tmp8, (1, 4, 3, 2), (4, 0))
    tmp41 += einsum(tmp37, (0, 1, 2, 3), t1, (2, 3), (1, 0)) * 2
    del tmp37
    tmp41 += einsum(t1, (0, 1), tmp40, (2, 1), (2, 0)) * 2
    del tmp40
    r2new += einsum(r2, (0, 1, 2), tmp41, (2, 3), (0, 1, 3)) * -1
    del tmp41
    tmp23 = tmp20.transpose((0, 2, 1)).copy()
    del tmp20
    tmp23 += tmp22.transpose((0, 2, 1))
    del tmp22
    r2new += einsum(tmp23, (0, 1, 2), t2, (3, 0, 2, 4), (1, 4, 3))
    r2new += einsum(tmp23, (0, 1, 2), t2, (3, 0, 4, 2), (4, 1, 3))
    del tmp23
    tmp44 = tmp7.copy()
    tmp44 += einsum(tmp0, (0, 1, 2), tmp8, (0, 3, 1, 2), (3,)) * -1
    r2new += einsum(t2, (0, 1, 2, 3), tmp44, (1,), (2, 3, 0))
    del tmp44
    tmp9 = tmp7.copy() * 0.5
    del tmp7
    tmp9 += einsum(tmp0, (0, 1, 2), tmp8, (0, 3, 1, 2), (3,)) * -0.5
    del tmp8, tmp0
    r1new += einsum(tmp9, (0,), t1, (0, 1), (1,)) * -2
    del tmp9
    tmp3 = tmp2.copy() * -0.5
    tmp3 += tmp2.transpose((1, 0, 2))
    del tmp2
    r1new += einsum(tmp3, (0, 1, 2), t2, (1, 0, 2, 3), (3,)) * -2
    del tmp3
    tmp6 = r2.transpose((2, 0, 1)).copy() * -1
    tmp6 += r2.transpose((2, 1, 0)) * 2
    tmp5 = f.ov.copy()
    tmp5 += einsum(t1, (0, 1), tmp4, (0, 2, 1, 3), (2, 3))
    del tmp4
    r1new += einsum(tmp5, (0, 1), tmp6, (0, 2, 1), (2,)) * -1
    del tmp5, tmp6
    r1new += einsum(r1, (0,), f.vv, (1, 0), (1,))
    r2new += einsum(v.vvvv, (0, 1, 2, 3), r2, (1, 3, 4), (0, 2, 4))

    return {f"r1new": r1new, f"r2new": r2new}

