"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T22:02:02.076238
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:02:03.211889.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp3 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp1 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp1 += t2 * 2
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp4 = f.ov.copy()
    tmp4 += einsum(v.xov, (0, 1, 2), tmp3, (1, 3, 0), (3, 2)) * -0.5
    del tmp3
    e_cc = einsum(t1, (0, 1), tmp4, (0, 1), ()) * 2
    del tmp4
    tmp2 = einsum(t1, (0, 1), tmp0, (2,), (0, 1, 2))
    del tmp0
    tmp2 += einsum(tmp1, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4)) * 0.5
    del tmp1
    e_cc += einsum(tmp2, (0, 1, 2), v.xov, (2, 0, 1), ()) * 2
    del tmp2

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:02:12.218279.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp6 = einsum(t1, (0, 1), v.xoo, (2, 3, 0), (3, 1, 2))
    tmp18 = einsum(v.xoo, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 2, 4))
    tmp16 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    t2new = einsum(tmp16, (0, 1, 2), tmp16, (3, 4, 2), (0, 3, 1, 4))
    tmp21 = v.xov.transpose((1, 2, 0)).copy() * -1
    tmp21 += tmp6
    tmp19 = einsum(t1, (0, 1), tmp18, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp18
    tmp27 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp29 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp24 = v.xoo.transpose((1, 2, 0)).copy()
    tmp24 += tmp2.transpose((1, 0, 2))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp9 = einsum(v.xov, (0, 1, 2), tmp2, (1, 3, 0), (3, 2))
    tmp12 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp12 += t2 * 2
    tmp22 = einsum(tmp21, (0, 1, 2), tmp16, (3, 4, 2), (0, 3, 1, 4))
    del tmp21
    tmp17 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp20 = einsum(tmp19, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    del tmp19
    tmp35 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp35 += einsum(tmp2, (0, 1, 2), tmp2, (3, 4, 2), (1, 4, 3, 0))
    tmp28 = einsum(t2, (0, 1, 2, 3), tmp27, (1, 4), (4, 0, 2, 3))
    del tmp27
    tmp30 = einsum(tmp29, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp29
    tmp25 = einsum(tmp24, (0, 1, 2), v.xov, (2, 3, 4), (0, 1, 3, 4))
    del tmp24
    tmp33 = einsum(tmp16, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    del tmp16
    tmp3 = v.xoo.transpose((1, 2, 0)).copy()
    tmp3 += tmp2.transpose((1, 0, 2))
    del tmp2
    tmp1 = einsum(v.xov, (0, 1, 2), tmp0, (0,), (1, 2))
    t1new = tmp1.copy() * 2
    tmp7 = einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 0.5
    tmp7 += t2.transpose((0, 1, 3, 2)) * -1
    tmp7 += t2 * 0.5
    tmp14 = f.ov.copy()
    tmp14 += tmp9 * -1
    tmp13 = tmp6.copy() * -1
    tmp13 += einsum(t1, (0, 1), tmp0, (2,), (0, 1, 2)) * 2
    tmp13 += einsum(tmp12, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4))
    del tmp12
    tmp23 = tmp17.copy()
    del tmp17
    tmp23 += tmp20
    del tmp20
    tmp23 += tmp22.transpose((1, 0, 2, 3)) * -1
    del tmp22
    t2new += tmp23.transpose((1, 0, 2, 3))
    t2new += tmp23.transpose((0, 1, 3, 2))
    del tmp23
    tmp36 = einsum(tmp35, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp35
    t2new += einsum(t1, (0, 1), tmp36, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp36
    tmp31 = tmp28.copy()
    del tmp28
    tmp31 += tmp30
    del tmp30
    t2new += tmp31.transpose((1, 0, 2, 3)) * -1
    t2new += tmp31.transpose((0, 1, 3, 2)) * -1
    del tmp31
    tmp26 = einsum(t1, (0, 1), tmp25, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp25
    t2new += tmp26.transpose((1, 0, 2, 3)) * -1
    t2new += tmp26.transpose((0, 1, 3, 2)) * -1
    del tmp26
    tmp32 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    t2new += tmp32.transpose((1, 0, 2, 3)) * -1
    t2new += tmp32.transpose((0, 1, 3, 2)) * -1
    del tmp32
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp33
    t2new += tmp34.transpose((1, 0, 3, 2)) * -1
    t2new += tmp34 * -1
    del tmp34
    tmp4 = einsum(v.xov, (0, 1, 2), tmp3, (3, 4, 0), (4, 1, 3, 2))
    del tmp3
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp5 += t2 * -1
    t1new += einsum(tmp5, (0, 1, 2, 3), tmp4, (4, 0, 1, 3), (4, 2)) * -1
    del tmp5, tmp4
    tmp10 = f.ov.copy()
    tmp10 += tmp1 * 2
    del tmp1
    tmp10 += tmp9 * -1
    del tmp9
    tmp8 = tmp6.copy()
    del tmp6
    tmp8 += einsum(t1, (0, 1), tmp0, (2,), (0, 1, 2)) * -2
    tmp8 += einsum(tmp7, (0, 1, 2, 3), v.xov, (4, 0, 3), (1, 2, 4)) * 2
    del tmp7
    t1new += einsum(v.xvv, (0, 1, 2), tmp8, (3, 2, 0), (3, 1)) * -1
    del tmp8
    tmp15 = f.oo.copy() * 0.5
    tmp15 += einsum(v.xoo, (0, 1, 2), tmp0, (0,), (1, 2))
    del tmp0
    tmp15 += einsum(tmp13, (0, 1, 2), v.xov, (2, 3, 1), (3, 0)) * 0.5
    del tmp13
    tmp15 += einsum(t1, (0, 1), tmp14, (2, 1), (2, 0)) * 0.5
    del tmp14
    t1new += einsum(t1, (0, 1), tmp15, (0, 2), (2, 1)) * -2
    del tmp15
    tmp11 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp11 += t2 * 2
    t1new += einsum(tmp10, (0, 1), tmp11, (0, 2, 1, 3), (2, 3))
    del tmp10, tmp11
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += f.ov
    t2new += einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:03:24.125382.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp5 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp13 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp15 = einsum(tmp5, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp14 = einsum(tmp13, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp33 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp0 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp7 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    l2new = tmp7.transpose((3, 2, 1, 0)).copy()
    tmp96 = tmp14.copy() * 2
    tmp96 += tmp15 * -1
    tmp91 = tmp33.copy() * 2
    tmp91 += tmp33.transpose((1, 0, 2, 3)) * -1
    tmp88 = v.xov.transpose((1, 2, 0)).copy()
    tmp88 += tmp0
    tmp89 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp89 += l2.transpose((2, 3, 0, 1)) * 2
    tmp9 = einsum(tmp5, (0, 1, 2), tmp5, (3, 4, 2), (0, 3, 1, 4))
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp20 = t2.transpose((0, 1, 3, 2)).copy()
    tmp20 += t2 * -0.5
    tmp49 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp97 = einsum(t1, (0, 1), tmp96, (2, 1), (0, 2))
    tmp62 = einsum(tmp5, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp93 = einsum(tmp91, (0, 1, 2, 3), tmp5, (1, 2, 4), (0, 3, 4))
    tmp90 = einsum(tmp89, (0, 1, 2, 3), tmp88, (0, 2, 4), (1, 3, 4))
    del tmp89, tmp88
    tmp92 = einsum(tmp91, (0, 1, 2, 3), v.xoo, (4, 1, 2), (0, 3, 4))
    del tmp91
    tmp79 = v.xoo.transpose((1, 2, 0)).copy()
    tmp79 += tmp5.transpose((1, 0, 2))
    tmp10 = tmp8.copy()
    del tmp8
    tmp10 += tmp9
    tmp3 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp21 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp21 += t2 * 2
    tmp50 = einsum(tmp20, (0, 1, 2, 3), l2, (3, 2, 0, 4), (4, 1))
    tmp55 = einsum(tmp20, (0, 1, 2, 3), l2, (3, 2, 0, 4), (4, 1)) * 2
    tmp77 = einsum(v.xov, (0, 1, 2), tmp5, (3, 4, 0), (3, 1, 4, 2))
    tmp108 = einsum(tmp49, (0, 1), v.xov, (2, 1, 3), (0, 3, 2))
    tmp75 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp65 = einsum(v.xvv, (0, 1, 2), tmp13, (0,), (1, 2))
    tmp98 = tmp62.copy()
    tmp98 += tmp97 * -1
    del tmp97
    tmp94 = tmp90.copy()
    del tmp90
    tmp94 += tmp92 * -1
    del tmp92
    tmp94 += tmp93 * -1
    del tmp93
    tmp80 = einsum(v.xvv, (0, 1, 2), tmp79, (3, 4, 0), (3, 4, 1, 2))
    del tmp79
    tmp72 = einsum(v.xvv, (0, 1, 2), l1, (2, 3), (3, 1, 0))
    tmp69 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp25 = einsum(tmp5, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp104 = einsum(tmp0, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp6 = einsum(tmp5, (0, 1, 2), tmp0, (3, 4, 2), (0, 3, 1, 4))
    tmp11 = einsum(t1, (0, 1), tmp10, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    del tmp10
    tmp4 = einsum(t2, (0, 1, 2, 3), tmp3, (4, 3, 5, 2), (0, 1, 4, 5))
    tmp18 = v.xoo.transpose((1, 2, 0)).copy()
    tmp18 += tmp5.transpose((1, 0, 2))
    tmp22 = einsum(tmp21, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4))
    tmp16 = tmp14.copy() * 2
    tmp16 += tmp15 * -1
    tmp24 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp46 = einsum(tmp33, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    l2new += einsum(tmp46, (0, 1, 2, 3), tmp7, (2, 3, 4, 5), (5, 4, 1, 0))
    del tmp7
    tmp34 = tmp33.copy() * 2
    tmp34 += tmp33.transpose((1, 0, 2, 3)) * -1
    tmp41 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp42 = tmp33.copy() * -0.5
    tmp42 += tmp33.transpose((1, 0, 2, 3))
    tmp39 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp39 += t2 * -1
    tmp28 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp28 += t2
    tmp51 = tmp49.copy() * 0.5
    tmp51 += tmp50
    del tmp50
    tmp44 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp56 = tmp49.copy()
    tmp56 += tmp55
    del tmp55
    tmp107 = einsum(l1, (0, 1), tmp77, (1, 2, 3, 4), (2, 3, 0, 4))
    tmp109 = einsum(v.xov, (0, 1, 2), tmp108, (3, 4, 0), (3, 1, 2, 4))
    del tmp108
    tmp61 = einsum(tmp13, (0,), v.xoo, (0, 1, 2), (1, 2))
    del tmp13
    tmp83 = einsum(tmp75, (0, 1, 2, 3), tmp33, (4, 1, 2, 5), (4, 0, 5, 3))
    tmp86 = einsum(tmp33, (0, 1, 2, 3), tmp77, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp100 = einsum(tmp96, (0, 1), tmp33, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp84 = einsum(tmp65, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    tmp99 = einsum(tmp98, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del tmp98
    tmp95 = einsum(v.xov, (0, 1, 2), tmp94, (3, 4, 0), (1, 3, 2, 4))
    del tmp94
    tmp85 = einsum(tmp3, (0, 1, 2, 3), tmp33, (4, 5, 0, 2), (5, 4, 3, 1))
    del tmp3
    tmp87 = einsum(l2, (0, 1, 2, 3), tmp80, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp76 = einsum(tmp75, (0, 1, 2, 3), tmp33, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp68 = einsum(f.vv, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp73 = einsum(tmp72, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 4, 1))
    del tmp72
    tmp70 = einsum(tmp69, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp69
    tmp81 = einsum(l2, (0, 1, 2, 3), tmp80, (4, 2, 5, 1), (3, 4, 0, 5))
    del tmp80
    tmp78 = einsum(tmp33, (0, 1, 2, 3), tmp77, (0, 2, 4, 5), (1, 4, 3, 5))
    del tmp77
    tmp71 = einsum(tmp33, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp74 = einsum(tmp25, (0, 1, 2, 3), l2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp103 = einsum(l1, (0, 1), tmp75, (2, 1, 3, 4), (2, 3, 0, 4))
    del tmp75
    tmp105 = einsum(tmp104, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp104
    tmp12 = tmp4.copy() * 2
    del tmp4
    tmp12 += tmp6 * 2
    del tmp6
    tmp12 += tmp11 * -1
    del tmp11
    tmp19 = einsum(v.xov, (0, 1, 2), tmp18, (3, 4, 0), (1, 3, 4, 2))
    tmp23 = v.xov.transpose((1, 2, 0)).copy()
    tmp23 += tmp22
    tmp1 = einsum(v.xoo, (0, 1, 2), tmp0, (3, 4, 0), (3, 1, 2, 4))
    tmp17 = einsum(t2, (0, 1, 2, 3), tmp16, (4, 2), (0, 1, 4, 3))
    del tmp16
    tmp2 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp26 = tmp24.transpose((3, 2, 1, 0)).copy()
    tmp26 += tmp25.transpose((1, 0, 3, 2))
    tmp26 += tmp25.transpose((3, 0, 2, 1)) * -0.5
    tmp29 = tmp24.transpose((3, 2, 1, 0)).copy() * 0.5
    tmp29 += tmp25.transpose((1, 0, 3, 2)) * 0.5
    tmp29 += tmp25.transpose((3, 0, 2, 1)) * -1
    del tmp25
    tmp63 = f.ov.copy()
    tmp63 += tmp14 * 2
    tmp63 += tmp15 * -1
    tmp48 = tmp46.copy() * -0.5
    tmp48 += tmp46.transpose((0, 1, 3, 2))
    tmp35 = tmp33.copy()
    tmp35 += tmp33.transpose((1, 0, 2, 3)) * -0.5
    tmp31 = v.xov.transpose((1, 2, 0)).copy()
    tmp31 += tmp0
    tmp31 += tmp22
    tmp43 = tmp41.copy() * -1
    tmp43 += tmp41.transpose((0, 2, 1, 3)) * 0.5
    del tmp41
    tmp43 += einsum(t2, (0, 1, 2, 3), tmp34, (1, 4, 5, 3), (4, 5, 0, 2)) * 0.5
    tmp43 += einsum(tmp42, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    del tmp42
    tmp40 = einsum(l2, (0, 1, 2, 3), tmp39, (2, 4, 1, 5), (3, 4, 0, 5))
    tmp40 += einsum(l2, (0, 1, 2, 3), tmp28, (3, 4, 1, 5), (2, 4, 0, 5)) * 2
    tmp47 = tmp46.copy() * 2
    tmp47 += tmp46.transpose((0, 1, 3, 2)) * -1
    del tmp46
    tmp52 = t1.copy() * -0.5
    tmp52 += einsum(tmp20, (0, 1, 2, 3), tmp33, (0, 1, 4, 3), (4, 2))
    tmp52 += einsum(tmp21, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * -0.5
    tmp52 += einsum(t1, (0, 1), tmp51, (0, 2), (2, 1))
    tmp45 = tmp44.transpose((1, 0, 2, 3)).copy() * -0.5
    tmp45 += tmp44.transpose((1, 0, 3, 2))
    del tmp44
    tmp58 = tmp49.copy()
    del tmp49
    tmp58 += einsum(l2, (0, 1, 2, 3), tmp21, (2, 4, 0, 1), (4, 3))
    del tmp21
    tmp54 = einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 0.5
    tmp54 += einsum(l2, (0, 1, 2, 3), tmp28, (3, 2, 1, 4), (0, 4))
    tmp57 = l1.transpose((1, 0)).copy()
    tmp57 += t1
    tmp57 += einsum(tmp39, (0, 1, 2, 3), tmp33, (0, 1, 4, 3), (4, 2)) * -1
    del tmp33, tmp39
    tmp57 += einsum(tmp20, (0, 1, 2, 3), l1, (3, 0), (1, 2)) * 2
    tmp57 += einsum(t1, (0, 1), tmp56, (0, 2), (2, 1)) * -1
    tmp37 = v.xoo.transpose((1, 2, 0)).copy()
    tmp37 += tmp5
    tmp36 = einsum(l2, (0, 1, 2, 3), tmp28, (3, 2, 1, 4), (0, 4)) * 2
    tmp32 = l2.transpose((3, 2, 0, 1)).copy()
    tmp32 += l2.transpose((2, 3, 0, 1)) * -0.5
    tmp110 = tmp107.copy()
    del tmp107
    tmp110 += tmp109
    del tmp109
    l2new += tmp110.transpose((2, 3, 1, 0)) * -1
    l2new += tmp110.transpose((3, 2, 0, 1)) * -1
    del tmp110
    tmp102 = einsum(l2, (0, 1, 2, 3), tmp61, (4, 3), (2, 4, 0, 1))
    l2new += tmp102.transpose((3, 2, 1, 0)) * -2
    l2new += tmp102.transpose((2, 3, 0, 1)) * -2
    del tmp102
    tmp101 = einsum(f.ov, (0, 1), l1, (2, 3), (0, 3, 1, 2))
    tmp101 += tmp83
    del tmp83
    tmp101 += tmp84 * 2
    del tmp84
    tmp101 += tmp85 * -1
    del tmp85
    tmp101 += tmp86
    del tmp86
    tmp101 += tmp87 * -1
    del tmp87
    tmp101 += tmp95.transpose((1, 0, 3, 2))
    del tmp95
    tmp101 += tmp99.transpose((0, 1, 3, 2))
    del tmp99
    tmp101 += tmp100 * -1
    del tmp100
    tmp101 += einsum(tmp96, (0, 1), l1, (2, 3), (3, 0, 2, 1))
    del tmp96
    l2new += tmp101.transpose((3, 2, 1, 0))
    l2new += tmp101.transpose((2, 3, 0, 1))
    del tmp101
    tmp82 = tmp68.copy()
    del tmp68
    tmp82 += tmp70 * -1
    del tmp70
    tmp82 += tmp71 * -1
    del tmp71
    tmp82 += tmp73
    del tmp73
    tmp82 += tmp74
    del tmp74
    tmp82 += tmp76
    del tmp76
    tmp82 += tmp78
    del tmp78
    tmp82 += tmp81 * -1
    del tmp81
    l2new += tmp82.transpose((2, 3, 1, 0))
    l2new += tmp82.transpose((3, 2, 0, 1))
    del tmp82
    tmp112 = tmp24.transpose((3, 2, 1, 0)).copy()
    del tmp24
    tmp112 += tmp9.transpose((0, 3, 1, 2))
    del tmp9
    l2new += einsum(l2, (0, 1, 2, 3), tmp112, (3, 4, 2, 5), (0, 1, 4, 5))
    del tmp112
    tmp106 = tmp103.copy()
    del tmp103
    tmp106 += tmp105
    del tmp105
    l2new += tmp106.transpose((3, 2, 1, 0)) * -1
    l2new += tmp106.transpose((2, 3, 0, 1)) * -1
    del tmp106
    tmp111 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    l2new += tmp111.transpose((2, 3, 1, 0)) * -1
    l2new += tmp111.transpose((3, 2, 0, 1)) * -1
    del tmp111
    tmp67 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    l2new += einsum(l2, (0, 1, 2, 3), tmp67, (4, 5, 1, 0), (4, 5, 2, 3))
    del tmp67
    tmp60 = f.ov.copy() * 0.5
    tmp60 += tmp14
    del tmp14
    tmp60 += tmp15 * -0.5
    del tmp15
    l1new = einsum(tmp60, (0, 1), tmp56, (2, 0), (1, 2)) * -2
    del tmp56, tmp60
    tmp27 = tmp1.transpose((0, 2, 1, 3)).copy()
    tmp27 += tmp2.transpose((1, 0, 2, 3))
    tmp27 += tmp2.transpose((2, 0, 1, 3)) * -2
    del tmp2
    tmp27 += tmp12.transpose((0, 2, 1, 3)) * -1
    tmp27 += tmp12.transpose((1, 2, 0, 3)) * 0.5
    del tmp12
    tmp27 += tmp17.transpose((1, 2, 0, 3))
    tmp27 += tmp17.transpose((0, 2, 1, 3)) * -2
    del tmp17
    tmp27 += einsum(tmp20, (0, 1, 2, 3), tmp19, (4, 0, 5, 3), (5, 4, 1, 2)) * 2
    del tmp20
    tmp27 += einsum(tmp18, (0, 1, 2), tmp23, (3, 4, 2), (1, 0, 3, 4)) * -2
    tmp27 += einsum(t1, (0, 1), tmp26, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp26
    l1new += einsum(l2, (0, 1, 2, 3), tmp27, (2, 4, 3, 1), (0, 4))
    del tmp27
    tmp30 = tmp1.transpose((0, 2, 1, 3)).copy() * -2
    del tmp1
    tmp30 += einsum(tmp28, (0, 1, 2, 3), tmp19, (4, 0, 5, 3), (5, 4, 1, 2)) * 2
    del tmp28, tmp19
    tmp30 += einsum(tmp18, (0, 1, 2), tmp23, (3, 4, 2), (1, 0, 3, 4))
    del tmp23
    tmp30 += einsum(t1, (0, 1), tmp29, (0, 2, 3, 4), (2, 3, 4, 1)) * -2
    del tmp29
    l1new += einsum(tmp30, (0, 1, 2, 3), l2, (4, 3, 2, 0), (4, 1))
    del tmp30
    tmp64 = f.oo.copy()
    tmp64 += tmp61.transpose((1, 0)) * 2
    del tmp61
    tmp64 += tmp62 * -1
    del tmp62
    tmp64 += einsum(v.xov, (0, 1, 2), tmp22, (3, 2, 0), (3, 1))
    del tmp22
    tmp64 += einsum(tmp63, (0, 1), t1, (2, 1), (2, 0))
    del tmp63
    l1new += einsum(tmp64, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp64
    tmp66 = f.vv.copy()
    tmp66 += tmp65.transpose((1, 0)) * 2
    del tmp65
    l1new += einsum(tmp66, (0, 1), l1, (0, 2), (1, 2))
    del tmp66
    tmp53 = einsum(l1, (0, 1), tmp0, (2, 0, 3), (2, 1, 3)) * -1
    del tmp0
    tmp53 += einsum(v.xvv, (0, 1, 2), tmp40, (3, 4, 2, 1), (4, 3, 0)) * -1
    del tmp40
    tmp53 += einsum(tmp31, (0, 1, 2), tmp35, (0, 3, 4, 1), (4, 3, 2)) * -2
    tmp53 += einsum(tmp43, (0, 1, 2, 3), v.xov, (4, 1, 3), (2, 0, 4)) * 2
    del tmp43
    tmp53 += einsum(tmp45, (0, 1, 2, 3), tmp18, (2, 0, 4), (3, 1, 4)) * 2
    del tmp18, tmp45
    tmp53 += einsum(tmp47, (0, 1, 2, 3), tmp5, (0, 2, 4), (3, 1, 4))
    del tmp47
    tmp53 += einsum(tmp48, (0, 1, 2, 3), v.xoo, (4, 0, 3), (2, 1, 4)) * 2
    del tmp48
    tmp53 += einsum(v.xov, (0, 1, 2), tmp52, (3, 2), (3, 1, 0)) * 2
    del tmp52
    tmp53 += einsum(v.xoo, (0, 1, 2), tmp51, (2, 3), (3, 1, 0)) * 2
    del tmp51
    l1new += einsum(v.xov, (0, 1, 2), tmp53, (1, 3, 0), (2, 3))
    del tmp53
    tmp59 = einsum(v.xvv, (0, 1, 2), tmp54, (2, 1), (0,)) * 2
    del tmp54
    tmp59 += einsum(v.xov, (0, 1, 2), tmp57, (1, 2), (0,))
    del tmp57
    tmp59 += einsum(v.xoo, (0, 1, 2), tmp58, (2, 1), (0,)) * -1
    del tmp58
    l1new += einsum(tmp59, (0,), v.xov, (0, 1, 2), (2, 1)) * 2
    del tmp59
    tmp38 = einsum(tmp31, (0, 1, 2), tmp32, (0, 3, 4, 1), (3, 4, 2)) * -2
    del tmp31, tmp32
    tmp38 += einsum(tmp34, (0, 1, 2, 3), v.xoo, (4, 1, 2), (0, 3, 4))
    del tmp34
    tmp38 += einsum(tmp35, (0, 1, 2, 3), tmp5, (1, 2, 4), (0, 3, 4)) * 2
    del tmp5, tmp35
    tmp38 += einsum(v.xov, (0, 1, 2), tmp36, (3, 2), (1, 3, 0))
    del tmp36
    tmp38 += einsum(tmp37, (0, 1, 2), l1, (3, 0), (1, 3, 2))
    del tmp37
    l1new += einsum(v.xvv, (0, 1, 2), tmp38, (3, 2, 0), (1, 3)) * -1
    del tmp38
    l1new += f.ov.transpose((1, 0))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:03:25.742667.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp0 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    rdm1.oo = tmp0.transpose((1, 0)).copy() * -2
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp5 += t2
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp7 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp7 += l2.transpose((2, 3, 0, 1)) * -1
    rdm1.vv = einsum(t2, (0, 1, 2, 3), tmp7, (0, 1, 4, 2), (4, 3)) * 2
    del tmp7
    tmp4 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp4 += t2 * 2
    rdm1.ov = einsum(l1, (0, 1), tmp4, (1, 2, 0, 3), (2, 3)) * 2
    del tmp4
    tmp6 = tmp0.copy()
    del tmp0
    tmp6 += einsum(tmp5, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    del tmp5
    rdm1.ov += einsum(tmp6, (0, 1), t1, (0, 2), (1, 2)) * -2
    del tmp6
    tmp3 = tmp2.copy() * -0.5
    tmp3 += tmp2.transpose((1, 0, 2, 3))
    del tmp2
    rdm1.ov += einsum(tmp3, (0, 1, 2, 3), t2, (1, 0, 3, 4), (2, 4)) * -4
    del tmp3
    tmp1 = t2.transpose((0, 1, 3, 2)).copy()
    tmp1 += t2 * -0.5
    rdm1.oo += einsum(tmp1, (0, 1, 2, 3), l2, (3, 2, 0, 4), (1, 4)) * -4
    del tmp1
    rdm1.oo += delta.oo * 2
    del delta
    rdm1.ov += t1 * 2
    rdm1.vo = l1.copy() * 2
    rdm1.vv += einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 2
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:04:40.631217.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.vooo = tmp2.transpose((3, 2, 1, 0)).copy()
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp2.transpose((3, 2, 1, 0))
    rdm2.vooo += tmp2.transpose((3, 2, 0, 1)) * -1
    rdm2.ovoo = tmp2.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 0, 1))
    rdm2.ovoo += tmp2.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp2.transpose((2, 3, 0, 1))
    tmp22 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp22 += t2 * 2
    tmp94 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp94 += t2
    tmp10 = tmp2.copy()
    tmp10 += tmp2.transpose((1, 0, 2, 3)) * -1
    tmp12 = tmp2.copy() * 2
    tmp12 += tmp2.transpose((1, 0, 2, 3)) * -1
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp5 += t2
    tmp45 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp45 += l2.transpose((2, 3, 0, 1)) * 2
    tmp93 = einsum(l2, (0, 1, 2, 3), tmp22, (3, 4, 1, 5), (4, 2, 5, 0))
    tmp87 = einsum(tmp2, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    rdm2.voov = tmp87.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.voov += tmp87.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo = tmp87.transpose((1, 2, 3, 0)).copy() * -1
    rdm2.ovvo += tmp87.transpose((1, 2, 3, 0)) * -1
    tmp95 = einsum(tmp94, (0, 1, 2, 3), l2, (4, 2, 0, 5), (1, 5, 3, 4))
    del tmp94
    tmp103 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp103 += l2.transpose((2, 3, 0, 1)) * 2
    tmp0 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    rdm2.ooov = einsum(t1, (0, 1), tmp0, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (0, 3, 2, 1))
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp0, (2, 3), (0, 3, 2, 1))
    rdm2.oooo = einsum(delta.oo, (0, 1), tmp0, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp0, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp0, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp11 = einsum(tmp10, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp13 = einsum(tmp12, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 2, 4, 5))
    del tmp12
    rdm2.oovo = tmp13.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.oovo += tmp13.transpose((2, 1, 3, 0)) * -1
    rdm2.ooov += tmp13.transpose((1, 2, 0, 3)) * -1
    rdm2.ooov += tmp13.transpose((1, 2, 0, 3)) * -1
    tmp8 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2.oovo += tmp8.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp8.transpose((1, 2, 3, 0)) * -1
    rdm2.ooov += tmp8.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp8.transpose((2, 1, 0, 3)) * -1
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp2, (1, 4, 5, 2), (4, 5, 0, 3))
    rdm2.oovo += tmp25.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp25.transpose((2, 1, 3, 0))
    rdm2.ooov += tmp25.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp25.transpose((1, 2, 0, 3))
    tmp6 = einsum(tmp5, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -1
    tmp17 = t2.transpose((0, 1, 3, 2)).copy()
    tmp17 += t2 * -0.5
    tmp26 = einsum(t2, (0, 1, 2, 3), tmp2, (4, 1, 5, 2), (4, 5, 0, 3))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    tmp3 = einsum(tmp2, (0, 1, 2, 3), t1, (4, 3), (0, 1, 4, 2))
    rdm2.oooo += tmp3.transpose((3, 2, 1, 0))
    rdm2.oooo += tmp3.transpose((3, 2, 1, 0))
    tmp54 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp54 += l2.transpose((2, 3, 0, 1))
    tmp1 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 1, 0), (3, 2, 4, 5))
    rdm2.oooo += tmp1.transpose((3, 2, 1, 0))
    rdm2.oooo += tmp1.transpose((3, 2, 1, 0))
    tmp31 = einsum(tmp5, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    tmp113 = einsum(l2, (0, 1, 2, 3), t1, (3, 4), (2, 0, 1, 4))
    rdm2.vvvo = tmp113.transpose((2, 1, 3, 0)).copy()
    rdm2.vvvo += tmp113.transpose((1, 2, 3, 0)) * -1
    rdm2.vvvo += tmp113.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp113.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp113.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp113.transpose((1, 2, 3, 0)) * -1
    rdm2.vvov = tmp113.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.vvov += tmp113.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp113.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp113.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp113.transpose((2, 1, 0, 3)) * -1
    rdm2.vvov += tmp113.transpose((1, 2, 0, 3))
    tmp83 = einsum(l2, (0, 1, 2, 3), tmp5, (3, 2, 1, 4), (0, 4)) * 2
    tmp82 = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    tmp66 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 1, 5), (2, 4, 0, 5))
    rdm2.voov += tmp66.transpose((2, 1, 0, 3)) * -1
    rdm2.voov += tmp66.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo += tmp66.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp66.transpose((1, 2, 3, 0)) * -1
    tmp52 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    rdm2.voov += tmp52.transpose((2, 1, 0, 3))
    rdm2.voov += tmp52.transpose((2, 1, 0, 3))
    rdm2.ovvo += tmp52.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp52.transpose((1, 2, 3, 0))
    tmp107 = tmp87.copy()
    tmp107 += tmp95.transpose((1, 0, 3, 2))
    tmp107 += tmp93.transpose((1, 0, 3, 2)) * -1
    tmp96 = tmp93.transpose((1, 0, 3, 2)).copy()
    del tmp93
    tmp96 += tmp95.transpose((1, 0, 3, 2)) * -1
    del tmp95
    tmp104 = einsum(t2, (0, 1, 2, 3), tmp103, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp103
    tmp23 = einsum(tmp22, (0, 1, 2, 3), l1, (2, 0), (1, 3))
    del tmp22
    tmp21 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    rdm2.oovv = einsum(tmp21, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.oovv += einsum(tmp21, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    tmp46 = einsum(t2, (0, 1, 2, 3), tmp45, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp45
    tmp48 = tmp8.copy()
    tmp48 += tmp11
    tmp48 += tmp13 * -1
    tmp39 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp39 += t2 * -1
    tmp70 = tmp25.copy()
    del tmp25
    tmp70 += tmp13 * -1
    tmp62 = einsum(l2, (0, 1, 2, 3), tmp5, (3, 2, 1, 4), (0, 4))
    del tmp5
    tmp19 = einsum(tmp6, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    tmp18 = einsum(tmp2, (0, 1, 2, 3), tmp17, (0, 1, 4, 3), (2, 4))
    tmp73 = tmp8.copy()
    tmp73 += tmp26 * -1
    del tmp26
    tmp9 = einsum(tmp3, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp55 = einsum(t2, (0, 1, 2, 3), tmp54, (1, 4, 2, 5), (4, 0, 5, 3))
    rdm2.ovvo += tmp55.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp55.transpose((1, 2, 3, 0)) * -1
    tmp59 = t2.copy()
    tmp59 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp4 = tmp1.transpose((1, 0, 3, 2)).copy()
    tmp4 += tmp3
    rdm2.oooo += tmp4.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp4.transpose((3, 2, 0, 1)) * -1
    rdm2.oooo += tmp4.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp4.transpose((3, 2, 0, 1)) * -1
    tmp29 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp29 += t2 * 2
    tmp32 = tmp0.copy() * 0.5
    tmp32 += tmp31
    del tmp31
    tmp114 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    rdm2.vvvv = tmp114.transpose((1, 0, 3, 2)).copy()
    rdm2.vvvv += tmp114.transpose((1, 0, 3, 2))
    tmp115 = einsum(t1, (0, 1), tmp113, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp113
    rdm2.vvvv += tmp115.transpose((1, 0, 3, 2))
    rdm2.vvvv += tmp115.transpose((1, 0, 3, 2))
    tmp84 = tmp82.copy()
    tmp84 += tmp83
    del tmp83
    rdm2.ovvv = einsum(tmp84, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvv += einsum(tmp84, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(delta.oo, (0, 1), tmp84, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.voov += einsum(delta.oo, (0, 1), tmp84, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovov = einsum(delta.oo, (0, 1), tmp84, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp84, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp84, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp84, (2, 3), (0, 2, 1, 3))
    tmp99 = einsum(t2, (0, 1, 2, 3), tmp2, (0, 1, 4, 5), (4, 5, 2, 3))
    rdm2.vovv = tmp99.transpose((1, 0, 2, 3)).copy() * -1
    rdm2.vovv += tmp99.transpose((1, 0, 2, 3)) * -1
    rdm2.ovvv += tmp99.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp99.transpose((0, 1, 3, 2)) * -1
    tmp68 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 1, 5), (5, 0, 4, 3))
    rdm2.vovo = tmp68.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.vovo += tmp68.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp68.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp68.transpose((1, 2, 0, 3)) * -1
    tmp111 = tmp66.copy()
    tmp111 += tmp87
    tmp111 += tmp52 * -1
    tmp108 = einsum(tmp107, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp107
    tmp92 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    rdm2.vovv += tmp92.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp92.transpose((1, 0, 3, 2))
    rdm2.ovvv += tmp92
    rdm2.ovvv += tmp92
    tmp97 = einsum(tmp96, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp96
    tmp105 = tmp66.copy()
    tmp105 += tmp87
    tmp105 += tmp104 * -1
    del tmp104
    tmp88 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp88 += l2.transpose((2, 3, 0, 1)) * -1
    tmp77 = t2.transpose((0, 1, 3, 2)).copy()
    tmp77 += t2 * -1
    tmp80 = tmp2.copy() * -1
    tmp80 += tmp2.transpose((1, 0, 2, 3))
    tmp24 = tmp21.copy()
    tmp24 += tmp23 * -1
    del tmp23
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1))
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1))
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp46
    tmp49 = einsum(t1, (0, 1), tmp48, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp48
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp0, (1, 4), (4, 0, 2, 3))
    tmp40 = einsum(tmp39, (0, 1, 2, 3), l1, (3, 0), (1, 2))
    rdm2.oovo += einsum(tmp40, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovo += einsum(tmp40, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(tmp40, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovo += einsum(tmp40, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    tmp71 = einsum(tmp70, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp70
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (2, 4), (0, 1, 4, 3)) * 2
    tmp20 = tmp18.copy()
    tmp20 += tmp19
    del tmp19
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    tmp64 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 4), (2, 1, 4, 3))
    tmp74 = einsum(t1, (0, 1), tmp73, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp73
    tmp53 = einsum(t2, (0, 1, 2, 3), tmp52, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp52
    rdm2.oovv += tmp53 * 2
    rdm2.oovv += tmp53 * 2
    tmp51 = einsum(tmp9, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    rdm2.oovv += tmp51
    rdm2.oovv += tmp51
    tmp56 = einsum(t2, (0, 1, 2, 3), tmp55, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp55
    tmp58 = einsum(tmp3, (0, 1, 2, 3), t2, (0, 1, 4, 5), (3, 2, 5, 4))
    del tmp3
    rdm2.oovv += tmp58
    rdm2.oovv += tmp58
    tmp60 = einsum(tmp59, (0, 1, 2, 3), tmp1, (0, 1, 4, 5), (4, 5, 2, 3))
    del tmp59
    rdm2.oovv += tmp60.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp60.transpose((1, 0, 3, 2))
    tmp27 = einsum(tmp4, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp4
    rdm2.oovo += tmp27.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp27.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp27.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp27.transpose((2, 1, 0, 3))
    tmp41 = einsum(l1, (0, 1), tmp29, (1, 2, 0, 3), (2, 3)) * 0.5
    tmp42 = einsum(t1, (0, 1), tmp32, (0, 2), (2, 1))
    tmp28 = einsum(tmp2, (0, 1, 2, 3), tmp17, (0, 1, 4, 3), (2, 4)) * 2
    del tmp17
    tmp33 = einsum(t1, (0, 1), tmp32, (0, 2), (2, 1)) * 2
    del tmp32
    tmp15 = einsum(t1, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp1
    tmp30 = einsum(l1, (0, 1), tmp29, (1, 2, 0, 3), (2, 3))
    del tmp29
    tmp116 = tmp114.transpose((1, 0, 3, 2)).copy()
    del tmp114
    tmp116 += tmp115.transpose((1, 0, 3, 2))
    del tmp115
    rdm2.vvvv += tmp116
    rdm2.vvvv += tmp116.transpose((0, 1, 3, 2)) * -1
    rdm2.vvvv += tmp116
    rdm2.vvvv += tmp116.transpose((0, 1, 3, 2)) * -1
    del tmp116
    tmp110 = tmp99.copy()
    tmp110 += einsum(tmp84, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    del tmp84
    rdm2.vovv += tmp110.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp110.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp110.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp110.transpose((1, 0, 2, 3)) * -1
    del tmp110
    tmp102 = einsum(tmp68, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    rdm2.vovv += tmp102.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp102.transpose((1, 0, 3, 2)) * -1
    rdm2.ovvv += tmp102 * -1
    rdm2.ovvv += tmp102 * -1
    del tmp102
    tmp86 = tmp82.copy() * 0.5
    tmp86 += tmp62
    rdm2.vovv += einsum(t1, (0, 1), tmp86, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.vovv += einsum(t1, (0, 1), tmp86, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp86, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp86, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp86, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp86, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp86, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp86, (2, 3), (0, 2, 3, 1)) * -2
    del tmp86
    tmp112 = einsum(tmp111, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp111
    rdm2.vovv += tmp112.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp112.transpose((1, 0, 3, 2)) * -1
    del tmp112
    tmp109 = tmp92.copy()
    tmp109 += tmp108.transpose((0, 1, 3, 2))
    del tmp108
    rdm2.vovv += tmp109.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp109.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp109.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp109.transpose((1, 0, 2, 3)) * -1
    del tmp109
    tmp101 = einsum(tmp87, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp87
    rdm2.ovvv += tmp101.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp101
    rdm2.ovvv += tmp101.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp101
    del tmp101
    tmp98 = tmp92.copy()
    del tmp92
    tmp98 += einsum(tmp82, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    del tmp82
    tmp98 += tmp97.transpose((0, 1, 3, 2)) * -1
    del tmp97
    rdm2.ovvv += tmp98.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp98
    rdm2.ovvv += tmp98.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp98
    del tmp98
    tmp100 = tmp99.copy()
    del tmp99
    tmp100 += einsum(tmp62, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    del tmp62
    rdm2.ovvv += tmp100.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp100
    rdm2.ovvv += tmp100.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp100
    del tmp100
    tmp106 = einsum(tmp105, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp105
    rdm2.ovvv += tmp106 * -1
    rdm2.ovvv += tmp106 * -1
    del tmp106
    tmp91 = einsum(t2, (0, 1, 2, 3), tmp54, (1, 4, 5, 2), (4, 0, 5, 3))
    del tmp54
    rdm2.vovo += tmp91.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp91.transpose((2, 1, 3, 0)) * -1
    del tmp91
    tmp85 = einsum(t1, (0, 1), tmp2, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp2
    rdm2.vovo += tmp85.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp85.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp85.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp85.transpose((1, 2, 0, 3)) * -1
    del tmp85
    tmp89 = einsum(t2, (0, 1, 2, 3), tmp88, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp88
    rdm2.vovo += tmp89.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp89.transpose((2, 1, 3, 0)) * -1
    rdm2.ovvo += tmp89.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp89.transpose((1, 2, 3, 0))
    del tmp89
    tmp90 = einsum(t1, (0, 1), tmp10, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp10
    rdm2.vovo += tmp90.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp90.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp90.transpose((2, 1, 0, 3))
    rdm2.voov += tmp90.transpose((2, 1, 0, 3))
    del tmp90
    tmp78 = einsum(tmp77, (0, 1, 2, 3), l2, (4, 3, 0, 5), (1, 5, 2, 4))
    del tmp77
    rdm2.voov += tmp78.transpose((3, 0, 1, 2)) * -1
    rdm2.voov += tmp78.transpose((3, 0, 1, 2)) * -1
    rdm2.ovov += tmp78.transpose((0, 3, 1, 2))
    rdm2.ovov += tmp78.transpose((0, 3, 1, 2))
    del tmp78
    tmp79 = einsum(l2, (0, 1, 2, 3), tmp39, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp39
    rdm2.voov += tmp79.transpose((3, 0, 1, 2))
    rdm2.voov += tmp79.transpose((3, 0, 1, 2))
    rdm2.ovov += tmp79.transpose((0, 3, 1, 2)) * -1
    rdm2.ovov += tmp79.transpose((0, 3, 1, 2)) * -1
    del tmp79
    tmp81 = einsum(t1, (0, 1), tmp80, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp80
    rdm2.ovvo += tmp81.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp81.transpose((1, 2, 3, 0)) * -1
    rdm2.ovov += tmp81.transpose((1, 2, 0, 3))
    rdm2.ovov += tmp81.transpose((1, 2, 0, 3))
    del tmp81
    tmp50 = tmp44.copy()
    tmp50 += tmp47.transpose((1, 0, 3, 2)) * -1
    tmp50 += tmp49.transpose((0, 1, 3, 2))
    del tmp49
    tmp50 += einsum(t1, (0, 1), tmp24, (2, 3), (0, 2, 1, 3)) * -1
    del tmp24
    rdm2.oovv += tmp50.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp50.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp50.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp50
    rdm2.oovv += tmp50.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp50.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp50.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp50
    del tmp50
    tmp72 = tmp47.transpose((1, 0, 3, 2)).copy() * -1
    del tmp47
    tmp72 += tmp71.transpose((0, 1, 3, 2))
    del tmp71
    tmp72 += einsum(t1, (0, 1), tmp40, (2, 3), (0, 2, 1, 3))
    del tmp40
    rdm2.oovv += tmp72.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp72
    rdm2.oovv += tmp72.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp72
    del tmp72
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp68
    rdm2.oovv += tmp69.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp69.transpose((0, 1, 3, 2))
    del tmp69
    tmp65 = tmp63.transpose((1, 0, 3, 2)).copy()
    del tmp63
    tmp65 += tmp64.transpose((0, 1, 3, 2))
    del tmp64
    tmp65 += einsum(t1, (0, 1), tmp20, (2, 3), (0, 2, 1, 3)) * 2
    del tmp20
    rdm2.oovv += tmp65.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp65.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp65.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp65 * -1
    rdm2.oovv += tmp65.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp65 * -1
    rdm2.oovv += tmp65.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp65 * -1
    rdm2.oovv += tmp65.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp65.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp65.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp65 * -1
    del tmp65
    tmp76 = t1.copy()
    tmp76 += tmp21 * -1
    del tmp21
    rdm2.oovv += einsum(tmp76, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovv += einsum(tmp76, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    del tmp76
    tmp75 = tmp44.copy()
    del tmp44
    tmp75 += tmp74.transpose((0, 1, 3, 2))
    del tmp74
    rdm2.oovv += tmp75.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp75.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp75.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp75.transpose((0, 1, 3, 2)) * -1
    del tmp75
    tmp57 = tmp51.copy()
    del tmp51
    tmp57 += tmp53 * 2
    del tmp53
    tmp57 += tmp56.transpose((1, 0, 3, 2))
    del tmp56
    rdm2.oovv += tmp57.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp57
    rdm2.oovv += tmp57.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp57
    del tmp57
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp66
    rdm2.oovv += tmp67
    rdm2.oovv += tmp67
    del tmp67
    tmp61 = tmp58.copy()
    del tmp58
    tmp61 += tmp60.transpose((1, 0, 3, 2))
    del tmp60
    rdm2.oovv += tmp61.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp61
    rdm2.oovv += tmp61.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp61
    del tmp61
    tmp37 = einsum(t1, (0, 1), tmp0, (2, 3), (2, 0, 3, 1))
    tmp37 += tmp11
    tmp37 += tmp13 * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    del tmp37
    tmp36 = tmp8.copy()
    tmp36 += tmp27.transpose((0, 2, 1, 3))
    del tmp27
    tmp36 += einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    rdm2.oovo += tmp36.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp36.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp36.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp36.transpose((1, 2, 3, 0)) * -1
    del tmp36
    tmp35 = tmp0.copy()
    tmp35 += tmp6
    rdm2.oovo += einsum(tmp35, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oovo += einsum(tmp35, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.ooov += einsum(tmp35, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.ooov += einsum(tmp35, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -1
    del tmp35
    tmp43 = t1.copy() * -0.5
    tmp43 += tmp18
    del tmp18
    tmp43 += tmp41 * -1
    del tmp41
    tmp43 += tmp42
    del tmp42
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp43, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp43, (2, 3), (2, 0, 3, 1)) * -2
    del tmp43
    tmp38 = tmp28.copy()
    tmp38 += tmp33
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3))
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3))
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    del tmp38
    tmp14 = tmp8.copy()
    del tmp8
    tmp14 += tmp9
    del tmp9
    tmp14 += tmp11
    del tmp11
    tmp14 += tmp13 * -1
    del tmp13
    rdm2.ooov += tmp14.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp14.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp14.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp14.transpose((1, 2, 0, 3))
    del tmp14
    tmp16 = tmp15.copy()
    del tmp15
    tmp16 += einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    del tmp6
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((1, 2, 0, 3))
    del tmp16
    tmp34 = t1.copy() * -1
    tmp34 += tmp28
    del tmp28
    tmp34 += tmp30 * -1
    del tmp30
    tmp34 += tmp33
    del tmp33
    rdm2.ooov += einsum(tmp34, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp34, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    del tmp34
    tmp7 = delta.oo.copy()
    tmp7 += tmp0 * -1
    del tmp0
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3))
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3))
    del tmp7
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    del delta
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovv += t2
    rdm2.oovv += t2
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vvoo = l2.transpose((0, 1, 3, 2)).copy() * -1
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2.transpose((0, 1, 3, 2)) * -1
    rdm2.vvoo += l2
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = rdm2.swapaxes(1, 2)

    return rdm2

