"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:46:19.383885
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:46:20.523835.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp3 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp1 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp1 += t2 * 2
    tmp4 = f.ov.copy()
    tmp4 += einsum(v.xov, (0, 1, 2), tmp3, (1, 3, 0), (3, 2)) * -0.5
    del tmp3
    e_cc = einsum(tmp4, (0, 1), t1, (0, 1), ()) * 2
    del tmp4
    tmp2 = einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0))
    del tmp0
    tmp2 += einsum(v.xov, (0, 1, 2), tmp1, (1, 3, 2, 4), (3, 4, 0)) * 0.5
    del tmp1
    e_cc += einsum(v.xov, (0, 1, 2), tmp2, (1, 2, 0), ()) * 2
    del tmp2

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:47:00.413803.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp27 = t2.copy()
    tmp27 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp35 = einsum(v.xoo, (0, 1, 2), v.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp9 = einsum(tmp2, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp1 = einsum(tmp0, (0,), v.xov, (0, 1, 2), (1, 2))
    t1new = tmp1.copy() * 2
    tmp38 = einsum(v.xov, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 4, 2))
    tmp18 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    t2new = einsum(tmp18, (0, 1, 2), tmp18, (3, 4, 2), (3, 0, 4, 1))
    tmp13 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp13 += t2 * 2
    tmp11 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp11 += t2 * 2
    tmp28 = einsum(v.xov, (0, 1, 2), tmp27, (1, 3, 4, 2), (3, 4, 0))
    del tmp27
    tmp63 = tmp35.transpose((1, 0, 2, 3)).copy() * 2
    tmp63 += tmp35.transpose((1, 2, 0, 3)) * -1
    tmp65 = tmp1.copy() * 2
    tmp65 += tmp9 * -1
    tmp39 = tmp38.copy() * -1
    tmp39 += tmp38.transpose((0, 2, 1, 3)) * 2
    tmp21 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    t2new += einsum(tmp21, (0, 1, 2), tmp21, (3, 4, 2), (3, 0, 4, 1))
    tmp19 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    t2new += tmp19.transpose((1, 0, 3, 2))
    tmp23 = v.xov.transpose((1, 2, 0)).copy()
    tmp23 += tmp18 * -1
    tmp14 = einsum(v.xov, (0, 1, 2), tmp13, (1, 3, 2, 4), (3, 4, 0))
    del tmp13
    tmp47 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp59 = einsum(v.xov, (0, 1, 2), tmp11, (1, 3, 2, 4), (3, 4, 0))
    tmp6 = einsum(v.xoo, (0, 1, 2), t1, (2, 3), (1, 3, 0))
    tmp67 = einsum(v.xoo, (0, 1, 2), tmp28, (3, 4, 0), (3, 1, 2, 4))
    tmp64 = einsum(t2, (0, 1, 2, 3), tmp63, (4, 5, 1, 3), (4, 5, 0, 2))
    del tmp63
    tmp66 = einsum(tmp65, (0, 1), t2, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp62 = einsum(tmp38, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    del tmp38
    tmp12 = einsum(tmp0, (0,), v.xoo, (0, 1, 2), (1, 2))
    tmp43 = einsum(tmp2, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp36 = einsum(tmp35, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    del tmp35
    tmp37 = einsum(tmp18, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    del tmp18
    tmp40 = einsum(t2, (0, 1, 2, 3), tmp39, (4, 5, 1, 3), (4, 5, 0, 2))
    del tmp39
    tmp31 = einsum(tmp0, (0,), v.xvv, (0, 1, 2), (1, 2))
    tmp32 = einsum(tmp21, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp20 = einsum(t2, (0, 1, 2, 3), tmp19, (1, 4, 5, 2), (0, 4, 3, 5))
    t2new += einsum(t2, (0, 1, 2, 3), tmp20, (4, 1, 5, 2), (4, 0, 3, 5))
    tmp24 = einsum(v.xov, (0, 1, 2), tmp23, (3, 4, 0), (3, 1, 4, 2))
    del tmp23
    tmp22 = einsum(v.xoo, (0, 1, 2), v.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp52 = einsum(v.xov, (0, 1, 2), tmp14, (3, 2, 0), (3, 1))
    tmp50 = einsum(v.xov, (0, 1, 2), tmp14, (1, 3, 0), (3, 2)) * 0.5
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 0, 1))
    del tmp47
    tmp85 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp86 = einsum(tmp2, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    tmp57 = einsum(v.xvv, (0, 1, 2), tmp2, (3, 4, 0), (3, 4, 1, 2))
    tmp60 = v.xov.transpose((1, 2, 0)).copy()
    tmp60 += tmp6 * -1
    tmp60 += tmp59
    del tmp59
    tmp70 = einsum(tmp65, (0, 1), t1, (2, 1), (0, 2))
    del tmp65
    tmp68 = tmp62.transpose((0, 2, 1, 3)).copy()
    del tmp62
    tmp68 += tmp64.transpose((2, 1, 0, 3)) * -1
    del tmp64
    tmp68 += tmp66.transpose((2, 0, 1, 3)) * -1
    del tmp66
    tmp68 += tmp67.transpose((0, 2, 1, 3))
    del tmp67
    tmp82 = einsum(tmp2, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp78 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp80 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp75 = einsum(tmp21, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    tmp44 = tmp43.transpose((1, 0)).copy() * -1
    del tmp43
    tmp44 += tmp12.transpose((1, 0)) * 2
    tmp41 = tmp36.copy()
    del tmp36
    tmp41 += tmp37
    del tmp37
    tmp41 += tmp40.transpose((0, 2, 1, 3)) * -1
    del tmp40
    tmp29 = tmp6.copy()
    tmp29 += tmp28
    del tmp28
    tmp33 = tmp31.transpose((1, 0)).copy() * 2
    del tmp31
    tmp33 += tmp32 * -1
    del tmp32
    tmp25 = tmp22.transpose((1, 0, 3, 2)).copy()
    tmp25 += tmp20 * -1
    del tmp20
    tmp25 += tmp24 * -2
    del tmp24
    tmp53 = einsum(tmp52, (0, 1), t2, (2, 1, 3, 4), (0, 2, 4, 3))
    del tmp52
    tmp51 = einsum(t2, (0, 1, 2, 3), tmp50, (4, 2), (0, 1, 4, 3)) * 2
    del tmp50
    tmp49 = einsum(t1, (0, 1), tmp48, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp48
    tmp92 = tmp85.transpose((3, 2, 1, 0)).copy()
    tmp92 += tmp86.transpose((2, 1, 3, 0))
    tmp90 = tmp19.transpose((1, 0, 2, 3)).copy() * 2
    tmp90 += tmp19.transpose((1, 0, 3, 2)) * -1
    tmp58 = einsum(tmp57, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp61 = einsum(tmp21, (0, 1, 2), tmp60, (3, 4, 2), (3, 0, 4, 1))
    del tmp21, tmp60
    tmp56 = einsum(t2, (0, 1, 2, 3), tmp22, (4, 1, 5, 2), (0, 4, 3, 5))
    del tmp22
    tmp71 = einsum(tmp70, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp70
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp68
    tmp55 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp88 = einsum(tmp19, (0, 1, 2, 3), t1, (1, 4), (0, 4, 2, 3))
    tmp83 = einsum(t2, (0, 1, 2, 3), tmp82, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp82
    tmp79 = einsum(tmp78, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    del tmp78
    tmp81 = einsum(t1, (0, 1), tmp80, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp80
    tmp76 = einsum(t1, (0, 1), tmp75, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp75
    tmp74 = einsum(tmp57, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 4, 5, 2))
    del tmp57
    tmp45 = einsum(tmp44, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp44
    tmp42 = einsum(t1, (0, 1), tmp41, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp41
    tmp30 = einsum(v.xov, (0, 1, 2), tmp29, (3, 4, 0), (3, 1, 4, 2))
    del tmp29
    tmp34 = einsum(t2, (0, 1, 2, 3), tmp33, (2, 4), (0, 1, 4, 3))
    del tmp33
    tmp26 = einsum(t2, (0, 1, 2, 3), tmp25, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp25
    tmp16 = f.ov.copy()
    tmp16 += tmp9 * -1
    tmp15 = tmp6.copy() * -1
    tmp15 += einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0)) * 2
    tmp15 += tmp14
    del tmp14
    tmp3 = v.xoo.transpose((1, 2, 0)).copy()
    tmp3 += tmp2.transpose((1, 0, 2))
    del tmp2
    tmp7 = einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 0.5
    tmp7 += t2.transpose((0, 1, 3, 2)) * -1
    tmp7 += t2 * 0.5
    tmp54 = tmp49.copy()
    del tmp49
    tmp54 += tmp51.transpose((1, 0, 3, 2))
    del tmp51
    tmp54 += tmp53.transpose((1, 0, 3, 2))
    del tmp53
    t2new += tmp54.transpose((1, 0, 3, 2)) * -1
    t2new += tmp54 * -1
    del tmp54
    tmp93 = einsum(tmp92, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    del tmp92
    t2new += einsum(t1, (0, 1), tmp93, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp93
    tmp91 = einsum(t2, (0, 1, 2, 3), tmp90, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp90
    t2new += einsum(t2, (0, 1, 2, 3), tmp91, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp91
    tmp72 = tmp55.copy()
    del tmp55
    tmp72 += tmp56 * -1
    del tmp56
    tmp72 += tmp58 * -1
    del tmp58
    tmp72 += tmp61.transpose((1, 0, 2, 3))
    del tmp61
    tmp72 += tmp69.transpose((0, 1, 3, 2))
    del tmp69
    tmp72 += tmp71.transpose((0, 1, 3, 2)) * -1
    del tmp71
    t2new += tmp72.transpose((1, 0, 2, 3))
    t2new += tmp72.transpose((0, 1, 3, 2))
    del tmp72
    tmp87 = tmp85.transpose((3, 2, 1, 0)).copy()
    del tmp85
    tmp87 += einsum(t2, (0, 1, 2, 3), tmp19, (4, 5, 3, 2), (4, 0, 5, 1))
    del tmp19
    tmp87 += tmp86.transpose((2, 1, 3, 0))
    del tmp86
    t2new += einsum(t2, (0, 1, 2, 3), tmp87, (0, 4, 1, 5), (4, 5, 3, 2))
    del tmp87
    tmp89 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp89 += einsum(tmp88, (0, 1, 2, 3), t1, (0, 4), (3, 2, 4, 1))
    del tmp88
    t2new += einsum(t2, (0, 1, 2, 3), tmp89, (2, 3, 4, 5), (0, 1, 5, 4))
    del tmp89
    tmp84 = tmp79.copy()
    del tmp79
    tmp84 += tmp81
    del tmp81
    tmp84 += tmp83 * -1
    del tmp83
    t2new += tmp84.transpose((1, 0, 2, 3)) * -1
    t2new += tmp84.transpose((0, 1, 3, 2)) * -1
    del tmp84
    tmp73 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    t2new += tmp73.transpose((1, 0, 2, 3)) * -1
    t2new += tmp73.transpose((0, 1, 3, 2)) * -1
    del tmp73
    tmp77 = tmp74.copy()
    del tmp74
    tmp77 += tmp76
    del tmp76
    t2new += tmp77.transpose((1, 0, 3, 2)) * -1
    t2new += tmp77 * -1
    del tmp77
    tmp46 = tmp26.transpose((1, 0, 3, 2)).copy()
    del tmp26
    tmp46 += tmp30
    del tmp30
    tmp46 += tmp34.transpose((1, 0, 3, 2)) * -1
    del tmp34
    tmp46 += tmp42.transpose((0, 1, 3, 2)) * -1
    del tmp42
    tmp46 += tmp45.transpose((1, 0, 3, 2))
    del tmp45
    t2new += tmp46.transpose((1, 0, 3, 2)) * -1
    t2new += tmp46 * -1
    del tmp46
    tmp17 = f.oo.copy()
    tmp17 += tmp12.transpose((1, 0)) * 2
    del tmp12
    tmp17 += einsum(tmp15, (0, 1, 2), v.xov, (2, 3, 1), (3, 0))
    del tmp15
    tmp17 += einsum(tmp16, (0, 1), t1, (2, 1), (0, 2))
    del tmp16
    t1new += einsum(tmp17, (0, 1), t1, (0, 2), (1, 2)) * -1
    del tmp17
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp5 += t2 * -1
    tmp4 = einsum(tmp3, (0, 1, 2), v.xov, (2, 3, 4), (1, 3, 0, 4))
    del tmp3
    t1new += einsum(tmp5, (0, 1, 2, 3), tmp4, (4, 0, 1, 3), (4, 2)) * -1
    del tmp5, tmp4
    tmp8 = tmp6.copy()
    del tmp6
    tmp8 += einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0)) * -2
    del tmp0
    tmp8 += einsum(v.xov, (0, 1, 2), tmp7, (1, 3, 4, 2), (3, 4, 0)) * 2
    del tmp7
    t1new += einsum(v.xvv, (0, 1, 2), tmp8, (3, 2, 0), (3, 1)) * -1
    del tmp8
    tmp10 = f.ov.copy()
    tmp10 += tmp1 * 2
    del tmp1
    tmp10 += tmp9 * -1
    del tmp9
    t1new += einsum(tmp10, (0, 1), tmp11, (0, 2, 1, 3), (2, 3))
    del tmp11, tmp10
    t1new += f.ov
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:48:16.880175.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp11 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp9 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp79 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp79 += t2 * 2
    tmp18 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp18 += t2 * 2
    tmp12 = einsum(v.xov, (0, 1, 2), tmp11, (1, 3, 0), (3, 2))
    tmp10 = einsum(tmp9, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp34 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp0 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp80 = einsum(tmp79, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4))
    del tmp79
    tmp17 = t2.transpose((0, 1, 3, 2)).copy()
    tmp17 += t2 * -0.5
    tmp75 = v.xoo.transpose((1, 2, 0)).copy()
    tmp75 += tmp11.transpose((1, 0, 2))
    tmp5 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    l2new = tmp5.transpose((3, 2, 1, 0)).copy()
    tmp19 = einsum(tmp18, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4))
    tmp89 = tmp10.copy() * 2
    tmp89 += tmp12 * -1
    tmp84 = tmp34.copy() * -1
    tmp84 += tmp34.transpose((1, 0, 2, 3)) * 2
    tmp82 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp82 += l2.transpose((2, 3, 0, 1)) * 2
    tmp81 = v.xov.transpose((1, 2, 0)).copy()
    tmp81 += tmp0
    tmp81 += tmp80
    del tmp80
    tmp73 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp73 += t2 * -1
    tmp48 = einsum(l2, (0, 1, 2, 3), tmp17, (2, 4, 1, 0), (3, 4))
    tmp47 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp76 = einsum(v.xvv, (0, 1, 2), tmp75, (3, 4, 0), (3, 4, 1, 2))
    del tmp75
    tmp104 = einsum(tmp5, (0, 1, 2, 3), t2, (4, 1, 2, 5), (4, 0, 5, 3))
    tmp116 = einsum(v.xov, (0, 1, 2), tmp19, (3, 2, 0), (1, 3)) * 0.5
    tmp58 = einsum(v.xoo, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp90 = einsum(tmp89, (0, 1), t1, (2, 1), (2, 0))
    tmp59 = einsum(tmp11, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp85 = einsum(tmp84, (0, 1, 2, 3), v.xoo, (4, 0, 2), (1, 3, 4))
    tmp83 = einsum(tmp81, (0, 1, 2), tmp82, (0, 3, 1, 4), (3, 4, 2))
    del tmp81, tmp82
    tmp86 = einsum(tmp84, (0, 1, 2, 3), tmp11, (0, 2, 4), (1, 3, 4))
    del tmp84
    tmp74 = einsum(tmp73, (0, 1, 2, 3), tmp5, (0, 4, 5, 3), (4, 1, 5, 2))
    del tmp73
    tmp49 = tmp47.copy() * 0.5
    tmp49 += tmp48
    del tmp48
    tmp37 = einsum(tmp17, (0, 1, 2, 3), l2, (4, 2, 0, 1), (4, 3)) * 2
    tmp53 = einsum(l2, (0, 1, 2, 3), tmp17, (2, 4, 1, 0), (3, 4)) * 2
    tmp26 = einsum(tmp11, (0, 1, 2), tmp11, (3, 4, 2), (0, 3, 1, 4))
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp3 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp65 = einsum(v.xoo, (0, 1, 2), v.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp122 = einsum(tmp0, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp96 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp22 = einsum(tmp11, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp71 = einsum(tmp11, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp105 = tmp104.copy() * -1
    del tmp104
    tmp105 += tmp76.transpose((1, 0, 3, 2))
    tmp99 = einsum(l1, (0, 1), v.xvv, (2, 3, 0), (1, 3, 2))
    tmp114 = einsum(v.xov, (0, 1, 2), tmp19, (1, 3, 0), (2, 3)) * 0.5
    tmp117 = tmp58.transpose((1, 0)).copy()
    tmp117 += tmp116.transpose((1, 0))
    del tmp116
    tmp62 = einsum(v.xvv, (0, 1, 2), tmp9, (0,), (1, 2))
    del tmp9
    tmp91 = tmp59.copy()
    tmp91 += tmp90 * -1
    del tmp90
    tmp87 = tmp83.copy() * -1
    del tmp83
    tmp87 += tmp85
    del tmp85
    tmp87 += tmp86
    del tmp86
    tmp69 = einsum(l2, (0, 1, 2, 3), t2, (4, 2, 5, 1), (3, 4, 0, 5))
    tmp77 = tmp74.transpose((1, 0, 3, 2)).copy()
    del tmp74
    tmp77 += tmp76.transpose((1, 0, 3, 2))
    del tmp76
    tmp109 = einsum(tmp49, (0, 1), v.xov, (2, 1, 3), (0, 3, 2)) * 2
    tmp111 = einsum(tmp37, (0, 1), v.xov, (2, 3, 1), (3, 0, 2)) * 0.5
    tmp54 = tmp47.copy()
    del tmp47
    tmp54 += tmp53
    del tmp53
    tmp29 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp29 += t2
    tmp42 = tmp34.copy() * 2
    tmp42 += tmp34.transpose((1, 0, 2, 3)) * -1
    tmp36 = tmp34.copy() * -0.5
    tmp36 += tmp34.transpose((1, 0, 2, 3))
    tmp41 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp45 = einsum(tmp34, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp44 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp21 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp27 = einsum(t1, (0, 1), tmp26, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp25 = einsum(tmp0, (0, 1, 2), tmp11, (3, 4, 2), (3, 0, 4, 1))
    tmp15 = v.xoo.transpose((1, 2, 0)).copy()
    tmp15 += tmp11.transpose((1, 0, 2))
    tmp13 = tmp10.copy() * 2
    tmp13 += tmp12 * -1
    tmp7 = einsum(t1, (0, 1), tmp6, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp4 = einsum(tmp3, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 0, 1))
    tmp121 = einsum(tmp65, (0, 1, 2, 3), l1, (4, 1), (0, 2, 4, 3))
    tmp123 = einsum(tmp122, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp122
    tmp95 = einsum(f.vv, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp97 = einsum(l2, (0, 1, 2, 3), tmp96, (4, 3), (4, 2, 0, 1))
    del tmp96
    tmp102 = einsum(tmp34, (0, 1, 2, 3), tmp65, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp101 = einsum(tmp22, (0, 1, 2, 3), l2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp103 = einsum(tmp34, (0, 1, 2, 3), tmp71, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp98 = einsum(tmp34, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp106 = einsum(tmp105, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp105
    tmp100 = einsum(v.xov, (0, 1, 2), tmp99, (3, 4, 0), (3, 1, 2, 4))
    del tmp99
    tmp115 = einsum(tmp114, (0, 1), l2, (2, 1, 3, 4), (4, 3, 2, 0)) * 2
    del tmp114
    tmp118 = einsum(l2, (0, 1, 2, 3), tmp117, (2, 4), (3, 4, 0, 1)) * 2
    del tmp117
    tmp67 = einsum(tmp62, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    tmp93 = einsum(tmp34, (0, 1, 2, 3), tmp89, (2, 4), (0, 1, 3, 4))
    tmp92 = einsum(tmp91, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del tmp91
    tmp68 = einsum(tmp3, (0, 1, 2, 3), tmp34, (4, 5, 0, 2), (5, 4, 3, 1))
    del tmp3
    tmp88 = einsum(tmp87, (0, 1, 2), v.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp87
    tmp72 = einsum(tmp71, (0, 1, 2, 3), tmp34, (4, 0, 1, 5), (4, 2, 5, 3))
    tmp70 = einsum(tmp5, (0, 1, 2, 3), tmp69, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp69
    tmp78 = einsum(l2, (0, 1, 2, 3), tmp77, (3, 4, 1, 5), (2, 4, 0, 5))
    del tmp77
    tmp66 = einsum(tmp65, (0, 1, 2, 3), tmp34, (4, 1, 2, 5), (4, 0, 5, 3))
    del tmp65
    tmp110 = einsum(v.xov, (0, 1, 2), tmp109, (3, 4, 0), (1, 3, 2, 4))
    del tmp109
    tmp108 = einsum(l1, (0, 1), tmp71, (1, 2, 3, 4), (2, 3, 0, 4))
    del tmp71
    tmp112 = einsum(tmp111, (0, 1, 2), v.xov, (2, 3, 4), (3, 0, 4, 1)) * 2
    del tmp111
    tmp33 = l2.transpose((3, 2, 0, 1)).copy() * -0.5
    tmp33 += l2.transpose((2, 3, 0, 1))
    tmp35 = tmp34.copy() * -1
    tmp35 += tmp34.transpose((1, 0, 2, 3)) * 2
    tmp38 = v.xoo.transpose((1, 2, 0)).copy()
    tmp38 += tmp11
    tmp32 = v.xov.transpose((1, 2, 0)).copy()
    tmp32 += tmp0
    tmp32 += tmp19
    tmp60 = f.ov.copy()
    tmp60 += tmp10 * 2
    tmp60 += tmp12 * -1
    tmp55 = l1.transpose((1, 0)).copy()
    tmp55 += t1
    tmp55 += einsum(tmp34, (0, 1, 2, 3), tmp18, (1, 0, 4, 3), (2, 4)) * -1
    tmp55 += einsum(tmp29, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * 2
    tmp55 += einsum(tmp54, (0, 1), t1, (0, 2), (1, 2)) * -1
    tmp52 = einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 0.5
    tmp52 += einsum(tmp17, (0, 1, 2, 3), l2, (4, 2, 0, 1), (4, 3))
    tmp40 = einsum(tmp18, (0, 1, 2, 3), l2, (4, 3, 0, 5), (5, 1, 4, 2))
    tmp40 += einsum(l2, (0, 1, 2, 3), tmp17, (3, 4, 5, 1), (2, 4, 0, 5)) * 2
    tmp50 = t1.copy() * -0.5
    tmp50 += einsum(tmp29, (0, 1, 2, 3), tmp34, (1, 0, 4, 3), (4, 2))
    del tmp34
    tmp50 += einsum(tmp18, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * -0.5
    del tmp18
    tmp50 += einsum(tmp49, (0, 1), t1, (0, 2), (1, 2))
    tmp43 = tmp41.copy() * -1
    tmp43 += tmp41.transpose((0, 2, 1, 3)) * 0.5
    del tmp41
    tmp43 += einsum(tmp42, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 2, 4, 5)) * 0.5
    del tmp42
    tmp43 += einsum(tmp36, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp46 = tmp44.transpose((1, 0, 2, 3)).copy() * 2
    tmp46 += tmp44.transpose((1, 0, 3, 2)) * -1
    tmp46 += tmp45 * -1
    tmp46 += tmp45.transpose((0, 1, 3, 2)) * 2
    tmp1 = einsum(tmp0, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp20 = v.xov.transpose((1, 2, 0)).copy()
    tmp20 += tmp19
    tmp30 = tmp21.transpose((3, 2, 1, 0)).copy()
    tmp30 += tmp22.transpose((1, 0, 3, 2))
    tmp30 += tmp22.transpose((3, 0, 2, 1)) * -0.5
    tmp28 = tmp25.copy() * 2
    del tmp25
    tmp28 += tmp27 * -2
    del tmp27
    tmp16 = einsum(tmp15, (0, 1, 2), v.xov, (2, 3, 4), (3, 0, 1, 4))
    tmp14 = einsum(t2, (0, 1, 2, 3), tmp13, (4, 2), (0, 1, 4, 3))
    del tmp13
    tmp23 = tmp21.transpose((3, 2, 1, 0)).copy()
    tmp23 += tmp22.transpose((1, 0, 3, 2))
    tmp23 += tmp22.transpose((3, 0, 2, 1)) * -2
    del tmp22
    tmp2 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp8 = tmp4.copy() * 0.5
    del tmp4
    tmp8 += tmp7 * -0.5
    del tmp7
    tmp126 = tmp44.transpose((1, 0, 3, 2)).copy()
    del tmp44
    tmp126 += tmp45
    del tmp45
    l2new += einsum(tmp126, (0, 1, 2, 3), tmp5, (2, 3, 4, 5), (5, 4, 1, 0))
    del tmp5, tmp126
    tmp124 = tmp121.copy()
    del tmp121
    tmp124 += tmp123
    del tmp123
    l2new += tmp124.transpose((3, 2, 1, 0)) * -1
    l2new += tmp124.transpose((2, 3, 0, 1)) * -1
    del tmp124
    tmp107 = tmp95.copy()
    del tmp95
    tmp107 += tmp97 * -1
    del tmp97
    tmp107 += tmp98 * -1
    del tmp98
    tmp107 += tmp100
    del tmp100
    tmp107 += tmp101
    del tmp101
    tmp107 += tmp102
    del tmp102
    tmp107 += tmp103
    del tmp103
    tmp107 += tmp106 * -1
    del tmp106
    l2new += tmp107.transpose((2, 3, 1, 0))
    l2new += tmp107.transpose((3, 2, 0, 1))
    del tmp107
    tmp119 = tmp115.transpose((1, 0, 2, 3)).copy()
    del tmp115
    tmp119 += tmp118.transpose((0, 1, 3, 2))
    del tmp118
    l2new += tmp119.transpose((3, 2, 1, 0)) * -1
    l2new += tmp119.transpose((2, 3, 0, 1)) * -1
    del tmp119
    tmp94 = einsum(f.ov, (0, 1), l1, (2, 3), (0, 3, 1, 2))
    tmp94 += tmp66
    del tmp66
    tmp94 += tmp67 * 2
    del tmp67
    tmp94 += tmp68 * -1
    del tmp68
    tmp94 += tmp70
    del tmp70
    tmp94 += tmp72
    del tmp72
    tmp94 += tmp78 * -1
    del tmp78
    tmp94 += tmp88.transpose((1, 0, 3, 2)) * -1
    del tmp88
    tmp94 += tmp92.transpose((0, 1, 3, 2))
    del tmp92
    tmp94 += tmp93 * -1
    del tmp93
    tmp94 += einsum(l1, (0, 1), tmp89, (2, 3), (1, 2, 0, 3))
    del tmp89
    l2new += tmp94.transpose((3, 2, 1, 0))
    l2new += tmp94.transpose((2, 3, 0, 1))
    del tmp94
    tmp125 = tmp21.transpose((3, 2, 1, 0)).copy()
    del tmp21
    tmp125 += tmp6.transpose((0, 3, 1, 2))
    del tmp6
    tmp125 += tmp26.transpose((0, 3, 1, 2))
    del tmp26
    l2new += einsum(l2, (0, 1, 2, 3), tmp125, (3, 4, 2, 5), (0, 1, 4, 5))
    del tmp125
    tmp120 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    l2new += tmp120.transpose((2, 3, 1, 0)) * -1
    l2new += tmp120.transpose((3, 2, 0, 1)) * -1
    del tmp120
    tmp113 = tmp108.copy()
    del tmp108
    tmp113 += tmp110.transpose((1, 0, 2, 3))
    del tmp110
    tmp113 += tmp112.transpose((0, 1, 3, 2))
    del tmp112
    l2new += tmp113.transpose((2, 3, 1, 0)) * -1
    l2new += tmp113.transpose((3, 2, 0, 1)) * -1
    del tmp113
    tmp64 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (3, 1, 2, 4))
    l2new += einsum(tmp64, (0, 1, 2, 3), l2, (3, 2, 4, 5), (0, 1, 4, 5))
    del tmp64
    tmp39 = einsum(tmp33, (0, 1, 2, 3), tmp32, (0, 2, 4), (1, 3, 4)) * -2
    del tmp33
    tmp39 += einsum(v.xoo, (0, 1, 2), tmp35, (1, 3, 2, 4), (3, 4, 0))
    del tmp35
    tmp39 += einsum(tmp36, (0, 1, 2, 3), tmp11, (0, 2, 4), (1, 3, 4)) * 2
    tmp39 += einsum(tmp37, (0, 1), v.xov, (2, 3, 1), (3, 0, 2))
    del tmp37
    tmp39 += einsum(tmp38, (0, 1, 2), l1, (3, 0), (1, 3, 2))
    del tmp38
    l1new = einsum(v.xvv, (0, 1, 2), tmp39, (3, 2, 0), (1, 3)) * -1
    del tmp39
    tmp63 = f.vv.copy()
    tmp63 += tmp62.transpose((1, 0)) * 2
    del tmp62
    l1new += einsum(l1, (0, 1), tmp63, (0, 2), (2, 1))
    del tmp63
    tmp61 = f.oo.copy()
    tmp61 += tmp58.transpose((1, 0)) * 2
    del tmp58
    tmp61 += tmp59 * -1
    del tmp59
    tmp61 += einsum(v.xov, (0, 1, 2), tmp19, (3, 2, 0), (3, 1))
    del tmp19
    tmp61 += einsum(t1, (0, 1), tmp60, (2, 1), (0, 2))
    del tmp60
    l1new += einsum(tmp61, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp61
    tmp56 = einsum(v.xvv, (0, 1, 2), tmp52, (2, 1), (0,))
    del tmp52
    tmp56 += einsum(tmp55, (0, 1), v.xov, (2, 0, 1), (2,)) * 0.5
    del tmp55
    tmp56 += einsum(v.xoo, (0, 1, 2), tmp54, (2, 1), (0,)) * -0.5
    del tmp54
    l1new += einsum(tmp56, (0,), v.xov, (0, 1, 2), (2, 1)) * 4
    del tmp56
    tmp57 = f.ov.copy() * 0.5
    tmp57 += tmp10
    del tmp10
    tmp57 += tmp12 * -0.5
    del tmp12
    l1new += einsum(tmp57, (0, 1), tmp49, (2, 0), (1, 2)) * -4
    del tmp57
    tmp51 = einsum(tmp0, (0, 1, 2), l1, (1, 3), (0, 3, 2)) * -1
    del tmp0
    tmp51 += einsum(v.xvv, (0, 1, 2), tmp40, (3, 4, 2, 1), (4, 3, 0)) * -1
    del tmp40
    tmp51 += einsum(tmp36, (0, 1, 2, 3), tmp32, (1, 3, 4), (2, 0, 4)) * -2
    del tmp36, tmp32
    tmp51 += einsum(v.xov, (0, 1, 2), tmp43, (3, 1, 4, 2), (4, 3, 0)) * 2
    del tmp43
    tmp51 += einsum(tmp46, (0, 1, 2, 3), tmp11, (0, 3, 4), (2, 1, 4))
    del tmp11
    tmp51 += einsum(tmp46, (0, 1, 2, 3), v.xoo, (4, 0, 3), (2, 1, 4))
    del tmp46
    tmp51 += einsum(v.xov, (0, 1, 2), tmp50, (3, 2), (3, 1, 0)) * 2
    del tmp50
    tmp51 += einsum(tmp49, (0, 1), v.xoo, (2, 3, 0), (1, 3, 2)) * 2
    del tmp49
    l1new += einsum(tmp51, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    del tmp51
    tmp31 = tmp1.transpose((0, 2, 1, 3)).copy()
    tmp31 += tmp28.transpose((0, 2, 1, 3)) * -1
    tmp31 += tmp28.transpose((1, 2, 0, 3)) * 0.5
    del tmp28
    tmp31 += einsum(tmp29, (0, 1, 2, 3), tmp16, (4, 0, 5, 2), (5, 4, 1, 3)) * 2
    del tmp29
    tmp31 += einsum(tmp20, (0, 1, 2), tmp15, (3, 4, 2), (4, 3, 0, 1)) * -2
    tmp31 += einsum(tmp30, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4)) * 2
    del tmp30
    l1new += einsum(l2, (0, 1, 2, 3), tmp31, (2, 4, 3, 1), (0, 4))
    del tmp31
    tmp24 = tmp1.transpose((0, 2, 1, 3)).copy() * -1
    del tmp1
    tmp24 += tmp2.transpose((1, 0, 2, 3)) * -1
    tmp24 += tmp2.transpose((2, 0, 1, 3)) * 0.5
    del tmp2
    tmp24 += tmp8.transpose((0, 2, 1, 3))
    tmp24 += tmp8.transpose((1, 2, 0, 3)) * -2
    del tmp8
    tmp24 += tmp14.transpose((1, 2, 0, 3)) * -1
    tmp24 += tmp14.transpose((0, 2, 1, 3)) * 0.5
    del tmp14
    tmp24 += einsum(tmp16, (0, 1, 2, 3), tmp17, (1, 4, 3, 5), (2, 0, 4, 5))
    del tmp17, tmp16
    tmp24 += einsum(tmp20, (0, 1, 2), tmp15, (3, 4, 2), (4, 3, 0, 1)) * 0.5
    del tmp15, tmp20
    tmp24 += einsum(tmp23, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4)) * -0.5
    del tmp23
    l1new += einsum(tmp24, (0, 1, 2, 3), l2, (4, 3, 2, 0), (4, 1)) * 2
    del tmp24
    l1new += f.ov.transpose((1, 0))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:48:18.420320.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp0 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm1.oo = tmp0.transpose((1, 0)).copy() * -2
    tmp5 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp5 += t2
    tmp7 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp7 += l2.transpose((2, 3, 0, 1)) * 2
    rdm1.vv = einsum(t2, (0, 1, 2, 3), tmp7, (0, 1, 4, 3), (4, 2)) * 2
    del tmp7
    tmp3 = tmp2.copy()
    tmp3 += tmp2.transpose((1, 0, 2, 3)) * -0.5
    del tmp2
    rdm1.ov = einsum(tmp3, (0, 1, 2, 3), t2, (1, 0, 4, 3), (2, 4)) * -4
    del tmp3
    tmp6 = tmp0.copy() * 0.5
    del tmp0
    tmp6 += einsum(l2, (0, 1, 2, 3), tmp5, (2, 4, 0, 1), (3, 4))
    del tmp5
    rdm1.ov += einsum(tmp6, (0, 1), t1, (0, 2), (1, 2)) * -4
    del tmp6
    tmp4 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp4 += t2 * 2
    rdm1.ov += einsum(tmp4, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * 2
    del tmp4
    tmp1 = t2.transpose((0, 1, 3, 2)).copy()
    tmp1 += t2 * -0.5
    rdm1.oo += einsum(tmp1, (0, 1, 2, 3), l2, (3, 2, 0, 4), (1, 4)) * -4
    del tmp1
    rdm1.oo += delta.oo * 2
    del delta
    rdm1.ov += t1 * 2
    rdm1.vo = l1.copy() * 2
    rdm1.vv += einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 2
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:49:31.916891.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp3 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.vooo = tmp3.transpose((3, 2, 1, 0)).copy()
    rdm2.vooo += tmp3.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp3.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp3.transpose((3, 2, 0, 1)) * -1
    rdm2.vooo += tmp3.transpose((3, 2, 1, 0))
    rdm2.vooo += tmp3.transpose((3, 2, 0, 1)) * -1
    rdm2.ovoo = tmp3.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.ovoo += tmp3.transpose((2, 3, 0, 1))
    rdm2.ovoo += tmp3.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp3.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp3.transpose((2, 3, 1, 0)) * -1
    rdm2.ovoo += tmp3.transpose((2, 3, 0, 1))
    tmp95 = t2.transpose((0, 1, 3, 2)).copy() * 2
    tmp95 += t2 * -1
    tmp97 = t2.transpose((0, 1, 3, 2)).copy()
    tmp97 += t2 * -1
    tmp12 = tmp3.copy() * 2
    tmp12 += tmp3.transpose((1, 0, 2, 3)) * -1
    tmp10 = tmp3.copy()
    tmp10 += tmp3.transpose((1, 0, 2, 3)) * -1
    tmp0 = t2.transpose((0, 1, 3, 2)).copy() * -0.5
    tmp0 += t2
    tmp45 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp45 += l2.transpose((2, 3, 0, 1)) * -1
    tmp96 = einsum(l2, (0, 1, 2, 3), tmp95, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp95
    tmp98 = einsum(l2, (0, 1, 2, 3), tmp97, (2, 4, 5, 1), (4, 3, 5, 0))
    del tmp97
    tmp89 = einsum(tmp3, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    rdm2.voov = tmp89.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.voov += tmp89.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo = tmp89.transpose((1, 2, 3, 0)).copy() * -1
    rdm2.ovvo += tmp89.transpose((1, 2, 3, 0)) * -1
    tmp60 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp60 += l2.transpose((2, 3, 0, 1)) * 2
    tmp106 = l2.transpose((3, 2, 0, 1)).copy() * 2
    tmp106 += l2.transpose((2, 3, 0, 1)) * -1
    tmp4 = einsum(t1, (0, 1), tmp3, (2, 3, 4, 1), (3, 2, 4, 0))
    rdm2.oooo = tmp4.transpose((3, 2, 1, 0)).copy()
    rdm2.oooo += tmp4.transpose((3, 2, 1, 0))
    tmp53 = l2.transpose((3, 2, 0, 1)).copy()
    tmp53 += l2.transpose((2, 3, 0, 1)) * -1
    tmp25 = einsum(tmp3, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    rdm2.oovo = tmp25.transpose((2, 1, 3, 0)).copy()
    rdm2.oovo += tmp25.transpose((2, 1, 3, 0))
    rdm2.ooov = tmp25.transpose((1, 2, 0, 3)).copy()
    rdm2.ooov += tmp25.transpose((1, 2, 0, 3))
    tmp13 = einsum(t2, (0, 1, 2, 3), tmp12, (1, 4, 5, 3), (4, 5, 0, 2))
    del tmp12
    tmp2 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.oooo += tmp2.transpose((3, 2, 1, 0))
    rdm2.oooo += tmp2.transpose((3, 2, 1, 0))
    tmp11 = einsum(t2, (0, 1, 2, 3), tmp10, (1, 4, 5, 2), (4, 5, 0, 3))
    tmp8 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2.oovo += tmp8.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp8.transpose((1, 2, 3, 0)) * -1
    rdm2.ooov += tmp8.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp8.transpose((2, 1, 0, 3)) * -1
    tmp22 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp22 += t2 * 2
    tmp6 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm2.ooov += einsum(tmp6, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.ooov += einsum(tmp6, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.ooov += einsum(t1, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 1, 2))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 1, 2))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp17 = tmp3.copy() * 2
    tmp17 += tmp3.transpose((1, 0, 2, 3)) * -1
    tmp1 = einsum(l2, (0, 1, 2, 3), tmp0, (2, 4, 0, 1), (3, 4)) * 2
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp1, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp1, (2, 3), (0, 3, 2, 1))
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp26 = einsum(tmp3, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp26.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp26.transpose((2, 1, 0, 3))
    tmp33 = einsum(l2, (0, 1, 2, 3), tmp0, (2, 4, 0, 1), (3, 4))
    del tmp0
    tmp116 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2.vvvo = tmp116.transpose((2, 1, 3, 0)).copy()
    rdm2.vvvo += tmp116.transpose((1, 2, 3, 0)) * -1
    rdm2.vvvo += tmp116.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp116.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp116.transpose((2, 1, 3, 0))
    rdm2.vvvo += tmp116.transpose((1, 2, 3, 0)) * -1
    rdm2.vvov = tmp116.transpose((2, 1, 0, 3)).copy() * -1
    rdm2.vvov += tmp116.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp116.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp116.transpose((1, 2, 0, 3))
    rdm2.vvov += tmp116.transpose((2, 1, 0, 3)) * -1
    rdm2.vvov += tmp116.transpose((1, 2, 0, 3))
    tmp65 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 5, 1), (5, 0, 4, 3))
    rdm2.voov += tmp65.transpose((2, 1, 0, 3)) * -1
    rdm2.voov += tmp65.transpose((2, 1, 0, 3)) * -1
    rdm2.ovvo += tmp65.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp65.transpose((1, 2, 3, 0)) * -1
    tmp46 = einsum(t2, (0, 1, 2, 3), tmp45, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp45
    tmp110 = tmp89.copy()
    tmp110 += tmp98.transpose((1, 0, 3, 2))
    tmp110 += tmp96.transpose((1, 0, 3, 2)) * -1
    tmp82 = einsum(t2, (0, 1, 2, 3), tmp60, (0, 1, 4, 3), (4, 2))
    tmp81 = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    tmp107 = einsum(t2, (0, 1, 2, 3), tmp106, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp106
    tmp99 = tmp96.transpose((1, 0, 3, 2)).copy()
    del tmp96
    tmp99 += tmp98.transpose((1, 0, 3, 2)) * -1
    del tmp98
    tmp9 = einsum(tmp4, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp54 = einsum(tmp53, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    tmp69 = tmp25.copy()
    del tmp25
    tmp69 += tmp13 * -1
    tmp5 = tmp2.transpose((1, 0, 3, 2)).copy()
    tmp5 += tmp4
    del tmp4
    rdm2.oooo += tmp5.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp5.transpose((3, 2, 0, 1)) * -1
    rdm2.oooo += tmp5.transpose((2, 3, 0, 1))
    rdm2.oooo += tmp5.transpose((3, 2, 0, 1)) * -1
    tmp48 = tmp8.copy()
    tmp48 += tmp11
    tmp48 += tmp13 * -1
    tmp23 = einsum(l1, (0, 1), tmp22, (1, 2, 0, 3), (2, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(tmp23, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(tmp23, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    tmp21 = einsum(tmp6, (0, 1), t1, (0, 2), (1, 2))
    rdm2.oovv = einsum(tmp21, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.oovv += einsum(tmp21, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    tmp18 = einsum(t2, (0, 1, 2, 3), tmp17, (0, 1, 4, 2), (4, 3)) * 0.5
    tmp19 = einsum(tmp1, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    tmp61 = einsum(t2, (0, 1, 2, 3), tmp60, (0, 1, 4, 3), (4, 2)) * 0.5
    del tmp60
    tmp72 = tmp8.copy()
    tmp72 += tmp26 * -1
    del tmp26
    tmp15 = einsum(tmp2, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp2
    tmp34 = tmp6.copy() * 0.5
    tmp34 += tmp33
    del tmp33
    rdm2.ooov += einsum(tmp34, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.ooov += einsum(tmp34, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -2
    tmp31 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp31 += t2 * 2
    tmp117 = einsum(t2, (0, 1, 2, 3), l2, (4, 5, 1, 0), (4, 5, 3, 2))
    rdm2.vvvv = tmp117.transpose((1, 0, 3, 2)).copy()
    rdm2.vvvv += tmp117.transpose((1, 0, 3, 2))
    tmp118 = einsum(t1, (0, 1), tmp116, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp116
    rdm2.vvvv += tmp118.transpose((1, 0, 3, 2))
    rdm2.vvvv += tmp118.transpose((1, 0, 3, 2))
    tmp67 = einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    rdm2.vovo = tmp67.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.vovo += tmp67.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov = tmp67.transpose((1, 2, 0, 3)).copy() * -1
    rdm2.ovov += tmp67.transpose((1, 2, 0, 3)) * -1
    tmp114 = tmp65.copy()
    tmp114 += tmp89
    tmp114 += tmp46 * -1
    tmp94 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    rdm2.vovv = tmp94.transpose((1, 0, 3, 2)).copy()
    rdm2.vovv += tmp94.transpose((1, 0, 3, 2))
    rdm2.ovvv = tmp94.copy()
    rdm2.ovvv += tmp94
    tmp111 = einsum(tmp110, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp110
    tmp83 = tmp81.copy()
    tmp83 += tmp82
    del tmp82
    rdm2.ovvv += einsum(tmp83, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvv += einsum(tmp83, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(delta.oo, (0, 1), tmp83, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.voov += einsum(delta.oo, (0, 1), tmp83, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp83, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp83, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp83, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp83, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp83, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp83, (2, 3), (0, 2, 1, 3))
    tmp102 = einsum(t2, (0, 1, 2, 3), tmp3, (1, 0, 4, 5), (4, 5, 3, 2))
    rdm2.vovv += tmp102.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp102.transpose((1, 0, 2, 3)) * -1
    rdm2.ovvv += tmp102.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp102.transpose((0, 1, 3, 2)) * -1
    tmp108 = tmp65.copy()
    tmp108 += tmp89
    tmp108 += tmp107 * -1
    del tmp107
    tmp100 = einsum(tmp99, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp99
    tmp85 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp85 += l2.transpose((2, 3, 0, 1)) * 2
    tmp90 = tmp3.copy() * -1
    tmp90 += tmp3.transpose((1, 0, 2, 3))
    tmp77 = t2.transpose((0, 1, 3, 2)).copy() * -1
    tmp77 += t2
    tmp87 = l2.transpose((3, 2, 0, 1)).copy() * -1
    tmp87 += l2.transpose((2, 3, 0, 1))
    tmp52 = einsum(t2, (0, 1, 2, 3), tmp46, (1, 4, 3, 5), (4, 0, 5, 2))
    rdm2.oovv += tmp52.transpose((1, 0, 3, 2)) * 2
    rdm2.oovv += tmp52.transpose((1, 0, 3, 2)) * 2
    tmp51 = einsum(t1, (0, 1), tmp9, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp54
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp46
    tmp70 = einsum(t1, (0, 1), tmp69, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp69
    tmp29 = einsum(tmp5, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    rdm2.oovo += tmp29.transpose((1, 2, 3, 0))
    rdm2.oovo += tmp29.transpose((1, 2, 3, 0))
    rdm2.ooov += tmp29.transpose((2, 1, 0, 3))
    rdm2.ooov += tmp29.transpose((2, 1, 0, 3))
    tmp44 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp48
    tmp24 = tmp21.copy()
    tmp24 += tmp23 * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1))
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1))
    tmp20 = tmp18.copy()
    tmp20 += tmp19
    del tmp19
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.ooov += einsum(tmp20, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4), (0, 4, 3, 2))
    tmp62 = einsum(tmp61, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4)) * 2
    tmp73 = einsum(t1, (0, 1), tmp72, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp72
    tmp57 = einsum(t1, (0, 1), tmp15, (0, 2, 3, 4), (3, 2, 4, 1))
    tmp58 = einsum(tmp5, (0, 1, 2, 3), t2, (0, 1, 4, 5), (2, 3, 4, 5))
    del tmp5
    rdm2.oovv += tmp58.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp58.transpose((1, 0, 3, 2))
    tmp30 = einsum(t2, (0, 1, 2, 3), tmp17, (0, 1, 4, 2), (4, 3))
    del tmp17
    tmp35 = einsum(tmp34, (0, 1), t1, (0, 2), (1, 2)) * 2
    tmp41 = einsum(tmp34, (0, 1), t1, (0, 2), (1, 2))
    del tmp34
    tmp40 = einsum(tmp31, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * 0.5
    tmp27 = tmp3.copy() * -1
    tmp27 += tmp3.transpose((1, 0, 2, 3)) * 2
    tmp32 = einsum(tmp31, (0, 1, 2, 3), l1, (2, 0), (1, 3))
    del tmp31
    tmp119 = tmp117.transpose((1, 0, 3, 2)).copy()
    del tmp117
    tmp119 += tmp118.transpose((1, 0, 3, 2))
    del tmp118
    rdm2.vvvv += tmp119
    rdm2.vvvv += tmp119.transpose((0, 1, 3, 2)) * -1
    rdm2.vvvv += tmp119
    rdm2.vvvv += tmp119.transpose((0, 1, 3, 2)) * -1
    del tmp119
    tmp93 = tmp81.copy() * 0.5
    tmp93 += tmp61
    rdm2.vovv += einsum(tmp93, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vovv += einsum(tmp93, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vovo += einsum(tmp93, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vovo += einsum(tmp93, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vovo += einsum(tmp93, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vovo += einsum(tmp93, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    del tmp93
    tmp105 = einsum(t1, (0, 1), tmp67, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.vovv += tmp105.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp105.transpose((1, 0, 3, 2)) * -1
    rdm2.ovvv += tmp105 * -1
    rdm2.ovvv += tmp105 * -1
    del tmp105
    tmp115 = einsum(tmp114, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp114
    rdm2.vovv += tmp115.transpose((1, 0, 3, 2)) * -1
    rdm2.vovv += tmp115.transpose((1, 0, 3, 2)) * -1
    del tmp115
    tmp112 = tmp94.copy()
    tmp112 += tmp111.transpose((0, 1, 3, 2))
    del tmp111
    rdm2.vovv += tmp112.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp112.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp112.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp112.transpose((1, 0, 2, 3)) * -1
    del tmp112
    tmp113 = tmp102.copy()
    tmp113 += einsum(tmp83, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    del tmp83
    rdm2.vovv += tmp113.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp113.transpose((1, 0, 2, 3)) * -1
    rdm2.vovv += tmp113.transpose((1, 0, 3, 2))
    rdm2.vovv += tmp113.transpose((1, 0, 2, 3)) * -1
    del tmp113
    tmp109 = einsum(tmp108, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp108
    rdm2.ovvv += tmp109 * -1
    rdm2.ovvv += tmp109 * -1
    del tmp109
    tmp101 = tmp94.copy()
    del tmp94
    tmp101 += einsum(tmp81, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    del tmp81
    tmp101 += tmp100.transpose((0, 1, 3, 2)) * -1
    del tmp100
    rdm2.ovvv += tmp101.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp101
    rdm2.ovvv += tmp101.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp101
    del tmp101
    tmp103 = tmp102.copy()
    del tmp102
    tmp103 += einsum(tmp61, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    del tmp61
    rdm2.ovvv += tmp103.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp103
    rdm2.ovvv += tmp103.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp103
    del tmp103
    tmp104 = einsum(tmp89, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp89
    rdm2.ovvv += tmp104.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp104
    rdm2.ovvv += tmp104.transpose((0, 1, 3, 2)) * -1
    rdm2.ovvv += tmp104
    del tmp104
    tmp86 = einsum(t2, (0, 1, 2, 3), tmp85, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp85
    rdm2.vovo += tmp86.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp86.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp86.transpose((2, 1, 0, 3))
    rdm2.voov += tmp86.transpose((2, 1, 0, 3))
    rdm2.ovvo += tmp86.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp86.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp86.transpose((1, 2, 3, 0))
    rdm2.ovvo += tmp86.transpose((1, 2, 3, 0))
    del tmp86
    tmp92 = einsum(tmp53, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp53
    rdm2.vovo += tmp92.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp92.transpose((2, 1, 3, 0)) * -1
    del tmp92
    tmp91 = einsum(t1, (0, 1), tmp90, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp90
    rdm2.vovo += tmp91.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp91.transpose((2, 1, 3, 0)) * -1
    rdm2.voov += tmp91.transpose((2, 1, 0, 3))
    rdm2.voov += tmp91.transpose((2, 1, 0, 3))
    del tmp91
    tmp84 = einsum(tmp3, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp3
    rdm2.vovo += tmp84.transpose((2, 1, 3, 0)) * -1
    rdm2.vovo += tmp84.transpose((2, 1, 3, 0)) * -1
    rdm2.ovov += tmp84.transpose((1, 2, 0, 3)) * -1
    rdm2.ovov += tmp84.transpose((1, 2, 0, 3)) * -1
    del tmp84
    tmp78 = einsum(tmp77, (0, 1, 2, 3), l2, (4, 2, 0, 5), (1, 5, 3, 4))
    del tmp77
    rdm2.voov += tmp78.transpose((3, 0, 1, 2)) * -1
    rdm2.voov += tmp78.transpose((3, 0, 1, 2)) * -1
    rdm2.ovov += tmp78.transpose((0, 3, 1, 2))
    rdm2.ovov += tmp78.transpose((0, 3, 1, 2))
    del tmp78
    tmp79 = einsum(l2, (0, 1, 2, 3), tmp22, (3, 4, 1, 5), (4, 2, 5, 0))
    del tmp22
    rdm2.voov += tmp79.transpose((3, 0, 1, 2))
    rdm2.voov += tmp79.transpose((3, 0, 1, 2))
    rdm2.ovov += tmp79.transpose((0, 3, 1, 2)) * -1
    rdm2.ovov += tmp79.transpose((0, 3, 1, 2)) * -1
    del tmp79
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp87
    rdm2.ovvo += tmp88.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp88.transpose((1, 2, 3, 0)) * -1
    del tmp88
    tmp80 = einsum(t1, (0, 1), tmp10, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp10
    rdm2.ovvo += tmp80.transpose((1, 2, 3, 0)) * -1
    rdm2.ovvo += tmp80.transpose((1, 2, 3, 0)) * -1
    rdm2.ovov += tmp80.transpose((1, 2, 0, 3))
    rdm2.ovov += tmp80.transpose((1, 2, 0, 3))
    del tmp80
    tmp68 = einsum(t2, (0, 1, 2, 3), tmp67, (1, 4, 2, 5), (0, 4, 3, 5))
    del tmp67
    rdm2.oovv += tmp68.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp68.transpose((0, 1, 3, 2))
    del tmp68
    tmp56 = tmp51.copy()
    del tmp51
    tmp56 += tmp52.transpose((1, 0, 3, 2)) * 2
    del tmp52
    tmp56 += tmp55
    del tmp55
    rdm2.oovv += tmp56.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp56
    rdm2.oovv += tmp56.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp56
    del tmp56
    tmp71 = tmp47.copy() * -1
    tmp71 += tmp70.transpose((0, 1, 3, 2))
    del tmp70
    tmp71 += einsum(t1, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    del tmp23
    rdm2.oovv += tmp71.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp71
    rdm2.oovv += tmp71.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp71
    del tmp71
    tmp75 = einsum(t1, (0, 1), tmp29, (0, 2, 3, 4), (3, 2, 4, 1))
    rdm2.oovv += tmp75.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp75.transpose((0, 1, 3, 2))
    del tmp75
    tmp50 = tmp44.copy()
    tmp50 += tmp47 * -1
    del tmp47
    tmp50 += tmp49.transpose((0, 1, 3, 2))
    del tmp49
    tmp50 += einsum(t1, (0, 1), tmp24, (2, 3), (0, 2, 1, 3)) * -1
    del tmp24
    rdm2.oovv += tmp50.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp50.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp50.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp50
    rdm2.oovv += tmp50.transpose((1, 0, 3, 2))
    rdm2.oovv += tmp50.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp50.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp50
    del tmp50
    tmp76 = t1.copy()
    tmp76 += tmp21 * -1
    del tmp21
    rdm2.oovv += einsum(t1, (0, 1), tmp76, (2, 3), (2, 0, 3, 1))
    rdm2.oovv += einsum(t1, (0, 1), tmp76, (2, 3), (2, 0, 3, 1))
    del tmp76
    tmp64 = tmp62.transpose((1, 0, 3, 2)).copy()
    del tmp62
    tmp64 += tmp63.transpose((0, 1, 3, 2))
    del tmp63
    tmp64 += einsum(t1, (0, 1), tmp20, (2, 3), (0, 2, 1, 3)) * 2
    del tmp20
    rdm2.oovv += tmp64.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp64.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp64.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp64 * -1
    rdm2.oovv += tmp64.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp64 * -1
    rdm2.oovv += tmp64.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp64 * -1
    rdm2.oovv += tmp64.transpose((1, 0, 3, 2)) * -1
    rdm2.oovv += tmp64.transpose((1, 0, 2, 3))
    rdm2.oovv += tmp64.transpose((0, 1, 3, 2))
    rdm2.oovv += tmp64 * -1
    del tmp64
    tmp74 = tmp44.copy()
    del tmp44
    tmp74 += tmp73.transpose((0, 1, 3, 2))
    del tmp73
    rdm2.oovv += tmp74.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp74.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp74.transpose((1, 0, 2, 3)) * -1
    rdm2.oovv += tmp74.transpose((0, 1, 3, 2)) * -1
    del tmp74
    tmp66 = einsum(t2, (0, 1, 2, 3), tmp65, (1, 4, 2, 5), (0, 4, 3, 5))
    del tmp65
    rdm2.oovv += tmp66
    rdm2.oovv += tmp66
    del tmp66
    tmp59 = tmp57.copy()
    del tmp57
    tmp59 += tmp58.transpose((1, 0, 3, 2))
    del tmp58
    rdm2.oovv += tmp59.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp59
    rdm2.oovv += tmp59.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += tmp59
    del tmp59
    tmp39 = tmp30.copy()
    tmp39 += tmp35
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp39, (2, 3), (0, 2, 3, 1))
    rdm2.oovo += einsum(tmp39, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp39, (2, 3), (0, 2, 3, 1))
    rdm2.oovo += einsum(tmp39, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    del tmp39
    tmp42 = t1.copy() * -0.5
    tmp42 += tmp18
    del tmp18
    tmp42 += tmp40 * -1
    del tmp40
    tmp42 += tmp41
    del tmp41
    rdm2.oovo += einsum(tmp42, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.oovo += einsum(tmp42, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -2
    del tmp42
    tmp28 = einsum(t2, (0, 1, 2, 3), tmp27, (4, 1, 5, 3), (4, 5, 0, 2))
    del tmp27
    rdm2.oovo += tmp28.transpose((2, 1, 3, 0)) * -1
    rdm2.oovo += tmp28.transpose((2, 1, 3, 0)) * -1
    rdm2.ooov += tmp28.transpose((1, 2, 0, 3)) * -1
    rdm2.ooov += tmp28.transpose((1, 2, 0, 3)) * -1
    del tmp28
    tmp38 = tmp8.copy()
    tmp38 += tmp29.transpose((0, 2, 1, 3))
    del tmp29
    tmp38 += einsum(tmp1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += tmp38.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp38.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp38.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp38.transpose((1, 2, 3, 0)) * -1
    del tmp38
    tmp37 = einsum(tmp6, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp37 += tmp11
    tmp37 += tmp13 * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    rdm2.oovo += tmp37.transpose((2, 1, 3, 0))
    rdm2.oovo += tmp37.transpose((1, 2, 3, 0)) * -1
    del tmp37
    tmp43 = tmp6.copy()
    tmp43 += tmp1
    rdm2.oovo += einsum(tmp43, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oovo += einsum(tmp43, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -1
    del tmp43
    tmp16 = tmp15.copy()
    del tmp15
    tmp16 += einsum(tmp1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    del tmp1
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp16.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp16.transpose((1, 2, 0, 3))
    del tmp16
    tmp14 = tmp8.copy()
    del tmp8
    tmp14 += tmp9
    del tmp9
    tmp14 += tmp11
    del tmp11
    tmp14 += tmp13 * -1
    del tmp13
    rdm2.ooov += tmp14.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp14.transpose((1, 2, 0, 3))
    rdm2.ooov += tmp14.transpose((2, 1, 0, 3)) * -1
    rdm2.ooov += tmp14.transpose((1, 2, 0, 3))
    del tmp14
    tmp36 = t1.copy() * -1
    tmp36 += tmp30
    del tmp30
    tmp36 += tmp32 * -1
    del tmp32
    tmp36 += tmp35
    del tmp35
    rdm2.ooov += einsum(tmp36, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.ooov += einsum(tmp36, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -1
    del tmp36
    tmp7 = delta.oo.copy()
    tmp7 += tmp6 * -1
    del tmp6
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3))
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3))
    del tmp7
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    del delta
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.oovv += t2
    rdm2.oovv += t2
    rdm2.oovv += t2.transpose((0, 1, 3, 2)) * -1
    rdm2.oovv += t2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ovov += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovov += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.ovvo += einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.voov += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vovo += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vovo += einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vvoo = l2.transpose((0, 1, 3, 2)).copy() * -1
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2
    rdm2.vvoo += l2.transpose((0, 1, 3, 2)) * -1
    rdm2.vvoo += l2
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = rdm2.swapaxes(1, 2)

    return rdm2

