"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:58:21.697457
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:58:22.965822.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp0 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp2 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp2 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp1 = f.bb.ov.copy() * 2
    tmp1 += einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3)) * 2
    tmp1 += einsum(t1.bb, (0, 1), tmp0, (0, 2, 3, 1), (2, 3)) * -1
    del tmp0
    e_cc = einsum(t1.bb, (0, 1), tmp1, (0, 1), ()) * 0.5
    del tmp1
    tmp3 = f.aa.ov.copy() * 2
    tmp3 += einsum(t1.aa, (0, 1), tmp2, (0, 2, 3, 1), (2, 3)) * -1
    del tmp2
    e_cc += einsum(tmp3, (0, 1), t1.aa, (0, 1), ()) * 0.5
    del tmp3
    e_cc += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 1, 3), ())
    e_cc += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 3), ())

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:58:39.156136.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp16 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    t1new.bb = einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (4, 1, 0, 3), (4, 2)) * -2
    tmp0 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    t1new.aa = einsum(t2.aaaa, (0, 1, 2, 3), tmp0, (4, 0, 1, 3), (4, 2)) * 2
    tmp11 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp11 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp5 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp5 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp68 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp72 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    t2new.bbbb = tmp72.transpose((1, 0, 3, 2)).copy() * -1
    t2new.bbbb += tmp72.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp72 * -1
    t2new.bbbb += tmp72.transpose((1, 0, 2, 3))
    tmp74 = einsum(t1.bb, (0, 1), tmp16, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp17 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    t2new.abab = einsum(t1.bb, (0, 1), tmp17, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp17, (0, 4, 1, 2), (4, 3)) * -1
    tmp43 = einsum(tmp0, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 2, 1))
    tmp36 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    t2new.aaaa = tmp36.transpose((1, 0, 3, 2)).copy() * -1
    t2new.aaaa += tmp36.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp36 * -1
    t2new.aaaa += tmp36.transpose((1, 0, 2, 3))
    tmp33 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp10 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    t1new.bb += tmp10
    tmp12 = einsum(t1.bb, (0, 1), tmp11, (0, 2, 3, 1), (2, 3))
    del tmp11
    tmp6 = einsum(t1.aa, (0, 1), tmp5, (0, 2, 3, 1), (2, 3))
    del tmp5
    tmp2 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 0, 1), (2, 3))
    t1new.aa += tmp2
    tmp69 = einsum(t1.bb, (0, 1), tmp68, (2, 3, 4, 0), (2, 4, 3, 1))
    del tmp68
    tmp79 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp49 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp49, (1, 4), (0, 4, 2, 3)) * -1
    tmp77 = einsum(tmp72, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp72
    tmp75 = einsum(t1.bb, (0, 1), tmp74, (2, 3, 0, 4), (3, 2, 4, 1))
    del tmp74
    tmp62 = einsum(t1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp65 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp47 = einsum(f.bb.ov, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp50 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp52 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp54 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    t2new.abab += tmp54
    tmp56 = einsum(t1.bb, (0, 1), v.aabb.vvov, (2, 3, 4, 1), (0, 4, 2, 3))
    tmp57 = einsum(t1.aa, (0, 1), tmp17, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp17
    tmp26 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp29 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp44 = einsum(t1.aa, (0, 1), tmp43, (2, 3, 0, 4), (3, 2, 4, 1))
    del tmp43
    tmp24 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp39 = einsum(t1.aa, (0, 1), tmp36, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp36
    tmp31 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    t2new.abab += einsum(tmp31, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    tmp34 = einsum(t1.aa, (0, 1), tmp33, (2, 3, 4, 0), (2, 4, 3, 1))
    del tmp33
    tmp41 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp13 = f.bb.ov.copy()
    tmp13 += tmp10
    del tmp10
    tmp13 += tmp12 * -1
    del tmp12
    t1new.bb += einsum(tmp13, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2
    t1new.aa += einsum(tmp13, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp21 = v.bbbb.ooov.copy()
    tmp21 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp7 = f.aa.ov.copy()
    tmp7 += tmp2
    del tmp2
    tmp7 += tmp6 * -1
    del tmp6
    t1new.bb += einsum(tmp7, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    t1new.aa += einsum(tmp7, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    tmp14 = v.aaaa.ooov.copy()
    tmp14 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp69
    t2new.bbbb += tmp70.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp70 * -1
    t2new.bbbb += tmp70.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp70.transpose((1, 0, 2, 3))
    del tmp70
    tmp73 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    t2new.bbbb += tmp73.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp73 * -1
    t2new.bbbb += tmp73.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp73.transpose((0, 1, 3, 2))
    del tmp73
    tmp80 = einsum(t1.bb, (0, 1), tmp79, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp79
    t2new.bbbb += tmp80.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp80
    del tmp80
    tmp67 = einsum(t2.bbbb, (0, 1, 2, 3), tmp49, (1, 4), (4, 0, 2, 3))
    del tmp49
    t2new.bbbb += tmp67.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp67.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp67.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp67.transpose((1, 0, 3, 2))
    del tmp67
    tmp78 = einsum(tmp77, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp77
    t2new.bbbb += tmp78.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp78 * -1
    t2new.bbbb += tmp78.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp78.transpose((0, 1, 3, 2))
    del tmp78
    tmp76 = einsum(tmp75, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp75
    t2new.bbbb += tmp76.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp76
    del tmp76
    tmp63 = einsum(tmp62, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp62
    t2new.bbbb += tmp63.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp63
    del tmp63
    tmp61 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    t2new.bbbb += tmp61.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp61.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp61.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp61.transpose((1, 0, 3, 2))
    del tmp61
    tmp66 = einsum(tmp65, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp65
    t2new.bbbb += tmp66
    t2new.bbbb += tmp66.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp66.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp66.transpose((1, 0, 3, 2))
    del tmp66
    tmp71 = einsum(tmp16, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp16
    t2new.bbbb += tmp71.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp71 * -1
    t2new.bbbb += tmp71.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp71.transpose((1, 0, 3, 2)) * -1
    del tmp71
    tmp64 = f.bb.vv.copy()
    tmp64 += tmp47 * -1
    t2new.bbbb += einsum(tmp64, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp64
    tmp48 = f.bb.vv.copy()
    tmp48 += tmp47 * -1
    del tmp47
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp48, (3, 4), (0, 1, 2, 4)) * 2
    t2new.abab += einsum(tmp48, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp48
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t1.bb, (3, 4), (1, 0, 2, 4))
    del tmp50
    t2new.abab += einsum(tmp51, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp51
    tmp59 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    t2new.abab += einsum(tmp59, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp59
    tmp46 = einsum(t1.bb, (0, 1), v.aabb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    t2new.abab += einsum(tmp46, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp46
    tmp1 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    t2new.abab += einsum(tmp1, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp1
    tmp55 = v.aabb.vvov.transpose((2, 0, 1, 3)).copy()
    tmp55 += einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    t2new.abab += einsum(t1.aa, (0, 1), tmp55, (2, 1, 3, 4), (0, 2, 3, 4))
    del tmp55
    tmp53 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp53 += einsum(tmp52, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4)) * -1
    del tmp52
    t2new.abab += einsum(t1.bb, (0, 1), tmp53, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp53
    tmp60 = einsum(t1.aa, (0, 1), tmp54, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp54
    t2new.abab += einsum(tmp60, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp60
    tmp58 = einsum(t1.aa, (0, 1), tmp56, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp56
    tmp58 += einsum(tmp57, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4)) * -1
    del tmp57
    t2new.abab += einsum(t1.bb, (0, 1), tmp58, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp58
    tmp27 = f.aa.vv.copy()
    tmp27 += tmp26 * -1
    t2new.abab += einsum(tmp27, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    t2new.aaaa += einsum(tmp27, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp27
    tmp30 = einsum(t1.aa, (0, 1), tmp29, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp29
    t2new.aaaa += tmp30
    t2new.aaaa += tmp30.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp30.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp30.transpose((1, 0, 3, 2))
    del tmp30
    tmp28 = f.aa.vv.copy()
    tmp28 += tmp26 * -1
    del tmp26
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp28, (3, 4), (0, 1, 2, 4)) * 2
    del tmp28
    tmp45 = einsum(tmp44, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp44
    t2new.aaaa += tmp45.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp45
    del tmp45
    tmp25 = einsum(t1.aa, (0, 1), tmp24, (2, 0, 3, 4), (3, 2, 4, 1))
    del tmp24
    t2new.aaaa += tmp25.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp25
    del tmp25
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp39
    t2new.aaaa += tmp40.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp40 * -1
    t2new.aaaa += tmp40.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp40.transpose((0, 1, 3, 2))
    del tmp40
    tmp23 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.oo, (4, 1), (4, 0, 2, 3))
    t2new.aaaa += tmp23.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp23.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp23.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp23.transpose((1, 0, 3, 2))
    del tmp23
    tmp32 = einsum(t2.aaaa, (0, 1, 2, 3), tmp31, (1, 4), (4, 0, 2, 3))
    del tmp31
    t2new.aaaa += tmp32.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp32.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp32.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp32.transpose((1, 0, 3, 2))
    del tmp32
    tmp38 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    t2new.aaaa += tmp38.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp38 * -1
    t2new.aaaa += tmp38.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp38.transpose((0, 1, 3, 2))
    del tmp38
    tmp35 = einsum(t1.aa, (0, 1), tmp34, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp34
    t2new.aaaa += tmp35.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp35 * -1
    t2new.aaaa += tmp35.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp35.transpose((1, 0, 2, 3))
    del tmp35
    tmp37 = einsum(t1.aa, (0, 1), tmp0, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp0
    t2new.aaaa += tmp37.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp37 * -1
    t2new.aaaa += tmp37.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp37.transpose((1, 0, 3, 2)) * -1
    del tmp37
    tmp42 = einsum(tmp41, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    del tmp41
    t2new.aaaa += tmp42.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp42
    del tmp42
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (4, 1))
    tmp19 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (4, 0)) * -2
    tmp19 += einsum(t1.bb, (0, 1), tmp13, (2, 1), (2, 0))
    del tmp13
    t1new.bb += einsum(t1.bb, (0, 1), tmp19, (0, 2), (2, 1)) * -1
    del tmp19
    tmp22 = f.bb.oo.copy()
    tmp22 += einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp22 += einsum(tmp21, (0, 1, 2, 3), t1.bb, (0, 3), (2, 1)) * -1
    del tmp21
    t1new.bb += einsum(t1.bb, (0, 1), tmp22, (0, 2), (2, 1)) * -1
    del tmp22
    tmp4 = t2.abab.copy()
    tmp4 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    t1new.bb += einsum(tmp4, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    t1new.aa += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp4, (4, 2, 1, 3), (4, 0))
    del tmp4
    tmp18 = t2.bbbb.copy() * 2
    tmp18 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    t1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp18, (0, 4, 1, 3), (4, 2))
    del tmp18
    tmp20 = f.bb.vv.copy()
    tmp20 += einsum(t1.bb, (0, 1), v.bbbb.ovvv, (0, 2, 3, 1), (2, 3)) * -1
    t1new.bb += einsum(tmp20, (0, 1), t1.bb, (2, 0), (2, 1))
    del tmp20
    tmp9 = f.aa.vv.copy()
    tmp9 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    t1new.aa += einsum(t1.aa, (0, 1), tmp9, (1, 2), (0, 2))
    del tmp9
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (4, 0)) * 2
    tmp8 += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (0, 4))
    tmp8 += einsum(tmp7, (0, 1), t1.aa, (2, 1), (0, 2))
    del tmp7
    t1new.aa += einsum(tmp8, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp8
    tmp15 = f.aa.oo.copy()
    tmp15 += einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp15 += einsum(t1.aa, (0, 1), tmp14, (0, 2, 3, 1), (3, 2)) * -1
    del tmp14
    t1new.aa += einsum(tmp15, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp15
    tmp3 = t2.aaaa.copy() * 2
    tmp3 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    t1new.aa += einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp3, (0, 4, 3, 1), (4, 2)) * -1
    del tmp3
    t1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    t1new.aa += f.aa.ov
    t1new.aa += einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 0, 3), (4, 2)) * 2
    t1new.aa += einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t1new.bb += f.bb.ov
    t1new.bb += einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3)) * -1
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.bb += einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 1, 3))
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 3, 1)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.oo, (4, 1), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(f.aa.oo, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    t2new.abab += v.aabb.ovov.transpose((0, 2, 1, 3))
    t2new.abab += einsum(t1.bb, (0, 1), v.aabb.ovoo, (2, 3, 4, 0), (2, 4, 3, 1)) * -1
    t2new.abab += einsum(v.aabb.ooov, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 1, 3))
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 3, 1)) * -1

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:00:25.644707.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp93 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp93 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp151 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp151 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp7 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp7 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp2 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp92 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp94 = einsum(t1.bb, (0, 1), tmp93, (0, 2, 3, 1), (2, 3))
    del tmp93
    tmp190 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp190 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp218 = v.bbbb.ovvv.copy() * -1
    tmp218 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp176 = v.bbbb.ovvv.copy() * -1
    tmp176 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp152 = einsum(tmp151, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp151
    tmp6 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 0, 1), (2, 3))
    tmp163 = v.aaaa.ovvv.copy() * -1
    tmp163 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    tmp143 = v.aaaa.ovvv.copy() * -1
    tmp143 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp7
    tmp14 = v.aabb.ovoo.transpose((0, 2, 3, 1)).copy()
    tmp14 += tmp2
    l2new.abab = einsum(tmp14, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 0, 2)) * -1
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp41 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp41, (4, 0), (1, 3, 4, 2)) * -1
    tmp42 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp49 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    l2new.abab += einsum(tmp49, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 2, 5), (3, 5, 0, 4))
    l2new.abab += einsum(tmp49, (0, 1, 2, 3), v.aabb.vvov, (4, 3, 2, 5), (4, 5, 0, 1)) * -1
    l2new.abab += einsum(tmp49, (0, 1, 2, 3), v.bbbb.ovoo, (4, 5, 2, 1), (3, 5, 0, 4)) * -1
    l1new.aa = einsum(v.aabb.vvoo, (0, 1, 2, 3), tmp49, (4, 3, 2, 1), (0, 4)) * -1
    tmp55 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp54 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp53 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp53, (4, 2), (1, 3, 0, 4)) * -1
    tmp90 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    l2new.abab += einsum(tmp90, (0, 1, 2, 3), tmp49, (4, 0, 1, 5), (5, 3, 4, 2))
    l2new.abab += einsum(tmp90, (0, 1, 2, 3), tmp49, (4, 0, 2, 5), (5, 3, 4, 1)) * -1
    tmp0 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp109 = v.bbbb.ooov.copy()
    tmp109 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp95 = f.bb.ov.copy()
    tmp95 += tmp92
    tmp95 += tmp94 * -1
    del tmp94
    tmp191 = einsum(t1.bb, (0, 1), tmp190, (0, 2, 3, 1), (2, 3))
    del tmp190
    tmp129 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (0, 1, 2, 3), (2, 3))
    tmp219 = einsum(t1.bb, (0, 1), tmp218, (0, 1, 2, 3), (2, 3))
    del tmp218
    tmp179 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp51 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    l2new.abab += einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp51, (4, 3, 2, 5), (1, 5, 0, 4)) * -2
    l2new.abab += einsum(tmp51, (0, 1, 2, 3), tmp2, (4, 1, 2, 5), (5, 3, 4, 0)) * -2
    l1new.bb = einsum(tmp51, (0, 1, 2, 3), v.bbbb.oovv, (2, 1, 4, 3), (4, 0)) * -2
    tmp177 = einsum(tmp176, (0, 1, 2, 3), t1.bb, (4, 2), (0, 4, 1, 3))
    tmp87 = v.aaaa.ovvv.copy() * -1
    tmp87 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp153 = f.aa.ov.copy()
    tmp153 += tmp6
    tmp153 += tmp152 * -1
    del tmp152
    tmp149 = v.aaaa.ooov.copy()
    tmp149 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp86 = einsum(t1.bb, (0, 1), v.aabb.vvov, (2, 3, 0, 1), (2, 3))
    tmp164 = einsum(t1.aa, (0, 1), tmp163, (0, 1, 2, 3), (2, 3))
    del tmp163
    tmp10 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp37 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    l2new.abab += einsum(tmp37, (0, 1, 2, 3), v.aabb.ooov, (2, 1, 4, 5), (3, 5, 0, 4)) * -2
    l1new.aa += einsum(tmp37, (0, 1, 2, 3), v.aaaa.oovv, (2, 1, 4, 3), (4, 0)) * -2
    tmp144 = einsum(tmp143, (0, 1, 2, 3), t1.aa, (4, 2), (0, 4, 1, 3))
    del tmp143
    tmp9 = f.aa.ov.copy()
    tmp9 += tmp6
    tmp9 += tmp8 * -1
    del tmp8
    tmp62 = v.aaaa.ooov.copy()
    tmp62 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp4 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    l2new.abab += einsum(tmp4, (0, 1, 2, 3), tmp37, (4, 0, 1, 5), (5, 3, 4, 2)) * -2
    tmp96 = einsum(t1.bb, (0, 1), v.aabb.vvov, (2, 3, 4, 1), (0, 4, 2, 3))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp12 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp39 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    l2new.abab += einsum(tmp39, (0, 1, 2, 3), tmp0, (0, 1, 4, 5), (5, 3, 4, 2))
    l2new.abab += einsum(tmp39, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 5), (5, 3, 4, 2))
    l2new.abab += einsum(tmp14, (0, 1, 2, 3), tmp39, (4, 0, 1, 5), (3, 5, 4, 2))
    l2new.abab += einsum(tmp153, (0, 1), tmp39, (2, 0, 3, 4), (1, 4, 2, 3)) * -1
    l2new.abab += einsum(tmp39, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 5, 3), (4, 5, 0, 2)) * -1
    l2new.abab += einsum(tmp39, (0, 1, 2, 3), tmp0, (0, 4, 1, 5), (5, 3, 4, 2)) * -1
    l2new.abab += einsum(tmp39, (0, 1, 2, 3), v.aaaa.ovoo, (4, 5, 1, 0), (5, 3, 4, 2)) * -1
    l1new.bb += einsum(v.aabb.oovv, (0, 1, 2, 3), tmp39, (1, 0, 4, 3), (2, 4)) * -1
    tmp44 = tmp41.copy() * 0.5
    tmp44 += tmp42
    tmp44 += tmp43 * 0.5
    l1new.bb += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp44, (1, 0), (3, 2)) * -2
    l1new.aa += einsum(tmp44, (0, 1), tmp9, (1, 2), (2, 0)) * -2
    tmp71 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp72 = einsum(tmp49, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    tmp56 = tmp53.copy()
    tmp56 += tmp54
    tmp56 += tmp55 * 2
    l1new.bb += einsum(tmp56, (0, 1), v.bbbb.ooov, (2, 0, 1, 3), (3, 2))
    l1new.bb += einsum(tmp56, (0, 1), v.bbbb.ovoo, (2, 3, 0, 1), (3, 2)) * -1
    tmp101 = einsum(t1.bb, (0, 1), tmp90, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp102 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp20 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    l1new.aa += einsum(tmp37, (0, 1, 2, 3), tmp20, (1, 2, 4, 3), (4, 0)) * 2
    tmp22 = einsum(tmp0, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp23 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp118 = v.bbbb.ovvv.copy() * -1
    tmp118 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp198 = v.bbbb.ooov.transpose((0, 2, 1, 3)).copy()
    tmp198 += tmp90
    tmp108 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp184 = einsum(tmp109, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    tmp185 = einsum(t1.bb, (0, 1), tmp95, (2, 1), (0, 2))
    tmp113 = v.bbbb.ovvv.copy() * -1
    tmp113 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp192 = f.bb.ov.copy()
    tmp192 += tmp92
    tmp192 += tmp191 * -1
    del tmp191
    l2new.abab += einsum(tmp192, (0, 1), tmp49, (2, 3, 0, 4), (4, 1, 2, 3)) * -1
    tmp211 = v.bbbb.ooov.copy()
    tmp211 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp181 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    tmp220 = f.bb.vv.copy()
    tmp220 += tmp129.transpose((1, 0))
    tmp220 += tmp219.transpose((1, 0)) * -1
    del tmp219
    tmp180 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp180 += tmp179
    l2new.abab += einsum(tmp180, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1)) * 2
    tmp122 = einsum(t1.bb, (0, 1), tmp51, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp208 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp208 += v.bbbb.oovv * -1
    tmp208 += tmp177.transpose((1, 0, 2, 3)) * -1
    tmp141 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp174 = v.aaaa.ovvv.copy()
    tmp174 += v.aaaa.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp3 = v.aabb.ovoo.transpose((0, 2, 3, 1)).copy()
    tmp3 += tmp2.transpose((0, 2, 1, 3))
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp154 = einsum(tmp153, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp61 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp150 = einsum(tmp149, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp149
    tmp165 = f.aa.vv.copy()
    tmp165 += tmp86.transpose((1, 0))
    tmp165 += tmp164.transpose((1, 0)) * -1
    del tmp164
    tmp160 = v.aaaa.ovvv.copy() * -1
    tmp160 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    tmp147 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp147 += tmp10
    l2new.abab += einsum(tmp147, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5)) * 2
    tmp132 = v.aaaa.ooov.transpose((0, 2, 1, 3)).copy()
    tmp132 += tmp0
    tmp78 = einsum(t1.aa, (0, 1), tmp37, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp145 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp145 += v.aaaa.oovv * -1
    tmp145 += tmp144.transpose((1, 0, 2, 3)) * -1
    del tmp144
    tmp64 = einsum(t1.aa, (0, 1), tmp9, (2, 1), (0, 2))
    tmp63 = einsum(t1.aa, (0, 1), tmp62, (0, 2, 3, 1), (2, 3))
    del tmp62
    tmp5 = v.aabb.ooov.copy()
    tmp5 += tmp4.transpose((1, 0, 2, 3))
    tmp97 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy()
    tmp97 += tmp96.transpose((1, 0, 3, 2))
    tmp91 = v.bbbb.ooov.copy() * -1
    tmp91 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp91 += tmp90.transpose((1, 0, 2, 3))
    tmp91 += tmp90.transpose((2, 0, 1, 3)) * -1
    tmp16 = v.aabb.oooo.copy()
    tmp16 += tmp12.transpose((1, 0, 3, 2))
    tmp16 += tmp13.transpose((1, 0, 3, 2))
    del tmp13
    tmp16 += tmp15.transpose((1, 0, 3, 2))
    del tmp15
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp36 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp45 = einsum(t1.aa, (0, 1), tmp44, (0, 2), (2, 1)) * 2
    del tmp44
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp35 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp73 = tmp71.copy()
    tmp73 += tmp72
    tmp124 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp121 = einsum(tmp51, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp120 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp57 = einsum(t1.bb, (0, 1), tmp56, (0, 2), (2, 1))
    del tmp56
    tmp47 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp50 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 1, 4, 2), (4, 3))
    tmp48 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp52 = einsum(tmp51, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4))
    tmp27 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp28 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp26 = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    tmp99 = v.bbbb.ooov.copy() * -1
    tmp99 += v.bbbb.ooov.transpose((0, 2, 1, 3))
    tmp99 += tmp90
    tmp99 += tmp90.transpose((0, 2, 1, 3)) * -1
    tmp103 = v.bbbb.oooo.copy()
    tmp103 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp103 += tmp101.transpose((3, 1, 2, 0))
    tmp103 += tmp102.transpose((2, 1, 3, 0))
    tmp103 += tmp102.transpose((3, 2, 1, 0)) * -1
    tmp100 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp100 += v.bbbb.oovv * -1
    tmp100 += einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp32 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp33 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp31 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp11 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp11 += tmp10
    del tmp10
    l2new.aaaa = einsum(tmp11, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (2, 4, 5, 0)) * -1
    tmp1 = v.aaaa.ooov.copy() * -1
    tmp1 += v.aaaa.ovoo.transpose((0, 2, 3, 1))
    tmp1 += tmp0.transpose((1, 0, 2, 3))
    tmp1 += tmp0.transpose((2, 0, 1, 3)) * -1
    tmp81 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp77 = einsum(tmp37, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp79 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp18 = v.aaaa.ooov.copy() * -1
    tmp18 += v.aaaa.ooov.transpose((0, 2, 1, 3))
    tmp18 += tmp0
    tmp18 += tmp0.transpose((0, 2, 1, 3)) * -1
    tmp19 = v.aabb.ooov.copy()
    tmp19 += tmp4
    tmp21 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp21 += v.aaaa.oovv * -1
    tmp21 += tmp20.transpose((0, 1, 3, 2))
    del tmp20
    tmp24 = v.aaaa.oooo.copy()
    tmp24 += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (0, 4, 2, 5)) * -1
    tmp24 += tmp22.transpose((2, 1, 3, 0)) * -1
    tmp24 += tmp23.transpose((2, 0, 3, 1)) * -1
    tmp24 += tmp23.transpose((3, 0, 2, 1))
    tmp216 = f.bb.vv.copy()
    tmp216 += tmp129.transpose((1, 0))
    tmp216 += einsum(t1.bb, (0, 1), tmp118, (0, 1, 2, 3), (3, 2)) * -1
    l2new.bbbb = einsum(tmp216, (0, 1), l2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    del tmp216
    tmp199 = einsum(l1.bb, (0, 1), tmp198, (1, 2, 3, 4), (2, 3, 4, 0))
    del tmp198
    l2new.bbbb += tmp199.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp199.transpose((3, 2, 0, 1))
    del tmp199
    tmp206 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp206 += tmp179
    del tmp179
    l2new.bbbb += einsum(tmp206, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (3, 4, 5, 1)) * -1
    del tmp206
    tmp203 = einsum(tmp39, (0, 1, 2, 3), v.aabb.ooov, (1, 0, 4, 5), (2, 4, 3, 5))
    l2new.bbbb += tmp203.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp203.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp203.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp203.transpose((3, 2, 0, 1))
    del tmp203
    tmp226 = einsum(tmp51, (0, 1, 2, 3), tmp90, (1, 2, 4, 5), (0, 4, 3, 5))
    l2new.bbbb += tmp226.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp226.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp226.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp226.transpose((3, 2, 0, 1)) * -2
    del tmp226
    tmp204 = einsum(v.bbbb.ovoo, (0, 1, 2, 3), tmp51, (3, 4, 2, 5), (4, 0, 5, 1)) * -1
    l2new.bbbb += tmp204.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp204.transpose((2, 3, 0, 1)) * -2
    l2new.bbbb += tmp204.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp204.transpose((3, 2, 0, 1)) * 2
    del tmp204
    tmp222 = einsum(l2.bbbb, (0, 1, 2, 3), tmp102, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp102
    l2new.bbbb += tmp222.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp222.transpose((2, 3, 0, 1)) * -2
    del tmp222
    tmp186 = f.bb.oo.copy()
    tmp186 += tmp108.transpose((1, 0))
    tmp186 += tmp184 * -1
    del tmp184
    tmp186 += tmp185
    del tmp185
    l2new.bbbb += einsum(tmp186, (0, 1), l2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    l2new.abab += einsum(tmp186, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp186
    tmp201 = einsum(tmp51, (0, 1, 2, 3), tmp90, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    l2new.bbbb += tmp201.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp201.transpose((2, 3, 0, 1)) * -2
    l2new.bbbb += tmp201.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp201.transpose((3, 2, 0, 1)) * 2
    del tmp201
    tmp227 = einsum(tmp51, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    l2new.bbbb += tmp227.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp227.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp227.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp227.transpose((3, 2, 0, 1)) * -2
    del tmp227
    tmp205 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp205 += v.bbbb.oovv * -1
    tmp205 += einsum(t1.bb, (0, 1), tmp113, (2, 3, 1, 4), (0, 2, 3, 4)) * -1
    l2new.bbbb += einsum(tmp205, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 0), (2, 4, 5, 1)) * -2
    del tmp205
    tmp213 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp51, (4, 5, 0, 3), (5, 4, 1, 2))
    l2new.bbbb += tmp213.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp213.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp213.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp213.transpose((2, 3, 1, 0))
    del tmp213
    tmp212 = f.bb.oo.copy()
    tmp212 += tmp108.transpose((1, 0))
    tmp212 += einsum(tmp211, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2)) * -1
    del tmp211
    tmp212 += einsum(t1.bb, (0, 1), tmp192, (2, 1), (0, 2))
    l2new.bbbb += einsum(tmp212, (0, 1), l2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp212
    tmp197 = v.bbbb.ooov.copy()
    tmp197 += tmp90.transpose((0, 2, 1, 3))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp197, (1, 2, 3, 4), (4, 0, 3, 2)) * -1
    del tmp197
    tmp217 = einsum(tmp192, (0, 1), tmp51, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp192
    l2new.bbbb += tmp217.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp217.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp217.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp217.transpose((2, 3, 1, 0)) * -1
    del tmp217
    tmp182 = f.bb.ov.copy()
    tmp182 += tmp92
    tmp182 += tmp181
    l2new.bbbb += einsum(tmp182, (0, 1), l1.bb, (2, 3), (2, 1, 0, 3)) * -1
    l2new.bbbb += einsum(tmp182, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0))
    l2new.bbbb += einsum(tmp182, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3))
    l2new.abab += einsum(tmp182, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    del tmp182
    tmp225 = einsum(tmp53, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (0, 2, 3, 4))
    l2new.bbbb += tmp225.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp225.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp225.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp225.transpose((3, 2, 0, 1)) * -1
    del tmp225
    tmp221 = einsum(tmp220, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2)) * -1
    del tmp220
    l2new.bbbb += tmp221.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp221.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp221.transpose((2, 3, 1, 0)) * -1
    del tmp221
    tmp210 = einsum(l2.abab, (0, 1, 2, 3), tmp180, (2, 4, 0, 5), (4, 3, 5, 1))
    del tmp180
    l2new.bbbb += tmp210.transpose((3, 2, 0, 1)) * -1
    l2new.bbbb += tmp210.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp210.transpose((2, 3, 0, 1))
    del tmp210
    tmp207 = f.bb.ov.copy()
    tmp207 += tmp92
    del tmp92
    tmp207 += tmp181
    del tmp181
    l2new.bbbb += einsum(tmp207, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0)) * -1
    del tmp207
    tmp200 = einsum(l1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    l2new.bbbb += tmp200.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp200.transpose((3, 2, 0, 1))
    l2new.bbbb += tmp200.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp200.transpose((2, 3, 0, 1)) * -1
    del tmp200
    tmp214 = einsum(tmp122, (0, 1, 2, 3), v.bbbb.ovov, (3, 4, 2, 5), (0, 1, 5, 4))
    l2new.bbbb += tmp214.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp214.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp214.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp214.transpose((3, 2, 1, 0)) * 0.5
    del tmp214
    tmp223 = v.bbbb.oooo.copy()
    tmp223 += tmp101.transpose((0, 3, 1, 2)) * -1
    del tmp101
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp223, (2, 4, 3, 5), (0, 1, 4, 5)) * 2
    del tmp223
    tmp196 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp196, (2, 3), (0, 3, 2, 1))
    l2new.bbbb += einsum(tmp196, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.bbbb += einsum(tmp196, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0)) * -1
    l2new.bbbb += einsum(tmp196, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.abab += einsum(l1.aa, (0, 1), tmp196, (2, 3), (0, 3, 1, 2)) * -1
    del tmp196
    tmp215 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), l2.bbbb, (3, 1, 4, 5), (4, 5, 0, 2)) * -1
    l2new.bbbb += tmp215.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp215.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp215.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp215.transpose((3, 2, 1, 0)) * 0.5
    del tmp215
    tmp209 = einsum(tmp208, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 0), (1, 5, 2, 4))
    del tmp208
    l2new.bbbb += tmp209.transpose((3, 2, 0, 1)) * -2
    l2new.bbbb += tmp209.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp209.transpose((2, 3, 0, 1)) * 2
    del tmp209
    tmp224 = v.bbbb.ooov.copy()
    tmp224 += tmp90.transpose((0, 2, 1, 3))
    del tmp90
    l2new.bbbb += einsum(tmp224, (0, 1, 2, 3), l1.bb, (4, 0), (3, 4, 1, 2))
    del tmp224
    tmp202 = einsum(tmp4, (0, 1, 2, 3), tmp39, (0, 1, 4, 5), (4, 2, 5, 3))
    l2new.bbbb += tmp202.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp202.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp202.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp202.transpose((3, 2, 0, 1))
    del tmp202
    tmp156 = f.aa.ov.copy()
    tmp156 += tmp141
    tmp156 += tmp6
    l2new.abab += einsum(tmp156, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp156, (2, 3), (0, 3, 2, 1)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp156, (2, 3), (0, 3, 1, 2))
    l2new.aaaa += einsum(tmp156, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3))
    del tmp156
    tmp175 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp175 += v.aaaa.oovv * -1
    tmp175 += einsum(t1.aa, (0, 1), tmp174, (2, 1, 3, 4), (0, 2, 4, 3)) * -1
    del tmp174
    l2new.abab += einsum(tmp175, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    del tmp175
    tmp194 = v.aabb.oooo.copy()
    tmp194 += tmp12.transpose((1, 0, 2, 3))
    del tmp12
    tmp194 += einsum(t1.aa, (0, 1), tmp3, (2, 3, 4, 1), (0, 2, 4, 3))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp194, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp194
    tmp89 = f.aa.vv.copy()
    tmp89 += tmp86.transpose((1, 0))
    tmp89 += tmp88.transpose((1, 0)) * -1
    del tmp88
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp89, (0, 4), (4, 1, 2, 3))
    l1new.aa += einsum(tmp89, (0, 1), l1.aa, (0, 2), (1, 2))
    del tmp89
    tmp178 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp178 += v.bbbb.oovv * -1
    tmp178 += tmp177.transpose((1, 0, 3, 2)) * -1
    del tmp177
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp178, (3, 4, 1, 5), (0, 5, 2, 4))
    del tmp178
    tmp187 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp72, (4, 0, 5, 2), (4, 5, 1, 3))
    l2new.abab += tmp187.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp187.transpose((2, 3, 0, 1)) * 0.5
    del tmp187
    tmp155 = f.aa.oo.copy()
    tmp155 += tmp61.transpose((1, 0))
    tmp155 += tmp150 * -1
    del tmp150
    tmp155 += tmp154.transpose((1, 0))
    del tmp154
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp155, (2, 4), (0, 1, 4, 3)) * -1
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp155, (3, 4), (0, 1, 4, 2)) * 2
    del tmp155
    tmp183 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy()
    tmp183 += tmp96.transpose((0, 1, 3, 2))
    del tmp96
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp183, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp183
    tmp189 = f.bb.vv.copy()
    tmp189 += tmp129.transpose((1, 0))
    tmp189 += einsum(tmp176, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    del tmp176
    l2new.abab += einsum(tmp189, (0, 1), l2.abab, (2, 0, 3, 4), (2, 1, 3, 4))
    del tmp189
    tmp188 = einsum(l2.abab, (0, 1, 2, 3), v.aabb.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    l2new.abab += tmp188.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp188.transpose((2, 3, 0, 1)) * 0.5
    del tmp188
    tmp195 = v.aabb.oovv.copy()
    tmp195 += einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp195, (2, 4, 1, 5), (0, 5, 4, 3)) * -1
    del tmp195
    tmp171 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (2, 3))
    l2new.abab += einsum(tmp171, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa += einsum(tmp171, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3))
    l2new.aaaa += einsum(tmp171, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp171, (2, 3), (0, 3, 1, 2)) * -1
    l2new.aaaa += einsum(tmp171, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0))
    del tmp171
    tmp193 = v.aabb.ooov.copy()
    tmp193 += tmp4
    del tmp4
    l2new.abab += einsum(tmp193, (0, 1, 2, 3), tmp49, (0, 4, 2, 5), (5, 3, 1, 4))
    l2new.abab += einsum(l1.aa, (0, 1), tmp193, (1, 2, 3, 4), (0, 4, 2, 3)) * -1
    del tmp193
    tmp138 = einsum(l1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    l2new.aaaa += tmp138.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp138.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp138.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp138.transpose((2, 3, 0, 1)) * -1
    del tmp138
    tmp166 = einsum(tmp165, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2)) * -1
    del tmp165
    l2new.aaaa += tmp166.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp166.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp166.transpose((2, 3, 1, 0)) * -1
    del tmp166
    tmp142 = f.aa.ov.copy()
    tmp142 += tmp141
    del tmp141
    tmp142 += tmp6
    del tmp6
    l2new.aaaa += einsum(tmp142, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0)) * -1
    del tmp142
    tmp167 = einsum(tmp23, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp23
    l2new.aaaa += tmp167.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp167.transpose((2, 3, 0, 1)) * -2
    del tmp167
    tmp139 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp139 += v.aaaa.oovv * -1
    tmp139 += einsum(tmp87, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3)) * -1
    del tmp87
    l2new.aaaa += einsum(tmp139, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 0), (2, 4, 5, 1)) * -2
    del tmp139
    tmp161 = f.aa.vv.copy()
    tmp161 += tmp86.transpose((1, 0))
    del tmp86
    tmp161 += einsum(tmp160, (0, 1, 2, 3), t1.aa, (0, 1), (3, 2)) * -1
    del tmp160
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp161, (4, 1), (4, 0, 2, 3)) * -1
    del tmp161
    tmp137 = einsum(tmp37, (0, 1, 2, 3), v.aaaa.ovoo, (4, 5, 2, 0), (1, 4, 3, 5)) * -1
    l2new.aaaa += tmp137.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp137.transpose((2, 3, 0, 1)) * -2
    l2new.aaaa += tmp137.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp137.transpose((3, 2, 0, 1)) * 2
    del tmp137
    tmp173 = einsum(tmp0, (0, 1, 2, 3), tmp37, (4, 0, 1, 5), (4, 2, 5, 3))
    l2new.aaaa += tmp173.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp173.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp173.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp173.transpose((3, 2, 0, 1)) * -2
    del tmp173
    tmp157 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp37, (4, 5, 0, 3), (5, 4, 1, 2))
    l2new.aaaa += tmp157.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp157.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp157.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp157.transpose((2, 3, 1, 0))
    del tmp157
    tmp170 = einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp37, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    l2new.aaaa += tmp170.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp170.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp170.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp170.transpose((3, 2, 0, 1)) * -2
    del tmp170
    tmp162 = einsum(tmp37, (0, 1, 2, 3), tmp153, (2, 4), (0, 1, 4, 3))
    del tmp153
    l2new.aaaa += tmp162.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp162.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp162.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp162.transpose((2, 3, 1, 0)) * -1
    del tmp162
    tmp136 = einsum(tmp0, (0, 1, 2, 3), tmp37, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    l2new.aaaa += tmp136.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp136.transpose((2, 3, 0, 1)) * -2
    l2new.aaaa += tmp136.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp136.transpose((3, 2, 0, 1)) * 2
    del tmp136
    tmp135 = einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp49, (4, 3, 2, 5), (4, 0, 5, 1))
    l2new.aaaa += tmp135.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp135.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp135.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp135.transpose((3, 2, 0, 1))
    del tmp135
    tmp148 = einsum(tmp147, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (0, 5, 2, 4))
    del tmp147
    l2new.aaaa += tmp148.transpose((3, 2, 0, 1)) * -1
    l2new.aaaa += tmp148.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp148.transpose((2, 3, 0, 1))
    del tmp148
    tmp133 = einsum(tmp132, (0, 1, 2, 3), l1.aa, (4, 0), (1, 2, 3, 4))
    del tmp132
    l2new.aaaa += tmp133.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp133.transpose((3, 2, 0, 1))
    del tmp133
    tmp131 = v.aaaa.ooov.copy()
    tmp131 += tmp0.transpose((0, 2, 1, 3))
    l2new.aaaa += einsum(tmp131, (0, 1, 2, 3), l1.aa, (4, 0), (3, 4, 2, 1)) * -1
    del tmp131
    tmp169 = v.aaaa.ooov.copy()
    tmp169 += tmp0.transpose((0, 2, 1, 3))
    del tmp0
    l2new.aaaa += einsum(tmp169, (0, 1, 2, 3), l1.aa, (4, 0), (3, 4, 1, 2))
    del tmp169
    tmp159 = einsum(l2.aaaa, (0, 1, 2, 3), v.aaaa.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    l2new.aaaa += tmp159.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp159.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp159.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp159.transpose((3, 2, 1, 0)) * 0.5
    del tmp159
    tmp134 = einsum(tmp49, (0, 1, 2, 3), tmp2, (4, 1, 2, 5), (0, 4, 3, 5))
    l2new.aaaa += tmp134.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp134.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp134.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp134.transpose((3, 2, 0, 1))
    del tmp134
    tmp168 = v.aaaa.oooo.copy()
    tmp168 += tmp22.transpose((0, 2, 3, 1))
    del tmp22
    l2new.aaaa += einsum(tmp168, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 3), (4, 5, 2, 1)) * -2
    del tmp168
    tmp172 = einsum(tmp41, (0, 1), v.aaaa.ovov, (2, 3, 1, 4), (0, 2, 3, 4))
    l2new.aaaa += tmp172.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp172.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp172.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp172.transpose((3, 2, 0, 1)) * -1
    del tmp172
    tmp158 = einsum(tmp78, (0, 1, 2, 3), v.aaaa.ovov, (3, 4, 2, 5), (0, 1, 5, 4))
    l2new.aaaa += tmp158.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp158.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp158.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp158.transpose((3, 2, 1, 0)) * 0.5
    del tmp158
    tmp146 = einsum(l2.aaaa, (0, 1, 2, 3), tmp145, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp145
    l2new.aaaa += tmp146.transpose((3, 2, 0, 1)) * -2
    l2new.aaaa += tmp146.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp146.transpose((2, 3, 0, 1)) * 2
    del tmp146
    tmp140 = f.aa.oo.copy()
    tmp140 += tmp61.transpose((1, 0))
    tmp140 += tmp63 * -1
    tmp140 += tmp64
    l2new.aaaa += einsum(tmp140, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp140
    tmp112 = l2.abab.transpose((2, 3, 0, 1)).copy()
    tmp112 += einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4)) * 2
    tmp112 += einsum(tmp39, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    tmp112 += einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4)) * 2
    l1new.bb += einsum(tmp112, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (4, 1))
    del tmp112
    tmp98 = v.aabb.ovoo.transpose((0, 2, 3, 1)).copy()
    tmp98 += tmp2
    del tmp2
    tmp98 += einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 2, 0))
    tmp98 += einsum(t2.abab, (0, 1, 2, 3), tmp91, (1, 4, 5, 3), (0, 4, 5, 2))
    del tmp91
    tmp98 += einsum(tmp3, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 2, 1, 5)) * 2
    tmp98 += einsum(tmp5, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5)) * -1
    tmp98 += einsum(tmp95, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp98 += einsum(tmp97, (0, 1, 2, 3), t1.aa, (4, 2), (4, 1, 0, 3))
    del tmp97
    tmp98 += einsum(tmp16, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4)) * -1
    l1new.bb += einsum(tmp98, (0, 1, 2, 3), l2.abab, (3, 4, 0, 1), (4, 2)) * -1
    del tmp98
    tmp130 = f.bb.vv.copy()
    tmp130 += tmp129.transpose((1, 0))
    del tmp129
    tmp130 += einsum(tmp113, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    l1new.bb += einsum(tmp130, (0, 1), l1.bb, (0, 2), (1, 2))
    del tmp130
    tmp59 = tmp53.copy() * 0.5
    del tmp53
    tmp59 += tmp54 * 0.5
    del tmp54
    tmp59 += tmp55
    del tmp55
    l1new.bb += einsum(tmp95, (0, 1), tmp59, (2, 0), (1, 2)) * -2
    l1new.aa += einsum(tmp59, (0, 1), v.aabb.ovoo, (2, 3, 1, 0), (3, 2)) * -2
    del tmp59
    tmp46 = l1.aa.transpose((1, 0)).copy() * -1
    tmp46 += t1.aa * -1
    tmp46 += tmp35 * -2
    tmp46 += tmp36 * -1
    tmp46 += tmp38 * 2
    tmp46 += tmp40
    tmp46 += tmp45
    l1new.bb += einsum(tmp46, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (3, 2)) * -1
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp46, (2, 3), (1, 0)) * -1
    del tmp46
    tmp117 = einsum(tmp51, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * -1
    l1new.bb += einsum(tmp118, (0, 1, 2, 3), tmp117, (4, 0, 2, 3), (1, 4)) * -2
    del tmp118, tmp117
    tmp115 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp115 += tmp49
    tmp115 += einsum(t2.aaaa, (0, 1, 2, 3), tmp49, (1, 4, 5, 3), (0, 4, 5, 2)) * 2
    tmp115 += einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 4, 5, 3), (4, 5, 1, 2)) * -1
    tmp115 += einsum(t2.abab, (0, 1, 2, 3), tmp51, (4, 1, 5, 3), (0, 4, 5, 2)) * -2
    tmp115 += einsum(tmp73, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    l1new.bb += einsum(tmp115, (0, 1, 2, 3), v.aabb.ovov, (0, 3, 2, 4), (4, 1)) * -1
    del tmp115
    tmp126 = tmp124.transpose((1, 0, 3, 2)).copy()
    tmp126 += tmp122.transpose((2, 1, 0, 3))
    l1new.bb += einsum(tmp126, (0, 1, 2, 3), v.bbbb.ooov, (2, 0, 3, 4), (4, 1)) * 2
    del tmp126
    tmp125 = tmp120.copy() * 0.25
    tmp125 += tmp121
    tmp125 += einsum(tmp124, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 0.5
    del tmp124
    l1new.bb += einsum(tmp125, (0, 1, 2, 3), v.bbbb.ovov, (2, 4, 1, 3), (4, 0)) * 4
    del tmp125
    tmp128 = t1.bb.copy() * -1
    tmp128 += tmp47 * -1
    tmp128 += tmp48 * -2
    tmp128 += tmp50
    tmp128 += tmp52 * 2
    tmp128 += tmp57
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp128, (2, 1), (3, 0))
    del tmp128
    tmp119 = v.bbbb.ovvv.copy()
    tmp119 += einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 4, 3)) * -1
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp119, (3, 0, 1, 4), (4, 2)) * -2
    del tmp119
    tmp116 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    tmp116 += einsum(t1.aa, (0, 1), tmp49, (0, 2, 3, 4), (2, 3, 1, 4))
    l1new.bb += einsum(tmp116, (0, 1, 2, 3), v.aabb.vvov, (3, 2, 1, 4), (4, 0)) * -1
    del tmp116
    tmp127 = tmp71.copy()
    tmp127 += tmp72.transpose((1, 0, 2, 3))
    l1new.bb += einsum(tmp127, (0, 1, 2, 3), v.aabb.ooov, (0, 1, 3, 4), (4, 2))
    del tmp127
    tmp114 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3)) * 0.25
    tmp114 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    l1new.bb += einsum(tmp114, (0, 1, 2, 3), tmp113, (1, 4, 3, 2), (4, 0)) * 4
    del tmp113, tmp114
    tmp111 = einsum(t1.aa, (0, 1), v.aabb.vvvv, (2, 1, 3, 4), (0, 2, 3, 4))
    l1new.bb += einsum(tmp111, (0, 1, 2, 3), l2.abab, (1, 3, 0, 4), (2, 4))
    del tmp111
    tmp110 = f.bb.oo.copy() * 0.5
    tmp110 += tmp108.transpose((1, 0)) * 0.5
    del tmp108
    tmp110 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4)) * 0.5
    tmp110 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp110 += einsum(tmp109, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2)) * -0.5
    del tmp109
    tmp110 += einsum(t1.bb, (0, 1), tmp95, (2, 1), (0, 2)) * 0.5
    l1new.bb += einsum(l1.bb, (0, 1), tmp110, (1, 2), (0, 2)) * -2
    del tmp110
    tmp123 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    tmp123 += tmp51.transpose((1, 0, 2, 3))
    del tmp51
    tmp123 += tmp120.transpose((0, 2, 1, 3)) * 0.5
    del tmp120
    tmp123 += tmp121.transpose((0, 2, 1, 3)) * 2
    del tmp121
    tmp123 += einsum(t1.bb, (0, 1), tmp122, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp122
    l1new.bb += einsum(tmp123, (0, 1, 2, 3), v.bbbb.ovov, (1, 3, 2, 4), (4, 0)) * -2
    del tmp123
    tmp107 = tmp26.copy()
    tmp107 += tmp27 * 2
    tmp107 += tmp28
    l1new.bb += einsum(tmp107, (0, 1), v.aabb.vvov, (1, 0, 2, 3), (3, 2))
    del tmp107
    tmp106 = v.bbbb.ovvv.copy()
    tmp106 += v.bbbb.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp104 = v.bbbb.ooov.transpose((0, 2, 1, 3)).copy()
    tmp104 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (0, 4, 5, 2))
    tmp104 += einsum(t2.bbbb, (0, 1, 2, 3), tmp99, (4, 1, 5, 3), (5, 0, 4, 2)) * 2
    del tmp99
    tmp104 += einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 4, 5, 2), (5, 1, 4, 3))
    del tmp14
    tmp104 += einsum(tmp95, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp95
    tmp104 += einsum(tmp100, (0, 1, 2, 3), t1.bb, (4, 3), (1, 0, 4, 2))
    del tmp100
    tmp104 += einsum(t1.bb, (0, 1), tmp103, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    del tmp103
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp104, (4, 2, 3, 1), (0, 4)) * 2
    del tmp104
    tmp58 = l1.bb.transpose((1, 0)).copy() * -1
    tmp58 += t1.bb * -1
    tmp58 += tmp47 * -1
    del tmp47
    tmp58 += tmp48 * -2
    del tmp48
    tmp58 += tmp50
    del tmp50
    tmp58 += tmp52 * 2
    del tmp52
    tmp58 += tmp57
    del tmp57
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp58, (2, 3), (1, 0)) * -1
    l1new.aa += einsum(tmp58, (0, 1), v.aabb.ovov, (2, 3, 0, 1), (3, 2)) * -1
    del tmp58
    tmp105 = tmp31.copy()
    tmp105 += tmp32
    tmp105 += tmp33 * 2
    l1new.bb += einsum(tmp105, (0, 1), tmp106, (2, 1, 0, 3), (3, 2)) * -1
    del tmp105, tmp106
    tmp17 = v.aabb.ooov.copy() * 0.5
    tmp17 += einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2)) * 0.5
    tmp17 += einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2)) * 0.5
    tmp17 += einsum(t2.abab, (0, 1, 2, 3), tmp1, (0, 4, 5, 2), (4, 5, 1, 3)) * 0.5
    del tmp1
    tmp17 += einsum(t2.abab, (0, 1, 2, 3), tmp3, (4, 1, 5, 2), (0, 4, 5, 3)) * -0.5
    del tmp3
    tmp17 += einsum(tmp5, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (1, 0, 4, 5))
    del tmp5
    tmp17 += einsum(t2.abab, (0, 1, 2, 3), tmp9, (4, 2), (0, 4, 1, 3)) * 0.5
    tmp17 += einsum(tmp11, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3)) * 0.5
    del tmp11
    tmp17 += einsum(t1.bb, (0, 1), tmp16, (2, 3, 0, 4), (3, 2, 4, 1)) * -0.5
    del tmp16
    l1new.aa += einsum(tmp17, (0, 1, 2, 3), l2.abab, (4, 3, 0, 2), (4, 1)) * -2
    del tmp17
    tmp74 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    tmp74 += tmp39
    tmp74 += einsum(t2.abab, (0, 1, 2, 3), tmp37, (4, 0, 5, 2), (4, 5, 1, 3)) * -2
    tmp74 += einsum(tmp39, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5)) * 2
    tmp74 += einsum(t2.abab, (0, 1, 2, 3), tmp49, (4, 1, 5, 2), (4, 0, 5, 3)) * -1
    tmp74 += einsum(t1.bb, (0, 1), tmp73, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp73
    l1new.aa += einsum(tmp74, (0, 1, 2, 3), v.aabb.ovov, (1, 4, 2, 3), (4, 0)) * -1
    del tmp74
    tmp70 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2)) * 4
    tmp70 += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp67 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    l1new.aa += einsum(tmp67, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 0), (1, 4)) * 2
    del tmp67
    tmp29 = tmp26.copy() * 0.5
    del tmp26
    tmp29 += tmp27
    del tmp27
    tmp29 += tmp28 * 0.5
    del tmp28
    tmp84 = tmp71.copy()
    del tmp71
    tmp84 += tmp72.transpose((0, 1, 3, 2))
    del tmp72
    l1new.aa += einsum(tmp84, (0, 1, 2, 3), v.aabb.ovoo, (1, 4, 3, 2), (4, 0))
    del tmp84
    tmp68 = l2.abab.transpose((2, 3, 0, 1)).copy()
    tmp68 += einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3)) * 2
    tmp68 += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5)) * 2
    tmp68 += einsum(t1.bb, (0, 1), tmp49, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp49
    l1new.aa += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp68, (4, 2, 1, 3), (0, 4))
    del tmp68
    tmp75 = l2.aaaa.transpose((2, 3, 0, 1)).copy() * -1
    tmp75 += einsum(t1.aa, (0, 1), tmp37, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    l1new.aa += einsum(tmp75, (0, 1, 2, 3), v.aaaa.ovvv, (1, 3, 4, 2), (4, 0)) * -2
    del tmp75
    tmp34 = tmp31.copy() * 0.5
    del tmp31
    tmp34 += tmp32 * 0.5
    del tmp32
    tmp34 += tmp33
    del tmp33
    l1new.aa += einsum(tmp34, (0, 1), v.aabb.ovvv, (2, 3, 1, 0), (3, 2)) * 2
    del tmp34
    tmp85 = t1.aa.copy() * -1
    tmp85 += tmp35 * -2
    del tmp35
    tmp85 += tmp36 * -1
    del tmp36
    tmp85 += tmp38 * 2
    del tmp38
    tmp85 += tmp40
    del tmp40
    tmp85 += tmp45
    del tmp45
    l1new.aa += einsum(tmp85, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (3, 2))
    del tmp85
    tmp60 = tmp41.copy()
    del tmp41
    tmp60 += tmp42 * 2
    del tmp42
    tmp60 += tmp43
    del tmp43
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp60, (1, 2), (3, 0))
    l1new.aa += einsum(tmp60, (0, 1), v.aaaa.ovoo, (2, 3, 1, 0), (3, 2)) * -1
    del tmp60
    tmp83 = tmp81.transpose((1, 0, 3, 2)).copy()
    tmp83 += tmp78.transpose((2, 1, 0, 3))
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp83, (1, 4, 0, 2), (3, 4)) * 2
    del tmp83
    tmp65 = f.aa.oo.copy()
    tmp65 += tmp61.transpose((1, 0))
    del tmp61
    tmp65 += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4)) * 2
    tmp65 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp65 += tmp63 * -1
    del tmp63
    tmp65 += tmp64
    del tmp64
    l1new.aa += einsum(l1.aa, (0, 1), tmp65, (1, 2), (0, 2)) * -1
    del tmp65
    tmp30 = v.aaaa.ovvv.copy()
    tmp30 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    l1new.aa += einsum(tmp29, (0, 1), tmp30, (2, 1, 0, 3), (3, 2)) * -2
    del tmp29, tmp30
    tmp80 = tmp37.transpose((1, 0, 2, 3)).copy() * -0.5
    del tmp37
    tmp80 += tmp77.transpose((2, 0, 1, 3))
    tmp80 += einsum(t1.aa, (0, 1), tmp78, (0, 2, 3, 4), (4, 2, 3, 1)) * 0.5
    del tmp78
    tmp80 += tmp79.transpose((2, 0, 1, 3)) * 0.25
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp80, (0, 4, 2, 1), (3, 4)) * -4
    del tmp80
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    tmp76 += einsum(t1.bb, (0, 1), tmp39, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp39
    l1new.aa += einsum(tmp76, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp76
    tmp69 = v.aaaa.ovvv.copy()
    tmp69 += v.aaaa.ovvv.transpose((0, 2, 1, 3)) * -1
    l1new.aa += einsum(tmp69, (0, 1, 2, 3), tmp70, (4, 0, 3, 2), (1, 4)) * -1
    del tmp69, tmp70
    tmp25 = v.aaaa.ooov.copy() * -0.5
    tmp25 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (0, 4, 5, 2)) * -0.5
    tmp25 += einsum(t2.aaaa, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (5, 0, 4, 2))
    del tmp18
    tmp25 += einsum(tmp19, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (1, 4, 0, 5)) * 0.5
    del tmp19
    tmp25 += einsum(tmp9, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4)) * 0.5
    del tmp9
    tmp25 += einsum(t1.aa, (0, 1), tmp21, (2, 3, 4, 1), (3, 2, 0, 4)) * 0.5
    del tmp21
    tmp25 += einsum(t1.aa, (0, 1), tmp24, (0, 2, 3, 4), (3, 4, 2, 1)) * 0.5
    del tmp24
    l1new.aa += einsum(tmp25, (0, 1, 2, 3), l2.aaaa, (4, 3, 1, 2), (4, 0)) * 4
    del tmp25
    tmp66 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    l1new.aa += einsum(l2.abab, (0, 1, 2, 3), tmp66, (3, 4, 0, 1), (4, 2))
    del tmp66
    tmp82 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2)) * 0.5
    tmp82 += tmp77.transpose((0, 2, 1, 3))
    del tmp77
    tmp82 += einsum(t1.aa, (0, 1), tmp81, (2, 0, 3, 4), (2, 4, 3, 1)) * -0.5
    del tmp81
    tmp82 += tmp79.transpose((0, 2, 1, 3)) * 0.25
    del tmp79
    l1new.aa += einsum(tmp82, (0, 1, 2, 3), v.aaaa.ovov, (1, 4, 2, 3), (4, 0)) * 4
    del tmp82
    l1new.aa += einsum(l1.aa, (0, 1), v.aaaa.oovv, (2, 1, 3, 0), (3, 2)) * -1
    l1new.aa += f.aa.ov.transpose((1, 0))
    l1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), l1.bb, (3, 1), (2, 0)) * -1
    l1new.bb += f.bb.ov.transpose((1, 0))
    l2new.aaaa += v.aaaa.ovov.transpose((1, 3, 0, 2))
    l2new.aaaa += v.aaaa.ovov.transpose((3, 1, 0, 2)) * -1
    l2new.abab += v.aabb.ovov.transpose((1, 3, 0, 2))
    l2new.abab += einsum(v.aabb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (1, 2, 0, 4))
    l2new.abab += einsum(v.aabb.vvov, (0, 1, 2, 3), l1.aa, (1, 4), (0, 3, 4, 2))
    l2new.bbbb += v.bbbb.ovov.transpose((1, 3, 0, 2))
    l2new.bbbb += v.bbbb.ovov.transpose((3, 1, 0, 2)) * -1

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:00:28.987281.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    rdm1.bb.oo = tmp5.transpose((1, 0)).copy() * -1
    tmp3 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    rdm1.bb.oo += tmp3.transpose((1, 0)) * -2
    tmp4 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    rdm1.bb.oo += tmp4.transpose((1, 0)) * -1
    tmp2 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    rdm1.aa.oo = tmp2.transpose((1, 0)).copy() * -2
    tmp1 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    rdm1.aa.oo += tmp1.transpose((1, 0)) * -1
    tmp0 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    rdm1.aa.oo += tmp0.transpose((1, 0)) * -1
    tmp11 = tmp4.copy()
    del tmp4
    tmp11 += tmp5
    del tmp5
    tmp11 += tmp3 * 2
    del tmp3
    rdm1.bb.ov = einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    tmp10 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.ov += einsum(t2.abab, (0, 1, 2, 3), tmp10, (0, 1, 4, 2), (4, 3)) * -1
    del tmp10
    tmp9 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), tmp9, (1, 0, 4, 3), (4, 2)) * -2
    del tmp9
    tmp8 = tmp1.copy()
    del tmp1
    tmp8 += tmp2 * 2
    del tmp2
    tmp8 += tmp0
    del tmp0
    rdm1.aa.ov = einsum(tmp8, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp8
    tmp7 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.aa.ov += einsum(tmp7, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4)) * -2
    del tmp7
    tmp6 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm1.aa.ov += einsum(tmp6, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4)) * -1
    del tmp6
    rdm1.aa.oo += delta.aa.oo
    rdm1.bb.oo += delta.bb.oo
    del delta
    rdm1.aa.ov += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2)) * 2
    rdm1.aa.ov += t1.aa
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2)) * 2
    rdm1.bb.ov += t1.bb
    rdm1.bb.ov += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    rdm1.aa.vo = l1.aa.copy()
    rdm1.bb.vo = l1.bb.copy()
    rdm1.aa.vv = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    rdm1.aa.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    rdm1.bb.vv = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1.bb.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:01:32.322941.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp19 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    rdm2.bbbb.vooo = tmp19.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.vooo += tmp19.transpose((3, 2, 1, 0))
    rdm2.bbbb.ovoo = tmp19.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.bbbb.ovoo += tmp19.transpose((2, 3, 1, 0)) * -1
    tmp14 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.abab.vovv = einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 1, 4, 5), (3, 2, 4, 5)) * -1
    rdm2.abab.vovo = einsum(t1.aa, (0, 1), tmp14, (0, 2, 3, 4), (4, 3, 1, 2)) * -1
    rdm2.abab.vooo = tmp14.transpose((3, 2, 0, 1)).copy() * -1
    tmp8 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp10 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp2 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp6 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.aaaa.vooo = tmp6.transpose((3, 2, 1, 0)).copy()
    rdm2.aaaa.vooo += tmp6.transpose((3, 2, 1, 0))
    rdm2.aaaa.ovoo = tmp6.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.aaaa.ovoo += tmp6.transpose((2, 3, 1, 0)) * -1
    tmp27 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm2.abab.ovvv = einsum(t2.abab, (0, 1, 2, 3), tmp27, (0, 4, 1, 5), (4, 5, 2, 3)) * -1
    rdm2.abab.ovov = einsum(tmp27, (0, 1, 2, 3), t1.bb, (2, 4), (1, 3, 0, 4)) * -1
    rdm2.abab.ovoo = tmp27.transpose((1, 3, 0, 2)).copy() * -1
    tmp87 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.bbbb.vovo = tmp87.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.voov = tmp87.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ovvo = tmp87.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.bbbb.ovov = tmp87.transpose((1, 2, 0, 3)).copy() * -4
    tmp86 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    rdm2.bbbb.vovo += tmp86.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.voov += tmp86.transpose((2, 1, 0, 3))
    rdm2.bbbb.ovvo += tmp86.transpose((1, 2, 3, 0))
    rdm2.bbbb.ovov += tmp86.transpose((1, 2, 0, 3)) * -1
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.aaaa.vovo = tmp70.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.aaaa.voov = tmp70.transpose((2, 1, 0, 3)).copy()
    rdm2.aaaa.ovvo = tmp70.transpose((1, 2, 3, 0)).copy()
    rdm2.aaaa.ovov = tmp70.transpose((1, 2, 0, 3)).copy() * -1
    tmp68 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.aaaa.vovo += tmp68.transpose((2, 1, 3, 0)) * -4
    rdm2.aaaa.voov += tmp68.transpose((2, 1, 0, 3)) * 4
    rdm2.aaaa.ovvo += tmp68.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ovov += tmp68.transpose((1, 2, 0, 3)) * -4
    tmp50 = einsum(tmp19, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    rdm2.bbbb.oovo = tmp50.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.oovo += tmp50.transpose((1, 2, 3, 0)) * 4
    rdm2.bbbb.ooov = tmp50.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ooov += tmp50.transpose((1, 2, 0, 3)) * -4
    tmp51 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 4, 5, 2), (4, 5, 1, 3))
    rdm2.bbbb.oovo += tmp51.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += tmp51.transpose((1, 2, 3, 0))
    rdm2.bbbb.ooov += tmp51.transpose((2, 1, 0, 3))
    rdm2.bbbb.ooov += tmp51.transpose((1, 2, 0, 3)) * -1
    tmp81 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp18 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.bbbb.oooo = tmp18.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.oooo += tmp18.transpose((3, 2, 1, 0))
    tmp20 = einsum(tmp19, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    rdm2.bbbb.oooo += tmp20.transpose((2, 3, 1, 0)) * -1
    rdm2.bbbb.oooo += tmp20.transpose((2, 3, 1, 0)) * -1
    tmp17 = tmp8.copy()
    tmp17 += tmp9
    tmp17 += tmp10 * 2
    rdm2.abab.oovv = einsum(tmp17, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    rdm2.abab.oovo = einsum(tmp17, (0, 1), t1.aa, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov += einsum(t1.bb, (0, 1), tmp17, (2, 3), (0, 3, 2, 1))
    rdm2.bbbb.ooov += einsum(tmp17, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.bbbb.oooo += einsum(tmp17, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.oooo += einsum(tmp17, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp13 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    rdm2.abab.oooo = tmp13.transpose((1, 3, 0, 2)).copy()
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    rdm2.abab.oooo += tmp15.transpose((1, 3, 0, 2))
    tmp12 = tmp0.copy() * 0.5
    tmp12 += tmp1
    tmp12 += tmp2 * 0.5
    rdm2.abab.oooo += einsum(delta.bb.oo, (0, 1), tmp12, (2, 3), (3, 0, 2, 1)) * -2
    tmp32 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    rdm2.aaaa.oovo = tmp32.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.aaaa.oovo += tmp32.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ooov = tmp32.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.aaaa.ooov += tmp32.transpose((1, 2, 0, 3)) * -4
    tmp31 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2.aaaa.oovo += tmp31.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += tmp31.transpose((1, 2, 3, 0))
    rdm2.aaaa.ooov += tmp31.transpose((2, 1, 0, 3))
    rdm2.aaaa.ooov += tmp31.transpose((1, 2, 0, 3)) * -1
    tmp5 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2.aaaa.oooo = tmp5.transpose((3, 2, 1, 0)).copy()
    rdm2.aaaa.oooo += tmp5.transpose((3, 2, 1, 0))
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    rdm2.aaaa.oooo += tmp7.transpose((2, 3, 1, 0)) * -1
    rdm2.aaaa.oooo += tmp7.transpose((2, 3, 1, 0)) * -1
    tmp108 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp111 = einsum(tmp19, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.bbbb.vovo += tmp111.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.voov += tmp111.transpose((2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo += tmp111.transpose((1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov += tmp111.transpose((1, 2, 0, 3)) * 2
    tmp88 = tmp86.copy()
    tmp88 += tmp87 * 4
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp88, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp64 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp105 = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    tmp63 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp84 = einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.abab.voov = tmp84.transpose((2, 1, 0, 3)).copy() * 2
    tmp83 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    rdm2.abab.voov += tmp83.transpose((2, 1, 0, 3)) * 2
    tmp118 = tmp68.copy() * 4
    tmp118 += tmp70
    tmp107 = einsum(t1.aa, (0, 1), tmp6, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.aaaa.vovo += tmp107.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.voov += tmp107.transpose((2, 1, 0, 3)) * -2
    rdm2.aaaa.ovvo += tmp107.transpose((1, 2, 3, 0)) * -2
    rdm2.aaaa.ovov += tmp107.transpose((1, 2, 0, 3)) * 2
    tmp112 = einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4))
    rdm2.abab.ovvo = tmp112.transpose((0, 3, 2, 1)).copy() * 2
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    rdm2.abab.ovvo += tmp66.transpose((0, 3, 2, 1)) * 2
    tmp103 = tmp51.copy()
    del tmp51
    tmp103 += tmp50 * 4
    del tmp50
    tmp92 = tmp80.copy()
    tmp92 += tmp81 * 2
    tmp52 = tmp18.transpose((1, 0, 3, 2)).copy()
    del tmp18
    tmp52 += tmp20.transpose((0, 1, 3, 2)) * -1
    del tmp20
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    rdm2.bbbb.oovo += tmp49.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.ooov += tmp49.transpose((2, 1, 0, 3)) * -2
    tmp39 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 1, 4, 2), (4, 3))
    tmp40 = einsum(t2.bbbb, (0, 1, 2, 3), tmp19, (1, 0, 4, 3), (4, 2))
    tmp60 = einsum(t1.bb, (0, 1), tmp17, (0, 2), (2, 1))
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp35 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp62 = tmp8.copy() * 0.5
    tmp62 += tmp9 * 0.5
    tmp62 += tmp10
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp62, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp62, (2, 3), (3, 0, 1, 2)) * 2
    tmp45 = tmp13.copy()
    del tmp13
    tmp45 += tmp15
    del tmp15
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp45, (0, 4, 1, 5), (4, 5, 2, 3))
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp45, (0, 2, 3, 4), (2, 4, 1, 3))
    tmp28 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (0, 4, 1, 3), (4, 2))
    tmp26 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp54 = einsum(tmp12, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp22 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp58 = einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    rdm2.abab.oovo += tmp58.transpose((0, 2, 3, 1)) * -2
    tmp57 = einsum(t2.aaaa, (0, 1, 2, 3), tmp14, (1, 4, 5, 3), (0, 4, 5, 2))
    rdm2.abab.oovo += tmp57.transpose((0, 2, 3, 1)) * -2
    tmp41 = einsum(t1.bb, (0, 1), tmp17, (0, 2), (2, 1)) * 0.5
    del tmp17
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), tmp27, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2.abab.ooov = tmp43.transpose((1, 2, 0, 3)).copy() * -2
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), tmp6, (4, 0, 5, 2), (4, 5, 1, 3)) * -1
    rdm2.abab.ooov += tmp44.transpose((1, 2, 0, 3)) * -2
    tmp29 = einsum(tmp12, (0, 1), t1.aa, (0, 2), (1, 2)) * 2
    del tmp12
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2))
    rdm2.aaaa.oovo += tmp25.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.ooov += tmp25.transpose((2, 1, 0, 3)) * -2
    tmp78 = tmp32.copy() * 4
    del tmp32
    tmp78 += tmp31
    del tmp31
    tmp33 = tmp5.transpose((1, 0, 3, 2)).copy()
    del tmp5
    tmp33 += tmp7.transpose((0, 1, 3, 2)) * -1
    del tmp7
    tmp4 = tmp0.copy()
    tmp4 += tmp1 * 2
    tmp4 += tmp2
    rdm2.abab.oovv += einsum(tmp4, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oovo += einsum(tmp4, (0, 1), t1.aa, (2, 3), (1, 2, 3, 0))
    rdm2.abab.ooov += einsum(t1.bb, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.aaaa.ooov += einsum(tmp4, (0, 1), t1.aa, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.aaaa.oooo += einsum(tmp4, (0, 1), delta.aa.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp131 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2.bbbb.vvvv = einsum(tmp131, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.bbbb.vvvo = tmp131.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.bbbb.vvov = tmp131.transpose((2, 1, 0, 3)).copy() * -2
    del tmp131
    tmp133 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.bbbb.vvvv += tmp133.transpose((1, 0, 3, 2))
    rdm2.bbbb.vvvv += tmp133.transpose((1, 0, 3, 2))
    del tmp133
    tmp130 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    rdm2.abab.vvvv = einsum(t1.aa, (0, 1), tmp130, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.vvov = tmp130.transpose((1, 2, 0, 3)).copy()
    del tmp130
    tmp129 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (3, 4), (2, 0, 1, 4))
    rdm2.aaaa.vvvv = einsum(t1.aa, (0, 1), tmp129, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    rdm2.aaaa.vvvo = tmp129.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.aaaa.vvov = tmp129.transpose((2, 1, 0, 3)).copy() * -2
    del tmp129
    tmp132 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.aaaa.vvvv += tmp132.transpose((1, 0, 3, 2))
    rdm2.aaaa.vvvv += tmp132.transpose((1, 0, 3, 2))
    del tmp132
    tmp124 = tmp108.copy() * 0.5
    tmp124 += tmp80 * 0.5
    tmp124 += tmp81
    rdm2.bbbb.vovv = einsum(t1.bb, (0, 1), tmp124, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.ovvv = einsum(t1.bb, (0, 1), tmp124, (2, 3), (0, 2, 3, 1)) * -2
    del tmp124
    tmp123 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    rdm2.bbbb.vovv += tmp123.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp123.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp123.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp123.transpose((0, 1, 3, 2)) * -1
    del tmp123
    tmp128 = einsum(tmp111, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * -1
    del tmp111
    rdm2.bbbb.vovv += tmp128.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv += tmp128.transpose((0, 1, 3, 2)) * -2
    del tmp128
    tmp127 = einsum(tmp19, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    del tmp19
    rdm2.bbbb.vovv += tmp127.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp127.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp127.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp127.transpose((0, 1, 3, 2)) * -1
    del tmp127
    tmp109 = tmp108.copy()
    del tmp108
    tmp109 += tmp80
    tmp109 += tmp81 * 2
    rdm2.bbbb.vovv += einsum(tmp109, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvv += einsum(tmp109, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvv += einsum(tmp109, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vovo += einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvo += einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovov += einsum(tmp109, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp109
    tmp126 = einsum(t1.bb, (0, 1), tmp88, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp88
    rdm2.bbbb.vovv += tmp126.transpose((2, 0, 3, 1)) * -1
    rdm2.bbbb.vovv += tmp126.transpose((2, 0, 1, 3))
    rdm2.bbbb.ovvv += tmp126.transpose((0, 2, 3, 1))
    del tmp126
    tmp115 = einsum(t1.bb, (0, 1), tmp14, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp115, (0, 2, 3, 4), (3, 2, 1, 4)) * -1
    rdm2.abab.voov += tmp115.transpose((2, 1, 0, 3)) * -1
    del tmp115
    tmp89 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    rdm2.abab.vovv += einsum(t1.bb, (0, 1), tmp89, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    rdm2.abab.vovo += tmp89.transpose((2, 1, 3, 0)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 4, 2, 5), (0, 4, 5, 3))
    del tmp89
    tmp114 = tmp105.copy() * 0.5
    tmp114 += tmp63
    tmp114 += tmp64 * 0.5
    rdm2.abab.vovv += einsum(t1.bb, (0, 1), tmp114, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.aaaa.vovo += einsum(delta.aa.oo, (0, 1), tmp114, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.aaaa.voov += einsum(delta.aa.oo, (0, 1), tmp114, (2, 3), (2, 0, 1, 3)) * -2
    del tmp114
    tmp85 = tmp83.copy()
    tmp85 += tmp84
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp85, (0, 2, 3, 4), (3, 2, 1, 4)) * 2
    rdm2.abab.oovv += einsum(tmp85, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 4
    del tmp85
    tmp119 = einsum(tmp118, (0, 1, 2, 3), t1.aa, (0, 4), (1, 4, 2, 3))
    del tmp118
    rdm2.aaaa.vovv = tmp119.transpose((2, 0, 3, 1)).copy() * -1
    rdm2.aaaa.vovv += tmp119.transpose((2, 0, 1, 3))
    rdm2.aaaa.ovvv = tmp119.transpose((0, 2, 3, 1)).copy()
    del tmp119
    tmp116 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.aaaa.vovv += tmp116.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp116.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp116.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp116.transpose((0, 1, 3, 2)) * -1
    del tmp116
    tmp106 = tmp105.copy()
    del tmp105
    tmp106 += tmp63 * 2
    tmp106 += tmp64
    rdm2.aaaa.vovv += einsum(tmp106, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovv += einsum(t1.aa, (0, 1), tmp106, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvv += einsum(tmp106, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp106, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovo += einsum(delta.bb.oo, (0, 1), tmp106, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.ovvo += einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovov += einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp106
    tmp121 = einsum(tmp107, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    del tmp107
    rdm2.aaaa.vovv += tmp121.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.ovvv += tmp121.transpose((0, 1, 3, 2)) * -2
    del tmp121
    tmp120 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    del tmp6
    rdm2.aaaa.vovv += tmp120.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp120.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp120.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp120.transpose((0, 1, 3, 2)) * -1
    del tmp120
    tmp125 = tmp86.copy()
    del tmp86
    tmp125 += tmp87 * 4
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp125, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp125
    tmp122 = tmp112.copy()
    del tmp112
    tmp122 += tmp66
    rdm2.abab.ovvv += einsum(tmp122, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    del tmp122
    tmp113 = einsum(t1.aa, (0, 1), tmp27, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ovvv += einsum(tmp113, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.abab.ovvo += tmp113.transpose((0, 3, 2, 1)) * -1
    del tmp113
    tmp110 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    rdm2.abab.ovvv += einsum(tmp110, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.ovov += tmp110.transpose((1, 2, 0, 3)) * -1
    del tmp110
    tmp117 = tmp68.copy() * 4
    tmp117 += tmp70
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp117, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp117
    tmp104 = einsum(tmp103, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3))
    del tmp103
    rdm2.bbbb.oovv = tmp104.transpose((0, 1, 3, 2)).copy()
    rdm2.bbbb.oovv += tmp104.transpose((1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp104 * -1
    rdm2.bbbb.oovv += tmp104.transpose((1, 0, 2, 3))
    del tmp104
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), tmp83, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp83
    rdm2.bbbb.oovv += tmp94.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp94.transpose((0, 1, 3, 2)) * -2
    del tmp94
    tmp95 = einsum(t2.bbbb, (0, 1, 2, 3), tmp87, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp87
    rdm2.bbbb.oovv += tmp95 * 8
    rdm2.bbbb.oovv += tmp95.transpose((0, 1, 3, 2)) * -8
    del tmp95
    tmp93 = einsum(t2.bbbb, (0, 1, 2, 3), tmp92, (3, 4), (0, 1, 2, 4)) * -2
    del tmp92
    rdm2.bbbb.oovv += tmp93.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp93.transpose((1, 0, 2, 3)) * -1
    del tmp93
    tmp96 = einsum(tmp84, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp84
    rdm2.bbbb.oovv += tmp96.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp96 * 2
    rdm2.bbbb.oovv += tmp96.transpose((1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp96.transpose((0, 1, 3, 2)) * -2
    del tmp96
    tmp102 = einsum(t1.bb, (0, 1), tmp52, (0, 2, 3, 4), (2, 4, 3, 1))
    rdm2.bbbb.oovv += einsum(tmp102, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    del tmp102
    tmp99 = einsum(tmp49, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3))
    del tmp49
    rdm2.bbbb.oovv += tmp99.transpose((0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += tmp99 * 2
    del tmp99
    tmp101 = einsum(tmp52, (0, 1, 2, 3), t2.bbbb, (0, 1, 4, 5), (2, 3, 4, 5))
    rdm2.bbbb.oovv += tmp101.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp101.transpose((1, 0, 3, 2))
    del tmp101
    tmp61 = tmp39.copy()
    tmp61 += tmp40 * 2
    tmp61 += tmp60
    del tmp60
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp61, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp61, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += einsum(tmp61, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp61, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp61, (2, 3), (0, 2, 3, 1))
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp61, (2, 3), (2, 0, 3, 1)) * -1
    del tmp61
    tmp98 = tmp35.copy()
    tmp98 += tmp36 * 2
    rdm2.bbbb.oovv += einsum(tmp98, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp98, (2, 3), (2, 0, 3, 1))
    del tmp98
    tmp100 = einsum(tmp62, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -2
    del tmp62
    rdm2.bbbb.oovv += tmp100.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp100.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp100.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp100.transpose((0, 1, 3, 2)) * -1
    del tmp100
    tmp37 = t1.bb.copy()
    tmp37 += tmp35
    tmp37 += tmp36 * 2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp37, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp37, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ooov += einsum(tmp37, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp37
    tmp97 = t1.bb.copy() * 0.5
    tmp97 += tmp35 * 0.5
    tmp97 += tmp36
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp97, (2, 3), (2, 0, 1, 3)) * -2
    del tmp97
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    rdm2.abab.oovv += einsum(tmp56, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    rdm2.abab.oovo += tmp56.transpose((0, 2, 3, 1)) * -1
    del tmp56
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (0, 4, 5, 3), (4, 5, 1, 2))
    del tmp27
    rdm2.abab.oovv += einsum(tmp59, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.abab.oovo += tmp59.transpose((0, 2, 3, 1))
    del tmp59
    tmp46 = einsum(t1.bb, (0, 1), tmp45, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp45
    rdm2.abab.oovv += einsum(tmp46, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.ooov += tmp46.transpose((1, 2, 0, 3))
    del tmp46
    tmp47 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp14
    rdm2.abab.oovv += einsum(tmp47, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.ooov += tmp47.transpose((1, 2, 0, 3))
    del tmp47
    tmp38 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    rdm2.abab.oovv += einsum(tmp38, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.ooov += tmp38.transpose((1, 2, 0, 3)) * -1
    del tmp38
    tmp55 = tmp26.copy()
    tmp55 += tmp28 * 0.5
    tmp55 += tmp54
    del tmp54
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp55, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovv = einsum(tmp55, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp55, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.oovo += einsum(delta.bb.oo, (0, 1), tmp55, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp55, (2, 3), (0, 2, 3, 1)) * 2
    del tmp55
    tmp72 = tmp21.copy() * 2
    tmp72 += tmp22
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp72, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp72, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp72, (2, 3), (2, 0, 3, 1))
    del tmp72
    tmp91 = tmp57.copy()
    del tmp57
    tmp91 += tmp58
    del tmp58
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp91, (2, 0, 3, 4), (2, 3, 4, 1)) * -2
    del tmp91
    tmp42 = tmp39.copy() * 0.5
    del tmp39
    tmp42 += tmp40
    del tmp40
    tmp42 += tmp41
    del tmp41
    rdm2.abab.oovv += einsum(tmp42, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp42, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.abab.ooov += einsum(delta.aa.oo, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -2
    del tmp42
    tmp90 = tmp44.copy()
    del tmp44
    tmp90 += tmp43
    del tmp43
    rdm2.abab.oovv += einsum(tmp90, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -2
    del tmp90
    tmp65 = tmp63.copy()
    tmp65 += tmp64 * 0.5
    rdm2.abab.oovv += einsum(tmp65, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp65, (3, 4), (0, 1, 2, 4)) * -4
    del tmp65
    tmp82 = tmp80.copy() * 0.5
    del tmp80
    tmp82 += tmp81
    del tmp81
    rdm2.abab.oovv += einsum(tmp82, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp82
    tmp30 = tmp26.copy() * 2
    del tmp26
    tmp30 += tmp28
    del tmp28
    tmp30 += tmp29
    del tmp29
    rdm2.aaaa.oovv += einsum(tmp30, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp30, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.oovo += einsum(tmp30, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp30, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.ooov += einsum(tmp30, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1))
    del tmp30
    tmp73 = einsum(t1.aa, (0, 1), tmp25, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp25
    rdm2.aaaa.oovv += tmp73.transpose((0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += tmp73 * 2
    del tmp73
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp66
    rdm2.aaaa.oovv += tmp67 * 2
    rdm2.aaaa.oovv += tmp67.transpose((0, 1, 3, 2)) * -2
    del tmp67
    tmp79 = einsum(tmp78, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp78
    rdm2.aaaa.oovv += tmp79.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp79.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp79 * -1
    rdm2.aaaa.oovv += tmp79.transpose((1, 0, 2, 3))
    del tmp79
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), tmp33, (0, 1, 4, 5), (4, 5, 2, 3))
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2))
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2))
    del tmp76
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp68
    rdm2.aaaa.oovv += tmp69 * 8
    rdm2.aaaa.oovv += tmp69.transpose((0, 1, 3, 2)) * -8
    del tmp69
    tmp75 = einsum(tmp4, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4)) * -1
    del tmp4
    rdm2.aaaa.oovv += tmp75.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp75.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp75.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp75.transpose((1, 0, 3, 2)) * -1
    del tmp75
    tmp23 = t1.aa.copy()
    tmp23 += tmp21 * 2
    tmp23 += tmp22
    rdm2.aaaa.oovv += einsum(tmp23, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.abab.oovo += einsum(delta.bb.oo, (0, 1), tmp23, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (2, 0, 1, 3)) * -1
    del tmp23
    tmp77 = einsum(t1.aa, (0, 1), tmp33, (0, 2, 3, 4), (2, 4, 3, 1))
    rdm2.aaaa.oovv += einsum(tmp77, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    del tmp77
    tmp74 = tmp63.copy() * 2
    del tmp63
    tmp74 += tmp64
    del tmp64
    rdm2.aaaa.oovv += einsum(tmp74, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp74
    tmp71 = einsum(tmp70, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp70
    rdm2.aaaa.oovv += tmp71.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += tmp71 * 2
    rdm2.aaaa.oovv += tmp71.transpose((1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp71.transpose((0, 1, 3, 2)) * -2
    del tmp71
    tmp24 = t1.aa.copy()
    tmp24 += tmp21 * 2
    del tmp21
    tmp24 += tmp22
    del tmp22
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp24, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp24, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp24, (2, 3), (0, 2, 1, 3))
    del tmp24
    tmp53 = einsum(t1.bb, (0, 1), tmp52, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp52
    rdm2.bbbb.oovo += tmp53.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov += tmp53.transpose((2, 1, 0, 3))
    del tmp53
    tmp48 = t1.bb.copy()
    tmp48 += tmp35
    del tmp35
    tmp48 += tmp36 * 2
    del tmp36
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp48, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp48, (2, 3), (2, 0, 1, 3)) * -1
    del tmp48
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * 2
    del tmp33
    rdm2.aaaa.oovo += tmp34.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.ooov += tmp34.transpose((2, 1, 0, 3))
    del tmp34
    tmp11 = delta.bb.oo.copy() * -0.5
    tmp11 += tmp8 * 0.5
    tmp11 += tmp9 * 0.5
    tmp11 += tmp10
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.abab.oooo += einsum(delta.aa.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -2
    del tmp11
    tmp16 = delta.bb.oo.copy() * -1
    tmp16 += tmp8
    del tmp8
    tmp16 += tmp9
    del tmp9
    tmp16 += tmp10 * 2
    del tmp10
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0))
    del tmp16
    tmp3 = delta.aa.oo.copy() * -0.5
    tmp3 += tmp0 * 0.5
    del tmp0
    tmp3 += tmp1
    del tmp1
    tmp3 += tmp2 * 0.5
    del tmp2
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -2
    del tmp3
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovoo += einsum(delta.aa.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.vooo += einsum(delta.bb.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 1, 3)) * -1
    del delta
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.abab.oovv += t2.abab
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.aaaa.ovov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvo += einsum(t1.aa, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.voov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.voov += einsum(t1.bb, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.vvoo = l2.aaaa.copy()
    rdm2.aaaa.vvoo += l2.aaaa
    rdm2.abab.vvoo = l2.abab.copy()
    rdm2.bbbb.vvoo = l2.bbbb.copy()
    rdm2.bbbb.vvoo += l2.bbbb
    rdm2.abab.ovvv += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.abab.vovv += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4))
    rdm2.abab.vvvo = einsum(t1.aa, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    rdm2.abab.vvvv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=rdm2.aaaa.swapaxes(1, 2),
        aabb=rdm2.abab.swapaxes(1, 2),
        bbbb=rdm2.bbbb.swapaxes(1, 2),
    )

    return rdm2

