"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:28:14.055569
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:28:14.611214.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 2, 1, 3), ())

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:28:28.193149.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t2new = Namespace()
    tmp46 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp46 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp9 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp9 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp30 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp30 += v.aaaa.ovov.transpose((0, 2, 1, 3)) * -1
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp35 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp47 = einsum(t2.bbbb, (0, 1, 2, 3), tmp46, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp46
    tmp13 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp13 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp19 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 3, 1), (4, 0)) * -1
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp10 = einsum(tmp9, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp9
    tmp53 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp50 = einsum(t2.abab, (0, 1, 2, 3), tmp30, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp27 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    t2new.abab = tmp27.copy() * 2
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp24 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp55 = tmp35.copy()
    tmp55 += tmp36 * 2
    tmp48 = v.bbbb.oovv.copy()
    tmp48 += tmp47 * -2
    del tmp47
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp2 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp14 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp13
    tmp32 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    t2new.abab += tmp32 * 2
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.aaaa = tmp6.copy()
    t2new.aaaa += tmp6.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp6.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp6.transpose((1, 0, 3, 2))
    tmp17 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp21 = tmp19.copy()
    tmp21 += tmp20 * 0.5
    tmp11 = v.aaaa.oovv.copy()
    tmp11 += tmp10 * -2
    del tmp10
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.bbbb = tmp43.copy() * 2
    t2new.bbbb += tmp43.transpose((0, 1, 3, 2)) * -2
    t2new.bbbb += tmp43.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp43.transpose((1, 0, 3, 2)) * 2
    del tmp43
    tmp54 = einsum(t2.bbbb, (0, 1, 2, 3), tmp53, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp53
    t2new.bbbb += tmp54.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp54.transpose((0, 1, 3, 2)) * -1
    del tmp54
    tmp51 = einsum(t2.abab, (0, 1, 2, 3), tmp50, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp50
    t2new.bbbb += tmp51
    t2new.bbbb += tmp51.transpose((1, 0, 2, 3)) * -1
    del tmp51
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    t2new.bbbb += tmp42
    t2new.bbbb += tmp42.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp42.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp42.transpose((1, 0, 3, 2))
    del tmp42
    tmp45 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp27
    t2new.bbbb += tmp45.transpose((1, 0, 3, 2)) * 2
    t2new.bbbb += tmp45 * 2
    t2new.bbbb += tmp45.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp45.transpose((0, 1, 3, 2)) * -2
    del tmp45
    tmp39 = einsum(f.bb.oo, (0, 1), t2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4))
    t2new.bbbb += tmp39.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp39.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp39.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp39.transpose((1, 0, 3, 2))
    del tmp39
    tmp41 = tmp24.copy() * 0.5
    tmp41 += tmp25
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp41, (4, 3), (0, 1, 2, 4)) * -4
    del tmp41
    tmp56 = einsum(t2.bbbb, (0, 1, 2, 3), tmp55, (4, 1), (0, 4, 2, 3)) * -1
    del tmp55
    t2new.bbbb += tmp56.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp56.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp56.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp56.transpose((0, 1, 3, 2)) * -1
    del tmp56
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), tmp48, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp48
    t2new.bbbb += tmp49.transpose((1, 0, 3, 2)) * -2
    t2new.bbbb += tmp49.transpose((0, 1, 3, 2)) * 2
    del tmp49
    tmp40 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    t2new.bbbb += tmp40.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp40.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp40.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp40.transpose((1, 0, 3, 2)) * 0.5
    del tmp40
    tmp44 = f.bb.vv.copy() * -1
    tmp44 += tmp24
    tmp44 += tmp25 * 2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp44, (4, 3), (0, 1, 4, 2)) * 2
    del tmp44
    tmp52 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    t2new.bbbb += tmp52.transpose((1, 0, 2, 3)) * 2
    t2new.bbbb += tmp52 * -2
    del tmp52
    tmp23 = einsum(v.aabb.oooo, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    t2new.abab += tmp23 * 0.5
    t2new.abab += tmp23 * 0.5
    del tmp23
    tmp28 = f.aa.vv.copy() * -1
    tmp28 += tmp2.transpose((1, 0)) * 2
    tmp28 += tmp3.transpose((1, 0))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp28, (2, 4), (0, 1, 4, 3)) * -1
    del tmp28
    tmp29 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy()
    tmp29 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (5, 1, 4, 2)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp29, (1, 4, 2, 5), (0, 4, 5, 3)) * -1
    del tmp29
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    t2new.abab += einsum(tmp34, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp34
    tmp33 = tmp32.copy() * 2
    del tmp32
    tmp33 += tmp14 * -1
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp33, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp33
    tmp37 = tmp35.copy() * 0.5
    del tmp35
    tmp37 += tmp36
    del tmp36
    t2new.abab += einsum(tmp37, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -2
    del tmp37
    tmp31 = v.aaaa.oovv.copy()
    tmp31 += tmp6.transpose((1, 0, 3, 2)) * -1
    tmp31 += einsum(tmp30, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (1, 4, 3, 5)) * 2
    del tmp30
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp31, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp31
    tmp38 = tmp19.copy() * 2
    del tmp19
    tmp38 += tmp20
    del tmp20
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp38, (4, 0), (4, 1, 2, 3)) * -1
    del tmp38
    tmp26 = tmp24.copy()
    del tmp24
    tmp26 += tmp25 * 2
    del tmp25
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 3), (0, 1, 2, 4)) * -1
    del tmp26
    tmp1 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t2.aaaa, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    t2new.aaaa += tmp1.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp1.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp1.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp1.transpose((1, 0, 3, 2)) * 0.5
    del tmp1
    tmp16 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    t2new.aaaa += tmp16.transpose((1, 0, 2, 3)) * 2
    t2new.aaaa += tmp16 * -2
    del tmp16
    tmp4 = tmp2.copy()
    tmp4 += tmp3 * 0.5
    t2new.aaaa += einsum(tmp4, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp4
    tmp8 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp6
    t2new.aaaa += tmp8.transpose((1, 0, 3, 2)) * 2
    t2new.aaaa += tmp8 * 2
    t2new.aaaa += tmp8.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp8.transpose((0, 1, 3, 2)) * -2
    del tmp8
    tmp15 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp14
    t2new.aaaa += tmp15.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp15.transpose((1, 0, 2, 3)) * -1
    del tmp15
    tmp18 = einsum(tmp17, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp17
    t2new.aaaa += tmp18.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp18.transpose((0, 1, 3, 2)) * -1
    del tmp18
    tmp5 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.aaaa += tmp5 * 2
    t2new.aaaa += tmp5.transpose((0, 1, 3, 2)) * -2
    t2new.aaaa += tmp5.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp5.transpose((1, 0, 3, 2)) * 2
    del tmp5
    tmp0 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.oo, (4, 1), (4, 0, 2, 3))
    t2new.aaaa += tmp0.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp0.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp0.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp0.transpose((1, 0, 3, 2))
    del tmp0
    tmp7 = f.aa.vv.copy() * -1
    tmp7 += tmp2 * 2
    del tmp2
    tmp7 += tmp3
    del tmp3
    t2new.aaaa += einsum(tmp7, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp7
    tmp22 = einsum(tmp21, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4)) * -2
    del tmp21
    t2new.aaaa += tmp22.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp22.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp22.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp22.transpose((1, 0, 3, 2)) * -1
    del tmp22
    tmp12 = einsum(tmp11, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp11
    t2new.aaaa += tmp12.transpose((1, 0, 3, 2)) * -2
    t2new.aaaa += tmp12.transpose((0, 1, 3, 2)) * 2
    del tmp12
    t2new.aaaa += einsum(f.aa.vv, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * 2
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 1, 3))
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 3, 1)) * -1
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.vvvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -2
    t2new.abab += einsum(f.bb.oo, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.aa.oo, (4, 0), (4, 1, 2, 3)) * -1
    t2new.abab += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    t2new.abab += einsum(f.bb.vv, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 4, 0))
    t2new.abab += v.aabb.ovov.transpose((0, 2, 1, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.bbbb.oovv, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    t2new.abab += einsum(v.aabb.oovv, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    t2new.abab += einsum(v.aabb.vvvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 0, 2))
    t2new.bbbb += einsum(f.bb.vv, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * 2
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 1, 3))
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 3, 1)) * -1
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.vvvv, (4, 2, 5, 3), (0, 1, 4, 5)) * 2

    return {f"t2new": t2new}

def update_lams(f=None, l2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:28:52.133674.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l2new = Namespace()
    tmp49 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp50 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp36 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp37 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp53 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp52 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp58 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp57 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp77 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp46 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 1), (4, 3)) * -1
    tmp45 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp7 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp8 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp4 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp31 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp30 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp19 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 1), (4, 3)) * -1
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp26 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp27 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp64 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp64 += v.bbbb.oovv * -1
    tmp64 += tmp49
    tmp64 += tmp50 * 2
    tmp62 = tmp36.copy()
    tmp62 += tmp37 * 2
    tmp54 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp54 += tmp52 * 2
    del tmp52
    tmp54 += tmp53
    del tmp53
    l2new.abab = einsum(l2.aaaa, (0, 1, 2, 3), tmp54, (3, 4, 1, 5), (0, 5, 2, 4)) * 2
    tmp81 = tmp57.copy() * 0.5
    tmp81 += tmp58
    tmp78 = tmp76.copy()
    del tmp76
    tmp78 += tmp77 * 4
    del tmp77
    tmp39 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp40 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 1, 3), (0, 4))
    tmp59 = tmp57.copy()
    del tmp57
    tmp59 += tmp58 * 2
    del tmp58
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp59, (4, 2), (1, 3, 0, 4)) * -1
    tmp69 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp51 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp51 += v.bbbb.oovv * -1
    tmp51 += tmp49
    del tmp49
    tmp51 += tmp50 * 2
    del tmp50
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp51, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp71 = f.bb.vv.copy() * -0.5
    tmp71 += tmp45 * 0.5
    tmp71 += tmp46
    tmp11 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp1 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp0 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp43 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp9 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp9 += tmp7
    del tmp7
    tmp9 += tmp8 * 2
    del tmp8
    l2new.abab += einsum(tmp9, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5)) * 2
    tmp17 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp24 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp24 += v.aaaa.oovv * -1
    tmp24 += tmp4 * 2
    tmp24 += tmp5
    tmp32 = tmp30.copy()
    tmp32 += tmp31 * 0.5
    tmp21 = f.aa.vv.copy() * -0.5
    tmp21 += tmp19
    del tmp19
    tmp21 += tmp20 * 0.5
    del tmp20
    l2new.abab += einsum(tmp21, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -2
    tmp28 = tmp26.copy() * 4
    del tmp26
    tmp28 += tmp27
    del tmp27
    tmp34 = tmp30.copy() * 2
    del tmp30
    tmp34 += tmp31
    del tmp31
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp34, (4, 0), (1, 3, 4, 2)) * -1
    tmp65 = einsum(tmp64, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 0), (5, 1, 4, 3)) * 2
    del tmp64
    l2new.bbbb = tmp65.transpose((3, 2, 1, 0)).copy()
    l2new.bbbb += tmp65.transpose((3, 2, 0, 1)) * -1
    del tmp65
    tmp63 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp62, (4, 1), (0, 2, 4, 3))
    l2new.bbbb += tmp63.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp63.transpose((3, 2, 1, 0)) * -1
    del tmp63
    tmp66 = einsum(l2.abab, (0, 1, 2, 3), tmp54, (2, 4, 0, 5), (4, 3, 5, 1))
    del tmp54
    l2new.bbbb += tmp66.transpose((3, 2, 0, 1)) * -1
    l2new.bbbb += tmp66.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp66.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp66.transpose((2, 3, 1, 0)) * -1
    del tmp66
    tmp74 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp62, (4, 3), (0, 2, 4, 1))
    del tmp62
    l2new.bbbb += tmp74.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp74.transpose((3, 2, 1, 0))
    del tmp74
    tmp68 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), l2.bbbb, (3, 1, 4, 5), (4, 5, 0, 2)) * -1
    l2new.bbbb += tmp68.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp68.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp68.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp68.transpose((3, 2, 1, 0)) * 0.5
    del tmp68
    tmp82 = einsum(tmp81, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (0, 2, 4, 3)) * 2
    del tmp81
    l2new.bbbb += tmp82.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp82.transpose((2, 3, 1, 0))
    del tmp82
    tmp79 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp78, (4, 2, 5, 1), (4, 0, 5, 3))
    del tmp78
    l2new.bbbb += tmp79.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp79.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp79.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp79.transpose((3, 2, 0, 1))
    del tmp79
    tmp41 = f.bb.oo.copy()
    tmp41 += tmp39
    tmp41 += tmp40 * 2
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp41, (3, 4), (0, 1, 2, 4)) * -2
    l2new.abab += einsum(tmp41, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp41
    tmp80 = einsum(tmp59, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (0, 2, 4, 3))
    del tmp59
    l2new.bbbb += tmp80.transpose((3, 2, 0, 1))
    l2new.bbbb += tmp80.transpose((2, 3, 0, 1)) * -1
    del tmp80
    tmp73 = v.bbbb.oooo.copy()
    tmp73 += einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 0, 2, 5)) * -1
    l2new.bbbb += einsum(tmp73, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 3), (4, 5, 2, 1)) * -2
    del tmp73
    tmp70 = einsum(tmp69, (0, 1, 2, 3), v.bbbb.ovov, (3, 4, 2, 5), (1, 0, 5, 4)) * -1
    del tmp69
    l2new.bbbb += tmp70.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp70.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp70.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp70.transpose((3, 2, 1, 0)) * 0.5
    del tmp70
    tmp67 = f.bb.oo.copy() * 0.5
    tmp67 += tmp39 * 0.5
    del tmp39
    tmp67 += tmp40
    del tmp40
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp67, (3, 4), (0, 1, 4, 2)) * 4
    del tmp67
    tmp75 = einsum(l2.bbbb, (0, 1, 2, 3), tmp51, (3, 4, 1, 5), (2, 4, 0, 5))
    del tmp51
    l2new.bbbb += tmp75.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp75.transpose((2, 3, 0, 1)) * 2
    del tmp75
    tmp72 = einsum(l2.bbbb, (0, 1, 2, 3), tmp71, (1, 4), (2, 3, 0, 4)) * -2
    del tmp71
    l2new.bbbb += tmp72.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp72.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp72.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp72.transpose((3, 2, 1, 0))
    del tmp72
    tmp15 = f.aa.oo.copy()
    tmp15 += tmp11 * 2
    tmp15 += tmp12
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp15, (2, 4), (0, 1, 4, 3)) * -1
    l2new.aaaa = einsum(tmp15, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp15
    tmp3 = tmp0.copy() * 2
    tmp3 += tmp1
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp3, (4, 1), (4, 3, 0, 2)) * -1
    l2new.aaaa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp3, (4, 1), (3, 4, 0, 2))
    l2new.aaaa += einsum(tmp3, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 3, 2, 4))
    del tmp3
    tmp42 = einsum(l2.abab, (0, 1, 2, 3), v.aabb.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    l2new.abab += tmp42.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp42.transpose((2, 3, 0, 1)) * 0.5
    del tmp42
    tmp60 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp60 += einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    l2new.abab += einsum(tmp60, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 0, 5), (5, 3, 4, 1)) * -2
    del tmp60
    tmp47 = f.bb.vv.copy() * -1
    tmp47 += tmp45
    del tmp45
    tmp47 += tmp46 * 2
    del tmp46
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp47, (1, 4), (0, 4, 2, 3)) * -1
    del tmp47
    tmp55 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp55, (3, 4, 0, 5), (5, 1, 2, 4))
    del tmp55
    tmp48 = v.aabb.oooo.copy()
    tmp48 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp48, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp48
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    l2new.abab += einsum(tmp56, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5))
    del tmp56
    tmp44 = einsum(tmp43, (0, 1, 2, 3), v.aabb.ovov, (1, 4, 3, 5), (0, 2, 4, 5))
    del tmp43
    l2new.abab += tmp44.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp44.transpose((2, 3, 0, 1)) * 0.5
    del tmp44
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp61 += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    l2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp61, (4, 2, 5, 1), (5, 3, 4, 0)) * -2
    del tmp61
    tmp38 = tmp36.copy() * 0.5
    del tmp36
    tmp38 += tmp37
    del tmp37
    l2new.abab += einsum(tmp38, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (3, 0, 2, 4)) * -2
    del tmp38
    tmp14 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp14 += v.aaaa.oovv * -1
    tmp14 += tmp4 * 2
    tmp14 += tmp5
    l2new.abab += einsum(tmp14, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    l2new.aaaa += einsum(tmp14, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (3, 4, 1, 5)) * 2
    del tmp14
    tmp10 = einsum(tmp9, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (0, 5, 2, 4))
    del tmp9
    l2new.aaaa += tmp10.transpose((3, 2, 0, 1)) * -1
    l2new.aaaa += tmp10.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp10.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp10.transpose((2, 3, 1, 0)) * -1
    del tmp10
    tmp6 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy() * 0.5
    tmp6 += v.aaaa.oovv * -0.5
    tmp6 += tmp4
    del tmp4
    tmp6 += tmp5 * 0.5
    del tmp5
    l2new.aaaa += einsum(tmp6, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (3, 4, 5, 1)) * -4
    del tmp6
    tmp23 = v.aaaa.oooo.copy()
    tmp23 += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 0, 2, 5)) * -1
    l2new.aaaa += einsum(tmp23, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 3), (4, 5, 2, 1)) * -2
    del tmp23
    tmp13 = f.aa.oo.copy() * 0.5
    tmp13 += tmp11
    del tmp11
    tmp13 += tmp12 * 0.5
    del tmp12
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp13, (3, 4), (0, 1, 2, 4)) * -4
    del tmp13
    tmp18 = einsum(tmp17, (0, 1, 2, 3), v.aaaa.ovov, (3, 4, 2, 5), (1, 0, 5, 4)) * -1
    del tmp17
    l2new.aaaa += tmp18.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp18.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp18.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp18.transpose((3, 2, 1, 0)) * 0.5
    del tmp18
    tmp25 = einsum(tmp24, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (1, 5, 3, 4))
    del tmp24
    l2new.aaaa += tmp25.transpose((3, 2, 0, 1)) * -2
    l2new.aaaa += tmp25.transpose((3, 2, 1, 0)) * 2
    del tmp25
    tmp33 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp32, (4, 2), (4, 0, 3, 1)) * 2
    del tmp32
    l2new.aaaa += tmp33.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp33.transpose((2, 3, 0, 1)) * -1
    del tmp33
    tmp22 = einsum(l2.aaaa, (0, 1, 2, 3), tmp21, (1, 4), (2, 3, 4, 0)) * -2
    del tmp21
    l2new.aaaa += tmp22.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp22.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp22.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp22.transpose((2, 3, 1, 0))
    del tmp22
    tmp29 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp28, (4, 2, 5, 1), (4, 0, 5, 3))
    del tmp28
    l2new.aaaa += tmp29.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp29.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp29.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp29.transpose((3, 2, 0, 1))
    del tmp29
    tmp35 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp34, (4, 2), (4, 0, 3, 1))
    del tmp34
    l2new.aaaa += tmp35.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp35.transpose((2, 3, 1, 0))
    del tmp35
    tmp16 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), l2.aaaa, (1, 3, 4, 5), (4, 5, 0, 2))
    l2new.aaaa += tmp16.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp16.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp16.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp16.transpose((3, 2, 1, 0)) * 0.5
    del tmp16
    tmp2 = tmp0.copy()
    del tmp0
    tmp2 += tmp1 * 0.5
    del tmp1
    l2new.aaaa += einsum(tmp2, (0, 1), v.aaaa.ovov, (2, 1, 3, 4), (0, 4, 2, 3)) * -2
    l2new.aaaa += einsum(tmp2, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (3, 0, 2, 4)) * -2
    del tmp2
    l2new.aaaa += v.aaaa.ovov.transpose((1, 3, 0, 2))
    l2new.aaaa += v.aaaa.ovov.transpose((3, 1, 0, 2)) * -1
    l2new.abab += v.aabb.ovov.transpose((1, 3, 0, 2))
    l2new.abab += einsum(v.aabb.vvoo, (0, 1, 2, 3), l2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    l2new.abab += einsum(v.aabb.oovv, (0, 1, 2, 3), l2.abab, (4, 3, 1, 5), (4, 2, 0, 5)) * -1
    l2new.bbbb += v.bbbb.ovov.transpose((1, 3, 0, 2))
    l2new.bbbb += v.bbbb.ovov.transpose((3, 1, 0, 2)) * -1

    return {f"l2new": l2new}

def make_rdm1_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:28:53.157873.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    rdm1.aa.oo = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (4, 2)) * -2
    rdm1.aa.oo += delta.aa.oo
    rdm1.aa.oo += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (4, 2)) * -1
    rdm1.bb.oo = delta.bb.oo.copy()
    del delta
    rdm1.bb.oo += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (4, 2)) * -2
    rdm1.bb.oo += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (1, 4)) * -1
    rdm1.aa.vv = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.bb.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa.ov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm1.aa.vo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm1.bb.ov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm1.bb.vo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:29:08.888508.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp5 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp6 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp25 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp26 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp14 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp13 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    rdm2.bbbb.vovo = tmp40.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.bbbb.voov = tmp40.transpose((2, 1, 0, 3)).copy()
    rdm2.bbbb.ovvo = tmp40.transpose((1, 2, 3, 0)).copy()
    rdm2.bbbb.ovov = tmp40.transpose((1, 2, 0, 3)).copy() * -1
    tmp38 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    rdm2.abab.voov = tmp38.transpose((2, 1, 0, 3)).copy() * 2
    tmp11 = tmp5.copy()
    tmp11 += tmp6 * 2
    rdm2.bbbb.oooo = einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp11, (2, 3), (3, 0, 2, 1)) * -1
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.bbbb.vovo += tmp36.transpose((2, 1, 3, 0)) * -4
    rdm2.bbbb.voov += tmp36.transpose((2, 1, 0, 3)) * 4
    rdm2.bbbb.ovvo += tmp36.transpose((1, 2, 3, 0)) * 4
    rdm2.bbbb.ovov += tmp36.transpose((1, 2, 0, 3)) * -4
    tmp12 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.bbbb.oooo += tmp12.transpose((3, 2, 1, 0))
    rdm2.bbbb.oooo += tmp12.transpose((3, 2, 1, 0))
    tmp30 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo = tmp30.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.aaaa.voov = tmp30.transpose((2, 1, 0, 3)).copy()
    rdm2.aaaa.ovvo = tmp30.transpose((1, 2, 3, 0)).copy()
    rdm2.aaaa.ovov = tmp30.transpose((1, 2, 0, 3)).copy() * -1
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.aaaa.vovo += tmp20.transpose((2, 1, 3, 0)) * -4
    rdm2.aaaa.voov += tmp20.transpose((2, 1, 0, 3)) * 4
    rdm2.aaaa.ovvo += tmp20.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ovov += tmp20.transpose((1, 2, 0, 3)) * -4
    tmp22 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    rdm2.abab.ovvo = tmp22.transpose((0, 3, 2, 1)).copy() * 2
    tmp18 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    rdm2.abab.ovvo += tmp18.transpose((0, 3, 2, 1)) * 2
    tmp4 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.aaaa.oooo = tmp4.transpose((3, 2, 1, 0)).copy()
    rdm2.aaaa.oooo += tmp4.transpose((3, 2, 1, 0))
    tmp8 = tmp0.copy()
    tmp8 += tmp1 * 0.5
    rdm2.abab.oooo = einsum(delta.bb.oo, (0, 1), tmp8, (2, 3), (3, 0, 2, 1)) * -2
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.bbbb.vvvv = tmp43.transpose((1, 0, 3, 2)).copy()
    rdm2.bbbb.vvvv += tmp43.transpose((1, 0, 3, 2))
    del tmp43
    tmp42 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa.vvvv = tmp42.transpose((1, 0, 3, 2)).copy()
    rdm2.aaaa.vvvv += tmp42.transpose((1, 0, 3, 2))
    del tmp42
    tmp27 = tmp25.copy()
    tmp27 += tmp26 * 2
    rdm2.bbbb.vovo += einsum(tmp27, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(tmp27, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.ovov = einsum(tmp27, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovv = einsum(t2.bbbb, (0, 1, 2, 3), tmp27, (3, 4), (0, 1, 4, 2)) * 2
    rdm2.abab.oovv = einsum(t2.abab, (0, 1, 2, 3), tmp27, (3, 4), (0, 1, 2, 4)) * -1
    del tmp27
    tmp15 = tmp13.copy() * 2
    tmp15 += tmp14
    rdm2.abab.vovo = einsum(delta.bb.oo, (0, 1), tmp15, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovo += einsum(tmp15, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovvo += einsum(tmp15, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp15, (2, 4), (0, 1, 4, 3)) * -1
    rdm2.aaaa.oovv = einsum(tmp15, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp15
    tmp33 = tmp25.copy() * 0.5
    del tmp25
    tmp33 += tmp26
    del tmp26
    rdm2.bbbb.voov += einsum(delta.bb.oo, (0, 1), tmp33, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.ovov += einsum(delta.bb.oo, (0, 1), tmp33, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.bbbb.oovv += einsum(tmp33, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    del tmp33
    tmp24 = tmp13.copy()
    del tmp13
    tmp24 += tmp14 * 0.5
    del tmp14
    rdm2.aaaa.voov += einsum(tmp24, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.aaaa.ovov += einsum(tmp24, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.aaaa.oovv += einsum(tmp24, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 4
    del tmp24
    tmp29 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    rdm2.abab.ovov += tmp29.transpose((1, 2, 0, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp29, (0, 4, 3, 5), (4, 1, 2, 5))
    del tmp29
    tmp41 = einsum(t2.bbbb, (0, 1, 2, 3), tmp40, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp40
    rdm2.bbbb.oovv += tmp41.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp41 * 2
    rdm2.bbbb.oovv += tmp41.transpose((1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp41.transpose((0, 1, 3, 2)) * -2
    del tmp41
    tmp39 = einsum(t2.abab, (0, 1, 2, 3), tmp38, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp38
    rdm2.bbbb.oovv += tmp39.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp39.transpose((0, 1, 3, 2)) * -2
    del tmp39
    tmp34 = einsum(tmp11, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    del tmp11
    rdm2.bbbb.oovv += tmp34.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp34.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp34.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp34.transpose((1, 0, 3, 2))
    del tmp34
    tmp37 = einsum(t2.bbbb, (0, 1, 2, 3), tmp36, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp36
    rdm2.bbbb.oovv += tmp37 * 8
    rdm2.bbbb.oovv += tmp37.transpose((0, 1, 3, 2)) * -8
    del tmp37
    tmp35 = einsum(t2.bbbb, (0, 1, 2, 3), tmp12, (1, 0, 4, 5), (5, 4, 2, 3))
    del tmp12
    rdm2.bbbb.oovv += tmp35.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp35.transpose((0, 1, 3, 2)) * -1
    del tmp35
    tmp3 = tmp0.copy() * 2
    tmp3 += tmp1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp3, (0, 4), (4, 1, 2, 3)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 2, 1))
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (1, 2, 0, 3)) * -1
    del tmp3
    tmp31 = tmp20.copy() * 4
    tmp31 += tmp30
    del tmp30
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp31, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp31
    tmp28 = tmp5.copy() * 0.5
    tmp28 += tmp6
    rdm2.abab.oovv += einsum(tmp28, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -2
    del tmp28
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    rdm2.abab.oovv += einsum(tmp9, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5))
    rdm2.abab.oooo += tmp9.transpose((1, 3, 0, 2))
    del tmp9
    tmp32 = tmp22.copy()
    tmp32 += tmp18
    rdm2.abab.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (4, 1, 5, 3), (4, 0, 5, 2)) * 4
    del tmp32
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp18
    rdm2.aaaa.oovv += tmp19 * 2
    rdm2.aaaa.oovv += tmp19.transpose((0, 1, 3, 2)) * -2
    del tmp19
    tmp17 = einsum(tmp4, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 5), (3, 2, 4, 5))
    del tmp4
    rdm2.aaaa.oovv += tmp17.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp17.transpose((0, 1, 3, 2)) * -1
    del tmp17
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), tmp8, (1, 4), (0, 4, 2, 3)) * -2
    del tmp8
    rdm2.aaaa.oovv += tmp16.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp16.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp16.transpose((1, 0, 3, 2))
    rdm2.aaaa.oovv += tmp16.transpose((1, 0, 3, 2))
    del tmp16
    tmp23 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp22
    rdm2.aaaa.oovv += tmp23.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += tmp23 * 2
    rdm2.aaaa.oovv += tmp23.transpose((1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp23.transpose((0, 1, 3, 2)) * -2
    del tmp23
    tmp21 = einsum(tmp20, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp20
    rdm2.aaaa.oovv += tmp21 * 8
    rdm2.aaaa.oovv += tmp21.transpose((0, 1, 3, 2)) * -8
    del tmp21
    tmp10 = delta.bb.oo.copy() * -0.5
    tmp10 += tmp5 * 0.5
    tmp10 += tmp6
    rdm2.bbbb.oooo += einsum(tmp10, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp10, (2, 3), (0, 3, 1, 2)) * -2
    del tmp10
    tmp7 = delta.bb.oo.copy() * -1
    tmp7 += tmp5
    del tmp5
    tmp7 += tmp6 * 2
    del tmp6
    rdm2.abab.oooo += einsum(tmp7, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -1
    del tmp7
    tmp2 = delta.aa.oo.copy() * -0.5
    tmp2 += tmp0
    del tmp0
    tmp2 += tmp1 * 0.5
    del tmp1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp2, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.aaaa.oooo += einsum(tmp2, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -2
    del delta, tmp2
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.abab.oovv += t2.abab
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.abab.voov += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (0, 4, 2, 5)) * 2
    rdm2.abab.vovo += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (4, 1, 2, 5)) * -1
    rdm2.aaaa.vvoo = l2.aaaa.copy()
    rdm2.aaaa.vvoo += l2.aaaa
    rdm2.abab.vvoo = l2.abab.copy()
    rdm2.bbbb.vvoo = l2.bbbb.copy()
    rdm2.bbbb.vvoo += l2.bbbb
    rdm2.abab.vvvv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa.ooov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.oovo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.aaaa.ovoo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.vooo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.ovvv = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vovv = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvov = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvvo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.abab.ooov = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[-1]))
    rdm2.abab.oovo = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[0]))
    rdm2.abab.ovoo = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[0]))
    rdm2.abab.vooo = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[0]))
    rdm2.abab.ovvv = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[-1]))
    rdm2.abab.vovv = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[-1]))
    rdm2.abab.vvov = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[-1]))
    rdm2.abab.vvvo = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbbb.ooov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.oovo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbbb.ovoo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.vooo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.ovvv = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vovv = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvov = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvvo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=rdm2.aaaa.swapaxes(1, 2),
        aabb=rdm2.abab.swapaxes(1, 2),
        bbbb=rdm2.bbbb.swapaxes(1, 2),
    )

    return rdm2

