"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T22:04:42.965388
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:04:44.766691.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp1 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 0, 1), (2,))
    tmp1 += tmp0 * 2
    tmp3 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2))
    tmp5 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (3, 1, 0))
    tmp2 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp2 += einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    tmp2 += einsum(tmp1, (0,), t1.aa, (1, 2), (1, 2, 0)) * 0.5
    del tmp1
    e_cc = einsum(tmp2, (0, 1, 2), v.baa.xov, (2, 0, 1), ())
    del tmp2
    tmp7 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0))
    tmp7 += einsum(tmp0, (0,), t1.bb, (1, 2), (1, 2, 0)) * 0.5
    del tmp0
    e_cc += einsum(tmp7, (0, 1, 2), v.bbb.xov, (2, 0, 1), ())
    del tmp7
    tmp4 = f.aa.ov.copy()
    tmp4 += einsum(v.baa.xov, (0, 1, 2), tmp3, (1, 3, 0), (3, 2)) * -0.5
    del tmp3
    e_cc += einsum(t1.aa, (0, 1), tmp4, (0, 1), ())
    del tmp4
    tmp6 = f.bb.ov.copy()
    tmp6 += einsum(v.bbb.xov, (0, 1, 2), tmp5, (1, 3, 0), (3, 2)) * -0.5
    del tmp5
    e_cc += einsum(tmp6, (0, 1), t1.bb, (0, 1), ())
    del tmp6

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:05:09.102167.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (3, 1, 0))
    tmp0 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2))
    tmp6 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp5 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 0, 1), (2,))
    tmp33 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (3, 1, 0))
    t1new.bb = einsum(tmp33, (0, 1, 2), v.bbb.xoo, (2, 3, 0), (3, 1)) * -1
    tmp86 = einsum(v.bbb.xoo, (0, 1, 2), tmp17, (3, 4, 0), (3, 1, 2, 4))
    tmp79 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp93 = einsum(tmp17, (0, 1, 2), tmp17, (3, 4, 2), (3, 0, 4, 1))
    tmp71 = einsum(t1.bb, (0, 1), tmp17, (2, 0, 3), (2, 1, 3))
    tmp50 = einsum(tmp0, (0, 1, 2), t1.aa, (1, 3), (0, 3, 2))
    tmp15 = einsum(t1.aa, (0, 1), v.baa.xvv, (2, 3, 1), (0, 3, 2))
    t1new.aa = einsum(tmp15, (0, 1, 2), v.baa.xoo, (2, 3, 0), (3, 1)) * -1
    tmp47 = einsum(v.baa.xoo, (0, 1, 2), tmp0, (3, 4, 0), (3, 1, 2, 4))
    tmp57 = einsum(tmp0, (0, 1, 2), tmp0, (3, 4, 2), (3, 0, 4, 1))
    tmp37 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp18 = einsum(tmp17, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3))
    tmp7 = tmp5.copy()
    tmp7 += tmp6
    tmp26 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp3 = einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), tmp0, (1, 3, 0), (3, 2))
    tmp64 = einsum(f.bb.ov, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp84 = einsum(tmp33, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp87 = einsum(tmp86, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp86
    tmp32 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (4, 0, 1, 3), (4, 2)) * -2
    tmp80 = einsum(t1.bb, (0, 1), tmp79, (2, 3, 4, 0), (3, 4, 2, 1))
    del tmp79
    tmp24 = einsum(tmp17, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 1, 4))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp24, (4, 1, 0, 3), (4, 2)) * -2
    tmp66 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    t2new.abab = einsum(tmp66, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp94 = einsum(t1.bb, (0, 1), tmp93, (2, 3, 0, 4), (3, 2, 4, 1))
    del tmp93
    tmp96 = einsum(tmp33, (0, 1, 2), tmp17, (3, 4, 2), (3, 0, 4, 1))
    tmp72 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp72 += tmp33
    tmp72 += tmp71 * -1
    t2new.abab += einsum(tmp72, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    tmp67 = einsum(v.baa.xoo, (0, 1, 2), tmp17, (3, 4, 0), (1, 2, 3, 4))
    tmp62 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp69 = tmp15.copy()
    tmp69 += tmp50 * -1
    tmp40 = einsum(f.aa.ov, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp73 = einsum(tmp0, (0, 1, 2), tmp17, (3, 4, 2), (0, 1, 3, 4))
    tmp43 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    t2new.abab += einsum(tmp43, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    del tmp47
    tmp2 = einsum(v.baa.xov, (0, 1, 2), tmp0, (3, 4, 0), (3, 1, 4, 2))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 1, 0, 3), (4, 2)) * -2
    tmp55 = einsum(tmp15, (0, 1, 2), tmp0, (3, 4, 2), (3, 0, 4, 1))
    tmp51 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp51 += tmp15
    tmp51 += tmp50 * -1
    del tmp50
    tmp58 = einsum(tmp57, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    del tmp57
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t1.aa, (3, 4), (1, 2, 0, 4))
    del tmp37
    tmp16 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp16, (4, 0, 1, 3), (4, 2)) * -2
    tmp45 = einsum(tmp15, (0, 1, 2), v.baa.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp27 = t2.bbbb.copy() * 2
    tmp27 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    tmp30 = f.bb.ov.copy()
    tmp30 += tmp18 * -1
    tmp29 = tmp26.copy()
    tmp29 += einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0)) * 2
    tmp29 += einsum(tmp7, (0,), t1.bb, (1, 2), (1, 2, 0))
    tmp19 = einsum(tmp7, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp21 = einsum(tmp7, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp4 = t2.aaaa.copy() * 2
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    tmp10 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp10 += tmp3 * 0.5
    tmp10 += einsum(t1.aa, (0, 1), tmp7, (2,), (0, 1, 2)) * 0.5
    tmp12 = f.aa.ov.copy()
    tmp12 += tmp11 * -1
    tmp65 = f.bb.vv.copy()
    tmp65 += tmp64 * -1
    t2new.bbbb = einsum(tmp65, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    t2new.abab += einsum(tmp65, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp65
    tmp85 = einsum(tmp84, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp84
    t2new.bbbb += tmp85
    t2new.bbbb += tmp85.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp85.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp85.transpose((1, 0, 3, 2))
    del tmp85
    tmp88 = einsum(t1.bb, (0, 1), tmp87, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp87
    t2new.bbbb += tmp88.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp88 * -1
    t2new.bbbb += tmp88.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp88.transpose((1, 0, 2, 3))
    del tmp88
    tmp90 = einsum(tmp32, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp32
    t2new.bbbb += tmp90.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp90 * -1
    t2new.bbbb += tmp90.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp90.transpose((0, 1, 3, 2))
    del tmp90
    tmp82 = f.bb.vv.copy()
    tmp82 += tmp64 * -1
    del tmp64
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp82, (3, 4), (0, 1, 4, 2)) * -2
    del tmp82
    tmp81 = einsum(t1.bb, (0, 1), tmp80, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp80
    t2new.bbbb += tmp81.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp81
    del tmp81
    tmp98 = einsum(tmp24, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp24
    t2new.bbbb += tmp98.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp98 * -1
    del tmp98
    tmp83 = einsum(tmp66, (0, 1), t2.bbbb, (2, 0, 3, 4), (1, 2, 3, 4))
    del tmp66
    t2new.bbbb += tmp83.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp83.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp83.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp83.transpose((1, 0, 3, 2))
    del tmp83
    tmp95 = einsum(t1.bb, (0, 1), tmp94, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp94
    t2new.bbbb += tmp95.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp95
    del tmp95
    tmp97 = einsum(t1.bb, (0, 1), tmp96, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp96
    t2new.bbbb += tmp97.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp97 * -1
    t2new.bbbb += tmp97.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp97.transpose((0, 1, 3, 2))
    del tmp97
    tmp92 = einsum(tmp33, (0, 1, 2), tmp33, (3, 4, 2), (0, 3, 1, 4))
    t2new.bbbb += tmp92.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp92
    del tmp92
    tmp89 = einsum(tmp72, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp72
    t2new.bbbb += tmp89.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp89
    del tmp89
    tmp91 = einsum(tmp33, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 4, 1))
    t2new.bbbb += tmp91.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp91.transpose((0, 1, 3, 2))
    del tmp91
    tmp78 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    t2new.bbbb += tmp78.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp78.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp78.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp78.transpose((1, 0, 3, 2))
    del tmp78
    tmp75 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp75 += tmp33
    tmp75 += tmp71 * -1
    del tmp71
    t2new.abab += einsum(tmp15, (0, 1, 2), tmp75, (3, 4, 2), (0, 3, 1, 4))
    del tmp75
    tmp68 = einsum(t1.bb, (0, 1), tmp67, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp67
    t2new.abab += einsum(tmp68, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp68
    tmp34 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    t2new.abab += einsum(t1.bb, (0, 1), tmp34, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp34, (0, 4, 1, 2), (4, 3)) * -1
    del tmp34
    tmp63 = einsum(tmp62, (0, 1, 2, 3), t1.bb, (3, 4), (1, 0, 2, 4))
    del tmp62
    t2new.abab += einsum(t1.aa, (0, 1), tmp63, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp63
    tmp70 = einsum(v.bbb.xoo, (0, 1, 2), tmp69, (3, 4, 0), (3, 1, 2, 4))
    del tmp69
    t2new.abab += einsum(tmp70, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    del tmp70
    tmp76 = einsum(tmp33, (0, 1, 2), v.baa.xoo, (2, 3, 4), (3, 4, 0, 1))
    t2new.abab += einsum(t1.aa, (0, 1), tmp76, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp76
    tmp1 = einsum(tmp0, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 1, 3, 4))
    t2new.abab += einsum(t1.aa, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp1
    tmp14 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    t2new.abab += einsum(tmp14, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    t1new.aa += einsum(tmp14, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp14
    tmp41 = f.aa.vv.copy()
    tmp41 += tmp40 * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp41, (2, 4), (0, 1, 4, 3))
    t2new.aaaa = einsum(tmp41, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp41
    tmp74 = einsum(t1.bb, (0, 1), tmp73, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp73
    t2new.abab += einsum(t1.aa, (0, 1), tmp74, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp74
    tmp77 = einsum(tmp33, (0, 1, 2), tmp0, (3, 4, 2), (3, 4, 0, 1))
    del tmp33
    t2new.abab += einsum(t1.aa, (0, 1), tmp77, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp77
    tmp54 = einsum(v.baa.xov, (0, 1, 2), tmp15, (3, 4, 0), (3, 1, 2, 4))
    t2new.aaaa += tmp54.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp54.transpose((0, 1, 3, 2))
    del tmp54
    tmp42 = f.aa.vv.copy()
    tmp42 += tmp40 * -1
    del tmp40
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp42, (3, 4), (0, 1, 2, 4)) * 2
    del tmp42
    tmp44 = einsum(t2.aaaa, (0, 1, 2, 3), tmp43, (1, 4), (4, 0, 2, 3))
    del tmp43
    t2new.aaaa += tmp44.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp44.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp44.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp44.transpose((1, 0, 3, 2))
    del tmp44
    tmp49 = einsum(t1.aa, (0, 1), tmp48, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp48
    t2new.aaaa += tmp49.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp49 * -1
    t2new.aaaa += tmp49.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp49.transpose((1, 0, 2, 3))
    del tmp49
    tmp61 = einsum(t1.aa, (0, 1), tmp2, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp2
    t2new.aaaa += tmp61.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp61 * -1
    del tmp61
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp55
    t2new.aaaa += tmp56.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp56 * -1
    t2new.aaaa += tmp56.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp56.transpose((0, 1, 3, 2))
    del tmp56
    tmp52 = einsum(tmp51, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp51
    t2new.aaaa += tmp52.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp52
    del tmp52
    tmp60 = einsum(tmp15, (0, 1, 2), tmp15, (3, 4, 2), (0, 3, 1, 4))
    del tmp15
    t2new.aaaa += tmp60.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp60
    del tmp60
    tmp36 = einsum(f.aa.oo, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4))
    t2new.aaaa += tmp36.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp36.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp36.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp36.transpose((1, 0, 3, 2))
    del tmp36
    tmp59 = einsum(t1.aa, (0, 1), tmp58, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp58
    t2new.aaaa += tmp59.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp59
    del tmp59
    tmp39 = einsum(t1.aa, (0, 1), tmp38, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp38
    t2new.aaaa += tmp39.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp39
    del tmp39
    tmp53 = einsum(t1.aa, (0, 1), tmp16, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp16
    t2new.aaaa += tmp53.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp53 * -1
    t2new.aaaa += tmp53.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp53.transpose((0, 1, 3, 2))
    del tmp53
    tmp46 = einsum(t1.aa, (0, 1), tmp45, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp45
    t2new.aaaa += tmp46
    t2new.aaaa += tmp46.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp46.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp46.transpose((1, 0, 3, 2))
    del tmp46
    tmp9 = tmp5.copy()
    del tmp5
    tmp9 += tmp6
    del tmp6
    t1new.bb += einsum(tmp9, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    t1new.aa += einsum(tmp9, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    del tmp9
    tmp28 = tmp26.copy() * 0.5
    del tmp26
    tmp28 += einsum(v.bbb.xov, (0, 1, 2), tmp27, (1, 3, 2, 4), (3, 4, 0)) * 0.5
    del tmp27
    tmp28 += einsum(tmp7, (0,), t1.bb, (1, 2), (1, 2, 0)) * 0.5
    t1new.bb += einsum(tmp28, (0, 1, 2), v.bbb.xvv, (2, 3, 1), (0, 3)) * 2
    del tmp28
    tmp31 = einsum(tmp29, (0, 1, 2), v.bbb.xov, (2, 3, 1), (3, 0))
    del tmp29
    tmp31 += einsum(t1.bb, (0, 1), tmp30, (2, 1), (2, 0))
    del tmp30
    t1new.bb += einsum(t1.bb, (0, 1), tmp31, (0, 2), (2, 1)) * -1
    del tmp31
    tmp20 = f.bb.ov.copy()
    tmp20 += tmp18 * -1
    del tmp18
    tmp20 += tmp19
    del tmp19
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp20, (1, 3), (0, 2)) * 2
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp20, (1, 3), (0, 2))
    del tmp20
    tmp35 = f.bb.oo.copy()
    tmp35 += einsum(tmp17, (0, 1, 2), v.bbb.xoo, (2, 3, 0), (1, 3)) * -1
    tmp35 += einsum(tmp7, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    t1new.bb += einsum(tmp35, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    del tmp35
    tmp22 = f.aa.ov.copy()
    tmp22 += tmp11 * -1
    del tmp11
    tmp22 += tmp21
    del tmp21
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp22, (0, 2), (1, 3))
    t1new.aa += einsum(tmp22, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp22
    tmp25 = einsum(tmp17, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 1, 4))
    del tmp17
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp25, (0, 4, 1, 2), (4, 3)) * -1
    del tmp25
    tmp8 = tmp3.copy()
    del tmp3
    tmp8 += einsum(v.baa.xov, (0, 1, 2), tmp4, (1, 3, 2, 4), (3, 4, 0))
    del tmp4
    tmp8 += einsum(t1.aa, (0, 1), tmp7, (2,), (0, 1, 2))
    t1new.aa += einsum(tmp8, (0, 1, 2), v.baa.xvv, (2, 3, 1), (0, 3))
    del tmp8
    tmp13 = einsum(tmp10, (0, 1, 2), v.baa.xov, (2, 3, 1), (3, 0)) * 2
    del tmp10
    tmp13 += einsum(tmp12, (0, 1), t1.aa, (2, 1), (0, 2))
    del tmp12
    t1new.aa += einsum(tmp13, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp13
    tmp23 = f.aa.oo.copy()
    tmp23 += einsum(tmp0, (0, 1, 2), v.baa.xoo, (2, 3, 0), (1, 3)) * -1
    del tmp0
    tmp23 += einsum(v.baa.xoo, (0, 1, 2), tmp7, (0,), (1, 2))
    del tmp7
    t1new.aa += einsum(tmp23, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp23
    t1new.aa += f.aa.ov
    t1new.aa += einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    t1new.bb += f.bb.ov
    t1new.bb += einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    t2new.abab += einsum(f.bb.oo, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    t2new.abab += einsum(f.aa.oo, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:07:19.084673.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp13 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp12 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 0, 1), (2,))
    tmp52 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp54 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp53 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp65 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp67 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp4 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (3, 1, 0))
    tmp14 = tmp12.copy()
    tmp14 += tmp13
    tmp7 = einsum(t1.bb, (0, 1), v.bbb.xvv, (2, 3, 1), (0, 3, 2))
    tmp27 = einsum(t1.aa, (0, 1), v.baa.xvv, (2, 3, 1), (0, 3, 2))
    tmp99 = tmp12.copy()
    del tmp12
    tmp99 += tmp13
    del tmp13
    tmp1 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2))
    tmp50 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    tmp48 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp55 = tmp52.copy() * 0.5
    tmp55 += tmp53
    tmp55 += tmp54 * 0.5
    tmp61 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp63 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp68 = tmp65.copy()
    tmp68 += tmp66
    tmp68 += tmp67 * 2
    tmp105 = einsum(tmp4, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3))
    l2new.bbbb = einsum(l1.bb, (0, 1), tmp105, (2, 3), (0, 3, 2, 1))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp105, (2, 3), (3, 0, 2, 1)) * -1
    l2new.bbbb += einsum(tmp105, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0)) * -1
    l2new.bbbb += einsum(tmp105, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.abab = einsum(l1.aa, (0, 1), tmp105, (2, 3), (0, 3, 1, 2)) * -1
    tmp106 = einsum(tmp14, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp156 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp156 += tmp7
    tmp154 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp154 += tmp27
    tmp161 = einsum(tmp99, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), tmp1, (1, 3, 0), (3, 2))
    l2new.abab += einsum(tmp11, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa = einsum(tmp11, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3))
    l2new.aaaa += einsum(tmp11, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (3, 0, 1, 2))
    tmp15 = einsum(tmp14, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    l2new.abab += tmp17.transpose((2, 3, 0, 1))
    tmp34 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp38 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp49 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (1, 0, 4, 3), (4, 2))
    tmp56 = einsum(tmp55, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp46 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp62 = einsum(tmp61, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp64 = einsum(t2.bbbb, (0, 1, 2, 3), tmp63, (1, 0, 4, 3), (4, 2))
    tmp60 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp69 = einsum(t1.bb, (0, 1), tmp68, (0, 2), (2, 1))
    tmp59 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp43 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp41 = einsum(t1.bb, (0, 1), l1.bb, (2, 0), (2, 1))
    tmp189 = v.bbb.xoo.transpose((1, 2, 0)).copy()
    tmp189 += tmp4.transpose((1, 0, 2))
    tmp191 = einsum(tmp99, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp107 = f.bb.ov.copy()
    tmp107 += tmp105 * -1
    tmp107 += tmp106
    l1new.bb = einsum(tmp107, (0, 1), tmp68, (2, 0), (1, 2)) * -1
    tmp185 = einsum(v.bbb.xvv, (0, 1, 2), l1.bb, (2, 3), (3, 1, 0))
    tmp130 = einsum(tmp63, (0, 1, 2, 3), tmp4, (1, 2, 4), (0, 3, 4))
    tmp129 = einsum(tmp50, (0, 1, 2, 3), tmp1, (0, 1, 4), (2, 3, 4))
    tmp128 = einsum(v.bbb.xoo, (0, 1, 2), tmp63, (2, 3, 1, 4), (3, 4, 0)) * -1
    tmp187 = einsum(l2.bbbb, (0, 1, 2, 3), tmp156, (3, 1, 4), (2, 0, 4))
    tmp186 = einsum(tmp154, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2))
    tmp127 = einsum(tmp50, (0, 1, 2, 3), v.baa.xoo, (4, 1, 0), (2, 3, 4))
    tmp198 = einsum(v.bbb.xov, (0, 1, 2), tmp7, (1, 3, 0), (2, 3))
    tmp140 = einsum(v.bbb.xvv, (0, 1, 2), tmp99, (0,), (1, 2))
    tmp162 = f.aa.ov.copy()
    tmp162 += tmp11 * -1
    tmp162 += tmp161
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp162, (1, 4), (4, 3, 0, 2)) * -1
    tmp100 = einsum(v.baa.xvv, (0, 1, 2), tmp99, (0,), (1, 2))
    tmp170 = einsum(v.baa.xov, (0, 1, 2), tmp27, (1, 3, 0), (2, 3))
    tmp142 = v.baa.xoo.transpose((1, 2, 0)).copy()
    tmp142 += tmp1.transpose((1, 0, 2))
    tmp84 = einsum(tmp4, (0, 1, 2), tmp61, (3, 0, 1, 4), (3, 4, 2))
    tmp81 = einsum(tmp48, (0, 1, 2, 3), v.baa.xoo, (4, 2, 0), (1, 3, 4)) * -1
    tmp82 = einsum(tmp61, (0, 1, 2, 3), v.bbb.xoo, (4, 2, 1), (0, 3, 4))
    tmp83 = einsum(tmp1, (0, 1, 2), tmp48, (0, 3, 1, 4), (3, 4, 2)) * -1
    tmp155 = einsum(l2.aaaa, (0, 1, 2, 3), tmp154, (3, 1, 4), (2, 0, 4))
    del tmp154
    tmp146 = einsum(l1.aa, (0, 1), v.baa.xvv, (2, 3, 0), (1, 3, 2))
    tmp157 = einsum(tmp156, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2))
    del tmp156
    tmp16 = f.aa.ov.copy()
    tmp16 += tmp11 * -1
    del tmp11
    tmp16 += tmp15
    tmp5 = v.bbb.xoo.transpose((1, 2, 0)).copy()
    tmp5 += tmp4
    tmp24 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp25 = einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    tmp2 = v.baa.xoo.transpose((1, 2, 0)).copy()
    tmp2 += tmp1
    tmp108 = v.bbb.xoo.transpose((1, 2, 0)).copy()
    tmp108 += tmp4.transpose((1, 0, 2))
    tmp18 = einsum(tmp17, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 0, 5, 1))
    tmp114 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp115 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    l2new.bbbb += tmp115.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp115.transpose((3, 2, 1, 0))
    tmp117 = einsum(tmp4, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp116 = einsum(tmp4, (0, 1, 2), tmp4, (3, 4, 2), (3, 0, 4, 1))
    tmp8 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp9 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0))
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp94 = einsum(tmp61, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    tmp39 = tmp38.copy() * 0.5
    del tmp38
    tmp39 += tmp34
    tmp39 += tmp35.transpose((1, 0)) * 0.5
    tmp57 = l1.aa.transpose((1, 0)).copy() * -0.5
    tmp57 += t1.aa * -0.5
    tmp57 += tmp46 * -1
    tmp57 += tmp47 * -0.5
    tmp57 += tmp49
    tmp57 += tmp51 * 0.5
    tmp57 += tmp56
    tmp73 = tmp65.copy()
    tmp73 += tmp66.transpose((1, 0))
    del tmp66
    tmp73 += tmp67 * 2
    del tmp67
    tmp70 = l1.bb.transpose((1, 0)).copy() * -1
    tmp70 += t1.bb * -1
    tmp70 += tmp59 * -1
    tmp70 += tmp60 * -2
    tmp70 += tmp62
    tmp70 += tmp64 * 2
    tmp70 += tmp69
    tmp44 = tmp41.copy()
    del tmp41
    tmp44 += tmp42.transpose((1, 0))
    tmp44 += tmp43.transpose((1, 0)) * 2
    tmp31 = einsum(v.baa.xoo, (0, 1, 2), tmp1, (3, 4, 0), (3, 1, 2, 4))
    tmp30 = einsum(tmp1, (0, 1, 2), tmp1, (3, 4, 2), (0, 3, 1, 4))
    tmp28 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp29 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    l2new.aaaa += tmp29.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp29.transpose((3, 2, 1, 0))
    tmp19 = v.baa.xoo.transpose((1, 2, 0)).copy()
    tmp19 += tmp1.transpose((1, 0, 2))
    tmp206 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp61, (0, 1, 2, 3), tmp206, (4, 1, 2, 5), (3, 5, 0, 4))
    tmp190 = einsum(tmp189, (0, 1, 2), v.bbb.xvv, (2, 3, 4), (0, 1, 3, 4))
    l2new.abab += einsum(tmp190, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (4, 2, 5, 0)) * -1
    tmp200 = f.bb.ov.copy()
    tmp200 += tmp105 * -1
    del tmp105
    tmp200 += tmp191
    l2new.abab += einsum(tmp61, (0, 1, 2, 3), tmp200, (2, 4), (3, 4, 0, 1)) * -1
    tmp147 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp147 += tmp27
    tmp148 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp148 += tmp7
    tmp125 = einsum(tmp107, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp124 = einsum(v.bbb.xoo, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp122 = einsum(v.bbb.xoo, (0, 1, 2), tmp4, (2, 3, 0), (1, 3))
    tmp204 = einsum(v.bbb.xov, (0, 1, 2), tmp65, (3, 1), (3, 2, 0))
    del tmp65
    l2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp204, (3, 4, 0), (2, 4, 1, 3)) * -1
    tmp188 = tmp185.copy()
    tmp188 += tmp127 * -1
    tmp188 += tmp128 * -2
    tmp188 += tmp129 * -1
    tmp188 += tmp130 * -2
    tmp188 += tmp186
    del tmp186
    tmp188 += tmp187 * 2
    del tmp187
    l2new.abab += einsum(tmp188, (0, 1, 2), v.baa.xov, (2, 3, 4), (4, 1, 3, 0))
    tmp111 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp133 = einsum(t1.bb, (0, 1), tmp63, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp215 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp207 = einsum(tmp189, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 1, 3, 4))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp207, (2, 1, 3, 4), (4, 0, 2, 3))
    tmp205 = einsum(v.bbb.xov, (0, 1, 2), tmp4, (3, 4, 0), (3, 1, 4, 2))
    l2new.abab += einsum(tmp61, (0, 1, 2, 3), tmp205, (1, 2, 4, 5), (3, 5, 0, 4))
    tmp199 = f.bb.vv.copy()
    tmp199 += tmp198.transpose((1, 0)) * -1
    tmp199 += tmp140.transpose((1, 0))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp199, (1, 4), (0, 4, 2, 3))
    tmp196 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 4, 1, 2))
    tmp171 = einsum(tmp14, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    tmp76 = einsum(v.baa.xoo, (0, 1, 2), tmp1, (2, 3, 0), (1, 3))
    tmp163 = einsum(tmp162, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp160 = einsum(v.baa.xoo, (0, 1, 2), tmp99, (0,), (1, 2))
    tmp174 = f.aa.vv.copy()
    tmp174 += tmp170.transpose((1, 0)) * -1
    tmp174 += tmp100.transpose((1, 0))
    tmp178 = einsum(tmp1, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp178, (0, 1, 4, 5), (5, 3, 4, 2))
    tmp87 = einsum(tmp48, (0, 1, 2, 3), t1.aa, (4, 3), (1, 0, 2, 4))
    tmp182 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp182, (0, 1, 2, 3), tmp50, (1, 2, 4, 5), (3, 5, 0, 4))
    tmp143 = einsum(v.baa.xov, (0, 1, 2), tmp142, (3, 4, 0), (3, 4, 1, 2))
    l2new.aaaa += einsum(tmp143, (0, 1, 2, 3), l1.aa, (4, 1), (3, 4, 0, 2))
    tmp158 = tmp146.copy()
    tmp158 += tmp81 * -2
    tmp158 += tmp82 * -1
    tmp158 += tmp83 * -2
    tmp158 += tmp84 * -1
    tmp158 += tmp155 * 2
    del tmp155
    tmp158 += tmp157
    del tmp157
    l2new.abab += einsum(tmp158, (0, 1, 2), v.bbb.xov, (2, 3, 4), (1, 4, 0, 3))
    tmp166 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp152 = einsum(v.baa.xvv, (0, 1, 2), tmp142, (3, 4, 0), (3, 4, 1, 2))
    l2new.abab += einsum(tmp152, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (2, 4, 0, 5)) * -1
    tmp180 = einsum(v.baa.xov, (0, 1, 2), tmp52, (3, 1), (3, 2, 0))
    l2new.abab += einsum(tmp180, (0, 1, 2), v.bbb.xov, (2, 3, 4), (1, 4, 0, 3)) * -1
    tmp22 = einsum(v.baa.xov, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp79 = einsum(t1.aa, (0, 1), tmp16, (2, 1), (0, 2))
    tmp78 = einsum(v.baa.xoo, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp104 = einsum(v.bbb.xov, (0, 1, 2), tmp5, (3, 4, 0), (4, 3, 1, 2))
    tmp85 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp85 += tmp27
    tmp85 += tmp24 * 2
    tmp85 += tmp25
    tmp102 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    l2new.abab += einsum(tmp102, (0, 1, 2, 3), tmp61, (4, 5, 0, 2), (1, 3, 4, 5)) * -1
    tmp103 = einsum(v.bbb.xov, (0, 1, 2), tmp2, (3, 4, 0), (4, 3, 1, 2))
    tmp109 = tmp18.transpose((1, 0, 2, 3)).copy()
    tmp109 += einsum(tmp2, (0, 1, 2), tmp108, (3, 4, 2), (1, 0, 4, 3))
    tmp120 = tmp42.copy() * 0.5
    del tmp42
    tmp120 += tmp43
    del tmp43
    tmp112 = einsum(v.bbb.xov, (0, 1, 2), tmp108, (3, 4, 0), (3, 4, 1, 2))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp112, (2, 1, 3, 4), (4, 0, 3, 2)) * -1
    tmp118 = tmp114.transpose((3, 2, 1, 0)).copy()
    tmp118 += einsum(tmp115, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (1, 0, 4, 5))
    tmp118 += tmp116.transpose((2, 3, 1, 0))
    tmp118 += tmp117.transpose((1, 3, 0, 2))
    tmp118 += tmp117.transpose((3, 2, 0, 1)) * -1
    tmp113 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp113 += tmp8
    tmp113 += tmp9 * 2
    tmp123 = tmp8.copy() * 0.5
    tmp123 += tmp9
    tmp95 = tmp93.copy()
    del tmp93
    tmp95 += tmp94
    tmp134 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3)) * 0.25
    tmp134 += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 2, 4))
    tmp137 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp135 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2)) * -0.5
    tmp135 += einsum(tmp61, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 2, 4, 5)) * 0.25
    tmp135 += einsum(tmp63, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp10 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp10 += tmp7
    tmp10 += tmp8
    del tmp8
    tmp10 += tmp9 * 2
    del tmp9
    tmp132 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    tmp136 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp136 += einsum(t2.abab, (0, 1, 2, 3), tmp50, (0, 4, 5, 3), (4, 5, 1, 2)) * -1
    tmp138 = t1.bb.copy() * -1
    tmp138 += tmp59 * -1
    del tmp59
    tmp138 += tmp60 * -2
    del tmp60
    tmp138 += tmp62
    del tmp62
    tmp138 += tmp64 * 2
    del tmp64
    tmp138 += tmp69
    del tmp69
    tmp40 = einsum(tmp39, (0, 1), v.baa.xvv, (2, 1, 0), (2,)) * 2
    del tmp39
    tmp58 = einsum(v.baa.xov, (0, 1, 2), tmp57, (1, 2), (0,)) * 2
    del tmp57
    tmp72 = einsum(v.baa.xoo, (0, 1, 2), tmp55, (2, 1), (0,)) * 2
    tmp74 = einsum(v.bbb.xoo, (0, 1, 2), tmp73, (2, 1), (0,))
    del tmp73
    tmp71 = einsum(v.bbb.xov, (0, 1, 2), tmp70, (1, 2), (0,))
    del tmp70
    tmp45 = einsum(tmp44, (0, 1), v.bbb.xvv, (2, 1, 0), (2,))
    del tmp44
    tmp36 = tmp34.copy() * 2
    del tmp34
    tmp36 += tmp35
    del tmp35
    tmp32 = tmp28.transpose((3, 2, 1, 0)).copy()
    tmp32 += einsum(tmp29, (0, 1, 2, 3), t2.aaaa, (4, 5, 2, 3), (1, 0, 4, 5))
    tmp32 += tmp30.transpose((2, 3, 1, 0))
    tmp32 += tmp31.transpose((1, 3, 0, 2))
    tmp32 += tmp31.transpose((3, 2, 0, 1)) * -1
    tmp26 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp26 += tmp24 * 2
    tmp26 += tmp25
    tmp23 = einsum(tmp19, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 1, 4))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp23, (2, 3, 1, 4), (4, 0, 2, 3)) * -1
    tmp89 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2)) * 4
    tmp89 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 5, 0))
    tmp88 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp96 = t1.aa.copy() * -0.5
    tmp96 += tmp46 * -1
    del tmp46
    tmp96 += tmp47 * -0.5
    del tmp47
    tmp96 += tmp49
    del tmp49
    tmp96 += tmp51 * 0.5
    del tmp51
    tmp96 += tmp56
    del tmp56
    tmp90 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2)) * -2
    tmp90 += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 1, 5, 3), (4, 5, 0, 2)) * -4
    tmp90 += einsum(tmp50, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp92 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp91 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    tmp91 += einsum(t2.abab, (0, 1, 2, 3), tmp61, (4, 1, 5, 2), (4, 0, 5, 3)) * -1
    tmp3 = einsum(v.baa.xov, (0, 1, 2), tmp2, (3, 4, 0), (4, 3, 1, 2))
    tmp0 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp0, (1, 4, 3, 5), (4, 5, 0, 2)) * -1
    tmp20 = tmp18.transpose((0, 1, 3, 2)).copy()
    del tmp18
    tmp20 += einsum(tmp5, (0, 1, 2), tmp19, (3, 4, 2), (4, 3, 1, 0))
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 1, 0, 4))
    tmp77 = tmp24.copy() * 2
    del tmp24
    tmp77 += tmp25
    del tmp25
    tmp224 = einsum(tmp63, (0, 1, 2, 3), tmp206, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    del tmp206
    l2new.bbbb += tmp224.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp224.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp224.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp224.transpose((3, 2, 0, 1)) * -2
    del tmp224
    tmp209 = einsum(v.bbb.xvv, (0, 1, 2), tmp108, (3, 4, 0), (4, 3, 1, 2))
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp209, (3, 4, 5, 1), (5, 0, 2, 4)) * 2
    del tmp209
    tmp212 = einsum(tmp190, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 1), (0, 5, 3, 4))
    del tmp190
    l2new.bbbb += tmp212.transpose((3, 2, 0, 1)) * 2
    l2new.bbbb += tmp212.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp212.transpose((2, 3, 0, 1)) * -2
    del tmp212
    tmp222 = einsum(tmp117, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp117
    l2new.bbbb += tmp222.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp222.transpose((2, 3, 0, 1)) * -2
    del tmp222
    tmp220 = einsum(tmp63, (0, 1, 2, 3), tmp200, (2, 4), (0, 1, 4, 3))
    l2new.bbbb += tmp220.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp220.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp220.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp220.transpose((2, 3, 1, 0)) * -1
    del tmp220
    tmp210 = tmp185.copy() * 0.5
    del tmp185
    tmp210 += tmp127 * -0.5
    tmp210 += tmp128 * -1
    tmp210 += tmp129 * -0.5
    tmp210 += tmp130 * -1
    tmp210 += einsum(tmp147, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2)) * 0.5
    tmp210 += einsum(tmp148, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2))
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp210, (3, 4, 0), (2, 4, 3, 1)) * -2
    del tmp210
    tmp194 = f.bb.oo.copy()
    tmp194 += tmp122 * -1
    tmp194 += tmp124.transpose((1, 0))
    tmp194 += tmp125.transpose((1, 0))
    l2new.bbbb += einsum(tmp194, (0, 1), l2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp194, (3, 4), (0, 1, 2, 4)) * -1
    del tmp194
    tmp192 = f.bb.ov.copy()
    tmp192 += tmp191
    del tmp191
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp192, (2, 3), (0, 3, 2, 1)) * -1
    l2new.bbbb += einsum(tmp192, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp192, (2, 3), (3, 0, 2, 1))
    l2new.abab += einsum(l1.aa, (0, 1), tmp192, (2, 3), (0, 3, 1, 2))
    del tmp192
    tmp226 = einsum(tmp204, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 4, 1))
    del tmp204
    l2new.bbbb += tmp226.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp226.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp226.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp226.transpose((3, 2, 0, 1)) * -1
    del tmp226
    tmp219 = f.bb.vv.copy()
    tmp219 += tmp198.transpose((1, 0)) * -1
    del tmp198
    tmp219 += einsum(tmp14, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    del tmp14
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp219, (1, 4), (4, 0, 2, 3)) * -1
    del tmp219
    tmp223 = tmp114.transpose((3, 2, 1, 0)).copy()
    del tmp114
    tmp223 += tmp116.transpose((0, 3, 1, 2))
    del tmp116
    l2new.bbbb += einsum(tmp223, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp223
    tmp213 = einsum(v.bbb.xov, (0, 1, 2), tmp188, (3, 4, 0), (3, 1, 4, 2))
    del tmp188
    l2new.bbbb += tmp213.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp213.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp213.transpose((3, 2, 1, 0))
    del tmp213
    tmp217 = einsum(tmp111, (0, 1, 2, 3), tmp63, (4, 5, 0, 2), (5, 4, 3, 1))
    l2new.bbbb += tmp217.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp217.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp217.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp217.transpose((2, 3, 1, 0))
    del tmp217
    tmp214 = f.bb.oo.copy()
    tmp214 += tmp122 * -1
    tmp214 += einsum(tmp99, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    del tmp99
    tmp214 += einsum(t1.bb, (0, 1), tmp200, (2, 1), (0, 2))
    del tmp200
    l2new.bbbb += einsum(tmp214, (0, 1), l2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp214
    tmp211 = f.bb.ov.copy()
    tmp211 += tmp106
    del tmp106
    l2new.bbbb += einsum(tmp211, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0)) * -1
    del tmp211
    tmp218 = einsum(tmp115, (0, 1, 2, 3), tmp133, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp115
    l2new.bbbb += tmp218.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp218.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp218.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp218.transpose((3, 2, 1, 0)) * 0.5
    del tmp218
    tmp216 = einsum(l2.bbbb, (0, 1, 2, 3), tmp215, (4, 5, 1, 0), (2, 3, 4, 5))
    del tmp215
    l2new.bbbb += tmp216.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp216.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp216.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp216.transpose((2, 3, 1, 0)) * -0.5
    del tmp216
    tmp208 = einsum(l1.bb, (0, 1), tmp207, (2, 1, 3, 4), (3, 2, 4, 0))
    del tmp207
    l2new.bbbb += tmp208.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp208.transpose((3, 2, 0, 1))
    del tmp208
    tmp225 = einsum(tmp63, (0, 1, 2, 3), tmp205, (1, 2, 4, 5), (0, 4, 3, 5))
    del tmp205
    l2new.bbbb += tmp225.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp225.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp225.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp225.transpose((3, 2, 0, 1)) * -2
    del tmp225
    tmp221 = einsum(l2.bbbb, (0, 1, 2, 3), tmp199, (1, 4), (2, 3, 4, 0)) * -1
    del tmp199
    l2new.bbbb += tmp221.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp221.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp221.transpose((2, 3, 1, 0)) * -1
    del tmp221
    tmp203 = einsum(tmp142, (0, 1, 2), v.bbb.xvv, (2, 3, 4), (1, 0, 3, 4))
    l2new.abab += einsum(tmp203, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5)) * -1
    del tmp203
    tmp197 = einsum(tmp196, (0, 1, 2, 3), l2.abab, (1, 2, 4, 5), (4, 5, 0, 3))
    del tmp196
    l2new.abab += tmp197.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp197.transpose((2, 3, 0, 1)) * 0.5
    del tmp197
    tmp193 = einsum(tmp189, (0, 1, 2), v.baa.xvv, (2, 3, 4), (1, 0, 3, 4))
    del tmp189
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp193, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp193
    tmp172 = f.aa.vv.copy()
    tmp172 += tmp170.transpose((1, 0)) * -1
    del tmp170
    tmp172 += tmp171.transpose((1, 0))
    del tmp171
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp172, (0, 4), (4, 1, 2, 3))
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp172, (1, 4), (4, 0, 2, 3)) * -1
    del tmp172
    tmp195 = einsum(tmp17, (0, 1, 2, 3), tmp94, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp17, tmp94
    l2new.abab += tmp195.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp195.transpose((2, 3, 0, 1)) * 0.5
    del tmp195
    tmp165 = f.aa.ov.copy()
    tmp165 += tmp161
    del tmp161
    l2new.abab += einsum(tmp165, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp165, (2, 3), (0, 3, 2, 1)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp165, (2, 3), (0, 3, 1, 2))
    l2new.aaaa += einsum(tmp165, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3))
    del tmp165
    tmp202 = einsum(tmp19, (0, 1, 2), tmp108, (3, 4, 2), (1, 0, 4, 3))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp202, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp202
    tmp184 = einsum(tmp108, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 1, 4))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp184, (1, 4, 2, 5), (5, 3, 0, 4))
    l2new.abab += einsum(l1.bb, (0, 1), tmp184, (2, 3, 1, 4), (4, 0, 2, 3)) * -1
    del tmp184
    tmp201 = einsum(v.bbb.xov, (0, 1, 2), tmp142, (3, 4, 0), (3, 4, 1, 2))
    del tmp142
    l2new.abab += einsum(tmp201, (0, 1, 2, 3), tmp61, (1, 4, 2, 5), (5, 3, 0, 4))
    l2new.abab += einsum(l1.aa, (0, 1), tmp201, (2, 1, 3, 4), (0, 4, 2, 3)) * -1
    del tmp201
    tmp164 = f.aa.oo.copy()
    tmp164 += tmp76 * -1
    tmp164 += tmp160.transpose((1, 0))
    del tmp160
    tmp164 += tmp163.transpose((1, 0))
    del tmp163
    l2new.abab += einsum(tmp164, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp164, (3, 4), (0, 1, 4, 2)) * 2
    del tmp164
    tmp177 = tmp28.transpose((3, 2, 1, 0)).copy()
    del tmp28
    tmp177 += tmp30.transpose((0, 3, 1, 2))
    del tmp30
    l2new.aaaa += einsum(tmp177, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp177
    tmp175 = einsum(l2.aaaa, (0, 1, 2, 3), tmp174, (1, 4), (2, 3, 4, 0)) * -1
    del tmp174
    l2new.aaaa += tmp175.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp175.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp175.transpose((2, 3, 1, 0)) * -1
    del tmp175
    tmp179 = einsum(tmp48, (0, 1, 2, 3), tmp178, (1, 2, 4, 5), (0, 4, 3, 5))
    del tmp178
    l2new.aaaa += tmp179.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp179.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp179.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp179.transpose((3, 2, 0, 1)) * -2
    del tmp179
    tmp176 = einsum(tmp31, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp31
    l2new.aaaa += tmp176.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp176.transpose((2, 3, 0, 1)) * -2
    del tmp176
    tmp169 = einsum(tmp29, (0, 1, 2, 3), tmp87, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp29
    l2new.aaaa += tmp169.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp169.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp169.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp169.transpose((3, 2, 1, 0)) * 0.5
    del tmp169
    tmp149 = tmp146.copy() * 0.5
    del tmp146
    tmp149 += tmp81 * -1
    tmp149 += tmp82 * -0.5
    tmp149 += tmp83 * -1
    tmp149 += tmp84 * -0.5
    tmp149 += einsum(l2.aaaa, (0, 1, 2, 3), tmp147, (3, 1, 4), (2, 0, 4))
    del tmp147
    tmp149 += einsum(tmp148, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2)) * 0.5
    del tmp148
    l2new.aaaa += einsum(tmp149, (0, 1, 2), v.baa.xov, (2, 3, 4), (4, 1, 0, 3)) * -2
    del tmp149
    tmp145 = einsum(v.baa.xvv, (0, 1, 2), tmp19, (3, 4, 0), (4, 3, 1, 2))
    l2new.aaaa += einsum(tmp145, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 0), (2, 4, 5, 1)) * 2
    del tmp145
    tmp183 = einsum(tmp48, (0, 1, 2, 3), tmp182, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    del tmp182
    l2new.aaaa += tmp183.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp183.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp183.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp183.transpose((3, 2, 0, 1)) * -2
    del tmp183
    tmp173 = einsum(tmp48, (0, 1, 2, 3), tmp162, (2, 4), (0, 1, 4, 3))
    del tmp162
    l2new.aaaa += tmp173.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp173.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp173.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp173.transpose((2, 3, 1, 0)) * -1
    del tmp173
    tmp144 = einsum(l1.aa, (0, 1), tmp143, (2, 1, 3, 4), (3, 2, 4, 0))
    del tmp143
    l2new.aaaa += tmp144.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp144.transpose((3, 2, 0, 1))
    del tmp144
    tmp159 = einsum(tmp158, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4))
    del tmp158
    l2new.aaaa += tmp159.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp159.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp159.transpose((3, 2, 1, 0))
    del tmp159
    tmp167 = einsum(l2.aaaa, (0, 1, 2, 3), tmp166, (4, 5, 1, 0), (2, 3, 4, 5))
    del tmp166
    l2new.aaaa += tmp167.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp167.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp167.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp167.transpose((2, 3, 1, 0)) * -0.5
    del tmp167
    tmp153 = einsum(tmp152, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 1), (0, 5, 3, 4))
    del tmp152
    l2new.aaaa += tmp153.transpose((3, 2, 0, 1)) * 2
    l2new.aaaa += tmp153.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp153.transpose((2, 3, 0, 1)) * -2
    del tmp153
    tmp181 = einsum(tmp180, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 4, 1))
    del tmp180
    l2new.aaaa += tmp181.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp181.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp181.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp181.transpose((3, 2, 0, 1)) * -1
    del tmp181
    tmp168 = einsum(tmp48, (0, 1, 2, 3), tmp22, (2, 4, 3, 5), (1, 0, 5, 4))
    l2new.aaaa += tmp168.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp168.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp168.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp168.transpose((2, 3, 1, 0))
    del tmp168
    tmp151 = f.aa.ov.copy()
    tmp151 += tmp15
    del tmp15
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp151, (2, 3), (3, 0, 1, 2)) * -1
    del tmp151
    tmp150 = f.aa.oo.copy()
    tmp150 += tmp76 * -1
    tmp150 += tmp78.transpose((1, 0))
    tmp150 += tmp79
    l2new.aaaa += einsum(tmp150, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp150
    tmp110 = einsum(tmp102, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2)) * 0.5
    del tmp102
    tmp110 += einsum(t2.abab, (0, 1, 2, 3), tmp103, (0, 4, 5, 3), (4, 5, 1, 2)) * -0.5
    del tmp103
    tmp110 += einsum(t2.abab, (0, 1, 2, 3), tmp104, (1, 4, 5, 3), (0, 5, 4, 2)) * -0.5
    del tmp104
    tmp110 += einsum(tmp5, (0, 1, 2), tmp85, (3, 4, 2), (3, 1, 0, 4)) * 0.5
    tmp110 += einsum(tmp107, (0, 1), t2.abab, (2, 3, 4, 1), (2, 0, 3, 4)) * 0.5
    tmp110 += einsum(tmp109, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4)) * -0.5
    del tmp109
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp110, (2, 4, 3, 0), (1, 4)) * -2
    del tmp110
    tmp141 = f.bb.vv.copy()
    tmp141 += tmp140.transpose((1, 0))
    del tmp140
    l1new.bb += einsum(tmp141, (0, 1), l1.bb, (0, 2), (1, 2))
    del tmp141
    tmp121 = einsum(v.bbb.xov, (0, 1, 2), tmp120, (3, 2), (1, 3, 0))
    del tmp120
    tmp121 += einsum(l1.bb, (0, 1), tmp5, (1, 2, 3), (2, 0, 3)) * 0.5
    l1new.bb += einsum(tmp121, (0, 1, 2), v.bbb.xvv, (2, 3, 1), (3, 0)) * -2
    del tmp121
    tmp119 = einsum(tmp111, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (0, 4, 5, 1)) * 0.5
    del tmp111
    tmp119 += einsum(t2.bbbb, (0, 1, 2, 3), tmp112, (1, 4, 5, 3), (5, 0, 4, 2)) * -1
    del tmp112
    tmp119 += einsum(tmp5, (0, 1, 2), tmp113, (3, 4, 2), (1, 3, 0, 4)) * 0.5
    del tmp113
    tmp119 += einsum(tmp107, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4)) * 0.5
    del tmp107
    tmp119 += einsum(tmp7, (0, 1, 2), tmp5, (3, 4, 2), (4, 3, 0, 1)) * -0.5
    del tmp5
    tmp119 += einsum(t1.bb, (0, 1), tmp118, (0, 2, 3, 4), (2, 4, 3, 1)) * -0.5
    del tmp118
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp119, (4, 2, 3, 1), (0, 4)) * 4
    del tmp119
    tmp126 = f.bb.oo.copy()
    tmp126 += tmp122 * -1
    del tmp122
    tmp126 += einsum(tmp123, (0, 1, 2), v.bbb.xov, (2, 3, 1), (0, 3)) * 2
    del tmp123
    tmp126 += tmp124.transpose((1, 0))
    del tmp124
    tmp126 += tmp125.transpose((1, 0))
    del tmp125
    l1new.bb += einsum(l1.bb, (0, 1), tmp126, (1, 2), (0, 2)) * -1
    del tmp126
    tmp139 = einsum(l1.bb, (0, 1), tmp7, (2, 0, 3), (2, 1, 3))
    del tmp7
    tmp139 += einsum(v.baa.xvv, (0, 1, 2), tmp132, (3, 4, 1, 2), (4, 3, 0))
    del tmp132
    tmp139 += einsum(tmp133, (0, 1, 2, 3), v.bbb.xoo, (4, 2, 1), (3, 0, 4)) * 2
    tmp139 += einsum(tmp133, (0, 1, 2, 3), tmp4, (0, 2, 4), (3, 1, 4)) * -2
    del tmp133
    tmp139 += einsum(v.bbb.xvv, (0, 1, 2), tmp134, (3, 4, 1, 2), (4, 3, 0)) * 4
    del tmp134
    tmp139 += einsum(tmp61, (0, 1, 2, 3), tmp85, (0, 3, 4), (2, 1, 4))
    del tmp61
    tmp139 += einsum(tmp10, (0, 1, 2), tmp63, (0, 3, 4, 1), (4, 3, 2)) * 2
    del tmp63
    tmp139 += einsum(tmp135, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (2, 0, 4)) * -4
    del tmp135
    tmp139 += einsum(tmp136, (0, 1, 2, 3), v.baa.xov, (4, 0, 3), (2, 1, 4))
    del tmp136
    tmp139 += einsum(tmp137, (0, 1, 2, 3), tmp108, (2, 0, 4), (3, 1, 4)) * -2
    del tmp108, tmp137
    tmp139 += einsum(v.baa.xoo, (0, 1, 2), tmp95, (1, 2, 3, 4), (4, 3, 0)) * -1
    tmp139 += einsum(tmp95, (0, 1, 2, 3), tmp1, (0, 1, 4), (3, 2, 4)) * -1
    tmp139 += einsum(v.bbb.xov, (0, 1, 2), tmp138, (3, 2), (3, 1, 0)) * -1
    del tmp138
    tmp139 += einsum(tmp68, (0, 1), v.bbb.xoo, (2, 3, 0), (1, 3, 2)) * -1
    del tmp68
    l1new.bb += einsum(v.bbb.xov, (0, 1, 2), tmp139, (1, 3, 0), (2, 3)) * -1
    del tmp139
    tmp75 = tmp40.copy()
    del tmp40
    tmp75 += tmp45
    del tmp45
    tmp75 += tmp58 * -1
    del tmp58
    tmp75 += tmp71 * -1
    del tmp71
    tmp75 += tmp72 * -1
    del tmp72
    tmp75 += tmp74 * -1
    del tmp74
    l1new.bb += einsum(tmp75, (0,), v.bbb.xov, (0, 1, 2), (2, 1))
    l1new.aa = einsum(tmp75, (0,), v.baa.xov, (0, 1, 2), (2, 1))
    del tmp75
    tmp131 = tmp127.copy() * -0.5
    del tmp127
    tmp131 += tmp128 * -1
    del tmp128
    tmp131 += tmp129 * -0.5
    del tmp129
    tmp131 += tmp130 * -1
    del tmp130
    tmp131 += einsum(tmp85, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2)) * 0.5
    tmp131 += einsum(tmp10, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2))
    l1new.bb += einsum(tmp131, (0, 1, 2), v.bbb.xvv, (2, 3, 1), (3, 0)) * 2
    del tmp131
    tmp37 = einsum(v.baa.xov, (0, 1, 2), tmp36, (3, 2), (1, 3, 0))
    del tmp36
    tmp37 += einsum(l1.aa, (0, 1), tmp2, (1, 2, 3), (2, 0, 3))
    l1new.aa += einsum(tmp37, (0, 1, 2), v.baa.xvv, (2, 3, 1), (3, 0)) * -1
    del tmp37
    tmp98 = tmp52.copy()
    del tmp52
    tmp98 += tmp53 * 2
    del tmp53
    tmp98 += tmp54
    del tmp54
    l1new.aa += einsum(tmp16, (0, 1), tmp98, (2, 0), (1, 2)) * -1
    del tmp98
    tmp33 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (4, 5, 2, 3), (4, 0, 1, 5))
    del tmp22
    tmp33 += einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp23
    tmp33 += einsum(tmp26, (0, 1, 2), tmp2, (3, 4, 2), (4, 0, 3, 1))
    del tmp26
    tmp33 += einsum(tmp16, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp33 += einsum(tmp27, (0, 1, 2), tmp2, (3, 4, 2), (4, 3, 0, 1)) * -1
    tmp33 += einsum(tmp32, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4)) * -1
    del tmp32
    l1new.aa += einsum(l2.aaaa, (0, 1, 2, 3), tmp33, (4, 2, 3, 1), (0, 4)) * 2
    del tmp33
    tmp97 = einsum(tmp27, (0, 1, 2), l1.aa, (1, 3), (0, 3, 2))
    del tmp27
    tmp97 += einsum(tmp87, (0, 1, 2, 3), v.baa.xoo, (4, 2, 1), (3, 0, 4)) * 2
    tmp97 += einsum(tmp88, (0, 1, 2, 3), v.bbb.xvv, (4, 3, 2), (1, 0, 4))
    del tmp88
    tmp97 += einsum(tmp87, (0, 1, 2, 3), tmp1, (0, 2, 4), (3, 1, 4)) * -2
    del tmp1, tmp87
    tmp97 += einsum(v.baa.xvv, (0, 1, 2), tmp89, (3, 4, 2, 1), (4, 3, 0))
    del tmp89
    tmp97 += einsum(tmp48, (0, 1, 2, 3), tmp85, (0, 3, 4), (2, 1, 4)) * 2
    del tmp48
    tmp97 += einsum(tmp50, (0, 1, 2, 3), tmp10, (2, 3, 4), (1, 0, 4))
    del tmp50
    tmp97 += einsum(v.baa.xov, (0, 1, 2), tmp90, (3, 1, 4, 2), (4, 3, 0)) * -1
    del tmp90
    tmp97 += einsum(tmp91, (0, 1, 2, 3), v.bbb.xov, (4, 2, 3), (1, 0, 4))
    del tmp91
    tmp97 += einsum(tmp19, (0, 1, 2), tmp92, (1, 3, 0, 4), (4, 3, 2)) * -2
    del tmp19, tmp92
    tmp97 += einsum(v.bbb.xoo, (0, 1, 2), tmp95, (3, 4, 1, 2), (4, 3, 0)) * -1
    tmp97 += einsum(tmp4, (0, 1, 2), tmp95, (3, 4, 0, 1), (4, 3, 2)) * -1
    del tmp4, tmp95
    tmp97 += einsum(tmp96, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2)) * -2
    del tmp96
    tmp97 += einsum(tmp55, (0, 1), v.baa.xoo, (2, 3, 0), (1, 3, 2)) * -2
    del tmp55
    l1new.aa += einsum(v.baa.xov, (0, 1, 2), tmp97, (1, 3, 0), (2, 3)) * -1
    del tmp97
    tmp21 = einsum(tmp0, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (0, 4, 5, 2))
    del tmp0
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp3, (0, 4, 5, 2), (5, 4, 1, 3)) * -1
    del tmp3
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp6, (4, 1, 5, 2), (4, 0, 5, 3)) * -1
    del tmp6
    tmp21 += einsum(tmp2, (0, 1, 2), tmp10, (3, 4, 2), (1, 0, 3, 4))
    del tmp2
    tmp21 += einsum(tmp16, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp16
    tmp21 += einsum(tmp20, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4)) * -1
    del tmp20
    l1new.aa += einsum(tmp21, (0, 1, 2, 3), l2.abab, (4, 3, 1, 2), (4, 0)) * -1
    del tmp21
    tmp80 = f.aa.oo.copy()
    tmp80 += tmp76 * -1
    del tmp76
    tmp80 += einsum(tmp77, (0, 1, 2), v.baa.xov, (2, 3, 1), (0, 3))
    del tmp77
    tmp80 += tmp78.transpose((1, 0))
    del tmp78
    tmp80 += tmp79
    del tmp79
    l1new.aa += einsum(l1.aa, (0, 1), tmp80, (1, 2), (0, 2)) * -1
    del tmp80
    tmp101 = f.aa.vv.copy()
    tmp101 += tmp100.transpose((1, 0))
    del tmp100
    l1new.aa += einsum(l1.aa, (0, 1), tmp101, (0, 2), (2, 1))
    del tmp101
    tmp86 = tmp81.copy() * -2
    del tmp81
    tmp86 += tmp82 * -1
    del tmp82
    tmp86 += tmp83 * -2
    del tmp83
    tmp86 += tmp84 * -1
    del tmp84
    tmp86 += einsum(l2.aaaa, (0, 1, 2, 3), tmp85, (3, 1, 4), (2, 0, 4)) * 2
    del tmp85
    tmp86 += einsum(tmp10, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2))
    del tmp10
    l1new.aa += einsum(tmp86, (0, 1, 2), v.baa.xvv, (2, 3, 1), (3, 0))
    del tmp86
    l1new.aa += f.aa.ov.transpose((1, 0))
    l1new.bb += f.bb.ov.transpose((1, 0))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:07:22.269820.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp3 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    rdm1.bb.oo = tmp3.transpose((1, 0)).copy() * -1
    tmp4 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    rdm1.bb.oo += tmp4.transpose((1, 0)) * -2
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    rdm1.bb.oo += tmp5.transpose((1, 0)) * -1
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    rdm1.aa.oo = tmp1.transpose((1, 0)).copy() * -2
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    rdm1.aa.oo += tmp2.transpose((1, 0)) * -1
    tmp0 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    rdm1.aa.oo += tmp0.transpose((1, 0)) * -1
    tmp10 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.ov = einsum(t2.abab, (0, 1, 2, 3), tmp10, (0, 1, 4, 2), (4, 3)) * -1
    del tmp10
    tmp11 = tmp3.copy()
    del tmp3
    tmp11 += tmp5
    del tmp5
    tmp11 += tmp4 * 2
    del tmp4
    rdm1.bb.ov += einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    tmp9 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), tmp9, (1, 0, 4, 3), (4, 2)) * -2
    del tmp9
    tmp7 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.aa.ov = einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (1, 0, 4, 3), (4, 2)) * -2
    del tmp7
    tmp8 = tmp0.copy()
    del tmp0
    tmp8 += tmp1 * 2
    del tmp1
    tmp8 += tmp2
    del tmp2
    rdm1.aa.ov += einsum(tmp8, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp8
    tmp6 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm1.aa.ov += einsum(tmp6, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4)) * -1
    del tmp6
    rdm1.aa.oo += delta.aa.oo
    rdm1.bb.oo += delta.bb.oo
    del delta
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2)) * 2
    rdm1.aa.ov += einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    rdm1.aa.ov += t1.aa
    rdm1.bb.ov += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    rdm1.bb.ov += einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.bb.ov += t1.bb
    rdm1.aa.vo = l1.aa.copy()
    rdm1.bb.vo = l1.bb.copy()
    rdm1.aa.vv = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa.vv += einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    rdm1.aa.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    rdm1.bb.vv = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.bb.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    rdm1.bb.vv += einsum(t1.bb, (0, 1), l1.bb, (2, 0), (2, 1))
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T22:08:25.549919.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp18 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.bbbb.vooo = tmp18.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.vooo += tmp18.transpose((3, 2, 1, 0))
    rdm2.bbbb.ovoo = tmp18.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.bbbb.ovoo += tmp18.transpose((2, 3, 1, 0)) * -1
    tmp14 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.abab.vovv = einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 1, 4, 5), (3, 2, 4, 5)) * -1
    rdm2.abab.vovo = einsum(tmp14, (0, 1, 2, 3), t1.aa, (0, 4), (3, 2, 4, 1)) * -1
    rdm2.abab.vooo = tmp14.transpose((3, 2, 0, 1)).copy() * -1
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp9 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp11 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp0 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp7 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.aaaa.vooo = tmp7.transpose((3, 2, 1, 0)).copy()
    rdm2.aaaa.vooo += tmp7.transpose((3, 2, 1, 0))
    rdm2.aaaa.ovoo = tmp7.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.aaaa.ovoo += tmp7.transpose((2, 3, 1, 0)) * -1
    tmp26 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm2.abab.ovvv = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5)) * -1
    rdm2.abab.ovov = einsum(tmp26, (0, 1, 2, 3), t1.bb, (2, 4), (1, 3, 0, 4)) * -1
    rdm2.abab.ovoo = tmp26.transpose((1, 3, 0, 2)).copy() * -1
    tmp84 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.bbbb.vovo = tmp84.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.voov = tmp84.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ovvo = tmp84.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.bbbb.ovov = tmp84.transpose((1, 2, 0, 3)).copy() * -4
    tmp83 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    rdm2.bbbb.vovo += tmp83.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.voov += tmp83.transpose((2, 1, 0, 3))
    rdm2.bbbb.ovvo += tmp83.transpose((1, 2, 3, 0))
    rdm2.bbbb.ovov += tmp83.transpose((1, 2, 0, 3)) * -1
    tmp66 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.aaaa.vovo = tmp66.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.aaaa.voov = tmp66.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.aaaa.ovvo = tmp66.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.aaaa.ovov = tmp66.transpose((1, 2, 0, 3)).copy() * -4
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.aaaa.vovo += tmp70.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.voov += tmp70.transpose((2, 1, 0, 3))
    rdm2.aaaa.ovvo += tmp70.transpose((1, 2, 3, 0))
    rdm2.aaaa.ovov += tmp70.transpose((1, 2, 0, 3)) * -1
    tmp19 = einsum(t1.bb, (0, 1), tmp18, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2.bbbb.oooo = tmp19.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.bbbb.oooo += tmp19.transpose((2, 3, 1, 0)) * -1
    tmp17 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2.bbbb.oooo += tmp17.transpose((3, 2, 1, 0))
    rdm2.bbbb.oooo += tmp17.transpose((3, 2, 1, 0))
    tmp52 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    rdm2.bbbb.oovo = tmp52.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.oovo += tmp52.transpose((1, 2, 3, 0)) * 4
    rdm2.bbbb.ooov = tmp52.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ooov += tmp52.transpose((1, 2, 0, 3)) * -4
    tmp53 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 4, 5, 2), (4, 5, 1, 3))
    rdm2.bbbb.oovo += tmp53.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += tmp53.transpose((1, 2, 3, 0))
    rdm2.bbbb.ooov += tmp53.transpose((2, 1, 0, 3))
    rdm2.bbbb.ooov += tmp53.transpose((1, 2, 0, 3)) * -1
    tmp40 = tmp9.copy()
    tmp40 += tmp10
    tmp40 += tmp11 * 2
    rdm2.abab.oovv = einsum(t2.abab, (0, 1, 2, 3), tmp40, (1, 4), (0, 4, 2, 3)) * -1
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp40, (2, 3), (3, 0, 1, 2))
    rdm2.abab.oovo = einsum(t1.aa, (0, 1), tmp40, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.bbbb.ooov += einsum(t1.bb, (0, 1), tmp40, (2, 3), (3, 0, 2, 1)) * -1
    tmp13 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    rdm2.abab.oooo = tmp13.transpose((1, 3, 0, 2)).copy()
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    rdm2.abab.oooo += tmp15.transpose((1, 3, 0, 2))
    tmp5 = tmp0.copy() * 0.5
    tmp5 += tmp1
    tmp5 += tmp2 * 0.5
    rdm2.abab.oooo += einsum(delta.bb.oo, (0, 1), tmp5, (2, 3), (3, 0, 2, 1)) * -2
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp5, (2, 3), (0, 3, 2, 1)) * 2
    tmp8 = einsum(t1.aa, (0, 1), tmp7, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2.aaaa.oooo += tmp8.transpose((2, 3, 1, 0)) * -1
    rdm2.aaaa.oooo += tmp8.transpose((2, 3, 1, 0)) * -1
    tmp6 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.aaaa.oooo += tmp6.transpose((3, 2, 1, 0))
    rdm2.aaaa.oooo += tmp6.transpose((3, 2, 1, 0))
    tmp30 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2.aaaa.oovo = tmp30.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.aaaa.oovo += tmp30.transpose((1, 2, 3, 0))
    rdm2.aaaa.ooov = tmp30.transpose((2, 1, 0, 3)).copy()
    rdm2.aaaa.ooov += tmp30.transpose((1, 2, 0, 3)) * -1
    tmp31 = einsum(tmp7, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    rdm2.aaaa.oovo += tmp31.transpose((2, 1, 3, 0)) * -4
    rdm2.aaaa.oovo += tmp31.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ooov += tmp31.transpose((2, 1, 0, 3)) * 4
    rdm2.aaaa.ooov += tmp31.transpose((1, 2, 0, 3)) * -4
    tmp85 = tmp83.copy()
    tmp85 += tmp84 * 4
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp85, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp110 = einsum(t1.bb, (0, 1), tmp18, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.bbbb.vovo += tmp110.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.voov += tmp110.transpose((2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo += tmp110.transpose((1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov += tmp110.transpose((1, 2, 0, 3)) * 2
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp106 = einsum(t1.bb, (0, 1), l1.bb, (2, 0), (2, 1))
    tmp81 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp63 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp103 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp64 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp87 = einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.abab.voov = tmp87.transpose((2, 1, 0, 3)).copy() * 2
    tmp86 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    rdm2.abab.voov += tmp86.transpose((2, 1, 0, 3)) * 2
    tmp105 = einsum(tmp7, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    rdm2.aaaa.vovo += tmp105.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.voov += tmp105.transpose((2, 1, 0, 3)) * -2
    rdm2.aaaa.ovvo += tmp105.transpose((1, 2, 3, 0)) * -2
    rdm2.aaaa.ovov += tmp105.transpose((1, 2, 0, 3)) * 2
    tmp117 = tmp66.copy() * 4
    tmp117 += tmp70
    tmp111 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    rdm2.abab.ovvo = tmp111.transpose((0, 3, 2, 1)).copy() * 2
    tmp68 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    rdm2.abab.ovvo += tmp68.transpose((0, 3, 2, 1)) * 2
    tmp54 = tmp17.transpose((1, 0, 3, 2)).copy()
    del tmp17
    tmp54 += tmp19.transpose((0, 1, 3, 2)) * -1
    del tmp19
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    rdm2.bbbb.oovo += tmp49.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.ooov += tmp49.transpose((2, 1, 0, 3)) * -2
    tmp101 = tmp53.copy()
    del tmp53
    tmp101 += tmp52 * 4
    del tmp52
    tmp34 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp35 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp38 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp39 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 3), (4, 2))
    tmp41 = einsum(t1.bb, (0, 1), tmp40, (0, 2), (2, 1)) * 0.5
    tmp50 = einsum(t1.bb, (0, 1), tmp40, (0, 2), (2, 1))
    tmp45 = tmp13.copy()
    del tmp13
    tmp45 += tmp15
    del tmp15
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp45, (0, 4, 1, 5), (4, 5, 2, 3))
    rdm2.abab.oovo += einsum(tmp45, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 4, 2))
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp21 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2.abab.ooov = tmp43.transpose((1, 2, 0, 3)).copy() * -2
    tmp44 = einsum(tmp7, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5)) * -1
    rdm2.abab.ooov += tmp44.transpose((1, 2, 0, 3)) * -2
    tmp28 = einsum(t1.aa, (0, 1), tmp5, (0, 2), (2, 1))
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (1, 0, 4, 3), (4, 2))
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp59 = einsum(tmp14, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    rdm2.abab.oovo += tmp59.transpose((0, 2, 3, 1)) * -2
    tmp60 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    rdm2.abab.oovo += tmp60.transpose((0, 2, 3, 1)) * -2
    tmp32 = tmp6.transpose((1, 0, 3, 2)).copy()
    del tmp6
    tmp32 += tmp8.transpose((0, 1, 3, 2)) * -1
    del tmp8
    tmp56 = einsum(t1.aa, (0, 1), tmp5, (0, 2), (2, 1)) * 2
    del tmp5
    tmp4 = tmp0.copy()
    tmp4 += tmp1 * 2
    tmp4 += tmp2
    rdm2.abab.oovv += einsum(tmp4, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 1, 2))
    rdm2.abab.ooov += einsum(tmp4, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    tmp78 = tmp31.copy() * 4
    del tmp31
    tmp78 += tmp30
    del tmp30
    tmp24 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2.aaaa.oovo += tmp24.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.ooov += tmp24.transpose((2, 1, 0, 3)) * -2
    tmp129 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    rdm2.bbbb.vvvv = einsum(tmp129, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.bbbb.vvvo = tmp129.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.bbbb.vvov = tmp129.transpose((2, 1, 0, 3)).copy() * -2
    del tmp129
    tmp131 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.bbbb.vvvv += tmp131.transpose((1, 0, 3, 2))
    rdm2.bbbb.vvvv += tmp131.transpose((1, 0, 3, 2))
    del tmp131
    tmp128 = einsum(t1.bb, (0, 1), l2.abab, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2.abab.vvvv = einsum(t1.aa, (0, 1), tmp128, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.vvov = tmp128.transpose((1, 2, 0, 3)).copy()
    del tmp128
    tmp127 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2.aaaa.vvvv = einsum(tmp127, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.aaaa.vvvo = tmp127.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.aaaa.vvov = tmp127.transpose((2, 1, 0, 3)).copy() * -2
    del tmp127
    tmp130 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.aaaa.vvvv += tmp130.transpose((1, 0, 3, 2))
    rdm2.aaaa.vvvv += tmp130.transpose((1, 0, 3, 2))
    del tmp130
    tmp124 = einsum(t1.bb, (0, 1), tmp85, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp85
    rdm2.bbbb.vovv = tmp124.transpose((2, 0, 3, 1)).copy() * -1
    rdm2.bbbb.vovv += tmp124.transpose((2, 0, 1, 3))
    rdm2.bbbb.ovvv = tmp124.transpose((0, 2, 3, 1)).copy()
    del tmp124
    tmp126 = einsum(tmp110, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * -1
    del tmp110
    rdm2.bbbb.vovv += tmp126.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv += tmp126.transpose((0, 1, 3, 2)) * -2
    del tmp126
    tmp125 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    del tmp18
    rdm2.bbbb.vovv += tmp125.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp125.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp125.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp125.transpose((0, 1, 3, 2)) * -1
    del tmp125
    tmp122 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.bbbb.vovv += tmp122.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp122.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp122.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp122.transpose((0, 1, 3, 2)) * -1
    del tmp122
    tmp109 = tmp106.copy()
    tmp109 += tmp80
    tmp109 += tmp81 * 2
    rdm2.bbbb.vovv += einsum(t1.bb, (0, 1), tmp109, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp109, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp109, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += einsum(delta.bb.oo, (0, 1), tmp109, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += einsum(delta.bb.oo, (0, 1), tmp109, (2, 3), (0, 2, 1, 3))
    del tmp109
    tmp107 = tmp106.copy() * 0.5
    del tmp106
    tmp107 += tmp80 * 0.5
    tmp107 += tmp81
    rdm2.bbbb.vovv += einsum(tmp107, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.ovvv += einsum(tmp107, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.vovo += einsum(delta.bb.oo, (0, 1), tmp107, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.ovvo += einsum(delta.bb.oo, (0, 1), tmp107, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.abab.ovov += einsum(delta.aa.oo, (0, 1), tmp107, (2, 3), (0, 2, 1, 3)) * 2
    del tmp107
    tmp89 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    rdm2.abab.vovv += einsum(tmp89, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    rdm2.abab.vovo += tmp89.transpose((2, 1, 3, 0)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 4, 2, 5), (0, 4, 5, 3))
    del tmp89
    tmp104 = tmp103.copy()
    tmp104 += tmp63 * 2
    tmp104 += tmp64
    rdm2.abab.vovv += einsum(t1.bb, (0, 1), tmp104, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovv = einsum(t1.aa, (0, 1), tmp104, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvv = einsum(t1.aa, (0, 1), tmp104, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovo += einsum(delta.bb.oo, (0, 1), tmp104, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovo += einsum(tmp104, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.voov += einsum(tmp104, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovvo += einsum(tmp104, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovov += einsum(tmp104, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp104
    tmp88 = tmp86.copy()
    tmp88 += tmp87
    del tmp87
    rdm2.abab.vovv += einsum(tmp88, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 4, 3)) * 2
    rdm2.abab.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp88, (1, 4, 3, 5), (0, 4, 2, 5)) * 4
    del tmp88
    tmp113 = einsum(tmp14, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp113, (0, 2, 3, 4), (3, 2, 1, 4)) * -1
    rdm2.abab.voov += tmp113.transpose((2, 1, 0, 3)) * -1
    del tmp113
    tmp120 = einsum(tmp105, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    del tmp105
    rdm2.aaaa.vovv += tmp120.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.ovvv += tmp120.transpose((0, 1, 3, 2)) * -2
    del tmp120
    tmp114 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (4, 1), (0, 4, 2, 3))
    rdm2.aaaa.vovv += tmp114.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp114.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp114.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp114.transpose((0, 1, 3, 2)) * -1
    del tmp114
    tmp119 = einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    del tmp7
    rdm2.aaaa.vovv += tmp119.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp119.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp119.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp119.transpose((0, 1, 3, 2)) * -1
    del tmp119
    tmp115 = tmp103.copy() * 0.5
    del tmp103
    tmp115 += tmp63
    tmp115 += tmp64 * 0.5
    rdm2.aaaa.vovv += einsum(t1.aa, (0, 1), tmp115, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp115, (2, 3), (0, 2, 3, 1)) * -2
    del tmp115
    tmp118 = einsum(t1.aa, (0, 1), tmp117, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp117
    rdm2.aaaa.vovv += tmp118.transpose((2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += tmp118.transpose((2, 0, 1, 3))
    rdm2.aaaa.ovvv += tmp118.transpose((0, 2, 3, 1))
    del tmp118
    tmp123 = tmp83.copy()
    tmp123 += tmp84 * 4
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp123, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp123
    tmp108 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    rdm2.abab.ovvv += einsum(tmp108, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.ovov += tmp108.transpose((1, 2, 0, 3)) * -1
    del tmp108
    tmp121 = tmp111.copy()
    del tmp111
    tmp121 += tmp68
    rdm2.abab.ovvv += einsum(tmp121, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    del tmp121
    tmp112 = einsum(t1.aa, (0, 1), tmp26, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ovvv += einsum(t1.bb, (0, 1), tmp112, (2, 0, 3, 4), (2, 4, 3, 1)) * -1
    rdm2.abab.ovvo += tmp112.transpose((0, 3, 2, 1)) * -1
    del tmp112
    tmp116 = tmp66.copy()
    tmp116 += tmp70 * 0.25
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp116, (0, 2, 3, 4), (2, 3, 1, 4)) * -4
    del tmp116
    tmp100 = einsum(t1.bb, (0, 1), tmp54, (0, 2, 3, 4), (2, 4, 3, 1))
    rdm2.bbbb.oovv = einsum(t1.bb, (0, 1), tmp100, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp100
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), tmp86, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp86
    rdm2.bbbb.oovv += tmp93.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp93.transpose((0, 1, 3, 2)) * -2
    del tmp93
    tmp99 = einsum(tmp54, (0, 1, 2, 3), t2.bbbb, (0, 1, 4, 5), (2, 3, 4, 5))
    rdm2.bbbb.oovv += tmp99.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp99.transpose((1, 0, 3, 2))
    del tmp99
    tmp96 = einsum(t1.bb, (0, 1), tmp49, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp49
    rdm2.bbbb.oovv += tmp96.transpose((0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += tmp96 * 2
    del tmp96
    tmp102 = einsum(t1.bb, (0, 1), tmp101, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp101
    rdm2.bbbb.oovv += tmp102.transpose((0, 1, 3, 2))
    rdm2.bbbb.oovv += tmp102.transpose((1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp102 * -1
    rdm2.bbbb.oovv += tmp102.transpose((1, 0, 2, 3))
    del tmp102
    tmp82 = tmp80.copy() * 0.5
    tmp82 += tmp81
    rdm2.bbbb.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp82, (3, 4), (0, 1, 2, 4)) * -4
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp82, (3, 4), (0, 1, 2, 4)) * -2
    del tmp82
    tmp98 = einsum(t2.bbbb, (0, 1, 2, 3), tmp40, (1, 4), (0, 4, 2, 3)) * -1
    del tmp40
    rdm2.bbbb.oovv += tmp98.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp98.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp98.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp98.transpose((0, 1, 3, 2)) * -1
    del tmp98
    tmp94 = einsum(t2.bbbb, (0, 1, 2, 3), tmp83, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp83
    rdm2.bbbb.oovv += tmp94.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp94 * 2
    rdm2.bbbb.oovv += tmp94.transpose((1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp94.transpose((0, 1, 3, 2)) * -2
    del tmp94
    tmp95 = tmp34.copy()
    tmp95 += tmp35 * 2
    rdm2.bbbb.oovv += einsum(tmp95, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp95, (2, 3), (2, 0, 3, 1))
    del tmp95
    tmp97 = tmp80.copy()
    del tmp80
    tmp97 += tmp81 * 2
    del tmp81
    rdm2.bbbb.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp97, (3, 4), (0, 1, 4, 2)) * 2
    del tmp97
    tmp36 = t1.bb.copy()
    tmp36 += tmp34
    tmp36 += tmp35 * 2
    rdm2.bbbb.oovv += einsum(tmp36, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp36, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ooov += einsum(tmp36, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp36
    tmp42 = tmp38.copy() * 0.5
    tmp42 += tmp39
    tmp42 += tmp41
    del tmp41
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp42, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp42, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.bbbb.oovo += einsum(tmp42, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.ooov += einsum(tmp42, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp42
    tmp92 = einsum(tmp84, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp84
    rdm2.bbbb.oovv += tmp92 * 8
    rdm2.bbbb.oovv += tmp92.transpose((0, 1, 3, 2)) * -8
    del tmp92
    tmp51 = tmp38.copy()
    del tmp38
    tmp51 += tmp39 * 2
    del tmp39
    tmp51 += tmp50
    del tmp50
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp51, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.oovv += einsum(tmp51, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp51, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.ooov += einsum(tmp51, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1))
    del tmp51
    tmp48 = t1.bb.copy()
    tmp48 += tmp34
    tmp48 += tmp35 * 2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp48, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp48, (2, 3), (2, 0, 1, 3)) * -1
    del tmp48
    tmp46 = einsum(t1.bb, (0, 1), tmp45, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp45
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp46, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ooov += tmp46.transpose((1, 2, 0, 3))
    del tmp46
    tmp58 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp58, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    rdm2.abab.oovo += tmp58.transpose((0, 2, 3, 1)) * -1
    del tmp58
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 5, 3), (4, 5, 1, 2))
    del tmp26
    rdm2.abab.oovv += einsum(tmp61, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.abab.oovo += tmp61.transpose((0, 2, 3, 1))
    del tmp61
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp14
    rdm2.abab.oovv += einsum(tmp47, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.ooov += tmp47.transpose((1, 2, 0, 3))
    del tmp47
    tmp37 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp37, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ooov += tmp37.transpose((1, 2, 0, 3)) * -1
    del tmp37
    tmp72 = tmp20.copy() * 2
    tmp72 += tmp21
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp72, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovv = einsum(t1.aa, (0, 1), tmp72, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp72, (2, 3), (2, 0, 3, 1))
    del tmp72
    tmp65 = tmp63.copy()
    tmp65 += tmp64 * 0.5
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp65, (2, 4), (0, 1, 4, 3)) * -2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp65, (3, 4), (0, 1, 2, 4)) * -4
    del tmp65
    tmp90 = tmp44.copy()
    del tmp44
    tmp90 += tmp43
    del tmp43
    rdm2.abab.oovv += einsum(tmp90, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -2
    del tmp90
    tmp29 = tmp25.copy()
    tmp29 += tmp27 * 0.5
    tmp29 += tmp28
    del tmp28
    rdm2.abab.oovv += einsum(tmp29, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.aaaa.oovv += einsum(tmp29, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp29, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.oovo += einsum(delta.bb.oo, (0, 1), tmp29, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp29, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp29, (2, 3), (2, 0, 1, 3)) * 2
    del tmp29
    tmp91 = tmp59.copy()
    del tmp59
    tmp91 += tmp60
    del tmp60
    rdm2.abab.oovv += einsum(tmp91, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -2
    del tmp91
    tmp76 = einsum(tmp32, (0, 1, 2, 3), t2.aaaa, (0, 1, 4, 5), (2, 3, 4, 5))
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2))
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2))
    del tmp76
    tmp71 = einsum(t2.aaaa, (0, 1, 2, 3), tmp70, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp70
    rdm2.aaaa.oovv += tmp71.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += tmp71 * 2
    rdm2.aaaa.oovv += tmp71.transpose((1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp71.transpose((0, 1, 3, 2)) * -2
    del tmp71
    tmp57 = tmp25.copy() * 2
    del tmp25
    tmp57 += tmp27
    del tmp27
    tmp57 += tmp56
    del tmp56
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp57, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp57, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp57, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp57, (2, 3), (2, 0, 3, 1)) * -1
    del tmp57
    tmp77 = einsum(tmp32, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp77, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp77
    tmp74 = tmp63.copy() * 2
    del tmp63
    tmp74 += tmp64
    del tmp64
    rdm2.aaaa.oovv += einsum(tmp74, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp74
    tmp67 = einsum(t2.aaaa, (0, 1, 2, 3), tmp66, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp66
    rdm2.aaaa.oovv += tmp67 * 8
    rdm2.aaaa.oovv += tmp67.transpose((0, 1, 3, 2)) * -8
    del tmp67
    tmp22 = t1.aa.copy()
    tmp22 += tmp20 * 2
    tmp22 += tmp21
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.oovo += einsum(delta.bb.oo, (0, 1), tmp22, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -1
    del tmp22
    tmp75 = einsum(t2.aaaa, (0, 1, 2, 3), tmp4, (1, 4), (4, 0, 2, 3)) * -1
    del tmp4
    rdm2.aaaa.oovv += tmp75.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp75.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp75.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp75.transpose((1, 0, 3, 2)) * -1
    del tmp75
    tmp79 = einsum(t1.aa, (0, 1), tmp78, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp78
    rdm2.aaaa.oovv += tmp79.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp79.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp79 * -1
    rdm2.aaaa.oovv += tmp79.transpose((1, 0, 2, 3))
    del tmp79
    tmp73 = einsum(t1.aa, (0, 1), tmp24, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp24
    rdm2.aaaa.oovv += tmp73.transpose((0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += tmp73 * 2
    del tmp73
    tmp23 = t1.aa.copy()
    tmp23 += tmp20 * 2
    del tmp20
    tmp23 += tmp21
    del tmp21
    rdm2.aaaa.oovv += einsum(tmp23, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovo += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ooov += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp23
    tmp69 = einsum(t2.abab, (0, 1, 2, 3), tmp68, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp68
    rdm2.aaaa.oovv += tmp69 * 2
    rdm2.aaaa.oovv += tmp69.transpose((0, 1, 3, 2)) * -2
    del tmp69
    tmp62 = t1.bb.copy() * 0.5
    tmp62 += tmp34 * 0.5
    del tmp34
    tmp62 += tmp35
    del tmp35
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp62, (2, 3), (2, 0, 3, 1)) * 2
    del tmp62
    tmp16 = tmp9.copy() * 0.5
    tmp16 += tmp10 * 0.5
    tmp16 += tmp11
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.bbbb.ooov += einsum(tmp16, (0, 1), t1.bb, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -2
    del tmp16
    tmp55 = einsum(t1.bb, (0, 1), tmp54, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp54
    rdm2.bbbb.oovo += tmp55.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov += tmp55.transpose((2, 1, 0, 3))
    del tmp55
    tmp33 = einsum(tmp32, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * 2
    del tmp32
    rdm2.aaaa.oovo += tmp33.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.ooov += tmp33.transpose((2, 1, 0, 3))
    del tmp33
    tmp12 = delta.bb.oo.copy() * -1
    tmp12 += tmp9
    del tmp9
    tmp12 += tmp10
    del tmp10
    tmp12 += tmp11 * 2
    del tmp11
    rdm2.bbbb.oooo += einsum(tmp12, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0))
    rdm2.bbbb.oooo += einsum(tmp12, (0, 1), delta.bb.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.abab.oooo += einsum(tmp12, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -1
    del tmp12
    tmp3 = delta.aa.oo.copy() * -1
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp1 * 2
    del tmp1
    tmp3 += tmp2
    del tmp2
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2))
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -1
    del tmp3
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovoo += einsum(delta.aa.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.vooo += einsum(l1.aa, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 1, 3)) * -1
    del delta
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.abab.oovv += t2.abab
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.aaaa.ovov += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvo += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovvo += einsum(t1.aa, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.voov += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.voov += einsum(l1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovo += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.vvoo = l2.aaaa.copy()
    rdm2.aaaa.vvoo += l2.aaaa
    rdm2.abab.vvoo = l2.abab.copy()
    rdm2.bbbb.vvoo = l2.bbbb.copy()
    rdm2.bbbb.vvoo += l2.bbbb
    rdm2.abab.ovvv += einsum(t2.abab, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    rdm2.abab.vovv += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4))
    rdm2.abab.vvvo = einsum(t1.aa, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    rdm2.abab.vvvv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=rdm2.aaaa.swapaxes(1, 2),
        aabb=rdm2.abab.swapaxes(1, 2),
        bbbb=rdm2.bbbb.swapaxes(1, 2),
    )

    return rdm2

