"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:29:52.785456
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:29:53.499637.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    e_cc = einsum(v.bbb.xov, (0, 1, 2), tmp0, (1, 2, 0), ())
    del tmp0
    tmp1 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp1 += einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    e_cc += einsum(tmp1, (0, 1, 2), v.baa.xov, (2, 0, 1), ())
    del tmp1

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:30:12.931422.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    t2new.bbbb = tmp17.transpose((1, 0, 2, 3)).copy() * -1
    t2new.bbbb += tmp17.transpose((1, 0, 3, 2))
    tmp10 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    t2new.aaaa = tmp10.transpose((1, 0, 2, 3)).copy() * -1
    t2new.aaaa += tmp10.transpose((1, 0, 3, 2))
    tmp54 = tmp17.transpose((1, 0, 2, 3)).copy() * -1
    tmp54 += tmp17.transpose((1, 0, 3, 2))
    tmp29 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp30 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0))
    tmp3 = einsum(t2.aaaa, (0, 1, 2, 3), v.baa.xov, (4, 1, 3), (0, 2, 4))
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    tmp13 = tmp10.transpose((1, 0, 2, 3)).copy() * -1
    tmp13 += tmp10.transpose((1, 0, 3, 2))
    tmp41 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    t2new.abab = einsum(t2.abab, (0, 1, 2, 3), tmp41, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    tmp55 = einsum(t2.bbbb, (0, 1, 2, 3), tmp54, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp54
    tmp31 = tmp29.copy() * 0.5
    tmp31 += tmp30
    tmp58 = tmp10.transpose((1, 0, 2, 3)).copy()
    tmp58 += tmp10.transpose((1, 0, 3, 2)) * -1
    tmp7 = tmp3.copy() * 2
    tmp7 += tmp4
    tmp18 = tmp17.transpose((1, 0, 2, 3)).copy()
    tmp18 += tmp17.transpose((1, 0, 3, 2)) * -1
    tmp12 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp14 = einsum(t2.aaaa, (0, 1, 2, 3), tmp13, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp13
    tmp5 = tmp3.copy() * 2
    tmp5 += tmp4
    tmp47 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp56 = tmp41.transpose((1, 0, 3, 2)).copy()
    tmp56 += tmp55 * -2
    del tmp55
    tmp33 = tmp29.copy()
    tmp33 += tmp30 * 2
    t2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp33, (3, 4, 0), (1, 3, 2, 4))
    tmp32 = einsum(tmp31, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3)) * 2
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp32, (4, 3), (0, 1, 2, 4)) * -1
    tmp59 = einsum(tmp58, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    del tmp58
    tmp45 = einsum(v.bbb.xov, (0, 1, 2), tmp31, (3, 2, 0), (3, 1))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 1), (0, 4, 2, 3)) * -2
    tmp62 = einsum(tmp17, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp34 = tmp3.copy()
    tmp34 += tmp4 * 0.5
    tmp8 = einsum(tmp7, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    t2new.aaaa += tmp8.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp8.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp8.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp8
    tmp36 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    t2new.abab += tmp36
    tmp27 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp39 = einsum(tmp7, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 1, 4))
    del tmp7
    t2new.abab += tmp39
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp18
    tmp15 = tmp12.transpose((1, 0, 3, 2)).copy()
    tmp15 += tmp14.transpose((1, 0, 3, 2)) * -2
    del tmp14
    tmp25 = einsum(tmp5, (0, 1, 2), v.baa.xov, (2, 3, 1), (3, 0)) * 0.5
    tmp23 = einsum(t2.aaaa, (0, 1, 2, 3), tmp10, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp0 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (2, 0, 3), (3, 1))
    t2new.aaaa += einsum(tmp6, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    t2new.bbbb += tmp49.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp49.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp49.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp49.transpose((1, 0, 3, 2))
    del tmp49
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t2.bbbb, (1, 3, 4, 5), (2, 0, 4, 5))
    del tmp47
    t2new.bbbb += tmp48.transpose((0, 1, 3, 2)) * -0.5
    t2new.bbbb += tmp48.transpose((0, 1, 3, 2)) * -0.5
    t2new.bbbb += tmp48.transpose((0, 1, 3, 2)) * -0.5
    t2new.bbbb += tmp48.transpose((0, 1, 3, 2)) * -0.5
    del tmp48
    tmp57 = einsum(t2.bbbb, (0, 1, 2, 3), tmp56, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp56
    t2new.bbbb += tmp57.transpose((1, 0, 3, 2)) * -2
    t2new.bbbb += tmp57.transpose((0, 1, 3, 2)) * 2
    del tmp57
    tmp53 = einsum(tmp30, (0, 1, 2), tmp29, (3, 4, 2), (3, 0, 4, 1))
    del tmp29, tmp30
    t2new.bbbb += tmp53.transpose((1, 0, 3, 2)) * 2
    t2new.bbbb += tmp53 * 2
    t2new.bbbb += tmp53.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp53.transpose((0, 1, 3, 2)) * -2
    del tmp53
    tmp51 = einsum(v.bbb.xov, (0, 1, 2), tmp33, (3, 4, 0), (3, 1, 4, 2))
    del tmp33
    t2new.bbbb += tmp51
    t2new.bbbb += tmp51.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp51.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp51.transpose((1, 0, 3, 2))
    del tmp51
    tmp52 = f.bb.vv.copy() * -1
    tmp52 += tmp32
    del tmp32
    t2new.bbbb += einsum(tmp52, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp52
    tmp61 = einsum(tmp41, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp41
    t2new.bbbb += tmp61.transpose((1, 0, 2, 3)) * 2
    t2new.bbbb += tmp61 * -2
    del tmp61
    tmp50 = einsum(tmp31, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3))
    del tmp31
    t2new.bbbb += einsum(tmp50, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp50
    tmp60 = einsum(tmp59, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp59
    t2new.bbbb += tmp60
    t2new.bbbb += tmp60.transpose((0, 1, 3, 2)) * -1
    del tmp60
    tmp65 = einsum(t2.bbbb, (0, 1, 2, 3), tmp45, (4, 1), (0, 4, 2, 3)) * -2
    del tmp45
    t2new.bbbb += tmp65.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp65.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp65.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp65.transpose((0, 1, 3, 2)) * -1
    del tmp65
    tmp64 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp64, (4, 2, 5, 3), (0, 1, 4, 5)) * -2
    del tmp64
    tmp63 = einsum(tmp62, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp62
    t2new.bbbb += tmp63.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp63.transpose((0, 1, 3, 2)) * -1
    del tmp63
    tmp35 = f.aa.vv.copy() * -0.5
    tmp35 += einsum(tmp34, (0, 1, 2), v.baa.xov, (2, 0, 3), (3, 1))
    del tmp34
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp35, (2, 4), (0, 1, 4, 3)) * -2
    del tmp35
    tmp42 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp42, (4, 0, 5, 3), (4, 1, 2, 5)) * -1
    del tmp42
    tmp46 = einsum(v.baa.xov, (0, 1, 2), tmp5, (3, 2, 0), (3, 1))
    del tmp5
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp46, (4, 0), (4, 1, 2, 3)) * -1
    del tmp46
    tmp38 = tmp12.transpose((1, 0, 3, 2)).copy()
    tmp38 += einsum(tmp10, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 2), (0, 4, 3, 5)) * 2
    del tmp10
    tmp38 += tmp8 * -1
    del tmp8
    t2new.abab += einsum(tmp38, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp38
    tmp43 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 4, 1, 2))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp43, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp43
    tmp37 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp37 += einsum(tmp36, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5)) * -1
    t2new.abab += einsum(tmp37, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5)) * -1
    del tmp37
    tmp28 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp27
    t2new.abab += tmp28 * 0.5
    t2new.abab += tmp28 * 0.5
    del tmp28
    tmp40 = einsum(tmp17, (0, 1, 2, 3), t2.abab, (4, 1, 5, 2), (4, 0, 5, 3)) * -1
    del tmp17
    tmp40 += tmp39
    del tmp39
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp40, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp40
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 5, 2, 3), (0, 4, 1, 5))
    del tmp36
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp44, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp44
    tmp2 = einsum(f.aa.oo, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4))
    t2new.aaaa += tmp2.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp2.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp2.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp2.transpose((1, 0, 3, 2))
    del tmp2
    tmp11 = einsum(tmp4, (0, 1, 2), tmp3, (3, 4, 2), (3, 0, 4, 1))
    del tmp3, tmp4
    t2new.aaaa += tmp11.transpose((1, 0, 3, 2)) * 2
    t2new.aaaa += tmp11 * 2
    t2new.aaaa += tmp11.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp11.transpose((0, 1, 3, 2)) * -2
    del tmp11
    tmp22 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (4, 2, 5, 3), (0, 1, 4, 5)) * -2
    del tmp22
    tmp20 = einsum(tmp19, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp19
    t2new.aaaa += tmp20
    t2new.aaaa += tmp20.transpose((1, 0, 2, 3)) * -1
    del tmp20
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), tmp15, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp15
    t2new.aaaa += tmp16 * -2
    t2new.aaaa += tmp16.transpose((1, 0, 2, 3)) * 2
    del tmp16
    tmp26 = einsum(tmp25, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4)) * -2
    del tmp25
    t2new.aaaa += tmp26.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp26.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp26.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp26.transpose((1, 0, 3, 2)) * -1
    del tmp26
    tmp24 = einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp23
    t2new.aaaa += tmp24.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp24.transpose((0, 1, 3, 2)) * -1
    del tmp24
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), tmp0, (4, 0, 5, 1), (5, 4, 2, 3))
    del tmp0
    t2new.aaaa += tmp1.transpose((0, 1, 3, 2)) * -0.5
    t2new.aaaa += tmp1.transpose((0, 1, 3, 2)) * -0.5
    t2new.aaaa += tmp1.transpose((0, 1, 3, 2)) * -0.5
    t2new.aaaa += tmp1.transpose((0, 1, 3, 2)) * -0.5
    del tmp1
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), tmp12, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp12
    t2new.aaaa += tmp21.transpose((1, 0, 2, 3)) * 2
    t2new.aaaa += tmp21 * -2
    del tmp21
    tmp9 = f.aa.vv.copy() * -1
    tmp9 += tmp6.transpose((1, 0))
    del tmp6
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (4, 3), (0, 1, 4, 2)) * 2
    del tmp9
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), f.aa.vv, (4, 3), (0, 1, 2, 4)) * 2
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.oo, (4, 1), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(f.aa.oo, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.vv, (4, 3), (0, 1, 2, 4))
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), f.bb.vv, (4, 3), (0, 1, 2, 4)) * 2

    return {f"t2new": t2new}

def update_lams(f=None, l2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:30:43.026709.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp51 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp50 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    tmp8 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp13 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp0 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp1 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp52 = tmp50.copy() * 0.5
    del tmp50
    tmp52 += tmp51
    del tmp51
    tmp33 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp33 += tmp8 * 2
    tmp33 += tmp9
    tmp35 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp35 += tmp12
    tmp35 += tmp13 * 2
    tmp74 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp75 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp56 = tmp12.copy() * 0.5
    tmp56 += tmp13
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp43 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp18 = tmp8.copy() * 2
    tmp18 += tmp9
    tmp2 = tmp0.copy() * 2
    del tmp0
    tmp2 += tmp1
    del tmp1
    tmp14 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp14 += tmp12
    del tmp12
    tmp14 += tmp13 * 2
    del tmp13
    tmp10 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp10 += tmp8 * 2
    del tmp8
    tmp10 += tmp9
    del tmp9
    tmp53 = einsum(tmp52, (0, 1), v.bbb.xov, (2, 3, 1), (3, 0, 2)) * 2
    l2new.bbbb = einsum(tmp53, (0, 1, 2), v.bbb.xov, (2, 3, 4), (4, 1, 0, 3))
    tmp93 = einsum(tmp33, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2))
    tmp94 = einsum(tmp35, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2))
    tmp98 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp97 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp76 = tmp74.copy() * 0.5
    del tmp74
    tmp76 += tmp75
    del tmp75
    tmp89 = einsum(tmp56, (0, 1, 2), v.bbb.xov, (2, 0, 3), (3, 1))
    tmp45 = tmp43.copy() * 2
    del tmp43
    tmp45 += tmp44
    del tmp44
    tmp27 = einsum(tmp18, (0, 1, 2), v.baa.xov, (2, 0, 3), (1, 3))
    tmp19 = einsum(tmp18, (0, 1, 2), v.baa.xov, (2, 3, 1), (0, 3))
    tmp40 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp39 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp3 = einsum(tmp2, (0, 1), v.baa.xov, (2, 3, 1), (3, 0, 2))
    l2new.abab = einsum(v.bbb.xov, (0, 1, 2), tmp3, (3, 4, 0), (4, 2, 3, 1)) * -1
    tmp15 = einsum(tmp14, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2))
    tmp11 = einsum(tmp10, (0, 1, 2), l2.aaaa, (3, 1, 4, 0), (4, 3, 2)) * 2
    tmp36 = einsum(tmp35, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2))
    del tmp35
    tmp34 = einsum(tmp33, (0, 1, 2), l2.aaaa, (3, 1, 4, 0), (4, 3, 2))
    del tmp33
    tmp54 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp54 += tmp53 * -1
    del tmp53
    l2new.abab += einsum(tmp54, (0, 1, 2), v.baa.xov, (2, 3, 4), (4, 1, 3, 0))
    tmp95 = tmp93.copy()
    del tmp93
    tmp95 += tmp94 * 2
    del tmp94
    tmp99 = tmp97.copy()
    del tmp97
    tmp99 += tmp98 * 4
    del tmp98
    tmp80 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp85 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp70 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp70, (4, 3, 5, 1), (0, 5, 2, 4)) * -1
    tmp77 = einsum(v.bbb.xov, (0, 1, 2), tmp76, (3, 1), (3, 2, 0)) * 2
    l2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp77, (3, 4, 0), (2, 4, 1, 3)) * -1
    tmp57 = einsum(tmp56, (0, 1, 2), v.bbb.xov, (2, 3, 1), (3, 0)) * 2
    tmp59 = einsum(tmp10, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2)) * 0.25
    tmp60 = einsum(tmp14, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2)) * 0.5
    tmp87 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp90 = f.bb.vv.copy() * -0.5
    tmp90 += tmp89.transpose((1, 0))
    del tmp89
    tmp101 = einsum(v.bbb.xov, (0, 1, 2), tmp76, (3, 1), (3, 2, 0))
    del tmp76
    tmp65 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp63 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 4, 1, 2))
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp24 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp6 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp6, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (2, 4, 0, 5)) * -1
    tmp46 = einsum(v.baa.xov, (0, 1, 2), tmp45, (3, 1), (3, 2, 0)) * 0.5
    tmp31 = einsum(tmp2, (0, 1), v.baa.xov, (2, 3, 1), (3, 0, 2)) * 0.5
    del tmp2
    tmp22 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp28 = f.aa.vv.copy() * -1
    tmp28 += tmp27
    del tmp27
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp28, (0, 4), (4, 1, 2, 3)) * -1
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp48 = einsum(v.baa.xov, (0, 1, 2), tmp45, (3, 1), (3, 2, 0))
    del tmp45
    l2new.abab += einsum(tmp48, (0, 1, 2), v.bbb.xov, (2, 3, 4), (1, 4, 0, 3)) * -1
    tmp20 = f.aa.oo.copy()
    tmp20 += tmp19
    del tmp19
    tmp41 = tmp39.copy() * 4
    del tmp39
    tmp41 += tmp40
    del tmp40
    tmp4 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp4 += tmp3 * -1
    del tmp3
    tmp16 = tmp11.copy()
    del tmp11
    tmp16 += tmp15
    del tmp15
    tmp37 = tmp34.copy() * 2
    del tmp34
    tmp37 += tmp36
    del tmp36
    l2new.abab += einsum(tmp37, (0, 1, 2), v.bbb.xov, (2, 3, 4), (1, 4, 0, 3))
    tmp81 = einsum(tmp54, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp54
    l2new.bbbb += tmp81.transpose((3, 2, 0, 1)) * -1
    l2new.bbbb += tmp81.transpose((2, 3, 0, 1))
    del tmp81
    tmp96 = einsum(tmp95, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp95
    l2new.bbbb += tmp96.transpose((3, 2, 0, 1)) * -1
    l2new.bbbb += tmp96.transpose((3, 2, 1, 0))
    del tmp96
    tmp84 = f.bb.oo.copy() * 0.5
    tmp84 += einsum(v.bbb.xov, (0, 1, 2), tmp56, (3, 2, 0), (3, 1))
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp84, (3, 4), (0, 1, 2, 4)) * -4
    del tmp84
    tmp100 = einsum(tmp99, (0, 1, 2, 3), tmp80, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp99
    l2new.bbbb += tmp100.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp100.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp100.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp100.transpose((3, 2, 0, 1))
    del tmp100
    tmp86 = einsum(tmp85, (0, 1, 2, 3), tmp80, (2, 3, 4, 5), (0, 1, 4, 5))
    del tmp85
    l2new.bbbb += tmp86.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp86.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp86.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp86.transpose((3, 2, 1, 0)) * 0.5
    del tmp86
    tmp83 = einsum(tmp10, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2))
    del tmp10
    tmp83 += einsum(tmp14, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2)) * 2
    del tmp14
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp83, (3, 4, 0), (2, 4, 3, 1)) * -1
    del tmp83
    tmp82 = einsum(tmp70, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    del tmp70
    l2new.bbbb += tmp82.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp82.transpose((2, 3, 0, 1)) * -2
    l2new.bbbb += tmp82.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp82.transpose((3, 2, 0, 1)) * 2
    del tmp82
    tmp103 = einsum(tmp77, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1)) * -1
    del tmp77
    l2new.bbbb += tmp103.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp103.transpose((3, 2, 0, 1)) * -1
    del tmp103
    tmp58 = f.bb.oo.copy()
    tmp58 += tmp57.transpose((1, 0))
    del tmp57
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp58, (3, 4), (0, 1, 4, 2)) * 2
    l2new.abab += einsum(tmp58, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp58
    tmp61 = tmp59.copy()
    del tmp59
    tmp61 += tmp60
    del tmp60
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp61, (3, 4, 0), (2, 4, 1, 3)) * 4
    l2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp61, (3, 4, 0), (2, 4, 1, 3)) * 4
    del tmp61
    tmp92 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp92 += einsum(t2.bbbb, (0, 1, 2, 3), tmp80, (4, 5, 3, 2), (0, 1, 5, 4)) * -1
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp92, (2, 3, 4, 5), (0, 1, 5, 4)) * 2
    del tmp92
    tmp88 = einsum(tmp87, (0, 1, 2, 3), l2.bbbb, (1, 3, 4, 5), (4, 5, 2, 0))
    del tmp87
    l2new.bbbb += tmp88.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp88.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp88.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp88.transpose((2, 3, 1, 0)) * -0.5
    del tmp88
    tmp91 = einsum(tmp90, (0, 1), l2.bbbb, (2, 0, 3, 4), (3, 4, 2, 1)) * -2
    del tmp90
    l2new.bbbb += tmp91.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp91.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp91.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp91.transpose((3, 2, 1, 0))
    del tmp91
    tmp104 = einsum(tmp52, (0, 1), v.bbb.xov, (2, 3, 1), (3, 0, 2)) * -1
    del tmp52
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp104, (3, 4, 0), (4, 2, 3, 1)) * 2
    del tmp104
    tmp102 = einsum(v.bbb.xov, (0, 1, 2), tmp101, (3, 4, 0), (1, 3, 2, 4)) * -2
    del tmp101
    l2new.bbbb += tmp102.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp102.transpose((3, 2, 1, 0))
    del tmp102
    tmp68 = f.bb.vv.copy() * -1
    tmp68 += einsum(v.bbb.xov, (0, 1, 2), tmp56, (1, 3, 0), (3, 2)) * 2
    del tmp56
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp68, (1, 4), (0, 4, 2, 3)) * -1
    del tmp68
    tmp71 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp71, (4, 2, 5, 1), (0, 5, 4, 3)) * -1
    del tmp71
    tmp62 = f.aa.oo.copy() * 0.5
    tmp62 += einsum(tmp18, (0, 1, 2), v.baa.xov, (2, 3, 1), (0, 3)) * 0.5
    del tmp18
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp62, (2, 4), (0, 1, 4, 3)) * -2
    del tmp62
    tmp73 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    l2new.abab += einsum(tmp65, (0, 1, 2, 3), tmp73, (4, 1, 5, 2), (5, 3, 0, 4))
    del tmp73
    tmp79 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp79 += einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    l2new.abab += einsum(tmp80, (0, 1, 2, 3), tmp79, (4, 0, 5, 3), (5, 2, 4, 1)) * -2
    del tmp80, tmp79
    tmp72 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    l2new.abab += einsum(tmp72, (0, 1, 2, 3), tmp65, (1, 4, 5, 3), (5, 2, 0, 4))
    del tmp72
    tmp78 = einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp78 += einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    l2new.abab += einsum(tmp24, (0, 1, 2, 3), tmp78, (0, 4, 3, 5), (2, 5, 1, 4)) * -2
    del tmp78
    tmp69 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp69 += einsum(t2.abab, (0, 1, 2, 3), tmp65, (4, 5, 2, 3), (0, 4, 1, 5))
    l2new.abab += einsum(tmp69, (0, 1, 2, 3), l2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp69
    tmp55 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp55, (0, 1, 2, 3), l2.abab, (3, 4, 5, 1), (2, 4, 5, 0)) * -1
    del tmp55
    tmp64 = einsum(tmp63, (0, 1, 2, 3), l2.abab, (1, 3, 4, 5), (4, 5, 0, 2))
    del tmp63
    l2new.abab += tmp64.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp64.transpose((2, 3, 0, 1)) * 0.5
    del tmp64
    tmp67 = einsum(tmp66, (0, 1, 2, 3), tmp65, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp65, tmp66
    l2new.abab += tmp67.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp67.transpose((2, 3, 0, 1)) * 0.5
    del tmp67
    tmp30 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp30 += einsum(tmp24, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 2), (4, 5, 1, 0)) * -1
    l2new.aaaa = einsum(l2.aaaa, (0, 1, 2, 3), tmp30, (2, 3, 4, 5), (0, 1, 5, 4)) * 2
    del tmp30
    tmp7 = einsum(tmp6, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    del tmp6
    l2new.aaaa += tmp7.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp7.transpose((2, 3, 0, 1)) * -2
    l2new.aaaa += tmp7.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp7.transpose((3, 2, 0, 1)) * 2
    del tmp7
    tmp47 = einsum(v.baa.xov, (0, 1, 2), tmp46, (3, 4, 0), (3, 1, 4, 2)) * -2
    del tmp46
    l2new.aaaa += tmp47.transpose((3, 2, 0, 1)) * -1
    l2new.aaaa += tmp47.transpose((2, 3, 0, 1))
    del tmp47
    tmp32 = einsum(tmp31, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4)) * -2
    del tmp31
    l2new.aaaa += tmp32.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp32.transpose((3, 2, 0, 1)) * -1
    del tmp32
    tmp23 = einsum(tmp22, (0, 1, 2, 3), l2.aaaa, (1, 3, 4, 5), (4, 5, 2, 0))
    del tmp22
    l2new.aaaa += tmp23.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp23.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp23.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp23.transpose((2, 3, 1, 0)) * -0.5
    del tmp23
    tmp29 = einsum(tmp28, (0, 1), l2.aaaa, (2, 0, 3, 4), (3, 4, 2, 1)) * -1
    del tmp28
    l2new.aaaa += tmp29.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp29.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp29.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp29.transpose((3, 2, 1, 0))
    del tmp29
    tmp26 = einsum(tmp25, (0, 1, 2, 3), tmp24, (2, 3, 4, 5), (0, 1, 4, 5))
    del tmp25
    l2new.aaaa += tmp26.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp26.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp26.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp26.transpose((3, 2, 1, 0)) * 0.5
    del tmp26
    tmp49 = einsum(tmp48, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4)) * -1
    del tmp48
    l2new.aaaa += tmp49.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp49.transpose((2, 3, 1, 0)) * -1
    del tmp49
    tmp21 = einsum(tmp20, (0, 1), l2.aaaa, (2, 3, 4, 0), (4, 1, 2, 3)) * -2
    del tmp20
    l2new.aaaa += tmp21.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp21.transpose((3, 2, 0, 1)) * -1
    del tmp21
    tmp42 = einsum(tmp41, (0, 1, 2, 3), tmp24, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp24, tmp41
    l2new.aaaa += tmp42.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp42.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp42.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp42.transpose((2, 3, 1, 0))
    del tmp42
    tmp5 = einsum(v.baa.xov, (0, 1, 2), tmp4, (3, 4, 0), (3, 1, 4, 2))
    del tmp4
    l2new.aaaa += tmp5.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp5.transpose((3, 2, 1, 0))
    del tmp5
    tmp17 = einsum(tmp16, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4))
    del tmp16
    l2new.aaaa += tmp17.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp17.transpose((3, 2, 0, 1)) * -1
    del tmp17
    tmp38 = einsum(v.baa.xov, (0, 1, 2), tmp37, (3, 4, 0), (3, 1, 4, 2))
    del tmp37
    l2new.aaaa += tmp38.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp38.transpose((2, 3, 0, 1))
    del tmp38

    return {f"l2new": l2new}

def make_rdm1_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:30:44.044299.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    rdm1.aa.oo = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (0, 4)) * -1
    rdm1.aa.oo += delta.aa.oo
    rdm1.aa.oo += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (4, 2)) * -2
    rdm1.bb.oo = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (4, 2)) * -2
    rdm1.bb.oo += delta.bb.oo
    del delta
    rdm1.bb.oo += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (1, 4)) * -1
    rdm1.aa.vv = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    rdm1.bb.vv = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa.oo = np.zeros((t2.aa.shape[0], t2.aa.shape[0]))
    rdm1.aa.vv = np.zeros((t2.aa.shape[-1], t2.aa.shape[-1]))
    rdm1.bb.oo = np.zeros((t2.bb.shape[0], t2.bb.shape[0]))
    rdm1.bb.vv = np.zeros((t2.bb.shape[-1], t2.bb.shape[-1]))
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:30:59.871942.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp6 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp0 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp1 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp24 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp13 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp12 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp11 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2.bbbb.oooo = tmp11.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.oooo += tmp11.transpose((3, 2, 1, 0))
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    rdm2.abab.voov = tmp35.transpose((2, 1, 0, 3)).copy() * 2
    tmp33 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.bbbb.vovo = tmp33.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.voov = tmp33.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ovvo = tmp33.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.bbbb.ovov = tmp33.transpose((1, 2, 0, 3)).copy() * -4
    tmp10 = tmp5.copy()
    tmp10 += tmp6 * 2
    rdm2.abab.oovv = einsum(tmp10, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    rdm2.bbbb.oooo += einsum(tmp10, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.oooo += einsum(tmp10, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp37 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    rdm2.bbbb.vovo += tmp37.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.voov += tmp37.transpose((2, 1, 0, 3))
    rdm2.bbbb.ovvo += tmp37.transpose((1, 2, 3, 0))
    rdm2.bbbb.ovov += tmp37.transpose((1, 2, 0, 3)) * -1
    tmp21 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    rdm2.abab.ovvo = tmp21.transpose((0, 3, 2, 1)).copy() * 2
    tmp19 = einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    rdm2.abab.ovvo += tmp19.transpose((0, 3, 2, 1)) * 2
    tmp28 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo = tmp28.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.aaaa.voov = tmp28.transpose((2, 1, 0, 3)).copy()
    rdm2.aaaa.ovvo = tmp28.transpose((1, 2, 3, 0)).copy()
    rdm2.aaaa.ovov = tmp28.transpose((1, 2, 0, 3)).copy() * -1
    tmp17 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo += tmp17.transpose((2, 1, 3, 0)) * -4
    rdm2.aaaa.voov += tmp17.transpose((2, 1, 0, 3)) * 4
    rdm2.aaaa.ovvo += tmp17.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ovov += tmp17.transpose((1, 2, 0, 3)) * -4
    tmp3 = tmp0.copy()
    tmp3 += tmp1 * 0.5
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (1, 2, 0, 3)) * -2
    tmp4 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.aaaa.oooo += tmp4.transpose((3, 2, 1, 0))
    rdm2.aaaa.oooo += tmp4.transpose((3, 2, 1, 0))
    tmp41 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.bbbb.vvvv = tmp41.transpose((1, 0, 3, 2)).copy()
    rdm2.bbbb.vvvv += tmp41.transpose((1, 0, 3, 2))
    del tmp41
    tmp40 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa.vvvv = tmp40.transpose((1, 0, 3, 2)).copy()
    rdm2.aaaa.vvvv += tmp40.transpose((1, 0, 3, 2))
    del tmp40
    tmp39 = tmp24.copy()
    tmp39 += tmp25 * 2
    rdm2.bbbb.vovo += einsum(tmp39, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(tmp39, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovv = einsum(tmp39, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp39
    tmp14 = tmp12.copy() * 2
    tmp14 += tmp13
    rdm2.abab.vovo = einsum(tmp14, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.voov += einsum(tmp14, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovov += einsum(tmp14, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp14, (2, 4), (0, 1, 4, 3)) * -1
    rdm2.aaaa.oovv = einsum(tmp14, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp14
    tmp23 = tmp12.copy()
    del tmp12
    tmp23 += tmp13 * 0.5
    del tmp13
    rdm2.aaaa.vovo += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.ovvo += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp23, (3, 4), (0, 1, 4, 2)) * 4
    del tmp23
    tmp26 = tmp24.copy() * 0.5
    del tmp24
    tmp26 += tmp25
    del tmp25
    rdm2.bbbb.voov += einsum(tmp26, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.ovov += einsum(tmp26, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.abab.ovov = einsum(tmp26, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.oovv += einsum(tmp26, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp26, (3, 4), (0, 1, 2, 4)) * -2
    del tmp26
    tmp27 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    rdm2.abab.ovov += tmp27.transpose((1, 2, 0, 3)) * -1
    rdm2.abab.oovv += einsum(tmp27, (0, 1, 2, 3), t2.abab, (0, 4, 5, 2), (1, 4, 5, 3))
    del tmp27
    tmp32 = einsum(tmp11, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (3, 2, 4, 5))
    del tmp11
    rdm2.bbbb.oovv += tmp32.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp32.transpose((0, 1, 3, 2)) * -1
    del tmp32
    tmp36 = einsum(tmp35, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp35
    rdm2.bbbb.oovv += tmp36.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp36.transpose((0, 1, 3, 2)) * -2
    del tmp36
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp33
    rdm2.bbbb.oovv += tmp34 * 8
    rdm2.bbbb.oovv += tmp34.transpose((0, 1, 3, 2)) * -8
    del tmp34
    tmp31 = einsum(t2.bbbb, (0, 1, 2, 3), tmp10, (1, 4), (0, 4, 2, 3)) * -1
    del tmp10
    rdm2.bbbb.oovv += tmp31.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp31.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp31.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp31.transpose((1, 0, 3, 2))
    del tmp31
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp37
    rdm2.bbbb.oovv += tmp38.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp38 * 2
    rdm2.bbbb.oovv += tmp38.transpose((1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp38.transpose((0, 1, 3, 2)) * -2
    del tmp38
    tmp30 = tmp21.copy()
    tmp30 += tmp19
    rdm2.abab.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp30, (4, 1, 5, 3), (4, 0, 5, 2)) * 4
    del tmp30
    tmp8 = tmp0.copy() * 2
    tmp8 += tmp1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp8, (0, 4), (4, 1, 2, 3)) * -1
    rdm2.abab.oooo = einsum(delta.bb.oo, (0, 1), tmp8, (2, 3), (3, 0, 2, 1)) * -1
    del tmp8
    tmp29 = tmp17.copy() * 4
    tmp29 += tmp28
    del tmp28
    rdm2.abab.oovv += einsum(tmp29, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp29
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 4, 1, 5), (4, 5, 2, 3))
    rdm2.abab.oooo += tmp9.transpose((1, 3, 0, 2))
    del tmp9
    tmp22 = einsum(tmp21, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp21
    rdm2.aaaa.oovv += tmp22.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += tmp22 * 2
    rdm2.aaaa.oovv += tmp22.transpose((1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp22.transpose((0, 1, 3, 2)) * -2
    del tmp22
    tmp15 = einsum(t2.aaaa, (0, 1, 2, 3), tmp3, (1, 4), (0, 4, 2, 3)) * -2
    del tmp3
    rdm2.aaaa.oovv += tmp15.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp15.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp15.transpose((1, 0, 3, 2))
    rdm2.aaaa.oovv += tmp15.transpose((1, 0, 3, 2))
    del tmp15
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp19
    rdm2.aaaa.oovv += tmp20 * 2
    rdm2.aaaa.oovv += tmp20.transpose((0, 1, 3, 2)) * -2
    del tmp20
    tmp16 = einsum(tmp4, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 5), (3, 2, 4, 5))
    del tmp4
    rdm2.aaaa.oovv += tmp16.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp16.transpose((0, 1, 3, 2)) * -1
    del tmp16
    tmp18 = einsum(t2.aaaa, (0, 1, 2, 3), tmp17, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp17
    rdm2.aaaa.oovv += tmp18 * 8
    rdm2.aaaa.oovv += tmp18.transpose((0, 1, 3, 2)) * -8
    del tmp18
    tmp7 = delta.bb.oo.copy() * -0.5
    tmp7 += tmp5 * 0.5
    del tmp5
    tmp7 += tmp6
    del tmp6
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp7, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.bbbb.oooo += einsum(tmp7, (0, 1), delta.bb.oo, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.abab.oooo += einsum(tmp7, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -2
    del tmp7
    tmp2 = delta.aa.oo.copy() * -1
    tmp2 += tmp0 * 2
    del tmp0
    tmp2 += tmp1
    del tmp1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp2, (2, 3), (3, 0, 1, 2))
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp2, (2, 3), (0, 3, 1, 2)) * -1
    del delta, tmp2
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.abab.oovv += t2.abab
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.abab.voov += einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (4, 0, 5, 2)) * 2
    rdm2.abab.vovo += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (0, 4, 5, 3)) * -1
    rdm2.aaaa.vvoo = l2.aaaa.copy()
    rdm2.aaaa.vvoo += l2.aaaa
    rdm2.abab.vvoo = l2.abab.copy()
    rdm2.bbbb.vvoo = l2.bbbb.copy()
    rdm2.bbbb.vvoo += l2.bbbb
    rdm2.abab.vvvv = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.aaaa.ooov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.oovo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.aaaa.ovoo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.vooo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.ovvv = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vovv = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvov = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvvo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.aabb.ooov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.aabb.oovo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.aabb.ovoo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.aabb.vooo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.aabb.ovvv = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.aabb.vovv = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.aabb.vvov = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.aabb.vvvo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbaa.ooov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.bbaa.oovo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.bbaa.ovoo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.bbaa.vooo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.bbaa.ovvv = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.bbaa.vovv = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.bbaa.vvov = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.bbaa.vvvo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.bbbb.ooov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.oovo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbbb.ovoo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.vooo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.ovvv = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vovv = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvov = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvvo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=rdm2.aaaa.swapaxes(1, 2),
        aabb=rdm2.abab.swapaxes(1, 2),
        bbbb=rdm2.bbbb.swapaxes(1, 2),
    )

    return rdm2

