"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:54:59.878219
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:55:00.400217.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 1, 3), ())
    e_cc += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 2, 1, 3), ())

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:55:18.784008.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp57 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp57 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp22 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp22 += v.aaaa.ovov.transpose((0, 2, 1, 3)) * -1
    tmp16 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 3, 1), (4, 0)) * -1
    tmp15 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp58 = einsum(t2.bbbb, (0, 1, 2, 3), tmp57, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp57
    tmp26 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp26 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp23 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp11 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp10 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp5 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp5 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp1 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp1 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp46 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    t2new.abab = tmp46.copy() * 2
    tmp17 = tmp15.copy()
    tmp17 += tmp16 * 2
    t1new.bb = einsum(t1.bb, (0, 1), tmp17, (2, 0), (2, 1)) * -1
    tmp44 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp64 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp61 = einsum(tmp22, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    del tmp22
    tmp59 = v.bbbb.oovv.copy()
    tmp59 += tmp58 * -2
    del tmp58
    tmp48 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp48 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.aaaa = tmp20.copy()
    t2new.aaaa += tmp20.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp20.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp20.transpose((1, 0, 3, 2))
    tmp34 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp35 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp26
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    t2new.abab += tmp50 * 2
    tmp24 = v.aaaa.oovv.copy()
    tmp24 += tmp23 * -2
    del tmp23
    tmp30 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp39 = tmp10.copy() * 2
    tmp39 += tmp11
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 0), (4, 1, 2, 3)) * -1
    tmp6 = einsum(t1.bb, (0, 1), tmp5, (0, 2, 3, 1), (2, 3))
    del tmp5
    tmp4 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    t1new.bb += tmp4
    tmp2 = einsum(tmp1, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp1
    tmp0 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    t1new.aa = tmp0.copy()
    tmp66 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    t2new.bbbb = tmp66.transpose((1, 0, 3, 2)).copy() * 0.5
    t2new.bbbb += tmp66.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp66.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp66.transpose((1, 0, 3, 2)) * 0.5
    del tmp66
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), tmp46, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp46
    t2new.bbbb += tmp56.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp56.transpose((0, 1, 3, 2)) * -2
    t2new.bbbb += tmp56.transpose((1, 0, 3, 2)) * 2
    t2new.bbbb += tmp56 * 2
    del tmp56
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    t2new.bbbb += tmp70
    t2new.bbbb += tmp70.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp70.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp70.transpose((1, 0, 3, 2))
    del tmp70
    tmp72 = einsum(t2.bbbb, (0, 1, 2, 3), tmp17, (4, 1), (0, 4, 2, 3)) * -1
    del tmp17
    t2new.bbbb += tmp72.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp72.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp72.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp72.transpose((0, 1, 3, 2)) * -1
    del tmp72
    tmp63 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    t2new.bbbb += tmp63 * -2
    t2new.bbbb += tmp63.transpose((1, 0, 2, 3)) * 2
    del tmp63
    tmp71 = f.bb.vv.copy() * -1
    tmp71 += tmp43
    tmp71 += tmp44 * 2
    t2new.bbbb += einsum(tmp71, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp71
    tmp69 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.bbbb += tmp69 * 2
    t2new.bbbb += tmp69.transpose((0, 1, 3, 2)) * -2
    t2new.bbbb += tmp69.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp69.transpose((1, 0, 3, 2)) * 2
    del tmp69
    tmp68 = tmp43.copy() * 0.5
    tmp68 += tmp44
    t2new.bbbb += einsum(tmp68, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp68
    tmp67 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    t2new.bbbb += tmp67.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp67.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp67.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp67.transpose((1, 0, 3, 2))
    del tmp67
    tmp65 = einsum(tmp64, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp64
    t2new.bbbb += tmp65.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp65.transpose((0, 1, 3, 2)) * -1
    del tmp65
    tmp55 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    t2new.bbbb += tmp55.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp55 * -1
    t2new.bbbb += tmp55.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp55.transpose((0, 1, 3, 2))
    del tmp55
    tmp54 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    t2new.bbbb += tmp54.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp54.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp54 * -1
    t2new.bbbb += tmp54.transpose((1, 0, 2, 3))
    del tmp54
    tmp62 = einsum(t2.abab, (0, 1, 2, 3), tmp61, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp61
    t2new.bbbb += tmp62.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp62.transpose((1, 0, 3, 2))
    del tmp62
    tmp60 = einsum(tmp59, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp59
    t2new.bbbb += tmp60.transpose((0, 1, 3, 2)) * 2
    t2new.bbbb += tmp60.transpose((1, 0, 3, 2)) * -2
    del tmp60
    tmp45 = tmp43.copy()
    del tmp43
    tmp45 += tmp44 * 2
    del tmp44
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 3), (0, 1, 2, 4)) * -1
    del tmp45
    tmp49 = v.aaaa.oovv.copy()
    tmp49 += tmp20.transpose((1, 0, 3, 2)) * -1
    tmp49 += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (1, 4, 5, 3), (4, 0, 5, 2)) * 2
    del tmp48
    t2new.abab += einsum(tmp49, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp49
    tmp47 = f.aa.vv.copy() * -1
    tmp47 += tmp34.transpose((1, 0)) * 2
    tmp47 += tmp35.transpose((1, 0))
    t2new.abab += einsum(tmp47, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    del tmp47
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    t2new.abab += tmp42 * 0.5
    t2new.abab += tmp42 * 0.5
    del tmp42
    tmp52 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp52, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp52
    tmp51 = tmp50.copy() * 2
    del tmp50
    tmp51 += tmp27 * -1
    t2new.abab += einsum(tmp51, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp51
    tmp41 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy()
    tmp41 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (5, 1, 4, 2)) * -1
    t2new.abab += einsum(tmp41, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5)) * -1
    del tmp41
    tmp53 = tmp15.copy() * 0.5
    del tmp15
    tmp53 += tmp16
    del tmp16
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp53, (4, 1), (0, 4, 2, 3)) * -2
    del tmp53
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp27
    t2new.aaaa += tmp28.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp28.transpose((1, 0, 3, 2))
    del tmp28
    tmp19 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    t2new.aaaa += tmp19.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp19 * -1
    t2new.aaaa += tmp19.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp19.transpose((0, 1, 3, 2))
    del tmp19
    tmp33 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.oo, (4, 1), (4, 0, 2, 3))
    t2new.aaaa += tmp33.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp33.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp33.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp33.transpose((1, 0, 3, 2))
    del tmp33
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), tmp24, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp24
    t2new.aaaa += tmp25.transpose((0, 1, 3, 2)) * 2
    t2new.aaaa += tmp25.transpose((1, 0, 3, 2)) * -2
    del tmp25
    tmp32 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t2.aaaa, (1, 3, 4, 5), (0, 2, 4, 5))
    t2new.aaaa += tmp32.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp32.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp32.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp32.transpose((1, 0, 3, 2)) * 0.5
    del tmp32
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp30
    t2new.aaaa += tmp31.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp31.transpose((0, 1, 3, 2)) * -1
    del tmp31
    tmp29 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    t2new.aaaa += tmp29 * -2
    t2new.aaaa += tmp29.transpose((1, 0, 2, 3)) * 2
    del tmp29
    tmp40 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (4, 1), (0, 4, 2, 3)) * -1
    del tmp39
    t2new.aaaa += tmp40.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp40.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp40.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp40.transpose((0, 1, 3, 2)) * -1
    del tmp40
    tmp36 = tmp34.copy()
    tmp36 += tmp35 * 0.5
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp36, (4, 3), (0, 1, 2, 4)) * -4
    del tmp36
    tmp37 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.aaaa += tmp37 * 2
    t2new.aaaa += tmp37.transpose((0, 1, 3, 2)) * -2
    t2new.aaaa += tmp37.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp37.transpose((1, 0, 3, 2)) * 2
    del tmp37
    tmp38 = f.aa.vv.copy() * -1
    tmp38 += tmp34 * 2
    del tmp34
    tmp38 += tmp35
    del tmp35
    t2new.aaaa += einsum(tmp38, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp38
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp20
    t2new.aaaa += tmp21.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp21.transpose((0, 1, 3, 2)) * -2
    t2new.aaaa += tmp21.transpose((1, 0, 3, 2)) * 2
    t2new.aaaa += tmp21 * 2
    del tmp21
    tmp18 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    t2new.aaaa += tmp18.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp18.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp18 * -1
    t2new.aaaa += tmp18.transpose((1, 0, 2, 3))
    del tmp18
    tmp7 = f.bb.ov.copy()
    tmp7 += tmp4
    del tmp4
    tmp7 += tmp6 * -1
    del tmp6
    t1new.bb += einsum(tmp7, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp7, (1, 3), (0, 2))
    del tmp7
    tmp13 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    t1new.bb += einsum(tmp13, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4)) * -2
    del tmp13
    tmp3 = f.aa.ov.copy()
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp2 * -1
    del tmp2
    t1new.bb += einsum(tmp3, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp3, (1, 3), (0, 2)) * 2
    del tmp3
    tmp14 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 4, 1, 2), (4, 3)) * -1
    del tmp14
    tmp8 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    t1new.aa += einsum(tmp8, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp8
    tmp12 = tmp10.copy()
    del tmp10
    tmp12 += tmp11 * 0.5
    del tmp11
    t1new.aa += einsum(tmp12, (0, 1), t1.aa, (1, 2), (0, 2)) * -2
    del tmp12
    tmp9 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    t1new.aa += einsum(tmp9, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    del tmp9
    t1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2)) * -1
    t1new.aa += einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    t1new.aa += einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2)) * -1
    t1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4)) * -2
    t1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    t1new.aa += einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (1, 2, 4, 3), (0, 4)) * -2
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3)) * -1
    t1new.bb += einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4)) * -2
    t1new.bb += einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1)) * -1
    t1new.bb += einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 2), (0, 4)) * 2
    t1new.bb += einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    t1new.bb += einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 1, 3))
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 3, 1)) * -1
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.vvvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -2
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), f.aa.vv, (4, 3), (0, 1, 2, 4)) * 2
    t2new.abab += einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    t2new.abab += v.aabb.ovov.transpose((0, 2, 1, 3))
    t2new.abab += einsum(t1.bb, (0, 1), v.aabb.ovoo, (2, 3, 4, 0), (2, 4, 3, 1)) * -1
    t2new.abab += einsum(v.aabb.oovv, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    t2new.abab += einsum(v.aabb.ooov, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    t2new.abab += einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.oo, (4, 1), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(f.aa.oo, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.vv, (4, 3), (0, 1, 2, 4))
    t2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.abab += einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    t2new.abab += einsum(v.aabb.vvvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 0, 2))
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 1, 3))
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 3, 1)) * -1
    t2new.bbbb += einsum(v.bbbb.vvvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -2
    t2new.bbbb += einsum(f.bb.vv, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * 2

    return {f"t1new": t1new, f"t2new": t2new}

