"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:34:20.513294
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:34:21.860646.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp2 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp2 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp0 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp0 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp3 = f.bb.ov.copy() * 2
    tmp3 += einsum(tmp2, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -1
    del tmp2
    e_cc = einsum(tmp3, (0, 1), t1.bb, (0, 1), ()) * 0.5
    del tmp3
    tmp1 = f.aa.ov.copy()
    tmp1 += einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2)) * -0.5
    del tmp0
    e_cc += einsum(tmp1, (0, 1), t1.aa, (0, 1), ())
    del tmp1
    e_cc += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 3), ())
    e_cc += einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 3, 1), ()) * -1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:35:20.560990.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp14 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp14 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp7 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp7 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp21 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    t1new.bb = einsum(t2.bbbb, (0, 1, 2, 3), tmp21, (4, 0, 1, 3), (4, 2)) * 2
    tmp115 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp115 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp14
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    t1new.bb += tmp13
    tmp0 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    t1new.aa = einsum(tmp0, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    tmp2 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    t1new.aa += tmp2
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp138 = v.bbbb.ooov.copy()
    tmp138 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp22 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp22, (0, 4, 1, 2), (4, 3)) * -1
    tmp182 = v.bbbb.ovvv.copy()
    tmp182 += v.bbbb.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp146 = tmp21.copy() * -1
    tmp146 += tmp21.transpose((0, 2, 1, 3))
    tmp189 = v.bbbb.ooov.copy() * -1
    tmp189 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp116 = einsum(tmp115, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp16 = f.bb.ov.copy()
    tmp16 += tmp13
    tmp16 += tmp15 * -1
    del tmp15
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (1, 3), (0, 2)) * 2
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp16, (1, 3), (0, 2))
    tmp1 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    tmp35 = v.aaaa.ooov.copy()
    tmp35 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp81 = v.aaaa.ooov.copy() * -1
    tmp81 += v.aaaa.ovoo.transpose((0, 2, 3, 1))
    tmp71 = v.aaaa.ovvv.copy()
    tmp71 += v.aaaa.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp73 = tmp0.copy()
    tmp73 += tmp0.transpose((0, 2, 1, 3)) * -1
    tmp9 = f.aa.ov.copy()
    tmp9 += tmp2
    tmp9 += tmp8 * -1
    del tmp8
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 2), (1, 3))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (1, 3), (0, 2)) * 2
    tmp200 = einsum(t1.bb, (0, 1), tmp21, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp157 = einsum(t1.bb, (0, 1), tmp138, (0, 2, 3, 1), (2, 3))
    tmp29 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp30 = v.bbbb.ooov.copy()
    tmp30 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp123 = einsum(t1.bb, (0, 1), tmp22, (2, 3, 0, 4), (2, 3, 4, 1))
    t2new.abab = tmp123.copy() * -1
    tmp124 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    t2new.abab += tmp124
    tmp183 = einsum(tmp182, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp182
    tmp147 = einsum(t1.bb, (0, 1), tmp146, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp146
    tmp190 = einsum(t1.bb, (0, 1), tmp189, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp189
    tmp117 = f.bb.ov.copy()
    tmp117 += tmp13
    del tmp13
    tmp117 += tmp116 * -1
    del tmp116
    tmp25 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp24 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp172 = einsum(tmp16, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp176 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    t2new.bbbb = tmp176.transpose((1, 0, 3, 2)).copy() * -1
    t2new.bbbb += tmp176.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp176 * -1
    t2new.bbbb += tmp176.transpose((1, 0, 2, 3))
    tmp166 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp46 = v.aaaa.ovvv.copy()
    tmp46 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp68 = einsum(t1.aa, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 1, 4))
    t2new.abab += tmp68 * -1
    tmp67 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp56 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp18 = v.aaaa.ooov.copy()
    tmp18 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp36 = einsum(t1.aa, (0, 1), tmp35, (0, 2, 3, 1), (2, 3))
    tmp17 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp82 = einsum(tmp81, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp81
    tmp95 = einsum(t1.aa, (0, 1), tmp0, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp72 = einsum(t1.aa, (0, 1), tmp71, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp71
    tmp74 = einsum(tmp73, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp73
    tmp62 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    t2new.aaaa = tmp62.transpose((1, 0, 3, 2)).copy() * -1
    t2new.aaaa += tmp62.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp62 * -1
    t2new.aaaa += tmp62.transpose((1, 0, 2, 3))
    tmp51 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp51 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp10 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp155 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp204 = einsum(tmp200, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4))
    tmp202 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp158 = f.bb.oo.copy()
    tmp158 += tmp29.transpose((1, 0))
    tmp158 += tmp157.transpose((1, 0)) * -1
    del tmp157
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    del tmp30
    tmp110 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp109 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp113 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp162 = v.bbbb.ovvv.copy()
    tmp162 += v.bbbb.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp85 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp85 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp180 = tmp124.copy() * -1
    tmp180 += tmp123
    tmp184 = tmp183.transpose((0, 1, 3, 2)).copy() * -1
    del tmp183
    tmp184 += tmp147 * -1
    tmp127 = einsum(t1.bb, (0, 1), v.aabb.ovoo, (2, 3, 4, 0), (2, 4, 3, 1))
    t2new.abab += tmp127 * -1
    tmp112 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    t2new.abab += tmp112 * 2
    tmp89 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp89 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp193 = v.bbbb.ooov.copy() * -1
    tmp193 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp196 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp198 = v.bbbb.oovv.copy()
    tmp198 += tmp190.transpose((1, 0, 2, 3)) * -1
    tmp164 = v.bbbb.ovvv.copy()
    tmp164 += v.bbbb.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp118 = einsum(t1.bb, (0, 1), tmp117, (0, 2), (1, 2))
    del tmp117
    tmp208 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp178 = tmp21.copy() * -1
    tmp178 += tmp21.transpose((0, 2, 1, 3))
    tmp177 = v.bbbb.ovvv.copy()
    tmp177 += v.bbbb.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp210 = v.bbbb.ovvv.copy()
    tmp210 += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 4), (0, 3, 1, 4))
    tmp173 = tmp24.copy() * 0.5
    tmp173 += tmp25
    tmp173 += tmp172
    del tmp172
    tmp206 = einsum(t1.bb, (0, 1), tmp176, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp176
    tmp149 = tmp124.copy()
    tmp149 += tmp123 * -1
    del tmp123
    t2new.abab += einsum(tmp149, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 2
    tmp170 = einsum(tmp166, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4))
    tmp168 = einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp141 = v.aabb.vvov.transpose((2, 0, 1, 3)).copy()
    tmp141 += einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 4), (2, 4, 1, 3)) * -1
    tmp125 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp47 = einsum(t1.aa, (0, 1), tmp46, (0, 1, 2, 3), (2, 3))
    del tmp46
    tmp45 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp48 = einsum(tmp9, (0, 1), t1.aa, (0, 2), (2, 1))
    del tmp9
    tmp40 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp39 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp114 = v.bbbb.ovvv.copy() * -1
    tmp114 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp133 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp133 += v.aaaa.ovov.transpose((0, 2, 1, 3)) * -1
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.aaaa += tmp44
    t2new.aaaa += tmp44.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp44.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp44.transpose((1, 0, 3, 2))
    tmp143 = v.aaaa.ovvv.copy() * -1
    tmp143 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp84 = einsum(t1.aa, (0, 1), v.aabb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    t2new.abab += tmp84 * -1
    tmp135 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    t2new.abab += tmp135 * 2
    tmp145 = v.bbbb.ovvv.copy() * -1
    tmp145 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp26 = einsum(tmp16, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp77 = tmp67.copy()
    tmp77 += tmp68 * -1
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp77, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    tmp54 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp103 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp58 = einsum(tmp56, (0, 1, 2, 3), t1.aa, (3, 4), (0, 2, 1, 4))
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp18
    tmp37 = f.aa.oo.copy()
    tmp37 += tmp17.transpose((1, 0))
    tmp37 += tmp36.transpose((1, 0)) * -1
    del tmp36
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp37, (0, 4), (4, 1, 2, 3)) * -1
    tmp87 = v.aaaa.ooov.copy() * -1
    tmp87 += v.aaaa.ovoo.transpose((0, 2, 3, 1))
    tmp93 = v.aaaa.oovv.copy()
    tmp93 += tmp82.transpose((1, 0, 2, 3)) * -1
    tmp105 = v.aaaa.ovvv.copy()
    tmp105 += einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 4), (0, 3, 1, 4))
    tmp65 = tmp0.copy()
    tmp65 += tmp0.transpose((0, 2, 1, 3)) * -1
    tmp64 = v.aaaa.ovvv.copy()
    tmp64 += v.aaaa.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp69 = tmp67.copy() * -1
    del tmp67
    tmp69 += tmp68
    del tmp68
    tmp97 = einsum(tmp95, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    tmp75 = tmp72.transpose((0, 1, 3, 2)).copy() * -1
    del tmp72
    tmp75 += tmp74 * -1
    tmp99 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp101 = einsum(tmp62, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    del tmp62
    tmp50 = v.aaaa.ovvv.copy()
    tmp50 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp52 = f.aa.ov.copy()
    tmp52 += tmp2
    del tmp2
    tmp52 += einsum(tmp51, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2)) * -1
    tmp91 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp60 = tmp5.copy() * 2
    tmp60 += tmp6
    tmp60 += tmp10
    tmp156 = einsum(t1.bb, (0, 1), tmp155, (2, 0, 3, 4), (3, 2, 4, 1))
    del tmp155
    t2new.bbbb += tmp156.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp156
    del tmp156
    tmp205 = einsum(t1.bb, (0, 1), tmp204, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp204
    t2new.bbbb += tmp205.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp205
    del tmp205
    tmp203 = einsum(tmp202, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp202
    t2new.bbbb += tmp203.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp203
    del tmp203
    tmp167 = einsum(tmp166, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    del tmp166
    t2new.bbbb += tmp167.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp167.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp167.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp167.transpose((1, 0, 3, 2)) * -1
    del tmp167
    tmp159 = einsum(t2.bbbb, (0, 1, 2, 3), tmp158, (1, 4), (0, 4, 2, 3)) * -1
    del tmp158
    t2new.bbbb += tmp159.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp159.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp159.transpose((0, 1, 3, 2)) * -1
    del tmp159
    tmp32 = f.bb.oo.copy()
    tmp32 += tmp29.transpose((1, 0))
    del tmp29
    tmp32 += tmp31.transpose((1, 0)) * -1
    del tmp31
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (1, 4), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp32, (1, 4), (0, 4, 2, 3)) * -1
    t1new.bb += einsum(t1.bb, (0, 1), tmp32, (0, 2), (2, 1)) * -1
    del tmp32
    tmp163 = f.bb.vv.copy() * -1
    tmp163 += tmp113.transpose((1, 0)) * -1
    tmp163 += tmp109.transpose((1, 0))
    tmp163 += tmp110.transpose((1, 0)) * 2
    tmp163 += einsum(t1.bb, (0, 1), tmp162, (0, 1, 2, 3), (3, 2)) * -1
    del tmp162
    tmp163 += einsum(t1.bb, (0, 1), tmp16, (0, 2), (2, 1))
    del tmp16
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp163, (3, 4), (0, 1, 4, 2)) * 2
    del tmp163
    tmp212 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    t2new.bbbb += einsum(t1.bb, (0, 1), tmp212, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp212
    tmp191 = v.bbbb.oovv.copy()
    tmp191 += einsum(tmp85, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 1, 5, 3)) * -2
    tmp191 += tmp190 * -1
    del tmp190
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp191, (4, 1, 5, 3), (4, 0, 5, 2)) * -2
    del tmp191
    tmp111 = tmp109.copy() * 0.5
    del tmp109
    tmp111 += tmp110
    del tmp110
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp111, (4, 3), (0, 1, 2, 4)) * -4
    t2new.abab += einsum(tmp111, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 4, 0)) * -2
    del tmp111
    tmp181 = einsum(tmp180, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp180
    t2new.bbbb += tmp181 * -1
    t2new.bbbb += tmp181.transpose((0, 1, 3, 2))
    del tmp181
    tmp185 = einsum(tmp184, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp184
    t2new.bbbb += tmp185.transpose((1, 0, 2, 3)) * 2
    t2new.bbbb += tmp185 * -2
    t2new.bbbb += tmp185.transpose((1, 0, 3, 2)) * -2
    del tmp185
    tmp192 = tmp127.copy()
    tmp192 += einsum(t2.abab, (0, 1, 2, 3), tmp51, (0, 4, 5, 2), (4, 1, 5, 3))
    t2new.bbbb += einsum(t2.abab, (0, 1, 2, 3), tmp192, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp192
    tmp188 = einsum(tmp112, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp112
    t2new.bbbb += tmp188.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp188.transpose((0, 1, 3, 2)) * -2
    t2new.bbbb += tmp188.transpose((1, 0, 3, 2)) * 2
    t2new.bbbb += tmp188 * 2
    del tmp188
    tmp194 = v.bbbb.oovv.copy()
    tmp194 += einsum(tmp89, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 1, 5, 3)) * -2
    tmp194 += einsum(t1.bb, (0, 1), tmp193, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp193
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp194, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp194
    tmp154 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    t2new.bbbb += tmp154.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp154.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp154.transpose((1, 0, 3, 2)) * 0.5
    t2new.bbbb += tmp154.transpose((1, 0, 3, 2)) * 0.5
    del tmp154
    tmp197 = einsum(t1.bb, (0, 1), tmp196, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp196
    t2new.bbbb += tmp197.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp197.transpose((1, 0, 3, 2))
    del tmp197
    tmp199 = einsum(tmp198, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp198
    t2new.bbbb += tmp199 * -2
    t2new.bbbb += tmp199.transpose((1, 0, 2, 3)) * 2
    del tmp199
    tmp165 = f.bb.vv.copy() * -1
    tmp165 += tmp113.transpose((1, 0)) * -1
    tmp165 += einsum(t1.bb, (0, 1), tmp164, (0, 1, 2, 3), (3, 2)) * -1
    del tmp164
    tmp165 += tmp118.transpose((1, 0))
    t2new.bbbb += einsum(tmp165, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp165
    tmp161 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    t2new.bbbb += tmp161
    t2new.bbbb += tmp161.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp161.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp161.transpose((1, 0, 3, 2))
    del tmp161
    tmp209 = einsum(tmp208, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp208
    t2new.bbbb += tmp209.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp209.transpose((0, 1, 3, 2)) * -1
    del tmp209
    tmp179 = einsum(t1.bb, (0, 1), tmp177, (2, 3, 1, 4), (0, 2, 4, 3)) * -1
    del tmp177
    tmp179 += einsum(t1.bb, (0, 1), tmp178, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    del tmp178
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp179, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp179
    tmp211 = v.bbbb.vvvv.copy() * -1
    tmp211 += einsum(t1.bb, (0, 1), tmp210, (0, 2, 3, 4), (2, 1, 4, 3))
    del tmp210
    t2new.bbbb += einsum(tmp211, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 3), (4, 5, 2, 1)) * 2
    del tmp211
    tmp160 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.bbbb += tmp160 * 2
    t2new.bbbb += tmp160.transpose((0, 1, 3, 2)) * -2
    t2new.bbbb += tmp160.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp160.transpose((1, 0, 3, 2)) * 2
    del tmp160
    tmp174 = einsum(t2.bbbb, (0, 1, 2, 3), tmp173, (4, 1), (0, 4, 2, 3)) * -2
    del tmp173
    t2new.bbbb += tmp174.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp174.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp174.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp174.transpose((0, 1, 3, 2)) * -1
    del tmp174
    tmp207 = einsum(tmp206, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp206
    t2new.bbbb += tmp207.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp207 * -1
    t2new.bbbb += tmp207.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp207.transpose((0, 1, 3, 2))
    del tmp207
    tmp186 = einsum(tmp149, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp149
    t2new.bbbb += tmp186.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp186.transpose((1, 0, 3, 2))
    del tmp186
    tmp171 = einsum(tmp170, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp170
    t2new.bbbb += tmp171.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp171 * -1
    t2new.bbbb += tmp171.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp171.transpose((1, 0, 2, 3))
    del tmp171
    tmp195 = tmp127.copy()
    del tmp127
    tmp195 += einsum(tmp7, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    t2new.bbbb += einsum(tmp195, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 3, 5))
    del tmp195
    tmp175 = einsum(t1.bb, (0, 1), tmp21, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp21
    t2new.bbbb += tmp175 * -1
    t2new.bbbb += tmp175.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp175.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp175.transpose((1, 0, 3, 2)) * -1
    del tmp175
    tmp201 = einsum(tmp200, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp200
    t2new.bbbb += tmp201.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp201.transpose((0, 1, 3, 2)) * -1
    del tmp201
    tmp169 = einsum(t1.bb, (0, 1), tmp168, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp168
    t2new.bbbb += tmp169
    t2new.bbbb += tmp169.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp169.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp169.transpose((1, 0, 3, 2))
    del tmp169
    tmp187 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    t2new.bbbb += tmp187.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp187 * -1
    t2new.bbbb += tmp187.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp187.transpose((0, 1, 3, 2))
    del tmp187
    tmp140 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp140, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp140
    tmp132 = einsum(tmp22, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp142 = v.aabb.vvvv.copy()
    tmp142 += einsum(tmp141, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    del tmp141
    t2new.abab += einsum(tmp142, (0, 1, 2, 3), t2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp142
    tmp120 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp126 = tmp125.transpose((0, 1, 3, 2)).copy()
    tmp126 += einsum(t1.aa, (0, 1), tmp22, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp22
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp126, (4, 1, 2, 5), (0, 4, 5, 3)) * -1
    del tmp126
    tmp49 = f.aa.vv.copy() * -1
    tmp49 += tmp45.transpose((1, 0)) * -1
    tmp49 += tmp39.transpose((1, 0)) * 2
    tmp49 += tmp40.transpose((1, 0))
    tmp49 += tmp47.transpose((1, 0)) * -1
    del tmp47
    tmp49 += tmp48.transpose((1, 0))
    del tmp48
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp49, (2, 4), (0, 1, 4, 3)) * -1
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp49, (3, 4), (0, 1, 4, 2)) * 2
    del tmp49
    tmp139 = v.bbbb.oovv.copy()
    tmp139 += einsum(t1.bb, (0, 1), tmp138, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp138
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp139, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp139
    tmp11 = tmp5.transpose((1, 0)).copy() * 2
    del tmp5
    tmp11 += tmp6.transpose((1, 0))
    del tmp6
    tmp11 += tmp10.transpose((1, 0))
    del tmp10
    t2new.abab += einsum(tmp11, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    t1new.aa += einsum(t1.aa, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    tmp153 = einsum(tmp124, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    del tmp124
    t2new.abab += einsum(t1.aa, (0, 1), tmp153, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp153
    tmp4 = t2.abab.copy()
    tmp4 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    t2new.abab += einsum(tmp132, (0, 1, 2, 3), tmp4, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp132
    t2new.abab += einsum(tmp120, (0, 1, 2, 3), tmp4, (0, 3, 4, 5), (1, 2, 4, 5))
    del tmp120
    t1new.bb += einsum(tmp4, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    t1new.aa += einsum(tmp4, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp131 = v.aabb.vvov.transpose((2, 0, 1, 3)).copy()
    tmp131 += einsum(t1.bb, (0, 1), v.aabb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    t2new.abab += einsum(t1.aa, (0, 1), tmp131, (2, 1, 3, 4), (0, 2, 3, 4))
    del tmp131
    tmp130 = einsum(t1.aa, (0, 1), tmp125, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp125
    t2new.abab += einsum(t1.bb, (0, 1), tmp130, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp130
    tmp121 = einsum(v.aabb.vvoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 2, 3, 0))
    t2new.abab += einsum(t1.bb, (0, 1), tmp121, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp121
    tmp151 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    t2new.abab += einsum(t1.aa, (0, 1), tmp151, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp151
    tmp119 = f.bb.vv.copy()
    tmp119 += tmp113.transpose((1, 0))
    del tmp113
    tmp119 += einsum(tmp114, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    del tmp114
    tmp119 += tmp118.transpose((1, 0)) * -1
    del tmp118
    t2new.abab += einsum(tmp119, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp119
    tmp129 = v.aabb.oovv.copy()
    tmp129 += einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp129, (0, 4, 3, 5), (4, 1, 2, 5)) * -1
    del tmp129
    tmp108 = t2.abab.copy()
    tmp108 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    t2new.abab += einsum(v.aabb.oooo, (0, 1, 2, 3), tmp108, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    del tmp108
    tmp150 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp150 += einsum(t1.bb, (0, 1), tmp1, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp1
    t2new.abab += einsum(tmp150, (0, 1, 2, 3), t2.abab, (1, 4, 5, 2), (0, 4, 5, 3)) * -1
    del tmp150
    tmp134 = v.aaaa.oovv.copy()
    tmp134 += tmp44.transpose((1, 0, 3, 2)) * -1
    tmp134 += einsum(tmp133, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (1, 4, 3, 5)) * 2
    del tmp133
    tmp134 += einsum(tmp35, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 3, 4))
    del tmp35
    t2new.abab += einsum(tmp134, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp134
    tmp137 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 3, 5))
    t2new.abab += einsum(t1.bb, (0, 1), tmp137, (2, 3, 0, 4), (2, 3, 4, 1)) * -2
    del tmp137
    tmp144 = einsum(t1.aa, (0, 1), tmp143, (2, 3, 1, 4), (0, 2, 3, 4)) * -1
    del tmp143
    tmp144 += tmp74.transpose((0, 1, 3, 2))
    del tmp74
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp144, (4, 0, 2, 5), (4, 1, 5, 3))
    del tmp144
    tmp136 = tmp84.copy() * -1
    tmp136 += tmp135 * 2
    del tmp135
    tmp136 += einsum(t2.abab, (0, 1, 2, 3), tmp115, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp115
    t2new.abab += einsum(tmp136, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp136
    tmp128 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy() * -1
    tmp128 += einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 4), (2, 3, 1, 4))
    tmp128 += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (2, 4, 1, 5))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp128, (1, 4, 2, 5), (0, 4, 5, 3))
    del tmp128
    tmp148 = einsum(t1.bb, (0, 1), tmp145, (2, 3, 1, 4), (0, 2, 3, 4)) * -1
    del tmp145
    tmp148 += tmp147.transpose((0, 1, 3, 2))
    del tmp147
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp148, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp148
    tmp152 = einsum(t1.bb, (0, 1), v.aabb.oovv, (2, 3, 4, 1), (2, 3, 0, 4))
    t2new.abab += einsum(t1.aa, (0, 1), tmp152, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp152
    tmp122 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    t2new.abab += einsum(tmp122, (0, 1, 2, 3), tmp4, (1, 2, 4, 5), (0, 3, 4, 5))
    del tmp4, tmp122
    tmp27 = tmp24.transpose((1, 0)).copy()
    del tmp24
    tmp27 += tmp25.transpose((1, 0)) * 2
    del tmp25
    tmp27 += tmp26.transpose((1, 0))
    del tmp26
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp27, (1, 4), (0, 4, 2, 3)) * -1
    t1new.bb += einsum(t1.bb, (0, 1), tmp27, (0, 2), (2, 1)) * -1
    del tmp27
    tmp78 = einsum(t2.abab, (0, 1, 2, 3), tmp77, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp77
    t2new.aaaa += tmp78.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp78.transpose((1, 0, 3, 2))
    del tmp78
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp54
    t2new.aaaa += tmp55
    t2new.aaaa += tmp55.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp55.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp55.transpose((1, 0, 3, 2))
    del tmp55
    tmp104 = einsum(t2.aaaa, (0, 1, 2, 3), tmp103, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp103
    t2new.aaaa += tmp104.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp104.transpose((0, 1, 3, 2)) * -1
    del tmp104
    tmp59 = einsum(tmp58, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp58
    t2new.aaaa += tmp59.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp59 * -1
    t2new.aaaa += tmp59.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp59.transpose((1, 0, 2, 3))
    del tmp59
    tmp20 = f.aa.oo.copy()
    tmp20 += tmp17.transpose((1, 0))
    del tmp17
    tmp20 += tmp19.transpose((1, 0)) * -1
    del tmp19
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (1, 4), (0, 4, 2, 3)) * -1
    t1new.aa += einsum(t1.aa, (0, 1), tmp20, (0, 2), (2, 1)) * -1
    del tmp20
    tmp38 = einsum(t2.aaaa, (0, 1, 2, 3), tmp37, (1, 4), (0, 4, 2, 3)) * -1
    del tmp37
    t2new.aaaa += tmp38.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp38.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp38.transpose((0, 1, 3, 2)) * -1
    del tmp38
    tmp80 = einsum(tmp44, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp44
    t2new.aaaa += tmp80.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp80.transpose((0, 1, 3, 2)) * -2
    t2new.aaaa += tmp80.transpose((1, 0, 3, 2)) * 2
    t2new.aaaa += tmp80 * 2
    del tmp80
    tmp107 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    t2new.aaaa += einsum(tmp107, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -2
    del tmp107
    tmp88 = v.aaaa.oovv.copy() * 0.5
    tmp88 += einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp7
    tmp88 += einsum(tmp87, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -0.5
    del tmp87
    t2new.aaaa += einsum(tmp88, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 4
    del tmp88
    tmp33 = einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    tmp33 += t2.aaaa * -1
    t2new.aaaa += einsum(tmp33, (0, 1, 2, 3), v.aaaa.oooo, (4, 0, 5, 1), (4, 5, 3, 2)) * 0.5
    del tmp33
    tmp42 = t2.aaaa.copy()
    tmp42 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    t2new.aaaa += einsum(tmp42, (0, 1, 2, 3), v.aaaa.oooo, (4, 0, 5, 1), (4, 5, 3, 2)) * -0.5
    del tmp42
    tmp94 = einsum(t2.aaaa, (0, 1, 2, 3), tmp93, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp93
    t2new.aaaa += tmp94 * -2
    t2new.aaaa += tmp94.transpose((1, 0, 2, 3)) * 2
    del tmp94
    tmp106 = v.aaaa.vvvv.copy()
    tmp106 += einsum(tmp105, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    del tmp105
    t2new.aaaa += einsum(tmp106, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 2), (4, 5, 1, 3)) * 2
    del tmp106
    tmp43 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.aaaa += tmp43 * 2
    t2new.aaaa += tmp43.transpose((0, 1, 3, 2)) * -2
    t2new.aaaa += tmp43.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp43.transpose((1, 0, 3, 2)) * 2
    del tmp43
    tmp66 = einsum(t1.aa, (0, 1), tmp64, (2, 3, 1, 4), (0, 2, 4, 3)) * -1
    del tmp64
    tmp66 += einsum(t1.aa, (0, 1), tmp65, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp65
    t2new.aaaa += einsum(tmp66, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp66
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp69
    t2new.aaaa += tmp70 * -1
    t2new.aaaa += tmp70.transpose((0, 1, 3, 2))
    del tmp70
    tmp98 = einsum(tmp97, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp97
    t2new.aaaa += tmp98.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp98
    del tmp98
    tmp79 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    t2new.aaaa += tmp79.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp79 * -1
    t2new.aaaa += tmp79.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp79.transpose((0, 1, 3, 2))
    del tmp79
    tmp34 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    t2new.aaaa += tmp34.transpose((1, 0, 3, 2)) * 0.5
    t2new.aaaa += tmp34.transpose((1, 0, 3, 2)) * 0.5
    del tmp34
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), tmp75, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp75
    t2new.aaaa += tmp76.transpose((1, 0, 2, 3)) * 2
    t2new.aaaa += tmp76 * -2
    t2new.aaaa += tmp76.transpose((1, 0, 3, 2)) * -2
    del tmp76
    tmp100 = einsum(t1.aa, (0, 1), tmp99, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp99
    t2new.aaaa += tmp100.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp100
    del tmp100
    tmp83 = v.aaaa.oovv.copy()
    tmp83 += einsum(t2.aaaa, (0, 1, 2, 3), tmp51, (1, 4, 3, 5), (0, 4, 2, 5)) * -2
    del tmp51
    tmp83 += tmp82 * -1
    del tmp82
    t2new.aaaa += einsum(tmp83, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp83
    tmp41 = tmp39.copy() * 2
    del tmp39
    tmp41 += tmp40
    del tmp40
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp41, (4, 3), (0, 1, 2, 4)) * -2
    del tmp41
    tmp102 = einsum(tmp101, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp101
    t2new.aaaa += tmp102.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp102 * -1
    t2new.aaaa += tmp102.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp102.transpose((0, 1, 3, 2))
    del tmp102
    tmp53 = f.aa.vv.copy() * -1
    tmp53 += tmp45.transpose((1, 0)) * -1
    del tmp45
    tmp53 += einsum(tmp50, (0, 1, 2, 3), t1.aa, (0, 1), (3, 2)) * -1
    del tmp50
    tmp53 += einsum(t1.aa, (0, 1), tmp52, (0, 2), (2, 1))
    del tmp52
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp53, (3, 4), (0, 1, 2, 4)) * -2
    del tmp53
    tmp92 = einsum(tmp91, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp91
    t2new.aaaa += tmp92.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp92.transpose((1, 0, 3, 2))
    del tmp92
    tmp90 = tmp84.copy()
    tmp90 += einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp89
    t2new.aaaa += einsum(t2.abab, (0, 1, 2, 3), tmp90, (4, 1, 5, 3), (0, 4, 5, 2))
    del tmp90
    tmp61 = einsum(t2.aaaa, (0, 1, 2, 3), tmp60, (4, 1), (0, 4, 2, 3)) * -1
    del tmp60
    t2new.aaaa += tmp61.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp61.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp61.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp61.transpose((0, 1, 3, 2)) * -1
    del tmp61
    tmp96 = einsum(tmp95, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp95
    t2new.aaaa += tmp96.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp96.transpose((0, 1, 3, 2)) * -1
    del tmp96
    tmp57 = einsum(tmp56, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (0, 1, 4, 5)) * -1
    del tmp56
    t2new.aaaa += tmp57.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp57.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp57.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp57.transpose((1, 0, 3, 2)) * -1
    del tmp57
    tmp86 = tmp84.copy()
    del tmp84
    tmp86 += einsum(t2.abab, (0, 1, 2, 3), tmp85, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp85
    t2new.aaaa += einsum(t2.abab, (0, 1, 2, 3), tmp86, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp86
    tmp63 = einsum(tmp0, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp0
    t2new.aaaa += tmp63 * -1
    t2new.aaaa += tmp63.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp63.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp63.transpose((1, 0, 3, 2)) * -1
    del tmp63
    tmp23 = t2.bbbb.copy() * 2
    tmp23 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    t1new.bb += einsum(tmp23, (0, 1, 2, 3), v.bbbb.ovvv, (0, 3, 4, 2), (1, 4)) * -1
    del tmp23
    tmp28 = f.bb.vv.copy()
    tmp28 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    t1new.bb += einsum(t1.bb, (0, 1), tmp28, (1, 2), (0, 2))
    del tmp28
    tmp12 = f.aa.vv.copy()
    tmp12 += einsum(t1.aa, (0, 1), v.aaaa.ovvv, (0, 2, 3, 1), (2, 3)) * -1
    t1new.aa += einsum(t1.aa, (0, 1), tmp12, (1, 2), (0, 2))
    del tmp12
    tmp3 = t2.aaaa.copy() * 2
    tmp3 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    t1new.aa += einsum(tmp3, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 3), (1, 4))
    del tmp3
    t1new.aa += f.aa.ov
    t1new.aa += einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    t1new.aa += einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2)) * -1
    t1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    t1new.bb += f.bb.ov
    t1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2)) * -1
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * 2
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3)) * -1
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 1, 3))
    t2new.aaaa += v.aaaa.ovov.transpose((0, 2, 3, 1)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    t2new.abab += v.aabb.ovov.transpose((0, 2, 1, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 1, 3))
    t2new.bbbb += v.bbbb.ovov.transpose((0, 2, 3, 1)) * -1

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:37:34.666790.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp95 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp95 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp7 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp7 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp96 = einsum(tmp95, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp95
    tmp94 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp6 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp7
    tmp2 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp97 = f.bb.ov.copy()
    tmp97 += tmp94
    tmp97 += tmp96 * -1
    del tmp96
    tmp115 = v.bbbb.ooov.copy()
    tmp115 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp39 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    l2new.abab = einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp39, (4, 3, 2, 5), (1, 5, 0, 4)) * -2
    l2new.abab += einsum(tmp39, (0, 1, 2, 3), tmp2, (4, 1, 2, 5), (5, 3, 4, 0)) * -2
    l1new.bb = einsum(tmp39, (0, 1, 2, 3), v.bbbb.oovv, (2, 1, 4, 3), (4, 0)) * -2
    tmp109 = v.bbbb.ovvv.copy()
    tmp109 += v.bbbb.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp200 = v.bbbb.ovvv.copy() * -1
    tmp200 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp216 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp216 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp37 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    l2new.abab += einsum(tmp37, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 2, 5), (3, 5, 0, 4))
    l2new.abab += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp37, (4, 5, 2, 1), (0, 3, 4, 5)) * -1
    l2new.abab += einsum(tmp37, (0, 1, 2, 3), v.bbbb.ovoo, (4, 5, 2, 1), (3, 5, 0, 4)) * -1
    l1new.aa = einsum(v.aabb.vvoo, (0, 1, 2, 3), tmp37, (4, 3, 2, 1), (0, 4)) * -1
    tmp9 = f.aa.ov.copy()
    tmp9 += tmp6
    tmp9 += tmp8 * -1
    del tmp8
    tmp62 = v.aaaa.ooov.copy()
    tmp62 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp30 = v.aaaa.ovvv.copy()
    tmp30 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp182 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp182 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp166 = v.aaaa.ovvv.copy() * -1
    tmp166 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp48 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    l2new.abab += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp48, (4, 1, 0, 5), (5, 3, 4, 2)) * -2
    l1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), tmp48, (4, 1, 0, 3), (2, 4)) * -2
    tmp41 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp42 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp92 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    l2new.abab += einsum(tmp92, (0, 1, 2, 3), tmp37, (4, 0, 1, 5), (5, 3, 4, 2))
    l2new.abab += einsum(tmp92, (0, 1, 2, 3), tmp37, (4, 0, 2, 5), (5, 3, 4, 1)) * -1
    tmp14 = v.aabb.ovoo.transpose((0, 2, 3, 1)).copy()
    tmp14 += tmp2
    l2new.abab += einsum(l1.bb, (0, 1), tmp14, (2, 1, 3, 4), (4, 0, 2, 3)) * -1
    tmp52 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp54 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp53 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp0 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp128 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp127 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp114 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp112 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp113 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp117 = einsum(t1.bb, (0, 1), tmp97, (2, 1), (0, 2))
    tmp116 = einsum(t1.bb, (0, 1), tmp115, (0, 2, 3, 1), (2, 3))
    del tmp115
    tmp32 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp33 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp122 = einsum(t1.bb, (0, 1), tmp39, (2, 3, 4, 1), (2, 3, 0, 4))
    l1new.bb += einsum(v.bbbb.ooov, (0, 1, 2, 3), tmp122, (4, 1, 0, 2), (3, 4)) * -2
    tmp121 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    l1new.bb += einsum(tmp121, (0, 1, 2, 3), v.bbbb.ooov, (1, 3, 2, 4), (4, 0)) * 2
    tmp203 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp204 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp205 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp213 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp245 = einsum(tmp109, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp214 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp141 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp198 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp201 = einsum(tmp200, (0, 1, 2, 3), t1.bb, (4, 2), (0, 4, 1, 3))
    del tmp200
    tmp199 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp217 = einsum(tmp216, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp216
    tmp73 = einsum(t1.aa, (0, 1), tmp37, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp72 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp161 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp59 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp160 = einsum(t1.aa, (0, 1), tmp62, (0, 2, 3, 1), (2, 3))
    tmp60 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp89 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp179 = einsum(t1.aa, (0, 1), tmp30, (0, 1, 2, 3), (2, 3))
    tmp177 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp178 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp183 = einsum(tmp182, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp182
    tmp69 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp70 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp10 = einsum(t1.bb, (0, 1), v.aabb.ovvv, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp157 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp158 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp28 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp27 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp155 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp167 = einsum(t1.aa, (0, 1), tmp166, (2, 3, 1, 4), (2, 0, 3, 4))
    del tmp166
    tmp154 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp84 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp81 = einsum(tmp48, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    tmp44 = tmp41.copy()
    tmp44 += tmp42
    tmp44 += tmp43 * 2
    l1new.bb += einsum(tmp44, (0, 1), tmp97, (1, 2), (2, 0)) * -1
    l1new.bb += einsum(tmp44, (0, 1), v.bbbb.ovoo, (2, 3, 0, 1), (3, 2)) * -1
    l1new.aa += einsum(tmp44, (0, 1), v.aabb.ovoo, (2, 3, 1, 0), (3, 2)) * -1
    tmp102 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    l1new.bb += einsum(tmp102, (0, 1, 2, 3), tmp39, (4, 0, 1, 3), (2, 4)) * 2
    tmp106 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp104 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp105 = einsum(tmp92, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp12 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp13 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp98 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp4 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    l2new.abab += einsum(tmp48, (0, 1, 2, 3), tmp4, (1, 2, 4, 5), (3, 5, 0, 4)) * -2
    tmp55 = tmp52.copy() * 0.5
    tmp55 += tmp53
    tmp55 += tmp54 * 0.5
    l1new.bb += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp55, (1, 0), (3, 2)) * -2
    l1new.aa += einsum(tmp9, (0, 1), tmp55, (2, 0), (1, 2)) * -2
    tmp50 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 5), (5, 3, 4, 2))
    l2new.abab += einsum(tmp0, (0, 1, 2, 3), tmp50, (0, 1, 4, 5), (3, 5, 2, 4))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp14, (1, 2, 4, 5), (5, 3, 0, 4))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 5, 3), (4, 5, 0, 2)) * -1
    l2new.abab += einsum(v.aaaa.ovoo, (0, 1, 2, 3), tmp50, (3, 2, 4, 5), (1, 5, 0, 4)) * -1
    l2new.abab += einsum(tmp0, (0, 1, 2, 3), tmp50, (0, 2, 4, 5), (3, 5, 1, 4)) * -1
    l1new.bb += einsum(v.aabb.oovv, (0, 1, 2, 3), tmp50, (1, 0, 4, 3), (2, 4)) * -1
    tmp23 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp22 = einsum(t1.aa, (0, 1), tmp0, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp21 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp142 = v.bbbb.ovvv.copy() * -1
    tmp142 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp129 = tmp127.copy()
    del tmp127
    tmp129 += tmp128 * 4
    del tmp128
    tmp118 = f.bb.oo.copy()
    tmp118 += tmp112.transpose((1, 0))
    del tmp112
    tmp118 += tmp113
    del tmp113
    tmp118 += tmp114 * 2
    del tmp114
    tmp118 += tmp116 * -1
    del tmp116
    tmp118 += tmp117
    del tmp117
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp118, (3, 4), (0, 1, 2, 4)) * -1
    l1new.bb += einsum(tmp118, (0, 1), l1.bb, (2, 0), (2, 1)) * -1
    tmp197 = tmp32.copy()
    tmp197 += tmp33 * 2
    l2new.bbbb = einsum(tmp197, (0, 1), v.bbbb.ovov, (2, 1, 3, 4), (4, 0, 2, 3))
    l2new.abab += einsum(tmp197, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (3, 0, 2, 4)) * -1
    tmp135 = tmp121.transpose((1, 0, 3, 2)).copy()
    del tmp121
    tmp135 += tmp122.transpose((0, 1, 3, 2)) * -1
    del tmp122
    tmp206 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp206 += tmp203
    tmp206 += tmp204 * 2
    tmp206 += tmp205
    l2new.abab += einsum(l2.aaaa, (0, 1, 2, 3), tmp206, (3, 4, 1, 5), (0, 5, 2, 4)) * 2
    tmp207 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp229 = v.bbbb.ooov.transpose((0, 2, 1, 3)).copy()
    tmp229 += tmp92
    tmp246 = f.bb.vv.copy() * -1
    tmp246 += tmp141.transpose((1, 0)) * -1
    tmp246 += tmp213.transpose((1, 0))
    tmp246 += tmp214.transpose((1, 0)) * 2
    tmp246 += tmp245.transpose((1, 0)) * -1
    del tmp245
    tmp202 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp202 += v.bbbb.oovv * -1
    tmp202 += tmp198
    tmp202 += tmp199 * 2
    tmp202 += tmp201.transpose((1, 0, 3, 2)) * -1
    del tmp201
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp202, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp218 = f.bb.ov.copy()
    tmp218 += tmp94
    tmp218 += tmp217 * -1
    del tmp217
    l2new.abab += einsum(tmp37, (0, 1, 2, 3), tmp218, (2, 4), (3, 4, 0, 1)) * -1
    tmp164 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp3 = v.aabb.ovoo.transpose((0, 2, 3, 1)).copy()
    tmp3 += tmp2.transpose((0, 2, 1, 3))
    tmp68 = v.aaaa.ovvv.copy() * -1
    tmp68 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp123 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp124 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp74 = tmp72.copy()
    tmp74 += tmp73
    tmp65 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp66 = einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp126 = v.bbbb.ovvv.copy()
    tmp126 += v.bbbb.ovvv.transpose((0, 2, 1, 3)) * -1
    l1new.bb += einsum(tmp126, (0, 1, 2, 3), tmp129, (4, 0, 3, 2), (1, 4)) * -1
    tmp162 = f.aa.oo.copy()
    tmp162 += tmp59.transpose((1, 0))
    tmp162 += tmp60 * 2
    tmp162 += tmp61
    tmp162 += tmp160 * -1
    del tmp160
    tmp162 += tmp161
    del tmp161
    l2new.abab += einsum(tmp162, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    tmp180 = f.aa.vv.copy() * -1
    tmp180 += tmp89.transpose((1, 0)) * -1
    tmp180 += tmp177.transpose((1, 0)) * 2
    tmp180 += tmp178.transpose((1, 0))
    tmp180 += tmp179.transpose((1, 0)) * -1
    del tmp179
    tmp184 = f.aa.ov.copy()
    tmp184 += tmp6
    tmp184 += tmp183 * -1
    del tmp183
    l2new.abab += einsum(tmp184, (0, 1), tmp50, (2, 0, 3, 4), (1, 4, 2, 3)) * -1
    tmp193 = tmp69.copy() * 4
    tmp193 += tmp70
    tmp170 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp170 += tmp10
    tmp170 += tmp157
    tmp170 += tmp158 * 2
    l2new.abab += einsum(l2.bbbb, (0, 1, 2, 3), tmp170, (4, 3, 5, 1), (5, 0, 4, 2)) * 2
    tmp147 = v.aaaa.ooov.transpose((0, 2, 1, 3)).copy()
    tmp147 += tmp0
    tmp144 = tmp27.copy()
    tmp144 += tmp28 * 0.5
    l2new.aaaa = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp144, (4, 1), (3, 4, 0, 2)) * 2
    tmp58 = tmp52.copy()
    del tmp52
    tmp58 += tmp53 * 2
    del tmp53
    tmp58 += tmp54
    del tmp54
    l2new.abab += einsum(tmp58, (0, 1), v.aabb.ovov, (1, 2, 3, 4), (2, 4, 0, 3)) * -1
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp58, (1, 2), (3, 0))
    l1new.aa += einsum(tmp58, (0, 1), v.aaaa.ovoo, (2, 3, 1, 0), (3, 2)) * -1
    tmp168 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp168 += v.aaaa.oovv * -1
    tmp168 += tmp154 * 2
    tmp168 += tmp155
    tmp168 += tmp167.transpose((1, 0, 3, 2)) * -1
    del tmp167
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp168, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp175 = tmp84.transpose((1, 0, 3, 2)).copy()
    tmp175 += tmp81.transpose((0, 1, 3, 2)) * -1
    tmp35 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp38 = einsum(t2.abab, (0, 1, 2, 3), tmp37, (0, 1, 4, 2), (4, 3))
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp110 = einsum(t1.bb, (0, 1), tmp44, (0, 2), (2, 1)) * 0.5
    tmp40 = einsum(t2.bbbb, (0, 1, 2, 3), tmp39, (1, 0, 4, 3), (4, 2))
    tmp103 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp103 += v.bbbb.oovv * -1
    tmp103 += tmp102.transpose((0, 1, 3, 2))
    del tmp102
    tmp101 = v.bbbb.ooov.copy() * -1
    tmp101 += v.bbbb.ooov.transpose((0, 2, 1, 3))
    tmp101 += tmp92
    tmp101 += tmp92.transpose((0, 2, 1, 3)) * -1
    tmp107 = v.bbbb.oooo.copy()
    tmp107 += tmp104.transpose((3, 1, 2, 0))
    tmp107 += tmp105.transpose((2, 1, 3, 0)) * -1
    tmp107 += tmp106.transpose((2, 0, 3, 1)) * -1
    tmp107 += tmp106.transpose((3, 0, 2, 1))
    tmp31 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp16 = v.aabb.oooo.copy()
    tmp16 += tmp12.transpose((1, 0, 3, 2))
    tmp16 += tmp13.transpose((1, 0, 3, 2))
    tmp16 += tmp15.transpose((1, 0, 3, 2))
    del tmp15
    tmp99 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy()
    tmp99 += tmp98.transpose((1, 0, 3, 2))
    tmp93 = v.bbbb.ooov.copy() * -1
    tmp93 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp93 += tmp92.transpose((1, 0, 2, 3))
    tmp93 += tmp92.transpose((2, 0, 1, 3)) * -1
    tmp5 = v.aabb.ooov.copy()
    tmp5 += tmp4.transpose((1, 0, 2, 3))
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), tmp37, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp134 = einsum(tmp39, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp26 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (0, 2), (2, 1)) * 2
    tmp47 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp46 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp49 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (1, 0, 4, 3), (4, 2))
    tmp90 = v.aaaa.ovvv.copy()
    tmp90 += v.aaaa.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp11 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp11 += tmp10
    tmp1 = v.aaaa.ooov.copy() * -1
    tmp1 += v.aaaa.ovoo.transpose((0, 2, 3, 1))
    tmp1 += tmp0.transpose((1, 0, 2, 3))
    tmp1 += tmp0.transpose((2, 0, 1, 3)) * -1
    tmp82 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp80 = einsum(tmp48, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp19 = v.aabb.ooov.copy()
    tmp19 += tmp4
    tmp18 = v.aaaa.ooov.copy() * -1
    tmp18 += v.aaaa.ooov.transpose((0, 2, 1, 3))
    tmp18 += tmp0
    tmp18 += tmp0.transpose((0, 2, 1, 3)) * -1
    tmp24 = v.aaaa.oooo.copy()
    tmp24 += tmp21.transpose((3, 1, 2, 0))
    tmp24 += tmp22.transpose((3, 1, 2, 0))
    tmp24 += tmp23.transpose((2, 1, 3, 0))
    tmp24 += tmp23.transpose((3, 2, 1, 0)) * -1
    tmp20 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp20 += v.aaaa.oovv * -1
    tmp20 += einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp225 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    l2new.bbbb += einsum(tmp225, (0, 1), l1.bb, (2, 3), (2, 1, 0, 3))
    l2new.bbbb += einsum(tmp225, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp225, (2, 3), (0, 3, 1, 2)) * -1
    l2new.bbbb += einsum(tmp225, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.abab += einsum(l1.aa, (0, 1), tmp225, (2, 3), (0, 3, 1, 2)) * -1
    del tmp225
    tmp236 = v.bbbb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp236 += v.bbbb.oovv * -1
    tmp236 += tmp198
    del tmp198
    tmp236 += tmp199 * 2
    del tmp199
    tmp236 += einsum(t1.bb, (0, 1), tmp142, (2, 3, 1, 4), (0, 2, 4, 3)) * -1
    l2new.bbbb += einsum(tmp236, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 0), (3, 4, 5, 1)) * -2
    del tmp236
    tmp231 = einsum(tmp92, (0, 1, 2, 3), tmp39, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    l2new.bbbb += tmp231.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp231.transpose((2, 3, 0, 1)) * -2
    l2new.bbbb += tmp231.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp231.transpose((3, 2, 0, 1)) * 2
    del tmp231
    tmp233 = einsum(tmp4, (0, 1, 2, 3), tmp50, (0, 1, 4, 5), (4, 2, 5, 3))
    l2new.bbbb += tmp233.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp233.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp233.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp233.transpose((3, 2, 0, 1))
    del tmp233
    tmp255 = einsum(tmp129, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    del tmp129
    l2new.bbbb += tmp255.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp255.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp255.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp255.transpose((3, 2, 0, 1))
    del tmp255
    tmp232 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    l2new.bbbb += tmp232.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp232.transpose((3, 2, 0, 1))
    l2new.bbbb += tmp232.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp232.transpose((2, 3, 0, 1)) * -1
    del tmp232
    tmp238 = einsum(l2.bbbb, (0, 1, 2, 3), tmp118, (3, 4), (2, 4, 0, 1)) * -2
    del tmp118
    l2new.bbbb += tmp238.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp238.transpose((3, 2, 0, 1)) * -1
    del tmp238
    tmp242 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp39, (4, 5, 0, 3), (5, 4, 1, 2))
    l2new.bbbb += tmp242.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp242.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp242.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp242.transpose((2, 3, 1, 0))
    del tmp242
    tmp227 = einsum(tmp197, (0, 1), v.bbbb.ovov, (2, 1, 3, 4), (2, 3, 0, 4))
    del tmp197
    l2new.bbbb += tmp227.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp227.transpose((3, 2, 1, 0)) * -1
    del tmp227
    tmp244 = einsum(tmp135, (0, 1, 2, 3), v.bbbb.ovov, (2, 4, 3, 5), (0, 1, 4, 5)) * 0.5
    l2new.bbbb += tmp244.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp244.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp244.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp244.transpose((3, 2, 1, 0))
    del tmp244
    tmp241 = einsum(l2.abab, (0, 1, 2, 3), tmp206, (2, 4, 0, 5), (4, 3, 5, 1))
    del tmp206
    l2new.bbbb += tmp241.transpose((3, 2, 0, 1)) * -1
    l2new.bbbb += tmp241.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp241.transpose((2, 3, 0, 1))
    del tmp241
    tmp252 = tmp32.copy() * 0.5
    tmp252 += tmp33
    l2new.bbbb += einsum(tmp252, (0, 1), v.bbbb.ovov, (2, 1, 3, 4), (0, 4, 2, 3)) * -2
    del tmp252
    tmp254 = einsum(tmp39, (0, 1, 2, 3), tmp92, (1, 2, 4, 5), (0, 4, 3, 5))
    l2new.bbbb += tmp254.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp254.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp254.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp254.transpose((3, 2, 0, 1)) * -2
    del tmp254
    tmp237 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp237 += tmp203
    del tmp203
    tmp237 += tmp204 * 2
    del tmp204
    tmp237 += tmp205
    del tmp205
    l2new.bbbb += einsum(l2.abab, (0, 1, 2, 3), tmp237, (2, 4, 0, 5), (5, 1, 3, 4)) * -1
    del tmp237
    tmp208 = f.bb.ov.copy()
    tmp208 += tmp94
    tmp208 += tmp207
    l2new.bbbb += einsum(tmp208, (0, 1), l1.bb, (2, 3), (2, 1, 0, 3)) * -1
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp208, (2, 3), (0, 3, 1, 2))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp208, (2, 3), (3, 0, 2, 1))
    l2new.abab += einsum(l1.aa, (0, 1), tmp208, (2, 3), (0, 3, 1, 2))
    del tmp208
    tmp230 = einsum(tmp229, (0, 1, 2, 3), l1.bb, (4, 0), (1, 2, 3, 4))
    del tmp229
    l2new.bbbb += tmp230.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp230.transpose((3, 2, 0, 1))
    del tmp230
    tmp251 = v.bbbb.ooov.copy()
    tmp251 += tmp92.transpose((0, 2, 1, 3))
    l2new.bbbb += einsum(tmp251, (0, 1, 2, 3), l1.bb, (4, 0), (3, 4, 1, 2))
    del tmp251
    tmp256 = einsum(tmp44, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (2, 0, 4, 3))
    l2new.bbbb += tmp256.transpose((3, 2, 0, 1)) * -1
    l2new.bbbb += tmp256.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp256.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp256.transpose((2, 3, 1, 0)) * -1
    del tmp256
    tmp247 = einsum(l2.bbbb, (0, 1, 2, 3), tmp246, (4, 1), (2, 3, 4, 0)) * -1
    del tmp246
    l2new.bbbb += tmp247.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp247.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp247.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp247.transpose((2, 3, 1, 0))
    del tmp247
    tmp240 = einsum(tmp202, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 0), (1, 5, 3, 4))
    del tmp202
    l2new.bbbb += tmp240.transpose((3, 2, 0, 1)) * -2
    l2new.bbbb += tmp240.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp240.transpose((2, 3, 0, 1)) * 2
    del tmp240
    tmp249 = einsum(l2.bbbb, (0, 1, 2, 3), tmp106, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp106
    l2new.bbbb += tmp249.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp249.transpose((2, 3, 0, 1)) * -2
    del tmp249
    tmp253 = einsum(tmp39, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    l2new.bbbb += tmp253.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp253.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp253.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp253.transpose((3, 2, 0, 1)) * -2
    del tmp253
    tmp243 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), l2.bbbb, (1, 3, 4, 5), (4, 5, 0, 2))
    l2new.bbbb += tmp243.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp243.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp243.transpose((3, 2, 1, 0)) * 0.5
    l2new.bbbb += tmp243.transpose((3, 2, 1, 0)) * 0.5
    del tmp243
    tmp228 = v.bbbb.ooov.copy()
    tmp228 += tmp92.transpose((0, 2, 1, 3))
    del tmp92
    l2new.bbbb += einsum(tmp228, (0, 1, 2, 3), l1.bb, (4, 0), (3, 4, 2, 1)) * -1
    del tmp228
    tmp239 = f.bb.ov.copy()
    tmp239 += tmp94
    del tmp94
    tmp239 += tmp207
    del tmp207
    l2new.bbbb += einsum(tmp239, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0)) * -1
    del tmp239
    tmp250 = v.bbbb.oooo.copy()
    tmp250 += tmp104.transpose((1, 3, 2, 0))
    del tmp104
    tmp250 += tmp105.transpose((0, 2, 3, 1))
    del tmp105
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp250, (2, 4, 5, 3), (0, 1, 5, 4)) * -2
    del tmp250
    tmp234 = einsum(tmp50, (0, 1, 2, 3), v.aabb.ooov, (1, 0, 4, 5), (2, 4, 3, 5))
    l2new.bbbb += tmp234.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp234.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp234.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp234.transpose((3, 2, 0, 1))
    del tmp234
    tmp248 = einsum(tmp39, (0, 1, 2, 3), tmp218, (2, 4), (0, 1, 4, 3))
    del tmp218
    l2new.bbbb += tmp248.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp248.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp248.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp248.transpose((2, 3, 1, 0)) * -1
    del tmp248
    tmp235 = einsum(tmp39, (0, 1, 2, 3), v.bbbb.ovoo, (4, 5, 2, 0), (1, 4, 3, 5)) * -1
    l2new.bbbb += tmp235.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp235.transpose((2, 3, 0, 1)) * -2
    l2new.bbbb += tmp235.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp235.transpose((3, 2, 0, 1)) * 2
    del tmp235
    tmp172 = f.aa.ov.copy()
    tmp172 += tmp164
    tmp172 += tmp6
    l2new.abab += einsum(l1.bb, (0, 1), tmp172, (2, 3), (3, 0, 2, 1))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp172, (2, 3), (0, 3, 2, 1)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp172, (2, 3), (0, 3, 1, 2))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp172, (2, 3), (3, 0, 2, 1))
    del tmp172
    tmp140 = tmp41.copy() * 0.5
    del tmp41
    tmp140 += tmp42 * 0.5
    del tmp42
    tmp140 += tmp43
    del tmp43
    l2new.abab += einsum(tmp140, (0, 1), v.aabb.ovov, (2, 3, 1, 4), (3, 4, 2, 0)) * -2
    l1new.bb += einsum(tmp140, (0, 1), v.bbbb.ooov, (2, 0, 1, 3), (3, 2)) * 2
    del tmp140
    tmp223 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    l2new.abab += einsum(tmp223, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5))
    del tmp223
    tmp220 = v.aabb.oooo.copy()
    tmp220 += tmp12.transpose((1, 0, 2, 3))
    del tmp12
    tmp220 += tmp13
    del tmp13
    tmp220 += einsum(tmp3, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    l2new.abab += einsum(tmp220, (0, 1, 2, 3), l2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp220
    tmp212 = f.aa.vv.copy() * -0.5
    tmp212 += tmp89.transpose((1, 0)) * -0.5
    tmp212 += tmp177
    del tmp177
    tmp212 += tmp178 * 0.5
    del tmp178
    tmp212 += einsum(t1.aa, (0, 1), tmp68, (0, 2, 1, 3), (3, 2)) * -0.5
    l2new.abab += einsum(tmp212, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -2
    del tmp212
    tmp191 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    l2new.abab += einsum(l1.bb, (0, 1), tmp191, (2, 3), (3, 0, 2, 1)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp191, (2, 3), (0, 3, 2, 1))
    l2new.aaaa += einsum(tmp191, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp191, (2, 3), (0, 3, 1, 2)) * -1
    l2new.aaaa += einsum(tmp191, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0))
    del tmp191
    tmp222 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp222, (3, 4, 0, 5), (5, 1, 2, 4))
    del tmp222
    tmp219 = v.aabb.ooov.copy()
    tmp219 += tmp4
    del tmp4
    l2new.abab += einsum(tmp37, (0, 1, 2, 3), tmp219, (0, 4, 2, 5), (3, 5, 4, 1))
    l2new.abab += einsum(l1.aa, (0, 1), tmp219, (1, 2, 3, 4), (0, 4, 2, 3)) * -1
    del tmp219
    tmp210 = einsum(l2.abab, (0, 1, 2, 3), v.aabb.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    l2new.abab += tmp210.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp210.transpose((2, 3, 0, 1)) * 0.5
    del tmp210
    tmp221 = v.aabb.oovv.copy()
    tmp221 += einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    l2new.abab += einsum(tmp221, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5)) * -1
    del tmp221
    tmp224 = tmp123.copy()
    tmp224 += tmp124
    l2new.abab += einsum(tmp224, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 0, 5), (5, 3, 4, 1)) * -2
    del tmp224
    tmp209 = v.aabb.vvoo.transpose((2, 3, 0, 1)).copy()
    tmp209 += tmp98.transpose((0, 1, 3, 2))
    del tmp98
    l2new.abab += einsum(tmp209, (0, 1, 2, 3), l2.abab, (2, 4, 5, 0), (3, 4, 5, 1)) * -1
    del tmp209
    tmp211 = einsum(tmp74, (0, 1, 2, 3), v.aabb.ovov, (1, 4, 3, 5), (0, 2, 4, 5)) * 0.5
    l2new.abab += tmp211.transpose((2, 3, 0, 1))
    l2new.abab += tmp211.transpose((2, 3, 0, 1))
    del tmp211
    tmp226 = tmp65.copy()
    tmp226 += tmp66
    l2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp226, (4, 2, 5, 1), (5, 3, 4, 0)) * -2
    del tmp226
    tmp215 = f.bb.vv.copy() * -1
    tmp215 += tmp141.transpose((1, 0)) * -1
    tmp215 += tmp213
    del tmp213
    tmp215 += tmp214 * 2
    del tmp214
    tmp215 += einsum(tmp126, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    del tmp126
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp215, (1, 4), (0, 4, 2, 3)) * -1
    del tmp215
    tmp189 = tmp27.copy() * 2
    tmp189 += tmp28
    l2new.abab += einsum(tmp189, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 4, 2, 3)) * -1
    l2new.aaaa += einsum(tmp189, (0, 1), v.aaaa.ovov, (2, 1, 3, 4), (0, 4, 2, 3)) * -1
    del tmp189
    tmp156 = v.aaaa.ovov.transpose((0, 2, 1, 3)).copy()
    tmp156 += v.aaaa.oovv * -1
    tmp156 += tmp154 * 2
    del tmp154
    tmp156 += tmp155
    del tmp155
    tmp156 += einsum(t1.aa, (0, 1), tmp68, (2, 3, 1, 4), (0, 2, 4, 3)) * -1
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp156, (3, 4, 1, 5), (5, 0, 2, 4)) * -2
    del tmp156
    tmp190 = einsum(tmp0, (0, 1, 2, 3), tmp48, (4, 0, 1, 5), (4, 2, 5, 3))
    l2new.aaaa += tmp190.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp190.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp190.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp190.transpose((3, 2, 0, 1)) * -2
    del tmp190
    tmp159 = v.aabb.ovov.transpose((0, 2, 1, 3)).copy()
    tmp159 += tmp10
    del tmp10
    tmp159 += tmp157
    del tmp157
    tmp159 += tmp158 * 2
    del tmp158
    l2new.aaaa += einsum(tmp159, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (2, 4, 5, 0)) * -1
    del tmp159
    tmp163 = einsum(l2.aaaa, (0, 1, 2, 3), tmp162, (3, 4), (4, 2, 0, 1)) * -2
    del tmp162
    l2new.aaaa += tmp163.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp163.transpose((3, 2, 1, 0)) * -1
    del tmp163
    tmp181 = einsum(l2.aaaa, (0, 1, 2, 3), tmp180, (4, 1), (2, 3, 4, 0)) * -1
    del tmp180
    l2new.aaaa += tmp181.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp181.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp181.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp181.transpose((2, 3, 1, 0))
    del tmp181
    tmp185 = einsum(tmp48, (0, 1, 2, 3), tmp184, (2, 4), (0, 1, 4, 3))
    del tmp184
    l2new.aaaa += tmp185.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp185.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp185.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp185.transpose((2, 3, 1, 0)) * -1
    del tmp185
    tmp153 = einsum(tmp37, (0, 1, 2, 3), tmp2, (4, 1, 2, 5), (0, 4, 3, 5))
    l2new.aaaa += tmp153.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp153.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp153.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp153.transpose((3, 2, 0, 1))
    del tmp153
    tmp192 = einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp48, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    l2new.aaaa += tmp192.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp192.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp192.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp192.transpose((3, 2, 0, 1)) * -2
    del tmp192
    tmp188 = v.aaaa.ooov.copy()
    tmp188 += tmp0.transpose((0, 2, 1, 3))
    l2new.aaaa += einsum(tmp188, (0, 1, 2, 3), l1.aa, (4, 0), (3, 4, 1, 2))
    del tmp188
    tmp194 = einsum(tmp193, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    del tmp193
    l2new.aaaa += tmp194.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp194.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp194.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp194.transpose((3, 2, 0, 1))
    del tmp194
    tmp173 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp48, (4, 5, 0, 3), (5, 4, 1, 2))
    l2new.aaaa += tmp173.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp173.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp173.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp173.transpose((2, 3, 1, 0))
    del tmp173
    tmp149 = einsum(l1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    l2new.aaaa += tmp149.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp149.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp149.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp149.transpose((2, 3, 0, 1)) * -1
    del tmp149
    tmp146 = v.aaaa.ooov.copy()
    tmp146 += tmp0.transpose((0, 2, 1, 3))
    l2new.aaaa += einsum(tmp146, (0, 1, 2, 3), l1.aa, (4, 0), (3, 4, 2, 1)) * -1
    del tmp146
    tmp151 = einsum(tmp48, (0, 1, 2, 3), v.aaaa.ovoo, (4, 5, 2, 0), (1, 4, 3, 5)) * -1
    l2new.aaaa += tmp151.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp151.transpose((2, 3, 0, 1)) * -2
    l2new.aaaa += tmp151.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp151.transpose((3, 2, 0, 1)) * 2
    del tmp151
    tmp165 = f.aa.ov.copy()
    tmp165 += tmp164
    del tmp164
    tmp165 += tmp6
    del tmp6
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp165, (2, 3), (3, 0, 1, 2)) * -1
    del tmp165
    tmp196 = einsum(tmp55, (0, 1), v.aaaa.ovov, (2, 3, 1, 4), (2, 0, 4, 3)) * 2
    del tmp55
    l2new.aaaa += tmp196.transpose((3, 2, 0, 1)) * -1
    l2new.aaaa += tmp196.transpose((2, 3, 0, 1))
    del tmp196
    tmp150 = einsum(tmp48, (0, 1, 2, 3), tmp0, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp0
    l2new.aaaa += tmp150.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp150.transpose((2, 3, 0, 1)) * -2
    l2new.aaaa += tmp150.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp150.transpose((3, 2, 0, 1)) * 2
    del tmp150
    tmp174 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), l2.aaaa, (3, 1, 4, 5), (4, 5, 0, 2)) * -1
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0)) * 0.5
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0)) * 0.5
    del tmp174
    tmp186 = einsum(tmp23, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp23
    l2new.aaaa += tmp186.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp186.transpose((2, 3, 0, 1)) * -2
    del tmp186
    tmp171 = einsum(l2.abab, (0, 1, 2, 3), tmp170, (4, 3, 5, 1), (4, 2, 5, 0))
    del tmp170
    l2new.aaaa += tmp171.transpose((3, 2, 0, 1)) * -1
    l2new.aaaa += tmp171.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp171.transpose((2, 3, 0, 1))
    del tmp171
    tmp148 = einsum(tmp147, (0, 1, 2, 3), l1.aa, (4, 0), (1, 2, 3, 4))
    del tmp147
    l2new.aaaa += tmp148.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp148.transpose((3, 2, 0, 1))
    del tmp148
    tmp152 = einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp37, (4, 3, 2, 5), (4, 0, 5, 1))
    l2new.aaaa += tmp152.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp152.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp152.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp152.transpose((3, 2, 0, 1))
    del tmp152
    tmp145 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp144, (4, 1), (0, 2, 4, 3)) * 2
    del tmp144
    l2new.aaaa += tmp145.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp145.transpose((3, 2, 1, 0)) * -1
    del tmp145
    tmp195 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp58, (4, 2), (0, 4, 3, 1))
    del tmp58
    l2new.aaaa += tmp195.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp195.transpose((2, 3, 1, 0)) * -1
    del tmp195
    tmp169 = einsum(tmp168, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (1, 5, 3, 4))
    del tmp168
    l2new.aaaa += tmp169.transpose((3, 2, 0, 1)) * -2
    l2new.aaaa += tmp169.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp169.transpose((2, 3, 0, 1)) * 2
    del tmp169
    tmp187 = v.aaaa.oooo.copy() * -1
    tmp187 += tmp21.transpose((1, 3, 0, 2)) * -1
    del tmp21
    tmp187 += tmp22.transpose((0, 3, 1, 2))
    del tmp22
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp187, (2, 4, 3, 5), (0, 1, 4, 5)) * -2
    del tmp187
    tmp176 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp175, (4, 5, 0, 2), (4, 5, 1, 3)) * 0.5
    del tmp175
    l2new.aaaa += tmp176.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp176.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp176.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp176.transpose((3, 2, 1, 0))
    del tmp176
    tmp132 = l2.bbbb.transpose((2, 3, 0, 1)).copy() * -1
    tmp132 += einsum(t1.bb, (0, 1), tmp39, (2, 0, 3, 4), (2, 3, 4, 1))
    l1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp132, (4, 0, 3, 1), (2, 4)) * -2
    del tmp132
    tmp143 = f.bb.vv.copy()
    tmp143 += tmp141.transpose((1, 0))
    del tmp141
    tmp143 += einsum(t1.bb, (0, 1), tmp142, (0, 1, 2, 3), (3, 2)) * -1
    del tmp142
    l1new.bb += einsum(tmp143, (0, 1), l1.bb, (0, 2), (1, 2))
    del tmp143
    tmp125 = l2.abab.transpose((2, 3, 0, 1)).copy() * 0.5
    tmp125 += tmp123
    del tmp123
    tmp125 += einsum(t1.aa, (0, 1), tmp50, (0, 2, 3, 4), (2, 3, 1, 4)) * -0.5
    tmp125 += tmp124
    del tmp124
    l1new.bb += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp125, (0, 4, 1, 3), (2, 4)) * 2
    del tmp125
    tmp120 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    l1new.bb += einsum(tmp120, (0, 1, 2, 3), l2.abab, (1, 3, 0, 4), (2, 4))
    del tmp120
    tmp111 = l1.bb.transpose((1, 0)).copy() * -0.5
    tmp111 += t1.bb * -0.5
    tmp111 += tmp35 * -0.5
    tmp111 += tmp36 * -1
    tmp111 += tmp38 * 0.5
    tmp111 += tmp40
    tmp111 += tmp110
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp111, (2, 3), (1, 0)) * -2
    del tmp111
    tmp139 = t1.bb.copy() * -0.5
    tmp139 += tmp35 * -0.5
    tmp139 += tmp36 * -1
    tmp139 += tmp38 * 0.5
    tmp139 += tmp40
    tmp139 += tmp110
    del tmp110
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp139, (2, 1), (3, 0)) * 2
    del tmp139
    tmp131 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp131 += einsum(t1.aa, (0, 1), tmp37, (0, 2, 3, 4), (2, 3, 1, 4))
    l1new.bb += einsum(tmp131, (0, 1, 2, 3), v.aabb.vvov, (2, 3, 1, 4), (4, 0)) * -1
    del tmp131
    tmp130 = einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    tmp130 += tmp37
    tmp130 += einsum(t2.aaaa, (0, 1, 2, 3), tmp37, (1, 4, 5, 3), (0, 4, 5, 2)) * 2
    tmp130 += einsum(t2.abab, (0, 1, 2, 3), tmp50, (0, 4, 5, 3), (4, 5, 1, 2)) * -1
    tmp130 += einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 1, 5, 3), (0, 4, 5, 2)) * -2
    tmp130 += einsum(tmp74, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    l1new.bb += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp130, (0, 4, 2, 1), (3, 4)) * -1
    del tmp130
    tmp119 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp119, (3, 4, 0, 1), (4, 2)) * 2
    del tmp119
    tmp138 = tmp72.copy()
    tmp138 += tmp73.transpose((1, 0, 2, 3))
    l1new.bb += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp138, (0, 1, 4, 2), (3, 4))
    del tmp138
    tmp108 = v.bbbb.ooov.copy() * -1
    tmp108 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (4, 0, 1, 5))
    tmp108 += einsum(t2.bbbb, (0, 1, 2, 3), tmp101, (4, 1, 5, 3), (5, 0, 4, 2)) * 2
    del tmp101
    tmp108 += einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (2, 4, 1, 5))
    del tmp14
    tmp108 += einsum(t2.bbbb, (0, 1, 2, 3), tmp97, (4, 3), (4, 0, 1, 2))
    tmp108 += einsum(t1.bb, (0, 1), tmp103, (2, 3, 4, 1), (3, 2, 0, 4))
    del tmp103
    tmp108 += einsum(tmp107, (0, 1, 2, 3), t1.bb, (0, 4), (2, 3, 1, 4))
    del tmp107
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp108, (4, 2, 3, 1), (0, 4)) * 2
    del tmp108
    tmp34 = tmp31.copy() * 0.5
    del tmp31
    tmp34 += tmp32 * 0.5
    del tmp32
    tmp34 += tmp33
    del tmp33
    l1new.bb += einsum(tmp34, (0, 1), tmp109, (2, 1, 0, 3), (3, 2)) * -2
    del tmp109
    l1new.aa += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp34, (3, 2), (1, 0)) * 2
    del tmp34
    tmp100 = v.aabb.ovoo.transpose((0, 2, 3, 1)).copy()
    tmp100 += tmp2
    del tmp2
    tmp100 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    tmp100 += einsum(t2.abab, (0, 1, 2, 3), tmp93, (1, 4, 5, 3), (0, 4, 5, 2))
    del tmp93
    tmp100 += einsum(t2.aaaa, (0, 1, 2, 3), tmp3, (1, 4, 5, 3), (0, 5, 4, 2)) * 2
    tmp100 += einsum(tmp5, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5)) * -1
    tmp100 += einsum(t2.abab, (0, 1, 2, 3), tmp97, (4, 3), (0, 1, 4, 2))
    del tmp97
    tmp100 += einsum(t1.aa, (0, 1), tmp99, (2, 3, 1, 4), (0, 3, 2, 4))
    del tmp99
    tmp100 += einsum(t1.aa, (0, 1), tmp16, (0, 2, 3, 4), (2, 4, 3, 1)) * -1
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp100, (2, 3, 4, 0), (1, 4)) * -1
    del tmp100
    tmp137 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2)) * 2
    tmp137 += tmp133.transpose((0, 2, 1, 3))
    tmp137 += tmp134.transpose((0, 2, 1, 3)) * 4
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp137, (4, 0, 2, 3), (1, 4))
    del tmp137
    tmp29 = tmp26.copy() * 0.5
    del tmp26
    tmp29 += tmp27
    del tmp27
    tmp29 += tmp28 * 0.5
    del tmp28
    l1new.bb += einsum(tmp29, (0, 1), v.aabb.vvov, (0, 1, 2, 3), (3, 2)) * 2
    l1new.aa += einsum(tmp30, (0, 1, 2, 3), tmp29, (2, 1), (3, 0)) * -2
    del tmp30, tmp29
    tmp136 = tmp39.transpose((1, 0, 2, 3)).copy() * -2
    del tmp39
    tmp136 += tmp133.transpose((2, 0, 1, 3))
    del tmp133
    tmp136 += tmp134.transpose((2, 0, 1, 3)) * 4
    del tmp134
    tmp136 += einsum(tmp135, (0, 1, 2, 3), t1.bb, (0, 4), (3, 1, 2, 4)) * 2
    del tmp135
    l1new.bb += einsum(tmp136, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 2, 4), (4, 1)) * -1
    del tmp136
    tmp57 = l1.aa.transpose((1, 0)).copy() * -1
    tmp57 += t1.aa * -1
    tmp57 += tmp46 * -2
    tmp57 += tmp47 * -1
    tmp57 += tmp49 * 2
    tmp57 += tmp51
    tmp57 += tmp56
    l1new.bb += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp57, (0, 1), (3, 2)) * -1
    l1new.aa += einsum(tmp57, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (3, 2)) * -1
    del tmp57
    tmp78 = einsum(t1.aa, (0, 1), tmp48, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp91 = f.aa.vv.copy()
    tmp91 += tmp89.transpose((1, 0))
    del tmp89
    tmp91 += einsum(t1.aa, (0, 1), tmp90, (0, 2, 1, 3), (3, 2)) * -1
    del tmp90
    l1new.aa += einsum(l1.aa, (0, 1), tmp91, (0, 2), (2, 1))
    del tmp91
    tmp45 = l1.bb.transpose((1, 0)).copy() * -1
    tmp45 += t1.bb * -1
    tmp45 += tmp35 * -1
    del tmp35
    tmp45 += tmp36 * -2
    del tmp36
    tmp45 += tmp38
    del tmp38
    tmp45 += tmp40 * 2
    del tmp40
    tmp45 += einsum(t1.bb, (0, 1), tmp44, (0, 2), (2, 1))
    del tmp44
    l1new.aa += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp45, (2, 3), (1, 0)) * -1
    del tmp45
    tmp71 = tmp69.copy() * 4
    del tmp69
    tmp71 += tmp70
    del tmp70
    l1new.aa += einsum(tmp71, (0, 1, 2, 3), tmp68, (1, 4, 3, 2), (4, 0))
    del tmp68, tmp71
    tmp88 = t1.aa.copy() * -1
    tmp88 += tmp46 * -2
    del tmp46
    tmp88 += tmp47 * -1
    del tmp47
    tmp88 += tmp49 * 2
    del tmp49
    tmp88 += tmp51
    del tmp51
    tmp88 += tmp56
    del tmp56
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp88, (2, 1), (3, 0))
    del tmp88
    tmp77 = v.aaaa.ovvv.copy()
    tmp77 += einsum(v.aaaa.vvvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1)) * -1
    l1new.aa += einsum(l2.aaaa, (0, 1, 2, 3), tmp77, (3, 0, 1, 4), (4, 2)) * -2
    del tmp77
    tmp75 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    tmp75 += tmp50
    tmp75 += einsum(tmp48, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5)) * -2
    tmp75 += einsum(t2.bbbb, (0, 1, 2, 3), tmp50, (4, 5, 1, 3), (4, 5, 0, 2)) * 2
    tmp75 += einsum(t2.abab, (0, 1, 2, 3), tmp37, (4, 1, 5, 2), (4, 0, 5, 3)) * -1
    tmp75 += einsum(t1.bb, (0, 1), tmp74, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp74
    l1new.aa += einsum(tmp75, (0, 1, 2, 3), v.aabb.ovov, (1, 4, 2, 3), (4, 0)) * -1
    del tmp75
    tmp64 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    l1new.aa += einsum(tmp64, (0, 1, 2, 3), l2.abab, (2, 3, 4, 0), (1, 4))
    del tmp64
    tmp67 = l2.abab.transpose((2, 3, 0, 1)).copy() * 0.5
    tmp67 += tmp65
    del tmp65
    tmp67 += tmp66
    del tmp66
    tmp67 += einsum(t1.bb, (0, 1), tmp37, (2, 0, 3, 4), (2, 3, 4, 1)) * -0.5
    del tmp37
    l1new.aa += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp67, (4, 2, 1, 3), (0, 4)) * 2
    del tmp67
    tmp79 = v.aaaa.ovvv.copy() * -1
    tmp79 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    l1new.aa += einsum(tmp79, (0, 1, 2, 3), tmp78, (4, 0, 2, 3), (1, 4)) * -2
    del tmp79, tmp78
    tmp17 = v.aabb.ooov.copy()
    tmp17 += einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp17 += einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp17 += einsum(tmp1, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 2, 4, 5))
    del tmp1
    tmp17 += einsum(tmp3, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (4, 0, 2, 5)) * -1
    del tmp3
    tmp17 += einsum(t2.bbbb, (0, 1, 2, 3), tmp5, (4, 5, 1, 3), (5, 4, 0, 2)) * 2
    del tmp5
    tmp17 += einsum(tmp9, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp17 += einsum(t1.aa, (0, 1), tmp11, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp11
    tmp17 += einsum(t1.bb, (0, 1), tmp16, (2, 3, 0, 4), (3, 2, 4, 1)) * -1
    del tmp16
    l1new.aa += einsum(l2.abab, (0, 1, 2, 3), tmp17, (2, 4, 3, 1), (0, 4)) * -1
    del tmp17
    tmp76 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp76 += einsum(tmp50, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp50
    l1new.aa += einsum(tmp76, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp76
    tmp83 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2)) * 0.5
    tmp83 += tmp48.transpose((1, 0, 2, 3)) * 0.5
    del tmp48
    tmp83 += tmp80.transpose((0, 2, 1, 3))
    tmp83 += einsum(t1.aa, (0, 1), tmp81, (0, 2, 3, 4), (2, 3, 4, 1)) * -0.5
    tmp83 += tmp82.transpose((0, 2, 1, 3)) * 0.25
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp83, (4, 0, 2, 1), (3, 4)) * -4
    del tmp83
    tmp25 = v.aaaa.ooov.transpose((0, 2, 1, 3)).copy() * 0.5
    tmp25 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (0, 4, 5, 2)) * 0.5
    tmp25 += einsum(tmp18, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (2, 4, 0, 5))
    del tmp18
    tmp25 += einsum(tmp19, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (1, 4, 0, 5)) * 0.5
    del tmp19
    tmp25 += einsum(tmp9, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4)) * 0.5
    tmp25 += einsum(t1.aa, (0, 1), tmp20, (2, 3, 4, 1), (3, 2, 0, 4)) * 0.5
    del tmp20
    tmp25 += einsum(t1.aa, (0, 1), tmp24, (0, 2, 3, 4), (3, 2, 4, 1)) * -0.5
    del tmp24
    l1new.aa += einsum(tmp25, (0, 1, 2, 3), l2.aaaa, (4, 3, 1, 2), (4, 0)) * 4
    del tmp25
    tmp86 = tmp84.transpose((1, 0, 3, 2)).copy()
    tmp86 += tmp81.transpose((2, 1, 0, 3))
    del tmp81
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp86, (1, 4, 0, 2), (3, 4)) * 2
    del tmp86
    tmp85 = tmp80.copy()
    del tmp80
    tmp85 += einsum(t1.aa, (0, 1), tmp84, (2, 0, 3, 4), (2, 4, 3, 1)) * 0.5
    del tmp84
    tmp85 += tmp82 * 0.25
    del tmp82
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp85, (4, 2, 0, 3), (1, 4)) * 4
    del tmp85
    tmp63 = f.aa.oo.copy() * 0.5
    tmp63 += tmp59.transpose((1, 0)) * 0.5
    del tmp59
    tmp63 += tmp60
    del tmp60
    tmp63 += tmp61 * 0.5
    del tmp61
    tmp63 += einsum(t1.aa, (0, 1), tmp62, (0, 2, 3, 1), (2, 3)) * -0.5
    del tmp62
    tmp63 += einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0)) * 0.5
    del tmp9
    l1new.aa += einsum(l1.aa, (0, 1), tmp63, (1, 2), (0, 2)) * -2
    del tmp63
    tmp87 = tmp72.copy()
    del tmp72
    tmp87 += tmp73.transpose((0, 1, 3, 2))
    del tmp73
    l1new.aa += einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp87, (4, 0, 3, 2), (1, 4))
    del tmp87
    l1new.aa += f.aa.ov.transpose((1, 0))
    l1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), l1.aa, (3, 1), (2, 0)) * -1
    l1new.bb += einsum(l1.bb, (0, 1), v.bbbb.oovv, (2, 1, 3, 0), (3, 2)) * -1
    l1new.bb += f.bb.ov.transpose((1, 0))
    l2new.aaaa += v.aaaa.ovov.transpose((1, 3, 0, 2))
    l2new.aaaa += v.aaaa.ovov.transpose((3, 1, 0, 2)) * -1
    l2new.abab += v.aabb.ovov.transpose((1, 3, 0, 2))
    l2new.abab += einsum(v.aabb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (1, 2, 0, 4))
    l2new.abab += einsum(v.aabb.vvov, (0, 1, 2, 3), l1.aa, (1, 4), (0, 3, 4, 2))
    l2new.bbbb += v.bbbb.ovov.transpose((1, 3, 0, 2))
    l2new.bbbb += v.bbbb.ovov.transpose((3, 1, 0, 2)) * -1

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:37:38.152231.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp3 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    rdm1.bb.oo = tmp3.transpose((1, 0)).copy() * -1
    tmp4 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    rdm1.bb.oo += tmp4.transpose((1, 0)) * -1
    tmp5 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    rdm1.bb.oo += tmp5.transpose((1, 0)) * -2
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    rdm1.aa.oo = tmp2.transpose((1, 0)).copy() * -1
    tmp0 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    rdm1.aa.oo += tmp0.transpose((1, 0)) * -2
    tmp1 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    rdm1.aa.oo += tmp1.transpose((1, 0)) * -1
    tmp9 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.ov = einsum(t2.bbbb, (0, 1, 2, 3), tmp9, (1, 0, 4, 3), (4, 2)) * -2
    del tmp9
    tmp11 = tmp4.copy()
    del tmp4
    tmp11 += tmp3
    del tmp3
    tmp11 += tmp5 * 2
    del tmp5
    rdm1.bb.ov += einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    tmp10 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.ov += einsum(t2.abab, (0, 1, 2, 3), tmp10, (0, 1, 4, 2), (4, 3)) * -1
    del tmp10
    tmp8 = tmp1.copy()
    del tmp1
    tmp8 += tmp0 * 2
    del tmp0
    tmp8 += tmp2
    del tmp2
    rdm1.aa.ov = einsum(t1.aa, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8
    tmp6 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 3), (4, 2)) * -2
    del tmp6
    tmp7 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm1.aa.ov += einsum(tmp7, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4)) * -1
    del tmp7
    rdm1.aa.oo += delta.aa.oo
    rdm1.bb.oo += delta.bb.oo
    del delta
    rdm1.aa.ov += t1.aa
    rdm1.aa.ov += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2)) * 2
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2)) * 2
    rdm1.bb.ov += t1.bb
    rdm1.bb.ov += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    rdm1.aa.vo = l1.aa.copy()
    rdm1.bb.vo = l1.bb.copy()
    rdm1.aa.vv = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    rdm1.aa.vv += einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    rdm1.bb.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.bb.vv += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:38:42.782101.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp13 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.abab.vovv = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 1, 4, 5), (5, 4, 2, 3)) * -1
    rdm2.abab.vovo = einsum(t1.aa, (0, 1), tmp13, (0, 2, 3, 4), (4, 3, 1, 2)) * -1
    rdm2.abab.vooo = tmp13.transpose((3, 2, 0, 1)).copy() * -1
    tmp18 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.bbbb.vooo = tmp18.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.vooo += tmp18.transpose((3, 2, 1, 0))
    rdm2.bbbb.ovoo = tmp18.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.bbbb.ovoo += tmp18.transpose((2, 3, 1, 0)) * -1
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp8 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp0 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp1 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp6 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    rdm2.aaaa.vooo = tmp6.transpose((3, 2, 1, 0)).copy()
    rdm2.aaaa.vooo += tmp6.transpose((3, 2, 1, 0))
    rdm2.aaaa.ovoo = tmp6.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.aaaa.ovoo += tmp6.transpose((2, 3, 1, 0)) * -1
    tmp26 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm2.abab.ovvv = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 1, 5), (4, 5, 2, 3)) * -1
    rdm2.abab.ovov = einsum(t1.bb, (0, 1), tmp26, (2, 3, 0, 4), (3, 4, 2, 1)) * -1
    rdm2.abab.ovoo = tmp26.transpose((1, 3, 0, 2)).copy() * -1
    tmp85 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.bbbb.vovo = tmp85.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.voov = tmp85.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ovvo = tmp85.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.bbbb.ovov = tmp85.transpose((1, 2, 0, 3)).copy() * -4
    tmp84 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    rdm2.bbbb.vovo += tmp84.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.voov += tmp84.transpose((2, 1, 0, 3))
    rdm2.bbbb.ovvo += tmp84.transpose((1, 2, 3, 0))
    rdm2.bbbb.ovov += tmp84.transpose((1, 2, 0, 3)) * -1
    tmp106 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo = tmp106.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.aaaa.voov = tmp106.transpose((2, 1, 0, 3)).copy()
    rdm2.aaaa.ovvo = tmp106.transpose((1, 2, 3, 0)).copy()
    rdm2.aaaa.ovov = tmp106.transpose((1, 2, 0, 3)).copy() * -1
    tmp67 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo += tmp67.transpose((2, 1, 3, 0)) * -4
    rdm2.aaaa.voov += tmp67.transpose((2, 1, 0, 3)) * 4
    rdm2.aaaa.ovvo += tmp67.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ovov += tmp67.transpose((1, 2, 0, 3)) * -4
    tmp52 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 4, 5, 2), (4, 5, 1, 3))
    rdm2.bbbb.oovo = tmp52.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.bbbb.oovo += tmp52.transpose((1, 2, 3, 0))
    rdm2.bbbb.ooov = tmp52.transpose((2, 1, 0, 3)).copy()
    rdm2.bbbb.ooov += tmp52.transpose((1, 2, 0, 3)) * -1
    tmp53 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    rdm2.bbbb.oovo += tmp53.transpose((2, 1, 3, 0)) * -4
    rdm2.bbbb.oovo += tmp53.transpose((1, 2, 3, 0)) * 4
    rdm2.bbbb.ooov += tmp53.transpose((2, 1, 0, 3)) * 4
    rdm2.bbbb.ooov += tmp53.transpose((1, 2, 0, 3)) * -4
    tmp19 = einsum(t1.bb, (0, 1), tmp18, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2.bbbb.oooo = tmp19.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.bbbb.oooo += tmp19.transpose((2, 3, 1, 0)) * -1
    tmp17 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2.bbbb.oooo += tmp17.transpose((3, 2, 1, 0))
    rdm2.bbbb.oooo += tmp17.transpose((3, 2, 1, 0))
    tmp16 = tmp8.copy()
    tmp16 += tmp9
    tmp16 += tmp10 * 2
    rdm2.abab.oovv = einsum(t2.abab, (0, 1, 2, 3), tmp16, (1, 4), (0, 4, 2, 3)) * -1
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (1, 2, 3, 0))
    rdm2.abab.oovo = einsum(t1.aa, (0, 1), tmp16, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.bbbb.ooov += einsum(tmp16, (0, 1), t1.bb, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.ooov += einsum(tmp16, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp14 = einsum(t1.aa, (0, 1), tmp13, (2, 3, 4, 1), (2, 0, 3, 4))
    rdm2.abab.oooo = tmp14.transpose((1, 3, 0, 2)).copy()
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    rdm2.abab.oooo += tmp12.transpose((1, 3, 0, 2))
    tmp28 = tmp0.copy() * 0.5
    tmp28 += tmp1
    tmp28 += tmp2 * 0.5
    rdm2.abab.ooov = einsum(tmp28, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -2
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    rdm2.aaaa.oooo = tmp7.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.aaaa.oooo += tmp7.transpose((2, 3, 1, 0)) * -1
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.aaaa.oooo += tmp5.transpose((3, 2, 1, 0))
    rdm2.aaaa.oooo += tmp5.transpose((3, 2, 1, 0))
    tmp32 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    rdm2.aaaa.oovo = tmp32.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.aaaa.oovo += tmp32.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ooov = tmp32.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.aaaa.ooov += tmp32.transpose((1, 2, 0, 3)) * -4
    tmp31 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    rdm2.aaaa.oovo += tmp31.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += tmp31.transpose((1, 2, 3, 0))
    rdm2.aaaa.ooov += tmp31.transpose((2, 1, 0, 3))
    rdm2.aaaa.ooov += tmp31.transpose((1, 2, 0, 3)) * -1
    tmp108 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp82 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp81 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp86 = tmp84.copy()
    tmp86 += tmp85 * 4
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp86, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp111 = einsum(t1.bb, (0, 1), tmp18, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.bbbb.vovo += tmp111.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.voov += tmp111.transpose((2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo += tmp111.transpose((1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov += tmp111.transpose((1, 2, 0, 3)) * 2
    tmp88 = einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.abab.voov = tmp88.transpose((2, 1, 0, 3)).copy() * 2
    tmp87 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    rdm2.abab.voov += tmp87.transpose((2, 1, 0, 3)) * 2
    tmp65 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp104 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp64 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp118 = tmp67.copy() * 4
    tmp118 += tmp106
    tmp107 = einsum(t1.aa, (0, 1), tmp6, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.aaaa.vovo += tmp107.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.voov += tmp107.transpose((2, 1, 0, 3)) * -2
    rdm2.aaaa.ovvo += tmp107.transpose((1, 2, 3, 0)) * -2
    rdm2.aaaa.ovov += tmp107.transpose((1, 2, 0, 3)) * 2
    tmp69 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    rdm2.abab.ovvo = tmp69.transpose((0, 3, 2, 1)).copy() * 2
    tmp71 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    rdm2.abab.ovvo += tmp71.transpose((0, 3, 2, 1)) * 2
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    rdm2.bbbb.oovo += tmp49.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.ooov += tmp49.transpose((2, 1, 0, 3)) * -2
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp35 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp102 = tmp52.copy()
    del tmp52
    tmp102 += tmp53 * 4
    del tmp53
    tmp54 = tmp17.transpose((1, 0, 3, 2)).copy()
    del tmp17
    tmp54 += tmp19.transpose((0, 1, 3, 2)) * -1
    del tmp19
    tmp41 = einsum(t1.bb, (0, 1), tmp16, (0, 2), (2, 1)) * 0.5
    tmp40 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4))
    tmp39 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 1, 4, 2), (4, 3))
    tmp50 = einsum(t1.bb, (0, 1), tmp16, (0, 2), (2, 1))
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2.abab.ooov += tmp43.transpose((1, 2, 0, 3)) * -2
    tmp44 = einsum(tmp6, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5)) * -1
    rdm2.abab.ooov += tmp44.transpose((1, 2, 0, 3)) * -2
    tmp21 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp45 = tmp12.copy()
    del tmp12
    tmp45 += tmp14
    del tmp14
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp45, (0, 4, 1, 5), (4, 5, 2, 3))
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp45, (0, 2, 3, 4), (2, 4, 1, 3))
    tmp61 = einsum(tmp13, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    rdm2.abab.oovo += tmp61.transpose((0, 2, 3, 1)) * -2
    tmp60 = einsum(tmp18, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5)) * -1
    rdm2.abab.oovo += tmp60.transpose((0, 2, 3, 1)) * -2
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 3), (4, 2))
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp29 = einsum(t1.aa, (0, 1), tmp28, (0, 2), (2, 1)) * 2
    tmp33 = tmp5.transpose((1, 0, 3, 2)).copy()
    del tmp5
    tmp33 += tmp7.transpose((0, 1, 3, 2)) * -1
    del tmp7
    tmp4 = tmp0.copy()
    tmp4 += tmp1 * 2
    tmp4 += tmp2
    rdm2.abab.oovv += einsum(tmp4, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    rdm2.aaaa.oovo += einsum(tmp4, (0, 1), t1.aa, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 1, 2))
    rdm2.aaaa.ooov += einsum(tmp4, (0, 1), t1.aa, (2, 3), (2, 1, 0, 3))
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.abab.oooo += einsum(tmp4, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    tmp57 = einsum(t1.aa, (0, 1), tmp28, (0, 2), (2, 1))
    del tmp28
    tmp24 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2))
    rdm2.aaaa.oovo += tmp24.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.ooov += tmp24.transpose((2, 1, 0, 3)) * -2
    tmp79 = tmp32.copy() * 4
    del tmp32
    tmp79 += tmp31
    del tmp31
    tmp130 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    rdm2.bbbb.vvvv = einsum(tmp130, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.bbbb.vvvo = tmp130.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.bbbb.vvov = tmp130.transpose((2, 1, 0, 3)).copy() * -2
    del tmp130
    tmp132 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.bbbb.vvvv += tmp132.transpose((1, 0, 3, 2))
    rdm2.bbbb.vvvv += tmp132.transpose((1, 0, 3, 2))
    del tmp132
    tmp129 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    rdm2.abab.vvvv = einsum(tmp129, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.vvov = tmp129.transpose((1, 2, 0, 3)).copy()
    del tmp129
    tmp131 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa.vvvv = tmp131.transpose((1, 0, 3, 2)).copy()
    rdm2.aaaa.vvvv += tmp131.transpose((1, 0, 3, 2))
    del tmp131
    tmp128 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (3, 4), (2, 0, 1, 4))
    rdm2.aaaa.vvvv += einsum(t1.aa, (0, 1), tmp128, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    rdm2.aaaa.vvvo = tmp128.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.aaaa.vvov = tmp128.transpose((2, 1, 0, 3)).copy() * -2
    del tmp128
    tmp109 = tmp108.copy()
    tmp109 += tmp81
    tmp109 += tmp82 * 2
    rdm2.bbbb.vovv = einsum(tmp109, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vovv += einsum(tmp109, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvv = einsum(tmp109, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovvv += einsum(tmp109, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvv += einsum(tmp109, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vovo += einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.ovov += einsum(tmp109, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp109
    tmp125 = einsum(t1.bb, (0, 1), tmp86, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp86
    rdm2.bbbb.vovv += tmp125.transpose((2, 0, 3, 1)) * -1
    rdm2.bbbb.vovv += tmp125.transpose((2, 0, 1, 3))
    rdm2.bbbb.ovvv += tmp125.transpose((0, 2, 3, 1))
    del tmp125
    tmp123 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.bbbb.vovv += tmp123.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp123.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp123.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp123.transpose((0, 1, 3, 2)) * -1
    del tmp123
    tmp126 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    del tmp18
    rdm2.bbbb.vovv += tmp126.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp126.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp126.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp126.transpose((0, 1, 3, 2)) * -1
    del tmp126
    tmp127 = einsum(tmp111, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * -1
    del tmp111
    rdm2.bbbb.vovv += tmp127.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv += tmp127.transpose((0, 1, 3, 2)) * -2
    del tmp127
    tmp89 = tmp87.copy()
    tmp89 += tmp88
    del tmp88
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp89, (0, 2, 3, 4), (3, 2, 1, 4)) * 2
    rdm2.abab.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp89, (1, 4, 3, 5), (0, 4, 2, 5)) * 4
    del tmp89
    tmp114 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    rdm2.abab.vovv += einsum(t1.bb, (0, 1), tmp114, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    rdm2.abab.vovo += tmp114.transpose((2, 1, 3, 0)) * -1
    del tmp114
    tmp105 = tmp104.copy()
    tmp105 += tmp64 * 2
    tmp105 += tmp65
    rdm2.abab.vovv += einsum(tmp105, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovv = einsum(tmp105, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovvv = einsum(tmp105, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.vovo += einsum(tmp105, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovo += einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.voov += einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvo += einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovov += einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (0, 2, 1, 3))
    del tmp105
    tmp113 = einsum(t1.bb, (0, 1), tmp13, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp113, (0, 2, 3, 4), (3, 2, 1, 4)) * -1
    rdm2.abab.voov += tmp113.transpose((2, 1, 0, 3)) * -1
    del tmp113
    tmp119 = einsum(t1.aa, (0, 1), tmp118, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp118
    rdm2.aaaa.vovv += tmp119.transpose((2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += tmp119.transpose((2, 0, 1, 3))
    rdm2.aaaa.ovvv += tmp119.transpose((0, 2, 3, 1))
    del tmp119
    tmp115 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.aaaa.vovv += tmp115.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp115.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp115.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp115.transpose((0, 1, 3, 2)) * -1
    del tmp115
    tmp120 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    del tmp6
    rdm2.aaaa.vovv += tmp120.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp120.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp120.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp120.transpose((0, 1, 3, 2)) * -1
    del tmp120
    tmp121 = einsum(tmp107, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    del tmp107
    rdm2.aaaa.vovv += tmp121.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.ovvv += tmp121.transpose((0, 1, 3, 2)) * -2
    del tmp121
    tmp116 = tmp104.copy() * 0.5
    del tmp104
    tmp116 += tmp64
    tmp116 += tmp65 * 0.5
    rdm2.aaaa.vovv += einsum(tmp116, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.ovvv += einsum(tmp116, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -2
    del tmp116
    tmp124 = tmp84.copy()
    tmp124 += tmp85 * 4
    rdm2.bbbb.ovvv += einsum(tmp124, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * -1
    del tmp124
    tmp90 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp90, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ovov += tmp90.transpose((1, 2, 0, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp90, (0, 4, 3, 5), (4, 1, 2, 5))
    del tmp90
    tmp112 = einsum(t1.aa, (0, 1), tmp26, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ovvv += einsum(tmp112, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.abab.ovvo += tmp112.transpose((0, 3, 2, 1)) * -1
    del tmp112
    tmp122 = tmp71.copy()
    tmp122 += tmp69
    rdm2.abab.ovvv += einsum(tmp122, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    del tmp122
    tmp117 = tmp67.copy()
    tmp117 += tmp106 * 0.25
    del tmp106
    rdm2.aaaa.ovvv += einsum(tmp117, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -4
    del tmp117
    tmp110 = tmp108.copy() * 0.5
    del tmp108
    tmp110 += tmp81 * 0.5
    tmp110 += tmp82
    rdm2.bbbb.voov += einsum(tmp110, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.ovov += einsum(tmp110, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * 2
    del tmp110
    tmp98 = einsum(t1.bb, (0, 1), tmp49, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp49
    rdm2.bbbb.oovv = tmp98.transpose((0, 1, 3, 2)).copy() * -2
    rdm2.bbbb.oovv += tmp98 * 2
    del tmp98
    tmp97 = tmp35.copy()
    tmp97 += tmp36 * 2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp97, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.oovv += einsum(tmp97, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    del tmp97
    tmp48 = t1.bb.copy() * 0.5
    tmp48 += tmp35 * 0.5
    tmp48 += tmp36
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp48, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.ooov += einsum(tmp48, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    del tmp48
    tmp37 = t1.bb.copy()
    tmp37 += tmp35
    tmp37 += tmp36 * 2
    rdm2.bbbb.oovv += einsum(tmp37, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.abab.oovv += einsum(tmp37, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp37, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ooov += einsum(delta.aa.oo, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    del tmp37
    tmp96 = einsum(tmp84, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp84
    rdm2.bbbb.oovv += tmp96.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp96 * 2
    rdm2.bbbb.oovv += tmp96.transpose((1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp96.transpose((0, 1, 3, 2)) * -2
    del tmp96
    tmp103 = einsum(t1.bb, (0, 1), tmp102, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp102
    rdm2.bbbb.oovv += tmp103.transpose((0, 1, 3, 2))
    rdm2.bbbb.oovv += tmp103.transpose((1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp103 * -1
    rdm2.bbbb.oovv += tmp103.transpose((1, 0, 2, 3))
    del tmp103
    tmp100 = einsum(tmp54, (0, 1, 2, 3), t2.bbbb, (0, 1, 4, 5), (2, 3, 4, 5))
    rdm2.bbbb.oovv += tmp100.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp100.transpose((1, 0, 3, 2))
    del tmp100
    tmp42 = tmp39.copy() * 0.5
    tmp42 += tmp40
    tmp42 += tmp41
    del tmp41
    rdm2.bbbb.oovv += einsum(tmp42, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.bbbb.oovv += einsum(tmp42, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.abab.oovv += einsum(tmp42, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.bbbb.oovo += einsum(tmp42, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp42, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.abab.ooov += einsum(delta.aa.oo, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -2
    del tmp42
    tmp51 = tmp39.copy()
    del tmp39
    tmp51 += tmp40 * 2
    del tmp40
    tmp51 += tmp50
    del tmp50
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp51, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += einsum(tmp51, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp51, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp51, (2, 3), (2, 0, 1, 3))
    del tmp51
    tmp99 = einsum(tmp16, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    del tmp16
    rdm2.bbbb.oovv += tmp99.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp99.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp99.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp99.transpose((0, 1, 3, 2)) * -1
    del tmp99
    tmp95 = einsum(t2.abab, (0, 1, 2, 3), tmp87, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp87
    rdm2.bbbb.oovv += tmp95.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp95.transpose((0, 1, 3, 2)) * -2
    del tmp95
    tmp94 = einsum(tmp85, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp85
    rdm2.bbbb.oovv += tmp94 * 8
    rdm2.bbbb.oovv += tmp94.transpose((0, 1, 3, 2)) * -8
    del tmp94
    tmp93 = tmp81.copy()
    tmp93 += tmp82 * 2
    rdm2.bbbb.oovv += einsum(tmp93, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp93
    tmp83 = tmp81.copy() * 0.5
    del tmp81
    tmp83 += tmp82
    del tmp82
    rdm2.bbbb.oovv += einsum(tmp83, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 4
    rdm2.abab.oovv += einsum(tmp83, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp83
    tmp101 = einsum(tmp54, (0, 1, 2, 3), t1.bb, (0, 4), (1, 3, 2, 4))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp101, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp101
    tmp91 = tmp44.copy()
    del tmp44
    tmp91 += tmp43
    del tmp43
    rdm2.abab.oovv += einsum(tmp91, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -2
    del tmp91
    tmp59 = einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp59, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    rdm2.abab.oovo += tmp59.transpose((0, 2, 3, 1)) * -1
    del tmp59
    tmp38 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp38, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ooov += tmp38.transpose((1, 2, 0, 3)) * -1
    del tmp38
    tmp73 = tmp20.copy() * 2
    tmp73 += tmp21
    rdm2.abab.oovv += einsum(tmp73, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv = einsum(tmp73, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(tmp73, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    del tmp73
    tmp62 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 5, 3), (4, 5, 1, 2))
    del tmp26
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp62, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.abab.oovo += tmp62.transpose((0, 2, 3, 1))
    del tmp62
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp13
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp47, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ooov += tmp47.transpose((1, 2, 0, 3))
    del tmp47
    tmp75 = tmp64.copy() * 2
    tmp75 += tmp65
    rdm2.abab.oovv += einsum(tmp75, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    rdm2.aaaa.oovv += einsum(tmp75, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp75
    tmp46 = einsum(t1.bb, (0, 1), tmp45, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp45
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp46, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ooov += tmp46.transpose((1, 2, 0, 3))
    del tmp46
    tmp92 = tmp61.copy()
    del tmp61
    tmp92 += tmp60
    del tmp60
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp92, (2, 0, 3, 4), (2, 3, 4, 1)) * -2
    del tmp92
    tmp30 = tmp25.copy() * 2
    tmp30 += tmp27
    tmp30 += tmp29
    del tmp29
    rdm2.abab.oovv += einsum(tmp30, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(tmp30, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(tmp30, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3))
    rdm2.abab.oovo += einsum(tmp30, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.ooov += einsum(tmp30, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.aaaa.ooov += einsum(tmp30, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1))
    del tmp30
    tmp56 = t1.aa.copy()
    tmp56 += tmp20 * 2
    tmp56 += tmp21
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp56, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.oovo += einsum(tmp56, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp56, (2, 3), (2, 0, 3, 1))
    del tmp56
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp69
    rdm2.aaaa.oovv += tmp70 * 2
    rdm2.aaaa.oovv += tmp70.transpose((0, 1, 3, 2)) * -2
    del tmp70
    tmp77 = einsum(tmp33, (0, 1, 2, 3), t2.aaaa, (0, 1, 4, 5), (2, 3, 4, 5))
    rdm2.aaaa.oovv += tmp77.transpose((1, 0, 3, 2))
    rdm2.aaaa.oovv += tmp77.transpose((1, 0, 3, 2))
    del tmp77
    tmp23 = t1.aa.copy()
    tmp23 += tmp20 * 2
    tmp23 += tmp21
    rdm2.aaaa.oovv += einsum(tmp23, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    del tmp23
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), tmp4, (1, 4), (4, 0, 2, 3)) * -1
    del tmp4
    rdm2.aaaa.oovv += tmp76.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp76.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2)) * -1
    del tmp76
    tmp58 = tmp25.copy()
    del tmp25
    tmp58 += tmp27 * 0.5
    del tmp27
    tmp58 += tmp57
    del tmp57
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp58, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.aaaa.oovv += einsum(tmp58, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp58, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp58, (2, 3), (2, 0, 3, 1)) * -2
    del tmp58
    tmp74 = einsum(t1.aa, (0, 1), tmp24, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp24
    rdm2.aaaa.oovv += tmp74.transpose((0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += tmp74 * 2
    del tmp74
    tmp68 = einsum(t2.aaaa, (0, 1, 2, 3), tmp67, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp67
    rdm2.aaaa.oovv += tmp68 * 8
    rdm2.aaaa.oovv += tmp68.transpose((0, 1, 3, 2)) * -8
    del tmp68
    tmp80 = einsum(t1.aa, (0, 1), tmp79, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp79
    rdm2.aaaa.oovv += tmp80.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp80.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp80 * -1
    rdm2.aaaa.oovv += tmp80.transpose((1, 0, 2, 3))
    del tmp80
    tmp66 = tmp64.copy()
    del tmp64
    tmp66 += tmp65 * 0.5
    del tmp65
    rdm2.aaaa.oovv += einsum(tmp66, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    del tmp66
    tmp72 = einsum(t2.abab, (0, 1, 2, 3), tmp71, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp71
    rdm2.aaaa.oovv += tmp72.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += tmp72 * 2
    rdm2.aaaa.oovv += tmp72.transpose((1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp72.transpose((0, 1, 3, 2)) * -2
    del tmp72
    tmp78 = einsum(t1.aa, (0, 1), tmp33, (0, 2, 3, 4), (2, 4, 3, 1))
    rdm2.aaaa.oovv += einsum(tmp78, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    del tmp78
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * 2
    del tmp54
    rdm2.bbbb.oovo += tmp55.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov += tmp55.transpose((2, 1, 0, 3))
    del tmp55
    tmp63 = t1.bb.copy()
    tmp63 += tmp35
    del tmp35
    tmp63 += tmp36 * 2
    del tmp36
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp63, (2, 3), (2, 0, 3, 1))
    del tmp63
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * 2
    del tmp33
    rdm2.aaaa.oovo += tmp34.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.ooov += tmp34.transpose((2, 1, 0, 3))
    del tmp34
    tmp22 = t1.aa.copy() * 0.5
    tmp22 += tmp20
    del tmp20
    tmp22 += tmp21 * 0.5
    del tmp21
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -2
    del tmp22
    tmp15 = delta.bb.oo.copy() * -0.5
    tmp15 += tmp8 * 0.5
    tmp15 += tmp9 * 0.5
    tmp15 += tmp10
    rdm2.bbbb.oooo += einsum(tmp15, (0, 1), delta.bb.oo, (2, 3), (2, 1, 3, 0)) * -2
    del tmp15
    tmp11 = delta.bb.oo.copy() * -1
    tmp11 += tmp8
    del tmp8
    tmp11 += tmp9
    del tmp9
    tmp11 += tmp10 * 2
    del tmp10
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp11, (2, 3), (3, 0, 1, 2))
    rdm2.abab.oooo += einsum(delta.aa.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -1
    del tmp11
    tmp3 = delta.aa.oo.copy() * -0.5
    tmp3 += tmp0 * 0.5
    del tmp0
    tmp3 += tmp1
    del tmp1
    tmp3 += tmp2 * 0.5
    del tmp2
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -2
    del tmp3
    rdm2.aaaa.ovoo += einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovoo += einsum(l1.bb, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vooo += einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.abab.vooo += einsum(l1.aa, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    del delta
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.abab.oovv += t2.abab
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.aaaa.ovov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovvo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvo += einsum(l1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovvo += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.voov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.voov += einsum(l1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovo += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vvoo = l2.aaaa.copy()
    rdm2.aaaa.vvoo += l2.aaaa
    rdm2.abab.vvoo = l2.abab.copy()
    rdm2.bbbb.vvoo = l2.bbbb.copy()
    rdm2.bbbb.vvoo += l2.bbbb
    rdm2.abab.ovvv += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.abab.vovv += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4))
    rdm2.abab.vvvo = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    rdm2.abab.vvvv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=rdm2.aaaa.swapaxes(1, 2),
        aabb=rdm2.abab.swapaxes(1, 2),
        bbbb=rdm2.bbbb.swapaxes(1, 2),
    )

    return rdm2

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:40:18.419225.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    r1new = Namespace()
    r2new = Namespace()
    tmp9 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp9 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp5 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp5 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp8 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp10 = einsum(tmp9, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp9
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp5
    tmp4 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp11 = f.bb.ov.copy()
    tmp11 += tmp8
    tmp11 += tmp10 * -1
    del tmp10
    r1new.b = einsum(tmp11, (0, 1), r2.bbb, (2, 0, 1), (2,)) * 2
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp11, (0, 2), (1,)) * -1
    tmp145 = v.bbbb.ooov.copy()
    tmp145 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp137 = v.bbbb.ooov.copy() * -1
    tmp137 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp70 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp70 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp62 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp62 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp80 = v.aaaa.ooov.copy()
    tmp80 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp7 = f.aa.ov.copy()
    tmp7 += tmp4
    tmp7 += tmp6 * -1
    del tmp6
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp7, (0, 2), (1,)) * -1
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp7, (1, 2), (0,)) * 2
    tmp64 = v.aaaa.ooov.copy()
    tmp64 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp205 = v.bbbb.ovvv.copy() * -1
    tmp205 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp164 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp165 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 3, 1), (4, 0)) * -1
    tmp219 = einsum(tmp11, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp20 = einsum(r1.b, (0,), v.bbbb.ovov, (1, 2, 0, 3), (1, 2, 3))
    r1new.b += einsum(t2.bbbb, (0, 1, 2, 3), tmp20, (1, 2, 3), (0,)) * 2
    tmp146 = einsum(t1.bb, (0, 1), tmp145, (0, 2, 3, 1), (2, 3))
    tmp144 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp208 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp138 = einsum(r1.b, (0,), tmp137, (0, 1, 2, 3), (1, 2, 3))
    del tmp137
    tmp244 = einsum(r2.bbb, (0, 1, 2), tmp70, (1, 3, 4, 2), (0, 3, 4)) * -1
    tmp135 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    r2new.bbb = tmp135.transpose((1, 0, 2)).copy()
    r2new.bbb += tmp135 * -1
    tmp90 = einsum(tmp70, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp87 = einsum(tmp62, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp81 = einsum(t1.aa, (0, 1), tmp80, (0, 2, 3, 1), (2, 3))
    del tmp80
    tmp79 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp25 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    tmp123 = einsum(tmp7, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp113 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp114 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp46 = v.aaaa.ovvv.copy()
    tmp46 += v.aaaa.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp63 = einsum(tmp62, (0, 1, 2, 3), r2.aaa, (4, 0, 3), (4, 1, 2)) * -1
    tmp33 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 4, 0, 2), (1, 3, 4)) * -1
    r2new.aaa = tmp33.transpose((1, 0, 2)).copy() * -1
    r2new.aaa += tmp33
    tmp65 = einsum(r1.a, (0,), tmp64, (0, 1, 2, 3), (1, 2, 3))
    tmp14 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp1 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3))
    r1new.a += einsum(tmp1, (0, 1, 2), t2.aaaa, (3, 0, 2, 1), (3,)) * -2
    tmp54 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (0, 2, 3, 1), (2, 3))
    tmp41 = v.aaaa.ovvv.copy() * -1
    tmp41 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    tmp177 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp230 = einsum(t1.bb, (0, 1), tmp205, (0, 1, 2, 3), (2, 3))
    tmp217 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp220 = tmp164.transpose((1, 0)).copy() * 0.5
    tmp220 += tmp165.transpose((1, 0))
    tmp220 += tmp219.transpose((1, 0))
    tmp154 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp19 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    r1new.b += einsum(t2.abab, (0, 1, 2, 3), tmp19, (0, 2, 3), (1,)) * -1
    tmp227 = einsum(tmp20, (0, 1, 2), t1.bb, (3, 1), (3, 0, 2))
    tmp195 = v.bbbb.ooov.copy()
    tmp195 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp147 = f.bb.oo.copy()
    tmp147 += tmp144.transpose((1, 0))
    tmp147 += tmp146.transpose((1, 0)) * -1
    del tmp146
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp147, (1, 3), (0, 3, 2)) * -2
    r2new.aba = einsum(r2.aba, (0, 1, 2), tmp147, (1, 3), (0, 3, 2)) * -1
    tmp142 = einsum(r2.aba, (0, 1, 2), tmp62, (0, 3, 2, 4), (3, 1, 4))
    del tmp62
    tmp140 = einsum(r1.b, (0,), v.aabb.ovoo, (1, 2, 3, 0), (1, 3, 2))
    r2new.aba += tmp140
    tmp141 = einsum(r2.bbb, (0, 1, 2), v.aabb.ovov, (3, 4, 1, 2), (3, 0, 4))
    tmp209 = f.bb.vv.copy()
    tmp209 += tmp208.transpose((1, 0))
    del tmp208
    tmp52 = t2.abab.copy()
    tmp52 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp207 = t2.bbbb.copy() * 2
    tmp207 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp245 = tmp135.copy()
    tmp245 += tmp244 * 2
    del tmp244
    tmp245 += tmp138 * -1
    tmp193 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp248 = einsum(t1.bb, (0, 1), tmp11, (0, 2), (1, 2))
    tmp192 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp224 = einsum(r1.b, (0,), v.bbbb.ovvv, (0, 1, 2, 3), (1, 2, 3))
    tmp91 = f.bb.ov.copy()
    tmp91 += tmp8
    tmp91 += tmp90 * -1
    del tmp90
    tmp88 = f.aa.ov.copy()
    tmp88 += tmp4
    tmp88 += tmp87 * -1
    del tmp87
    tmp189 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (1, 3, 4, 2), (0, 4, 3)) * -1
    tmp188 = einsum(r1.a, (0,), v.aabb.ovoo, (0, 1, 2, 3), (2, 3, 1))
    tmp0 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.a, (0,), (2, 1, 3))
    r1new.a += einsum(t2.abab, (0, 1, 2, 3), tmp0, (1, 2, 3), (0,)) * -1
    tmp69 = einsum(r2.aaa, (0, 1, 2), v.aabb.ovov, (1, 2, 3, 4), (0, 3, 4))
    tmp68 = einsum(r1.a, (0,), v.aabb.ooov, (1, 0, 2, 3), (1, 2, 3))
    r2new.bab = tmp68.transpose((1, 0, 2)).copy()
    tmp71 = einsum(r2.bab, (0, 1, 2), tmp70, (0, 3, 2, 4), (1, 3, 4)) * -1
    del tmp70
    tmp82 = f.aa.oo.copy()
    tmp82 += tmp79.transpose((1, 0))
    tmp82 += tmp81.transpose((1, 0)) * -1
    del tmp81
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp82, (1, 3), (0, 3, 2)) * -1
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp82, (1, 3), (0, 3, 2)) * -2
    tmp21 = r2.aba.copy()
    tmp21 += einsum(r1.b, (0,), t1.aa, (1, 2), (1, 0, 2)) * -1
    r1new.b += einsum(tmp21, (0, 1, 2), v.aabb.ovoo, (0, 2, 3, 1), (3,))
    tmp22 = r2.bbb.copy() * 2
    tmp22 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2)) * -1
    r1new.b += einsum(v.bbbb.ooov, (0, 1, 2, 3), tmp22, (1, 2, 3), (0,)) * -1
    tmp26 = f.bb.ov.copy()
    tmp26 += tmp25 * -1
    del tmp25
    tmp31 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp121 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp150 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (3, 2, 1, 4), (0, 3, 4))
    tmp149 = einsum(r1.b, (0,), v.aabb.ooov, (1, 2, 0, 3), (1, 2, 3))
    tmp76 = einsum(tmp7, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp75 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp74 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp124 = tmp113.transpose((1, 0)).copy() * 2
    tmp124 += tmp114.transpose((1, 0))
    tmp124 += tmp123.transpose((1, 0))
    del tmp123
    r2new.bab += einsum(tmp124, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.aba += einsum(tmp124, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    tmp45 = einsum(r2.bab, (0, 1, 2), v.aabb.vvov, (3, 4, 0, 2), (1, 3, 4)) * -1
    tmp47 = einsum(tmp46, (0, 1, 2, 3), r2.aaa, (4, 0, 2), (4, 1, 3)) * -1
    del tmp46
    tmp115 = einsum(tmp7, (0, 1), t1.aa, (2, 1), (2, 0)) * 0.5
    tmp66 = tmp33.copy()
    tmp66 += tmp63 * 2
    tmp66 += tmp65 * -1
    tmp15 = f.aa.ov.copy()
    tmp15 += tmp14
    tmp3 = r2.aaa.copy() * 2
    tmp3 += einsum(r1.a, (0,), t1.aa, (1, 2), (1, 0, 2)) * -1
    r1new.a += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp3, (2, 1, 3), (0,))
    tmp2 = r2.bab.transpose((1, 0, 2)).copy() * -1
    tmp2 += einsum(r1.a, (0,), t1.bb, (1, 2), (0, 1, 2))
    r1new.a += einsum(tmp2, (0, 1, 2), v.aabb.ooov, (3, 0, 1, 2), (3,)) * -1
    tmp37 = einsum(tmp1, (0, 1, 2), t1.aa, (3, 1), (3, 0, 2))
    tmp55 = f.aa.vv.copy()
    tmp55 += tmp54 * -1
    del tmp54
    tmp50 = t2.aaaa.copy() * 2
    tmp50 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp42 = einsum(t1.aa, (0, 1), tmp41, (0, 1, 2, 3), (2, 3))
    del tmp41
    tmp40 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp34 = einsum(r1.a, (0,), v.aaaa.ovvv, (0, 1, 2, 3), (1, 2, 3))
    tmp231 = f.bb.vv.copy()
    tmp231 += tmp177.transpose((1, 0))
    tmp231 += tmp230.transpose((1, 0)) * -1
    del tmp230
    tmp258 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp218 = einsum(t2.bbbb, (0, 1, 2, 3), tmp217, (4, 0, 1, 3), (4, 2)) * -1
    tmp266 = einsum(t1.bb, (0, 1), tmp220, (0, 2), (2, 1)) * 2
    tmp216 = einsum(t2.abab, (0, 1, 2, 3), tmp154, (0, 4, 1, 2), (4, 3))
    tmp251 = einsum(r1.b, (0,), v.bbbb.oooo, (1, 2, 3, 0), (1, 2, 3))
    tmp252 = einsum(r2.aba, (0, 1, 2), v.aabb.ovoo, (0, 2, 3, 4), (1, 3, 4))
    tmp162 = tmp20.copy()
    tmp162 += tmp20.transpose((0, 2, 1)) * -1
    tmp268 = tmp20.copy()
    tmp268 += tmp20.transpose((0, 2, 1)) * -1
    tmp180 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp234 = v.bbbb.ovvv.copy()
    tmp234 += v.bbbb.ovvv.transpose((0, 2, 1, 3)) * -1
    tmp233 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.aba, (0, 4, 1), (4, 2, 3))
    tmp156 = einsum(tmp19, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    r2new.aba += einsum(tmp156, (0, 1, 2), t2.aaaa, (3, 0, 4, 2), (3, 1, 4)) * 2
    tmp228 = einsum(t1.bb, (0, 1), tmp227, (2, 3, 1), (2, 0, 3))
    del tmp227
    tmp240 = r2.bbb.copy()
    tmp240 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2)) * -1
    tmp196 = einsum(t1.bb, (0, 1), tmp195, (0, 2, 3, 1), (2, 3))
    tmp200 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp201 = einsum(t1.bb, (0, 1), tmp147, (0, 2), (2, 1))
    del tmp147
    tmp199 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3))
    tmp262 = tmp164.copy() * 0.5
    tmp262 += tmp165
    tmp262 += tmp219
    del tmp219
    tmp143 = tmp140.copy() * -1
    del tmp140
    tmp143 += tmp141 * 2
    del tmp141
    tmp143 += tmp142 * -1
    del tmp142
    r2new.aba += einsum(tmp143, (0, 1, 2), t2.aaaa, (3, 0, 4, 2), (3, 1, 4)) * -2
    tmp238 = einsum(tmp209, (0, 1), t1.bb, (2, 0), (2, 1)) * 0.5
    tmp236 = einsum(tmp52, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4)) * 0.5
    tmp237 = einsum(tmp207, (0, 1, 2, 3), v.bbbb.ovvv, (0, 3, 4, 2), (1, 4)) * 0.5
    tmp264 = einsum(t1.bb, (0, 1), tmp245, (2, 3, 1), (2, 3, 0))
    tmp249 = tmp192.transpose((1, 0)).copy()
    tmp249 += tmp193.transpose((1, 0)) * 2
    tmp249 += tmp248.transpose((1, 0))
    del tmp248
    tmp225 = einsum(t1.bb, (0, 1), tmp224, (2, 3, 1), (0, 2, 3))
    tmp133 = einsum(t1.bb, (0, 1), r1.b, (2,), (2, 0, 1))
    tmp133 += r2.bbb * 2
    r2new.aba += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp133, (2, 4, 3), (0, 4, 1))
    tmp186 = einsum(tmp91, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp185 = einsum(t2.abab, (0, 1, 2, 3), tmp88, (0, 2), (1, 3))
    tmp111 = einsum(t1.aa, (0, 1), r1.a, (2,), (2, 0, 1))
    tmp111 += r2.aaa * 2
    r2new.bab += einsum(tmp111, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (3, 1, 4))
    tmp109 = tmp1.copy() * -1
    tmp109 += tmp1.transpose((0, 2, 1))
    tmp166 = einsum(tmp11, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp178 = v.bbbb.ovvv.copy() * -1
    tmp178 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp212 = tmp188.transpose((1, 0, 2)).copy()
    tmp212 += tmp189
    tmp203 = einsum(tmp0, (0, 1, 2), t1.bb, (3, 2), (3, 0, 1))
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp203, (4, 1, 2), (4, 0, 3)) * -1
    tmp72 = tmp68.copy() * -1
    del tmp68
    tmp72 += tmp69 * 2
    del tmp69
    tmp72 += tmp71 * -1
    del tmp71
    r2new.bab += einsum(tmp72, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 0, 4)) * -2
    tmp131 = v.aaaa.ovvv.copy() * -1
    tmp131 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    tmp96 = einsum(t1.aa, (0, 1), tmp82, (0, 2), (2, 1))
    del tmp82
    tmp95 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp94 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp158 = v.aaaa.ovvv.copy()
    tmp158 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp92 = einsum(tmp91, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp91
    tmp89 = einsum(t2.aaaa, (0, 1, 2, 3), tmp88, (1, 3), (0, 2))
    del tmp88
    tmp136 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp136 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp98 = einsum(tmp64, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp23 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp21, (0, 2, 1), (3,))
    tmp24 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp22, (0, 2, 1), (3,))
    tmp27 = einsum(r1.b, (0,), tmp26, (0, 1), (1,))
    tmp120 = einsum(t2.aaaa, (0, 1, 2, 3), tmp31, (4, 0, 1, 3), (4, 2)) * -1
    tmp122 = einsum(tmp121, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    del tmp121
    tmp168 = tmp149.transpose((1, 0, 2)).copy()
    tmp168 += tmp150 * -1
    tmp77 = tmp74.transpose((1, 0)).copy() * 2
    tmp77 += tmp75.transpose((1, 0))
    tmp77 += tmp76.transpose((1, 0))
    del tmp76
    tmp103 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp125 = einsum(tmp124, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp48 = tmp1.copy() * 0.5
    tmp48 += tmp45.transpose((0, 2, 1)) * 0.5
    del tmp45
    tmp48 += tmp47.transpose((0, 2, 1))
    del tmp47
    tmp116 = tmp113.copy()
    del tmp113
    tmp116 += tmp114 * 0.5
    del tmp114
    tmp116 += tmp115
    del tmp115
    tmp59 = r2.aaa.copy()
    tmp59 += einsum(r1.a, (0,), t1.aa, (1, 2), (1, 0, 2)) * -1
    tmp105 = einsum(tmp0, (0, 1, 2), t1.aa, (3, 1), (3, 0, 2))
    del tmp0
    r2new.bab += einsum(t2.bbbb, (0, 1, 2, 3), tmp105, (4, 1, 3), (0, 4, 2)) * 2
    tmp118 = einsum(tmp66, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    tmp16 = einsum(r1.a, (0,), tmp15, (0, 1), (1,)) * 0.5
    tmp12 = einsum(tmp3, (0, 1, 2), v.aaaa.ovov, (0, 3, 1, 2), (3,)) * 0.5
    tmp13 = einsum(tmp2, (0, 1, 2), v.aabb.ovov, (0, 3, 1, 2), (3,)) * 0.5
    tmp38 = einsum(t1.aa, (0, 1), tmp37, (2, 3, 1), (2, 0, 3))
    del tmp37
    tmp127 = tmp1.copy() * -1
    tmp127 += tmp1.transpose((0, 2, 1))
    del tmp1
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (1, 2), (0, 2)) * 0.5
    tmp51 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp50, (0, 4, 1, 3), (4, 2)) * 0.5
    tmp53 = einsum(v.aabb.vvov, (0, 1, 2, 3), tmp52, (4, 2, 1, 3), (4, 0)) * 0.5
    tmp43 = f.aa.vv.copy()
    tmp43 += tmp40.transpose((1, 0))
    tmp43 += tmp42.transpose((1, 0)) * -1
    del tmp42
    tmp83 = einsum(r1.a, (0,), v.aaaa.oooo, (1, 2, 3, 0), (1, 2, 3))
    tmp84 = einsum(r2.bab, (0, 1, 2), v.aabb.ooov, (3, 4, 0, 2), (1, 3, 4)) * -1
    tmp85 = v.aaaa.ooov.copy() * -1
    tmp85 += v.aaaa.ooov.transpose((0, 2, 1, 3))
    tmp35 = einsum(t1.aa, (0, 1), tmp34, (2, 3, 1), (0, 2, 3))
    tmp100 = v.aaaa.ooov.copy() * -1
    tmp100 += v.aaaa.ooov.transpose((0, 2, 1, 3))
    tmp232 = einsum(r2.bbb, (0, 1, 2), tmp231, (2, 3), (0, 1, 3))
    del tmp231
    r2new.bbb += tmp232.transpose((1, 0, 2)) * -1
    r2new.bbb += tmp232.transpose((1, 0, 2)) * -1
    del tmp232
    tmp259 = einsum(r2.bbb, (0, 1, 2), tmp258, (3, 4, 0, 1), (3, 4, 2))
    del tmp258
    r2new.bbb += tmp259 * -2
    r2new.bbb += tmp259.transpose((1, 0, 2)) * 2
    del tmp259
    tmp223 = einsum(t1.bb, (0, 1), tmp217, (2, 3, 4, 1), (2, 0, 4, 3))
    del tmp217
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp223, (3, 4, 1, 0), (4, 3, 2)) * 2
    del tmp223
    tmp267 = tmp216.copy()
    tmp267 += tmp218 * 2
    tmp267 += tmp266
    del tmp266
    r2new.bbb += einsum(r1.b, (0,), tmp267, (1, 2), (1, 0, 2))
    r2new.bbb += einsum(tmp267, (0, 1), r1.b, (2,), (2, 0, 1)) * -1
    del tmp267
    tmp255 = tmp251.transpose((1, 0, 2)).copy()
    tmp255 += tmp252.transpose((2, 0, 1)) * -1
    tmp255 += einsum(r2.bbb, (0, 1, 2), tmp195, (1, 3, 4, 2), (4, 0, 3)) * -2
    r2new.bbb += einsum(t1.bb, (0, 1), tmp255, (0, 2, 3), (3, 2, 1))
    del tmp255
    tmp257 = einsum(r1.b, (0,), v.bbbb.ooov, (1, 0, 2, 3), (1, 2, 3))
    r2new.bbb += tmp257.transpose((1, 0, 2))
    r2new.bbb += tmp257 * -1
    del tmp257
    tmp163 = einsum(tmp162, (0, 1, 2), t1.bb, (3, 1), (3, 0, 2))
    del tmp162
    r2new.bbb += einsum(tmp163, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 0, 4)) * -2
    r2new.aba += einsum(tmp163, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 0, 4)) * -1
    del tmp163
    tmp269 = einsum(t1.bb, (0, 1), tmp268, (2, 1, 3), (0, 2, 3)) * -1
    del tmp268
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp269, (4, 1, 3), (4, 0, 2)) * -2
    del tmp269
    tmp181 = f.bb.ov.copy()
    tmp181 += tmp8
    del tmp8
    tmp181 += tmp180
    del tmp180
    r2new.bbb += einsum(tmp181, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.bbb += einsum(tmp181, (0, 1), r1.b, (2,), (2, 0, 1))
    r2new.bab += einsum(tmp181, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp181
    tmp242 = tmp20.copy()
    tmp242 += tmp233.transpose((0, 2, 1)) * -1
    tmp242 += einsum(tmp234, (0, 1, 2, 3), r2.bbb, (4, 0, 2), (4, 3, 1)) * -2
    r2new.bbb += einsum(tmp242, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    del tmp242
    tmp222 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (4, 2, 3), (4, 0, 1))
    r2new.bbb += tmp222.transpose((1, 0, 2)) * -2
    r2new.bbb += tmp222 * 2
    del tmp222
    tmp260 = einsum(t2.abab, (0, 1, 2, 3), tmp156, (0, 4, 2), (4, 1, 3))
    r2new.bbb += tmp260 * -1
    r2new.bbb += tmp260.transpose((1, 0, 2))
    del tmp260
    tmp229 = einsum(t1.bb, (0, 1), tmp228, (2, 3, 0), (3, 2, 1))
    del tmp228
    r2new.bbb += tmp229.transpose((1, 0, 2)) * -1
    r2new.bbb += tmp229
    del tmp229
    tmp241 = tmp224.transpose((0, 2, 1)).copy()
    del tmp224
    tmp241 += einsum(tmp240, (0, 1, 2), v.bbbb.ovov, (0, 3, 1, 4), (4, 3, 2))
    del tmp240
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp241, (2, 3, 4), (0, 1, 4)) * -2
    del tmp241
    tmp197 = f.bb.oo.copy()
    tmp197 += tmp144.transpose((1, 0))
    del tmp144
    tmp197 += tmp196.transpose((1, 0)) * -1
    del tmp196
    r2new.bbb += einsum(tmp197, (0, 1), r2.bbb, (2, 0, 3), (1, 2, 3)) * 2
    r2new.bab += einsum(tmp197, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    del tmp197
    tmp254 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp21, (0, 2, 1), (3,)) * -0.5
    tmp254 += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp22, (0, 2, 1), (3,)) * -0.5
    del tmp22
    tmp254 += einsum(r1.b, (0,), tmp26, (0, 1), (1,)) * 0.5
    del tmp26
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp254, (3,), (0, 1, 2)) * 4
    del tmp254
    tmp202 = tmp199.copy()
    del tmp199
    tmp202 += tmp200 * 2
    del tmp200
    tmp202 += tmp201
    del tmp201
    r2new.bbb += einsum(r1.b, (0,), tmp202, (1, 2), (1, 0, 2))
    r2new.bbb += einsum(r1.b, (0,), tmp202, (1, 2), (0, 1, 2)) * -1
    r2new.bab += einsum(r1.a, (0,), tmp202, (1, 2), (1, 0, 2))
    del tmp202
    tmp211 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    r2new.bbb += einsum(r1.b, (0,), tmp211, (1, 2), (0, 1, 2)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp211, (1, 2), (1, 0, 2))
    r2new.bab += einsum(r1.a, (0,), tmp211, (1, 2), (1, 0, 2))
    del tmp211
    tmp263 = einsum(r2.bbb, (0, 1, 2), tmp262, (3, 1), (3, 0, 2)) * -4
    del tmp262
    r2new.bbb += tmp263 * -1
    r2new.bbb += tmp263.transpose((1, 0, 2))
    del tmp263
    tmp247 = einsum(tmp143, (0, 1, 2), t2.abab, (0, 3, 2, 4), (3, 1, 4))
    r2new.bbb += tmp247.transpose((1, 0, 2))
    r2new.bbb += tmp247 * -1
    del tmp247
    tmp256 = einsum(tmp7, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3)) * 0.5
    tmp256 += einsum(t2.bbbb, (0, 1, 2, 3), tmp11, (1, 3), (0, 2))
    r2new.bbb += einsum(r1.b, (0,), tmp256, (1, 2), (0, 1, 2)) * 2
    del tmp256
    tmp253 = tmp251.transpose((1, 0, 2)).copy() * 0.5
    del tmp251
    tmp253 += tmp252.transpose((2, 0, 1)) * -0.5
    del tmp252
    tmp253 += einsum(tmp145, (0, 1, 2, 3), r2.bbb, (4, 0, 3), (2, 4, 1)) * -1
    del tmp145
    r2new.bbb += einsum(tmp253, (0, 1, 2), t1.bb, (0, 3), (1, 2, 3)) * -2
    del tmp253
    tmp243 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oooo, (3, 1, 4, 0), (3, 4, 2)) * -1
    r2new.bbb += tmp243.transpose((1, 0, 2)) * -1
    r2new.bbb += tmp243.transpose((1, 0, 2)) * -1
    del tmp243
    tmp239 = tmp236.copy()
    del tmp236
    tmp239 += tmp237 * -1
    del tmp237
    tmp239 += tmp238
    del tmp238
    r2new.bbb += einsum(r1.b, (0,), tmp239, (1, 2), (0, 1, 2)) * 2
    r2new.bbb += einsum(r1.b, (0,), tmp239, (1, 2), (1, 0, 2)) * -2
    del tmp239
    tmp265 = einsum(t1.bb, (0, 1), tmp264, (2, 0, 3), (3, 2, 1))
    del tmp264
    r2new.bbb += tmp265 * -1
    r2new.bbb += tmp265.transpose((1, 0, 2))
    del tmp265
    tmp250 = einsum(r2.bbb, (0, 1, 2), tmp249, (2, 3), (0, 1, 3))
    del tmp249
    r2new.bbb += tmp250.transpose((1, 0, 2))
    r2new.bbb += tmp250.transpose((1, 0, 2))
    del tmp250
    tmp246 = einsum(t2.bbbb, (0, 1, 2, 3), tmp245, (4, 1, 3), (4, 0, 2))
    del tmp245
    r2new.bbb += tmp246 * -2
    r2new.bbb += tmp246.transpose((1, 0, 2)) * 2
    del tmp246
    tmp226 = einsum(t1.bb, (0, 1), tmp225, (2, 1, 3), (0, 2, 3))
    del tmp225
    r2new.bbb += tmp226.transpose((1, 0, 2))
    r2new.bbb += tmp226 * -1
    del tmp226
    tmp261 = einsum(v.bbbb.oovv, (0, 1, 2, 3), tmp133, (1, 4, 3), (0, 4, 2))
    r2new.bbb += tmp261.transpose((1, 0, 2))
    r2new.bbb += tmp261 * -1
    del tmp261
    tmp235 = tmp20.copy() * 0.5
    del tmp20
    tmp235 += tmp233.transpose((0, 2, 1)) * -0.5
    del tmp233
    tmp235 += einsum(tmp234, (0, 1, 2, 3), r2.bbb, (4, 0, 2), (4, 3, 1)) * -1
    del tmp234
    r2new.bbb += einsum(tmp235, (0, 1, 2), t1.bb, (3, 2), (3, 0, 1)) * -2
    del tmp235
    tmp187 = tmp185.copy()
    del tmp185
    tmp187 += tmp186 * 2
    del tmp186
    r2new.bbb += einsum(tmp187, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.bab += einsum(tmp187, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp187
    tmp155 = einsum(tmp154, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    del tmp154
    r2new.bab += einsum(tmp155, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    r2new.aba += einsum(tmp155, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp155
    tmp206 = einsum(tmp205, (0, 1, 2, 3), r2.bab, (0, 4, 1), (4, 3, 2))
    del tmp205
    tmp206 += einsum(tmp111, (0, 1, 2), v.aabb.ovvv, (0, 2, 3, 4), (1, 3, 4)) * -1
    r2new.bab += einsum(t1.bb, (0, 1), tmp206, (2, 1, 3), (0, 2, 3)) * -1
    del tmp206
    tmp110 = einsum(tmp109, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    del tmp109
    r2new.bab += einsum(tmp110, (0, 1, 2), t2.abab, (1, 3, 2, 4), (3, 0, 4)) * -1
    r2new.aaa += einsum(tmp110, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 0, 4)) * -2
    del tmp110
    tmp190 = tmp188.transpose((1, 0, 2)).copy()
    del tmp188
    tmp190 += tmp189.transpose((1, 0, 2))
    del tmp189
    r2new.bab += einsum(tmp190, (0, 1, 2), t2.abab, (3, 0, 2, 4), (1, 3, 4)) * -1
    del tmp190
    tmp167 = tmp164.transpose((1, 0)).copy()
    del tmp164
    tmp167 += tmp165.transpose((1, 0)) * 2
    del tmp165
    tmp167 += tmp166.transpose((1, 0))
    del tmp166
    r2new.bab += einsum(tmp167, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp167, (1, 3), (0, 3, 2)) * -1
    del tmp167
    tmp191 = einsum(tmp3, (0, 1, 2), v.aaaa.ovov, (0, 3, 1, 2), (3,))
    del tmp3
    tmp191 += einsum(tmp2, (0, 1, 2), v.aabb.ovov, (0, 3, 1, 2), (3,))
    tmp191 += einsum(r1.a, (0,), tmp15, (0, 1), (1,))
    del tmp15
    r2new.bab += einsum(tmp191, (0,), t2.abab, (1, 2, 0, 3), (2, 1, 3))
    del tmp191
    tmp183 = tmp33.transpose((1, 0, 2)).copy()
    del tmp33
    tmp183 += tmp63.transpose((1, 0, 2)) * 2
    del tmp63
    tmp183 += tmp65.transpose((1, 0, 2)) * -1
    del tmp65
    r2new.bab += einsum(tmp183, (0, 1, 2), t2.abab, (0, 3, 2, 4), (3, 1, 4)) * -1
    del tmp183
    tmp170 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    r2new.bab += einsum(tmp170, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    r2new.aba += einsum(tmp170, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp170
    tmp194 = tmp192.transpose((1, 0)).copy() * 0.5
    del tmp192
    tmp194 += tmp193.transpose((1, 0))
    del tmp193
    tmp194 += einsum(tmp11, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    r2new.bab += einsum(tmp194, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -2
    del tmp194
    tmp210 = einsum(tmp52, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp210 += einsum(tmp207, (0, 1, 2, 3), v.bbbb.ovvv, (0, 3, 4, 2), (1, 4)) * -1
    del tmp207
    tmp210 += einsum(tmp209, (0, 1), t1.bb, (2, 0), (2, 1))
    del tmp209
    r2new.bab += einsum(r1.a, (0,), tmp210, (1, 2), (1, 0, 2)) * -1
    del tmp210
    tmp221 = tmp216.copy() * 0.5
    del tmp216
    tmp221 += tmp218
    del tmp218
    tmp221 += einsum(t1.bb, (0, 1), tmp220, (0, 2), (2, 1))
    del tmp220
    r2new.bab += einsum(r1.a, (0,), tmp221, (1, 2), (1, 0, 2)) * 2
    del tmp221
    tmp161 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp161, (3, 1, 4, 0), (4, 3, 2))
    r2new.aba += einsum(tmp161, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp161
    tmp179 = f.bb.vv.copy()
    tmp179 += tmp177.transpose((1, 0))
    del tmp177
    tmp179 += einsum(t1.bb, (0, 1), tmp178, (0, 1, 2, 3), (3, 2)) * -1
    del tmp178
    r2new.bab += einsum(tmp179, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1))
    del tmp179
    tmp213 = einsum(tmp212, (0, 1, 2), t1.aa, (3, 2), (3, 1, 0))
    del tmp212
    r2new.bab += einsum(t1.bb, (0, 1), tmp213, (2, 0, 3), (3, 2, 1)) * -1
    del tmp213
    tmp198 = einsum(r2.aaa, (0, 1, 2), v.aabb.ovoo, (1, 2, 3, 4), (0, 3, 4)) * 2
    tmp198 += einsum(tmp195, (0, 1, 2, 3), r2.bab, (0, 4, 3), (4, 2, 1))
    del tmp195
    r2new.bab += einsum(t1.bb, (0, 1), tmp198, (2, 0, 3), (3, 2, 1))
    del tmp198
    tmp204 = einsum(t1.aa, (0, 1), tmp203, (2, 3, 1), (0, 2, 3))
    del tmp203
    r2new.bab += einsum(t1.bb, (0, 1), tmp204, (2, 3, 0), (3, 2, 1)) * -1
    del tmp204
    tmp182 = einsum(v.aabb.ooov, (0, 1, 2, 3), r2.bab, (4, 1, 3), (0, 4, 2)) * -1
    r2new.bab += einsum(t1.bb, (0, 1), tmp182, (2, 3, 0), (3, 2, 1)) * -1
    del tmp182
    tmp175 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.bab, (4, 0, 3), (4, 1, 2)) * -1
    r2new.bab += einsum(tmp175, (0, 1, 2), t1.aa, (3, 1), (0, 3, 2))
    del tmp175
    tmp214 = r2.bab.transpose((1, 0, 2)).copy() * -1
    tmp214 += einsum(r1.a, (0,), t1.bb, (1, 2), (0, 1, 2))
    r2new.bab += einsum(tmp214, (0, 1, 2), v.aabb.oovv, (3, 0, 4, 2), (1, 3, 4))
    del tmp214
    tmp184 = r2.bab.transpose((1, 0, 2)).copy() * -1
    tmp184 += einsum(r1.a, (0,), t1.bb, (1, 2), (0, 1, 2)) * 2
    r2new.bab += einsum(v.aabb.oooo, (0, 1, 2, 3), tmp184, (1, 3, 4), (2, 0, 4)) * -0.5
    del tmp184
    tmp215 = einsum(tmp72, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    r2new.bab += einsum(t1.bb, (0, 1), tmp215, (2, 3, 0), (3, 2, 1))
    del tmp215
    tmp176 = einsum(r1.a, (0,), v.aabb.ovvv, (0, 1, 2, 3), (1, 2, 3)) * -1
    tmp176 += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp2, (0, 2, 4), (1, 3, 4))
    del tmp2
    r2new.bab += einsum(tmp176, (0, 1, 2), t2.abab, (3, 4, 0, 1), (4, 3, 2)) * -1
    del tmp176
    tmp132 = f.aa.vv.copy()
    tmp132 += tmp40.transpose((1, 0))
    del tmp40
    tmp132 += einsum(t1.aa, (0, 1), tmp131, (0, 1, 2, 3), (3, 2)) * -1
    del tmp131
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp132, (2, 3), (0, 1, 3))
    del tmp132
    tmp97 = tmp94.copy() * 2
    del tmp94
    tmp97 += tmp95
    del tmp95
    tmp97 += tmp96
    del tmp96
    r2new.aba += einsum(tmp97, (0, 1), r1.b, (2,), (0, 2, 1))
    r2new.aaa += einsum(tmp97, (0, 1), r1.a, (2,), (0, 2, 1))
    r2new.aaa += einsum(r1.a, (0,), tmp97, (1, 2), (0, 1, 2)) * -1
    del tmp97
    tmp159 = einsum(r2.aba, (0, 1, 2), tmp158, (0, 2, 3, 4), (1, 4, 3)) * -1
    del tmp158
    tmp159 += einsum(tmp133, (0, 1, 2), v.aabb.vvov, (3, 4, 0, 2), (1, 3, 4)) * -1
    del tmp133
    r2new.aba += einsum(t1.aa, (0, 1), tmp159, (2, 1, 3), (0, 2, 3)) * -1
    del tmp159
    tmp93 = tmp89.copy() * 2
    del tmp89
    tmp93 += tmp92
    del tmp92
    r2new.aba += einsum(r1.b, (0,), tmp93, (1, 2), (1, 0, 2)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp93, (1, 2), (1, 0, 2)) * -1
    del tmp93
    tmp107 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    r2new.aba += einsum(r1.b, (0,), tmp107, (1, 2), (1, 0, 2))
    r2new.aaa += einsum(r1.a, (0,), tmp107, (1, 2), (0, 1, 2)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp107, (1, 2), (1, 0, 2))
    del tmp107
    tmp139 = tmp135.transpose((1, 0, 2)).copy()
    del tmp135
    tmp139 += einsum(r2.bbb, (0, 1, 2), tmp136, (1, 3, 2, 4), (3, 0, 4)) * -2
    del tmp136
    tmp139 += tmp138.transpose((1, 0, 2)) * -1
    del tmp138
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp139, (1, 4, 3), (0, 4, 2))
    del tmp139
    tmp153 = einsum(r2.bbb, (0, 1, 2), v.aabb.ooov, (3, 4, 1, 2), (3, 4, 0)) * 2
    tmp153 += einsum(tmp64, (0, 1, 2, 3), r2.aba, (0, 4, 3), (2, 1, 4))
    del tmp64
    r2new.aba += einsum(t1.aa, (0, 1), tmp153, (0, 2, 3), (2, 3, 1))
    del tmp153
    tmp172 = r2.aba.copy()
    tmp172 += einsum(r1.b, (0,), t1.aa, (1, 2), (1, 0, 2)) * -1
    r2new.aba += einsum(v.aabb.vvoo, (0, 1, 2, 3), tmp172, (4, 3, 1), (4, 2, 0)) * -1
    del tmp172
    tmp58 = f.aa.ov.copy()
    tmp58 += tmp14
    del tmp14
    tmp58 += tmp4
    del tmp4
    r2new.aba += einsum(r1.b, (0,), tmp58, (1, 2), (1, 0, 2)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp58, (1, 2), (1, 0, 2)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp58, (1, 2), (0, 1, 2))
    del tmp58
    tmp130 = einsum(r1.b, (0,), v.aabb.vvov, (1, 2, 0, 3), (1, 2, 3))
    tmp130 += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp21, (0, 2, 4), (1, 4, 3))
    del tmp21
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp130, (2, 4, 3), (0, 1, 4))
    del tmp130
    tmp173 = einsum(tmp143, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    del tmp143
    r2new.aba += einsum(t1.aa, (0, 1), tmp173, (2, 0, 3), (2, 3, 1))
    del tmp173
    tmp151 = tmp149.transpose((1, 0, 2)).copy()
    del tmp149
    tmp151 += tmp150.transpose((1, 0, 2)) * -1
    del tmp150
    r2new.aba += einsum(tmp151, (0, 1, 2), t2.abab, (0, 3, 4, 2), (1, 3, 4)) * -1
    del tmp151
    tmp99 = f.aa.oo.copy()
    tmp99 += tmp79.transpose((1, 0))
    del tmp79
    tmp99 += tmp98.transpose((1, 0)) * -1
    del tmp98
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp99, (0, 3), (3, 1, 2)) * -1
    r2new.aaa += einsum(tmp99, (0, 1), r2.aaa, (2, 0, 3), (1, 2, 3)) * 2
    del tmp99
    tmp28 = tmp23.copy() * -1
    del tmp23
    tmp28 += tmp24 * -1
    del tmp24
    tmp28 += tmp27
    del tmp27
    r2new.aba += einsum(tmp28, (0,), t2.abab, (1, 2, 3, 0), (1, 2, 3))
    r1new.b += einsum(tmp28, (0,), t1.bb, (1, 0), (1,)) * -1
    del tmp28
    tmp129 = einsum(r2.aba, (0, 1, 2), v.aabb.vvov, (3, 2, 1, 4), (0, 3, 4))
    r2new.aba += einsum(tmp129, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1)) * -1
    del tmp129
    tmp160 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp50, (0, 4, 1, 3), (4, 2))
    del tmp50
    tmp160 += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp52, (4, 2, 1, 3), (4, 0))
    del tmp52
    tmp160 += einsum(t1.aa, (0, 1), tmp55, (1, 2), (0, 2))
    del tmp55
    r2new.aba += einsum(r1.b, (0,), tmp160, (1, 2), (1, 0, 2)) * -1
    del tmp160
    tmp134 = einsum(r2.aba, (0, 1, 2), v.aabb.ovoo, (3, 2, 4, 1), (0, 3, 4))
    r2new.aba += einsum(t1.aa, (0, 1), tmp134, (2, 0, 3), (2, 3, 1))
    del tmp134
    tmp174 = tmp120.copy()
    tmp174 += tmp122 * 0.5
    tmp174 += einsum(tmp124, (0, 1), t1.aa, (0, 2), (1, 2)) * 0.5
    del tmp124
    r2new.aba += einsum(tmp174, (0, 1), r1.b, (2,), (0, 2, 1)) * 2
    del tmp174
    tmp171 = einsum(tmp19, (0, 1, 2), t1.aa, (3, 1), (3, 0, 2))
    del tmp19
    r2new.aba += einsum(tmp171, (0, 1, 2), t2.abab, (1, 3, 4, 2), (0, 3, 4)) * -1
    del tmp171
    tmp148 = einsum(r1.b, (0,), t1.aa, (1, 2), (1, 0, 2)) * 2
    tmp148 += r2.aba * -1
    r2new.aba += einsum(v.aabb.oooo, (0, 1, 2, 3), tmp148, (1, 3, 4), (0, 2, 4)) * -0.5
    del tmp148
    tmp157 = einsum(tmp156, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    del tmp156
    r2new.aba += einsum(t1.aa, (0, 1), tmp157, (2, 0, 3), (2, 3, 1)) * -1
    del tmp157
    tmp152 = tmp74.transpose((1, 0)).copy()
    del tmp74
    tmp152 += tmp75.transpose((1, 0)) * 0.5
    del tmp75
    tmp152 += einsum(tmp7, (0, 1), t1.aa, (0, 2), (1, 2)) * 0.5
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp152, (2, 3), (0, 1, 3)) * -2
    del tmp152
    tmp169 = einsum(tmp168, (0, 1, 2), t1.bb, (3, 2), (1, 0, 3))
    del tmp168
    r2new.aba += einsum(t1.aa, (0, 1), tmp169, (0, 2, 3), (2, 3, 1)) * -1
    del tmp169
    tmp78 = einsum(r2.aaa, (0, 1, 2), tmp77, (2, 3), (0, 1, 3))
    del tmp77
    r2new.aaa += tmp78.transpose((1, 0, 2))
    r2new.aaa += tmp78.transpose((1, 0, 2))
    del tmp78
    tmp104 = einsum(r2.aaa, (0, 1, 2), tmp103, (3, 4, 1, 0), (3, 4, 2)) * -1
    del tmp103
    r2new.aaa += tmp104 * -2
    r2new.aaa += tmp104.transpose((1, 0, 2)) * 2
    del tmp104
    tmp32 = einsum(tmp31, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 2, 1))
    del tmp31
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp32, (3, 4, 0, 1), (4, 3, 2)) * -2
    del tmp32
    tmp126 = tmp120.copy() * 2
    del tmp120
    tmp126 += tmp122
    del tmp122
    tmp126 += tmp125
    del tmp125
    r2new.aaa += einsum(r1.a, (0,), tmp126, (1, 2), (1, 0, 2))
    r2new.aaa += einsum(r1.a, (0,), tmp126, (1, 2), (0, 1, 2)) * -1
    del tmp126
    tmp49 = einsum(t1.aa, (0, 1), tmp48, (2, 3, 1), (0, 2, 3)) * 2
    del tmp48
    r2new.aaa += tmp49.transpose((1, 0, 2))
    r2new.aaa += tmp49 * -1
    del tmp49
    tmp73 = einsum(t2.abab, (0, 1, 2, 3), tmp72, (4, 1, 3), (0, 4, 2))
    del tmp72
    r2new.aaa += tmp73.transpose((1, 0, 2))
    r2new.aaa += tmp73 * -1
    del tmp73
    tmp117 = einsum(tmp116, (0, 1), r2.aaa, (2, 1, 3), (2, 0, 3)) * -4
    del tmp116
    r2new.aaa += tmp117.transpose((1, 0, 2)) * -1
    r2new.aaa += tmp117
    del tmp117
    tmp60 = tmp34.transpose((0, 2, 1)).copy() * -1
    del tmp34
    tmp60 += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp59, (0, 2, 4), (3, 1, 4)) * -1
    del tmp59
    r2new.aaa += einsum(tmp60, (0, 1, 2), t2.aaaa, (3, 4, 0, 1), (3, 4, 2)) * 2
    del tmp60
    tmp106 = einsum(tmp105, (0, 1, 2), t2.abab, (3, 1, 4, 2), (0, 3, 4))
    del tmp105
    r2new.aaa += tmp106 * -1
    r2new.aaa += tmp106.transpose((1, 0, 2))
    del tmp106
    tmp119 = einsum(tmp118, (0, 1, 2), t1.aa, (2, 3), (0, 1, 3))
    del tmp118
    r2new.aaa += tmp119
    r2new.aaa += tmp119.transpose((1, 0, 2)) * -1
    del tmp119
    tmp67 = einsum(tmp66, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 0, 4))
    del tmp66
    r2new.aaa += tmp67.transpose((1, 0, 2)) * 2
    r2new.aaa += tmp67 * -2
    del tmp67
    tmp108 = einsum(v.aaaa.ooov, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    r2new.aaa += tmp108.transpose((1, 0, 2))
    r2new.aaa += tmp108 * -1
    del tmp108
    tmp17 = tmp12.copy()
    del tmp12
    tmp17 += tmp13
    del tmp13
    tmp17 += tmp16
    del tmp16
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp17, (3,), (0, 1, 2)) * 4
    r1new.a += einsum(t1.aa, (0, 1), tmp17, (1,), (0,)) * -2
    del tmp17
    tmp102 = einsum(tmp7, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp7
    tmp102 += einsum(tmp11, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp11
    r2new.aaa += einsum(tmp102, (0, 1), r1.a, (2,), (2, 0, 1))
    del tmp102
    tmp39 = einsum(tmp38, (0, 1, 2), t1.aa, (2, 3), (1, 0, 3))
    del tmp38
    r2new.aaa += tmp39.transpose((1, 0, 2)) * -1
    r2new.aaa += tmp39
    del tmp39
    tmp128 = einsum(t1.aa, (0, 1), tmp127, (2, 3, 1), (0, 2, 3)) * -1
    del tmp127
    r2new.aaa += einsum(tmp128, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4)) * -2
    del tmp128
    tmp61 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oooo, (3, 0, 4, 1), (3, 4, 2))
    r2new.aaa += tmp61.transpose((1, 0, 2)) * -1
    r2new.aaa += tmp61.transpose((1, 0, 2)) * -1
    del tmp61
    tmp112 = einsum(v.aaaa.oovv, (0, 1, 2, 3), tmp111, (1, 4, 3), (0, 4, 2))
    del tmp111
    r2new.aaa += tmp112.transpose((1, 0, 2))
    r2new.aaa += tmp112 * -1
    del tmp112
    tmp57 = tmp51.copy()
    del tmp51
    tmp57 += tmp53
    del tmp53
    tmp57 += tmp56
    del tmp56
    r2new.aaa += einsum(tmp57, (0, 1), r1.a, (2,), (2, 0, 1)) * 2
    r2new.aaa += einsum(r1.a, (0,), tmp57, (1, 2), (1, 0, 2)) * -2
    del tmp57
    tmp30 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    r2new.aaa += tmp30.transpose((1, 0, 2)) * -2
    r2new.aaa += tmp30 * 2
    del tmp30
    tmp44 = einsum(r2.aaa, (0, 1, 2), tmp43, (2, 3), (0, 1, 3))
    del tmp43
    r2new.aaa += tmp44.transpose((1, 0, 2)) * -1
    r2new.aaa += tmp44.transpose((1, 0, 2)) * -1
    del tmp44
    tmp86 = tmp83.transpose((1, 0, 2)).copy() * 0.5
    tmp86 += tmp84.transpose((2, 0, 1)) * 0.5
    tmp86 += einsum(r2.aaa, (0, 1, 2), tmp85, (3, 4, 1, 2), (4, 0, 3)) * -1
    del tmp85
    r2new.aaa += einsum(tmp86, (0, 1, 2), t1.aa, (0, 3), (1, 2, 3)) * -2
    del tmp86
    tmp36 = einsum(tmp35, (0, 1, 2), t1.aa, (3, 1), (3, 0, 2))
    del tmp35
    r2new.aaa += tmp36.transpose((1, 0, 2))
    r2new.aaa += tmp36 * -1
    del tmp36
    tmp101 = tmp83.transpose((1, 0, 2)).copy()
    del tmp83
    tmp101 += tmp84.transpose((2, 0, 1))
    del tmp84
    tmp101 += einsum(r2.aaa, (0, 1, 2), tmp100, (3, 4, 1, 2), (4, 0, 3)) * -2
    del tmp100
    r2new.aaa += einsum(tmp101, (0, 1, 2), t1.aa, (0, 3), (2, 1, 3))
    del tmp101
    tmp29 = f.bb.oo.copy()
    tmp29 += einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 0, 1), (2, 3))
    r1new.b += einsum(r1.b, (0,), tmp29, (0, 1), (1,)) * -1
    del tmp29
    tmp18 = f.aa.oo.copy()
    tmp18 += einsum(v.aaaa.ovoo, (0, 1, 2, 3), t1.aa, (3, 1), (0, 2)) * -1
    r1new.a += einsum(r1.a, (0,), tmp18, (0, 1), (1,)) * -1
    del tmp18
    r2new.aba += einsum(r2.aba, (0, 1, 2), v.aaaa.ovov, (3, 4, 0, 2), (3, 1, 4))
    r2new.aba += einsum(v.aabb.oooo, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4)) * 0.5
    r2new.aba += einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aba, (1, 4, 3), (0, 4, 2)) * -1
    r2new.bab += einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bab, (2, 4, 3), (0, 4, 1))
    r2new.bab += einsum(v.aabb.oooo, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4)) * 0.5
    r2new.bab += einsum(r2.bab, (0, 1, 2), v.bbbb.oovv, (3, 0, 4, 2), (3, 1, 4)) * -1

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:41:54.224496.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    r1new = Namespace()
    r2new = Namespace()
    tmp9 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp9 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp5 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp5 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp8 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp10 = einsum(tmp9, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp4 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp172 = v.bbbb.ooov.copy()
    tmp172 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp11 = f.bb.ov.copy()
    tmp11 += tmp8
    tmp11 += tmp10 * -1
    del tmp10
    r1new.b = einsum(r2.bbb, (0, 1, 2), tmp11, (2, 1), (0,)) * 2
    r1new.a = einsum(tmp11, (0, 1), r2.bab, (1, 2, 0), (2,)) * -1
    tmp192 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp254 = v.bbbb.ovvv.copy()
    tmp254 += v.bbbb.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp26 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp7 = f.aa.ov.copy()
    tmp7 += tmp4
    tmp7 += tmp6 * -1
    del tmp6
    r1new.b += einsum(tmp7, (0, 1), r2.aba, (1, 2, 0), (2,)) * -1
    r1new.a += einsum(tmp7, (0, 1), r2.aaa, (2, 1, 0), (2,)) * 2
    tmp83 = v.aaaa.ooov.copy()
    tmp83 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp116 = v.aaaa.ovvv.copy()
    tmp116 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp113 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp14 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    tmp55 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp55 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp52 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp52 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp171 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp173 = einsum(tmp172, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    del tmp172
    tmp30 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp177 = v.bbbb.ovvv.copy() * -1
    tmp177 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp215 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp215 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp214 = r2.bbb.transpose((2, 0, 1)).copy() * 2
    tmp214 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2))
    tmp179 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp197 = einsum(tmp11, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp180 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp150 = v.bbbb.ovvv.copy() * -1
    tmp150 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp183 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp252 = tmp192.copy()
    tmp252 += tmp192.transpose((0, 2, 1, 3)) * -1
    tmp255 = einsum(r1.b, (0,), tmp254, (1, 0, 2, 3), (1, 2, 3))
    del tmp254
    tmp22 = r2.bbb.transpose((2, 0, 1)).copy() * 2
    tmp22 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 2, 0)) * -1
    r1new.b += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp22, (0, 3, 1), (2,))
    tmp27 = f.bb.ov.copy()
    tmp27 += tmp26
    tmp23 = r2.aba.transpose((2, 0, 1)).copy()
    tmp23 += einsum(r1.b, (0,), t1.aa, (1, 2), (1, 2, 0)) * -1
    r2new.aba = einsum(tmp23, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 2), (3, 4, 0))
    r1new.b += einsum(tmp23, (0, 1, 2), v.aabb.ovvv, (0, 1, 3, 2), (3,)) * -1
    tmp20 = einsum(r1.b, (0,), v.bbbb.ovov, (1, 2, 3, 0), (1, 3, 2))
    r1new.b += einsum(tmp20, (0, 1, 2), t2.bbbb, (1, 0, 3, 2), (3,)) * -2
    tmp18 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (0, 2, 3, 1), (2, 3))
    tmp106 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp108 = einsum(tmp7, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp107 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp84 = einsum(t1.aa, (0, 1), tmp83, (0, 2, 3, 1), (2, 3))
    tmp82 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp117 = einsum(r1.a, (0,), tmp116, (1, 0, 2, 3), (1, 2, 3))
    del tmp116
    tmp114 = tmp113.copy()
    tmp114 += tmp113.transpose((0, 2, 1, 3)) * -1
    tmp111 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp102 = v.aaaa.ovvv.copy() * -1
    tmp102 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    tmp36 = r2.aaa.transpose((2, 0, 1)).copy() * 2
    tmp36 += einsum(t1.aa, (0, 1), r1.a, (2,), (0, 2, 1))
    tmp37 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp37 += v.aaaa.ovov.transpose((0, 2, 1, 3)) * -1
    tmp39 = v.aaaa.ovvv.copy() * -1
    tmp39 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp1 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r1.a, (3,), (0, 2, 1))
    r1new.a += einsum(t2.aaaa, (0, 1, 2, 3), tmp1, (1, 0, 3), (2,)) * -2
    tmp15 = f.aa.ov.copy()
    tmp15 += tmp14 * -1
    del tmp14
    tmp3 = r2.aaa.transpose((2, 0, 1)).copy() * 2
    tmp3 += einsum(r1.a, (0,), t1.aa, (1, 2), (1, 2, 0)) * -1
    r1new.a += einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp3, (0, 1, 3), (2,)) * -1
    tmp2 = r2.bab.transpose((2, 1, 0)).copy() * -1
    tmp2 += einsum(r1.a, (0,), t1.bb, (1, 2), (1, 0, 2))
    r2new.bab = einsum(v.aabb.vvvv, (0, 1, 2, 3), tmp2, (4, 1, 3), (2, 0, 4)) * -1
    r1new.a += einsum(tmp2, (0, 1, 2), v.aabb.vvov, (3, 1, 0, 2), (3,))
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp53 = einsum(t1.aa, (0, 1), tmp52, (0, 2, 3, 1), (2, 3))
    tmp174 = f.bb.oo.copy()
    tmp174 += tmp171.transpose((1, 0))
    del tmp171
    tmp174 += tmp173.transpose((1, 0)) * -1
    del tmp173
    r2new.bab += einsum(tmp174, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -1
    tmp229 = einsum(r1.b, (0,), v.bbbb.ooov, (1, 2, 3, 0), (1, 2, 3))
    tmp138 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp140 = einsum(t1.bb, (0, 1), tmp11, (0, 2), (1, 2))
    tmp139 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp127 = t2.abab.copy()
    tmp127 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp188 = f.bb.vv.copy()
    tmp188 += tmp30.transpose((1, 0))
    tmp186 = t2.bbbb.copy() * 2
    tmp186 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp157 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 4, 3))
    r2new.bbb = tmp157.transpose((1, 2, 0)).copy() * -1
    r2new.bbb += tmp157.transpose((2, 1, 0))
    tmp217 = einsum(r1.b, (0,), tmp177, (1, 0, 2, 3), (1, 2, 3))
    tmp216 = einsum(tmp215, (0, 1, 2, 3), tmp214, (0, 2, 4), (1, 4, 3))
    del tmp215, tmp214
    tmp198 = tmp179.transpose((1, 0)).copy() * 0.5
    tmp198 += tmp180.transpose((1, 0))
    tmp198 += tmp197.transpose((1, 0))
    del tmp197
    tmp201 = v.bbbb.ooov.copy() * -1
    tmp201 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp142 = einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2))
    tmp142 += r2.bbb.transpose((2, 0, 1)) * 2
    tmp149 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp151 = einsum(t1.bb, (0, 1), tmp150, (0, 1, 2, 3), (2, 3))
    tmp251 = einsum(tmp183, (0, 1, 2, 3), r2.aba, (3, 4, 0), (1, 2, 4))
    tmp253 = einsum(tmp252, (0, 1, 2, 3), r2.bbb, (4, 3, 2), (0, 1, 4)) * -2
    del tmp252
    tmp256 = einsum(tmp255, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1)) * -1
    del tmp255
    tmp181 = einsum(tmp11, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp232 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (4, 0, 2)) * -1
    tmp25 = einsum(tmp22, (0, 1, 2), v.bbbb.ovov, (3, 1, 0, 2), (3,))
    del tmp22
    tmp28 = einsum(r1.b, (0,), tmp27, (1, 0), (1,))
    del tmp27
    tmp24 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp23, (0, 1, 3), (2,))
    del tmp23
    tmp243 = einsum(t1.bb, (0, 1), tmp20, (2, 3, 1), (0, 3, 2))
    del tmp20
    tmp0 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    r1new.a += einsum(tmp0, (0, 1, 2), t2.abab, (0, 1, 3, 2), (3,)) * -1
    tmp50 = einsum(t1.aa, (0, 1), r1.a, (2,), (0, 2, 1))
    tmp50 += r2.aaa.transpose((2, 0, 1)) * 2
    tmp19 = f.aa.vv.copy()
    tmp19 += tmp18 * -1
    del tmp18
    r1new.a += einsum(tmp19, (0, 1), r1.a, (0,), (1,))
    tmp125 = t2.aaaa.copy() * 2
    tmp125 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp109 = tmp106.transpose((1, 0)).copy() * 2
    del tmp106
    tmp109 += tmp107.transpose((1, 0))
    del tmp107
    tmp109 += tmp108.transpose((1, 0))
    del tmp108
    r2new.aba += einsum(tmp109, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    tmp85 = f.aa.oo.copy()
    tmp85 += tmp82.transpose((1, 0))
    del tmp82
    tmp85 += tmp84.transpose((1, 0)) * -1
    del tmp84
    r2new.aba += einsum(tmp85, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    tmp21 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.b, (3,), (0, 2, 1))
    r1new.b += einsum(t2.abab, (0, 1, 2, 3), tmp21, (0, 1, 2), (3,)) * -1
    tmp79 = v.aaaa.ooov.copy() * -1
    tmp79 += v.aaaa.ovoo.transpose((0, 2, 3, 1))
    tmp118 = einsum(tmp117, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1)) * -1
    del tmp117
    tmp115 = einsum(tmp114, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 2, 4)) * -2
    del tmp114
    tmp112 = einsum(tmp111, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 1, 4)) * -1
    tmp45 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp47 = einsum(tmp7, (0, 1), t1.aa, (0, 2), (2, 1)) * 0.5
    tmp46 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp73 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (3, 1, 4), (4, 0, 2)) * -1
    tmp70 = einsum(r1.a, (0,), v.aaaa.ooov, (1, 2, 3, 0), (1, 2, 3))
    tmp101 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp103 = einsum(t1.aa, (0, 1), tmp102, (0, 1, 2, 3), (2, 3))
    del tmp102
    tmp38 = einsum(tmp36, (0, 1, 2), tmp37, (0, 3, 1, 4), (3, 2, 4)) * 0.5
    del tmp37
    tmp40 = einsum(r1.a, (0,), tmp39, (1, 2, 0, 3), (1, 2, 3)) * 0.5
    tmp35 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 4, 1)) * -1
    r2new.aaa = tmp35.transpose((1, 2, 0)).copy()
    r2new.aaa += tmp35.transpose((2, 1, 0)) * -1
    tmp94 = einsum(t1.aa, (0, 1), tmp1, (2, 3, 1), (0, 3, 2))
    del tmp1
    tmp16 = einsum(r1.a, (0,), tmp15, (1, 0), (1,)) * 0.5
    del tmp15
    tmp12 = einsum(tmp3, (0, 1, 2), v.aaaa.ovov, (3, 2, 0, 1), (3,)) * 0.5
    del tmp3
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp2, (2, 1, 3), (0,)) * 0.5
    del tmp2
    tmp57 = f.bb.ov.copy()
    tmp57 += tmp8
    tmp57 += tmp56 * -1
    del tmp56
    tmp54 = f.aa.ov.copy()
    tmp54 += tmp4
    tmp54 += tmp53 * -1
    del tmp53
    tmp203 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3))
    tmp204 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp205 = einsum(t1.bb, (0, 1), tmp174, (0, 2), (2, 1))
    tmp230 = einsum(t1.bb, (0, 1), tmp229, (2, 3, 0), (2, 3, 1))
    tmp222 = tmp138.copy()
    tmp222 += tmp139 * 2
    tmp222 += tmp140
    tmp185 = einsum(tmp127, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4)) * 0.5
    tmp189 = einsum(tmp188, (0, 1), t1.bb, (2, 0), (2, 1)) * 0.5
    del tmp188
    tmp187 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp186, (0, 4, 3, 1), (4, 2)) * 0.5
    del tmp186
    tmp211 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovvv, (3, 1, 4, 0), (2, 3, 4)) * -1
    tmp176 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp176, (2, 3, 1, 4), (4, 0, 3)) * -2
    tmp259 = v.bbbb.ovvv.copy() * -1
    tmp259 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp218 = tmp157.copy()
    tmp218 += tmp216
    del tmp216
    tmp218 += tmp217.transpose((0, 2, 1)) * -1
    del tmp217
    tmp199 = einsum(t1.bb, (0, 1), tmp198, (0, 2), (2, 1)) * 2
    del tmp198
    tmp196 = einsum(t2.bbbb, (0, 1, 2, 3), tmp192, (4, 0, 1, 3), (4, 2)) * -1
    tmp195 = einsum(tmp183, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp238 = einsum(tmp201, (0, 1, 2, 3), r2.bbb, (4, 3, 0), (1, 2, 4)) * -2
    tmp236 = einsum(r1.b, (0,), v.bbbb.oovv, (1, 2, 3, 0), (1, 2, 3))
    tmp237 = einsum(v.aabb.ovoo, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 3, 4))
    tmp220 = r2.bbb.transpose((2, 0, 1)).copy()
    tmp220 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2)) * 0.5
    tmp134 = einsum(r1.b, (0,), v.aabb.ovvv, (1, 2, 3, 0), (1, 2, 3))
    r2new.aba += tmp134.transpose((1, 2, 0)) * -1
    tmp143 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp142, (2, 3, 4), (0, 1, 4))
    r2new.aba += tmp143.transpose((1, 2, 0))
    tmp159 = einsum(r2.aba, (0, 1, 2), tmp52, (2, 3, 4, 0), (3, 4, 1))
    tmp152 = f.bb.vv.copy()
    tmp152 += tmp149.transpose((1, 0))
    del tmp149
    tmp152 += tmp151.transpose((1, 0)) * -1
    del tmp151
    r2new.bab += einsum(tmp152, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3))
    r2new.aba += einsum(tmp152, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3))
    tmp257 = tmp251.copy()
    del tmp251
    tmp257 += tmp253 * -1
    del tmp253
    tmp257 += tmp256.transpose((1, 0, 2)) * -1
    del tmp256
    tmp182 = tmp179.transpose((1, 0)).copy()
    del tmp179
    tmp182 += tmp180.transpose((1, 0)) * 2
    del tmp180
    tmp182 += tmp181.transpose((1, 0))
    del tmp181
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp182, (2, 3), (0, 1, 3)) * -1
    tmp245 = einsum(r1.b, (0,), v.bbbb.vvvv, (1, 2, 3, 0), (1, 2, 3))
    tmp233 = tmp229.transpose((1, 0, 2)).copy()
    del tmp229
    tmp233 += tmp232.transpose((2, 0, 1))
    tmp29 = tmp24.copy() * -1
    del tmp24
    tmp29 += tmp25
    del tmp25
    tmp29 += tmp28
    del tmp28
    r2new.aba += einsum(tmp29, (0,), t2.abab, (1, 0, 2, 3), (2, 3, 1))
    r1new.b += einsum(tmp29, (0,), t1.bb, (0, 1), (1,)) * -1
    tmp247 = einsum(tmp243, (0, 1, 2), t1.bb, (2, 3), (0, 1, 3))
    tmp193 = tmp192.copy() * -1
    tmp193 += tmp192.transpose((0, 2, 1, 3))
    del tmp192
    tmp43 = einsum(r1.a, (0,), v.aabb.vvov, (1, 0, 2, 3), (2, 1, 3))
    r2new.bab += tmp43.transpose((2, 1, 0)) * -1
    tmp164 = r2.bab.transpose((2, 1, 0)).copy() * -1
    tmp164 += einsum(r1.a, (0,), t1.bb, (1, 2), (1, 0, 2))
    tmp163 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    tmp208 = v.aaaa.ovvv.copy()
    tmp208 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp175 = einsum(t1.bb, (0, 1), tmp0, (2, 3, 1), (2, 0, 3))
    del tmp0
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp175, (0, 4, 1), (3, 2, 4)) * -1
    tmp61 = einsum(tmp55, (0, 1, 2, 3), r2.bab, (2, 4, 0), (1, 4, 3)) * -1
    tmp62 = einsum(tmp50, (0, 1, 2), v.aabb.ovov, (0, 1, 3, 4), (3, 2, 4))
    r2new.bab += tmp62.transpose((2, 1, 0))
    tmp59 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp153 = tmp113.copy() * -1
    tmp153 += tmp113.transpose((0, 2, 1, 3))
    tmp129 = einsum(tmp19, (0, 1), t1.aa, (2, 0), (2, 1))
    del tmp19
    tmp128 = einsum(tmp127, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp126 = einsum(tmp125, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 3), (1, 4))
    del tmp125
    tmp65 = einsum(tmp11, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp64 = einsum(tmp7, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    tmp136 = r2.aba.transpose((2, 0, 1)).copy()
    tmp136 += einsum(r1.b, (0,), t1.aa, (1, 2), (1, 2, 0)) * -1
    tmp135 = einsum(r1.b, (0,), v.aabb.vvov, (1, 2, 3, 0), (3, 1, 2))
    tmp122 = einsum(tmp111, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp123 = einsum(t1.aa, (0, 1), tmp109, (0, 2), (2, 1))
    tmp121 = einsum(t2.aaaa, (0, 1, 2, 3), tmp113, (4, 1, 0, 3), (4, 2))
    del tmp113
    tmp89 = einsum(tmp85, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp88 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp87 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2))
    tmp146 = einsum(tmp21, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    del tmp21
    r2new.aba += einsum(tmp146, (0, 1, 2), t2.abab, (1, 2, 3, 4), (3, 4, 0)) * -1
    tmp77 = einsum(r1.a, (0,), v.aaaa.oovv, (1, 2, 3, 0), (1, 2, 3))
    tmp78 = einsum(v.aabb.ooov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 1, 4)) * -1
    tmp80 = einsum(tmp79, (0, 1, 2, 3), r2.aaa, (4, 3, 0), (1, 2, 4)) * -2
    del tmp79
    tmp96 = einsum(r1.a, (0,), v.aaaa.vvvv, (1, 2, 3, 0), (1, 2, 3))
    tmp119 = tmp112.copy()
    del tmp112
    tmp119 += tmp115 * -1
    del tmp115
    tmp119 += tmp118
    del tmp118
    tmp48 = tmp45.copy()
    tmp48 += tmp46 * 0.5
    tmp48 += tmp47
    tmp92 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    r2new.aba += einsum(tmp92, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (2, 4, 0)) * -2
    tmp74 = tmp70.transpose((1, 0, 2)).copy()
    tmp74 += tmp73.transpose((2, 0, 1))
    tmp104 = f.aa.vv.copy()
    tmp104 += tmp101.transpose((1, 0))
    del tmp101
    tmp104 += tmp103.transpose((1, 0)) * -1
    del tmp103
    r2new.bab += einsum(tmp104, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3))
    r2new.aba += einsum(tmp104, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3))
    tmp41 = tmp35.copy() * 0.5
    tmp41 += tmp38
    del tmp38
    tmp41 += tmp40.transpose((0, 2, 1)) * -1
    del tmp40
    tmp98 = einsum(tmp94, (0, 1, 2), t1.aa, (2, 3), (0, 1, 3))
    tmp33 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovvv, (3, 0, 4, 1), (2, 3, 4))
    tmp17 = tmp12.copy() * -1
    del tmp12
    tmp17 += tmp13
    del tmp13
    tmp17 += tmp16
    del tmp16
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp17, (0,), (3, 2, 1)) * 2
    r1new.a += einsum(t1.aa, (0, 1), tmp17, (0,), (1,)) * -2
    tmp131 = v.aaaa.ovvv.copy() * -1
    tmp131 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp71 = einsum(tmp70, (0, 1, 2), t1.aa, (2, 3), (0, 1, 3))
    del tmp70
    tmp225 = einsum(tmp54, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp225 += einsum(tmp57, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2
    r2new.bbb += einsum(r1.b, (0,), tmp225, (1, 2), (0, 2, 1))
    del tmp225
    tmp206 = tmp203.copy()
    del tmp203
    tmp206 += tmp204 * 2
    del tmp204
    tmp206 += tmp205
    del tmp205
    r2new.bbb += einsum(r1.b, (0,), tmp206, (1, 2), (2, 0, 1))
    r2new.bbb += einsum(r1.b, (0,), tmp206, (1, 2), (0, 2, 1)) * -1
    r2new.bab += einsum(r1.a, (0,), tmp206, (1, 2), (2, 0, 1))
    del tmp206
    tmp231 = einsum(t1.bb, (0, 1), tmp230, (2, 0, 3), (2, 1, 3))
    del tmp230
    r2new.bbb += tmp231.transpose((2, 1, 0))
    r2new.bbb += tmp231.transpose((1, 2, 0)) * -1
    del tmp231
    tmp223 = einsum(r2.bbb, (0, 1, 2), tmp222, (3, 1), (2, 3, 0)) * -2
    del tmp222
    r2new.bbb += tmp223.transpose((1, 2, 0)) * -1
    r2new.bbb += tmp223.transpose((2, 1, 0))
    del tmp223
    tmp190 = tmp185.copy()
    del tmp185
    tmp190 += tmp187 * -1
    del tmp187
    tmp190 += tmp189
    del tmp189
    r2new.bbb += einsum(r1.b, (0,), tmp190, (1, 2), (0, 2, 1)) * 2
    r2new.bbb += einsum(r1.b, (0,), tmp190, (1, 2), (2, 0, 1)) * -2
    r2new.bab += einsum(tmp190, (0, 1), r1.a, (2,), (1, 2, 0)) * -2
    del tmp190
    tmp167 = f.bb.ov.copy()
    tmp167 += tmp8
    tmp167 += tmp26
    r2new.bbb += einsum(r1.b, (0,), tmp167, (1, 2), (2, 0, 1)) * -1
    r2new.bab += einsum(tmp167, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    del tmp167
    tmp212 = einsum(t1.bb, (0, 1), tmp211, (2, 0, 3), (2, 1, 3))
    del tmp211
    r2new.bbb += tmp212.transpose((1, 2, 0)) * -2
    r2new.bbb += tmp212.transpose((2, 1, 0)) * 2
    del tmp212
    tmp242 = einsum(tmp176, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp176
    r2new.bbb += tmp242.transpose((1, 2, 0)) * -1
    r2new.bbb += tmp242.transpose((2, 1, 0))
    del tmp242
    tmp260 = einsum(tmp259, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3)) * -1
    del tmp259
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp260, (3, 2, 1, 4), (0, 4, 3)) * 2
    del tmp260
    tmp219 = einsum(t2.bbbb, (0, 1, 2, 3), tmp218, (1, 4, 3), (0, 4, 2)) * 2
    del tmp218
    r2new.bbb += tmp219.transpose((2, 1, 0))
    r2new.bbb += tmp219.transpose((1, 2, 0)) * -1
    del tmp219
    tmp178 = einsum(tmp177, (0, 1, 2, 3), t1.bb, (4, 2), (0, 4, 1, 3))
    del tmp177
    r2new.bbb += einsum(tmp178, (0, 1, 2, 3), r2.bbb, (4, 2, 0), (3, 4, 1)) * 2
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp178, (2, 3, 0, 4), (4, 1, 3)) * -1
    del tmp178
    tmp227 = f.bb.ov.copy()
    tmp227 += tmp8
    del tmp8
    tmp227 += tmp26
    del tmp26
    r2new.bbb += einsum(r1.b, (0,), tmp227, (1, 2), (0, 2, 1))
    del tmp227
    tmp244 = einsum(tmp243, (0, 1, 2), t2.bbbb, (2, 1, 3, 4), (0, 3, 4)) * -1
    del tmp243
    r2new.bbb += tmp244.transpose((1, 2, 0))
    r2new.bbb += tmp244.transpose((1, 2, 0))
    del tmp244
    tmp200 = tmp195.copy()
    del tmp195
    tmp200 += tmp196 * 2
    del tmp196
    tmp200 += tmp199
    del tmp199
    r2new.bbb += einsum(r1.b, (0,), tmp200, (1, 2), (2, 0, 1))
    r2new.bbb += einsum(r1.b, (0,), tmp200, (1, 2), (0, 2, 1)) * -1
    r2new.bab += einsum(r1.a, (0,), tmp200, (1, 2), (2, 0, 1))
    del tmp200
    tmp241 = tmp236.transpose((1, 0, 2)).copy()
    tmp241 += tmp237.transpose((1, 0, 2)) * -1
    tmp241 += tmp238.transpose((1, 0, 2)) * -1
    r2new.bbb += einsum(t1.bb, (0, 1), tmp241, (0, 2, 3), (1, 3, 2))
    del tmp241
    tmp221 = tmp134.copy()
    tmp221 += einsum(tmp5, (0, 1, 2, 3), r2.aba, (3, 4, 0), (1, 2, 4))
    del tmp5
    tmp221 += einsum(tmp220, (0, 1, 2), v.aabb.ovov, (3, 4, 0, 1), (3, 4, 2)) * -2
    del tmp220
    r2new.bbb += einsum(tmp221, (0, 1, 2), t2.abab, (0, 3, 1, 4), (2, 4, 3))
    del tmp221
    tmp224 = einsum(tmp142, (0, 1, 2), v.bbbb.ovov, (3, 4, 0, 1), (3, 4, 2))
    r2new.bbb += tmp224.transpose((2, 1, 0)) * -1
    r2new.bbb += tmp224.transpose((1, 2, 0))
    del tmp224
    tmp160 = tmp134.copy()
    tmp160 += tmp159
    del tmp159
    tmp160 += tmp143 * -1
    del tmp143
    r2new.bbb += einsum(tmp160, (0, 1, 2), t2.abab, (0, 3, 1, 4), (4, 2, 3)) * -1
    r2new.aba += einsum(t2.aaaa, (0, 1, 2, 3), tmp160, (1, 3, 4), (2, 4, 0)) * -2
    del tmp160
    tmp213 = einsum(r1.b, (0,), v.bbbb.ovvv, (1, 2, 3, 0), (1, 2, 3))
    r2new.bbb += tmp213.transpose((2, 1, 0))
    r2new.bbb += tmp213.transpose((1, 2, 0)) * -1
    del tmp213
    tmp240 = einsum(r2.bbb, (0, 1, 2), tmp174, (2, 3), (3, 0, 1))
    del tmp174
    r2new.bbb += tmp240.transpose((2, 1, 0))
    r2new.bbb += tmp240.transpose((2, 1, 0))
    del tmp240
    tmp249 = einsum(r2.bbb, (0, 1, 2), tmp152, (1, 3), (2, 0, 3)) * -1
    del tmp152
    r2new.bbb += tmp249.transpose((1, 2, 0)) * -2
    r2new.bbb += tmp249.transpose((2, 1, 0)) * 2
    del tmp249
    tmp258 = einsum(tmp257, (0, 1, 2), t1.bb, (1, 3), (0, 2, 3))
    del tmp257
    r2new.bbb += tmp258.transpose((2, 1, 0)) * -1
    r2new.bbb += tmp258.transpose((1, 2, 0))
    del tmp258
    tmp228 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 1), (3, 0, 4))
    r2new.bbb += tmp228.transpose((1, 2, 0)) * -2
    r2new.bbb += tmp228.transpose((2, 1, 0)) * 2
    del tmp228
    tmp239 = tmp236.transpose((1, 0, 2)).copy()
    del tmp236
    tmp239 += tmp237.transpose((1, 0, 2)) * -1
    del tmp237
    tmp239 += einsum(tmp232, (0, 1, 2), t1.bb, (1, 3), (2, 0, 3)) * -2
    del tmp232
    tmp239 += tmp238.transpose((1, 0, 2)) * -1
    del tmp238
    r2new.bbb += einsum(tmp239, (0, 1, 2), t1.bb, (0, 3), (2, 3, 1)) * -1
    del tmp239
    tmp250 = einsum(r2.bbb, (0, 1, 2), tmp182, (2, 3), (3, 0, 1))
    del tmp182
    r2new.bbb += tmp250.transpose((2, 1, 0))
    r2new.bbb += tmp250.transpose((2, 1, 0))
    del tmp250
    tmp246 = einsum(t1.bb, (0, 1), tmp245, (2, 1, 3), (0, 3, 2))
    del tmp245
    r2new.bbb += tmp246.transpose((2, 1, 0)) * -1
    r2new.bbb += tmp246.transpose((1, 2, 0))
    del tmp246
    tmp226 = einsum(tmp7, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3)) * 0.5
    tmp226 += einsum(t2.bbbb, (0, 1, 2, 3), tmp11, (1, 3), (0, 2))
    r2new.bbb += einsum(r1.b, (0,), tmp226, (1, 2), (2, 0, 1)) * -2
    del tmp226
    tmp169 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    r2new.bbb += einsum(tmp169, (0, 1), r1.b, (2,), (2, 1, 0)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp169, (1, 2), (2, 0, 1))
    r2new.bab += einsum(tmp169, (0, 1), r1.a, (2,), (1, 2, 0))
    del tmp169
    tmp234 = einsum(tmp233, (0, 1, 2), t2.bbbb, (0, 2, 3, 4), (1, 3, 4))
    del tmp233
    r2new.bbb += tmp234.transpose((2, 1, 0))
    r2new.bbb += tmp234.transpose((2, 1, 0))
    del tmp234
    tmp235 = einsum(tmp29, (0,), t2.bbbb, (1, 0, 2, 3), (1, 2, 3)) * -1
    del tmp29
    r2new.bbb += tmp235.transpose((2, 1, 0))
    r2new.bbb += tmp235.transpose((2, 1, 0))
    del tmp235
    tmp248 = einsum(t1.bb, (0, 1), tmp247, (2, 0, 3), (2, 1, 3))
    del tmp247
    r2new.bbb += tmp248.transpose((2, 1, 0)) * -1
    r2new.bbb += tmp248.transpose((1, 2, 0))
    del tmp248
    tmp191 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp191, (3, 2, 4, 1), (0, 4, 3)) * -1
    del tmp191
    tmp162 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.bab, (3, 1, 4), (0, 4, 2)) * -1
    r2new.bab += einsum(tmp162, (0, 1, 2), t1.aa, (0, 3), (2, 3, 1))
    del tmp162
    tmp141 = tmp138.transpose((1, 0)).copy()
    del tmp138
    tmp141 += tmp139.transpose((1, 0)) * 2
    del tmp139
    tmp141 += tmp140.transpose((1, 0))
    del tmp140
    r2new.bab += einsum(tmp141, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(tmp141, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    del tmp141
    tmp170 = einsum(v.aabb.ovoo, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    tmp170 += einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 1, 4), (0, 2, 4)) * -1
    r2new.bab += einsum(tmp170, (0, 1, 2), tmp127, (0, 1, 3, 4), (4, 3, 2)) * -1
    del tmp170
    tmp194 = einsum(tmp43, (0, 1, 2), t1.bb, (3, 2), (3, 0, 1))
    tmp194 += einsum(r2.aaa, (0, 1, 2), tmp183, (2, 3, 4, 1), (3, 4, 0)) * 2
    tmp194 += einsum(tmp193, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 1, 4)) * -1
    del tmp193
    r2new.bab += einsum(t1.bb, (0, 1), tmp194, (2, 0, 3), (1, 3, 2))
    del tmp194
    tmp210 = einsum(tmp7, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp210 += einsum(t2.bbbb, (0, 1, 2, 3), tmp11, (1, 3), (0, 2)) * 2
    del tmp11
    r2new.bab += einsum(r1.a, (0,), tmp210, (1, 2), (2, 0, 1)) * -1
    del tmp210
    tmp202 = einsum(r1.a, (0,), v.aabb.vvoo, (1, 0, 2, 3), (2, 3, 1))
    tmp202 += einsum(r2.aaa, (0, 1, 2), v.aabb.ovoo, (2, 1, 3, 4), (3, 4, 0)) * 2
    tmp202 += einsum(tmp201, (0, 1, 2, 3), r2.bab, (3, 4, 0), (2, 1, 4)) * -1
    del tmp201
    r2new.bab += einsum(t1.bb, (0, 1), tmp202, (0, 2, 3), (1, 3, 2))
    del tmp202
    tmp165 = tmp163.transpose((0, 2, 1)).copy() * -1
    tmp165 += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp164, (2, 1, 4), (0, 3, 4))
    del tmp164
    r2new.bab += einsum(tmp165, (0, 1, 2), t2.abab, (0, 3, 4, 1), (2, 4, 3)) * -1
    del tmp165
    tmp209 = tmp35.transpose((0, 2, 1)).copy()
    del tmp35
    tmp209 += einsum(tmp50, (0, 1, 2), tmp52, (0, 3, 1, 4), (3, 4, 2)) * -1
    del tmp52
    tmp209 += einsum(r1.a, (0,), tmp208, (1, 0, 2, 3), (1, 3, 2)) * -1
    del tmp208
    r2new.bab += einsum(tmp209, (0, 1, 2), t2.abab, (0, 3, 1, 4), (4, 2, 3)) * -1
    del tmp209
    tmp166 = tmp45.transpose((1, 0)).copy()
    tmp166 += tmp46.transpose((1, 0)) * 0.5
    tmp166 += tmp47.transpose((1, 0))
    del tmp47
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp166, (1, 3), (0, 3, 2)) * -2
    del tmp166
    tmp207 = einsum(r2.bab, (0, 1, 2), v.aabb.vvov, (3, 1, 4, 0), (2, 4, 3)) * -1
    r2new.bab += einsum(tmp207, (0, 1, 2), t1.bb, (1, 3), (3, 2, 0))
    del tmp207
    tmp168 = einsum(r2.bab, (0, 1, 2), v.aabb.ovoo, (3, 1, 4, 2), (3, 4, 0)) * -1
    r2new.bab += einsum(t1.aa, (0, 1), tmp168, (0, 2, 3), (3, 1, 2)) * -1
    del tmp168
    tmp184 = einsum(t1.bb, (0, 1), tmp163, (2, 3, 1), (2, 0, 3)) * -1
    del tmp163
    tmp184 += einsum(tmp183, (0, 1, 2, 3), r2.bab, (4, 3, 2), (0, 1, 4)) * -1
    del tmp183
    tmp184 += einsum(t1.bb, (0, 1), tmp175, (2, 3, 0), (2, 3, 1))
    del tmp175
    r2new.bab += einsum(tmp184, (0, 1, 2), t1.aa, (0, 3), (2, 3, 1)) * -1
    del tmp184
    tmp63 = tmp43.copy()
    tmp63 += tmp61 * -1
    del tmp61
    tmp63 += tmp62 * -1
    del tmp62
    r2new.bab += einsum(tmp63, (0, 1, 2), t2.bbbb, (3, 0, 4, 2), (4, 1, 3)) * -2
    r2new.aaa += einsum(tmp63, (0, 1, 2), t2.abab, (3, 0, 4, 2), (4, 1, 3)) * -1
    del tmp63
    tmp155 = einsum(r1.b, (0,), v.aabb.oovv, (1, 2, 3, 0), (1, 2, 3))
    tmp155 += einsum(r2.bbb, (0, 1, 2), v.aabb.ooov, (3, 4, 2, 1), (3, 4, 0)) * 2
    tmp155 += einsum(r2.aba, (0, 1, 2), tmp83, (2, 3, 4, 0), (4, 3, 1))
    del tmp83
    r2new.aba += einsum(t1.aa, (0, 1), tmp155, (0, 2, 3), (1, 3, 2))
    del tmp155
    tmp133 = einsum(v.aabb.vvov, (0, 1, 2, 3), r2.aba, (1, 3, 4), (4, 2, 0))
    r2new.aba += einsum(tmp133, (0, 1, 2), t1.bb, (1, 3), (2, 3, 0)) * -1
    del tmp133
    tmp156 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.aba, (1, 3, 4), (4, 0, 2))
    r2new.aba += einsum(t1.aa, (0, 1), tmp156, (2, 0, 3), (1, 3, 2)) * -1
    del tmp156
    tmp60 = f.aa.ov.copy()
    tmp60 += tmp59
    tmp60 += tmp4
    r2new.aba += einsum(tmp60, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp60, (1, 2), (2, 0, 1)) * -1
    del tmp60
    tmp158 = tmp157.transpose((0, 2, 1)).copy()
    del tmp157
    tmp158 += einsum(tmp142, (0, 1, 2), tmp55, (0, 3, 1, 4), (3, 4, 2)) * -1
    del tmp55, tmp142
    tmp158 += einsum(tmp150, (0, 1, 2, 3), r1.b, (1,), (0, 3, 2)) * -1
    del tmp150
    r2new.aba += einsum(tmp158, (0, 1, 2), t2.abab, (3, 0, 4, 1), (4, 2, 3))
    del tmp158
    tmp154 = einsum(t1.aa, (0, 1), tmp134, (2, 1, 3), (0, 2, 3))
    del tmp134
    tmp154 += einsum(r2.bbb, (0, 1, 2), tmp111, (3, 4, 2, 1), (3, 4, 0)) * 2
    tmp154 += einsum(tmp153, (0, 1, 2, 3), r2.aba, (3, 4, 1), (0, 2, 4))
    del tmp153
    r2new.aba += einsum(t1.aa, (0, 1), tmp154, (2, 0, 3), (1, 3, 2))
    del tmp154
    tmp130 = tmp126.copy()
    del tmp126
    tmp130 += tmp128
    del tmp128
    tmp130 += tmp129
    del tmp129
    r2new.aba += einsum(tmp130, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp130, (1, 2), (0, 2, 1))
    r2new.aaa += einsum(tmp130, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    del tmp130
    tmp66 = tmp64.copy()
    del tmp64
    tmp66 += tmp65
    del tmp65
    r2new.aba += einsum(tmp66, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa += einsum(tmp66, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    del tmp66
    tmp161 = tmp45.transpose((1, 0)).copy() * 2
    del tmp45
    tmp161 += tmp46.transpose((1, 0))
    del tmp46
    tmp161 += einsum(tmp7, (0, 1), t1.aa, (0, 2), (1, 2))
    del tmp7
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp161, (0, 3), (3, 1, 2)) * -1
    del tmp161
    tmp69 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    r2new.aba += einsum(tmp69, (0, 1), r1.b, (2,), (1, 2, 0))
    r2new.aaa += einsum(r1.a, (0,), tmp69, (1, 2), (0, 2, 1)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp69, (1, 2), (2, 0, 1))
    del tmp69
    tmp100 = einsum(t1.aa, (0, 1), tmp39, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp39
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp100, (3, 2, 0, 4), (4, 1, 3)) * -1
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp100, (3, 2, 1, 4), (4, 0, 3)) * 2
    del tmp100
    tmp137 = tmp135.transpose((0, 2, 1)).copy()
    tmp137 += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp136, (0, 4, 3), (2, 1, 4))
    del tmp136
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp137, (1, 2, 4), (4, 3, 0))
    del tmp137
    tmp124 = tmp121.copy() * 2
    del tmp121
    tmp124 += tmp122
    del tmp122
    tmp124 += tmp123
    del tmp123
    r2new.aba += einsum(r1.b, (0,), tmp124, (1, 2), (2, 0, 1))
    r2new.aaa += einsum(r1.a, (0,), tmp124, (1, 2), (2, 0, 1))
    r2new.aaa += einsum(tmp124, (0, 1), r1.a, (2,), (2, 1, 0)) * -1
    del tmp124
    tmp144 = einsum(v.aabb.ooov, (0, 1, 2, 3), r2.aba, (4, 3, 1), (0, 2, 4))
    r2new.aba += einsum(t1.bb, (0, 1), tmp144, (2, 0, 3), (3, 1, 2))
    del tmp144
    tmp148 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    r2new.aba += einsum(tmp148, (0, 1, 2, 3), r2.aba, (4, 3, 1), (4, 2, 0)) * -1
    del tmp148
    tmp90 = tmp87.copy() * 2
    del tmp87
    tmp90 += tmp88
    del tmp88
    tmp90 += tmp89
    del tmp89
    r2new.aba += einsum(r1.b, (0,), tmp90, (1, 2), (2, 0, 1))
    r2new.aaa += einsum(r1.a, (0,), tmp90, (1, 2), (2, 0, 1))
    r2new.aaa += einsum(tmp90, (0, 1), r1.a, (2,), (2, 1, 0)) * -1
    del tmp90
    tmp147 = einsum(tmp135, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    del tmp135
    tmp147 += einsum(tmp111, (0, 1, 2, 3), r2.aba, (4, 3, 1), (0, 2, 4))
    del tmp111
    tmp147 += einsum(t1.aa, (0, 1), tmp146, (2, 0, 3), (2, 3, 1)) * -1
    del tmp146
    r2new.aba += einsum(tmp147, (0, 1, 2), t1.bb, (1, 3), (2, 3, 0))
    del tmp147
    tmp145 = einsum(r1.b, (0,), v.aabb.ooov, (1, 2, 3, 0), (1, 2, 3))
    tmp145 += einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 4, 2)) * -1
    r2new.aba += einsum(tmp127, (0, 1, 2, 3), tmp145, (0, 4, 1), (2, 3, 4)) * -1
    del tmp127, tmp145
    tmp91 = tmp77.transpose((1, 0, 2)).copy()
    tmp91 += tmp78.transpose((1, 0, 2))
    tmp91 += tmp80.transpose((1, 0, 2)) * -1
    r2new.aaa += einsum(t1.aa, (0, 1), tmp91, (0, 2, 3), (1, 3, 2))
    del tmp91
    tmp97 = einsum(tmp96, (0, 1, 2), t1.aa, (3, 1), (3, 2, 0))
    del tmp96
    r2new.aaa += tmp97.transpose((2, 1, 0)) * -1
    r2new.aaa += tmp97.transpose((1, 2, 0))
    del tmp97
    tmp120 = einsum(t1.aa, (0, 1), tmp119, (2, 0, 3), (2, 1, 3))
    del tmp119
    r2new.aaa += tmp120.transpose((1, 2, 0))
    r2new.aaa += tmp120.transpose((2, 1, 0)) * -1
    del tmp120
    tmp32 = einsum(r1.a, (0,), v.aaaa.ovvv, (1, 2, 3, 0), (1, 2, 3))
    r2new.aaa += tmp32.transpose((2, 1, 0))
    r2new.aaa += tmp32.transpose((1, 2, 0)) * -1
    del tmp32
    tmp51 = einsum(tmp50, (0, 1, 2), v.aaaa.ovov, (3, 4, 0, 1), (3, 4, 2))
    del tmp50
    r2new.aaa += tmp51.transpose((2, 1, 0)) * -1
    r2new.aaa += tmp51.transpose((1, 2, 0))
    del tmp51
    tmp49 = einsum(tmp48, (0, 1), r2.aaa, (2, 1, 3), (3, 2, 0)) * -4
    del tmp48
    r2new.aaa += tmp49.transpose((2, 1, 0)) * -1
    r2new.aaa += tmp49.transpose((1, 2, 0))
    del tmp49
    tmp93 = einsum(tmp92, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 4, 2)) * -1
    del tmp92
    r2new.aaa += tmp93.transpose((1, 2, 0))
    r2new.aaa += tmp93.transpose((2, 1, 0)) * -1
    del tmp93
    tmp110 = einsum(r2.aaa, (0, 1, 2), tmp109, (2, 3), (3, 0, 1))
    del tmp109
    r2new.aaa += tmp110.transpose((2, 1, 0))
    r2new.aaa += tmp110.transpose((2, 1, 0))
    del tmp110
    tmp75 = einsum(tmp74, (0, 1, 2), t2.aaaa, (2, 0, 3, 4), (1, 3, 4))
    del tmp74
    r2new.aaa += tmp75.transpose((2, 1, 0)) * -1
    r2new.aaa += tmp75.transpose((2, 1, 0)) * -1
    del tmp75
    tmp105 = einsum(tmp104, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -1
    del tmp104
    r2new.aaa += tmp105.transpose((1, 2, 0)) * -2
    r2new.aaa += tmp105.transpose((2, 1, 0)) * 2
    del tmp105
    tmp58 = einsum(tmp54, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp54
    tmp58 += einsum(tmp57, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp57
    r2new.aaa += einsum(tmp58, (0, 1), r1.a, (2,), (2, 1, 0))
    del tmp58
    tmp42 = einsum(t2.aaaa, (0, 1, 2, 3), tmp41, (1, 4, 3), (0, 2, 4)) * 4
    del tmp41
    r2new.aaa += tmp42.transpose((1, 2, 0)) * -1
    r2new.aaa += tmp42.transpose((2, 1, 0))
    del tmp42
    tmp99 = einsum(t1.aa, (0, 1), tmp98, (2, 0, 3), (2, 1, 3))
    del tmp98
    r2new.aaa += tmp99.transpose((2, 1, 0)) * -1
    r2new.aaa += tmp99.transpose((1, 2, 0))
    del tmp99
    tmp67 = f.aa.ov.copy()
    tmp67 += tmp59
    del tmp59
    tmp67 += tmp4
    del tmp4
    r2new.aaa += einsum(tmp67, (0, 1), r1.a, (2,), (2, 1, 0))
    del tmp67
    tmp34 = einsum(t1.aa, (0, 1), tmp33, (2, 0, 3), (2, 1, 3))
    del tmp33
    r2new.aaa += tmp34.transpose((1, 2, 0)) * -2
    r2new.aaa += tmp34.transpose((2, 1, 0)) * 2
    del tmp34
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), tmp17, (1,), (0, 2, 3)) * -2
    del tmp17
    r2new.aaa += tmp76.transpose((2, 1, 0))
    r2new.aaa += tmp76.transpose((2, 1, 0))
    del tmp76
    tmp132 = einsum(t1.aa, (0, 1), tmp131, (2, 3, 1, 4), (0, 2, 3, 4)) * -1
    del tmp131
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp132, (3, 2, 1, 4), (0, 4, 3)) * 2
    del tmp132
    tmp68 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 2, 4, 1), (3, 0, 4))
    r2new.aaa += tmp68.transpose((1, 2, 0)) * -2
    r2new.aaa += tmp68.transpose((2, 1, 0)) * 2
    del tmp68
    tmp44 = tmp43.copy()
    del tmp43
    tmp44 += einsum(r2.bab, (0, 1, 2), tmp9, (2, 3, 0, 4), (3, 1, 4))
    del tmp9
    tmp44 += einsum(tmp36, (0, 1, 2), v.aabb.ovov, (0, 1, 3, 4), (3, 2, 4)) * -1
    del tmp36
    r2new.aaa += einsum(t2.abab, (0, 1, 2, 3), tmp44, (1, 4, 3), (4, 2, 0))
    del tmp44
    tmp86 = einsum(tmp85, (0, 1), r2.aaa, (2, 3, 0), (1, 2, 3))
    del tmp85
    r2new.aaa += tmp86.transpose((2, 1, 0))
    r2new.aaa += tmp86.transpose((2, 1, 0))
    del tmp86
    tmp95 = einsum(tmp94, (0, 1, 2), t2.aaaa, (1, 2, 3, 4), (0, 3, 4))
    del tmp94
    r2new.aaa += tmp95.transpose((1, 2, 0))
    r2new.aaa += tmp95.transpose((1, 2, 0))
    del tmp95
    tmp81 = tmp77.transpose((1, 0, 2)).copy()
    del tmp77
    tmp81 += tmp78.transpose((1, 0, 2))
    del tmp78
    tmp81 += einsum(tmp73, (0, 1, 2), t1.aa, (1, 3), (2, 0, 3)) * -2
    del tmp73
    tmp81 += tmp80.transpose((1, 0, 2)) * -1
    del tmp80
    r2new.aaa += einsum(tmp81, (0, 1, 2), t1.aa, (0, 3), (2, 3, 1)) * -1
    del tmp81
    tmp72 = einsum(t1.aa, (0, 1), tmp71, (2, 0, 3), (2, 1, 3))
    del tmp71
    r2new.aaa += tmp72.transpose((2, 1, 0))
    r2new.aaa += tmp72.transpose((1, 2, 0)) * -1
    del tmp72
    tmp31 = f.bb.vv.copy()
    tmp31 += tmp30.transpose((1, 0))
    del tmp30
    r1new.b += einsum(r1.b, (0,), tmp31, (0, 1), (1,))
    del tmp31
    r2new.aaa += einsum(v.aaaa.vvvv, (0, 1, 2, 3), r2.aaa, (1, 3, 4), (0, 2, 4)) * 2
    r2new.aba += einsum(r2.aba, (0, 1, 2), v.aaaa.ovov, (3, 4, 2, 0), (4, 1, 3))
    r2new.aba += einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aba, (3, 4, 1), (2, 4, 0)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), v.aabb.oovv, (3, 2, 4, 1), (0, 4, 3)) * -1
    r2new.bab += einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (1, 4, 0))
    r2new.bab += einsum(r2.bab, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 0), (4, 1, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), v.aabb.vvoo, (3, 1, 4, 2), (0, 3, 4)) * -1
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), v.bbbb.vvvv, (3, 0, 4, 1), (3, 4, 2)) * 2

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ee(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:44:57.316685.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    r1new = Namespace()
    r2new = Namespace()
    tmp7 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp7 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp3 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp3 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp6 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp2 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp4 = einsum(t1.aa, (0, 1), tmp3, (0, 2, 3, 1), (2, 3))
    tmp9 = f.bb.ov.copy()
    tmp9 += tmp6
    tmp9 += tmp8 * -1
    del tmp8
    r1new.bb = einsum(r2.bbbb, (0, 1, 2, 3), tmp9, (1, 3), (0, 2)) * 2
    r1new.aa = einsum(r2.abab, (0, 1, 2, 3), tmp9, (1, 3), (0, 2))
    tmp47 = v.bbbb.ooov.copy()
    tmp47 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp15 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy()
    tmp15 += v.bbbb.ovov.transpose((0, 2, 1, 3)) * -1
    tmp11 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp11 += v.aaaa.ovov.transpose((0, 2, 1, 3))
    tmp55 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    r1new.bb += einsum(r2.bbbb, (0, 1, 2, 3), tmp55, (4, 1, 0, 3), (4, 2)) * -2
    tmp14 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.aa, (0, 1), (2, 3))
    r1new.bb += tmp14
    tmp64 = einsum(tmp7, (0, 1, 2, 3), r1.bb, (0, 2), (1, 3))
    tmp5 = f.aa.ov.copy()
    tmp5 += tmp2
    tmp5 += tmp4 * -1
    del tmp4
    r1new.bb += einsum(r2.abab, (0, 1, 2, 3), tmp5, (0, 2), (1, 3))
    r1new.aa += einsum(r2.aaaa, (0, 1, 2, 3), tmp5, (1, 3), (0, 2)) * 2
    tmp152 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp29 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    r1new.aa += einsum(r2.aaaa, (0, 1, 2, 3), tmp29, (4, 0, 1, 3), (4, 2)) * 2
    tmp10 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.bb, (2, 3), (0, 1))
    r1new.aa += tmp10
    tmp39 = einsum(r1.aa, (0, 1), tmp3, (0, 2, 3, 1), (2, 3))
    del tmp3
    tmp21 = v.aaaa.ooov.copy()
    tmp21 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp338 = v.bbbb.ooov.copy()
    tmp338 += v.bbbb.ooov.transpose((0, 2, 1, 3)) * -1
    tmp58 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp271 = einsum(tmp9, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp59 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp62 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp352 = v.bbbb.ooov.copy()
    tmp352 += v.bbbb.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp51 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp52 = einsum(t1.bb, (0, 1), tmp47, (0, 2, 3, 1), (2, 3))
    tmp214 = r2.bbbb.copy() * 2
    tmp214 += einsum(t1.bb, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1)) * -1
    tmp325 = v.bbbb.ovvv.copy() * -1
    tmp325 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp195 = einsum(tmp15, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp192 = einsum(tmp11, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp56 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    r2new.abab = einsum(tmp56, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4)) * -1
    r1new.bb += einsum(r2.abab, (0, 1, 2, 3), tmp56, (0, 4, 1, 2), (4, 3)) * -1
    tmp266 = tmp55.copy()
    tmp266 += tmp55.transpose((0, 2, 1, 3)) * -1
    tmp65 = tmp14.copy()
    tmp65 += tmp64 * -1
    del tmp64
    tmp241 = v.bbbb.ovvv.copy()
    tmp241 += v.bbbb.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp37 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (0, 2, 3, 1), (2, 3))
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp33 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp35 = einsum(tmp5, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp106 = v.aaaa.ooov.copy()
    tmp106 += v.aaaa.ooov.transpose((0, 2, 1, 3)) * -1
    tmp124 = v.aaaa.ooov.copy()
    tmp124 += v.aaaa.ovoo.transpose((0, 2, 3, 1)) * -1
    tmp73 = r2.aaaa.copy() * 2
    tmp73 += einsum(r1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    tmp176 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp176 += v.aaaa.ovov.transpose((0, 2, 1, 3)) * -1
    tmp30 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    r2new.abab += einsum(r1.aa, (0, 1), tmp30, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    r1new.aa += einsum(tmp30, (0, 1, 2, 3), r2.abab, (1, 2, 4, 3), (0, 4)) * -1
    tmp161 = tmp152.transpose((0, 2, 1, 3)).copy() * -1
    tmp161 += tmp152.transpose((0, 3, 2, 1))
    tmp159 = tmp29.copy()
    tmp159 += tmp29.transpose((0, 2, 1, 3)) * -1
    tmp135 = tmp29.copy()
    tmp135 += tmp29.transpose((0, 2, 1, 3)) * -1
    tmp182 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp182 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp85 = v.aaaa.ovvv.copy()
    tmp85 += v.aaaa.ovvv.transpose((0, 2, 3, 1)) * -1
    tmp40 = tmp10.copy()
    tmp40 += tmp39 * -1
    del tmp39
    tmp26 = einsum(tmp21, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp25 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp92 = v.aaaa.ovvv.copy() * -1
    tmp92 += v.aaaa.ovvv.transpose((0, 2, 3, 1))
    tmp340 = einsum(r2.bbbb, (0, 1, 2, 3), tmp338, (4, 5, 1, 3), (4, 5, 0, 2)) * 2
    tmp336 = einsum(r1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp337 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp217 = v.bbbb.ovvv.copy() * -1
    tmp217 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp272 = tmp58.transpose((1, 0)).copy() * 0.5
    tmp272 += tmp59.transpose((1, 0))
    tmp272 += tmp271.transpose((1, 0))
    del tmp271
    tmp259 = t2.bbbb.copy() * 2
    tmp259 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp261 = f.bb.vv.copy()
    tmp261 += tmp62.transpose((1, 0))
    tmp141 = t2.abab.copy()
    tmp141 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp353 = einsum(t1.bb, (0, 1), tmp352, (0, 2, 3, 1), (2, 3))
    tmp53 = f.bb.oo.copy()
    tmp53 += tmp51.transpose((1, 0))
    tmp53 += tmp52.transpose((1, 0)) * -1
    del tmp52
    r2new.abab += einsum(tmp53, (0, 1), r2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    r1new.bb += einsum(tmp53, (0, 1), r1.bb, (0, 2), (1, 2)) * -1
    tmp280 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    r2new.bbbb = tmp280.transpose((1, 0, 2, 3)).copy() * -1
    r2new.bbbb += tmp280
    r2new.bbbb += tmp280.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp280.transpose((0, 1, 3, 2)) * -1
    tmp393 = einsum(tmp15, (0, 1, 2, 3), tmp214, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp394 = einsum(r1.bb, (0, 1), tmp352, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp352
    tmp286 = einsum(r2.abab, (0, 1, 2, 3), tmp11, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp285 = einsum(v.aabb.ovoo, (0, 1, 2, 3), r1.bb, (3, 4), (0, 2, 1, 4))
    r2new.abab += tmp285 * -1
    tmp215 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp214, (2, 4, 3, 5), (0, 4, 1, 5))
    r2new.abab += tmp215
    tmp380 = tmp55.copy()
    tmp380 += tmp55.transpose((0, 2, 1, 3)) * -1
    tmp369 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp45 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp48 = einsum(r1.bb, (0, 1), tmp47, (0, 2, 3, 1), (2, 3))
    tmp46 = einsum(r2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp44 = einsum(r1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp49 = einsum(tmp9, (0, 1), r1.bb, (2, 1), (2, 0))
    tmp246 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp326 = einsum(t1.bb, (0, 1), tmp325, (0, 1, 2, 3), (2, 3))
    del tmp325
    tmp330 = einsum(v.bbbb.ooov, (0, 1, 2, 3), r1.bb, (4, 3), (4, 0, 1, 2))
    tmp196 = f.bb.ov.copy()
    tmp196 += tmp6
    tmp196 += tmp195 * -1
    del tmp195
    tmp193 = f.aa.ov.copy()
    tmp193 += tmp2
    tmp193 += tmp192 * -1
    del tmp192
    tmp60 = einsum(tmp9, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp360 = einsum(tmp56, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp361 = einsum(t2.bbbb, (0, 1, 2, 3), tmp266, (4, 1, 5, 3), (4, 5, 0, 2))
    tmp321 = v.bbbb.ovvv.copy() * -1
    tmp321 += v.bbbb.ovvv.transpose((0, 2, 1, 3))
    tmp348 = einsum(tmp9, (0, 1), t1.bb, (0, 2), (2, 1))
    tmp232 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp231 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp373 = einsum(tmp55, (0, 1, 2, 3), r1.bb, (4, 3), (4, 0, 1, 2))
    tmp401 = einsum(t1.bb, (0, 1), tmp55, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp239 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp244 = einsum(t1.bb, (0, 1), tmp65, (0, 2), (1, 2))
    tmp240 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbbb, (0, 2, 4, 3), (4, 1))
    tmp243 = einsum(r1.bb, (0, 1), tmp9, (0, 2), (1, 2))
    tmp238 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r1.aa, (0, 1), (2, 3))
    tmp242 = einsum(r1.bb, (0, 1), tmp241, (0, 1, 2, 3), (2, 3))
    del tmp241
    tmp345 = einsum(r2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp407 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp139 = t2.aaaa.copy() * 2
    tmp139 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp143 = f.aa.vv.copy()
    tmp143 += tmp37 * -1
    tmp36 = tmp33.transpose((1, 0)).copy() * 2
    tmp36 += tmp34.transpose((1, 0))
    tmp36 += tmp35.transpose((1, 0))
    r2new.abab += einsum(tmp36, (0, 1), r2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    r1new.aa += einsum(r1.aa, (0, 1), tmp36, (0, 2), (2, 1)) * -1
    tmp16 = einsum(r1.bb, (0, 1), tmp15, (0, 2, 1, 3), (2, 3))
    del tmp15
    tmp148 = einsum(tmp29, (0, 1, 2, 3), r1.aa, (4, 3), (4, 0, 1, 2))
    tmp107 = einsum(r2.aaaa, (0, 1, 2, 3), tmp106, (4, 5, 1, 3), (4, 5, 0, 2)) * 2
    tmp104 = einsum(r1.aa, (0, 1), v.aaaa.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp105 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp115 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp97 = einsum(v.aaaa.ooov, (0, 1, 2, 3), r1.aa, (4, 3), (4, 0, 1, 2))
    tmp125 = einsum(tmp124, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp69 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    r2new.aaaa = tmp69.transpose((1, 0, 2, 3)).copy() * -1
    r2new.aaaa += tmp69
    r2new.aaaa += tmp69.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp69.transpose((0, 1, 3, 2)) * -1
    tmp177 = einsum(tmp176, (0, 1, 2, 3), tmp73, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp176
    tmp178 = einsum(r1.aa, (0, 1), tmp124, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp124
    tmp158 = einsum(r2.abab, (0, 1, 2, 3), tmp30, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp162 = einsum(r1.aa, (0, 1), tmp161, (2, 0, 3, 4), (2, 3, 4, 1)) * 0.5
    del tmp161
    tmp160 = einsum(tmp159, (0, 1, 2, 3), r2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5))
    del tmp159
    tmp199 = einsum(t1.aa, (0, 1), tmp29, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp134 = einsum(tmp30, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp136 = einsum(tmp135, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5))
    tmp205 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp183 = einsum(r2.abab, (0, 1, 2, 3), tmp182, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp182
    tmp181 = einsum(r1.aa, (0, 1), v.aabb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    r2new.abab += tmp181 * -1
    tmp184 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp73, (0, 4, 1, 5), (4, 2, 5, 3))
    r2new.abab += tmp184
    tmp19 = einsum(r2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp18 = einsum(r1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp22 = einsum(tmp21, (0, 1, 2, 3), r1.aa, (0, 3), (1, 2))
    tmp23 = einsum(tmp5, (0, 1), r1.aa, (2, 1), (2, 0))
    tmp20 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp70 = v.aaaa.ovvv.copy() * -1
    tmp70 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp82 = einsum(r1.bb, (0, 1), v.aabb.vvov, (2, 3, 0, 1), (2, 3))
    tmp86 = einsum(tmp85, (0, 1, 2, 3), r1.aa, (0, 1), (2, 3))
    del tmp85
    tmp83 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaaa, (0, 2, 4, 1), (4, 3)) * -1
    tmp84 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp88 = einsum(tmp40, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp87 = einsum(r1.aa, (0, 1), tmp5, (0, 2), (1, 2))
    tmp27 = f.aa.oo.copy()
    tmp27 += tmp25.transpose((1, 0))
    tmp27 += tmp26.transpose((1, 0)) * -1
    del tmp26
    r1new.aa += einsum(tmp27, (0, 1), r1.aa, (0, 2), (1, 2)) * -1
    tmp120 = einsum(tmp5, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp119 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp118 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp91 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp93 = einsum(t1.aa, (0, 1), tmp92, (0, 1, 2, 3), (2, 3))
    del tmp92
    tmp79 = v.aaaa.ovvv.copy() * -1
    tmp79 += v.aaaa.ovvv.transpose((0, 2, 1, 3))
    tmp341 = tmp336.transpose((1, 0, 2, 3)).copy()
    tmp341 += tmp337.transpose((0, 2, 1, 3))
    tmp341 += tmp340.transpose((2, 1, 0, 3))
    tmp218 = einsum(r1.bb, (0, 1), tmp217, (2, 3, 1, 4), (2, 0, 3, 4))
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp218, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    tmp270 = einsum(tmp55, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4)) * -1
    tmp269 = einsum(t2.abab, (0, 1, 2, 3), tmp56, (0, 4, 1, 2), (4, 3))
    tmp385 = einsum(tmp272, (0, 1), t1.bb, (0, 2), (1, 2)) * 2
    tmp365 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp259, (0, 4, 3, 1), (4, 2))
    tmp366 = einsum(t1.bb, (0, 1), tmp261, (1, 2), (0, 2))
    tmp364 = einsum(tmp141, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp354 = f.bb.oo.copy()
    tmp354 += tmp51.transpose((1, 0))
    del tmp51
    tmp354 += tmp353.transpose((1, 0)) * -1
    del tmp353
    tmp225 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3))
    tmp343 = einsum(t1.bb, (0, 1), tmp53, (0, 2), (2, 1)) * 0.5
    tmp226 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp219 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp395 = tmp280.copy()
    tmp395 += tmp393 * -1
    del tmp393
    tmp395 += tmp394.transpose((0, 1, 3, 2)) * -1
    del tmp394
    tmp283 = einsum(tmp47, (0, 1, 2, 3), r1.bb, (0, 4), (1, 2, 4, 3)) * 0.5
    tmp281 = r2.bbbb.copy() * 2
    tmp281 += einsum(t1.bb, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1)) * -1
    tmp287 = tmp285.copy()
    del tmp285
    tmp287 += tmp286
    del tmp286
    tmp287 += tmp215 * -1
    del tmp215
    r2new.abab += einsum(t2.aaaa, (0, 1, 2, 3), tmp287, (1, 4, 3, 5), (0, 4, 2, 5)) * -2
    tmp381 = einsum(tmp380, (0, 1, 2, 3), r2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5))
    tmp379 = einsum(tmp56, (0, 1, 2, 3), r2.abab, (0, 4, 3, 5), (4, 1, 2, 5))
    tmp382 = tmp369.transpose((0, 2, 1, 3)).copy()
    tmp382 += tmp369.transpose((0, 3, 2, 1)) * -1
    tmp387 = einsum(tmp380, (0, 1, 2, 3), r2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * 2
    del tmp380
    tmp254 = einsum(tmp217, (0, 1, 2, 3), t1.bb, (4, 2), (0, 4, 1, 3))
    del tmp217
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), tmp254, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    tmp257 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    r2new.abab += einsum(tmp73, (0, 1, 2, 3), tmp257, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp50 = tmp44.transpose((1, 0)).copy()
    tmp50 += tmp45.transpose((1, 0))
    tmp50 += tmp46.transpose((1, 0)) * 2
    tmp50 += tmp48.transpose((1, 0)) * -1
    del tmp48
    tmp50 += tmp49.transpose((1, 0))
    del tmp49
    r1new.bb += einsum(t1.bb, (0, 1), tmp50, (0, 2), (2, 1)) * -1
    tmp403 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp327 = f.bb.vv.copy()
    tmp327 += tmp246.transpose((1, 0))
    tmp327 += tmp326.transpose((1, 0)) * -1
    del tmp326
    tmp332 = einsum(tmp330, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4))
    tmp371 = einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp290 = einsum(tmp196, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp289 = einsum(tmp193, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp377 = tmp58.copy()
    tmp377 += tmp59 * 2
    tmp377 += tmp60
    tmp362 = tmp360.copy()
    del tmp360
    tmp362 += tmp361.transpose((0, 2, 1, 3)) * 2
    del tmp361
    tmp322 = einsum(tmp321, (0, 1, 2, 3), r1.bb, (4, 2), (0, 4, 1, 3))
    tmp319 = einsum(r2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp216 = einsum(r1.bb, (0, 1), v.aabb.ovvv, (2, 3, 4, 1), (2, 0, 3, 4))
    r2new.abab += tmp216
    r2new.abab += einsum(tmp216, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 2
    tmp66 = einsum(t1.bb, (0, 1), tmp65, (2, 1), (0, 2))
    del tmp65
    r1new.bb += einsum(t1.bb, (0, 1), tmp66, (2, 0), (2, 1)) * -1
    tmp349 = tmp231.copy()
    tmp349 += tmp232 * 2
    tmp349 += tmp348
    del tmp348
    tmp375 = einsum(tmp373, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp260 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp259, (0, 4, 3, 1), (4, 2)) * 0.5
    del tmp259
    tmp262 = einsum(t1.bb, (0, 1), tmp261, (1, 2), (0, 2)) * 0.5
    del tmp261
    tmp258 = einsum(tmp141, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4)) * 0.5
    tmp405 = einsum(tmp401, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4))
    tmp245 = tmp238.transpose((1, 0)).copy() * -1
    del tmp238
    tmp245 += tmp239.transpose((1, 0))
    del tmp239
    tmp245 += tmp240.transpose((1, 0)) * 2
    del tmp240
    tmp245 += tmp242.transpose((1, 0)) * -1
    del tmp242
    tmp245 += tmp243.transpose((1, 0))
    del tmp243
    tmp245 += tmp244.transpose((1, 0))
    del tmp244
    r2new.abab += einsum(tmp245, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    tmp389 = tmp369.transpose((0, 2, 1, 3)).copy() * -1
    tmp389 += tmp369.transpose((0, 3, 2, 1))
    tmp410 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp227 = einsum(t1.bb, (0, 1), tmp53, (0, 2), (2, 1))
    tmp346 = tmp330.transpose((0, 2, 1, 3)).copy()
    tmp346 += tmp345.transpose((1, 3, 0, 2)) * -1
    tmp408 = einsum(t1.bb, (0, 1), tmp407, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp407
    tmp298 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp109 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp110 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp293 = r2.abab.copy()
    tmp293 += einsum(r1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    r2new.abab += einsum(tmp293, (0, 1, 2, 3), v.aabb.oovv, (4, 0, 5, 3), (4, 1, 2, 5)) * -1
    tmp142 = einsum(tmp141, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp140 = einsum(tmp139, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 3), (1, 4))
    del tmp139
    tmp144 = einsum(t1.aa, (0, 1), tmp143, (1, 2), (0, 2))
    del tmp143
    tmp295 = r2.abab.copy()
    tmp295 += einsum(r1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    r2new.abab += einsum(tmp295, (0, 1, 2, 3), v.aabb.vvoo, (4, 2, 5, 1), (0, 5, 4, 3)) * -1
    tmp197 = einsum(t2.abab, (0, 1, 2, 3), tmp196, (1, 3), (0, 2))
    del tmp196
    tmp194 = einsum(tmp193, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    del tmp193
    tmp75 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp247 = v.bbbb.ovvv.copy() * -1
    tmp247 += v.bbbb.ovvv.transpose((0, 2, 3, 1))
    tmp300 = einsum(tmp56, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp277 = r2.abab.copy()
    tmp277 += einsum(r1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp275 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    r2new.abab += einsum(tmp275, (0, 1, 2, 3), r2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp250 = v.aaaa.ooov.copy() * -1
    tmp250 += v.aaaa.ovoo.transpose((0, 2, 3, 1))
    tmp166 = einsum(t2.aaaa, (0, 1, 2, 3), tmp29, (4, 0, 1, 3), (4, 2)) * -1
    tmp170 = einsum(t1.aa, (0, 1), tmp36, (0, 2), (2, 1))
    tmp167 = einsum(tmp30, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp304 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp265 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    r2new.abab += einsum(tmp265, (0, 1, 2, 3), r2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp17 = tmp14.copy()
    del tmp14
    tmp17 += tmp16 * -1
    del tmp16
    r1new.bb += einsum(tmp17, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2
    r1new.aa += einsum(tmp17, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp223 = v.bbbb.ooov.copy() * -1
    tmp223 += v.bbbb.ovoo.transpose((0, 2, 3, 1))
    tmp255 = tmp55.copy() * -1
    tmp255 += tmp55.transpose((0, 2, 1, 3))
    tmp282 = v.bbbb.ovov.transpose((0, 2, 3, 1)).copy() * -1
    tmp282 += v.bbbb.ovov.transpose((0, 2, 1, 3))
    tmp154 = einsum(tmp148, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp77 = einsum(r2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp113 = tmp104.transpose((1, 0, 2, 3)).copy()
    tmp113 += tmp105.transpose((0, 2, 1, 3))
    tmp113 += tmp107.transpose((2, 1, 0, 3))
    tmp190 = v.aaaa.ovov.transpose((0, 2, 3, 1)).copy()
    tmp190 += v.aaaa.ovov.transpose((0, 2, 1, 3)) * -1
    tmp189 = r2.aaaa.copy() * 2
    tmp189 += einsum(r1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    tmp116 = tmp97.transpose((0, 2, 1, 3)).copy()
    tmp116 += tmp115.transpose((1, 3, 0, 2)) * -1
    tmp126 = f.aa.oo.copy()
    tmp126 += tmp25.transpose((1, 0))
    del tmp25
    tmp126 += tmp125.transpose((1, 0)) * -1
    del tmp125
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), tmp126, (0, 4), (4, 1, 2, 3)) * -1
    tmp179 = tmp69.copy()
    tmp179 += tmp177.transpose((1, 0, 3, 2)) * -1
    tmp179 += tmp178.transpose((0, 1, 3, 2)) * -1
    tmp129 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    r2new.abab += einsum(tmp214, (0, 1, 2, 3), tmp129, (4, 0, 5, 2), (4, 1, 5, 3))
    tmp172 = tmp158.transpose((1, 2, 0, 3)).copy() * 0.5
    tmp172 += tmp160
    tmp172 += tmp162.transpose((0, 2, 1, 3))
    tmp201 = einsum(tmp199, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    tmp41 = einsum(tmp40, (0, 1), t1.aa, (2, 1), (2, 0))
    del tmp40
    r2new.abab += einsum(tmp41, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    r1new.aa += einsum(t1.aa, (0, 1), tmp41, (2, 0), (2, 1)) * -1
    tmp163 = tmp158.transpose((1, 0, 2, 3)).copy() * 0.5
    del tmp158
    tmp163 += tmp160.transpose((0, 2, 1, 3))
    del tmp160
    tmp163 += tmp162
    del tmp162
    tmp150 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp208 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp137 = tmp134.copy()
    del tmp134
    tmp137 += tmp136.transpose((0, 2, 1, 3)) * 2
    del tmp136
    tmp206 = einsum(t1.aa, (0, 1), tmp205, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp205
    tmp185 = tmp181.copy()
    del tmp181
    tmp185 += tmp183 * -1
    del tmp183
    tmp185 += tmp184 * -1
    del tmp184
    r2new.abab += einsum(tmp185, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    tmp67 = einsum(r1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    r2new.abab += tmp67
    r2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp67, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    tmp24 = tmp18.transpose((1, 0)).copy()
    tmp24 += tmp19.transpose((1, 0)) * 2
    tmp24 += tmp20.transpose((1, 0))
    tmp24 += tmp22.transpose((1, 0)) * -1
    del tmp22
    tmp24 += tmp23.transpose((1, 0))
    del tmp23
    r1new.aa += einsum(t1.aa, (0, 1), tmp24, (0, 2), (2, 1)) * -1
    tmp146 = einsum(tmp70, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    r2new.abab += einsum(tmp146, (0, 1, 2, 3), r2.abab, (1, 4, 2, 5), (0, 4, 3, 5)) * -1
    tmp89 = tmp82.transpose((1, 0)).copy() * -1
    del tmp82
    tmp89 += tmp83.transpose((1, 0)) * 2
    del tmp83
    tmp89 += tmp84.transpose((1, 0))
    del tmp84
    tmp89 += tmp86.transpose((1, 0)) * -1
    del tmp86
    tmp89 += tmp87.transpose((1, 0))
    del tmp87
    tmp89 += tmp88.transpose((1, 0))
    del tmp88
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp89, (2, 4), (0, 1, 4, 3)) * -1
    tmp156 = tmp33.copy() * 2
    del tmp33
    tmp156 += tmp34
    del tmp34
    tmp156 += tmp35
    del tmp35
    tmp203 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp111 = einsum(tmp27, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp121 = tmp118.copy() * 2
    tmp121 += tmp119
    tmp121 += tmp120
    tmp168 = einsum(t1.aa, (0, 1), tmp36, (0, 2), (2, 1)) * 0.5
    del tmp36
    tmp94 = f.aa.vv.copy()
    tmp94 += tmp91.transpose((1, 0))
    del tmp91
    tmp94 += tmp93.transpose((1, 0)) * -1
    del tmp93
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), tmp94, (2, 4), (0, 1, 4, 3))
    tmp80 = einsum(tmp79, (0, 1, 2, 3), r1.aa, (4, 2), (4, 0, 1, 3))
    r2new.abab += einsum(tmp80, (0, 1, 2, 3), t2.abab, (1, 4, 2, 5), (0, 4, 3, 5)) * -1
    tmp100 = einsum(tmp97, (0, 1, 2, 3), t1.aa, (3, 4), (0, 2, 1, 4))
    tmp71 = einsum(tmp70, (0, 1, 2, 3), r1.aa, (4, 2), (4, 0, 1, 3))
    del tmp70
    tmp12 = einsum(r1.aa, (0, 1), tmp11, (0, 2, 3, 1), (2, 3))
    del tmp11
    tmp342 = einsum(t1.bb, (0, 1), tmp341, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp341
    r2new.bbbb += tmp342.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp342.transpose((0, 1, 3, 2))
    del tmp342
    tmp316 = einsum(t2.bbbb, (0, 1, 2, 3), tmp218, (1, 4, 3, 5), (4, 0, 5, 2)) * -1
    del tmp218
    r2new.bbbb += tmp316.transpose((1, 0, 3, 2)) * 2
    r2new.bbbb += tmp316.transpose((1, 0, 2, 3)) * -2
    del tmp316
    tmp386 = tmp269.copy()
    tmp386 += tmp270 * 2
    tmp386 += tmp385
    del tmp385
    r2new.bbbb += einsum(tmp386, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3)) * -1
    r2new.bbbb += einsum(tmp386, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1))
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp386, (2, 3), (0, 2, 3, 1))
    r2new.bbbb += einsum(tmp386, (0, 1), r1.bb, (2, 3), (2, 0, 3, 1)) * -1
    del tmp386
    tmp413 = r2.bbbb.copy()
    tmp413 += einsum(r1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * 2
    tmp367 = tmp364.copy()
    del tmp364
    tmp367 += tmp365 * -1
    del tmp365
    tmp367 += tmp366
    del tmp366
    r2new.bbbb += einsum(tmp367, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3))
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp367, (2, 3), (0, 2, 3, 1)) * -1
    del tmp367
    tmp355 = einsum(r2.bbbb, (0, 1, 2, 3), tmp354, (1, 4), (4, 0, 2, 3)) * -1
    del tmp354
    r2new.bbbb += tmp355.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp355.transpose((0, 1, 3, 2))
    del tmp355
    tmp344 = tmp225.copy() * 0.5
    tmp344 += tmp226
    tmp344 += tmp343
    del tmp343
    r2new.bbbb += einsum(tmp344, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3)) * -2
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp344, (2, 3), (0, 2, 3, 1)) * 2
    del tmp344
    tmp329 = einsum(r2.bbbb, (0, 1, 2, 3), v.bbbb.oooo, (4, 1, 5, 0), (4, 5, 2, 3)) * -1
    r2new.bbbb += tmp329.transpose((1, 0, 3, 2)) * 0.5
    r2new.bbbb += tmp329.transpose((1, 0, 3, 2)) * 0.5
    r2new.bbbb += tmp329.transpose((1, 0, 3, 2)) * 0.5
    r2new.bbbb += tmp329.transpose((1, 0, 3, 2)) * 0.5
    del tmp329
    tmp331 = einsum(tmp330, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    del tmp330
    r2new.bbbb += tmp331.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp331.transpose((0, 1, 3, 2))
    del tmp331
    tmp318 = f.bb.ov.copy()
    tmp318 += tmp6
    tmp318 += tmp219
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp318, (2, 3), (0, 2, 3, 1)) * -1
    del tmp318
    tmp396 = einsum(t2.bbbb, (0, 1, 2, 3), tmp395, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp395
    r2new.bbbb += tmp396.transpose((1, 0, 2, 3)) * -2
    r2new.bbbb += tmp396 * 2
    r2new.bbbb += tmp396.transpose((0, 1, 3, 2)) * -2
    del tmp396
    tmp220 = f.bb.ov.copy()
    tmp220 += tmp6
    del tmp6
    tmp220 += tmp219
    del tmp219
    r2new.bbbb += einsum(tmp220, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1)) * -1
    r2new.bbbb += einsum(tmp220, (0, 1), r1.bb, (2, 3), (2, 0, 3, 1))
    r2new.bbbb += einsum(tmp220, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3))
    r2new.abab += einsum(tmp220, (0, 1), r1.aa, (2, 3), (2, 0, 3, 1))
    del tmp220
    tmp399 = einsum(t2.abab, (0, 1, 2, 3), tmp5, (0, 2), (1, 3)) * 0.5
    tmp399 += einsum(t2.bbbb, (0, 1, 2, 3), tmp9, (1, 3), (0, 2))
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp399, (2, 3), (0, 2, 3, 1)) * -2
    del tmp399
    tmp339 = tmp336.transpose((1, 0, 2, 3)).copy() * 0.5
    tmp339 += tmp337.transpose((2, 0, 1, 3)) * 0.5
    tmp339 += einsum(r2.bbbb, (0, 1, 2, 3), tmp338, (4, 5, 1, 3), (5, 0, 4, 2))
    del tmp338
    r2new.bbbb += einsum(t1.bb, (0, 1), tmp339, (0, 2, 3, 4), (2, 3, 4, 1)) * -2
    del tmp339
    tmp317 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp214, (2, 4, 3, 5), (4, 0, 5, 1))
    r2new.bbbb += tmp317.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp317
    r2new.bbbb += tmp317.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp317.transpose((0, 1, 3, 2)) * -1
    del tmp317
    tmp400 = tmp280.copy() * 0.5
    tmp400 += einsum(tmp281, (0, 1, 2, 3), tmp7, (0, 4, 2, 5), (1, 4, 3, 5)) * -0.5
    del tmp7
    tmp400 += tmp283 * -1
    r2new.bbbb += einsum(tmp400, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2)) * 4
    del tmp400
    tmp397 = einsum(t2.abab, (0, 1, 2, 3), tmp287, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp287
    r2new.bbbb += tmp397.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp397 * -1
    r2new.bbbb += tmp397.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp397.transpose((0, 1, 3, 2))
    del tmp397
    tmp383 = tmp379.transpose((1, 0, 2, 3)).copy() * 0.5
    tmp383 += tmp381.transpose((0, 2, 1, 3))
    tmp383 += einsum(tmp382, (0, 1, 2, 3), r1.bb, (3, 4), (0, 2, 1, 4)) * 0.5
    r2new.bbbb += einsum(t1.bb, (0, 1), tmp383, (2, 3, 0, 4), (3, 2, 4, 1)) * -2
    del tmp383
    tmp388 = tmp379.transpose((1, 0, 2, 3)).copy()
    tmp388 += tmp387.transpose((0, 2, 1, 3))
    tmp388 += einsum(tmp382, (0, 1, 2, 3), r1.bb, (3, 4), (0, 2, 1, 4))
    del tmp382
    r2new.bbbb += einsum(tmp388, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 4, 3))
    del tmp388
    tmp368 = einsum(tmp214, (0, 1, 2, 3), tmp254, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp254
    r2new.bbbb += tmp368.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp368
    r2new.bbbb += tmp368.transpose((1, 0, 3, 2))
    del tmp368
    tmp357 = einsum(r2.abab, (0, 1, 2, 3), tmp257, (0, 4, 2, 5), (1, 4, 3, 5))
    r2new.bbbb += tmp357.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp357
    r2new.bbbb += tmp357.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp357.transpose((0, 1, 3, 2)) * -1
    del tmp357
    tmp334 = einsum(t2.bbbb, (0, 1, 2, 3), tmp50, (1, 4), (0, 4, 2, 3)) * -1
    del tmp50
    r2new.bbbb += tmp334.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp334.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp334.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp334.transpose((0, 1, 3, 2)) * -1
    del tmp334
    tmp404 = einsum(r1.bb, (0, 1), tmp403, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp403
    r2new.bbbb += tmp404.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp404
    r2new.bbbb += tmp404.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp404.transpose((1, 0, 2, 3)) * -1
    del tmp404
    tmp374 = einsum(tmp373, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    del tmp373
    r2new.bbbb += tmp374.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp374.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp374.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp374.transpose((0, 1, 3, 2)) * -1
    del tmp374
    tmp328 = einsum(tmp327, (0, 1), r2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp327
    r2new.bbbb += tmp328.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp328.transpose((1, 0, 2, 3)) * -1
    del tmp328
    tmp414 = einsum(t1.bb, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1)) * 2
    tmp414 += r2.bbbb * -1
    tmp333 = einsum(t1.bb, (0, 1), tmp332, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp332
    r2new.bbbb += tmp333.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp333.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp333.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp333 * -1
    del tmp333
    tmp372 = einsum(r1.bb, (0, 1), tmp371, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp371
    r2new.bbbb += tmp372
    r2new.bbbb += tmp372.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp372.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp372.transpose((1, 0, 3, 2))
    del tmp372
    tmp398 = einsum(v.bbbb.oovv, (0, 1, 2, 3), tmp214, (1, 4, 3, 5), (4, 0, 5, 2))
    r2new.bbbb += tmp398.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp398.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp398 * -1
    r2new.bbbb += tmp398.transpose((1, 0, 2, 3))
    del tmp398
    tmp291 = tmp289.copy()
    del tmp289
    tmp291 += tmp290 * 2
    del tmp290
    r2new.bbbb += einsum(tmp291, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1)) * -1
    r2new.bbbb += einsum(tmp291, (0, 1), r1.bb, (2, 3), (2, 0, 3, 1))
    r2new.bbbb += einsum(tmp291, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3))
    r2new.abab += einsum(tmp291, (0, 1), r1.aa, (2, 3), (2, 0, 3, 1))
    del tmp291
    tmp351 = tmp336.transpose((1, 0, 2, 3)).copy()
    del tmp336
    tmp351 += tmp337.transpose((2, 0, 1, 3))
    del tmp337
    tmp351 += einsum(tmp345, (0, 1, 2, 3), t1.bb, (2, 4), (3, 1, 0, 4)) * 2
    del tmp345
    tmp351 += tmp340.transpose((1, 2, 0, 3))
    del tmp340
    r2new.bbbb += einsum(t1.bb, (0, 1), tmp351, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp351
    tmp279 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp279, (2, 3), (0, 2, 3, 1))
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp279, (2, 3), (2, 0, 3, 1)) * -1
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp279, (2, 3), (0, 2, 1, 3)) * -1
    r2new.bbbb += einsum(tmp279, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1))
    r2new.abab += einsum(r1.aa, (0, 1), tmp279, (2, 3), (0, 2, 1, 3)) * -1
    del tmp279
    tmp378 = einsum(r2.bbbb, (0, 1, 2, 3), tmp377, (4, 1), (4, 0, 2, 3)) * -1
    del tmp377
    r2new.bbbb += tmp378.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp378.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp378.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp378.transpose((1, 0, 3, 2)) * -1
    del tmp378
    tmp370 = einsum(r2.bbbb, (0, 1, 2, 3), tmp369, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp369
    r2new.bbbb += tmp370.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp370.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp370.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp370.transpose((1, 0, 3, 2)) * -1
    del tmp370
    tmp412 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    r2new.bbbb += einsum(tmp412, (0, 1, 2, 3), tmp414, (2, 3, 4, 5), (1, 0, 5, 4)) * -1
    del tmp414
    r2new.bbbb += einsum(tmp412, (0, 1, 2, 3), tmp413, (2, 3, 4, 5), (1, 0, 5, 4))
    del tmp412, tmp413
    tmp363 = einsum(r1.bb, (0, 1), tmp362, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp362
    r2new.bbbb += tmp363
    r2new.bbbb += tmp363.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp363.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp363.transpose((1, 0, 3, 2))
    del tmp363
    tmp323 = einsum(t2.bbbb, (0, 1, 2, 3), tmp322, (1, 4, 3, 5), (4, 0, 5, 2)) * -2
    del tmp322
    r2new.bbbb += tmp323.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp323
    del tmp323
    tmp320 = einsum(t1.bb, (0, 1), tmp319, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp319
    r2new.bbbb += tmp320 * -2
    r2new.bbbb += tmp320.transpose((0, 1, 3, 2)) * 2
    del tmp320
    tmp315 = einsum(t2.abab, (0, 1, 2, 3), tmp216, (0, 4, 2, 5), (4, 1, 3, 5))
    del tmp216
    r2new.bbbb += tmp315 * -1
    r2new.bbbb += tmp315.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp315.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp315.transpose((1, 0, 3, 2)) * -1
    del tmp315
    tmp384 = einsum(t2.bbbb, (0, 1, 2, 3), tmp66, (4, 1), (0, 4, 2, 3)) * -1
    del tmp66
    r2new.bbbb += tmp384.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp384.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp384.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp384.transpose((0, 1, 3, 2)) * -1
    del tmp384
    tmp350 = einsum(tmp349, (0, 1), r2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4)) * -2
    del tmp349
    r2new.bbbb += tmp350.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp350.transpose((1, 0, 3, 2)) * -1
    del tmp350
    tmp376 = einsum(tmp375, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp375
    r2new.bbbb += tmp376.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp376.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp376.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp376
    del tmp376
    tmp263 = tmp258.copy()
    del tmp258
    tmp263 += tmp260 * -1
    del tmp260
    tmp263 += tmp262
    del tmp262
    r2new.bbbb += einsum(tmp263, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1)) * -2
    r2new.bbbb += einsum(r1.bb, (0, 1), tmp263, (2, 3), (0, 2, 1, 3)) * 2
    r2new.abab += einsum(r1.aa, (0, 1), tmp263, (2, 3), (0, 2, 1, 3)) * 2
    del tmp263
    tmp406 = einsum(tmp405, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 4, 3))
    del tmp405
    r2new.bbbb += tmp406.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp406.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp406.transpose((1, 0, 2, 3)) * -1
    r2new.bbbb += tmp406
    del tmp406
    tmp324 = einsum(t2.bbbb, (0, 1, 2, 3), tmp245, (3, 4), (0, 1, 4, 2)) * -2
    del tmp245
    r2new.bbbb += tmp324.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp324.transpose((1, 0, 2, 3))
    del tmp324
    tmp391 = tmp379.transpose((1, 2, 0, 3)).copy()
    tmp391 += tmp387
    del tmp387
    tmp391 += einsum(r1.bb, (0, 1), tmp389, (2, 0, 3, 4), (2, 4, 3, 1))
    r2new.bbbb += einsum(t1.bb, (0, 1), tmp391, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp391
    tmp411 = einsum(tmp410, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 4, 3))
    del tmp410
    r2new.bbbb += tmp411 * -2
    r2new.bbbb += tmp411.transpose((0, 1, 3, 2)) * 2
    del tmp411
    tmp358 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), r1.bb, (4, 3), (4, 0, 1, 2))
    r2new.bbbb += tmp358.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp358.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp358 * -1
    r2new.bbbb += tmp358.transpose((1, 0, 2, 3))
    del tmp358
    tmp228 = tmp225.copy()
    del tmp225
    tmp228 += tmp226 * 2
    del tmp226
    tmp228 += tmp227
    del tmp227
    r2new.bbbb += einsum(tmp228, (0, 1), r1.bb, (2, 3), (0, 2, 3, 1))
    r2new.bbbb += einsum(tmp228, (0, 1), r1.bb, (2, 3), (2, 0, 3, 1)) * -1
    r2new.abab += einsum(tmp228, (0, 1), r1.aa, (2, 3), (2, 0, 3, 1)) * -1
    del tmp228
    tmp347 = einsum(tmp346, (0, 1, 2, 3), t2.bbbb, (1, 3, 4, 5), (0, 2, 4, 5)) * -1
    del tmp346
    r2new.bbbb += tmp347.transpose((1, 0, 3, 2))
    r2new.bbbb += tmp347.transpose((1, 0, 3, 2))
    del tmp347
    tmp390 = tmp379.transpose((1, 2, 0, 3)).copy() * 0.5
    del tmp379
    tmp390 += tmp381
    del tmp381
    tmp390 += einsum(r1.bb, (0, 1), tmp389, (2, 0, 3, 4), (2, 4, 3, 1)) * 0.5
    del tmp389
    r2new.bbbb += einsum(t1.bb, (0, 1), tmp390, (2, 0, 3, 4), (2, 3, 4, 1)) * 2
    del tmp390
    tmp392 = einsum(v.bbbb.ooov, (0, 1, 2, 3), r1.bb, (1, 4), (0, 2, 4, 3))
    r2new.bbbb += tmp392.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp392.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp392.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp392 * -1
    del tmp392
    tmp402 = einsum(r2.bbbb, (0, 1, 2, 3), tmp401, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp401
    r2new.bbbb += tmp402.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp402.transpose((0, 1, 3, 2)) * -1
    del tmp402
    tmp335 = einsum(r2.bbbb, (0, 1, 2, 3), tmp53, (1, 4), (0, 4, 2, 3)) * -1
    del tmp53
    r2new.bbbb += tmp335.transpose((0, 1, 3, 2)) * -1
    r2new.bbbb += tmp335.transpose((0, 1, 3, 2)) * -1
    del tmp335
    tmp359 = einsum(t1.bb, (0, 1), tmp321, (2, 3, 1, 4), (0, 2, 3, 4)) * -1
    del tmp321
    r2new.bbbb += einsum(tmp214, (0, 1, 2, 3), tmp359, (4, 0, 2, 5), (1, 4, 5, 3)) * -1
    del tmp214, tmp359
    tmp356 = einsum(tmp55, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 4, 3))
    del tmp55
    r2new.bbbb += tmp356 * -1
    r2new.bbbb += tmp356.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp356.transpose((0, 1, 3, 2))
    r2new.bbbb += tmp356.transpose((1, 0, 3, 2)) * -1
    del tmp356
    tmp409 = einsum(tmp408, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 4, 3))
    del tmp408
    r2new.bbbb += tmp409.transpose((1, 0, 2, 3))
    r2new.bbbb += tmp409 * -1
    r2new.bbbb += tmp409.transpose((1, 0, 3, 2)) * -1
    r2new.bbbb += tmp409.transpose((0, 1, 3, 2))
    del tmp409
    tmp299 = einsum(t1.aa, (0, 1), tmp298, (2, 3, 4, 1), (0, 2, 3, 4))
    r2new.abab += einsum(tmp299, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4)) * -1
    del tmp299
    tmp310 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    r2new.abab += einsum(r1.aa, (0, 1), tmp310, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp310
    tmp305 = einsum(v.aabb.oooo, (0, 1, 2, 3), r1.bb, (3, 4), (0, 1, 2, 4))
    tmp305 += einsum(v.aabb.ovoo, (0, 1, 2, 3), r2.abab, (4, 3, 1, 5), (0, 4, 2, 5))
    r2new.abab += einsum(t1.aa, (0, 1), tmp305, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp305
    tmp252 = tmp109.copy()
    tmp252 += tmp110 * 0.5
    tmp252 += einsum(tmp27, (0, 1), t1.aa, (0, 2), (1, 2)) * 0.5
    r2new.abab += einsum(r1.bb, (0, 1), tmp252, (2, 3), (2, 0, 3, 1)) * -2
    del tmp252
    tmp294 = einsum(r1.aa, (0, 1), v.aabb.ovoo, (0, 2, 3, 4), (3, 4, 1, 2))
    tmp294 += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp293, (0, 4, 5, 3), (2, 4, 5, 1))
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp294, (1, 4, 5, 2), (0, 4, 5, 3))
    del tmp294
    tmp174 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    r2new.abab += einsum(tmp174, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp174, (2, 3), (0, 2, 3, 1))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp174, (2, 3), (2, 0, 3, 1)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp174, (2, 3), (0, 2, 1, 3)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp174, (2, 3), (2, 0, 1, 3))
    del tmp174
    tmp61 = tmp58.transpose((1, 0)).copy()
    del tmp58
    tmp61 += tmp59.transpose((1, 0)) * 2
    del tmp59
    tmp61 += tmp60.transpose((1, 0))
    del tmp60
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), tmp61, (1, 4), (0, 4, 2, 3)) * -1
    r1new.bb += einsum(tmp61, (0, 1), r1.bb, (0, 2), (1, 2)) * -1
    del tmp61
    tmp145 = tmp140.copy()
    del tmp140
    tmp145 += tmp142
    del tmp142
    tmp145 += tmp144
    del tmp144
    r2new.abab += einsum(tmp145, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp145, (2, 3), (2, 0, 1, 3)) * -1
    r2new.aaaa += einsum(tmp145, (0, 1), r1.aa, (2, 3), (2, 0, 3, 1))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp145, (2, 3), (2, 0, 3, 1))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp145, (2, 3), (0, 2, 3, 1)) * -1
    del tmp145
    tmp301 = r2.abab.copy()
    tmp301 += einsum(r1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    r2new.abab += einsum(tmp304, (0, 1, 2, 3), tmp301, (1, 3, 4, 5), (0, 2, 4, 5))
    r2new.abab += einsum(tmp301, (0, 1, 2, 3), v.aabb.vvvv, (4, 2, 5, 3), (0, 1, 4, 5))
    r2new.abab += einsum(tmp301, (0, 1, 2, 3), tmp298, (4, 1, 2, 5), (0, 4, 5, 3)) * -1
    del tmp298
    r2new.abab += einsum(tmp301, (0, 1, 2, 3), tmp300, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp301
    tmp264 = einsum(tmp56, (0, 1, 2, 3), r1.aa, (4, 3), (4, 0, 1, 2))
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp264, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp264
    tmp222 = tmp44.transpose((1, 0)).copy() * 0.5
    del tmp44
    tmp222 += tmp45.transpose((1, 0)) * 0.5
    del tmp45
    tmp222 += tmp46.transpose((1, 0))
    del tmp46
    tmp222 += einsum(r1.bb, (0, 1), tmp47, (0, 2, 3, 1), (3, 2)) * -0.5
    del tmp47
    tmp222 += einsum(tmp9, (0, 1), r1.bb, (2, 1), (0, 2)) * 0.5
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp222, (1, 4), (0, 4, 2, 3)) * -2
    del tmp222
    tmp229 = einsum(v.aabb.ooov, (0, 1, 2, 3), r2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    r2new.abab += einsum(t1.bb, (0, 1), tmp229, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp229
    tmp296 = einsum(r1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp296 += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp295, (4, 2, 1, 5), (0, 4, 5, 3))
    del tmp295
    r2new.abab += einsum(tmp296, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 5, 2))
    del tmp296
    tmp253 = einsum(tmp30, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5)) * 2
    tmp253 += einsum(tmp135, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5))
    r2new.abab += einsum(r1.aa, (0, 1), tmp253, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp253
    tmp302 = einsum(tmp56, (0, 1, 2, 3), t2.abab, (4, 2, 3, 5), (4, 0, 1, 5))
    r2new.abab += einsum(tmp302, (0, 1, 2, 3), r1.aa, (1, 4), (0, 2, 4, 3))
    del tmp302
    tmp307 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    r2new.abab += einsum(tmp293, (0, 1, 2, 3), tmp307, (4, 0, 3, 5), (4, 1, 2, 5)) * -1
    del tmp293, tmp307
    tmp288 = tmp69.transpose((1, 0, 2, 3)).copy()
    tmp288 += tmp177.transpose((0, 1, 3, 2)) * -1
    del tmp177
    tmp288 += tmp178.transpose((1, 0, 3, 2)) * -1
    del tmp178
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp288, (0, 4, 5, 2), (4, 1, 5, 3))
    del tmp288
    tmp198 = tmp194.copy() * 2
    del tmp194
    tmp198 += tmp197
    del tmp197
    r2new.abab += einsum(tmp198, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3))
    r2new.aaaa += einsum(tmp198, (0, 1), r1.aa, (2, 3), (0, 2, 3, 1)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp198, (2, 3), (0, 2, 1, 3))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp198, (2, 3), (2, 0, 3, 1))
    del tmp198
    tmp96 = f.aa.ov.copy()
    tmp96 += tmp75
    tmp96 += tmp2
    r2new.abab += einsum(tmp96, (0, 1), r1.bb, (2, 3), (0, 2, 1, 3))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp96, (2, 3), (2, 0, 1, 3)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp96, (2, 3), (0, 2, 1, 3))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp96, (2, 3), (2, 0, 3, 1))
    del tmp96
    tmp248 = f.bb.vv.copy()
    tmp248 += tmp246.transpose((1, 0))
    del tmp246
    tmp248 += einsum(t1.bb, (0, 1), tmp247, (0, 1, 2, 3), (3, 2)) * -1
    del tmp247
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), tmp248, (3, 4), (0, 1, 2, 4))
    del tmp248
    tmp236 = einsum(r1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    r2new.abab += einsum(tmp236, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    del tmp236
    tmp306 = einsum(tmp30, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    r2new.abab += einsum(tmp306, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4))
    del tmp306
    tmp312 = einsum(r1.bb, (0, 1), v.aabb.vvov, (2, 3, 4, 1), (0, 4, 2, 3))
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp312, (4, 1, 5, 2), (0, 4, 5, 3)) * -1
    del tmp312
    tmp274 = einsum(v.aabb.vvoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 2, 3, 0))
    r2new.abab += einsum(tmp274, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4)) * -1
    del tmp274
    tmp314 = einsum(t1.aa, (0, 1), tmp300, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp300
    r2new.abab += einsum(tmp314, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4))
    del tmp314
    tmp221 = einsum(r1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp221, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp221
    tmp278 = einsum(r1.aa, (0, 1), tmp275, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp278 += einsum(tmp277, (0, 1, 2, 3), tmp30, (4, 0, 5, 3), (4, 5, 1, 2))
    del tmp277
    r2new.abab += einsum(t1.bb, (0, 1), tmp278, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp278
    tmp251 = einsum(r2.bbbb, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (4, 5, 0, 2)) * 2
    tmp251 += einsum(tmp250, (0, 1, 2, 3), r2.abab, (0, 4, 3, 5), (2, 1, 4, 5))
    del tmp250
    r2new.abab += einsum(t1.aa, (0, 1), tmp251, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp251
    tmp213 = einsum(r2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    r2new.abab += einsum(t1.bb, (0, 1), tmp213, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp213
    tmp292 = einsum(tmp275, (0, 1, 2, 3), r1.bb, (3, 4), (0, 1, 2, 4)) * -1
    del tmp275
    tmp292 += einsum(tmp30, (0, 1, 2, 3), r2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5)) * 2
    tmp292 += einsum(r2.abab, (0, 1, 2, 3), tmp135, (4, 0, 5, 2), (4, 5, 1, 3))
    del tmp135
    r2new.abab += einsum(t1.aa, (0, 1), tmp292, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp292
    tmp249 = tmp118.transpose((1, 0)).copy() * 2
    del tmp118
    tmp249 += tmp119.transpose((1, 0))
    del tmp119
    tmp249 += tmp120.transpose((1, 0))
    del tmp120
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), tmp249, (2, 4), (0, 1, 4, 3)) * -1
    del tmp249
    tmp171 = tmp166.copy() * 2
    tmp171 += tmp167
    tmp171 += tmp170
    del tmp170
    r2new.abab += einsum(r1.bb, (0, 1), tmp171, (2, 3), (2, 0, 3, 1)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp171, (2, 3), (2, 0, 3, 1)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp171, (2, 3), (0, 2, 3, 1))
    del tmp171
    tmp311 = einsum(t1.aa, (0, 1), tmp304, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp304
    r2new.abab += einsum(tmp311, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4))
    del tmp311
    tmp234 = tmp18.transpose((1, 0)).copy() * 0.5
    del tmp18
    tmp234 += tmp19.transpose((1, 0))
    del tmp19
    tmp234 += tmp20.transpose((1, 0)) * 0.5
    del tmp20
    tmp234 += einsum(r1.aa, (0, 1), tmp21, (0, 2, 3, 1), (3, 2)) * -0.5
    tmp234 += einsum(r1.aa, (0, 1), tmp5, (2, 1), (2, 0)) * 0.5
    r2new.abab += einsum(tmp234, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -2
    del tmp234
    tmp303 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    r2new.abab += einsum(tmp303, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4)) * -1
    del tmp303
    tmp267 = einsum(r1.aa, (0, 1), tmp265, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp267 += einsum(r2.abab, (0, 1, 2, 3), tmp266, (4, 5, 1, 3), (0, 4, 5, 2))
    del tmp266
    tmp267 += einsum(tmp56, (0, 1, 2, 3), tmp73, (0, 4, 3, 5), (4, 1, 2, 5)) * -1
    r2new.abab += einsum(t1.bb, (0, 1), tmp267, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp267
    tmp233 = tmp231.transpose((1, 0)).copy() * 0.5
    del tmp231
    tmp233 += tmp232.transpose((1, 0))
    del tmp232
    tmp233 += einsum(t1.bb, (0, 1), tmp9, (0, 2), (2, 1)) * 0.5
    r2new.abab += einsum(tmp233, (0, 1), r2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp233
    tmp268 = einsum(tmp17, (0, 1), t1.bb, (2, 1), (2, 0))
    del tmp17
    r2new.abab += einsum(tmp268, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    del tmp268
    tmp273 = tmp269.copy() * 0.5
    del tmp269
    tmp273 += tmp270
    del tmp270
    tmp273 += einsum(tmp272, (0, 1), t1.bb, (0, 2), (1, 2))
    del tmp272
    r2new.abab += einsum(tmp273, (0, 1), r1.aa, (2, 3), (2, 0, 3, 1)) * -2
    del tmp273
    tmp237 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    r2new.abab += einsum(tmp237, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp237
    tmp308 = einsum(t1.bb, (0, 1), v.aabb.oovv, (2, 3, 4, 1), (2, 3, 0, 4))
    r2new.abab += einsum(r1.aa, (0, 1), tmp308, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp308
    tmp230 = einsum(v.aabb.ooov, (0, 1, 2, 3), r1.bb, (4, 3), (0, 1, 4, 2))
    tmp230 += einsum(v.aabb.ovov, (0, 1, 2, 3), r2.abab, (4, 5, 1, 3), (0, 4, 5, 2))
    r2new.abab += einsum(tmp141, (0, 1, 2, 3), tmp230, (0, 4, 5, 1), (4, 5, 2, 3))
    del tmp141, tmp230
    tmp224 = einsum(r2.abab, (0, 1, 2, 3), tmp223, (1, 4, 5, 3), (0, 5, 4, 2))
    del tmp223
    tmp224 += einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp73, (0, 4, 1, 5), (4, 2, 3, 5))
    r2new.abab += einsum(t1.bb, (0, 1), tmp224, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp224
    tmp276 = einsum(tmp30, (0, 1, 2, 3), r1.bb, (4, 3), (0, 1, 4, 2))
    del tmp30
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp276, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp276
    tmp256 = einsum(t2.aaaa, (0, 1, 2, 3), tmp56, (1, 4, 5, 3), (0, 4, 5, 2)) * 2
    tmp256 += einsum(t2.abab, (0, 1, 2, 3), tmp255, (4, 5, 1, 3), (0, 4, 5, 2))
    del tmp255
    r2new.abab += einsum(tmp256, (0, 1, 2, 3), r1.bb, (2, 4), (0, 1, 3, 4)) * -1
    del tmp256
    tmp284 = tmp280.transpose((1, 0, 2, 3)).copy() * 0.5
    del tmp280
    tmp284 += einsum(tmp282, (0, 1, 2, 3), tmp281, (0, 4, 3, 5), (1, 4, 5, 2)) * -0.5
    del tmp281, tmp282
    tmp284 += tmp283.transpose((1, 0, 2, 3)) * -1
    del tmp283
    r2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp284, (1, 4, 5, 3), (0, 4, 2, 5)) * 2
    del tmp284
    tmp297 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    r2new.abab += einsum(r1.bb, (0, 1), tmp297, (2, 3, 4, 1), (2, 0, 3, 4))
    del tmp297
    tmp309 = einsum(tmp265, (0, 1, 2, 3), r1.bb, (3, 4), (1, 0, 2, 4))
    del tmp265
    tmp309 += einsum(tmp56, (0, 1, 2, 3), r2.abab, (4, 2, 3, 5), (4, 0, 1, 5))
    del tmp56
    r2new.abab += einsum(t1.aa, (0, 1), tmp309, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp309
    tmp313 = einsum(t1.aa, (0, 1), tmp257, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp257
    r2new.abab += einsum(r1.aa, (0, 1), tmp313, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp313
    tmp235 = r2.abab.copy()
    tmp235 += einsum(r1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    r2new.abab += einsum(v.aabb.oooo, (0, 1, 2, 3), tmp235, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    del tmp235
    tmp155 = einsum(tmp154, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp154
    r2new.aaaa += tmp155.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp155.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp155.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp155
    del tmp155
    tmp78 = einsum(tmp77, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp77
    r2new.aaaa += tmp78 * -2
    r2new.aaaa += tmp78.transpose((0, 1, 3, 2)) * 2
    del tmp78
    tmp99 = einsum(r2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    r2new.aaaa += tmp99.transpose((1, 0, 3, 2)) * 0.5
    r2new.aaaa += tmp99.transpose((1, 0, 3, 2)) * 0.5
    r2new.aaaa += tmp99.transpose((1, 0, 3, 2)) * 0.5
    r2new.aaaa += tmp99.transpose((1, 0, 3, 2)) * 0.5
    del tmp99
    tmp133 = r2.aaaa.copy()
    tmp133 += einsum(r1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -0.5
    tmp114 = einsum(tmp113, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    del tmp113
    r2new.aaaa += tmp114.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp114.transpose((0, 1, 3, 2))
    del tmp114
    tmp103 = einsum(tmp27, (0, 1), r2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    del tmp27
    r2new.aaaa += tmp103.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp103.transpose((0, 1, 3, 2)) * -1
    del tmp103
    tmp212 = einsum(r1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    tmp212 += r2.aaaa * -1
    tmp191 = tmp69.copy()
    del tmp69
    tmp191 += einsum(tmp189, (0, 1, 2, 3), tmp190, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp189, tmp190
    tmp191 += einsum(r1.aa, (0, 1), tmp21, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp21
    r2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp191, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp191
    tmp117 = einsum(tmp116, (0, 1, 2, 3), t2.aaaa, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp116
    r2new.aaaa += tmp117.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp117.transpose((1, 0, 3, 2)) * -1
    del tmp117
    tmp127 = einsum(r2.aaaa, (0, 1, 2, 3), tmp126, (1, 4), (4, 0, 2, 3)) * -1
    del tmp126
    r2new.aaaa += tmp127.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp127.transpose((0, 1, 3, 2))
    del tmp127
    tmp153 = einsum(tmp152, (0, 1, 2, 3), r2.aaaa, (3, 2, 4, 5), (0, 1, 4, 5)) * -1
    del tmp152
    r2new.aaaa += tmp153.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp153.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp153.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp153.transpose((1, 0, 3, 2)) * -1
    del tmp153
    tmp180 = einsum(tmp179, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp179
    r2new.aaaa += tmp180.transpose((1, 0, 2, 3)) * -2
    r2new.aaaa += tmp180 * 2
    r2new.aaaa += tmp180.transpose((0, 1, 3, 2)) * -2
    del tmp180
    tmp188 = einsum(t2.aaaa, (0, 1, 2, 3), tmp5, (1, 3), (0, 2))
    del tmp5
    tmp188 += einsum(t2.abab, (0, 1, 2, 3), tmp9, (1, 3), (0, 2)) * 0.5
    del tmp9
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp188, (2, 3), (0, 2, 3, 1)) * -2
    del tmp188
    tmp200 = einsum(tmp199, (0, 1, 2, 3), r2.aaaa, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp199
    r2new.aaaa += tmp200.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp200.transpose((0, 1, 3, 2)) * -1
    del tmp200
    tmp210 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    r2new.aaaa += einsum(tmp212, (0, 1, 2, 3), tmp210, (4, 5, 0, 1), (5, 4, 3, 2)) * -1
    del tmp212
    tmp123 = tmp104.transpose((1, 0, 2, 3)).copy() * 0.5
    tmp123 += tmp105.transpose((2, 0, 1, 3)) * 0.5
    tmp123 += einsum(tmp115, (0, 1, 2, 3), t1.aa, (2, 4), (3, 1, 0, 4))
    del tmp115
    tmp123 += einsum(tmp106, (0, 1, 2, 3), r2.aaaa, (4, 2, 5, 3), (1, 4, 0, 5))
    del tmp106
    r2new.aaaa += einsum(t1.aa, (0, 1), tmp123, (0, 2, 3, 4), (3, 2, 4, 1)) * 2
    del tmp123
    tmp131 = einsum(r1.aa, (0, 1), tmp29, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp29
    r2new.aaaa += tmp131 * -1
    r2new.aaaa += tmp131.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp131.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp131.transpose((1, 0, 3, 2)) * -1
    del tmp131
    tmp130 = einsum(r2.abab, (0, 1, 2, 3), tmp129, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp129
    r2new.aaaa += tmp130.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp130
    r2new.aaaa += tmp130.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp130.transpose((0, 1, 3, 2)) * -1
    del tmp130
    tmp173 = einsum(t1.aa, (0, 1), tmp172, (2, 0, 3, 4), (2, 3, 4, 1)) * 2
    del tmp172
    r2new.aaaa += tmp173.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp173
    del tmp173
    tmp202 = einsum(tmp201, (0, 1, 2, 3), r1.aa, (2, 4), (0, 1, 4, 3))
    del tmp201
    r2new.aaaa += tmp202.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp202.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp202.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp202
    del tmp202
    tmp165 = einsum(t2.aaaa, (0, 1, 2, 3), tmp41, (4, 1), (0, 4, 2, 3)) * -1
    del tmp41
    r2new.aaaa += tmp165.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp165.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp165.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp165.transpose((0, 1, 3, 2)) * -1
    del tmp165
    tmp164 = einsum(t1.aa, (0, 1), tmp163, (2, 3, 0, 4), (2, 3, 4, 1)) * 2
    del tmp163
    r2new.aaaa += tmp164.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp164.transpose((1, 0, 2, 3)) * -1
    del tmp164
    tmp149 = einsum(tmp148, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (0, 1, 4, 5)) * -1
    del tmp148
    r2new.aaaa += tmp149.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp149.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp149.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp149.transpose((0, 1, 3, 2)) * -1
    del tmp149
    tmp151 = einsum(r1.aa, (0, 1), tmp150, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp150
    r2new.aaaa += tmp151
    r2new.aaaa += tmp151.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp151.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp151.transpose((1, 0, 3, 2))
    del tmp151
    tmp98 = einsum(tmp97, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (0, 1, 4, 5)) * -1
    del tmp97
    r2new.aaaa += tmp98.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp98.transpose((0, 1, 3, 2))
    del tmp98
    tmp209 = einsum(tmp208, (0, 1, 2, 3), r1.aa, (2, 4), (0, 1, 4, 3))
    del tmp208
    r2new.aaaa += tmp209 * -2
    r2new.aaaa += tmp209.transpose((0, 1, 3, 2)) * 2
    del tmp209
    tmp138 = einsum(r1.aa, (0, 1), tmp137, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp137
    r2new.aaaa += tmp138
    r2new.aaaa += tmp138.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp138.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp138.transpose((1, 0, 3, 2))
    del tmp138
    tmp211 = r2.aaaa.copy()
    tmp211 += einsum(r1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    r2new.aaaa += einsum(tmp211, (0, 1, 2, 3), tmp210, (4, 5, 0, 1), (5, 4, 3, 2))
    del tmp210, tmp211
    tmp108 = tmp104.transpose((1, 0, 2, 3)).copy()
    del tmp104
    tmp108 += tmp105.transpose((2, 0, 1, 3))
    del tmp105
    tmp108 += tmp107.transpose((1, 2, 0, 3))
    del tmp107
    r2new.aaaa += einsum(tmp108, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    del tmp108
    tmp76 = f.aa.ov.copy()
    tmp76 += tmp75
    del tmp75
    tmp76 += tmp2
    del tmp2
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp76, (2, 3), (0, 2, 3, 1)) * -1
    del tmp76
    tmp74 = einsum(tmp73, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    r2new.aaaa += tmp74.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp74.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp74
    r2new.aaaa += tmp74.transpose((1, 0, 2, 3)) * -1
    del tmp74
    tmp207 = einsum(r1.aa, (0, 1), tmp206, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp206
    r2new.aaaa += tmp207.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp207 * -1
    r2new.aaaa += tmp207.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp207.transpose((0, 1, 3, 2))
    del tmp207
    tmp186 = einsum(tmp185, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp185
    r2new.aaaa += tmp186.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp186 * -1
    r2new.aaaa += tmp186.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp186.transpose((0, 1, 3, 2))
    del tmp186
    tmp132 = einsum(t1.aa, (0, 1), tmp79, (2, 3, 1, 4), (0, 2, 3, 4)) * -1
    del tmp79
    r2new.aaaa += einsum(tmp132, (0, 1, 2, 3), tmp133, (1, 4, 2, 5), (4, 0, 3, 5)) * -2
    del tmp132, tmp133
    tmp68 = einsum(tmp67, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 5, 2))
    del tmp67
    r2new.aaaa += tmp68 * -1
    r2new.aaaa += tmp68.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp68.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp68.transpose((1, 0, 3, 2)) * -1
    del tmp68
    tmp102 = einsum(t2.aaaa, (0, 1, 2, 3), tmp24, (1, 4), (0, 4, 2, 3)) * -1
    del tmp24
    r2new.aaaa += tmp102.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp102.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp102.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp102.transpose((0, 1, 3, 2)) * -1
    del tmp102
    tmp128 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r1.aa, (4, 3), (4, 0, 1, 2))
    r2new.aaaa += tmp128.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp128.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp128 * -1
    r2new.aaaa += tmp128.transpose((1, 0, 2, 3))
    del tmp128
    tmp147 = einsum(tmp73, (0, 1, 2, 3), tmp146, (4, 0, 2, 5), (4, 1, 5, 3)) * -1
    del tmp146
    r2new.aaaa += tmp147.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp147.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp147
    del tmp147
    tmp90 = einsum(tmp89, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp89
    r2new.aaaa += tmp90.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp90.transpose((1, 0, 3, 2))
    del tmp90
    tmp157 = einsum(tmp156, (0, 1), r2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    del tmp156
    r2new.aaaa += tmp157.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp157.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp157.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp157.transpose((1, 0, 3, 2)) * -1
    del tmp157
    tmp204 = einsum(tmp203, (0, 1, 2, 3), r1.aa, (4, 2), (4, 0, 1, 3))
    del tmp203
    r2new.aaaa += tmp204.transpose((0, 1, 3, 2)) * -1
    r2new.aaaa += tmp204
    r2new.aaaa += tmp204.transpose((1, 0, 3, 2))
    r2new.aaaa += tmp204.transpose((1, 0, 2, 3)) * -1
    del tmp204
    tmp112 = tmp109.copy() * 2
    del tmp109
    tmp112 += tmp110
    del tmp110
    tmp112 += tmp111
    del tmp111
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp112, (2, 3), (2, 0, 3, 1)) * -1
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp112, (2, 3), (2, 0, 1, 3))
    r2new.aaaa += einsum(tmp112, (0, 1), r1.aa, (2, 3), (2, 0, 1, 3))
    r2new.aaaa += einsum(r1.aa, (0, 1), tmp112, (2, 3), (0, 2, 1, 3)) * -1
    del tmp112
    tmp122 = einsum(r2.aaaa, (0, 1, 2, 3), tmp121, (4, 3), (0, 1, 4, 2)) * -2
    del tmp121
    r2new.aaaa += tmp122.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp122.transpose((1, 0, 3, 2)) * -1
    del tmp122
    tmp175 = einsum(v.aaaa.ooov, (0, 1, 2, 3), r1.aa, (1, 4), (0, 2, 4, 3))
    r2new.aaaa += tmp175.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp175.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp175.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp175 * -1
    del tmp175
    tmp169 = tmp166.copy()
    del tmp166
    tmp169 += tmp167 * 0.5
    del tmp167
    tmp169 += tmp168
    del tmp168
    r2new.aaaa += einsum(tmp169, (0, 1), r1.aa, (2, 3), (0, 2, 3, 1)) * 2
    r2new.aaaa += einsum(tmp169, (0, 1), r1.aa, (2, 3), (2, 0, 3, 1)) * -2
    del tmp169
    tmp95 = einsum(tmp94, (0, 1), r2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp94
    r2new.aaaa += tmp95.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp95.transpose((1, 0, 3, 2)) * -1
    del tmp95
    tmp81 = einsum(t2.aaaa, (0, 1, 2, 3), tmp80, (4, 1, 3, 5), (0, 4, 2, 5)) * -2
    del tmp80
    r2new.aaaa += tmp81.transpose((1, 0, 2, 3)) * -1
    r2new.aaaa += tmp81.transpose((1, 0, 3, 2))
    del tmp81
    tmp101 = einsum(tmp100, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp100
    r2new.aaaa += tmp101.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp101.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp101.transpose((0, 1, 3, 2))
    r2new.aaaa += tmp101 * -1
    del tmp101
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp71, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    del tmp71
    r2new.aaaa += tmp72 * 2
    r2new.aaaa += tmp72.transpose((0, 1, 3, 2)) * -2
    del tmp72
    tmp187 = einsum(tmp73, (0, 1, 2, 3), v.aaaa.oovv, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp73
    r2new.aaaa += tmp187.transpose((1, 0, 2, 3))
    r2new.aaaa += tmp187 * -1
    r2new.aaaa += tmp187.transpose((1, 0, 3, 2)) * -1
    r2new.aaaa += tmp187.transpose((0, 1, 3, 2))
    del tmp187
    tmp32 = r2.abab.copy()
    tmp32 += einsum(r1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp32 += einsum(r1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    r1new.bb += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp32, (0, 4, 1, 3), (4, 2))
    r1new.aa += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp32, (4, 2, 1, 3), (4, 0))
    del tmp32
    tmp54 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), r1.bb, (0, 1), (2, 3))
    r1new.bb += einsum(t1.bb, (0, 1), tmp54, (2, 1), (0, 2))
    del tmp54
    tmp13 = tmp10.copy()
    del tmp10
    tmp13 += tmp12 * -1
    del tmp12
    r1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 2), (1, 3))
    r1new.aa += einsum(tmp13, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp13
    tmp42 = einsum(r1.bb, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    r1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp42, (4, 0, 1, 3), (4, 2)) * 2
    del tmp42
    tmp43 = einsum(v.aabb.ovov, (0, 1, 2, 3), r1.bb, (4, 3), (0, 4, 2, 1))
    r1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp43, (0, 4, 1, 2), (4, 3)) * -1
    del tmp43
    tmp57 = r2.bbbb.copy() * 2
    tmp57 += einsum(r1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp57 += einsum(r1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    r1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp57, (0, 4, 3, 1), (4, 2)) * -1
    del tmp57
    tmp63 = f.bb.vv.copy()
    tmp63 += tmp62.transpose((1, 0))
    del tmp62
    r1new.bb += einsum(r1.bb, (0, 1), tmp63, (1, 2), (0, 2))
    del tmp63
    tmp38 = f.aa.vv.copy()
    tmp38 += tmp37 * -1
    del tmp37
    r1new.aa += einsum(r1.aa, (0, 1), tmp38, (1, 2), (0, 2))
    del tmp38
    tmp1 = einsum(r1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    r1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp1
    tmp31 = r2.aaaa.copy()
    tmp31 += einsum(r1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * 0.5
    tmp31 += einsum(r1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 0.5
    r1new.aa += einsum(tmp31, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 3), (1, 4)) * 2
    del tmp31
    tmp0 = einsum(r1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    r1new.aa += einsum(tmp0, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    del tmp0
    tmp28 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r1.aa, (0, 3), (1, 2))
    r1new.aa += einsum(t1.aa, (0, 1), tmp28, (1, 2), (0, 2)) * -1
    del tmp28
    r1new.aa += einsum(v.aabb.ooov, (0, 1, 2, 3), r2.abab, (1, 2, 4, 3), (0, 4)) * -1
    r1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), r2.aaaa, (1, 2, 4, 3), (0, 4)) * -2
    r1new.aa += einsum(r1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3)) * -1
    r1new.aa += einsum(r1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    r1new.bb += einsum(r1.bb, (0, 1), v.bbbb.oovv, (2, 0, 3, 1), (2, 3)) * -1
    r1new.bb += einsum(r2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * 2
    r1new.bb += einsum(r2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3)) * -1
    r1new.bb += einsum(r1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    r2new.aaaa += einsum(v.aaaa.vvvv, (0, 1, 2, 3), r2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -2
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    r2new.abab += einsum(v.aabb.oooo, (0, 1, 2, 3), r2.abab, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), v.bbbb.oovv, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    r2new.abab += einsum(r2.abab, (0, 1, 2, 3), v.aaaa.oovv, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    r2new.bbbb += einsum(r2.bbbb, (0, 1, 2, 3), v.bbbb.vvvv, (4, 2, 5, 3), (0, 1, 4, 5)) * 2
    r2new.baba = r2new.abab.transpose(1, 0, 3, 2)

    return {f"r1new": r1new, f"r2new": r2new}

