"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-08-09T21:49:34.224770
  * python version: 3.10.14 (main, Jul 16 2024, 19:03:10) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.14/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1487-369
  * system: Linux
  * processor: x86_64
  * release: 6.5.0-1025-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, direct_sum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:49:36.017636.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 0, 1), (2,))
    tmp1 = tmp0.copy()
    tmp1 += einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,)) * 0.5
    tmp5 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2))
    tmp3 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (0, 3, 2))
    tmp2 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp2 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    tmp2 += einsum(t1.bb, (0, 1), tmp1, (2,), (0, 1, 2))
    del tmp1
    e_cc = einsum(tmp2, (0, 1, 2), v.bbb.xov, (2, 0, 1), ())
    del tmp2
    tmp6 = f.aa.ov.copy() * 2
    tmp6 += einsum(tmp5, (0, 1, 2), v.baa.xov, (2, 0, 3), (1, 3)) * -1
    del tmp5
    e_cc += einsum(t1.aa, (0, 1), tmp6, (0, 1), ()) * 0.5
    del tmp6
    tmp7 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp7 += einsum(tmp0, (0,), t1.aa, (1, 2), (1, 2, 0)) * 0.5
    del tmp0
    e_cc += einsum(tmp7, (0, 1, 2), v.baa.xov, (2, 0, 1), ())
    del tmp7
    tmp4 = f.bb.ov.copy() * 2
    tmp4 += einsum(tmp3, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3)) * -1
    del tmp3
    e_cc += einsum(t1.bb, (0, 1), tmp4, (0, 1), ()) * 0.5
    del tmp4

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:51:02.011569.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp6 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp5 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 0, 1), (2,))
    tmp21 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (0, 3, 2))
    tmp0 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2))
    tmp149 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 3), (1, 3, 2))
    tmp9 = tmp5.copy()
    tmp9 += tmp6
    tmp42 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (3, 1, 0))
    t1new.bb = einsum(v.bbb.xoo, (0, 1, 2), tmp42, (2, 3, 0), (1, 3)) * -1
    tmp143 = einsum(t1.bb, (0, 1), tmp21, (2, 0, 3), (2, 1, 3))
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    tmp32 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp7 = tmp5.copy()
    del tmp5
    tmp7 += tmp6
    del tmp6
    tmp22 = einsum(tmp21, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3))
    tmp80 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 3), (3, 2, 0))
    tmp78 = einsum(t1.aa, (0, 1), tmp0, (2, 0, 3), (2, 1, 3))
    tmp18 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (3, 1, 0))
    t1new.aa = einsum(tmp18, (0, 1, 2), v.baa.xoo, (2, 3, 0), (3, 1)) * -1
    tmp14 = einsum(tmp0, (0, 1, 2), v.baa.xov, (2, 0, 3), (1, 3))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp3 = einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    tmp201 = v.bbb.xvv.transpose((1, 2, 0)).copy()
    tmp201 += tmp149.transpose((1, 0, 2)) * -1
    tmp43 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    t1new.bb += einsum(tmp43, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4)) * -2
    tmp35 = einsum(v.bbb.xov, (0, 1, 2), tmp9, (0,), (1, 2))
    t1new.bb += tmp35
    tmp166 = tmp42.copy()
    tmp166 += tmp143 * -1
    t2new.abab = einsum(tmp166, (0, 1, 2), tmp11, (3, 4, 2), (3, 0, 4, 1)) * 2
    tmp37 = tmp32.copy()
    tmp37 += tmp36 * 2
    tmp37 += einsum(tmp7, (0,), t1.bb, (1, 2), (1, 2, 0))
    tmp191 = f.bb.ov.copy() * -1
    tmp191 += tmp22
    tmp89 = v.baa.xvv.transpose((1, 2, 0)).copy()
    tmp89 += tmp80.transpose((1, 0, 2)) * -1
    tmp87 = tmp18.copy()
    tmp87 += tmp78 * -1
    t2new.abab += einsum(tmp87, (0, 1, 2), tmp36, (3, 4, 2), (0, 3, 1, 4)) * 2
    tmp74 = f.aa.ov.copy() * -1
    tmp74 += tmp14
    tmp72 = tmp11.copy() * 2
    tmp72 += tmp3
    tmp72 += einsum(tmp7, (0,), t1.aa, (1, 2), (1, 2, 0))
    tmp20 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (4, 0, 1, 3), (4, 2)) * -2
    tmp208 = einsum(tmp201, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (3, 4, 0, 1))
    tmp159 = einsum(t1.bb, (0, 1), tmp43, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp43
    t2new.bbbb = tmp159.transpose((1, 0, 2, 3)).copy()
    t2new.bbbb += tmp159 * -1
    t2new.bbbb += tmp159.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp159.transpose((0, 1, 3, 2))
    tmp101 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp221 = einsum(tmp21, (0, 1, 2), tmp21, (3, 4, 2), (3, 0, 4, 1))
    tmp196 = v.bbb.xvv.transpose((1, 2, 0)).copy()
    tmp196 += tmp149.transpose((1, 0, 2)) * -1
    tmp134 = f.bb.ov.copy()
    tmp134 += tmp22 * -1
    tmp134 += tmp35
    del tmp35
    tmp202 = einsum(tmp201, (0, 1, 2), tmp21, (3, 4, 2), (3, 4, 0, 1))
    del tmp201
    tmp167 = einsum(tmp166, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1))
    tmp190 = einsum(v.bbb.xov, (0, 1, 2), tmp37, (3, 2, 0), (1, 3))
    tmp192 = einsum(t1.bb, (0, 1), tmp191, (2, 1), (2, 0))
    del tmp191
    tmp44 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp44, (0, 4, 1, 2), (4, 3)) * -1
    tmp96 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp184 = einsum(v.bbb.xoo, (0, 1, 2), tmp21, (3, 4, 0), (3, 1, 2, 4))
    tmp177 = einsum(v.bbb.xoo, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp45 = einsum(tmp21, (0, 1, 2), v.bbb.xoo, (2, 3, 0), (3, 1))
    tmp154 = einsum(t1.aa, (0, 1), v.baa.xoo, (2, 3, 0), (3, 1, 2))
    tmp57 = tmp18.copy()
    tmp57 += tmp11 * 2
    tmp57 += tmp3
    tmp57 += einsum(tmp7, (0,), t1.aa, (1, 2), (1, 2, 0))
    tmp15 = f.aa.ov.copy()
    tmp15 += tmp14 * -1
    tmp39 = f.bb.ov.copy()
    tmp39 += tmp22 * -1
    tmp12 = tmp11.copy()
    tmp12 += tmp3 * 0.5
    tmp12 += einsum(tmp7, (0,), t1.aa, (1, 2), (1, 2, 0)) * 0.5
    tmp146 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp66 = einsum(tmp0, (0, 1, 2), v.baa.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp81 = v.baa.xvv.transpose((1, 2, 0)).copy()
    tmp81 += tmp80.transpose((1, 0, 2)) * -1
    tmp51 = einsum(tmp9, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp27 = einsum(v.baa.xoo, (0, 1, 2), tmp0, (2, 3, 0), (1, 3))
    tmp112 = einsum(tmp0, (0, 1, 2), tmp0, (3, 4, 2), (3, 0, 4, 1))
    tmp10 = einsum(tmp9, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    t1new.aa += tmp10
    tmp19 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 0, 1, 3), (4, 2)) * -1
    tmp90 = einsum(tmp89, (0, 1, 2), tmp0, (3, 4, 2), (3, 4, 0, 1))
    tmp88 = einsum(tmp87, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    tmp75 = einsum(t1.aa, (0, 1), tmp74, (2, 1), (0, 2))
    del tmp74
    tmp73 = einsum(tmp72, (0, 1, 2), v.baa.xov, (2, 3, 1), (3, 0))
    del tmp72
    tmp98 = einsum(tmp89, (0, 1, 2), v.baa.xoo, (2, 3, 4), (3, 4, 0, 1))
    del tmp89
    tmp94 = einsum(t1.aa, (0, 1), tmp20, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp20
    t2new.aaaa = tmp94.transpose((1, 0, 2, 3)).copy()
    t2new.aaaa += tmp94 * -1
    t2new.aaaa += tmp94.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp94.transpose((0, 1, 3, 2))
    tmp225 = einsum(tmp21, (0, 1, 2), tmp42, (3, 4, 2), (0, 3, 1, 4))
    tmp218 = tmp159.copy()
    tmp218 += tmp208.transpose((1, 0, 3, 2))
    tmp207 = tmp101.transpose((1, 0, 2, 3)).copy()
    tmp207 += tmp101.transpose((1, 0, 3, 2)) * -1
    tmp223 = einsum(tmp221, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4))
    tmp230 = einsum(tmp196, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 1, 0, 4))
    tmp212 = tmp101.transpose((1, 0, 2, 3)).copy()
    tmp212 += tmp101.transpose((1, 0, 3, 2)) * -1
    tmp186 = einsum(tmp42, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp132 = einsum(tmp42, (0, 1, 2), v.bbb.xov, (2, 0, 3), (3, 1))
    tmp135 = einsum(t1.bb, (0, 1), tmp134, (0, 2), (1, 2))
    del tmp134
    tmp133 = einsum(v.bbb.xvv, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp181 = tmp42.copy()
    tmp181 += tmp32
    tmp181 += tmp36 * 2
    tmp181 += einsum(tmp7, (0,), t1.bb, (1, 2), (1, 2, 0))
    tmp199 = tmp42.copy() * -1
    tmp199 += tmp143
    tmp203 = tmp167.transpose((1, 0, 3, 2)).copy() * -1
    tmp203 += tmp202.transpose((0, 1, 3, 2))
    del tmp202
    tmp174 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp46 = einsum(tmp7, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp233 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp193 = tmp190.transpose((1, 0)).copy()
    del tmp190
    tmp193 += tmp192.transpose((1, 0)) * -1
    del tmp192
    tmp145 = einsum(tmp44, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    del tmp44
    t2new.abab += tmp145 * -1
    tmp210 = tmp96.transpose((1, 0, 2, 3)).copy()
    tmp210 += tmp96.transpose((1, 0, 3, 2)) * -1
    tmp195 = tmp42.copy()
    tmp195 += tmp143 * -1
    tmp188 = einsum(t1.bb, (0, 1), tmp184, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp214 = tmp96.transpose((1, 0, 2, 3)).copy()
    tmp214 += tmp96.transpose((1, 0, 3, 2)) * -1
    tmp131 = tmp32.copy()
    tmp131 += tmp36 * 2
    t2new.abab += einsum(tmp131, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    tmp144 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp144 += tmp42
    tmp144 += tmp143 * -1
    t2new.abab += einsum(tmp144, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    tmp228 = einsum(t2.bbbb, (0, 1, 2, 3), tmp101, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp129 = tmp32.copy() * 0.5
    tmp129 += tmp36
    tmp178 = f.bb.oo.copy()
    tmp178 += tmp45.transpose((1, 0)) * -1
    tmp178 += tmp177.transpose((1, 0))
    del tmp177
    tmp31 = einsum(tmp21, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 1, 4))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp31, (4, 1, 0, 3), (4, 2)) * -2
    tmp216 = einsum(v.bbb.xoo, (0, 1, 2), tmp32, (3, 4, 0), (3, 1, 2, 4))
    tmp141 = v.baa.xvv.transpose((1, 2, 0)).copy()
    tmp141 += tmp80 * -1
    tmp150 = v.bbb.xvv.transpose((1, 2, 0)).copy()
    tmp150 += tmp149 * -1
    tmp155 = tmp154.copy() * -1
    del tmp154
    tmp155 += tmp11 * 2
    tmp155 += tmp3
    tmp58 = einsum(tmp57, (0, 1, 2), v.baa.xov, (2, 0, 3), (3, 1))
    del tmp57
    tmp59 = einsum(tmp7, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    tmp60 = einsum(t1.aa, (0, 1), tmp15, (0, 2), (1, 2))
    tmp40 = einsum(tmp39, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp38 = einsum(v.bbb.xov, (0, 1, 2), tmp37, (3, 2, 0), (1, 3)) * 0.5
    del tmp37
    tmp170 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp147 = v.baa.xvv.transpose((1, 2, 0)).copy()
    tmp147 += tmp80 * -1
    del tmp80
    tmp16 = einsum(t1.aa, (0, 1), tmp15, (2, 1), (0, 2)) * 0.5
    del tmp15
    tmp13 = einsum(tmp12, (0, 1, 2), v.baa.xov, (2, 3, 1), (3, 0))
    del tmp12
    tmp162 = einsum(tmp146, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    tmp163 = v.bbb.xvv.transpose((1, 2, 0)).copy()
    tmp163 += tmp149 * -1
    del tmp149
    tmp28 = einsum(tmp7, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp70 = einsum(t1.aa, (0, 1), tmp66, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp122 = einsum(v.baa.xov, (0, 1, 2), tmp81, (3, 4, 0), (1, 4, 3, 2))
    tmp108 = einsum(v.baa.xoo, (0, 1, 2), tmp3, (3, 4, 0), (3, 1, 2, 4))
    tmp83 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp83 += tmp18
    tmp83 += tmp78 * -1
    tmp52 = f.aa.oo.copy()
    tmp52 += tmp27.transpose((1, 0)) * -1
    tmp52 += tmp51.transpose((1, 0))
    del tmp51
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp52, (0, 4), (4, 1, 2, 3)) * -1
    tmp68 = einsum(tmp18, (0, 1, 2), v.baa.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp117 = einsum(t1.aa, (0, 1), tmp112, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp62 = tmp11.copy() * 2
    tmp62 += tmp3
    t2new.abab += einsum(v.bbb.xov, (0, 1, 2), tmp62, (3, 4, 0), (3, 1, 4, 2))
    tmp64 = f.aa.ov.copy()
    tmp64 += tmp14 * -1
    tmp64 += tmp10
    del tmp10
    tmp97 = tmp96.transpose((1, 0, 2, 3)).copy() * -1
    tmp97 += tmp96.transpose((1, 0, 3, 2))
    tmp100 = einsum(t1.aa, (0, 1), tmp19, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp19
    t2new.abab += tmp100 * -1
    tmp106 = tmp101.transpose((1, 0, 2, 3)).copy() * -1
    tmp106 += tmp101.transpose((1, 0, 3, 2))
    tmp91 = tmp88.transpose((1, 0, 3, 2)).copy() * -1
    tmp91 += tmp90.transpose((0, 1, 3, 2))
    del tmp90
    tmp48 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp76 = tmp73.transpose((1, 0)).copy()
    del tmp73
    tmp76 += tmp75 * -1
    del tmp75
    tmp2 = einsum(v.baa.xov, (0, 1, 2), tmp0, (3, 4, 0), (3, 1, 4, 2))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 1, 0, 3), (4, 2)) * -2
    tmp110 = tmp94.copy()
    tmp110 += tmp98.transpose((1, 0, 3, 2))
    tmp79 = tmp18.copy()
    tmp79 += tmp78 * -1
    tmp125 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp120 = einsum(t2.aaaa, (0, 1, 2, 3), tmp96, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp54 = tmp11.copy() * 2
    tmp54 += tmp3
    tmp115 = einsum(tmp18, (0, 1, 2), tmp0, (3, 4, 2), (3, 0, 4, 1))
    tmp102 = tmp101.transpose((1, 0, 2, 3)).copy() * -1
    tmp102 += tmp101.transpose((1, 0, 3, 2))
    tmp104 = tmp96.transpose((1, 0, 2, 3)).copy() * -1
    tmp104 += tmp96.transpose((1, 0, 3, 2))
    tmp85 = tmp18.copy() * -1
    tmp85 += tmp78
    del tmp78
    tmp25 = einsum(tmp7, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp33 = t2.bbbb.copy() * 2
    tmp33 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    tmp23 = einsum(tmp7, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp4 = t2.aaaa.copy() * 2
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    tmp185 = einsum(t2.bbbb, (0, 1, 2, 3), tmp184, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp184
    t2new.bbbb += tmp185.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp185.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp185.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp185.transpose((1, 0, 3, 2)) * -1
    del tmp185
    tmp226 = einsum(t1.bb, (0, 1), tmp225, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp225
    t2new.bbbb += tmp226.transpose((1, 0, 2, 3))
    t2new.bbbb += tmp226 * -1
    t2new.bbbb += tmp226.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp226.transpose((0, 1, 3, 2))
    del tmp226
    tmp219 = einsum(tmp218, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp218
    t2new.bbbb += tmp219.transpose((1, 0, 3, 2)) * -2
    t2new.bbbb += tmp219.transpose((0, 1, 3, 2)) * 2
    del tmp219
    tmp209 = tmp159.copy()
    tmp209 += einsum(t2.bbbb, (0, 1, 2, 3), tmp207, (1, 4, 5, 3), (0, 4, 2, 5)) * -2
    del tmp207
    tmp209 += tmp208.transpose((1, 0, 3, 2))
    del tmp208
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp209, (4, 1, 5, 3), (4, 0, 5, 2)) * -2
    del tmp209
    tmp224 = einsum(t1.bb, (0, 1), tmp223, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp223
    t2new.bbbb += tmp224.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp224
    del tmp224
    tmp231 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp231 += einsum(t1.bb, (0, 1), tmp230, (0, 2, 3, 4), (4, 3, 1, 2))
    del tmp230
    t2new.bbbb += einsum(tmp231, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (4, 5, 3, 2)) * 2
    del tmp231
    tmp213 = tmp159.copy()
    tmp213 += einsum(t2.bbbb, (0, 1, 2, 3), tmp212, (1, 4, 5, 3), (0, 4, 2, 5)) * -2
    del tmp212
    tmp213 += einsum(tmp196, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (3, 4, 1, 0))
    t2new.bbbb += einsum(tmp213, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp213
    tmp206 = einsum(tmp32, (0, 1, 2), tmp36, (3, 4, 2), (0, 3, 1, 4))
    del tmp36
    t2new.bbbb += tmp206.transpose((1, 0, 2, 3)) * -2
    t2new.bbbb += tmp206.transpose((0, 1, 3, 2)) * -2
    t2new.bbbb += tmp206.transpose((1, 0, 3, 2)) * 2
    t2new.bbbb += tmp206 * 2
    del tmp206
    tmp187 = einsum(t1.bb, (0, 1), tmp186, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp186
    t2new.bbbb += tmp187
    t2new.bbbb += tmp187.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp187.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp187.transpose((1, 0, 3, 2))
    del tmp187
    tmp136 = f.bb.vv.copy()
    tmp136 += tmp132 * -1
    del tmp132
    tmp136 += tmp133.transpose((1, 0))
    del tmp133
    tmp136 += tmp135.transpose((1, 0)) * -1
    del tmp135
    t2new.bbbb += einsum(tmp136, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp136, (3, 4), (0, 1, 2, 4))
    del tmp136
    tmp182 = f.bb.vv.copy() * -0.5
    tmp182 += einsum(tmp181, (0, 1, 2), v.bbb.xov, (2, 0, 3), (3, 1)) * 0.5
    del tmp181
    tmp182 += einsum(tmp7, (0,), v.bbb.xvv, (0, 1, 2), (1, 2)) * -0.5
    tmp182 += einsum(tmp39, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    del tmp39
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp182, (3, 4), (0, 1, 4, 2)) * 4
    del tmp182
    tmp200 = einsum(tmp32, (0, 1, 2), tmp199, (3, 4, 2), (3, 0, 4, 1))
    del tmp199
    t2new.bbbb += tmp200.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp200.transpose((1, 0, 2, 3))
    del tmp200
    tmp204 = einsum(tmp203, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp203
    t2new.bbbb += tmp204.transpose((0, 1, 3, 2)) * 2
    t2new.bbbb += tmp204.transpose((1, 0, 3, 2)) * -2
    t2new.bbbb += tmp204 * -2
    del tmp204
    tmp180 = einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * 2
    tmp180 += t2.bbbb * -1
    t2new.bbbb += einsum(tmp174, (0, 1, 2, 3), tmp180, (0, 2, 4, 5), (1, 3, 5, 4)) * -0.5
    del tmp180
    tmp220 = einsum(tmp42, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 4, 1))
    t2new.bbbb += tmp220.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp220.transpose((0, 1, 3, 2))
    del tmp220
    tmp176 = einsum(t2.bbbb, (0, 1, 2, 3), tmp174, (4, 0, 5, 1), (5, 4, 2, 3))
    t2new.bbbb += tmp176.transpose((0, 1, 3, 2)) * -0.5
    t2new.bbbb += tmp176.transpose((0, 1, 3, 2)) * -0.5
    del tmp176
    tmp227 = einsum(tmp42, (0, 1, 2), tmp42, (3, 4, 2), (0, 3, 1, 4))
    t2new.bbbb += tmp227.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp227
    del tmp227
    tmp47 = f.bb.oo.copy()
    tmp47 += tmp45.transpose((1, 0)) * -1
    del tmp45
    tmp47 += tmp46.transpose((1, 0))
    del tmp46
    t2new.bbbb += einsum(tmp47, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp47, (1, 4), (0, 4, 2, 3)) * -1
    t1new.bb += einsum(t1.bb, (0, 1), tmp47, (0, 2), (2, 1)) * -1
    del tmp47
    tmp234 = einsum(tmp233, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (4, 5, 0, 1)) * -1
    del tmp233
    t2new.bbbb += einsum(t1.bb, (0, 1), tmp234, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp234
    tmp194 = einsum(tmp193, (0, 1), t2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    del tmp193
    t2new.bbbb += tmp194.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp194.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp194.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp194.transpose((1, 0, 3, 2)) * -1
    del tmp194
    tmp211 = tmp145.copy()
    tmp211 += einsum(t2.abab, (0, 1, 2, 3), tmp210, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp210
    t2new.bbbb += einsum(t2.abab, (0, 1, 2, 3), tmp211, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp211
    tmp205 = einsum(tmp166, (0, 1, 2), tmp32, (3, 4, 2), (3, 0, 4, 1))
    del tmp166
    t2new.bbbb += tmp205.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp205.transpose((1, 0, 3, 2))
    del tmp205
    tmp197 = einsum(v.bbb.xov, (0, 1, 2), tmp195, (3, 4, 0), (3, 1, 4, 2)) * -1
    del tmp195
    tmp197 += einsum(tmp196, (0, 1, 2), tmp21, (3, 4, 2), (3, 4, 1, 0))
    del tmp196
    t2new.bbbb += einsum(tmp197, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp197
    tmp189 = einsum(t1.bb, (0, 1), tmp188, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp188
    t2new.bbbb += tmp189.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp189 * -1
    t2new.bbbb += tmp189.transpose((1, 0, 3, 2)) * -1
    t2new.bbbb += tmp189.transpose((1, 0, 2, 3))
    del tmp189
    tmp215 = tmp145.copy()
    del tmp145
    tmp215 += einsum(tmp214, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp214
    t2new.bbbb += einsum(t2.abab, (0, 1, 2, 3), tmp215, (0, 4, 2, 5), (1, 4, 5, 3))
    del tmp215
    tmp183 = einsum(tmp131, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp131
    t2new.bbbb += tmp183.transpose((1, 0, 3, 2))
    t2new.bbbb += tmp183.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp183.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp183
    del tmp183
    tmp198 = einsum(tmp144, (0, 1, 2), v.bbb.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp144
    t2new.bbbb += tmp198.transpose((1, 0, 2, 3)) * -1
    t2new.bbbb += tmp198
    del tmp198
    tmp229 = einsum(tmp228, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp228
    t2new.bbbb += tmp229.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp229.transpose((0, 1, 3, 2)) * -1
    del tmp229
    tmp130 = einsum(v.bbb.xov, (0, 1, 2), tmp129, (1, 3, 0), (2, 3)) * 2
    del tmp129
    t2new.bbbb += einsum(tmp130, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    t2new.abab += einsum(tmp130, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp130
    tmp179 = einsum(t2.bbbb, (0, 1, 2, 3), tmp178, (1, 4), (4, 0, 2, 3)) * -1
    del tmp178
    t2new.bbbb += tmp179.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp179.transpose((0, 1, 3, 2))
    t2new.bbbb += tmp179.transpose((1, 0, 3, 2)) * -1
    del tmp179
    tmp232 = einsum(t1.bb, (0, 1), tmp31, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp31
    t2new.bbbb += tmp232 * -1
    t2new.bbbb += tmp232.transpose((1, 0, 2, 3))
    del tmp232
    tmp222 = einsum(tmp221, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp221
    t2new.bbbb += tmp222.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp222.transpose((0, 1, 3, 2)) * -1
    del tmp222
    tmp217 = einsum(t1.bb, (0, 1), tmp216, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp216
    t2new.bbbb += tmp217.transpose((0, 1, 3, 2)) * -1
    t2new.bbbb += tmp217.transpose((1, 0, 3, 2))
    del tmp217
    tmp175 = t2.bbbb.copy()
    tmp175 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    t2new.bbbb += einsum(tmp175, (0, 1, 2, 3), tmp174, (0, 4, 1, 5), (4, 5, 3, 2)) * 0.5
    del tmp174, tmp175
    tmp138 = t2.abab.copy()
    tmp138 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp142 = einsum(tmp21, (0, 1, 2), tmp141, (3, 4, 2), (0, 1, 4, 3))
    del tmp141
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp142, (4, 1, 2, 5), (0, 4, 5, 3)) * -1
    del tmp142
    tmp1 = einsum(v.bbb.xov, (0, 1, 2), tmp0, (3, 4, 0), (3, 4, 1, 2))
    t2new.abab += einsum(t1.aa, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp1
    tmp168 = tmp167.transpose((1, 0, 2, 3)).copy() * -1
    del tmp167
    tmp168 += einsum(tmp21, (0, 1, 2), tmp150, (3, 4, 2), (0, 1, 4, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp168, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    del tmp168
    tmp157 = einsum(tmp101, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 1, 5, 2)) * -1
    del tmp101
    tmp157 += einsum(v.bbb.xov, (0, 1, 2), tmp155, (3, 4, 0), (3, 1, 4, 2))
    t2new.abab += einsum(tmp157, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp157
    tmp153 = einsum(tmp21, (0, 1, 2), tmp0, (3, 4, 2), (3, 4, 0, 1))
    t2new.abab += einsum(tmp153, (0, 1, 2, 3), tmp138, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp153
    tmp128 = t2.abab.copy()
    tmp128 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    tmp169 = einsum(tmp150, (0, 1, 2), tmp0, (3, 4, 2), (3, 4, 1, 0))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp169, (4, 0, 3, 5), (4, 1, 2, 5)) * -1
    del tmp169
    tmp161 = einsum(tmp146, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 0, 5, 1))
    t2new.abab += einsum(tmp161, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp161
    tmp61 = f.aa.vv.copy() * -1
    tmp61 += tmp58
    del tmp58
    tmp61 += tmp59.transpose((1, 0)) * -1
    del tmp59
    tmp61 += tmp60.transpose((1, 0))
    del tmp60
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp61, (2, 4), (0, 1, 4, 3)) * -1
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp61, (3, 4), (0, 1, 4, 2)) * 2
    del tmp61
    tmp41 = tmp38.copy()
    del tmp38
    tmp41 += tmp40.transpose((1, 0))
    del tmp40
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp41, (1, 4), (0, 4, 2, 3)) * -2
    t1new.bb += einsum(t1.bb, (0, 1), tmp41, (0, 2), (2, 1)) * -2
    del tmp41
    tmp172 = einsum(tmp42, (0, 1, 2), v.baa.xoo, (2, 3, 4), (3, 4, 0, 1))
    t2new.abab += einsum(t1.aa, (0, 1), tmp172, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp172
    tmp171 = einsum(t2.abab, (0, 1, 2, 3), tmp170, (4, 2, 5, 3), (0, 4, 1, 5))
    del tmp170
    t2new.abab += einsum(t1.aa, (0, 1), tmp171, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp171
    tmp148 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (0, 4, 5, 3), (4, 1, 5, 2))
    del tmp146
    tmp148 += einsum(tmp147, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (3, 4, 1, 0)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp148, (1, 4, 2, 5), (0, 4, 5, 3))
    del tmp148
    tmp127 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    t2new.abab += einsum(tmp127, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    t2new.abab += einsum(tmp127, (0, 1, 2, 3), tmp128, (0, 2, 4, 5), (1, 3, 4, 5)) * 0.5
    del tmp127, tmp128
    tmp158 = einsum(tmp11, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (0, 3, 4, 1))
    t2new.abab += einsum(t1.bb, (0, 1), tmp158, (2, 0, 3, 4), (2, 3, 4, 1)) * -2
    del tmp158
    tmp152 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp152 += tmp42
    tmp152 += tmp143 * -1
    del tmp143
    t2new.abab += einsum(tmp18, (0, 1, 2), tmp152, (3, 4, 2), (0, 3, 1, 4))
    del tmp152
    tmp151 = einsum(v.baa.xoo, (0, 1, 2), tmp150, (3, 4, 0), (1, 2, 4, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp151, (0, 4, 3, 5), (4, 1, 2, 5)) * -1
    del tmp151
    tmp140 = einsum(tmp0, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (0, 1, 3, 4))
    t2new.abab += einsum(tmp140, (0, 1, 2, 3), tmp138, (1, 2, 4, 5), (0, 3, 4, 5))
    del tmp140
    tmp173 = einsum(tmp42, (0, 1, 2), tmp0, (3, 4, 2), (3, 4, 0, 1))
    del tmp42
    t2new.abab += einsum(t1.aa, (0, 1), tmp173, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp173
    tmp137 = einsum(v.baa.xoo, (0, 1, 2), tmp21, (3, 4, 0), (1, 2, 3, 4))
    t2new.abab += einsum(tmp137, (0, 1, 2, 3), tmp138, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp138, tmp137
    tmp156 = einsum(tmp96, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (1, 4, 2, 5)) * 2
    del tmp96
    tmp156 += einsum(tmp155, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1)) * -1
    del tmp155
    tmp156 += einsum(tmp147, (0, 1, 2), v.baa.xoo, (2, 3, 4), (3, 4, 1, 0))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp156, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp156
    tmp160 = tmp159.transpose((1, 0, 3, 2)).copy()
    del tmp159
    tmp160 += einsum(tmp150, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (3, 4, 1, 0))
    del tmp150
    t2new.abab += einsum(tmp160, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    del tmp160
    tmp17 = tmp13.copy()
    del tmp13
    tmp17 += tmp16.transpose((1, 0))
    del tmp16
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp17, (0, 4), (4, 1, 2, 3)) * -2
    t1new.aa += einsum(t1.aa, (0, 1), tmp17, (0, 2), (2, 1)) * -2
    del tmp17
    tmp139 = einsum(tmp18, (0, 1, 2), v.bbb.xoo, (2, 3, 4), (0, 3, 4, 1))
    t2new.abab += einsum(t1.bb, (0, 1), tmp139, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp139
    tmp164 = einsum(tmp162, (0, 1, 2, 3), t1.aa, (0, 4), (1, 4, 3, 2))
    del tmp162
    tmp164 += einsum(v.baa.xvv, (0, 1, 2), tmp163, (3, 4, 0), (1, 2, 4, 3))
    del tmp163
    t2new.abab += einsum(tmp164, (0, 1, 2, 3), t2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp164
    tmp165 = tmp88.transpose((1, 0, 2, 3)).copy() * -1
    del tmp88
    tmp165 += einsum(tmp147, (0, 1, 2), tmp0, (3, 4, 2), (3, 4, 1, 0))
    del tmp147
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp165, (4, 0, 2, 5), (4, 1, 5, 3)) * -1
    del tmp165
    tmp29 = f.aa.oo.copy()
    tmp29 += tmp27.transpose((1, 0)) * -1
    del tmp27
    tmp29 += tmp28.transpose((1, 0))
    del tmp28
    t2new.aaaa += einsum(tmp29, (0, 1), t2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    t1new.aa += einsum(t1.aa, (0, 1), tmp29, (0, 2), (2, 1)) * -1
    del tmp29
    tmp71 = einsum(tmp70, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp70
    t2new.aaaa += tmp71.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp71 * -1
    t2new.aaaa += tmp71.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp71.transpose((1, 0, 2, 3))
    del tmp71
    tmp123 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp123 += einsum(t1.aa, (0, 1), tmp122, (0, 2, 3, 4), (4, 3, 1, 2))
    del tmp122
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp123, (2, 3, 4, 5), (0, 1, 5, 4)) * 2
    del tmp123
    tmp109 = einsum(t1.aa, (0, 1), tmp108, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp108
    t2new.aaaa += tmp109.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp109.transpose((1, 0, 3, 2))
    del tmp109
    tmp84 = einsum(v.baa.xov, (0, 1, 2), tmp83, (3, 4, 0), (1, 3, 2, 4))
    del tmp83
    t2new.aaaa += tmp84.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp84
    del tmp84
    tmp56 = einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    tmp56 += t2.aaaa * -1
    t2new.aaaa += einsum(tmp48, (0, 1, 2, 3), tmp56, (0, 2, 4, 5), (1, 3, 5, 4)) * -0.5
    del tmp56
    tmp53 = einsum(t2.aaaa, (0, 1, 2, 3), tmp52, (1, 4), (0, 4, 2, 3)) * -1
    del tmp52
    t2new.aaaa += tmp53.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp53.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp53.transpose((0, 1, 3, 2)) * -1
    del tmp53
    tmp113 = einsum(t2.aaaa, (0, 1, 2, 3), tmp112, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp112
    t2new.aaaa += tmp113.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp113.transpose((0, 1, 3, 2)) * -1
    del tmp113
    tmp69 = einsum(t1.aa, (0, 1), tmp68, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp68
    t2new.aaaa += tmp69
    t2new.aaaa += tmp69.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp69.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp69.transpose((1, 0, 3, 2))
    del tmp69
    tmp118 = einsum(t1.aa, (0, 1), tmp117, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp117
    t2new.aaaa += tmp118.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp118
    del tmp118
    tmp63 = einsum(tmp62, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp62
    t2new.aaaa += tmp63.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp63.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp63.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp63
    del tmp63
    tmp65 = f.aa.vv.copy()
    tmp65 += einsum(v.baa.xov, (0, 1, 2), tmp18, (1, 3, 0), (2, 3)) * -1
    tmp65 += einsum(v.baa.xvv, (0, 1, 2), tmp9, (0,), (1, 2))
    del tmp9
    tmp65 += einsum(tmp64, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp64
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp65, (3, 4), (0, 1, 2, 4)) * 2
    del tmp65
    tmp99 = tmp94.copy()
    tmp99 += einsum(t2.aaaa, (0, 1, 2, 3), tmp97, (1, 4, 3, 5), (0, 4, 2, 5)) * -2
    del tmp97
    tmp99 += tmp98.transpose((1, 0, 3, 2))
    del tmp98
    t2new.aaaa += einsum(tmp99, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp99
    tmp107 = tmp100.copy()
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), tmp106, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp106
    t2new.aaaa += einsum(tmp107, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5))
    del tmp107
    tmp92 = einsum(t2.aaaa, (0, 1, 2, 3), tmp91, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp91
    t2new.aaaa += tmp92.transpose((1, 0, 2, 3)) * 2
    t2new.aaaa += tmp92 * -2
    t2new.aaaa += tmp92.transpose((1, 0, 3, 2)) * -2
    del tmp92
    tmp95 = einsum(tmp3, (0, 1, 2), tmp11, (3, 4, 2), (3, 0, 4, 1))
    del tmp11
    t2new.aaaa += tmp95.transpose((1, 0, 2, 3)) * -2
    t2new.aaaa += tmp95.transpose((0, 1, 3, 2)) * -2
    t2new.aaaa += tmp95.transpose((1, 0, 3, 2)) * 2
    t2new.aaaa += tmp95 * 2
    del tmp95
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 0, 5, 1), (5, 4, 2, 3))
    t2new.aaaa += tmp50.transpose((0, 1, 3, 2)) * -0.5
    t2new.aaaa += tmp50.transpose((0, 1, 3, 2)) * -0.5
    del tmp50
    tmp77 = einsum(t2.aaaa, (0, 1, 2, 3), tmp76, (4, 1), (0, 4, 2, 3)) * -1
    del tmp76
    t2new.aaaa += tmp77.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp77.transpose((1, 0, 3, 2))
    t2new.aaaa += tmp77.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp77.transpose((0, 1, 3, 2)) * -1
    del tmp77
    tmp124 = einsum(t1.aa, (0, 1), tmp2, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp2
    t2new.aaaa += tmp124 * -1
    t2new.aaaa += tmp124.transpose((1, 0, 2, 3))
    del tmp124
    tmp49 = t2.aaaa.copy()
    tmp49 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    t2new.aaaa += einsum(tmp49, (0, 1, 2, 3), tmp48, (0, 4, 1, 5), (4, 5, 3, 2)) * 0.5
    del tmp48, tmp49
    tmp111 = einsum(t2.aaaa, (0, 1, 2, 3), tmp110, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp110
    t2new.aaaa += tmp111 * -2
    t2new.aaaa += tmp111.transpose((1, 0, 2, 3)) * 2
    del tmp111
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2.aaaa, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp66
    t2new.aaaa += tmp67.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp67.transpose((0, 1, 3, 2))
    t2new.aaaa += tmp67.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp67.transpose((1, 0, 3, 2)) * -1
    del tmp67
    tmp82 = einsum(tmp79, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4)) * -1
    del tmp79
    tmp82 += einsum(tmp0, (0, 1, 2), tmp81, (3, 4, 2), (0, 1, 4, 3))
    del tmp0
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp82, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp82
    tmp126 = einsum(tmp125, (0, 1, 2, 3), t2.aaaa, (4, 5, 2, 3), (4, 5, 0, 1)) * -1
    del tmp125
    t2new.aaaa += einsum(t1.aa, (0, 1), tmp126, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp126
    tmp121 = einsum(tmp120, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp120
    t2new.aaaa += tmp121.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp121.transpose((0, 1, 3, 2)) * -1
    del tmp121
    tmp55 = einsum(v.baa.xov, (0, 1, 2), tmp54, (1, 3, 0), (3, 2)) * 0.5
    del tmp54
    t2new.aaaa += einsum(tmp55, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp55
    tmp93 = einsum(tmp87, (0, 1, 2), tmp3, (3, 4, 2), (3, 0, 4, 1))
    del tmp87
    t2new.aaaa += tmp93.transpose((1, 0, 2, 3)) * -1
    t2new.aaaa += tmp93.transpose((1, 0, 3, 2))
    del tmp93
    tmp116 = einsum(t1.aa, (0, 1), tmp115, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp115
    t2new.aaaa += tmp116.transpose((1, 0, 2, 3))
    t2new.aaaa += tmp116 * -1
    t2new.aaaa += tmp116.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp116.transpose((0, 1, 3, 2))
    del tmp116
    tmp119 = einsum(tmp18, (0, 1, 2), tmp18, (3, 4, 2), (3, 0, 4, 1))
    t2new.aaaa += tmp119.transpose((0, 1, 3, 2)) * -1
    t2new.aaaa += tmp119
    del tmp119
    tmp103 = tmp100.copy()
    del tmp100
    tmp103 += einsum(t2.abab, (0, 1, 2, 3), tmp102, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp102
    t2new.aaaa += einsum(t2.abab, (0, 1, 2, 3), tmp103, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp103
    tmp105 = tmp94.copy()
    del tmp94
    tmp105 += einsum(tmp104, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * -2
    del tmp104
    tmp105 += einsum(v.baa.xoo, (0, 1, 2), tmp81, (3, 4, 0), (1, 2, 4, 3))
    del tmp81
    t2new.aaaa += einsum(tmp105, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp105
    tmp114 = einsum(v.baa.xov, (0, 1, 2), tmp18, (3, 4, 0), (3, 1, 2, 4))
    del tmp18
    t2new.aaaa += tmp114.transpose((1, 0, 3, 2)) * -1
    t2new.aaaa += tmp114.transpose((0, 1, 3, 2))
    del tmp114
    tmp86 = einsum(tmp85, (0, 1, 2), tmp3, (3, 4, 2), (3, 0, 4, 1))
    del tmp85
    t2new.aaaa += tmp86 * -1
    t2new.aaaa += tmp86.transpose((0, 1, 3, 2))
    del tmp86
    tmp26 = f.aa.ov.copy()
    tmp26 += tmp14 * -1
    del tmp14
    tmp26 += tmp25
    del tmp25
    t1new.bb += einsum(tmp26, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp26, (1, 3), (0, 2)) * 2
    del tmp26
    tmp30 = einsum(tmp21, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 1, 4))
    del tmp21
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp30, (0, 4, 1, 2), (4, 3)) * -1
    del tmp30
    tmp34 = tmp32.copy()
    del tmp32
    tmp34 += einsum(v.bbb.xov, (0, 1, 2), tmp33, (1, 3, 2, 4), (3, 4, 0))
    del tmp33
    tmp34 += einsum(tmp7, (0,), t1.bb, (1, 2), (1, 2, 0))
    t1new.bb += einsum(tmp34, (0, 1, 2), v.bbb.xvv, (2, 3, 1), (0, 3))
    del tmp34
    tmp24 = f.bb.ov.copy()
    tmp24 += tmp22 * -1
    del tmp22
    tmp24 += tmp23
    del tmp23
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp24, (1, 3), (0, 2)) * 2
    t1new.aa += einsum(tmp24, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp24
    tmp8 = tmp3.copy()
    del tmp3
    tmp8 += einsum(v.baa.xov, (0, 1, 2), tmp4, (1, 3, 2, 4), (3, 4, 0))
    del tmp4
    tmp8 += einsum(tmp7, (0,), t1.aa, (1, 2), (1, 2, 0))
    del tmp7
    t1new.aa += einsum(tmp8, (0, 1, 2), v.baa.xvv, (2, 3, 1), (0, 3))
    del tmp8
    t1new.aa += f.aa.ov
    t1new.aa += einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    t1new.bb += f.bb.ov
    t1new.bb += einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:53:41.106213.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp12 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 0, 1), (2,))
    tmp13 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp14 = tmp12.copy()
    tmp14 += tmp13
    tmp4 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (0, 3, 2))
    tmp1 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (0, 3, 2))
    tmp24 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    tmp27 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (3, 1, 0))
    tmp25 = einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    tmp7 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (3, 1, 0))
    tmp9 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (0, 2, 4))
    tmp8 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (1, 3, 4))
    tmp103 = einsum(v.bbb.xov, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp102 = einsum(tmp4, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3))
    l2new.bbbb = einsum(l1.bb, (0, 1), tmp102, (2, 3), (0, 3, 2, 1))
    l2new.bbbb += einsum(tmp102, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.bbbb += einsum(tmp102, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0)) * -1
    l2new.bbbb += einsum(tmp102, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.abab = einsum(tmp102, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0)) * -1
    tmp43 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp44 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp36 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp35 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), tmp1, (1, 3, 0), (3, 2))
    l2new.abab += einsum(l1.bb, (0, 1), tmp11, (2, 3), (3, 0, 2, 1)) * -1
    l2new.aaaa = einsum(tmp11, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3))
    l2new.aaaa += einsum(tmp11, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa += einsum(tmp11, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (3, 0, 1, 2))
    tmp15 = einsum(tmp14, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp64 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp66 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp65 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp53 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp52 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp54 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp97 = tmp12.copy()
    del tmp12
    tmp97 += tmp13
    del tmp13
    tmp62 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp162 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp162 += tmp27
    tmp162 += tmp24 * 2
    tmp162 += tmp25
    tmp50 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    tmp164 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp164 += tmp7
    tmp164 += tmp8
    tmp164 += tmp9 * 2
    tmp123 = tmp8.copy() * 0.5
    tmp123 += tmp9
    tmp104 = f.bb.ov.copy()
    tmp104 += tmp102 * -1
    tmp104 += tmp103
    tmp118 = tmp43.copy() * 0.5
    tmp118 += tmp44
    tmp210 = tmp7.copy()
    tmp210 += tmp8
    tmp210 += tmp9 * 2
    tmp60 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp48 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    tmp37 = tmp35.copy() * 2
    tmp37 += tmp36
    tmp16 = f.aa.ov.copy()
    tmp16 += tmp11 * -1
    tmp16 += tmp15
    tmp73 = tmp24.copy() * 2
    tmp73 += tmp25
    tmp175 = tmp27.copy() * 0.5
    tmp175 += tmp24
    tmp175 += tmp25 * 0.5
    tmp112 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp67 = tmp64.copy()
    tmp67 += tmp65
    tmp67 += tmp66 * 2
    l1new.bb = einsum(tmp67, (0, 1), tmp104, (1, 2), (2, 0)) * -1
    tmp55 = tmp52.copy() * 0.5
    tmp55 += tmp53
    tmp55 += tmp54 * 0.5
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp29 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp203 = einsum(v.bbb.xov, (0, 1, 2), tmp97, (0,), (1, 2))
    tmp197 = einsum(v.bbb.xvv, (0, 1, 2), l1.bb, (2, 3), (3, 1, 0))
    tmp131 = einsum(tmp62, (0, 1, 2, 3), tmp4, (0, 2, 4), (1, 3, 4)) * -1
    tmp129 = einsum(v.bbb.xoo, (0, 1, 2), tmp62, (2, 3, 1, 4), (3, 4, 0)) * -1
    tmp198 = einsum(l2.abab, (0, 1, 2, 3), tmp162, (2, 0, 4), (3, 1, 4))
    tmp128 = einsum(v.baa.xoo, (0, 1, 2), tmp50, (2, 1, 3, 4), (3, 4, 0))
    tmp130 = einsum(tmp50, (0, 1, 2, 3), tmp1, (0, 1, 4), (2, 3, 4))
    tmp199 = einsum(tmp164, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2))
    tmp201 = v.bbb.xoo.transpose((1, 2, 0)).copy()
    tmp201 += tmp4.transpose((1, 0, 2))
    tmp124 = einsum(tmp123, (0, 1, 2), v.bbb.xov, (2, 3, 1), (0, 3)) * 2
    del tmp123
    tmp122 = einsum(tmp4, (0, 1, 2), v.bbb.xoo, (2, 3, 0), (3, 1))
    tmp126 = einsum(t1.bb, (0, 1), tmp104, (2, 1), (2, 0))
    tmp125 = einsum(tmp14, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp140 = einsum(t1.bb, (0, 1), tmp62, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp139 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp134 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp135 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp119 = einsum(v.bbb.xov, (0, 1, 2), tmp118, (3, 2), (1, 3, 0)) * 2
    tmp212 = einsum(v.bbb.xvv, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp211 = einsum(tmp210, (0, 1, 2), v.bbb.xov, (2, 0, 3), (1, 3))
    del tmp210
    tmp91 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp92 = einsum(t1.aa, (0, 1), tmp60, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp90 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp83 = einsum(t1.aa, (0, 1), tmp48, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp85 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp86 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp145 = einsum(v.baa.xov, (0, 1, 2), tmp37, (3, 2), (1, 3, 0)) * 0.5
    l2new.abab += einsum(tmp145, (0, 1, 2), v.bbb.xov, (2, 3, 4), (1, 4, 0, 3)) * -2
    tmp10 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp10 += tmp7
    tmp10 += tmp8
    tmp10 += tmp9 * 2
    tmp79 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp79 += tmp27
    tmp79 += tmp24 * 2
    tmp79 += tmp25
    tmp148 = v.baa.xoo.transpose((1, 2, 0)).copy()
    tmp148 += tmp1.transpose((1, 0, 2))
    tmp168 = einsum(v.baa.xov, (0, 1, 2), tmp97, (0,), (1, 2))
    tmp152 = einsum(v.baa.xvv, (0, 1, 2), l1.aa, (2, 3), (3, 1, 0))
    tmp77 = einsum(tmp1, (0, 1, 2), tmp48, (0, 3, 1, 4), (3, 4, 2)) * -1
    tmp163 = einsum(l2.aaaa, (0, 1, 2, 3), tmp162, (3, 1, 4), (2, 0, 4))
    del tmp162
    tmp76 = einsum(tmp60, (0, 1, 2, 3), v.bbb.xoo, (4, 2, 1), (0, 3, 4))
    tmp75 = einsum(tmp48, (0, 1, 2, 3), v.baa.xoo, (4, 2, 0), (1, 3, 4)) * -1
    tmp78 = einsum(tmp60, (0, 1, 2, 3), tmp4, (1, 2, 4), (0, 3, 4))
    tmp165 = einsum(l2.abab, (0, 1, 2, 3), tmp164, (3, 1, 4), (2, 0, 4))
    del tmp164
    tmp72 = einsum(v.baa.xoo, (0, 1, 2), tmp1, (2, 3, 0), (1, 3))
    tmp156 = einsum(tmp16, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp154 = einsum(v.baa.xov, (0, 1, 2), tmp73, (3, 2, 0), (1, 3))
    tmp155 = einsum(tmp14, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp176 = einsum(v.baa.xov, (0, 1, 2), tmp175, (1, 3, 0), (3, 2)) * 2
    tmp177 = einsum(v.baa.xvv, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp114 = einsum(tmp4, (0, 1, 2), tmp4, (3, 4, 2), (0, 3, 1, 4))
    tmp113 = einsum(tmp112, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (4, 5, 1, 0)) * -1
    tmp115 = einsum(v.bbb.xoo, (0, 1, 2), tmp4, (3, 4, 0), (3, 1, 2, 4))
    tmp111 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp105 = v.bbb.xoo.transpose((1, 2, 0)).copy()
    tmp105 += tmp4.transpose((1, 0, 2))
    tmp58 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), tmp60, (0, 1, 4, 2), (4, 3))
    tmp68 = einsum(t1.bb, (0, 1), tmp67, (0, 2), (2, 1))
    tmp59 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp63 = einsum(tmp62, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4))
    tmp46 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (0, 2), (2, 1))
    tmp49 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (1, 0, 4, 3), (4, 2))
    tmp47 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp42 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp40 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp5 = v.bbb.xoo.transpose((1, 2, 0)).copy()
    tmp5 += tmp4
    tmp2 = v.baa.xoo.transpose((1, 2, 0)).copy()
    tmp2 += tmp1
    tmp18 = einsum(tmp17, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 0, 5, 1))
    tmp19 = v.baa.xoo.transpose((1, 2, 0)).copy()
    tmp19 += tmp1.transpose((1, 0, 2))
    tmp32 = einsum(v.baa.xoo, (0, 1, 2), tmp1, (3, 4, 0), (3, 1, 2, 4))
    tmp28 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp31 = einsum(tmp1, (0, 1, 2), tmp1, (3, 4, 2), (0, 3, 1, 4))
    tmp30 = einsum(t2.aaaa, (0, 1, 2, 3), tmp29, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    tmp220 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp220, (0, 1, 2, 3), tmp60, (4, 1, 2, 5), (5, 3, 4, 0))
    tmp214 = f.bb.ov.copy()
    tmp214 += tmp102 * -1
    del tmp102
    tmp214 += tmp203
    l2new.abab += einsum(tmp60, (0, 1, 2, 3), tmp214, (2, 4), (3, 4, 0, 1)) * -1
    tmp232 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp240 = einsum(v.bbb.xov, (0, 1, 2), tmp118, (3, 2), (1, 3, 0))
    del tmp118
    tmp200 = tmp197.copy()
    tmp200 += tmp128 * -1
    tmp200 += tmp129 * -2
    tmp200 += tmp130 * -1
    tmp200 += tmp131 * -2
    tmp200 += tmp198
    del tmp198
    tmp200 += tmp199 * 2
    del tmp199
    l2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp200, (3, 4, 0), (2, 4, 1, 3))
    tmp246 = einsum(tmp67, (0, 1), v.bbb.xov, (2, 1, 3), (0, 3, 2)) * 0.5
    tmp202 = einsum(v.bbb.xvv, (0, 1, 2), tmp201, (3, 4, 0), (3, 4, 1, 2))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp202, (4, 3, 5, 1), (0, 5, 2, 4)) * -1
    tmp221 = einsum(tmp4, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 1, 4))
    l2new.abab += einsum(tmp221, (0, 1, 2, 3), tmp60, (4, 0, 1, 5), (5, 3, 4, 2))
    tmp127 = f.bb.oo.copy()
    tmp127 += tmp122 * -1
    del tmp122
    tmp127 += tmp124
    del tmp124
    tmp127 += tmp125.transpose((1, 0))
    del tmp125
    tmp127 += tmp126.transpose((1, 0))
    del tmp126
    l2new.abab += einsum(tmp127, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    l1new.bb += einsum(l1.bb, (0, 1), tmp127, (1, 2), (0, 2)) * -1
    tmp224 = einsum(tmp201, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 1, 3, 4))
    l2new.bbbb += einsum(tmp224, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 0, 2))
    tmp141 = tmp139.transpose((1, 0, 3, 2)).copy()
    del tmp139
    tmp141 += tmp140.transpose((0, 1, 3, 2)) * -1
    del tmp140
    tmp108 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp244 = tmp134.copy()
    tmp244 += tmp135 * 4
    tmp195 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp195 += tmp119 * -1
    l2new.abab += einsum(tmp195, (0, 1, 2), v.baa.xov, (2, 3, 4), (4, 1, 3, 0))
    tmp218 = einsum(tmp67, (0, 1), v.bbb.xov, (2, 1, 3), (0, 3, 2))
    l2new.abab += einsum(tmp218, (0, 1, 2), v.baa.xov, (2, 3, 4), (4, 1, 3, 0)) * -1
    tmp213 = f.bb.vv.copy() * -1
    tmp213 += tmp211
    del tmp211
    tmp213 += tmp212.transpose((1, 0)) * -1
    del tmp212
    l2new.abab += einsum(tmp213, (0, 1), l2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp206 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp93 = tmp91.copy()
    tmp93 += tmp92
    tmp187 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    l2new.abab += einsum(tmp187, (0, 1, 2, 3), tmp50, (1, 2, 4, 5), (3, 5, 0, 4))
    tmp173 = tmp90.transpose((1, 0, 3, 2)).copy()
    tmp173 += tmp83.transpose((0, 1, 3, 2)) * -1
    tmp189 = tmp85.copy() * 4
    tmp189 += tmp86
    tmp146 = v.baa.xov.transpose((1, 2, 0)).copy() * 0.5
    tmp146 += tmp145 * -1
    del tmp145
    tmp81 = einsum(tmp10, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2)) * 0.5
    tmp80 = einsum(l2.aaaa, (0, 1, 2, 3), tmp79, (3, 1, 4), (2, 0, 4))
    tmp149 = einsum(v.baa.xov, (0, 1, 2), tmp148, (3, 4, 0), (3, 4, 1, 2))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp149, (2, 1, 3, 4), (4, 0, 2, 3))
    tmp180 = f.aa.ov.copy()
    tmp180 += tmp11 * -1
    del tmp11
    tmp180 += tmp168
    l2new.abab += einsum(tmp180, (0, 1), tmp50, (2, 0, 3, 4), (1, 4, 2, 3)) * -1
    tmp160 = einsum(v.baa.xvv, (0, 1, 2), tmp148, (3, 4, 0), (3, 4, 1, 2))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp160, (4, 2, 5, 0), (5, 1, 4, 3)) * -1
    tmp191 = einsum(tmp55, (0, 1), v.baa.xov, (2, 1, 3), (0, 3, 2)) * 2
    l2new.abab += einsum(tmp191, (0, 1, 2), v.bbb.xov, (2, 3, 4), (1, 4, 0, 3)) * -1
    tmp185 = einsum(tmp1, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4))
    l2new.abab += einsum(tmp185, (0, 1, 2, 3), tmp50, (0, 1, 4, 5), (3, 5, 2, 4))
    tmp22 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp171 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp166 = tmp152.copy()
    tmp166 += tmp75 * -2
    tmp166 += tmp76 * -1
    tmp166 += tmp77 * -2
    tmp166 += tmp78 * -1
    tmp166 += tmp163 * 2
    del tmp163
    tmp166 += tmp165
    del tmp165
    l2new.abab += einsum(v.bbb.xov, (0, 1, 2), tmp166, (3, 4, 0), (4, 2, 3, 1))
    tmp193 = einsum(tmp55, (0, 1), v.baa.xov, (2, 1, 3), (0, 3, 2))
    tmp38 = einsum(v.baa.xov, (0, 1, 2), tmp37, (3, 2), (1, 3, 0))
    del tmp37
    tmp157 = f.aa.oo.copy()
    tmp157 += tmp72 * -1
    tmp157 += tmp154.transpose((1, 0))
    del tmp154
    tmp157 += tmp155.transpose((1, 0))
    del tmp155
    tmp157 += tmp156
    del tmp156
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp157, (2, 4), (0, 1, 4, 3)) * -1
    tmp178 = f.aa.vv.copy() * -1
    tmp178 += tmp176
    del tmp176
    tmp178 += tmp177.transpose((1, 0)) * -1
    del tmp177
    tmp116 = tmp111.transpose((3, 2, 1, 0)).copy()
    tmp116 += tmp113.transpose((2, 3, 1, 0))
    tmp116 += tmp114.transpose((2, 3, 1, 0))
    tmp116 += tmp115.transpose((1, 3, 0, 2))
    tmp116 += tmp115.transpose((3, 2, 0, 1)) * -1
    tmp110 = v.bbb.xov.transpose((1, 2, 0)).copy()
    tmp110 += tmp8
    del tmp8
    tmp110 += tmp9 * 2
    del tmp9
    tmp109 = einsum(tmp105, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 1, 3, 4))
    l2new.bbbb += einsum(tmp109, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 2, 0)) * -1
    tmp138 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp138 += einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5)) * -1
    tmp142 = t1.bb.copy() * -1
    tmp142 += tmp58 * -1
    tmp142 += tmp59 * -2
    tmp142 += tmp61
    tmp142 += tmp63 * 2
    tmp142 += tmp68
    tmp136 = tmp134.copy() * 0.25
    del tmp134
    tmp136 += tmp135.transpose((0, 1, 3, 2))
    del tmp135
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    l2new.abab += einsum(tmp17, (0, 1, 2, 3), tmp133, (4, 1, 5, 2), (5, 3, 0, 4))
    tmp137 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 3, 4, 0), (1, 2, 3, 4)) * -0.5
    tmp137 += einsum(t2.abab, (0, 1, 2, 3), tmp60, (0, 4, 5, 2), (4, 5, 1, 3)) * 0.25
    tmp137 += einsum(tmp62, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp57 = l1.aa.transpose((1, 0)).copy() * -0.5
    tmp57 += t1.aa * -0.5
    tmp57 += tmp46 * -1
    tmp57 += tmp47 * -0.5
    tmp57 += tmp49
    tmp57 += tmp51 * 0.5
    tmp57 += tmp56
    tmp45 = tmp42.copy()
    del tmp42
    tmp45 += tmp43.transpose((1, 0))
    del tmp43
    tmp45 += tmp44 * 2
    del tmp44
    tmp69 = l1.bb.transpose((1, 0)).copy() * -1
    tmp69 += t1.bb * -1
    tmp69 += tmp58 * -1
    del tmp58
    tmp69 += tmp59 * -2
    del tmp59
    tmp69 += tmp61
    del tmp61
    tmp69 += tmp63 * 2
    del tmp63
    tmp69 += tmp68
    del tmp68
    tmp70 = tmp64.copy()
    del tmp64
    tmp70 += tmp65.transpose((1, 0))
    del tmp65
    tmp70 += tmp66.transpose((1, 0)) * 2
    del tmp66
    tmp41 = tmp40.copy() * 0.5
    del tmp40
    tmp41 += tmp35.transpose((1, 0))
    del tmp35
    tmp41 += tmp36 * 0.5
    del tmp36
    tmp101 = einsum(v.bbb.xov, (0, 1, 2), tmp5, (3, 4, 0), (4, 3, 1, 2))
    tmp106 = tmp18.transpose((1, 0, 2, 3)).copy()
    tmp106 += einsum(tmp2, (0, 1, 2), tmp105, (3, 4, 2), (1, 0, 4, 3))
    tmp99 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    l2new.abab += einsum(tmp99, (0, 1, 2, 3), tmp60, (4, 5, 0, 2), (1, 3, 4, 5)) * -1
    tmp100 = einsum(v.bbb.xov, (0, 1, 2), tmp2, (3, 4, 0), (4, 3, 1, 2))
    tmp3 = einsum(v.baa.xov, (0, 1, 2), tmp2, (3, 4, 0), (4, 3, 1, 2))
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 1, 0, 4))
    tmp20 = tmp18.transpose((0, 1, 3, 2)).copy()
    tmp20 += einsum(tmp5, (0, 1, 2), tmp19, (3, 4, 2), (4, 3, 1, 0))
    tmp0 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp0, (1, 4, 3, 5), (4, 5, 0, 2)) * -1
    tmp33 = tmp28.transpose((3, 2, 1, 0)).copy()
    tmp33 += tmp30.transpose((2, 3, 1, 0))
    tmp33 += tmp31.transpose((2, 3, 1, 0))
    tmp33 += tmp32.transpose((1, 3, 0, 2))
    tmp33 += tmp32.transpose((3, 2, 0, 1)) * -1
    tmp26 = v.baa.xov.transpose((1, 2, 0)).copy()
    tmp26 += tmp24 * 2
    del tmp24
    tmp26 += tmp25
    del tmp25
    tmp23 = einsum(v.baa.xov, (0, 1, 2), tmp19, (3, 4, 0), (1, 3, 4, 2))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp23, (2, 3, 1, 4), (4, 0, 2, 3)) * -1
    tmp84 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    l2new.abab += einsum(tmp84, (0, 1, 2, 3), tmp17, (1, 4, 5, 3), (5, 2, 0, 4))
    tmp89 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 4), (4, 0, 1, 3))
    tmp89 += einsum(tmp60, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    tmp88 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4)) * -2
    tmp88 += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 1, 5, 3), (4, 5, 0, 2)) * -4
    tmp88 += einsum(tmp50, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp87 = tmp85.copy() * 4
    del tmp85
    tmp87 += tmp86.transpose((0, 1, 3, 2))
    del tmp86
    tmp94 = t1.aa.copy() * -0.5
    tmp94 += tmp46 * -1
    del tmp46
    tmp94 += tmp47 * -0.5
    del tmp47
    tmp94 += tmp49
    del tmp49
    tmp94 += tmp51 * 0.5
    del tmp51
    tmp94 += tmp56
    del tmp56
    tmp226 = einsum(tmp105, (0, 1, 2), v.bbb.xvv, (2, 3, 4), (1, 0, 3, 4))
    l2new.bbbb += einsum(tmp226, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 0), (2, 4, 5, 1)) * 2
    del tmp226
    tmp238 = einsum(tmp115, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp115
    l2new.bbbb += tmp238.transpose((2, 3, 1, 0)) * 2
    l2new.bbbb += tmp238.transpose((2, 3, 0, 1)) * -2
    del tmp238
    tmp243 = einsum(tmp62, (0, 1, 2, 3), tmp220, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    del tmp220
    l2new.bbbb += tmp243.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp243.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp243.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp243.transpose((3, 2, 0, 1)) * -2
    del tmp243
    tmp237 = einsum(tmp62, (0, 1, 2, 3), tmp214, (2, 4), (0, 1, 4, 3))
    del tmp214
    l2new.bbbb += tmp237.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp237.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp237.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp237.transpose((2, 3, 1, 0)) * -1
    del tmp237
    tmp233 = einsum(tmp232, (0, 1, 2, 3), l2.bbbb, (3, 2, 4, 5), (4, 5, 0, 1))
    del tmp232
    l2new.bbbb += tmp233.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp233.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp233.transpose((2, 3, 1, 0)) * -0.5
    l2new.bbbb += tmp233.transpose((2, 3, 1, 0)) * -0.5
    del tmp233
    tmp241 = einsum(tmp240, (0, 1, 2), v.bbb.xov, (2, 3, 4), (0, 3, 1, 4)) * -2
    del tmp240
    l2new.bbbb += tmp241.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp241.transpose((3, 2, 0, 1)) * -1
    del tmp241
    tmp231 = einsum(v.bbb.xov, (0, 1, 2), tmp200, (3, 4, 0), (3, 1, 4, 2))
    del tmp200
    l2new.bbbb += tmp231.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp231.transpose((2, 3, 0, 1))
    l2new.bbbb += tmp231.transpose((3, 2, 1, 0))
    del tmp231
    tmp247 = einsum(v.bbb.xov, (0, 1, 2), tmp246, (3, 4, 0), (3, 1, 4, 2)) * 2
    del tmp246
    l2new.bbbb += tmp247.transpose((3, 2, 0, 1))
    l2new.bbbb += tmp247.transpose((2, 3, 0, 1)) * -1
    del tmp247
    tmp230 = einsum(tmp202, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 1), (0, 5, 3, 4))
    del tmp202
    l2new.bbbb += tmp230.transpose((3, 2, 0, 1)) * 2
    l2new.bbbb += tmp230.transpose((3, 2, 1, 0)) * -2
    l2new.bbbb += tmp230.transpose((2, 3, 0, 1)) * -2
    del tmp230
    tmp204 = f.bb.ov.copy()
    tmp204 += tmp203
    del tmp203
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp204, (2, 3), (0, 3, 2, 1)) * -1
    l2new.bbbb += einsum(tmp204, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp204, (2, 3), (3, 0, 2, 1))
    l2new.abab += einsum(tmp204, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    del tmp204
    tmp239 = tmp111.transpose((3, 2, 1, 0)).copy()
    del tmp111
    tmp239 += tmp113.transpose((0, 3, 1, 2))
    del tmp113
    tmp239 += tmp114.transpose((0, 3, 1, 2))
    del tmp114
    l2new.bbbb += einsum(tmp239, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp239
    tmp242 = einsum(tmp221, (0, 1, 2, 3), tmp62, (4, 0, 1, 5), (4, 2, 5, 3))
    del tmp221
    l2new.bbbb += tmp242.transpose((2, 3, 1, 0)) * -2
    l2new.bbbb += tmp242.transpose((3, 2, 1, 0)) * 2
    l2new.bbbb += tmp242.transpose((2, 3, 0, 1)) * 2
    l2new.bbbb += tmp242.transpose((3, 2, 0, 1)) * -2
    del tmp242
    tmp228 = einsum(l2.bbbb, (0, 1, 2, 3), tmp127, (3, 4), (4, 2, 0, 1)) * -2
    del tmp127
    l2new.bbbb += tmp228.transpose((3, 2, 0, 1))
    l2new.bbbb += tmp228.transpose((3, 2, 1, 0)) * -1
    del tmp228
    tmp227 = tmp197.copy() * 0.5
    del tmp197
    tmp227 += tmp128 * -0.5
    tmp227 += tmp129 * -1
    tmp227 += tmp130 * -0.5
    tmp227 += tmp131 * -1
    tmp227 += einsum(tmp79, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2)) * 0.5
    tmp227 += einsum(l2.bbbb, (0, 1, 2, 3), tmp10, (3, 1, 4), (2, 0, 4))
    l2new.bbbb += einsum(tmp227, (0, 1, 2), v.bbb.xov, (2, 3, 4), (4, 1, 0, 3)) * -2
    del tmp227
    tmp225 = einsum(l1.bb, (0, 1), tmp224, (2, 1, 3, 4), (3, 2, 4, 0))
    del tmp224
    l2new.bbbb += tmp225.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp225.transpose((3, 2, 0, 1))
    del tmp225
    tmp235 = einsum(tmp112, (0, 1, 2, 3), tmp141, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    l2new.bbbb += tmp235.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp235.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp235.transpose((3, 2, 1, 0))
    l2new.bbbb += tmp235.transpose((3, 2, 1, 0))
    del tmp235
    tmp234 = einsum(tmp62, (0, 1, 2, 3), tmp108, (2, 4, 3, 5), (1, 0, 5, 4))
    l2new.bbbb += tmp234.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp234.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp234.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp234.transpose((2, 3, 1, 0))
    del tmp234
    tmp245 = einsum(tmp112, (0, 1, 2, 3), tmp244, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp244
    l2new.bbbb += tmp245.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp245.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp245.transpose((2, 3, 0, 1)) * -1
    l2new.bbbb += tmp245.transpose((3, 2, 0, 1))
    del tmp245
    tmp223 = einsum(v.bbb.xov, (0, 1, 2), tmp195, (3, 4, 0), (3, 1, 4, 2))
    del tmp195
    l2new.bbbb += tmp223.transpose((2, 3, 1, 0)) * -1
    l2new.bbbb += tmp223.transpose((3, 2, 1, 0))
    del tmp223
    tmp229 = f.bb.ov.copy()
    tmp229 += tmp103
    del tmp103
    l2new.bbbb += einsum(tmp229, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0)) * -1
    del tmp229
    tmp248 = einsum(v.bbb.xov, (0, 1, 2), tmp218, (3, 4, 0), (3, 1, 4, 2))
    del tmp218
    l2new.bbbb += tmp248.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp248.transpose((2, 3, 1, 0))
    del tmp248
    tmp236 = einsum(tmp213, (0, 1), l2.bbbb, (2, 0, 3, 4), (3, 4, 1, 2)) * -1
    del tmp213
    l2new.bbbb += tmp236.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp236.transpose((3, 2, 1, 0)) * -1
    l2new.bbbb += tmp236.transpose((2, 3, 1, 0))
    l2new.bbbb += tmp236.transpose((2, 3, 1, 0))
    del tmp236
    tmp216 = tmp18.copy()
    del tmp18
    tmp216 += einsum(tmp105, (0, 1, 2), tmp19, (3, 4, 2), (4, 3, 1, 0))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp216, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp216
    tmp219 = einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp219 += einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    l2new.abab += einsum(tmp29, (0, 1, 2, 3), tmp219, (0, 4, 3, 5), (2, 5, 1, 4)) * -2
    del tmp219
    tmp209 = f.aa.vv.copy() * -0.5
    tmp209 += einsum(v.baa.xov, (0, 1, 2), tmp175, (1, 3, 0), (3, 2))
    del tmp175
    tmp209 += einsum(v.baa.xvv, (0, 1, 2), tmp14, (0,), (1, 2)) * -0.5
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp209, (0, 4), (4, 1, 2, 3)) * -2
    del tmp209
    tmp169 = f.aa.ov.copy()
    tmp169 += tmp168
    del tmp168
    l2new.abab += einsum(l1.bb, (0, 1), tmp169, (2, 3), (3, 0, 2, 1))
    l2new.aaaa += einsum(tmp169, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3)) * -1
    l2new.aaaa += einsum(tmp169, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    l2new.aaaa += einsum(tmp169, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3))
    del tmp169
    tmp207 = einsum(tmp206, (0, 1, 2, 3), l2.abab, (1, 2, 4, 5), (4, 5, 0, 3))
    del tmp206
    l2new.abab += tmp207.transpose((2, 3, 0, 1)) * 0.5
    l2new.abab += tmp207.transpose((2, 3, 0, 1)) * 0.5
    del tmp207
    tmp205 = einsum(v.baa.xvv, (0, 1, 2), tmp201, (3, 4, 0), (4, 3, 1, 2))
    del tmp201
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp205, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp205
    tmp215 = einsum(v.bbb.xov, (0, 1, 2), tmp148, (3, 4, 0), (3, 4, 1, 2))
    l2new.abab += einsum(tmp215, (0, 1, 2, 3), tmp60, (1, 4, 2, 5), (5, 3, 0, 4))
    l2new.abab += einsum(tmp215, (0, 1, 2, 3), l1.aa, (4, 1), (4, 3, 0, 2)) * -1
    del tmp215
    tmp196 = einsum(tmp105, (0, 1, 2), v.baa.xov, (2, 3, 4), (3, 0, 1, 4))
    del tmp105
    l2new.abab += einsum(tmp196, (0, 1, 2, 3), tmp50, (4, 0, 2, 5), (3, 5, 4, 1))
    l2new.abab += einsum(l1.bb, (0, 1), tmp196, (2, 3, 1, 4), (4, 0, 2, 3)) * -1
    del tmp196
    tmp222 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp222 += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    l2new.abab += einsum(tmp112, (0, 1, 2, 3), tmp222, (4, 0, 5, 3), (5, 2, 4, 1)) * -2
    del tmp112, tmp222
    tmp217 = einsum(tmp148, (0, 1, 2), v.bbb.xvv, (2, 3, 4), (1, 0, 3, 4))
    del tmp148
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp217, (2, 4, 1, 5), (0, 5, 4, 3)) * -1
    del tmp217
    tmp208 = einsum(tmp17, (0, 1, 2, 3), tmp93, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    del tmp17
    l2new.abab += tmp208.transpose((2, 3, 0, 1))
    l2new.abab += tmp208.transpose((2, 3, 0, 1))
    del tmp208
    tmp188 = einsum(tmp187, (0, 1, 2, 3), tmp48, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    del tmp187
    l2new.aaaa += tmp188.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp188.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp188.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp188.transpose((3, 2, 0, 1)) * -2
    del tmp188
    tmp174 = einsum(tmp29, (0, 1, 2, 3), tmp173, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    del tmp173
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp174.transpose((3, 2, 1, 0))
    del tmp174
    tmp190 = einsum(tmp189, (0, 1, 2, 3), tmp29, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp29, tmp189
    l2new.aaaa += tmp190.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp190.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp190.transpose((2, 3, 0, 1)) * -1
    l2new.aaaa += tmp190.transpose((3, 2, 0, 1))
    del tmp190
    tmp147 = einsum(v.baa.xov, (0, 1, 2), tmp146, (3, 4, 0), (3, 1, 4, 2)) * 2
    del tmp146
    l2new.aaaa += tmp147.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp147.transpose((3, 2, 1, 0))
    del tmp147
    tmp153 = tmp152.copy() * 0.5
    del tmp152
    tmp153 += tmp75 * -1
    tmp153 += tmp76 * -0.5
    tmp153 += tmp77 * -1
    tmp153 += tmp78 * -0.5
    tmp153 += tmp80
    tmp153 += tmp81
    l2new.aaaa += einsum(tmp153, (0, 1, 2), v.baa.xov, (2, 3, 4), (4, 1, 0, 3)) * -2
    del tmp153
    tmp150 = einsum(l1.aa, (0, 1), tmp149, (2, 1, 3, 4), (3, 2, 4, 0))
    del tmp149
    l2new.aaaa += tmp150.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp150.transpose((3, 2, 0, 1))
    del tmp150
    tmp181 = einsum(tmp180, (0, 1), tmp48, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp180
    l2new.aaaa += tmp181.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp181.transpose((3, 2, 1, 0))
    l2new.aaaa += tmp181.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp181.transpose((2, 3, 1, 0)) * -1
    del tmp181
    tmp182 = einsum(l2.aaaa, (0, 1, 2, 3), tmp32, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp32
    l2new.aaaa += tmp182.transpose((2, 3, 1, 0)) * 2
    l2new.aaaa += tmp182.transpose((2, 3, 0, 1)) * -2
    del tmp182
    tmp161 = einsum(tmp160, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 1), (0, 5, 3, 4))
    del tmp160
    l2new.aaaa += tmp161.transpose((3, 2, 0, 1)) * 2
    l2new.aaaa += tmp161.transpose((3, 2, 1, 0)) * -2
    l2new.aaaa += tmp161.transpose((2, 3, 0, 1)) * -2
    del tmp161
    tmp192 = einsum(tmp191, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4))
    del tmp191
    l2new.aaaa += tmp192.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp192.transpose((2, 3, 0, 1)) * -1
    del tmp192
    tmp186 = einsum(tmp48, (0, 1, 2, 3), tmp185, (1, 2, 4, 5), (0, 4, 3, 5))
    del tmp185
    l2new.aaaa += tmp186.transpose((2, 3, 1, 0)) * -2
    l2new.aaaa += tmp186.transpose((3, 2, 1, 0)) * 2
    l2new.aaaa += tmp186.transpose((2, 3, 0, 1)) * 2
    l2new.aaaa += tmp186.transpose((3, 2, 0, 1)) * -2
    del tmp186
    tmp170 = einsum(tmp48, (0, 1, 2, 3), tmp22, (2, 4, 3, 5), (1, 0, 5, 4))
    l2new.aaaa += tmp170.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp170.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp170.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp170.transpose((2, 3, 1, 0))
    del tmp170
    tmp172 = einsum(l2.aaaa, (0, 1, 2, 3), tmp171, (4, 5, 1, 0), (2, 3, 4, 5))
    del tmp171
    l2new.aaaa += tmp172.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp172.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp172.transpose((2, 3, 1, 0)) * -0.5
    l2new.aaaa += tmp172.transpose((2, 3, 1, 0)) * -0.5
    del tmp172
    tmp167 = einsum(v.baa.xov, (0, 1, 2), tmp166, (3, 4, 0), (3, 1, 4, 2))
    del tmp166
    l2new.aaaa += tmp167.transpose((2, 3, 1, 0)) * -1
    l2new.aaaa += tmp167.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp167.transpose((3, 2, 1, 0))
    del tmp167
    tmp194 = einsum(tmp193, (0, 1, 2), v.baa.xov, (2, 3, 4), (0, 3, 1, 4)) * 2
    del tmp193
    l2new.aaaa += tmp194.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp194.transpose((2, 3, 1, 0))
    del tmp194
    tmp184 = einsum(v.baa.xov, (0, 1, 2), tmp38, (3, 4, 0), (3, 1, 4, 2)) * -1
    l2new.aaaa += tmp184.transpose((2, 3, 0, 1))
    l2new.aaaa += tmp184.transpose((3, 2, 0, 1)) * -1
    del tmp184
    tmp158 = einsum(l2.aaaa, (0, 1, 2, 3), tmp157, (3, 4), (4, 2, 0, 1)) * -2
    del tmp157
    l2new.aaaa += tmp158.transpose((3, 2, 0, 1))
    l2new.aaaa += tmp158.transpose((3, 2, 1, 0)) * -1
    del tmp158
    tmp151 = einsum(v.baa.xvv, (0, 1, 2), tmp19, (3, 4, 0), (4, 3, 1, 2))
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp151, (3, 4, 5, 1), (5, 0, 2, 4)) * 2
    del tmp151
    tmp183 = tmp28.transpose((3, 2, 1, 0)).copy()
    del tmp28
    tmp183 += tmp30.transpose((0, 3, 1, 2))
    del tmp30
    tmp183 += tmp31.transpose((0, 3, 1, 2))
    del tmp31
    l2new.aaaa += einsum(tmp183, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp183
    tmp159 = f.aa.ov.copy()
    tmp159 += tmp15
    del tmp15
    l2new.aaaa += einsum(tmp159, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0)) * -1
    del tmp159
    tmp179 = einsum(tmp178, (0, 1), l2.aaaa, (2, 0, 3, 4), (3, 4, 1, 2)) * -1
    del tmp178
    l2new.aaaa += tmp179.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp179.transpose((3, 2, 1, 0)) * -1
    l2new.aaaa += tmp179.transpose((2, 3, 1, 0))
    l2new.aaaa += tmp179.transpose((2, 3, 1, 0))
    del tmp179
    tmp144 = f.bb.vv.copy()
    tmp144 += einsum(v.bbb.xvv, (0, 1, 2), tmp97, (0,), (1, 2))
    l1new.bb += einsum(l1.bb, (0, 1), tmp144, (0, 2), (2, 1))
    del tmp144
    tmp117 = einsum(t2.bbbb, (0, 1, 2, 3), tmp108, (4, 2, 5, 3), (4, 0, 1, 5))
    del tmp108
    tmp117 += einsum(tmp109, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 3), (2, 4, 1, 5)) * -2
    del tmp109
    tmp117 += einsum(tmp110, (0, 1, 2), tmp5, (3, 4, 2), (4, 0, 3, 1))
    del tmp110
    tmp117 += einsum(tmp104, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp117 += einsum(tmp7, (0, 1, 2), tmp5, (3, 4, 2), (4, 3, 0, 1)) * -1
    tmp117 += einsum(t1.bb, (0, 1), tmp116, (0, 2, 3, 4), (2, 4, 3, 1)) * -1
    del tmp116
    l1new.bb += einsum(tmp117, (0, 1, 2, 3), l2.bbbb, (4, 3, 1, 2), (4, 0)) * 2
    del tmp117
    tmp132 = tmp128.copy() * -1
    del tmp128
    tmp132 += tmp129 * -2
    del tmp129
    tmp132 += tmp130 * -1
    del tmp130
    tmp132 += tmp131 * -2
    del tmp131
    tmp132 += einsum(tmp79, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2))
    tmp132 += einsum(l2.bbbb, (0, 1, 2, 3), tmp10, (3, 1, 4), (2, 0, 4)) * 2
    l1new.bb += einsum(tmp132, (0, 1, 2), v.bbb.xvv, (2, 3, 1), (3, 0))
    del tmp132
    tmp143 = einsum(l1.bb, (0, 1), tmp7, (2, 0, 3), (2, 1, 3))
    del tmp7
    tmp143 += einsum(v.baa.xoo, (0, 1, 2), tmp92, (2, 1, 3, 4), (4, 3, 0)) * -1
    tmp143 += einsum(v.baa.xvv, (0, 1, 2), tmp133, (3, 4, 1, 2), (4, 3, 0))
    del tmp133
    tmp143 += einsum(tmp92, (0, 1, 2, 3), tmp1, (0, 1, 4), (3, 2, 4)) * -1
    del tmp92
    tmp143 += einsum(tmp136, (0, 1, 2, 3), v.bbb.xvv, (4, 2, 3), (1, 0, 4)) * 4
    del tmp136
    tmp143 += einsum(tmp79, (0, 1, 2), tmp60, (0, 3, 4, 1), (4, 3, 2))
    del tmp60
    tmp143 += einsum(tmp62, (0, 1, 2, 3), tmp10, (0, 3, 4), (2, 1, 4)) * 2
    del tmp62
    tmp143 += einsum(tmp137, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (2, 0, 4)) * -4
    del tmp137
    tmp143 += einsum(tmp138, (0, 1, 2, 3), v.baa.xov, (4, 0, 3), (2, 1, 4))
    del tmp138
    tmp143 += einsum(tmp91, (0, 1, 2, 3), tmp19, (1, 0, 4), (3, 2, 4)) * -1
    del tmp91
    tmp143 += einsum(tmp141, (0, 1, 2, 3), v.bbb.xoo, (4, 0, 2), (3, 1, 4)) * -2
    tmp143 += einsum(tmp141, (0, 1, 2, 3), tmp4, (0, 2, 4), (3, 1, 4)) * -2
    del tmp141
    tmp143 += einsum(tmp142, (0, 1), v.bbb.xov, (2, 3, 1), (0, 3, 2)) * -1
    del tmp142
    tmp143 += einsum(v.bbb.xoo, (0, 1, 2), tmp67, (2, 3), (3, 1, 0)) * -1
    del tmp67
    l1new.bb += einsum(tmp143, (0, 1, 2), v.bbb.xov, (2, 0, 3), (3, 1)) * -1
    del tmp143
    tmp120 = tmp119.copy()
    del tmp119
    tmp120 += einsum(l1.bb, (0, 1), tmp5, (1, 2, 3), (2, 0, 3))
    l1new.bb += einsum(tmp120, (0, 1, 2), v.bbb.xvv, (2, 3, 1), (3, 0)) * -1
    del tmp120
    tmp121 = einsum(v.baa.xvv, (0, 1, 2), tmp41, (2, 1), (0,)) * 2
    tmp121 += einsum(v.bbb.xvv, (0, 1, 2), tmp45, (2, 1), (0,))
    tmp121 += einsum(tmp57, (0, 1), v.baa.xov, (2, 0, 1), (2,)) * -2
    tmp121 += einsum(tmp69, (0, 1), v.bbb.xov, (2, 0, 1), (2,)) * -1
    tmp121 += einsum(tmp55, (0, 1), v.baa.xoo, (2, 1, 0), (2,)) * -2
    tmp121 += einsum(v.bbb.xoo, (0, 1, 2), tmp70, (2, 1), (0,)) * -1
    l1new.bb += einsum(tmp121, (0,), v.bbb.xov, (0, 1, 2), (2, 1))
    del tmp121
    tmp107 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (4, 2, 5, 3), (0, 4, 1, 5))
    del tmp99
    tmp107 += einsum(tmp100, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5)) * -1
    del tmp100
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), tmp101, (1, 4, 5, 3), (0, 5, 4, 2)) * -1
    del tmp101
    tmp107 += einsum(tmp79, (0, 1, 2), tmp5, (3, 4, 2), (0, 4, 3, 1))
    del tmp5
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), tmp104, (4, 3), (0, 4, 1, 2))
    del tmp104
    tmp107 += einsum(t1.aa, (0, 1), tmp106, (0, 2, 3, 4), (2, 4, 3, 1)) * -1
    del tmp106
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp107, (2, 4, 3, 0), (1, 4)) * -1
    del tmp107
    tmp98 = f.aa.vv.copy()
    tmp98 += einsum(v.baa.xvv, (0, 1, 2), tmp97, (0,), (1, 2))
    del tmp97
    l1new.aa = einsum(l1.aa, (0, 1), tmp98, (0, 2), (2, 1))
    del tmp98
    tmp96 = tmp52.copy()
    del tmp52
    tmp96 += tmp53 * 2
    del tmp53
    tmp96 += tmp54
    del tmp54
    l1new.aa += einsum(tmp96, (0, 1), tmp16, (1, 2), (2, 0)) * -1
    del tmp96
    tmp74 = f.aa.oo.copy() * 0.5
    tmp74 += tmp72 * -0.5
    del tmp72
    tmp74 += einsum(tmp73, (0, 1, 2), v.baa.xov, (2, 3, 1), (0, 3)) * 0.5
    del tmp73
    tmp74 += einsum(v.baa.xoo, (0, 1, 2), tmp14, (0,), (1, 2)) * 0.5
    del tmp14
    tmp74 += einsum(tmp16, (0, 1), t1.aa, (2, 1), (2, 0)) * 0.5
    l1new.aa += einsum(tmp74, (0, 1), l1.aa, (2, 0), (2, 1)) * -2
    del tmp74
    tmp71 = einsum(v.baa.xvv, (0, 1, 2), tmp41, (2, 1), (0,))
    del tmp41
    tmp71 += einsum(v.bbb.xvv, (0, 1, 2), tmp45, (2, 1), (0,)) * 0.5
    del tmp45
    tmp71 += einsum(tmp57, (0, 1), v.baa.xov, (2, 0, 1), (2,)) * -1
    del tmp57
    tmp71 += einsum(tmp69, (0, 1), v.bbb.xov, (2, 0, 1), (2,)) * -0.5
    del tmp69
    tmp71 += einsum(tmp55, (0, 1), v.baa.xoo, (2, 1, 0), (2,)) * -1
    tmp71 += einsum(v.bbb.xoo, (0, 1, 2), tmp70, (2, 1), (0,)) * -0.5
    del tmp70
    l1new.aa += einsum(tmp71, (0,), v.baa.xov, (0, 1, 2), (2, 1)) * 2
    del tmp71
    tmp82 = tmp75.copy() * -1
    del tmp75
    tmp82 += tmp76 * -0.5
    del tmp76
    tmp82 += tmp77 * -1
    del tmp77
    tmp82 += tmp78 * -0.5
    del tmp78
    tmp82 += tmp80
    del tmp80
    tmp82 += tmp81
    del tmp81
    l1new.aa += einsum(tmp82, (0, 1, 2), v.baa.xvv, (2, 3, 1), (3, 0)) * 2
    del tmp82
    tmp21 = einsum(t2.abab, (0, 1, 2, 3), tmp0, (4, 2, 5, 3), (4, 0, 1, 5))
    del tmp0
    tmp21 += einsum(tmp3, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (2, 1, 4, 5)) * -1
    del tmp3
    tmp21 += einsum(tmp6, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    del tmp6
    tmp21 += einsum(tmp10, (0, 1, 2), tmp2, (3, 4, 2), (4, 3, 0, 1))
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp16, (4, 2), (4, 0, 1, 3))
    tmp21 += einsum(t1.bb, (0, 1), tmp20, (2, 3, 0, 4), (3, 2, 4, 1)) * -1
    del tmp20
    l1new.aa += einsum(l2.abab, (0, 1, 2, 3), tmp21, (4, 2, 3, 1), (0, 4)) * -1
    del tmp21
    tmp39 = tmp38.copy()
    del tmp38
    tmp39 += einsum(l1.aa, (0, 1), tmp2, (1, 2, 3), (2, 0, 3))
    l1new.aa += einsum(v.baa.xvv, (0, 1, 2), tmp39, (3, 2, 0), (1, 3)) * -1
    del tmp39
    tmp34 = einsum(tmp22, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (0, 4, 5, 2))
    del tmp22
    tmp34 += einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp23
    tmp34 += einsum(tmp26, (0, 1, 2), tmp2, (3, 4, 2), (4, 0, 3, 1))
    del tmp26
    tmp34 += einsum(tmp16, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp16
    tmp34 += einsum(tmp27, (0, 1, 2), tmp2, (3, 4, 2), (4, 3, 0, 1)) * -1
    del tmp2
    tmp34 += einsum(t1.aa, (0, 1), tmp33, (0, 2, 3, 4), (2, 4, 3, 1)) * -1
    del tmp33
    l1new.aa += einsum(l2.aaaa, (0, 1, 2, 3), tmp34, (4, 2, 3, 1), (0, 4)) * 2
    del tmp34
    tmp95 = einsum(tmp27, (0, 1, 2), l1.aa, (1, 3), (0, 3, 2))
    del tmp27
    tmp95 += einsum(v.baa.xoo, (0, 1, 2), tmp83, (3, 2, 1, 4), (4, 3, 0)) * 2
    tmp95 += einsum(tmp84, (0, 1, 2, 3), v.bbb.xvv, (4, 3, 2), (1, 0, 4))
    del tmp84
    tmp95 += einsum(tmp83, (0, 1, 2, 3), tmp1, (0, 2, 4), (3, 1, 4)) * -2
    del tmp1, tmp83
    tmp95 += einsum(v.baa.xvv, (0, 1, 2), tmp87, (3, 4, 1, 2), (4, 3, 0))
    del tmp87
    tmp95 += einsum(tmp79, (0, 1, 2), tmp48, (0, 3, 4, 1), (4, 3, 2)) * 2
    del tmp48, tmp79
    tmp95 += einsum(tmp10, (0, 1, 2), tmp50, (3, 4, 0, 1), (4, 3, 2))
    del tmp50, tmp10
    tmp95 += einsum(v.baa.xov, (0, 1, 2), tmp88, (3, 1, 4, 2), (4, 3, 0)) * -1
    del tmp88
    tmp95 += einsum(v.bbb.xov, (0, 1, 2), tmp89, (3, 4, 1, 2), (4, 3, 0))
    del tmp89
    tmp95 += einsum(tmp90, (0, 1, 2, 3), tmp19, (2, 0, 4), (3, 1, 4)) * -2
    del tmp90, tmp19
    tmp95 += einsum(tmp93, (0, 1, 2, 3), v.bbb.xoo, (4, 2, 3), (1, 0, 4)) * -1
    tmp95 += einsum(tmp93, (0, 1, 2, 3), tmp4, (2, 3, 4), (1, 0, 4)) * -1
    del tmp4, tmp93
    tmp95 += einsum(v.baa.xov, (0, 1, 2), tmp94, (3, 2), (3, 1, 0)) * -2
    del tmp94
    tmp95 += einsum(tmp55, (0, 1), v.baa.xoo, (2, 3, 0), (1, 3, 2)) * -2
    del tmp55
    l1new.aa += einsum(tmp95, (0, 1, 2), v.baa.xov, (2, 0, 3), (3, 1)) * -1
    del tmp95
    l1new.aa += f.aa.ov.transpose((1, 0))
    l1new.bb += f.bb.ov.transpose((1, 0))

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:53:44.333518.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    rdm1.bb.oo = tmp4.transpose((1, 0)).copy() * -1
    tmp3 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    rdm1.bb.oo += tmp3.transpose((1, 0)) * -2
    tmp5 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    rdm1.bb.oo += tmp5.transpose((1, 0)) * -1
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    rdm1.aa.oo = tmp2.transpose((1, 0)).copy() * -1
    tmp0 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    rdm1.aa.oo += tmp0.transpose((1, 0)) * -2
    tmp1 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    rdm1.aa.oo += tmp1.transpose((1, 0)) * -1
    tmp10 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.ov = einsum(t2.abab, (0, 1, 2, 3), tmp10, (0, 1, 4, 2), (4, 3)) * -1
    del tmp10
    tmp9 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    rdm1.bb.ov += einsum(tmp9, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4)) * -2
    del tmp9
    tmp11 = tmp5.copy() * 0.5
    del tmp5
    tmp11 += tmp4 * 0.5
    del tmp4
    tmp11 += tmp3
    del tmp3
    rdm1.bb.ov += einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -2
    del tmp11
    tmp6 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    rdm1.aa.ov = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4)) * -2
    del tmp6
    tmp8 = tmp1.copy()
    del tmp1
    tmp8 += tmp0 * 2
    del tmp0
    tmp8 += tmp2
    del tmp2
    rdm1.aa.ov += einsum(t1.aa, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8
    tmp7 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm1.aa.ov += einsum(tmp7, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4)) * -1
    del tmp7
    rdm1.aa.oo += delta.aa.oo
    rdm1.bb.oo += delta.bb.oo
    del delta
    rdm1.aa.ov += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    rdm1.aa.ov += t1.aa
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2)) * 2
    rdm1.bb.ov += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    rdm1.bb.ov += t1.bb
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2)) * 2
    rdm1.aa.vo = l1.aa.copy()
    rdm1.bb.vo = l1.bb.copy()
    rdm1.aa.vv = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    rdm1.aa.vv += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.bb.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.bb.vv += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-08-09T21:54:48.751626.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp18 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    rdm2.bbbb.vooo = tmp18.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.vooo += tmp18.transpose((3, 2, 1, 0))
    rdm2.bbbb.ovoo = tmp18.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.bbbb.ovoo += tmp18.transpose((2, 3, 1, 0)) * -1
    tmp14 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2.abab.vovv = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 1, 4, 5), (5, 4, 2, 3)) * -1
    rdm2.abab.vovo = einsum(tmp14, (0, 1, 2, 3), t1.aa, (0, 4), (3, 2, 4, 1)) * -1
    rdm2.abab.vooo = tmp14.transpose((3, 2, 0, 1)).copy() * -1
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp10 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp8 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp0 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp1 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp6 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    rdm2.aaaa.vooo = tmp6.transpose((3, 2, 1, 0)).copy()
    rdm2.aaaa.vooo += tmp6.transpose((3, 2, 1, 0))
    rdm2.aaaa.ovoo = tmp6.transpose((2, 3, 1, 0)).copy() * -1
    rdm2.aaaa.ovoo += tmp6.transpose((2, 3, 1, 0)) * -1
    tmp26 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm2.abab.ovvv = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 1, 5), (4, 5, 2, 3)) * -1
    rdm2.abab.ovov = einsum(tmp26, (0, 1, 2, 3), t1.bb, (2, 4), (1, 3, 0, 4)) * -1
    rdm2.abab.ovoo = tmp26.transpose((1, 3, 0, 2)).copy() * -1
    tmp90 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.bbbb.vovo = tmp90.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.bbbb.voov = tmp90.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.bbbb.ovvo = tmp90.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.bbbb.ovov = tmp90.transpose((1, 2, 0, 3)).copy() * -4
    tmp109 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    rdm2.bbbb.vovo += tmp109.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.voov += tmp109.transpose((2, 1, 0, 3))
    rdm2.bbbb.ovvo += tmp109.transpose((1, 2, 3, 0))
    rdm2.bbbb.ovov += tmp109.transpose((1, 2, 0, 3)) * -1
    tmp69 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo = tmp69.transpose((2, 1, 3, 0)).copy() * -4
    rdm2.aaaa.voov = tmp69.transpose((2, 1, 0, 3)).copy() * 4
    rdm2.aaaa.ovvo = tmp69.transpose((1, 2, 3, 0)).copy() * 4
    rdm2.aaaa.ovov = tmp69.transpose((1, 2, 0, 3)).copy() * -4
    tmp71 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2.aaaa.vovo += tmp71.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.voov += tmp71.transpose((2, 1, 0, 3))
    rdm2.aaaa.ovvo += tmp71.transpose((1, 2, 3, 0))
    rdm2.aaaa.ovov += tmp71.transpose((1, 2, 0, 3)) * -1
    tmp17 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2.bbbb.oooo = tmp17.transpose((3, 2, 1, 0)).copy()
    rdm2.bbbb.oooo += tmp17.transpose((3, 2, 1, 0))
    tmp19 = einsum(t1.bb, (0, 1), tmp18, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2.bbbb.oooo += tmp19.transpose((2, 3, 1, 0)) * -1
    rdm2.bbbb.oooo += tmp19.transpose((2, 3, 1, 0)) * -1
    tmp49 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 4, 5, 2), (4, 5, 1, 3))
    rdm2.bbbb.oovo = tmp49.transpose((2, 1, 3, 0)).copy() * -1
    rdm2.bbbb.oovo += tmp49.transpose((1, 2, 3, 0))
    rdm2.bbbb.ooov = tmp49.transpose((2, 1, 0, 3)).copy()
    rdm2.bbbb.ooov += tmp49.transpose((1, 2, 0, 3)) * -1
    tmp50 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    rdm2.bbbb.oovo += tmp50.transpose((2, 1, 3, 0)) * -4
    rdm2.bbbb.oovo += tmp50.transpose((1, 2, 3, 0)) * 4
    rdm2.bbbb.ooov += tmp50.transpose((2, 1, 0, 3)) * 4
    rdm2.bbbb.ooov += tmp50.transpose((1, 2, 0, 3)) * -4
    tmp16 = tmp8.copy()
    tmp16 += tmp9
    tmp16 += tmp10 * 2
    rdm2.abab.oovv = einsum(t2.abab, (0, 1, 2, 3), tmp16, (1, 4), (0, 4, 2, 3)) * -1
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp16, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp16, (2, 3), (3, 0, 1, 2))
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    tmp15 = einsum(t1.aa, (0, 1), tmp14, (2, 3, 4, 1), (2, 0, 3, 4))
    rdm2.abab.oooo = tmp15.transpose((1, 3, 0, 2)).copy()
    tmp13 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    rdm2.abab.oooo += tmp13.transpose((1, 3, 0, 2))
    tmp4 = tmp0.copy() * 0.5
    tmp4 += tmp1
    tmp4 += tmp2 * 0.5
    rdm2.aaaa.oovo = einsum(t1.aa, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.aaaa.oooo += einsum(tmp4, (0, 1), delta.aa.oo, (2, 3), (1, 2, 0, 3)) * -2
    tmp7 = einsum(t1.aa, (0, 1), tmp6, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2.aaaa.oooo += tmp7.transpose((2, 3, 1, 0)) * -1
    rdm2.aaaa.oooo += tmp7.transpose((2, 3, 1, 0)) * -1
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    rdm2.aaaa.oooo += tmp5.transpose((3, 2, 1, 0))
    rdm2.aaaa.oooo += tmp5.transpose((3, 2, 1, 0))
    tmp31 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    rdm2.aaaa.oovo += tmp31.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += tmp31.transpose((1, 2, 3, 0))
    rdm2.aaaa.ooov = tmp31.transpose((2, 1, 0, 3)).copy()
    rdm2.aaaa.ooov += tmp31.transpose((1, 2, 0, 3)) * -1
    tmp30 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    rdm2.aaaa.oovo += tmp30.transpose((2, 1, 3, 0)) * -4
    rdm2.aaaa.oovo += tmp30.transpose((1, 2, 3, 0)) * 4
    rdm2.aaaa.ooov += tmp30.transpose((2, 1, 0, 3)) * 4
    rdm2.aaaa.ooov += tmp30.transpose((1, 2, 0, 3)) * -4
    tmp123 = tmp109.copy()
    tmp123 += tmp90 * 4
    tmp81 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp82 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp107 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp110 = einsum(tmp18, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.bbbb.vovo += tmp110.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.voov += tmp110.transpose((2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo += tmp110.transpose((1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov += tmp110.transpose((1, 2, 0, 3)) * 2
    tmp64 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp104 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp65 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp94 = einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    rdm2.abab.voov = tmp94.transpose((2, 1, 0, 3)).copy() * 2
    tmp92 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    rdm2.abab.voov += tmp92.transpose((2, 1, 0, 3)) * 2
    tmp86 = tmp69.copy() * 4
    tmp86 += tmp71
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp86, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp106 = einsum(t1.aa, (0, 1), tmp6, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.aaaa.vovo += tmp106.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.voov += tmp106.transpose((2, 1, 0, 3)) * -2
    rdm2.aaaa.ovvo += tmp106.transpose((1, 2, 3, 0)) * -2
    rdm2.aaaa.ovov += tmp106.transpose((1, 2, 0, 3)) * 2
    tmp67 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    rdm2.abab.ovvo = tmp67.transpose((0, 3, 2, 1)).copy() * 2
    tmp84 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    rdm2.abab.ovvo += tmp84.transpose((0, 3, 2, 1)) * 2
    tmp35 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp34 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp52 = tmp17.transpose((1, 0, 3, 2)).copy()
    del tmp17
    tmp52 += tmp19.transpose((0, 1, 3, 2)) * -1
    del tmp19
    tmp48 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    rdm2.bbbb.oovo += tmp48.transpose((2, 1, 3, 0)) * 2
    rdm2.bbbb.ooov += tmp48.transpose((2, 1, 0, 3)) * -2
    tmp102 = tmp49.copy()
    del tmp49
    tmp102 += tmp50 * 4
    del tmp50
    tmp39 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4))
    tmp38 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 1, 4, 2), (4, 3))
    tmp62 = einsum(t1.bb, (0, 1), tmp16, (0, 2), (2, 1)) * 0.5
    tmp40 = einsum(t1.bb, (0, 1), tmp16, (0, 2), (2, 1))
    del tmp16
    tmp51 = tmp8.copy() * 0.5
    tmp51 += tmp9 * 0.5
    tmp51 += tmp10
    rdm2.abab.oovo = einsum(tmp51, (0, 1), t1.aa, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.bbbb.ooov += einsum(tmp51, (0, 1), t1.bb, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.bbbb.ooov += einsum(tmp51, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -2
    tmp44 = tmp13.copy()
    del tmp13
    tmp44 += tmp15
    del tmp15
    rdm2.abab.oovv += einsum(tmp44, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5))
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp44, (0, 2, 3, 4), (2, 4, 1, 3))
    tmp58 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    rdm2.abab.oovo += tmp58.transpose((0, 2, 3, 1)) * -2
    tmp59 = einsum(tmp14, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    rdm2.abab.oovo += tmp59.transpose((0, 2, 3, 1)) * -2
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp21 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2.abab.ooov = tmp43.transpose((1, 2, 0, 3)).copy() * -2
    tmp42 = einsum(tmp6, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5)) * -1
    rdm2.abab.ooov += tmp42.transpose((1, 2, 0, 3)) * -2
    tmp56 = einsum(t1.aa, (0, 1), tmp4, (0, 2), (2, 1))
    tmp27 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 1, 3), (4, 2))
    tmp25 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp32 = tmp5.transpose((1, 0, 3, 2)).copy()
    del tmp5
    tmp32 += tmp7.transpose((0, 1, 3, 2)) * -1
    del tmp7
    tmp24 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2.aaaa.oovo += tmp24.transpose((2, 1, 3, 0)) * 2
    rdm2.aaaa.ooov += tmp24.transpose((2, 1, 0, 3)) * -2
    tmp79 = tmp30.copy() * 4
    del tmp30
    tmp79 += tmp31
    del tmp31
    tmp28 = einsum(t1.aa, (0, 1), tmp4, (0, 2), (2, 1)) * 2
    tmp132 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.bbbb.vvvv = tmp132.transpose((1, 0, 3, 2)).copy()
    rdm2.bbbb.vvvv += tmp132.transpose((1, 0, 3, 2))
    del tmp132
    tmp130 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    rdm2.bbbb.vvvv += einsum(t1.bb, (0, 1), tmp130, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    rdm2.bbbb.vvvo = tmp130.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.bbbb.vvov = tmp130.transpose((2, 1, 0, 3)).copy() * -2
    del tmp130
    tmp129 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    rdm2.abab.vvvv = einsum(tmp129, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.vvov = tmp129.transpose((1, 2, 0, 3)).copy()
    del tmp129
    tmp131 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa.vvvv = tmp131.transpose((1, 0, 3, 2)).copy()
    rdm2.aaaa.vvvv += tmp131.transpose((1, 0, 3, 2))
    del tmp131
    tmp128 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (3, 4), (2, 0, 1, 4))
    rdm2.aaaa.vvvv += einsum(tmp128, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.aaaa.vvvo = tmp128.transpose((2, 1, 3, 0)).copy() * 2
    rdm2.aaaa.vvov = tmp128.transpose((2, 1, 0, 3)).copy() * -2
    del tmp128
    tmp124 = einsum(t1.bb, (0, 1), tmp123, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp123
    rdm2.bbbb.vovv = tmp124.transpose((2, 0, 3, 1)).copy() * -1
    rdm2.bbbb.vovv += tmp124.transpose((2, 0, 1, 3))
    rdm2.bbbb.ovvv = tmp124.transpose((0, 2, 3, 1)).copy()
    del tmp124
    tmp113 = tmp107.copy()
    tmp113 += tmp81
    tmp113 += tmp82 * 2
    rdm2.bbbb.vovv += einsum(t1.bb, (0, 1), tmp113, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vovv += einsum(tmp113, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvv += einsum(tmp113, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vovo += einsum(tmp113, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(tmp113, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    del tmp113
    tmp126 = einsum(t1.bb, (0, 1), tmp110, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp110
    rdm2.bbbb.vovv += tmp126.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv += tmp126.transpose((0, 1, 3, 2)) * -2
    del tmp126
    tmp121 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.bbbb.vovv += tmp121.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp121.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp121.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp121.transpose((0, 1, 3, 2)) * -1
    del tmp121
    tmp125 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    del tmp18
    rdm2.bbbb.vovv += tmp125.transpose((1, 0, 3, 2))
    rdm2.bbbb.vovv += tmp125.transpose((1, 0, 3, 2))
    rdm2.bbbb.ovvv += tmp125.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.ovvv += tmp125.transpose((0, 1, 3, 2)) * -1
    del tmp125
    tmp105 = tmp104.copy()
    tmp105 += tmp64 * 2
    tmp105 += tmp65
    rdm2.abab.vovv += einsum(tmp105, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovv = einsum(tmp105, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovvv = einsum(tmp105, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.vovo += einsum(tmp105, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.voov += einsum(tmp105, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovov += einsum(tmp105, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp105
    tmp114 = einsum(t1.bb, (0, 1), tmp14, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.abab.vovv += einsum(tmp114, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 4, 3)) * -1
    rdm2.abab.voov += tmp114.transpose((2, 1, 0, 3)) * -1
    del tmp114
    tmp115 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    rdm2.abab.vovv += einsum(t1.bb, (0, 1), tmp115, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    rdm2.abab.vovo += tmp115.transpose((2, 1, 3, 0)) * -1
    del tmp115
    tmp127 = tmp92.copy()
    tmp127 += tmp94
    rdm2.abab.vovv += einsum(tmp127, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 4, 3)) * 2
    del tmp127
    tmp116 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.aaaa.vovv += tmp116.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp116.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp116.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp116.transpose((0, 1, 3, 2)) * -1
    del tmp116
    tmp119 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    del tmp6
    rdm2.aaaa.vovv += tmp119.transpose((1, 0, 3, 2))
    rdm2.aaaa.vovv += tmp119.transpose((1, 0, 3, 2))
    rdm2.aaaa.ovvv += tmp119.transpose((0, 1, 3, 2)) * -1
    rdm2.aaaa.ovvv += tmp119.transpose((0, 1, 3, 2)) * -1
    del tmp119
    tmp111 = tmp104.copy() * 0.5
    del tmp104
    tmp111 += tmp64
    tmp111 += tmp65 * 0.5
    rdm2.aaaa.vovv += einsum(tmp111, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.ovvv += einsum(tmp111, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.vovo += einsum(tmp111, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.ovvo += einsum(tmp111, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -2
    del tmp111
    tmp118 = einsum(t1.aa, (0, 1), tmp86, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp86
    rdm2.aaaa.vovv += tmp118.transpose((2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += tmp118.transpose((2, 0, 1, 3))
    rdm2.aaaa.ovvv += tmp118.transpose((0, 2, 3, 1))
    del tmp118
    tmp120 = einsum(tmp106, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    del tmp106
    rdm2.aaaa.vovv += tmp120.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.ovvv += tmp120.transpose((0, 1, 3, 2)) * -2
    del tmp120
    tmp122 = tmp109.copy() * 0.25
    del tmp109
    tmp122 += tmp90
    rdm2.bbbb.ovvv += einsum(tmp122, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * -4
    del tmp122
    tmp108 = tmp107.copy() * 0.5
    del tmp107
    tmp108 += tmp81 * 0.5
    tmp108 += tmp82
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp108, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp108, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.bbbb.voov += einsum(delta.bb.oo, (0, 1), tmp108, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.ovov += einsum(delta.bb.oo, (0, 1), tmp108, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.abab.ovov += einsum(tmp108, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * 2
    del tmp108
    tmp87 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp87, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ovov += tmp87.transpose((1, 2, 0, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp87, (0, 4, 3, 5), (4, 1, 2, 5))
    del tmp87
    tmp85 = tmp84.copy()
    del tmp84
    tmp85 += tmp67
    rdm2.abab.ovvv += einsum(tmp85, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    rdm2.abab.oovv += einsum(tmp85, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 4
    del tmp85
    tmp112 = einsum(t1.aa, (0, 1), tmp26, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ovvv += einsum(tmp112, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.abab.ovvo += tmp112.transpose((0, 3, 2, 1)) * -1
    del tmp112
    tmp117 = tmp69.copy() * 4
    tmp117 += tmp71
    rdm2.aaaa.ovvv += einsum(tmp117, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    del tmp117
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), tmp92, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp92
    rdm2.bbbb.oovv = tmp93.transpose((1, 0, 3, 2)).copy() * 2
    rdm2.bbbb.oovv += tmp93.transpose((0, 1, 3, 2)) * -2
    del tmp93
    tmp96 = tmp34.copy()
    tmp96 += tmp35 * 2
    rdm2.bbbb.oovv += einsum(tmp96, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovv += einsum(tmp96, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    del tmp96
    tmp101 = einsum(t1.bb, (0, 1), tmp52, (0, 2, 3, 4), (2, 4, 3, 1))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp101, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp101
    tmp97 = einsum(t1.bb, (0, 1), tmp48, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp48
    rdm2.bbbb.oovv += tmp97.transpose((0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += tmp97 * 2
    del tmp97
    tmp103 = einsum(t1.bb, (0, 1), tmp102, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp102
    rdm2.bbbb.oovv += tmp103.transpose((0, 1, 3, 2))
    rdm2.bbbb.oovv += tmp103.transpose((1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp103 * -1
    rdm2.bbbb.oovv += tmp103.transpose((1, 0, 2, 3))
    del tmp103
    tmp63 = tmp38.copy() * 0.5
    tmp63 += tmp39
    tmp63 += tmp62
    del tmp62
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp63, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.bbbb.oovv += einsum(tmp63, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp63, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.bbbb.oovo += einsum(tmp63, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -2
    del tmp63
    tmp47 = t1.bb.copy()
    tmp47 += tmp34
    tmp47 += tmp35 * 2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp47, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ooov += einsum(tmp47, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    del tmp47
    tmp41 = tmp38.copy()
    del tmp38
    tmp41 += tmp39 * 2
    del tmp39
    tmp41 += tmp40
    del tmp40
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp41, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp41, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp41, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.ooov += einsum(tmp41, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.ooov += einsum(tmp41, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1))
    rdm2.abab.ooov += einsum(tmp41, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -1
    del tmp41
    tmp98 = tmp81.copy() * 0.5
    tmp98 += tmp82
    rdm2.bbbb.oovv += einsum(tmp98, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 4
    del tmp98
    tmp83 = tmp81.copy()
    del tmp81
    tmp83 += tmp82 * 2
    del tmp82
    rdm2.bbbb.oovv += einsum(tmp83, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    rdm2.abab.oovv += einsum(tmp83, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp83
    tmp91 = einsum(t2.bbbb, (0, 1, 2, 3), tmp90, (1, 4, 3, 5), (4, 0, 5, 2))
    del tmp90
    rdm2.bbbb.oovv += tmp91 * 8
    rdm2.bbbb.oovv += tmp91.transpose((0, 1, 3, 2)) * -8
    del tmp91
    tmp36 = t1.bb.copy()
    tmp36 += tmp34
    tmp36 += tmp35 * 2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp36, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp36, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ooov += einsum(tmp36, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp36
    tmp99 = einsum(tmp51, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -2
    del tmp51
    rdm2.bbbb.oovv += tmp99.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp99.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp99.transpose((0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += tmp99.transpose((0, 1, 3, 2)) * -1
    del tmp99
    tmp100 = einsum(tmp52, (0, 1, 2, 3), t2.bbbb, (0, 1, 4, 5), (2, 3, 4, 5))
    rdm2.bbbb.oovv += tmp100.transpose((1, 0, 3, 2))
    rdm2.bbbb.oovv += tmp100.transpose((1, 0, 3, 2))
    del tmp100
    tmp95 = einsum(tmp94, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp94
    rdm2.bbbb.oovv += tmp95.transpose((1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += tmp95 * 2
    rdm2.bbbb.oovv += tmp95.transpose((1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp95.transpose((0, 1, 3, 2)) * -2
    del tmp95
    tmp45 = einsum(t1.bb, (0, 1), tmp44, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp44
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp45, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ooov += tmp45.transpose((1, 2, 0, 3))
    del tmp45
    tmp37 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 4), (4, 0, 1, 3))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp37, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ooov += tmp37.transpose((1, 2, 0, 3)) * -1
    del tmp37
    tmp75 = tmp64.copy()
    tmp75 += tmp65 * 0.5
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp75, (2, 4), (0, 1, 4, 3)) * -2
    rdm2.aaaa.oovv = einsum(t2.aaaa, (0, 1, 2, 3), tmp75, (3, 4), (0, 1, 4, 2)) * 4
    del tmp75
    tmp89 = tmp59.copy()
    del tmp59
    tmp89 += tmp58
    del tmp58
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp89, (2, 0, 3, 4), (2, 3, 4, 1)) * -2
    del tmp89
    tmp73 = tmp20.copy() * 2
    tmp73 += tmp21
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp73, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovv += einsum(tmp73, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp73, (2, 3), (2, 0, 3, 1))
    del tmp73
    tmp88 = tmp42.copy()
    del tmp42
    tmp88 += tmp43
    del tmp43
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp88, (0, 2, 3, 4), (2, 3, 1, 4)) * -2
    del tmp88
    tmp57 = tmp25.copy()
    tmp57 += tmp27 * 0.5
    tmp57 += tmp56
    del tmp56
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp57, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp57, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovv += einsum(tmp57, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.abab.oovo += einsum(tmp57, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -2
    del tmp57
    tmp55 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp55, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    rdm2.abab.oovo += tmp55.transpose((0, 2, 3, 1)) * -1
    del tmp55
    tmp46 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp14
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp46, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.ooov += tmp46.transpose((1, 2, 0, 3))
    del tmp46
    tmp60 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5))
    del tmp26
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp60, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.abab.oovo += tmp60.transpose((0, 2, 3, 1))
    del tmp60
    tmp12 = tmp0.copy()
    tmp12 += tmp1 * 2
    tmp12 += tmp2
    rdm2.abab.oovv += einsum(tmp12, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    rdm2.abab.ooov += einsum(t1.bb, (0, 1), tmp12, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.ooov += einsum(tmp12, (0, 1), t1.aa, (2, 3), (2, 1, 0, 3))
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp12, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.abab.oooo += einsum(tmp12, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    del tmp12
    tmp77 = einsum(t2.aaaa, (0, 1, 2, 3), tmp32, (0, 1, 4, 5), (4, 5, 2, 3))
    rdm2.aaaa.oovv += tmp77.transpose((1, 0, 3, 2))
    rdm2.aaaa.oovv += tmp77.transpose((1, 0, 3, 2))
    del tmp77
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp71, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp71
    rdm2.aaaa.oovv += tmp72.transpose((1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += tmp72 * 2
    rdm2.aaaa.oovv += tmp72.transpose((1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp72.transpose((0, 1, 3, 2)) * -2
    del tmp72
    tmp68 = einsum(t2.abab, (0, 1, 2, 3), tmp67, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp67
    rdm2.aaaa.oovv += tmp68 * 2
    rdm2.aaaa.oovv += tmp68.transpose((0, 1, 3, 2)) * -2
    del tmp68
    tmp74 = einsum(tmp24, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp24
    rdm2.aaaa.oovv += tmp74.transpose((0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += tmp74 * 2
    del tmp74
    tmp22 = t1.aa.copy() * 0.5
    tmp22 += tmp20
    tmp22 += tmp21 * 0.5
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.ooov += einsum(tmp22, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -2
    del tmp22
    tmp76 = einsum(tmp4, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4)) * -2
    del tmp4
    rdm2.aaaa.oovv += tmp76.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp76.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp76.transpose((1, 0, 3, 2)) * -1
    del tmp76
    tmp70 = einsum(t2.aaaa, (0, 1, 2, 3), tmp69, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp69
    rdm2.aaaa.oovv += tmp70 * 8
    rdm2.aaaa.oovv += tmp70.transpose((0, 1, 3, 2)) * -8
    del tmp70
    tmp80 = einsum(t1.aa, (0, 1), tmp79, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp79
    rdm2.aaaa.oovv += tmp80.transpose((0, 1, 3, 2))
    rdm2.aaaa.oovv += tmp80.transpose((1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += tmp80 * -1
    rdm2.aaaa.oovv += tmp80.transpose((1, 0, 2, 3))
    del tmp80
    tmp78 = einsum(t1.aa, (0, 1), tmp32, (0, 2, 3, 4), (2, 4, 3, 1))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp78, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp78
    tmp66 = tmp64.copy() * 2
    del tmp64
    tmp66 += tmp65
    del tmp65
    rdm2.aaaa.oovv += einsum(tmp66, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp66
    tmp29 = tmp25.copy() * 2
    del tmp25
    tmp29 += tmp27
    del tmp27
    tmp29 += tmp28
    del tmp28
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp29, (2, 3), (2, 0, 1, 3))
    rdm2.aaaa.oovv += einsum(tmp29, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.aaaa.oovo += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3))
    rdm2.aaaa.oovo += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1))
    del tmp29
    tmp23 = t1.aa.copy()
    tmp23 += tmp20 * 2
    tmp23 += tmp21
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovo += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ooov += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp23
    tmp61 = t1.bb.copy() * 0.5
    tmp61 += tmp34 * 0.5
    del tmp34
    tmp61 += tmp35
    del tmp35
    rdm2.bbbb.oovo += einsum(tmp61, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * 2
    del tmp61
    tmp53 = einsum(tmp52, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * 2
    del tmp52
    rdm2.bbbb.oovo += tmp53.transpose((2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov += tmp53.transpose((2, 1, 0, 3))
    del tmp53
    tmp54 = t1.aa.copy()
    tmp54 += tmp20 * 2
    del tmp20
    tmp54 += tmp21
    del tmp21
    rdm2.abab.oovo += einsum(tmp54, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovo += einsum(tmp54, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    del tmp54
    tmp33 = einsum(t1.aa, (0, 1), tmp32, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp32
    rdm2.aaaa.oovo += tmp33.transpose((2, 1, 3, 0)) * -1
    rdm2.aaaa.ooov += tmp33.transpose((2, 1, 0, 3))
    del tmp33
    tmp11 = delta.bb.oo.copy() * -0.5
    tmp11 += tmp8 * 0.5
    del tmp8
    tmp11 += tmp9 * 0.5
    del tmp9
    tmp11 += tmp10
    del tmp10
    rdm2.bbbb.oooo += einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.abab.oooo += einsum(tmp11, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -2
    del tmp11
    tmp3 = delta.aa.oo.copy() * -1
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp1 * 2
    del tmp1
    tmp3 += tmp2
    del tmp2
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (1, 2, 3, 0))
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -1
    del tmp3
    rdm2.aaaa.ovoo += einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovoo += einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovoo += einsum(l1.bb, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vooo += einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vooo += einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.abab.vooo += einsum(delta.bb.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    del delta
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.aaaa.oovv += t2.aaaa
    rdm2.abab.oovv += t2.abab
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.bbbb.oovv += t2.bbbb
    rdm2.aaaa.ovov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvo += einsum(t1.aa, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.voov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.abab.voov += einsum(t1.bb, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.vvoo = l2.aaaa.copy()
    rdm2.aaaa.vvoo += l2.aaaa
    rdm2.abab.vvoo = l2.abab.copy()
    rdm2.bbbb.vvoo = l2.bbbb.copy()
    rdm2.bbbb.vvoo += l2.bbbb
    rdm2.abab.ovvv += einsum(t2.abab, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    rdm2.abab.vovv += einsum(t2.abab, (0, 1, 2, 3), l1.aa, (4, 0), (4, 1, 2, 3))
    rdm2.abab.vvvo = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    rdm2.abab.vvvv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=rdm2.aaaa.swapaxes(1, 2),
        aabb=rdm2.abab.swapaxes(1, 2),
        bbbb=rdm2.bbbb.swapaxes(1, 2),
    )

    return rdm2

